/*
*   2021年5月24日
*
*   android没有网络解决方案页面js控制器
*
*   开发者：付长建
*/
define(["jquery","Shell","Fastclick","iscroll"],function($,Shell,Fastclick,iscroll){
    var Controller = {
        init:function(){
            //设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            //创建头部元素
            var maxHeadContainer = $("<div style='width:100%;padding-top:"+phonexh("top")+"px;border-bottom:1px solid #EAEFF2;box-sizing:border-box;'></div>").appendTo($("body"));
            this.headContent = $("<div style='width:100%;height:0.44rem;display:flex;flex-direction:row;justify-content:center;position:relative;'></div>").appendTo(maxHeadContainer);
            $("<p style='height:100%;display:flex;align-items:center;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;position:absolute;top:0;left:0;'><img style='width:0.1rem;height:0.17rem;' src='../djcommon/img/common/icon_back@3x.png'/></p>").appendTo(this.headContent);
            $("<span style='display:flex;align-items:center;font-size:0.18rem;font-weight:bold;color:#000;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;'>网络设置</span>").appendTo(this.headContent);
            //创建内容元素
            var contentContainer = $("<div id='iosContentContainer' style='width:100%;overflow:hidden;'></div>").appendTo($("body"));
            var content = $("<div style='width:100%;padding:0.15rem 0.15rem 0 0.15rem;box-sizing:border-box;'></div>").appendTo(contentContainer);
            $("<p style='font-size:0.15rem;color:#000;font-weight:bold;'>您的设备未启用Wi-Fi或移动网络</p>").appendTo(content);
            $("<p style='font-size:0.15rem;color:#666;font-weight:400;margin-top:0.2rem;'>如需要连接互联网，可参照以下几种方法：</p>").appendTo(content);
            $("<p style='font-size:0.15rem;color:#666;font-weight:400;margin-top:0.15rem;'>① 在设备的“设置”-“Wi-Fi”设置面板中选择一个可用的Wi-Fi热点接入</p>").appendTo(content);
            $("<p style='font-size:0.15rem;color:#666;font-weight:400;margin-top:0.05rem;'>② 在设备的“设置”-“通用”-“网络”设置面板中启用蜂窝数据</p>").appendTo(content);
            $("<p style='font-size:0.15rem;color:#666;font-weight:400;margin-top:0.05rem;'>③ 在设备的“设置”-“飞行模式”设置面板中关闭飞行模式</p>").appendTo(content);
            $("<p style='font-size:0.15rem;color:#666;font-weight:400;margin-top:0.05rem;'>④ 试试重启一下手机</p>").appendTo(content);
            //创建底部去设置按钮容器
            var bott = phonexh("bottom") == 0 ? "0.2rem" : "0.3rem";
            var bottomContainer = $("<div style='width:100%;display:flex;justify-content:center;padding:0.2rem 0 "+bott+" 0;box-sizing:border-box;'></div>").appendTo($("body"));
            $("<p style='width:1.68rem;height:0.4rem;line-height:0.38rem;text-align:center;border-radius:0.22rem;font-size:0.15rem;color:#fff;background:linear-gradient(270deg, #CF000F 0%, #E30514 100%);'>去设置</p>").appendTo(bottomContainer);
            
            contentContainer.css("height",$(window).height() - maxHeadContainer.outerHeight(true) - bottomContainer.outerHeight(true) + "px");
            content.css("min-height",contentContainer.height() + 1 + "px");
            //初始化筛选滚动插件
            this.iscrollY = new iscroll("#iosContentContainer",{
                click:iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });
            //调用按下抬起效果方法
            btnTextCommon(bottomContainer.children("p"));
            //点击返回按钮
            this.headContent.children("p").bind("click",function(){
                try{
                    Shell.sendEvent("closeWin");//关闭当前页面
                }catch(error){}
            });
            //点击去设置按钮
            bottomContainer.children("p").bind("click",function(){
                try{
                    Shell.sendEvent("openPhoneSet");//给原生发送打开手机设置页面事件
                }catch(error){}
            });
            //解决移动端点击事件300ms延迟问题
			Fastclick.attach(document.body);
			//通知原生加载完毕
            Shell.sendPageReady(); 
            setTimeout(function(that){
                that.iscrollY.refresh();
            },500,this);
		}
    }
    //判读设备函数（主要解决点击事件失效问题）
    function iScrollClick(){
        if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
        if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
        if (/Silk/i.test(navigator.userAgent)) return false;
        if (/Android/i.test(navigator.userAgent)) {
        var s = navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
            return parseFloat(s[0]+s[3]) < 44 ? false : true
        }
    }
    //按钮按下抬起效果
    function btnTextCommon(element){
        //给选项绑定手指按下事件
        element.bind('touchstart',function(){
            $(this).css("opacity","0.5");
        });
        //给选项绑定手指抬起事件
        element.bind('touchend',function(){
            $(this).css("opacity","");
        });
    }
    return Controller;
});
