/*
*   2021年4月6日
*
*   本子管理页面 phonexh("bottom") 
*
*   开发者：付长建
*/
define(["jquery","Shell","Fastclick","iscroll","NewBookCell","CommonDeleteMask"],function($,Shell,Fastclick,iscroll){
    var Controller = {
        iscroll:null,//滚动插件
        pageName:"bookmanage",//当前页面的名称主要用于监听原生事件在本页面执行 
        isClick:true,//防止点击事件多次执行 
        moreIsShow:false,//是否有更多菜单显示了
        maskContainerContent:null,//同步本子数据到保险箱元素
        init:function(){
            global = JSON.parse(localStorage.getItem("configData"));//获取配置信息
			//设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});//禁止整个页面滚动
            //创建头部元素
            var maxHeadContainer = $("<div style='width:100%;padding-top:"+phonexh("top")+"px;box-sizing:border-box;'></div>").appendTo($("body"));
            this.headContent = $("<div style='width:100%;height:0.44rem;display:flex;flex-direction:row;justify-content:center;position:relative;'></div>").appendTo(maxHeadContainer);
            $("<p style='height:100%;display:flex;align-items:center;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;position:absolute;top:0;left:0;'><img style='width:0.1rem;height:0.17rem;' src='../djcommon/img/common/icon_back@3x.png'/></p>").appendTo(this.headContent);
            $("<div style='display:flex;flex-direction:column;'><p style='font-size:0.16rem;font-weight:bold;color:#000;margin-top:0.11rem;transition:all 0.3s;'>智能本管理</p><span style='font-size:0.12rem;font-weight:500;color:#999;text-align:center;opacity:0;transform:scale(0.8);'>共5个智能本</span></div>").appendTo(this.headContent);
            $("<span style='display:inline-block;height:100%;display:flex;align-items:center;font-size:0.15rem;font-weight:bold;color:#000;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;position:absolute;top:0;right:0;'>帮助</span>").appendTo(this.headContent);
            //创建提示元素
            var tipsElement = $("<div style='width:100%;height:0.36rem;line-height:0.34rem;padding-left:0.15rem;box-sizing:border-box;background:#FFE1D2;font-size:0.12rem;color:#FF6B20;font-weight:500;'>请注意：同类型笔记本，只可启用一个更新书写内容！</div>").appendTo($("body"));
            //创建添加本子按钮
            this.addBookContainer = $("<div style='width:100%;padding:0.3rem 0 0.3rem 0;box-sizing:border-box;display:flex;justify-content:center;'></div>").appendTo($("body"));
            $("<p style='width:1.4rem;height:0.44rem;border:1px solid #C82128;box-sizing:border-box;border-radius:0.22rem;display:flex;justify-content:center;line-height:0.42rem;text-align:center;color:#C82128;font-weight:bold;'><span style='font-size:0.15rem;margin-left:5px;'>新增笔记本</span></p>").appendTo(this.addBookContainer);
            //创建滚动容器
            var maxIscrollContainer = $("<div id='maxIscrollContainer' style='width:100%;height:"+($(window).height() - maxHeadContainer.outerHeight(true) - tipsElement.height() - this.addBookContainer.outerHeight(true))+"px;overflow:hidden;'></div>").appendTo($("body"));
            this.iscrollContent = $("<ul style='width:100%;min-height:"+(maxIscrollContainer.height() + 1)+"px;padding-left:0.15rem;padding-right:0.15rem;box-sizing:border-box;'></ul>").appendTo(maxIscrollContainer);
            //初始化滚动插件
            this.iscroll = new iscroll("#maxIscrollContainer",{
                click:iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });
            //给头部的返回按钮绑定点击事件
            this.headContent.children("p").bind("click",goBackClick);
            //给头部的帮助按钮绑定点击事件
            this.headContent.children("span").bind("click",helpClick);
            //给添加本子绑定点击事件
            this.addBookContainer.children("p").bind("click",addBook);
            //监听本子的锁定操作按钮被点击
            Controller.iscrollContent.bind("LOCK_BTN_CLICK",lockClick);
            //监听本子的重命名操作按钮被点击 
            Controller.iscrollContent.bind("RENAME_BTN_CLICK",renameClick);
            //监听本子的更多操作按钮被点击 
            Controller.iscrollContent.bind("MORE_BTN_CLICK",moreClick);
            //监听菜单选项被点击了 
            Controller.iscrollContent.bind("MORE_OPTION_BTN_CLICK",moreOptionClick);
            //当用户点击其它空白出隐藏更多菜单
            $(window).bind("click",windowClick);
            //调用监听原生发送过来的事件
            monitorAllEvent();
            //解决移动端点击事件300ms延迟问题
			Fastclick.attach(document.body);
			//通知原生加载完毕
            Shell.sendPageReady();  
            $("body").fadeTo("slow",1);
            //调用获取本子接口数据
            getBookData();
		}
    }
    //监听原生发送过来的事件
    function monitorAllEvent(){
        try{
            //监听原生发送的本子重命名成功事件
			api.addEventListener({name:"bookRenameSuccess"},function(){
				Shell.sendEvent("H5bookRenameSuccess");//给首页发送本子重命名成功事件
                getBookData();//调用获取本子列表方法
			});
            //监听原生同步本子数据到保险箱后成功或者失败事件
            api.addEventListener({name:"synchronizationBookSuccessAndFail"},function(arg){
                Controller.maskContainerContent.children("span").html(arg.value.text);//提示是否同步成功
                Controller.maskContainerContent.children("img").removeClass("iconRotate");//删除旋转动画
                setTimeout(function(){
                    Controller.maskContainerContent.css({"transform":"scale(1,1)","opacity":"1"});//隐藏提示弹框
                    setTimeout(function(){
                        Controller.maskContainerContent.remove();//删除提示弹框
                        lockout();//调用解锁页面方法
                    },280);
                },1500);
			});
            //监听添加本子页面添加本子成功事件 
            api.addEventListener({name:"H5addBookSuccess"},function(){
                getBookData();//调用获取本子数据方法
			});
            //监听笔记首页发送过来的移除页面监听事件的事件
            api.addEventListener({name:"H5removeEvent"},function(arg){
                removeAllEvent();//调用移除页面监听事件方法
			});
            //监听首页发h5送过来的本子改变事件
            api.addEventListener({name:"H5BookChange"},function(e){
                $("[bookId='"+e.value.bookId+"']").css("display","flex");
                $("[bookId='"+e.value.bookId+"']").attr("data","ysfcj");
                Controller.headContent.children("div").children("span").html("共"+$("[data='ysfcj']").length+"个智能本").css("opacity","1");
                Controller.iscrollContent.find("li:first-child").css("padding-top","0");//去除第一个子元素的上padding
                Controller.iscrollContent.find("li:last-child").css("border-bottom","0");//去除最后一个子元素的下边框
                Controller.iscrollContent.css({
                    "background":"",
                    "background-repeat":"",
                    "background-size":"",
                    "background-position":""
                }); 
                Controller.iscroll.refresh();//刷新高度
			});
        }catch(e){}
    }
    //移除页面监听事件方法
	function removeAllEvent(){
		try{
            api.removeEventListener({"name":"bookRenameSuccess"});//移除原生发送的本子重命名成功事件
            api.removeEventListener({"name":"synchronizationBookSuccessAndFail"});//移除原生同步本子数据到保险箱后成功或者失败事件
			api.removeEventListener({"name":"H5addBookSuccess"});//移除添加本子页面添加本子成功事件
			api.removeEventListener({"name":"H5removeEvent"});//移除笔记首页发送过来的移除页面监听事件的事件
            api.removeEventListener({"name":"H5BookChange"});//移除笔记首页发送过来的本子改变事件
		}catch(e){}
	}
    //判读设备函数（主要解决点击事件失效问题）
    function iScrollClick(){
        if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
        if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
        if (/Silk/i.test(navigator.userAgent)) return false;
        if (/Android/i.test(navigator.userAgent)) {
        var s = navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
            return parseFloat(s[0]+s[3]) < 44 ? false : true
        }
    }
    //当用户点击返回按钮
    function goBackClick(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("closeWin");//关闭当前页面
            }catch(e){}
        }
    }
    //当用户点击帮助按钮
    function helpClick(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("openWin",{"url":"/notebookhelp/noteBookHelp.html","open_type":true,"title":"帮助"});
            }catch(e){}
            setTimeout(function(){
                Controller.isClick = true;
            },500);
        }
    }
    //当用户点击添加本子
    function addBook(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("openWin",{"url":"/createbook/createBook.html","open_type":true,"title":"新建本子"});
            }catch(e){}
            setTimeout(function(){
                Controller.isClick = true;
            },500);
        }
    }
    //生成本子列表方法
    function generateBookCell(dataArray){
        Controller.iscrollContent.children("li").remove();//清空原来数据
        //判断本子是否为空
        if(dataArray.length != 0){
            for(var i = 0; i < dataArray.length; i++){
                var tmen = $("<li bookId='"+dataArray[i].id+"' data='ysfcj' style='width:100%;padding:0.15rem 0 0.15rem 0;border-bottom:1px solid #ECECEC;box-sizing:border-box;display:flex;flex-direction:row;'></li>").appendTo(Controller.iscrollContent);
                tmen.NewBookCell({"data":dataArray[i]});
                //判断本子是否是隐藏的
                if(parseInt(dataArray[i].visible) != 1 && dataArray[i].id != getUrl("bookId")){
                    tmen.css("display","none");
                    tmen.removeAttr("data");
                }
            }
            //判断是否有本子数据
            if($("[data='ysfcj']").length == 0){
                Controller.iscrollContent.css({
                    "background":"url(../djcommon/img/note/img_nodata_all.png)",
                    "background-repeat":"no-repeat",
                    "background-size":"2.3rem 1.8rem",
                    "background-position":"50% 30%"
                }); 
            }else{
                Controller.iscrollContent.css({
                    "background":"",
                    "background-repeat":"",
                    "background-size":"",
                    "background-position":""
                }); 
            }
            var mumm = $("[data='ysfcj']").length == 0 ? "暂无智能本" : "共"+$("[data='ysfcj']").length+"个智能本";
            Controller.headContent.children("div").children("p").css("margin-top","0.03rem");
            Controller.headContent.children("div").children("span").html(mumm).css("opacity","1");
            Controller.iscrollContent.find("li:first-child").css("padding-top","0");//去除第一个子元素的上padding
            Controller.iscrollContent.find("li:last-child").css("border-bottom","0");//去除最后一个子元素的下边框
            Controller.iscroll.refresh();//刷新高度
        }
    }
    //当用户点击了锁定按钮
    function lockClick(event,obj){
        locking();//调用锁定页面方法
        //判断当前是启用还是禁用（后端改了逻辑现在是能启用不能禁用了也就是只有dataType为1的时候才调用接口）
        if(parseInt(obj.dataType) != 1){
            try{
                api.toast({"msg":"本子只能启用不能禁用,且每个类型本子只能启用一个","duration":1500,"location":"middle"});
            }catch(e){}
            setTimeout(function(){
                lockout();//调用解锁页面方法
            },1500);
            return;
        }
        //请求参数
		var paramet = {"token":global.token,"accountCode":global.accountCode,"bookId":obj.data.id,"activeFlag":obj.dataType};
        http(ServerConfig.djDomain+"/ctl/cpcapi/book/active_book",paramet,{
            success:function(arg){
                if(arg.retCode == "SUCCESS"){	
                    if(arg.data == "CPC_BOOK_0001"){
                        var msg1 = parseInt(obj.dataType) == 1 ? "本子不存在启用失败" : "本子不存在禁用失败";
                        try{
                            api.toast({"msg":msg1,"duration":1500,"location":"middle"});
                        }catch(e){}
                    }else if(arg.data == "CPC_BOOK_0007"){
                        try{
                            var msg2 = parseInt(obj.dataType) == 1 ? "启用失败" : "同类型只有一个本子，禁用失败";
                            api.toast({"msg":msg2,"duration":1500,"location":"middle"});
                        }catch(e){}
                    }else if(arg.data == "CPC_BOOK_0099"){
                        var msg3 = parseInt(obj.dataType) == 1 ? "本子和用户账号不匹配启用失败" : "本子和用户账号不匹配禁用失败";
                        try{
                            api.toast({"msg":msg3,"duration":1500,"location":"middle"});
                        }catch(e){}
                    }else if(arg.data == "CPC_BOOK_0008"){
                        var msg4 = parseInt(obj.dataType) == 1 ? "本子启用成功" : "本子禁用成功";
                        try{
                            api.toast({"msg":msg4,"duration":1500,"location":"middle"});
                            Shell.sendEvent("H5BookStateChange");//给首页发送一个本子状态被修改事件
                        }catch(e){}
                        getBookData();//调用重新获取本子数据方法  
                    }
                }else if(arg.retCode == "NO_AUTH"){
                    try{
						Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
					}catch(e){}
                }else{
					try{
						api.toast({"msg":arg.message,"duration":1500,"location":"middle"});
					}catch(e){}
				}
                setTimeout(function(){
                    lockout();//调用解锁页面方法
                },1500);
            }
        });
    }
    //当用户点击了重名
    function renameClick(event,obj){
        try{
            Shell.sendEvent("renameBook",{"bookData":obj});//给原生发送重命名本子名称事件
        }catch(e){}
    }
    //当用户点击了更多
    function moreClick(event,obj){
        //判断当前是隐藏还是显示
        if(obj.type == "no"){
            Controller.iscrollContent.children("li").NewBookCell("hideMore");//隐藏所有的菜单
            Controller.iscrollContent.find("[bookId="+obj.data.id+"]").NewBookCell("showMore");//显示当前点击的这个菜单
            Controller.moreIsShow = true;//有更多菜单显示了
        }else{
            Controller.iscrollContent.find("[bookId="+obj.data.id+"]").NewBookCell("hideMore");//隐藏当前点击的这个菜单
            Controller.moreIsShow = false;//没有更多菜单显示了
        }
    }
    //当用户点击了菜单选项
    function moreOptionClick(event,obj){
        locking();//调用锁定页面方法
        //判断当前点击的是什么选项
        if(obj.type == "synchro"){
            Controller.maskContainerContent = $("<div></div>").appendTo($("body"));
            Controller.maskContainerContent.css({"z-index":1,"width":"2.2rem","height":"1.2rem","position":"absolute","top":"50%","left":"50%","margin":"-0.6rem 0 0 -1.1rem","border-radius":"0.05rem","transition":"all 0.3s","box-shadow":"rgba(0, 0, 0, 0.08) 1px 0.03rem 0.13rem 0.03rem","transform":"scale(0.5,0.5)","opacity":"0","background":"#fff","display":"flex","flex-direction":"column","justify-content":"center","align-items":"center"});
            $("<span style='font-size:0.16rem;color:#000;font-weight:bold;'>同步中，请稍后...</span>").appendTo(Controller.maskContainerContent);
            $("<img class='iconRotate' style='width:22px;height:22px;margin-top:0.2rem;' src='../djcommon/img/note/pull_load.png'/>").appendTo(Controller.maskContainerContent);
            setTimeout(function(){
                Controller.maskContainerContent.css({"transform":"scale(1,1)","opacity":"1"});
                try{
                    Shell.sendEvent("synchronizationBookDeposit",{"bookData":obj.data});//给原生发送同步本子数据到保险箱事件
                }catch(error){}
            },10);
        }else{
            //初始化询问组件
            var inquiryMaskContainer = $("<div style='z-index:1;'></div>").appendTo($("body"));
            inquiryMaskContainer.CommonDeleteMask({"title":"删除提示","text":"删除后将无法恢复笔记内容，确定要删除吗？"});
            //监听取消事件  
            inquiryMaskContainer.bind("DELETE_MASK_CANCEL",function(){
                lockout();//调用解锁页面方法
            });
            //监听确定事件
            inquiryMaskContainer.bind("DELETE_MASK_DETERMINE",function(){
                //判读防止多次执行
                if(Controller.isClick){
                    Controller.isClick = false;
                    try{
                        inquiryMaskContainer.CommonDeleteMask("removeMask");//调用询问组件的隐藏组件方法
                        deleteBook(obj.data);//调用删除本子方法
                        setTimeout(function(){
                            Controller.isClick = true;
                        },500);
                    }catch(e){}
                }
                
            });
        }
    }
    //当用户点击其它空白处
    function windowClick(){
        //判断是否显示了更多菜单
        if(Controller.moreIsShow){
            Controller.iscrollContent.children("li").NewBookCell("hideMore");//隐藏所有的菜单
        }
    }
    //锁定页面方法
    function locking(){
        Controller.headContent.children("p").css({"pointer-events":"none","opacity":"0.5"});//锁定头部返回按钮
        Controller.headContent.children("span").css({"pointer-events":"none","opacity":"0.5"});//锁定头部帮助按钮
        Controller.addBookContainer.children("p").css({"pointer-events":"none","opacity":"0.5"});//锁定添加本子按钮
        Controller.iscrollContent.css({"pointer-events":"none","opacity":"0.8"});//锁定所有本子操作
        Controller.iscroll.enabled = false;//禁止滚动容器滚动
    }
    //解锁页面方法
    function lockout(){
        Controller.headContent.children("p").css({"pointer-events":"","opacity":""});//解锁头部返回按钮
        Controller.headContent.children("span").css({"pointer-events":"","opacity":""});//解锁头部帮助按钮
        Controller.addBookContainer.children("p").css({"pointer-events":"","opacity":""});//解锁添加本子按钮
        Controller.iscrollContent.css({"pointer-events":"","opacity":""});//解锁所有本子操作
        Controller.iscroll.enabled = true;//允许滚动容器滚动
    }
    //获取本子数据方法
	function getBookData(){
		//请求参数
		var paramet = {"token":global.token,"accountCode":global.accountCode};
        http(ServerConfig.djDomain+"/ctl/cpcapi/book/search_book",paramet,{
            success:function(arg){
                if(arg.retCode == "SUCCESS"){	
					generateBookCell(arg.data);//调用生成本子数据方法
                }else if(arg.retCode == "NO_AUTH"){
                    try{
						Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
					}catch(e){}
                }else{
					try{
						api.toast({"msg":arg.message,"duration":1500,"location":"middle"});
					}catch(e){}
				}
            }
        });
	}
    //删除本子方法
    function deleteBook(obj){
        //请求参数
		var paramet = {"token":global.token,"accountCode":global.accountCode,"bookId":obj.id};
        http(ServerConfig.djDomain+"/ctl/cpcapi/book/remove_book",paramet,{
            success:function(arg){
                if(arg.retCode == "SUCCESS"){	
                    if(arg.data == "CPC_BOOK_0001"){
                        try{
                            api.toast({"msg":"本子不存在，删除失败","duration":1500,"location":"middle"});
                        }catch(e){}
                    }else if(arg.data == "CPC_BOOK_0004"){
                        try{
                            api.toast({"msg":"本子处于启用状态不能删除","duration":1500,"location":"middle"});
                        }catch(e){}
                    }else if(arg.data == "CPC_BOOK_0005"){
                        try{
                            api.toast({"msg":"唯一一个本子，不能删除","duration":1500,"location":"middle"});
                        }catch(e){}
                    }else if(arg.data == "CPC_BOOK_0099"){
                        try{
                            api.toast({"msg":"本子和账号不匹配不能删除","duration":1500,"location":"middle"});
                        }catch(e){}
                    }else if(arg.data == "CPC_BOOK_0006"){
                        Controller.iscrollContent.find("[bookId="+obj.id+"]").remove();
                        try{
                            api.toast({"msg":"删除成功","duration":1500,"location":"middle"});
                            Shell.sendEvent("H5BookDelteSuccess",{"bookId":obj.id});//给首页发送一个本子被删除成功事件
                        }catch(e){}

                    }
                }else if(arg.retCode == "NO_AUTH"){
                    try{
						Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
					}catch(e){}
                }else{
					try{
						api.toast({"msg":arg.message,"duration":1500,"location":"middle"});
					}catch(e){}
				}
                setTimeout(function(){
                    lockout();//调用解锁页面方法
                },1500);
            }
        });
    }
    return Controller;
});
