/*
*   2021年4月6日
*
*   连接详情页面 
*
*   开发者：付长建
*/
define(["jquery","Shell","Fastclick","iscroll","CommonDeleteMask"],function($,Shell,Fastclick,iscroll){
    var Controller = {
        iscroll:null,//滚动插件
        cacheConnectData:null,//缓存里面当前连接的笔信息
        pageName:"connectdetails",//当前页面的名称主要用于监听原生事件在本页面执行 
        isClick:true,//防止点击事件多次执行 
        init:function(){
            global = JSON.parse(localStorage.getItem("configData"));//获取配置信息
			//设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});//禁止整个页面滚动
            //创建头部元素
            var maxHeadContainer = $("<div style='width:100%;padding-top:"+phonexh("top")+"px;box-sizing:border-box;background:#c82128;'></div>").appendTo($("body"));
            this.headContent = $("<div style='width:100%;height:0.44rem;display:flex;flex-direction:row;justify-content:center;position:relative;'></div>").appendTo(maxHeadContainer);
            $("<div style='height:100%;display:flex;align-items:center;justify-content:center;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;position:absolute;top:0;left:0;'><img style='width:9px;height:16px;' src='../djcommon/img/note/ic_back_title.png'/></div>").appendTo(this.headContent);
            $("<span style='display:flex;align-items:center;justify-content:center;font-size:0.18rem;font-weight:bold;color:#fff;'>设备详情</span>").appendTo(this.headContent);
            $("<p style='height:100%;display:flex;align-items:center;justify-content:center;font-size:0.15rem;font-weight:bold;color:#fff;margin-right:0.15rem;position:absolute;top:0;right:0;'>修改密码</p>").appendTo(this.headContent);
            //创建内容体元素
            var contentContainer = $("<div id='iscrollContainer' style='width:100%;overflow:hidden;'></div>").appendTo($("body"));
            var iscrollContainer = $("<div style='width:100%;background:#fff;'></div>").appendTo(contentContainer);
            //创建笔类型图片元素容器
            this.penTypeImgContainer = $("<div style='width:100%;height:1.36rem;padding-top:0.12rem;box-sizing:border-box;background:#c82128;display:flex;justify-content:center;'></div>").appendTo(iscrollContainer);
            $("<img style='width:2.4rem;height:0.54rem;' src='../djcommon/img/note/pen1.png'/>").appendTo(this.penTypeImgContainer);
            //创建笔连接信息
            var penConnectInformationContainer = $("<div style='width:100%;height:1.24rem;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;margin-top:-0.44rem;'></div>").appendTo(iscrollContainer);
            this.penConnectInformationContent = $("<div style='width:100%;height:100%;border:1px solid #EAEFF2;box-shadow:0px 0px 0.1rem rgba(0,0,0,0.15);box-sizing:border-box;background:#fff;border-radius:5px;'></div>").appendTo(penConnectInformationContainer);
            //创建笔名称和刷新按钮元素
            this.penNameRefreshContainer = $("<div style='width:100%;height:0.44rem;display:flex;flex-direction:row;align-items:center;justify-content:space-between;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;'></div>").appendTo(this.penConnectInformationContent);
            $("<div style='display:flex;flex-direction:row;align-items:center;'><span style='font-size:0.16rem;font-weight:bold;color:#000;'>蓝牙笔</span><img style='width:0.13rem;height:0.13rem;margin-left:5px;position:relative;top:1px;' src='../djcommon/img/note/ic-edit_me.png'/></div>").appendTo(this.penNameRefreshContainer);
            $("<p style='width:0.64rem;height:24px;display:flex;align-items:center;justify-content:center;background:#F3F3F3;border-radius:16px;'><img style='width:0.15rem;height:0.15rem;margin-right:3px;' src='../djcommon/img/note/ic_refresh.png'/><span style='font-size:12px;font-weight:500px;color:#333;'>刷新</span></p>").appendTo(this.penNameRefreshContainer);
            //创建连接和电量信息元素
            var connectElectricityContainer = $("<div style='width:100%;display:flex;flex-direction:row;justify-content:space-between;margin-top:0.12rem;'></div>").appendTo(this.penConnectInformationContent);
            this.connectName = $("<div style='width:50%;display:flex;flex-direction:column;'></div>").appendTo(connectElectricityContainer);
            $("<div style='display:flex;flex-direction:row;align-items:center;justify-content:center;'><img style='width:0.08rem;height:0.14rem;margin-right:5px;' src='../djcommon/img/note/ic_blooth.png'/><span style='font-size:0.14rem;color:#333;font-weight:500;'>蓝牙</span></div>").appendTo(this.connectName);
            $("<p style='font-size:0.12rem;color:#333;font-weight:500px;margin-top:0.05rem;text-align:center;'>未连接</p>").appendTo(this.connectName);
            this.eectricity = $("<div style='width:50%;display:flex;flex-direction:column;border-left:1px solid #EAEFF2;box-sizing:border-box;'></div>").appendTo(connectElectricityContainer);
            $("<div style='display:flex;flex-direction:row;align-items:center;justify-content:center;'><img style='width:0.08rem;height:0.14rem;margin-right:5px;' src='../djcommon/img/note/power_full.png'/><span style='font-size:0.14rem;color:#333;font-weight:500;'>电量</span></div>").appendTo(this.eectricity);
            $("<p style='font-size:0.12rem;color:#2FC899;font-weight:500px;margin-top:0.05rem;text-align:center;'>--</p>").appendTo(this.eectricity);
            $("<div style='width:100%;height:0.4rem;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;display:flex;flex-direction:row;align-items:center;margin-top:0.2rem;'><p style='width:2px;height:0.14rem;background:#C82128;border-radius:1px;position:relative;top:1px;'></p><span style='font-size:0.14rem;font-weight:400;color:#000;margin-left:0.1rem;'>设备绑定</span></div>").appendTo(iscrollContainer);
            //创建连接管理栏
            var connectCellContainer = $("<div style='width:100%;height:0.54rem;padding-left:0.15rem;box-sizing:border-box;'></div>").appendTo(iscrollContainer);
            this.connectCell = $("<div style='width:100%;height:100%;border-bottom:1px solid #EAEFF2;box-sizing:border-box;display:flex;flex-direction:row;align-items:center;justify-content:space-between;'></div>").appendTo(connectCellContainer);
            $("<sapn style='font-size:0.16rem;color:#000;font-weight:500;'>连接管理</sapn>").appendTo(this.connectCell);
            $("<div style='width:0.54rem;height:100%;display:flex;align-items:center;justify-content:flex-end;padding-right:0.15rem;box-sizing:border-box;'><img style='width:5px;height:8px;' src='../djcommon/img/note/enter.png'/></div>").appendTo(this.connectCell);
            //创建笔mac ID地址栏
            var macContainer = $("<div style='width:100%;height:0.54rem;padding-left:0.15rem;box-sizing:border-box;'></div>").appendTo(iscrollContainer);
            this.macContent = $("<div style='width:100%;height:100%;border-bottom:1px solid #EAEFF2;box-sizing:border-box;display:flex;flex-direction:row;align-items:center;justify-content:space-between;'></div>").appendTo(macContainer);
            $("<span style='font-size:0.16rem;color:#000;font-weight:bold;'>ID码</span>").appendTo(this.macContent);
            $("<p style='font-size:0.12rem;color:#999;font-weight:400;margin-right:0.15rem;'>--</p>").appendTo(this.macContent);
            //创建笔存储空间栏
            var storageContainer = $("<div style='width:100%;height:0.54rem;padding-left:0.15rem;box-sizing:border-box;'></div>").appendTo(iscrollContainer);
            this.storageContent = $("<div style='width:100%;height:100%;border-bottom:1px solid #EAEFF2;box-sizing:border-box;display:flex;flex-direction:row;align-items:center;justify-content:space-between;'></div>").appendTo(storageContainer);
            $("<span style='font-size:0.16rem;color:#000;font-weight:500;'>存储空间</span>").appendTo(this.storageContent);
            $("<p style='font-size:0.14rem;color:#666;font-weight:500;margin-right:0.15rem;'>--</p>").appendTo(this.storageContent);
            //创建自动连接栏
            var automaticConnectContainer = $("<div style='width:100%;height:0.54rem;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;'></div>").appendTo(iscrollContainer);
            this.automaticConnectContent = $("<div style='width:100%;height:100%;display:flex;flex-direction:row;align-items:center;justify-content:space-between;'></div>").appendTo(automaticConnectContainer);
            $("<span style='font-size:0.16rem;color:#000;font-weight:500;'>自动连接</span>").appendTo(this.automaticConnectContent);
            $("<img data='2' style='width:0.51rem;height:0.32rem;' src='../djcommon/img/note/switch_off.png'/>").appendTo(this.automaticConnectContent);
            $("<div style='width:100%;height:0.4rem;padding:0 0.15rem 0 0.15rem;border-bottom:1px solid #EAEFF2;box-sizing:border-box;display:flex;flex-direction:row;align-items:center;margin-top:0.1rem;'><p style='width:2px;height:0.14rem;background:#C82128;border-radius:1px;position:relative;top:1px;'></p><span style='font-size:0.14rem;font-weight:400;color:#000;margin-left:0.1rem;'>设备绑定</span></div>").appendTo(iscrollContainer);
            //创建使用说明栏
            var explainContainer = $("<div style='width:100%;height:0.54rem;padding-left:0.15rem;box-sizing:border-box;'></div>").appendTo(iscrollContainer);
            this.explainContent = $("<div style='width:100%;height:100%;border-bottom:1px solid #EAEFF2;box-sizing:border-box;display:flex;flex-direction:row;align-items:center;justify-content:space-between;'></div>").appendTo(explainContainer);
            $("<sapn style='font-size:0.16rem;color:#000;font-weight:500;'>使用说明</sapn>").appendTo(this.explainContent);
            $("<div style='width:0.54rem;height:100%;display:flex;align-items:center;justify-content:flex-end;padding-right:0.15rem;box-sizing:border-box;'><img style='width:5px;height:8px;' src='../djcommon/img/note/enter.png'/></div>").appendTo(this.explainContent);
            //创建设备信息栏
            var equipmentContainer = $("<div style='width:100%;height:0.54rem;padding-left:0.15rem;box-sizing:border-box;'></div>").appendTo(iscrollContainer);
            this.equipmentContent = $("<div style='width:100%;height:100%;border-bottom:1px solid #EAEFF2;box-sizing:border-box;display:flex;flex-direction:row;align-items:center;justify-content:space-between;'></div>").appendTo(equipmentContainer);
            $("<sapn style='font-size:0.16rem;color:#000;font-weight:500;'>设备信息</sapn>").appendTo(this.equipmentContent);
            $("<div style='width:0.54rem;height:100%;display:flex;align-items:center;justify-content:flex-end;padding-right:0.15rem;box-sizing:border-box;'><img style='width:5px;height:8px;' src='../djcommon/img/note/enter.png'/></div>").appendTo(this.equipmentContent);
            //创建恢复出厂设置栏(需要判断是否是本人的笔)
            this.recoveryContainer = $("<div style='width:100%;height:0.54rem;padding-left:0.15rem;box-sizing:border-box;'></div>").appendTo(iscrollContainer);
            this.recoveryContent = $("<div style='width:100%;height:100%;border-bottom:1px solid #EAEFF2;box-sizing:border-box;display:flex;flex-direction:row;align-items:center;justify-content:space-between;'></div>").appendTo(this.recoveryContainer);
            $("<sapn style='font-size:0.16rem;color:#000;font-weight:500;'>恢复出厂设置</sapn>").appendTo(this.recoveryContent);
            $("<div style='width:0.54rem;height:100%;display:flex;align-items:center;justify-content:flex-end;padding-right:0.15rem;box-sizing:border-box;'><img style='width:5px;height:8px;' src='../djcommon/img/note/enter.png'/></div>").appendTo(this.recoveryContent);

            //创建底部按钮
            var paddBottom = phonexh("bottom") == 0 ? "0.2rem" : "0.1rem";
            this.btnContainer = $("<div style='width:100%;padding:0.2rem 0.15rem "+paddBottom+" 0.15rem;box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-between;'></div>").appendTo($("body"));
            $("<div style='width:47.5%;height:44px;border:1px solid #C82128;box-sizing:border-box;line-height:42px;text-align:center;font-size:16px;font-weight:400;color:#C82128;border-radius:22px;'>删除设备</div>").appendTo(this.btnContainer);
            $("<p style='width:47.5%;height:44px;background:linear-gradient(90deg, #E50414 0%, #CF000F 100%);line-height:42px;text-align:center;font-size:16px;font-weight:400;color:#FEFEFE;border-radius:22px;'>断开连接</p>").appendTo(this.btnContainer);
            contentContainer.css("height",$(window).height() - maxHeadContainer.outerHeight(true) - this.btnContainer.outerHeight(true) + "px");
            iscrollContainer.css("min-height",$(window).height() - maxHeadContainer.outerHeight(true) - this.btnContainer.outerHeight(true) + 1 + "px");
			//初始化滚动插件
            this.iscroll = new iscroll("#iscrollContainer",{
                click:iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });
            
            //给头部的返回按钮绑定点击事件
            this.headContent.children("div").bind("click",goBackClick);
            //给头部修改密码按钮绑定点击事件
            this.headContent.children("p").bind("click",modifyPassword);
            //给重命名绑定点击事件
            this.penNameRefreshContainer.children("div").bind("click",renamePen);
            //给刷新按钮绑定点击事件
            this.penNameRefreshContainer.children("p").bind("click",refreshClick);
            //给连接管理栏绑定点击事件
            this.connectCell.bind("click",connectManage); 
            //给自动连接的开关按钮绑定点击事件
            this.automaticConnectContent.children("img").bind("click",connectSwitch);
            //给使用说明栏绑定点击事件
            this.explainContent.bind("click",useExplain);
            //给设备信息栏绑定点击事件
            this.equipmentContent.bind("click",equipmentInformation);
            //给恢复出厂设置栏绑定点击事件
            this.recoveryContent.bind("click",factorySettings);
            //给底部的删除设备按钮绑定点击事件
            this.btnContainer.children("div").bind("click",deleteEquipment);
            //给底部的断开连接按钮绑定点击事件
            this.btnContainer.children("p").bind("click",breakConnect);
            //调用连接成功赋值方法
            connectSuccess();
            //调用监听原生发送过来的事件和其它h5页面发送过来的事件
            monitorAllEvent();
            //解决移动端点击事件300ms延迟问题
			Fastclick.attach(document.body);
			//通知原生加载完毕
            Shell.sendPageReady(); 
            $("body").fadeTo("slow",1);
		}
    }
    //监听原生发送过来的事件和其它h5页面发送过来的事件
    function monitorAllEvent(){
        try{
            //监听笔记首页获取到新的电量发送过来的事件
			api.addEventListener({name:"H5setElectric"},function(arg){
                Controller.eectricity.children("div").children("img").attr("src",eectricityIocn(arg.value.numm));
                Controller.eectricity.children("p").html(arg.value.numm + "%");
			});
            //监听笔记首页发送过来的蓝牙笔连接成功事件
            api.addEventListener({name:"H5PenConnectSuccess"},function(){
                connectSuccess();//调用蓝牙连接成功赋值方法
			});
            //监听笔记首页发送过来的蓝牙已断开事件
            api.addEventListener({name:"H5BluetoothBreak"},function(arg){
                connectBreak();//调用断开连接赋值方法
                api.toast({"msg":arg.value.text,"duration":1500,"location":"middle"});//提示信息
			});
            //监听原生抛出的重命名成功事件
            api.addEventListener({name:"renamePenNameSuccess"},function(arg){
                Controller.penNameRefreshContainer.children("div").children("span").html(arg.value.penName);//修改名称
                Shell.sendEvent("H5renamePenNameSuccess",arg.value);//给首页发送重命名成功事件
                Controller.cacheConnectData.penName = arg.value.penName;
                localStorage.setItem("connectData",JSON.stringify(Controller.cacheConnectData));//设置缓存
			});
            //监听笔记首页发送过来的移除页面监听事件的事件
            api.addEventListener({name:"H5removeEvent"},function(arg){
                removeAllEvent();//调用移除页面监听事件方法
			});
        }catch(e){}
    }
    //移除页面监听事件方法
	function removeAllEvent(){
		try{
			api.removeEventListener({"name":"H5setElectric"});//移除笔记首页获取到新的电量发送过来的事件
			api.removeEventListener({"name":"H5PenConnectSuccess"});//移除笔记首页发送过来的蓝牙笔连接成功事件
			api.removeEventListener({"name":"H5BluetoothBreak"});//移除笔记首页发送过来的蓝牙已断开事件
			api.removeEventListener({"name":"renamePenNameSuccess"});//移除原生抛出的重命名成功事件
			api.removeEventListener({"name":"H5removeEvent"});//移除笔记首页发送过来的移除页面监听事件的事件
		}catch(e){}
	}
    //判读设备函数（主要解决点击事件失效问题）
    function iScrollClick(){
        if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
        if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
        if (/Silk/i.test(navigator.userAgent)) return false;
        if (/Android/i.test(navigator.userAgent)) {
        var s = navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
            return parseFloat(s[0]+s[3]) < 44 ? false : true
        }
    }
    //连接成功赋值方法
    function connectSuccess(){
        //获取缓存内当前连接的数据
        Controller.cacheConnectData = JSON.parse(localStorage.getItem("connectData"));
        if(Controller.cacheConnectData != undefined && Controller.cacheConnectData != null && Controller.cacheConnectData != ""){
            Controller.penTypeImgContainer.children("img").attr("src","../djcommon/img/note/pen"+parseInt(Controller.cacheConnectData.penType)+".png");//赋值笔图片
            Controller.headContent.children("p").css({"pointer-events":"","opacity":""});//解锁头部的修改密码按钮
            Controller.penNameRefreshContainer.children("div").children("span").html(Controller.cacheConnectData.penName);//赋值当前连接得笔名
            Controller.connectCell.css({"pointer-events":"","opacity":""});//解锁连接管理栏
            Controller.penNameRefreshContainer.css({"pointer-events":"","opacity":""});//解锁修改名称和刷新按钮
            Controller.automaticConnectContent.children("img").css({"pointer-events":"","opacity":""});//锁定自动连接按钮
            Controller.recoveryContent.css({"pointer-events":"","opacity":""});//解锁恢复出厂设置按钮
            Controller.btnContainer.css({"pointer-events":"","opacity":""});//解锁底部按钮
            Controller.connectName.children("p").html("已连接").css("color","#2FC899");//赋值当前已连接
            if(parseInt(Controller.cacheConnectData.numm) != -1){
                Controller.eectricity.children("div").children("img").attr("src",eectricityIocn(Controller.cacheConnectData.numm));//赋值根据电量切换电量图标
                Controller.eectricity.children("p").html(Controller.cacheConnectData.numm + "%");//赋值电量
            }else{
                Controller.eectricity.children("p").html("获取中...");//赋值电量
            }
            Controller.macContent.children("p").html(Controller.cacheConnectData.macAddress);//赋值mac地址 
            Controller.storageContent.children("p").html("128M");//赋值笔的离线存储大小
            //判断是否是自动连接
            if(parseInt(Controller.cacheConnectData.auto) == 1){
                Controller.automaticConnectContent.children("img").attr("data","1");
                Controller.automaticConnectContent.children("img").attr("src","../djcommon/img/note/switch_on.png");
            }else{
                Controller.automaticConnectContent.children("img").attr("data","2");
                Controller.automaticConnectContent.children("img").attr("src","../djcommon/img/note/switch_off.png");
            }
            //判断是否是本人的笔
            if(parseInt(Controller.cacheConnectData.isSelfBind) != 1){
                Controller.recoveryContainer.css("display","none");
            }else{
                Controller.recoveryContainer.css("display","");
            }
            Controller.iscroll.refresh();//刷新列表高度
        }
    }
    //断开连接赋值方法
    function connectBreak(){
        Controller.headContent.children("p").css({"pointer-events":"none","opacity":"0.5"});//锁定头部的修改密码按钮
        Controller.penNameRefreshContainer.css({"pointer-events":"none","opacity":"0.5"});//锁定修改名称和刷新按钮
        Controller.automaticConnectContent.children("img").css({"pointer-events":"none","opacity":"0.5"});//锁定自动连接按钮
        Controller.recoveryContent.css({"pointer-events":"none","opacity":"0.5"});//锁定恢复出厂设置按钮
        Controller.btnContainer.css({"pointer-events":"none","opacity":"0.5"});//锁定底部按钮
        Controller.penNameRefreshContainer.children("div").children("span").html("蓝牙笔");//赋值当前连接得笔名
        Controller.connectName.children("p").html("未连接").css("color","#333");//赋值当前已连接
        Controller.eectricity.children("p").html("--");//赋值电量
        Controller.macContent.children("p").html("--");//赋值mac地址
        Controller.storageContent.children("p").html("--");//赋值笔的离线存储大小
        Controller.connectCell.css({"pointer-events":"none","opacity":"0.5"});//锁定连接管理栏
    }
    //根据当前电量返回对应的电池图标
    function eectricityIocn(numm){
        //判断当前电量改变电池图标
        if(parseInt(numm) >= 80){
            return "../djcommon/img/note/power_full.png";
        }else if(parseInt(numm) <= 80 && parseInt(numm) >= 50){
            return "../djcommon/img/note/power_icon.png";
        }else if(parseInt(numm) <= 50 && parseInt(numm) >= 20){
            return "../djcommon/img/note/power_middle.png";
        }else if(parseInt(numm) <= 20 && parseInt(numm) >= 0){
            return "../djcommon/img/note/power_low.png";
        }
    }
    //点击头部的返回按钮
    function goBackClick(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("closeWin");//关闭当前页面
            }catch(e){}
        }
    }
    //当用户点击修改密码按钮
    function modifyPassword(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("modifyPassword",{"penData":Controller.cacheConnectData});//给原生发送一个修改密码事件
            }catch(e){}
            setTimeout(function(){
                Controller.isClick = true;
            },1000);
        }
    }
    //当用户点击了重命名
    function renamePen(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("renamePenName",{"penData":Controller.cacheConnectData});//给原生发送一个重命名事件
            }catch(e){}
            setTimeout(function(){
                Controller.isClick = true;
            },500);
        }
    }
    //锁定页面
    function locking(){
        Controller.headContent.children("div").css({"pointer-events":"none","opacity":"0.5"});//锁定头部的返回按钮
        Controller.headContent.children("p").css({"pointer-events":"none","opacity":"0.5"});//锁定头部的修改密码按钮
        Controller.penNameRefreshContainer.css({"pointer-events":"none","opacity":"0.5"});//锁定修改名称和刷新按钮
        Controller.connectCell.css({"pointer-events":"none","opacity":"0.5"});//锁定连接管理按钮
        Controller.automaticConnectContent.children("img").css({"pointer-events":"none","opacity":"0.5"});//锁定自动连接按钮
        Controller.explainContent.css({"pointer-events":"none","opacity":"0.5"});//锁定使用说明按钮
        Controller.equipmentContent.css({"pointer-events":"none","opacity":"0.5"});//锁定设备信息按钮
        Controller.recoveryContent.css({"pointer-events":"none","opacity":"0.5"});//锁定恢复出厂设置按钮
        Controller.btnContainer.css({"pointer-events":"none","opacity":"0.5"});//锁定底部按钮
        Controller.iscroll.enabled = false;//禁止滚动容器滚动
    }
    //解锁页面
    function lockout(){
        Controller.headContent.children("div").css({"pointer-events":"","opacity":""});//解锁头部的返回按钮
        Controller.headContent.children("p").css({"pointer-events":"","opacity":""});//解锁头部的修改密码按钮
        Controller.penNameRefreshContainer.css({"pointer-events":"","opacity":""});//解锁修改名称按钮
        Controller.connectCell.css({"pointer-events":"","opacity":""});//解锁连接管理按钮
        Controller.automaticConnectContent.children("img").css({"pointer-events":"","opacity":""});//解锁自动连接按钮
        Controller.explainContent.css({"pointer-events":"","opacity":""});//解锁使用说明按钮
        Controller.equipmentContent.css({"pointer-events":"","opacity":""});//解锁设备信息按钮
        Controller.recoveryContent.css({"pointer-events":"","opacity":""});//解锁恢复出厂设置按钮
        Controller.btnContainer.css({"pointer-events":"","opacity":""});//解锁底部按钮
        Controller.iscroll.enabled = true;//允许滚动容器滚动
    }
    //当用户点击了刷新按钮
    function refreshClick(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            locking();//调用锁定页面方法
            $(this).children("img").addClass("iconRotate");
            setTimeout(function(that){
                lockout();//调用解锁页面方法
                that.children("img").removeClass("iconRotate");
                Controller.isClick = true;
            },1500,$(this));
        }
    }
    //当用户点击连接管理cell
    function connectManage(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("openWin",{"url":"/connectmanage/connectManage.html","open_type":true,"title":""});
            }catch(e){}
            setTimeout(function(){
                Controller.isClick = true;
            },500);
        }
    }
    //当用户点击自动连接的开关
    function connectSwitch(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            //判断是打开自动连接还是关闭
            if(parseInt($(this).attr("data")) == 1){
                $(this).attr("data",2);
                $(this).attr("src","../djcommon/img/note/switch_off.png");
                Controller.cacheConnectData.auto = 2;
            }else{
                $(this).attr("data",1);
                $(this).attr("src","../djcommon/img/note/switch_on.png");
                Controller.cacheConnectData.auto = 1;
            }
            localStorage.setItem("connectData",JSON.stringify(Controller.cacheConnectData));//设置缓存
            setTimeout(function(){
                Controller.isClick = true;
            },500);
        } 
    }
    //当用户点击使用说明 
    function useExplain(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("openWin",{"url":"/notependesc/notePenDesc.html","open_type":true,"title":"使用说明"});
            }catch(e){}
            setTimeout(function(){
                Controller.isClick = true;
            },500);
        }
    }
    //当用户点击了设备信息
    function equipmentInformation(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("openWin",{"url":"/notependevice/notePenDevice.html","open_type":true,"title":"设备信息"});
            }catch(e){}
            setTimeout(function(){
                Controller.isClick = true;
            },500);
        }
    }
    //当用户点击恢复出厂设置
    function factorySettings(){
        if(Controller.isClick){
            Controller.isClick = false;
            locking();//调用锁定页面方法
            //初始化询问组件
            var inquiryMaskContainer = $("<div style='z-index:1;'></div>").appendTo($("body"));
            inquiryMaskContainer.CommonDeleteMask({"title":"恢复出厂设置","text":"此操作会清空所有离线数据以及重置连接密码，是否确认操作？"});
            //监听取消事件  
            inquiryMaskContainer.bind("DELETE_MASK_CANCEL",function(){
                lockout();//调用解锁页面方法
                Controller.isClick = true;//允许点击了
            });
            //监听确定事件
            inquiryMaskContainer.bind("DELETE_MASK_DETERMINE",function(){
                inquiryMaskContainer.CommonDeleteMask("removeMask");//调用询问组件的隐藏组件方法
                //请求参数
                var paramet = {"accountCode":global.accountCode,"token":global.token,"macAddr":Controller.cacheConnectData.macAddress};
                http(ServerConfig.djDomain+"/ctl/cpcapi/bindpen/recovery_pen",paramet,{
                    success:function(arg){
                        if(arg.retCode == "SUCCESS"){
                            try{
                                Shell.sendEvent("breakBluetoothConnect",{"text":"恢复出厂设置成功"});//给原生发送断开连接事件
                                Controller.cacheConnectData.auto = 1;//修改自动连接属性
                                localStorage.setItem("connectData",JSON.stringify(Controller.cacheConnectData));//设置缓存
                                setTimeout(function(){
                                    Shell.sendEvent("closeWin");//关闭当前页面
                                },1500);
                            }catch(error){}
                        }else if(arg.retCode == "NO_AUTH"){
                            try{
                                Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                            }catch(e){}
                        }else{
                            try{
                                api.toast({msg:arg.message,duration:1500,location:"middle"});
                            }catch(e){}
                        }
                        Controller.isClick = true;
                    }
                });
            });
        } 
    }
    //当用户点击了删除设备
    function deleteEquipment(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            locking();//调用锁定页面方法
            //初始化询问组件
            var inquiryMaskContainer = $("<div style='z-index:1;'></div>").appendTo($("body"));
            inquiryMaskContainer.CommonDeleteMask({"title":"删除设备","text":"解除绑定后将断开连接并且下次连接时需要重新输入密码，确定要解绑吗？"});
            //监听取消事件  
            inquiryMaskContainer.bind("DELETE_MASK_CANCEL",function(){
                lockout();//调用解锁页面方法
                Controller.isClick = true;//允许点击了
            });
            //监听确定事件
            inquiryMaskContainer.bind("DELETE_MASK_DETERMINE",function(){
                inquiryMaskContainer.CommonDeleteMask("removeMask");//调用询问组件的隐藏组件方法
                //请求参数
                var paramet = {"accountCode":global.accountCode,"token":global.token,"macAddr":Controller.cacheConnectData.macAddress};
                http(ServerConfig.djDomain+"/ctl/cpcapi/bindpen/unbind_pen",paramet,{
                    success:function(arg){
                        if(arg.retCode == "SUCCESS"){
                            try{
                                Shell.sendEvent("breakBluetoothConnect",{"text":"解绑成功"});//给原生发送断开连接事件
                                Controller.cacheConnectData.auto = 1;//修改自动连接属性
                                localStorage.setItem("connectData",JSON.stringify(Controller.cacheConnectData));//设置缓存
                                setTimeout(function(){
                                    Shell.sendEvent("closeWin");//关闭当前页面
                                },1500);
                            }catch(error){}
                        }else if(arg.retCode == "NO_AUTH"){
                            try{
                                Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                            }catch(e){}
                        }else{
                            try{
                                api.toast({msg:arg.message,duration:1500,location:"middle"});
                            }catch(e){}
                        }
                        Controller.isClick = true;//允许点击了
                    }
                });
            });
        }
    }
    //当用户点击了断开连接
    function breakConnect(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            locking();//调用锁定页面方法
            //初始化询问组件
            var inquiryMaskContainer = $("<div style='z-index:1;'></div>").appendTo($("body"));
            inquiryMaskContainer.CommonDeleteMask({"title":"断开连接","text":"断开连接数据将不更新到智能本，是否确定？"});
            //监听取消事件  
            inquiryMaskContainer.bind("DELETE_MASK_CANCEL",function(){
                lockout();//调用解锁页面方法
            });
            //监听确定事件
            inquiryMaskContainer.bind("DELETE_MASK_DETERMINE",function(){
                inquiryMaskContainer.CommonDeleteMask("removeMask");//调用询问组件的隐藏组件方法
                try{
                    Shell.sendEvent("breakBluetoothConnect",{"text":"蓝牙已断开"});//给原生发送断开连接事件
                    setTimeout(function(){
                        Shell.sendEvent("closeWin");//关闭当前页面
                    },1500);
                }catch(error){}
            });
            setTimeout(function(){
                Controller.isClick = true;
            },500);
        }
    }
    return Controller;
});
