/*
*   2021年4月2日
*
*   连接管理页面
*
*   开发者：付长建
*/
define(["jquery","Shell","Fastclick","iscroll","NewPenCell"],function($,Shell,Fastclick,iscroll){
    var Controller = {
		maxContainer:null,//页面最大容器 phonexh("bottom") 
        iscroll:null,//滚动插件
        isClick:true,//防止多次执行
        cacheConnectData:null,//缓存里面当前连接的笔信息
        pageName:"connectmanage",//当前页面的名称主要用于监听原生事件在本页面执行
        isGenerate:true,//这个参数主要控制在倒计时刚刚为0得时候突然检测到笔数据或者在刚刚点击了暂不连接原生还未收到取消检索事件突然返回笔信息突然生成笔列表
        time:null,//检索设备定时器
        alrData:[],//以后笔数据（连接过的笔数据）
        currentBtnData:null,//当前点击的按钮数据
        isForce:1,//是否是强制连接 1不是2是(主要用于判读错误提示)
        isBluetoothError:false,//蓝牙错误
        isLink:false,//是否连接成功笔
        init:function(){
            global = JSON.parse(localStorage.getItem("configData"));//获取配置信息
            Controller.cacheConnectData = JSON.parse(localStorage.getItem("connectData"));//获取缓存内当前连接的数据
			//设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});//禁止整个页面滚动
			this.maxContainer = $("<div style='width:100%;height:100%;'></div>").appendTo($("body"));
            //创建头部元素
            var headContainer = $("<div style='width:100%;padding-top:"+phonexh("top")+"px;box-sizing:border-box;'></div>").appendTo(this.maxContainer);
            this.head = $("<div style='width:100%;height:0.44rem;display:flex;flex-direction:row;'></div>").appendTo(headContainer);
            $("<div style='width:0.4rem;height:0.44rem;display:flex;align-items:center;justify-content:center;'><img style='width:0.1rem;height:0.17rem;' src='../djcommon/img/common/icon_back@3x.png'/></div>").appendTo(this.head);
            this.head.children("div").bind("click",function(){
                if(Controller.isClick){
                    Controller.isClick = false;
                    Shell.sendEvent("closeWin");//关闭当前页面
                }
            });
            //创建当前连接的笔信息元素 请确认笔身的ID码
            this.linkPenInformationContainer = $("<div style='width:100%;padding:0.1rem 0.15rem 0.4rem 0.15rem;box-sizing:border-box;display:flex;flex-direction:row;'></div>").appendTo(this.maxContainer);
            this.penImg = $("<img style='width:0.9rem;height:0.9rem;' src='../djcommon/img/note/mac.png'/>").appendTo(this.linkPenInformationContainer);
            var penNameMacBtnContainer = $("<div style='margin-left:0.15rem;display:flex;flex-direction:column;'></div>").appendTo(this.linkPenInformationContainer);
            //如果没有连接笔就显示默认名称
            this.penName = $("<p style='font-size:0.2rem;color:#000;font-weight:800;position:relative;top:-0.04rem;'>"+Controller.cacheConnectData.penName+"</p>").appendTo(penNameMacBtnContainer);
            //如果没有连接笔就显示默认提示ID码
            this.mac = $("<p style='height:0.18rem;font-size:0.14rem;color:#999;font-weight:500;margin:0.04rem 0 0.1rem 0;'>"+Controller.cacheConnectData.macAddress+"</p>").appendTo(penNameMacBtnContainer);
            this.btnContainer = $("<div style='display:flex;flex-direction:row;'></div>").appendTo(penNameMacBtnContainer);
            $("<div style='width:0.74rem;height:32px;line-height:32px;font-size:12px;text-align:center;color:#C82128;font-weight:bold;border:1px solid #C82128;box-sizing:border-box;border-radius:16px;margin-right:0.15rem;display:none;'>检索设备</div>").appendTo(this.btnContainer);
            $("<p style='width:0.74rem;height:32px;line-height:32px;font-size:12px;text-align:center;color:#999;font-weight:bold;border:1px solid #999;box-sizing:border-box;border-radius:16px;'>设备详情</p>").appendTo(this.btnContainer);
            //创建滚动容器
            var padd = phonexh("bottom") != 0 ? 20 : 0;
            var maxIscrollContainer = $("<div style='width:100%;background:#F8F8F8;'></div>").appendTo(this.maxContainer);
            maxIscrollContainer.css("height",$(window).height() - headContainer.outerHeight(true) - this.linkPenInformationContainer.outerHeight(true) + "px");
            var iscrollContainer = $("<div id='iscrollContainer' style='width:100%;height:"+(maxIscrollContainer.height() - padd)+"px;overflow:hidden;'></div>").appendTo(maxIscrollContainer);
            this.wapIscrollContainer = $("<div style='width:100%;min-height:"+(iscrollContainer.height() + 1)+"px;'></div>").appendTo(iscrollContainer);
            //创建已有设备容器
            this.existingConatiner = $("<div style='width:100%;background:#fff;'></div>").appendTo(this.wapIscrollContainer);
            //创建新的设备容器
            this.newContainer = $("<div style='width:100%;background:#fff;'></div>").appendTo(this.wapIscrollContainer);
            //初始化滚动插件
            this.iscroll = new iscroll("#iscrollContainer",{
                click:iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });
            //监听连接按钮和取消连接按钮被点击
            this.wapIscrollContainer.bind("LINK_BTN_CLICK",connectAndOffConnect);
            //给检索按钮绑定点击事件
            this.btnContainer.children("div").bind("click",equipmentRetrieval);
            //给详情按钮绑定点击事件
            this.btnContainer.children("p").bind("click",connectDetails);
            //调用监听原生发送过来的事件和其它h5页面发送过来的事件
            monitorAllEvent();
			//解决移动端点击事件300ms延迟问题
			Fastclick.attach(document.body);
			//通知原生加载完毕
            Shell.sendPageReady(); 
            //调用获取已有设备数据方法
            getAlrEquipment();
		}
    }
    //监听原生发送过来的事件和其它h5页面发送过来的事件
    function monitorAllEvent(){
        try{
            //监听笔记首页发送过来的蓝牙笔连接成功事件
            api.addEventListener({name:"H5PenConnectSuccess"},function(){
                Controller.isMany = false;
                Controller.cacheConnectData = JSON.parse(localStorage.getItem("connectData"));//获取缓存内当前连接的数据
                Controller.penName.html(Controller.cacheConnectData.penName);//赋值笔名
                Controller.mac.html(Controller.cacheConnectData.macAddress);//赋值mac地址
                Controller.btnContainer.children("div").css("display","none");//隐藏检索按钮
                Controller.btnContainer.children("p").css("display","");//显示设备详情按钮
                lockout();//解锁页面操作按钮
                Controller.alrData = [];//清空已有数据判断重复数组字段
                Controller.newContainer.children().remove();//清空新检索数据节点
                Controller.existingConatiner.children().remove();//清空已有数据节点
                getAlrEquipment();//重新调用获取已有设备数据方法
			});
            //监听笔记首页发送过来的蓝牙断开事件
            api.addEventListener({name:"H5BluetoothBreak"},function(arg){
                Controller.isLink = false;//赋值连接断开
                Controller.wapIscrollContainer.find("[penId='"+Controller.cacheConnectData.macAddress+"']").NewPenCell("changeBtnName","连接");//改变点击那个按钮的文字
                //判断当前是否是点击触发的连接断开或失败
                if(Controller.currentBtnData != undefined && Controller.currentBtnData != null){
                    Controller.wapIscrollContainer.find("[penId='"+Controller.currentBtnData.macAddress+"']").NewPenCell("changeBtnName","连接");//改变点击那个按钮的文字
                }
                Controller.wapIscrollContainer.find("[penId='"+Controller.cacheConnectData.macAddress+"']").find(".fcjBtn").css({"background":"#fff","color":"#000","border-color":"#DCDCDC"});
                Controller.wapIscrollContainer.find("[penId='"+Controller.cacheConnectData.macAddress+"']").removeClass("fcjll");
                Controller.penName.html("蓝牙笔");
                Controller.mac.html("请确认笔身的ID码");
                Controller.btnContainer.children("div").css("display","");//显示检索按钮
                Controller.btnContainer.children("p").css("display","none");//隐藏设备详情按钮
                //判断当前是否是强制连接笔
                if(Controller.isForce == 2){
                    if(parseInt(arg.type) != 1){//强制连接的时候原生的断开连接不需要提示
                        api.toast({"msg":"连接失败","duration":1500,"location":"middle"});
                    }
                    lockout();//解锁页面操作按钮
                }else{
                    if(arg.value.text == "连接取消"){
                        lockout();//调用界面解锁方法
                    }else{
                        api.toast({"msg":arg.value.text,"duration":1500,"location":"middle"});//提示信息
                        setTimeout(function(){
                            lockout();//调用界面解锁方法
                        },1500);
                    }
                }
			});
            //监听原生发送的扫描到笔事件
			api.addEventListener({name:"bluetoothSuccess"},function(arg){
				//判断是否是当前页面的扫描成功事件
				if(arg.value.pageName == Controller.pageName){
					generateNewData(arg.value.penData);//调用生成新检索到的数据
				}
			});
			//监听件原生发送的扫描出错事
			api.addEventListener({name:"scanningBluetoothError"},function(arg){
				//判断是否是当前页面的扫描成功事件
				if(arg.value.pageName == Controller.pageName){
                    //判断当前是否是强制连接笔
                    if(Controller.isForce == 2){
                        api.toast({"msg":"连接失败","duration":1500,"location":"middle"});
                    }else{
                        api.toast({"msg":arg.value.text,"duration":1500,"location":"middle"});
                        Controller.wapIscrollContainer.find("[penId='"+Controller.currentBtnData.macAddress+"']").NewPenCell("changeBtnName","连接");//改变点击那个按钮的文字
                    }
                    setTimeout(function(){
                        lockout();//解锁页面操作按钮
                    },1500);
				}
			});
            //监听笔记首页发送过来的移除页面监听事件的事件
            api.addEventListener({name:"H5removeEvent"},function(arg){
                removeAllEvent();//调用移除页面监听事件方法
			});
        }catch(e){}
    }
    //移除页面监听事件方法
	function removeAllEvent(){
		try{
            api.removeEventListener({"name":"H5PenConnectSuccess"});//移除笔记首页发送过来的蓝牙笔连接成功事件
            api.removeEventListener({"name":"H5BluetoothBreak"});//移除笔记首页发送过来的蓝牙已断开事件
			api.removeEventListener({"name":"bluetoothSuccess"});//移除原生发送的扫描到笔事件
			api.removeEventListener({"name":"scanningBluetoothError"});//移除件原生发送的扫描出错事
			api.removeEventListener({"name":"H5removeEvent"});//移除笔记首页发送过来的移除页面监听事件的事件
		}catch(e){}
	}
    //判读设备函数（主要解决点击事件失效问题）
    function iScrollClick(){
        if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
        if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
        if (/Silk/i.test(navigator.userAgent)) return false;
        if (/Android/i.test(navigator.userAgent)) {
        var s = navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
            return parseFloat(s[0]+s[3]) < 44 ? false : true
        }
    }
    //生成已有数据
    function generateExistingData(dataArray){
        noData(dataArray);//调用是否添加没有数据样式方法
        //判断是否有已有设备数据
        if(dataArray.length != 0){
            var title = $("<p id='already' style='width:100%;height:0.4rem;line-height:38px;padding-left:0.15rem;box-sizing:border-box;font-size:0.14rem;color:#000;font-weight:bold;'>已有设备</p>").appendTo(Controller.existingConatiner);
            for(var i = 0; i < dataArray.length; i++){
                //判断设备进行特殊处理连接字段
                if(global.deviceType == "ios"){
                    dataArray[i].macAddress = dataArray[i].penSnAddr != undefined ? dataArray[i].penSnAddr : dataArray[i].penMacAddr;//给原数据加一个字段主要是用于适配笔连接（拓思德笔需要使用SN码）
                }else{
                    dataArray[i].macAddress = dataArray[i].penMacAddr;//给原数据加一个字段主要是用于适配笔连接（拓思德笔ios需要使用SN码）
                }
                Controller.alrData.push(dataArray[i].macAddress);//这个主要用于检测的时候判断是否在已有设备有新检测出来的数据（用于去重）
                var tiem = $("<div penId='"+dataArray[i].macAddress+"' style='width:100%;padding:0 0.15rem 0 0.15rem;border-top:1px solid #EAEFF2;box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-between;'></div>").appendTo(Controller.existingConatiner);
                tiem.NewPenCell({"data":dataArray[i]});
            }
            title.after($("[penId='"+Controller.cacheConnectData.macAddress+"']"));
            Controller.existingConatiner.find("[penId='"+Controller.cacheConnectData.macAddress+"']").NewPenCell("changeBtnName","断开连接");
            Controller.existingConatiner.find("[penId='"+Controller.cacheConnectData.macAddress+"']").find(".fcjBtn").css({"background":"linear-gradient(90deg, #CF000F 0%, #E50414 100%)","color":"#fff","border-color":"#CF000F"});
            Controller.existingConatiner.find("[penId='"+Controller.cacheConnectData.macAddress+"']").addClass("fcjll");
            //判断是否是初始化密码连接
            if(Controller.existingConatiner.find("[penId='"+Controller.cacheConnectData.macAddress+"']").length == 0){
                Controller.isLink = true;//赋值连接初始化密码连接状态
            }else{
                Controller.isLink = false;//赋值连接初始化密码连接状态
            }
        }
        $("body").fadeTo("slow",1);
        Controller.iscroll.refresh();//刷新高度
        setTimeout(function(){
            Controller.isMany = true;
        },1000);
    }
    //生成新检索到的数据
    function generateNewData(dataArray){
        noData(dataArray);//调用是否添加没有数据样式
        //判断是否可以生成新检测到的设备
        if(Controller.isGenerate){
            //判断新检测的数据是否为空
            if(dataArray.length != 0){
                if($(".newTiele").length == 0){
                    var title = $("<p class='newTiele' style='width:100%;height:0.4rem;margin-top:0.1rem;line-height:38px;padding-left:0.15rem;box-sizing:border-box;font-size:0.14rem;color:#000;font-weight:bold;'>新的设备</p>").appendTo(Controller.newContainer);
                    if(Controller.existingConatiner.children("div").length == 0){
                        title.css("margin-top","0");
                    }
                }
                for(var i = 0; i < dataArray.length; i++){
                    //判断新检索到的笔数据如果在已有设备容器有了就不在新设备容器显示
                    if(Controller.alrData.indexOf(dataArray[i].macAddress) == -1){
                        var tiem = $("<div penId='"+dataArray[i].macAddress+"' style='width:100%;padding:0 0.15rem 0 0.15rem;border-top:1px solid #EAEFF2;box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-between;'></div>").appendTo(Controller.newContainer);
                        tiem.NewPenCell({"data":dataArray[i]});
                    }
                }
            }
            Controller.iscroll.refresh();//刷新高度
            Controller.iscroll.scrollTo(0,Controller.iscroll.maxScrollY,300);//滚动到指定位置
            Controller.newContainer.children("div").NewPenCell("locking");//锁定所有新设备按钮
            //判断是否有新设备
            if(Controller.newContainer.children("div").length == 0){
                title.remove();
            }
        }
    }
    //锁定本页面所有操作按钮方法
    function locking(){
        Controller.existingConatiner.children("div").NewPenCell("locking");//锁定所有已有设备按钮
        Controller.newContainer.children("div").NewPenCell("locking");//锁定所有新设备按钮
        Controller.btnContainer.css({"pointer-events":"none","opacity":"0.5"});//锁定检索和详情按钮
        Controller.head.css({"pointer-events":"none","opacity":"0.5"});//锁定头部返回按钮
        Controller.iscroll.enabled = false;//禁止滚动容器刷新
    }
    //解锁本页面所有操作按钮方法 
    function lockout(){
        Controller.existingConatiner.children("div").NewPenCell("lockout");//解锁所有已有设备按钮
        Controller.newContainer.children("div").NewPenCell("lockout");//解锁所有新设备按钮
        Controller.btnContainer.css({"pointer-events":"","opacity":""});//解锁检索和详情按钮
        Controller.head.css({"pointer-events":"","opacity":""});//解锁头部返回按钮
        Controller.iscroll.enabled = true;//允许滚动容器刷新
    }
    //点击连接和断开连接方法
    function connectAndOffConnect(event,obj){
        Controller.currentBtnData = obj.penData;//赋值当前点击的那个按钮数据
        locking();//调用锁定本页面所有操作按钮方法
        //判断当前点击的是连接还是断开连接
        if(obj.type == "连接"){
            Controller.wapIscrollContainer.find("[penId='"+Controller.cacheConnectData.macAddress+"']").find(".fcjBtn").css({"background":"#fff","color":"#000","border-color":"#DCDCDC"});//将连接中那个条数据置为正常连接按钮不高量
            Controller.wapIscrollContainer.find("[penId='"+Controller.cacheConnectData.macAddress+"']").NewPenCell("changeBtnName","连接");//将连接中那个数据文字改成连接
            Controller.wapIscrollContainer.find("[penId='"+obj.penData.macAddress+"']").NewPenCell("changeBtnName","连接中...");
            //判断是强挤还是正常连接
            if($(".fcjll").length == 0){
                //判断是否是初始化密码连接
                if(Controller.isLink){
                    try{    
                        Controller.isForce = 2;//强制连接
                        Shell.sendEvent("H5stopGetElectricity");//告诉首页停止获取电量
                        Shell.sendEvent("forceConnect",{"penData":obj.penData,"pageName":Controller.pageName});//给原生发送强制连接事件
                    }catch(e){}
                }else{
                    try{    
                        Controller.isForce = 1;//普通连接
                        Shell.sendEvent("connectBluetoothPen",{"penData":obj.penData,"pageName":Controller.pageName});//给原生发送连接事件
                    }catch(e){}
                }
            }else{
                try{    
                    Controller.isForce = 2;//强制连接
                    Shell.sendEvent("H5stopGetElectricity");//告诉首页停止获取电量
                    Shell.sendEvent("forceConnect",{"penData":obj.penData,"pageName":Controller.pageName});//给原生发送强制连接事件
                }catch(e){}
            }
        }else{
            Controller.isForce = 1;//普通连接
            Shell.sendEvent("breakBluetoothConnect",{"text":"蓝牙已断开"});//给原生发送断开连接事件
            Controller.wapIscrollContainer.find("[penId='"+obj.penData.macAddress+"']").NewPenCell("changeBtnName","连接");
            Controller.wapIscrollContainer.find("[penId='"+Controller.cacheConnectData.macAddress+"']").find(".fcjBtn").css({"background":"#fff","color":"#000","border-color":"#DCDCDC"});
        }
    }
    //当用户点击了设备检索按钮
    function equipmentRetrieval(){
        if(Controller.isClick){
            Controller.isClick = false;
            Controller.isGenerate = true;//允许新检测到的数据进行显示
            locking();//调用锁定本页面所有操作按钮方法
            Controller.newContainer.children().remove();//清空所有数据
            Shell.sendEvent("startScanningBluetooth",{"pageName":Controller.pageName});//给原生发送开始扫描蓝牙笔事件
            var inx = 2;
            var time = setInterval(function(){
                if(inx > 1){
                    inx = inx - 1;
                }else{
                    Controller.isGenerate = false;//不允许新检测到的数据进行显示
                    Shell.sendEvent("stopScanningBluetooth",{"pageName":Controller.pageName});//给原生发送停止扫描蓝牙笔事件
                    clearInterval(time);//清除定时器
                    lockout();//调用本页面所有操作按钮方法
                    Controller.isClick = true;
                    //判断是否有新检测到的数据和已连接的数据
                    if(Controller.newContainer.children("div").length == 0 && Controller.existingConatiner.children("div").length == 0){
                        noData([]);//调用是否添加没有数据样式
                    }
                }
            },1000);
        } 
    }
    //调用用户点击了连接详情按钮
    function connectDetails(){
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("closeWin");//关闭当前页面返回到详情页面
            }catch(e){}
            return;
        }
    }
    //是否添加没有数据样式
    function noData(dataArray){
        if(dataArray.length == 0){
            $("#iscrollContainer").css({"border-top":"1px solid #efefef","box-sizing":"border-box"});
            Controller.wapIscrollContainer.css({
                "background":"url(../djcommon/img/note/img_nodata_all.png) #fff",
                "background-repeat":"no-repeat",
                "background-size":"2.54rem 1.21rem",
                "background-position":"50% 30%"
            });
        }else{
            $("#iscrollContainer").css({"border-top":"","box-sizing":""});
            Controller.wapIscrollContainer.css({
                "background":"",
                "background-repeat":"",
                "background-size":"",
                "background-position":""
            });
        }
    }
    //获取已有设备数据
    function getAlrEquipment(){
        //请求参数
		var paramet = {"token":global.token,"accountCode":global.accountCode};
        var ajaxTimeoutTest = $.ajax({
			cache:false,
			type:"POST",
			url:ServerConfig.djDomain+"/ctl/cpcapi/bindpen/get_cpc_bind_pen_list",
			timeout:3000,
			data:paramet,
			dataType:"json",
			success:function(arg){
                if(arg.retCode == "SUCCESS"){	
                    if(arg.data != undefined && arg.data != null){
                        generateExistingData(arg.data);//调用生成已有设备数据
                    }else{
                        generateExistingData([]);//调用生成已有设备数据
                    }
                }else if(arg.retCode == "NO_AUTH"){
                    try{
						Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
					}catch(e){}
                }else{
					try{
						api.toast({msg:arg.message,duration:1500,location:"middle"});
					}catch(e){}
				}
			},
			complete:function(XMLHttpRequest,status){//请求完成后最终执行参数
		　　　　 if(status == "timeout"){
					try{
						api.toast({"msg":"您的网络似乎有问题，请检测您的网络设置","duration":1500,"location":"middle"});
					}catch(e){}
			　　　　 ajaxTimeoutTest.abort();
		　　　　 }
			}
		});
    }
    return Controller;
});
