/*
*   2021年5月13日
*
*   笔记协同
*
*   开发者：付长建
*/
define(["jquery","Shell","Fastclick"],function($,Shell,Fastclick,){
    var Controller = {
        init:function(){
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            Controller.jssdk = null;//协同对象
            Controller.token = getUrl("token");//用户token
            Controller.uuid = getUrl("uuid");//文件uuid
            Controller.http = getUrl("http");//访问域名 https://view.ys100.com
            Controller.fileId = getUrl("fileId");//保存文件的id
            try{
                //监听原生点击了保存事件
                api.addEventListener({"name":"sendDocName"},function(e){
                    jssdk.ready();
                    saveType = jssdk.save();
                    setTimeout(function(){
                        keepMyspace(e.value.fileName);//调用保存到个人空间的方法
                    },1000);
                });
            }catch(error){}
            //调用获取平哥协同地址方法
            getCoordinationUrl();
            //解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
            setTimeout(function(){
                Shell.sendPageReady();//通知原生加载完毕
            },300);
        }
    }
    //刷新token方法
    function refreshToken(){
        var url = Controller.http+"/getUrlAndToken?token="+Controller.token+"&uuid="+Controller.uuid;
        //请求参数
        var paramet = {"ajaxType":"GET"};
        http(url,paramet,{
            success:function(data){
                setToken(data.token);//调用设置token方法
            }
        });
    }
    //设置token方法
    function setToken(token){
        jssdk.setToken({
            token:token,
            timeout:10 * 60 * 1000,
        });
    }
    //调用平哥接口
    function getCoordinationUrl(){
        var url = Controller.http+"/getUrlAndToken?token="+Controller.token+"&uuid="+Controller.uuid;
        //请求参数
        var paramet = {"ajaxType":"GET"};
        http(url,paramet,{
            success:function(data){
                jssdk = WebOfficeSDK.config({
                    mount:document.querySelector(".iframeContainer"),//设置iframe挂载节点
                    mode:"normal",//普通模式
                    url:data.wpsUrl,//协同地址
                    timeout:10 * 60 * 1000,//设置token有效时间
                    wordOptions:{mobile:{isOpenIntoEdit:true}},//打开直接进入编辑
                    pdfOptions:{mobile:{isOpenIntoEdit:true,}},//打开直接进入编辑
                    pptOptions:{mobile:{isOpenIntoEdit:true}}//打开直接进入编辑
                });
                setToken(data.token);//调用设置token方法
                setTimeout(function(){
                    $(".loadContainer").css("opacity",0);
                    $(".iframeContainer").css("opacity",1);
                    setTimeout(function(){
                        document.querySelector(".loadContainer").style.display = "none";
                        $(".loadContainer").css("display","none");
                    },300);
                },1500);
                //延迟10分钟新token刷
                setTimeout(function(){
                    refreshToken();//调用刷新token方法
                },10 * 60 * 1000);
            }
        });
    }
    //保存到个人空间方法
    function keepMyspace(name){
        //请求参数
        // 换成java接口
        var paramet = {"accountCode": getUrl("accountCode"), "token":Controller.token,"file_id":Controller.fileId,"name":name};
        http(ServerConfig.djDomain+"/ctl/cpcapi/temporarySpace/saveFileToMySpace",paramet,{
            success:function(arg){
                if(arg.retCode == "SUCCESS"){
                    Shell.sendEvent("preserveDocx",{"type":"success","msg":"已保存至个人空间"});//告诉原生到底是成功还是失败
                    Shell.sendEvent("commonChange",{"pageName":"djmyspace"});//通知原生我个人空间需要刷新
                    setTimeout(function(){
                        Shell.sendEvent("closeWin");//关闭当前页面
                    },1000);
                }else{
                    //判断是否是退出登录了
                    if(arg.retCode == "NO_AUTH"){
                        Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                    }else{
                        Shell.sendEvent("preserveDocx",{"type":"error","msg":arg.message});//告诉原生到底是成功还是失败
                    }
                }
            }
        });
    }
    return Controller;
});
