/*
*   2021年4月7日
*
*   本子管理页面 phonexh("bottom") 
*
*   开发者：付长建
*/
define(["jquery","Shell","Fastclick","iscroll"],function($,Shell,Fastclick,iscroll){
    var Controller = {
        iscrollX:null,
        iscrollY:null,
        pageName:"createbook",//当前页面的名称主要用于监听原生事件在本页面执行 
        isClick:true,//防止点击事件多次执行 
        contentHeight:0,//滚动容器的高度
        screenData:[],//筛选数据
        currentData:{},//当前选中的数据
        bookData:{},//本子数据
        init:function(){
             

            global = JSON.parse(localStorage.getItem("configData"));//获取配置信息
            //设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});//禁止整个页面滚动
            //创建头部元素
            var maxHeadContainer = $("<div style='width:100%;padding-top:"+phonexh("top")+"px;border-bottom:1px solid #EAEFF2;box-sizing:border-box;'></div>").appendTo($("body"));
            this.headContent = $("<div style='width:100%;height:0.44rem;display:flex;flex-direction:row;justify-content:center;position:relative;'></div>").appendTo(maxHeadContainer);
            $("<p style='height:100%;display:flex;align-items:center;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;position:absolute;top:0;left:0;'><img style='width:0.1rem;height:0.17rem;' src='../djcommon/img/common/icon_back@3x.png'/></p>").appendTo(this.headContent);
            $("<span style='display:flex;align-items:center;font-size:0.18rem;font-weight:bold;color:#000;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;'>新增笔记本</span>").appendTo(this.headContent);
            //创建筛选栏
            var screenContainer = $("<div style='width:100%;height:0.6rem;padding:0.15rem;box-sizing:border-box;'></div>").appendTo($("body"));
            var iscrollContainerX = $("<div id='iscrollContainerX' style='width:100%;height:100%;overflow:hidden;'></div>").appendTo(screenContainer);
            //创建内容容器
            this.contentHeight = $(window).height() - maxHeadContainer.outerHeight(true) - screenContainer.outerHeight(true);//得到滚动容器的高度
            this.contentContainer = $("<div id='iscrollYContent' style='width:100%;height:"+this.contentHeight+"px;transition:all 0.3s;overflow:hidden;'></div>").appendTo($("body"));
            this.iscrollYContent = $("<div style='width:100%;min-height:"+(this.contentContainer.height() + 1)+"px;'></div>").appendTo(this.contentContainer);
            //初始化筛选滚动插件
            this.iscrollY = new iscroll("#iscrollYContent",{
                click:iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });
            //创建底部操作菜单  
            this.optMenuContainer = $("<div style='width:100%;height:195px;padding:20px 20px 20px 20px;box-sizing:border-box;background:#fff;border-radius:8px 8px 0px 0px;position:relative;'></div>").appendTo($("body"));
            $("<p style='font-size:0.15rem;color:#333;font-weight:bold;'></p>").appendTo(this.optMenuContainer);
            $("<span style='display:flex;font-size:0.13rem;color:#666;font-weight:500;margin-top:10px;'></span>").appendTo(this.optMenuContainer);
            $("<div style='width:100%;height:44px;padding:0 22px 0 22px;box-sizing:border-box;position:absolute;left:0;bottom:20px;'><p style='width:100%;height:100%;text-align:center;line-height:42px;border-radius:22px;background:linear-gradient(270deg, #CF000F 0%, #E30514 100%);font-size:0.16rem;color:#fff;font-weight:500;'>确认添加</p></div>").appendTo(this.optMenuContainer);
            //给头部的返回按钮绑定点击事件
            this.headContent.children("p").bind("click",goBackClick);
            //给确认添加按钮绑定点击事件
            this.optMenuContainer.children("div").children("p").bind("click",addBook);
            //调用按钮按下抬起效果
            btnTextCommon(this.optMenuContainer.children("div").children("p"));
            //解决移动端点击事件300ms延迟问题
			Fastclick.attach(document.body);
            
            $("body").fadeTo("slow",1);
            
            // 获取分类
            getCodeByType();
            // 获取本子列表
            getSmartBookList('');
		},

    }

    //判读设备函数（主要解决点击事件失效问题）
    function iScrollClick(){
        if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
        if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
        if (/Silk/i.test(navigator.userAgent)) return false;
        if (/Android/i.test(navigator.userAgent)) {
        var s = navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
            return parseFloat(s[0]+s[3]) < 44 ? false : true
        }
    }
    //按钮按下抬起效果
    function btnTextCommon(element){
        //给选项绑定手指按下事件
        element.bind('touchstart',function(){
            $(this).css("opacity","0.5");
        });
        //给选项绑定手指抬起事件
        element.bind('touchend',function(){
            $(this).css("opacity","");
        });
    }
    //当用户点击返回按钮
    function goBackClick(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("closeWin");//关闭当前页面
            }catch(e){}
        }
    }
    //点击筛选按钮方法
    function screenClick(){
        // 分类code
        var code = $(this).data("code");            
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            Controller.iscrollXContent.find("li").css({"border-color":"#EFF0F3","color":"#666","background":"#EFF0F3"});
            $(this).css({"border-color":"#C82128","color":"#C82128","background":"rgba(200,33,40,0.08)"});
            // 获取指定分类的本子列表
            getSmartBookList(code);
            setTimeout(function(){
                Controller.isClick = true;
            },200);
        }
    }


    //生成顶部分类方法
    function getScreenData(arr){
        console.log('生成顶部分类方法')
        console.log(arr)
        Controller.iscrollXContent = $("<ul style='width:"+(Controller.screenData.length * 79 - 15)+"px;height:100%;'></ul>").appendTo(iscrollContainerX);
        //初始化筛选滚动插件
        Controller.iscrollX = new iscroll("#iscrollContainerX",{
            scrollX:true,  
            scrollY:false, 
            click:iScrollClick(),//调用判断函数
            tap:true,//开启自定义的点击事件
            bounceTime:300,//配置滑动回弹时间
            probeType:3//开启这个参数就可以每滑动1px获取一次值
        });
        for(var i = 0; i < arr.length; i++){
            $("<li data-code='" + arr[i].code + "'   style='width:64px;height:100%;display:flex;align-items:center;justify-content:center;margin-left:15px;font-size:0.13rem;color:#666;font-weight:400;background:#EFF0F3;border-radius:15px;border:1px solid #EFF0F3;box-sizing:border-box;float:left;'>"+Controller.screenData[i].name+"</li>").appendTo(Controller.iscrollXContent);
            }
        //去除第一个子元素的margin-left
        Controller.iscrollXContent.find("li:first-child").css({"border-color":"#C82128","color":"#C82128","margin-left":"0","background":"rgba(200,33,40,0.08)"});
        //给所有的筛选按钮绑定点击事件
        Controller.iscrollXContent.children("li").bind("click",screenClick);
    }


    //生成本子方法
    function generateBook(arr){
        // setTimeout(() => {
            console.log('生成本子方法')
            console.log(arr)
            Controller.iscrollYContent.children().remove();
            for(var i = 0; i < arr.length; i+=3){
                var content = $("<ul style='width:100%;background:url(../djcommon/img/note/bg_shujia.png);background-size:100% 32px;background-repeat:no-repeat;display:flex;flex-direction:row;justify-content:flex-start; padding-left: .4rem; padding-right: .4rem;background-position:0 0.9rem;padding-bottom:0.6rem;box-sizing:border-box;'></ul>").appendTo(Controller.iscrollYContent);
                for(var j = i; j < i + 3 && j<arr.length; j+=1){
                    if(arr[j].bookDesc == undefined || arr[j].bookDesc == null) {
                        arr[j].bookDesc = '';
                    }
                    var backImg = arr[j].bookType != undefined ? arr[j].bookIconUrl : "";
                    var tmen = $("<li isShow='no' text='"+arr[j].bookDesc+"' penType='"+arr[j].dotPageSource+"'  bookName='"+arr[j].bookName+"' bookType='"+arr[j].bookType+"' style='width:0.71rem;height:0.98rem;background:url("+backImg+");background-size:cover;border-radius:0 5px 5px 0;margin-right: .4rem;flex-shrink:0;position:relative;overflow:hidden;'></li>").appendTo(content);
                    var msk = $("<div style='z-index:-1;position:absolute;top:0;left:0;width:0.71rem;height:0.98rem;background:rgba(0,0,0,0.3);display:flex;align-items:center;justify-content:center;transition:all 0.3s;opacity:0;'></div>").appendTo(tmen);
                    $("<img style='width:0.2rem;height:0.2rem;' src='../djcommon/img/note/note_fm_dan.png'/>").appendTo(msk);
                }   
            }
            if(arr.length == '') {
                var content = $("<ul style='width:100%;background:url(../djcommon/img/note/bg_shujia.png);background-size:100% 32px;height:152px; background-repeat:no-repeat;display:flex;flex-direction:row;justify-content:space-evenly;background-position:0 0.9rem;padding-bottom:0.6rem;box-sizing:border-box;'></ul>").appendTo(Controller.iscrollYContent);
            }
            var padd = phonexh("bottom") == 0 ? "0.4rem" : "0.3rem";
            Controller.iscrollYContent.find("ul:first-child").css("margin-top","0.1rem");//处理第一一排书架的padding-top值
            Controller.iscrollYContent.find("ul:last-child").css("padding-bottom",padd);//处理最后一排书架的padding-bottom值
            //给所有的本子绑定点击事件
            Controller.iscrollYContent.find("li").bind("click",bookClick);
            Controller.iscrollY.refresh();//刷新高度
        // }, 260);
    }
    //点击本子方法
    function bookClick(){
        //判断是否是补位的元素
        if($(this).attr("bookType") == "undefined"){
            return;
        }
        //判断当前是显示还是隐藏
        if($(this).attr("isShow") == "no"){
            Controller.iscrollYContent.find("li").attr("isShow","no").children("div").css({"z-index":"-1","opacity":"0"});
            $(this).attr("isShow","yes");
            $(this).children("div").css({"z-index":"1","opacity":"1"});
            Controller.currentData.bookType = $(this).attr("bookType");
            Controller.currentData.bookName = $(this).attr("bookName");
            Controller.currentData.penType = $(this).attr("penType") ==2?'6':$(this).attr("penType");
            Controller.optMenuContainer.css("box-shadow","0px -2px 8px #E5E5E5");
            Controller.optMenuContainer.children("p").html($(this).attr("bookName"));
            Controller.optMenuContainer.children("span").html($(this).attr("text"));
            Controller.contentContainer.css("height",Controller.contentHeight - 195 + "px");
            Controller.iscrollYContent.css("min-height",Controller.contentHeight - 194 + "px");
            Controller.iscrollXContent.css({"pointer-events":"none","opacity":"0.7"});
            Controller.optMenuContainer.children("div").children("p").css({"pointer-events":"","opacity":""});
            Controller.iscrollX.enabled = false;
        }else{
            Controller.optMenuContainer.children("div").children("p").css({"pointer-events":"none","opacity":"0.7"});
            $(this).attr("isShow","no");
            $(this).children("div").css({"z-index":"-1","opacity":"0"});
            Controller.contentContainer.css("height",Controller.contentHeight + "px");
            Controller.iscrollYContent.css("min-height",Controller.contentHeight + 1 + "px");
            Controller.optMenuContainer.css("box-shadow","");
            Controller.currentData = {};
            Controller.iscrollXContent.css({"pointer-events":"","opacity":""});
            Controller.iscrollX.enabled = true;
        }
        setTimeout(function(){
            Controller.iscrollY.refresh();//刷新高度
        },300);
    }
    //点击确当添加按钮
    function addBook(){
        if(!Controller.isClick){
            return;
        }
        Controller.isClick = false;
        Controller.iscrollY.enabled = false;
        Controller.contentContainer.css({"pointer-events":"none","opacity":"0.7"});
        Controller.optMenuContainer.css({"pointer-events":"none","opacity":"0.7"});
        if(Controller.currentData.penType == ""){
            try{
                api.toast({msg:"暂未配置此智能本",duration:1500,location:"middle"});
            }catch(e){}
            setTimeout(function(){
                Controller.isClick = true;
                Controller.iscrollY.enabled = true;
                Controller.contentContainer.css({"pointer-events":"","opacity":""});
                Controller.optMenuContainer.css({"pointer-events":"","opacity":""});
            },1500);
            return;
        }
        //请求参数
		var paramet = { 
            "token":global.token,
            "accountCode":global.accountCode,
            "bookName":Controller.currentData.bookName,
            "bookType":Controller.currentData.bookType,
            "penType":Controller.currentData.penType
        };
        http(ServerConfig.djDomain+"/ctl/cpcapi/book/create_book",paramet,{
            success:function(arg){
                if(arg.retCode == "SUCCESS"){	
                    try{
                        Shell.sendEvent("H5addBookSuccess");//通知本子管理页面和首页添加本子成功事件
                        api.toast({"msg":"添加成功","duration":1500,"location":"middle"});
                        Controller.headContent.children("p").css({"pointer-events":"none","opacity":"0.7"});
                        setTimeout(function(){
                            Shell.sendEvent("closeWin");//关闭当前页面
                        },1500);
                    }catch(e){}
                }else if(arg.retCode == "NO_AUTH"){
                    try{
						Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
					}catch(e){}
                }else{
					try{
						api.toast({"msg":arg.message,"duration":1500,"location":"middle"});
					}catch(e){}
				}
                setTimeout(function(){
                    Controller.isClick = true;
                    Controller.iscrollY.enabled = true;
                    Controller.contentContainer.css({"pointer-events":"","opacity":""});
                    Controller.optMenuContainer.css({"pointer-events":"","opacity":""});
                },1500);
            }
        });
    };

    // 获取分类
    function getCodeByType() {
        http(ServerConfig.djDomain+"/ctl/cpcapi/common/getCodeByType",{codeType:'book_classify',token:'global.token',accountCode:'global.accountCode'},{
            success:function(arg){
                console.log('分类')
                console.log(arg)
                if(arg.retCode == "SUCCESS"){
                    try{
                        // 全部
                        var all = {code: '', name: "全部"}
                        // 插入数据
                        Controller.screenData = [all,...arg.data];
                        getScreenData(Controller.screenData)
                    }catch(e){}
                }else if(arg.retCode == "NO_AUTH"){
                    try{
						Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
					}catch(e){}
                }else{
					try{
						api.toast({"msg":arg.message,"duration":1500,"location":"middle"});
					}catch(e){}
				}
            }
        });
    }

    // 获取本子列表
    function getSmartBookList(code) {
        //请求参数
		var paramet = { 
            "token":global.token,
            "accountCode":global.accountCode,
            "book_state":'1',
            "pageSize":'999',
            "book_classify":code
        };
        http(ServerConfig.djDomain+"/ctl/cpcapi/smartBook/list",paramet,{
            success:function(arg){
                console.log('获取本子列表')
                console.log(arg)
                if(arg.retCode == "SUCCESS"){	
                    try{
                        // 插入数据
                        Controller.bookData = [...arg.data];
                        //调用生成本子方法
                        generateBook(Controller.bookData);

                        

                    }catch(e){}
                }else if(arg.retCode == "NO_AUTH"){
                    try{
						Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
					}catch(e){}
                }else{
					try{
						api.toast({"msg":arg.message,"duration":1500,"location":"middle"});
					}catch(e){}
				}

                setTimeout(function(){
                    //通知原生加载完毕
                   Shell.sendPageReady();
               },200);
               
            }
        });
    }
    return Controller;
});
