/*
*   2020年12月5日
*
*   保险箱js控制器
*
*   开发者：付长建 
*/
define(["jquery","Shell","Fastclick","YsPreviewManager","CommonToast","CommonHead","CommonSearch","CommonCrumbs","CommonIscroll","CommonBottonMenu","CommonCell","DepositSearchPanel"],function($,Shell,Fastclick,YsPreviewManager){
    var Controller = {
        CommonToastContainer:null,//飘窗组件
        maxContainer:null,//页面最大元素
        headContainer:null,//头部组件
        searchContainer:null,//搜索组件
        crumbsContainer:null,//面包屑组件
        iscrollContainer:null,//滚动容器组件
        CommonBottonMenuContainer:null,//列表选择底部操作菜单组件
        depositSearchPanel:null,//搜索panel组件
        pid:0,//获取那一层文件夹下面的文件
        offset:0,//数据请求偏移量
        sort:"createtime",//排序
        fileType:"all",//请求文件类型
        selectSize:2,//控制新生成的节点勾选图标大小参数2是小1是大
        selectData:[],//选中数据数组
        pageName:"deposit",//预览类型，主要是那个页面进行预览
        previewData:{},//预览文件数据（这个主要是给原生用和删除当前正在预览的文件判断是否还有下一张上一张或者下一个上一个文件使用的）
        currentData:{},//当前预览文件的数据（这个主要是用来控制器用和换取预览地址的和给原生提供当前预览的文件信息的）
        isNextPrev:true,//防止用户一只触发上一张下一张事件
        //页面加载成功执行的方法
        init:function(){
            $("body").css("opacity",0);
            //设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            //禁止整个页面滚动
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});
            //获取配置信息
            http(ServerConfig.domain+"/Setting/getGlobal",{"token":getUrl("token")},{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        global.userInfo = arg.data.userInfo;//得到用户信息
                        global.preview_config = arg.data.preview_config;//得到文件预览配置
                        global.is_thumb_model = arg.data.is_thumb_model;//得到是否显示搜索图
                        global.thumb_width_height_config = arg.data.thumb_width_height_config;//得到缩略图配置
                        global.skin = arg.data.skin_name;//得到皮肤配置
                        global.is_yingshuo = arg.data.is_yingshuo;//得到是否显示云笔记筛选选项
                        global.version = arg.data.version;//得到当前是哪个版本
                        Controller.create();//调用创建页面方法
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            try{
                                api.toast({msg:arg.msg,duration:2000,location:"middle"});
                            }catch(e){}
                        }
                    }
                }
            });
            //监听ajax请求错误
            $(window).bind("HTTP_REQUEST_ERROR",function(event,msg){
                try{
                    api.toast({msg:msg,duration:2000,location:"middle"});
                }catch(e){}
            });
        },
        //生成页面
        create:function(){
            //初始化预览管理器
            YsPreviewManager.Init(
                Controller.pageName,
                global.preview_config.preview_config.type,
                global.preview_config.preview_config.type=="url"?global.preview_config.preview_config.storageStatus+"?uid=1&uuid=":"",
                global.preview_config.preview_config.type=="url"?global.preview_config.preview_config.task+"?user_id=1&":"",
                global.preview_config.preview_config.type=="url"?global.preview_config.download_check_task_url+"?id=":"",
                global.preview_config.preview_config.type=="url"?global.preview_config.preview_config.encode+"?origin=2&appName=dj&":global.preview_config.preview_config.encode+"?origin=1&appName=dj&",
                global.preview_config.preview_config.encodeStatus+"?task=",
                function(successObj){
                    Controller.previewData.url = successObj.url;//赋值获取到的预览地址
                    Shell.sendEvent("changePreviewFileAndImage",Controller.previewData);
                },function(errorObj){
                    Controller.previewData.error = errorObj.error;
                    Shell.sendEvent("changePreviewFileAndImage",Controller.previewData);
                }
            )
            //创建飘窗提示元素
            Controller.CommonToastContainer = $("<div></div>").CommonToast().appendTo($("body"));
            //创建页面最大容器元素
            this.maxContainer = $("<div style='width:100%;height:100%;background:#fff;position:relative;overflow:hidden;'></div>").appendTo($("body"));
            //创建页面头部
            this.headContainer = $("<div></div>").appendTo(this.maxContainer);
            //判断是否需要云笔记选项
            this.headContainer.CommonHead({
                "isGoback":true,//是否显示返回按钮
                "title":"保险箱"
            });
            //初始化搜索组件  
            this.searchContainer = $("<div style='width:100%;padding-left:0.15rem;box-sizing:border-box;box-shadow:0px 3px 4px 1px rgba(0, 37, 87, 0.03);background:#fff;'></div>").appendTo(this.maxContainer);
            this.searchContainer.CommonSearch({
                "isSortBtn":true,//是否显示排序按钮
                "isInputClickFocus":false//输入框是否可以点击获取焦点
            });
            //初始化面包屑组件
            this.crumbsContainer = $("<div style='width:100%;height:0.36rem;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;background:rgba(0,37,87,0.05);overflow:hidden;'></div>").appendTo(this.maxContainer);
            this.crumbsContainer.CommonCrumbs({"navData":[{"text":"云盘","pid":-1},{"text":"保险箱","pid":0}]}); 
            //初始化内容滑动组件
            var safe = phonexh("bottom") == 0 ? 0 : 0;//底部安全区
            this.iscrollContainer = $("<div id='baoxianxiangContainer' style='width:100%;overflow:hidden;background:#fff;'></div>").appendTo(this.maxContainer);
            this.iscrollContainer.css("height",this.maxContainer.height() - this.headContainer.outerHeight(true) - this.searchContainer.outerHeight(true) - this.crumbsContainer.outerHeight(true) - safe + "px");
            this.iscrollContainer.CommonIscroll({"isUploadBtn":false});
            //初始化底部操作菜单组件
            this.CommonBottonMenuContainer = $("<div isShow='no' style='width:100%;'></div>").appendTo(this.maxContainer);
            this.CommonBottonMenuContainer.CommonBottonMenu({
                "btnMenu":[
                    {"text":"移出保险箱","type":"inSafe","icon":skinConfig(global.skin).commonIcon + "out.png"},
                    {"text":"转为文档","type":"change","icon":skinConfig(global.skin).commonIcon + "pop_icon.png"}
                ]
            });  
            //监听返回按钮被点击
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                var pidAndName = Controller.crumbsContainer.CommonCrumbs("getPid");//调用面包屑组件获取上一层pid和文件名方法
                //判断当前是否是在最外层了 
                if(pidAndName.pid != undefined){
                    lock("yes");//锁定头部组件，搜索组件，面包屑组件，列表选中底部操作菜单组件
                    Controller.iscrollContainer.find("li").CommonCell("lockList","yes");//锁定所有列表禁止点击
                    Controller.pid = pidAndName.pid;//重置pid
                    Controller.offset = 0;//重置数据请求起止位置
                    var title = pidAndName.title != "" ? pidAndName.title : "保险箱";
                    Controller.headContainer.CommonHead("changeTitle",title);//调用头部组件显示title文字方法
                    getListData(1);//调用获取数据
                    //判断是否通知原生禁用侧滑和点击物理键返回
                    if(pidAndName.pid != 0){
                        Shell.sendEvent("forwardAndGoback",{"isGoback":false,"pageName":Controller.pageName});//通知原生禁止侧滑和点击虚拟键返回退出应用
                    }else{
                        Shell.sendEvent("forwardAndGoback",{"isGoback":true,"pageName":Controller.pageName});//通知原生允许侧滑和点击虚拟键返回退出应用
                    }
                }else{
                    Shell.sendEvent("closeWin");//关闭当前页面
                }
            });
            //监听头部组件点击全选按钮
            this.headContainer.bind("ALL_SELECT_BTN_CLICK",function(){
                Controller.iscrollContainer.find("li").CommonCell("allSelect");//调用列表组件选中方法
                Controller.headContainer.CommonHead("showAllNoSelectBtn");//调用头部组件显示全不选按钮
                Controller.CommonBottonMenuContainer.CommonBottonMenu("lockOptBtn",["转为文档"]);//解锁操作菜单
                Controller.selectData = [];//清空选中数据
                //循环得到全选的所有数据
                Controller.iscrollContainer.find("li").each(function(){
                    Controller.selectData.push($(this).CommonCell("getData"));
                });
            });
            //监听头部组件点击全不选按钮
            this.headContainer.bind("ALL_NO_SELECT_BTN_CLICK",function(){
                Controller.selectData = [];//清空选中数据
                Controller.headContainer.CommonHead("showAllSelectBtn");//调用头部组件显示全选按钮
                Controller.iscrollContainer.find("li").CommonCell("cancelSelect");//调用列表组件取消选中方法
                Controller.CommonBottonMenuContainer.CommonBottonMenu("lockOptBtn",["移出保险箱","转为文档"]);//锁定操作菜单
            });
            //监听头部组件点击取消按钮
            this.headContainer.bind("CANCE_BTN_CLICK",function(){
                Controller.selectSize = 2;//列表勾选框默认设置为小的
                Controller.selectData = [];//清空选中数据
                Controller.headContainer.CommonHead("hideCancelBtn");//调用头部组件隐藏取消按钮
                Controller.iscrollContainer.find("li").CommonCell("changeSelectSize",2);//调用列表组件改变勾选图标大小方法
                Controller.iscrollContainer.find("li").CommonCell("cancelSelect");//调用列表组件取消选中方法
                Controller.headContainer.CommonHead("showGobackBtn");//调用头部组件显示返回按钮
                Controller.iscrollContainer.find("li").CommonCell("lock","no");//解锁列表图标和文件信息禁止点击
                Controller.searchContainer.CommonSearch("lock","no");//解锁搜索组件
                Controller.crumbsContainer.CommonCrumbs("lock","no");//解锁面包屑组件
                showAndHideBottomMenu("hide");//隐藏列表选中底部操作菜单
            });
            //监听头部组件点击了传输列表按钮 
            this.headContainer.bind("TRANSMISSION_BTN_CLICK",function(){
                Shell.sendEvent("transferList");//通知原生显示传输列表
            });
            //监听搜索组件点击排序选项
            this.searchContainer.bind("SORT_MENU_OPTION_CLICK",function(event,type){
                lock("yes");//锁定头部组件，搜索组件，面包屑组件，列表选中底部操作菜单组件
                Controller.iscrollContainer.find("li").CommonCell("lockList","yes");//锁定所有列表禁止点击
                Controller.offset = 0;//重置数据请求起止位置
                Controller.sort = type;//重置请求的数据的排序参数
                getListData(1);
            });
            //监听面包屑被点击
            this.crumbsContainer.bind("NAV_CLICK",function(event,obj){
                //判读当前点击的面包屑是否是云盘
                if(obj.pid == "-1"){
                    Shell.sendEvent("closeWin");//关闭当前页面 
                }else{
                    lock("yes");//锁定头部组件，搜索组件，面包屑组件，列表选中底部操作菜单组件
                    Controller.iscrollContainer.find("li").CommonCell("lockList","yes");//锁定所有列表禁止点击
                    Controller.pid = obj.pid;//重置pid
                    Controller.offset = 0;//重置数据请求起止位置
                    if(Controller.pid != 0){
                        Controller.headContainer.CommonHead("changeTitle",obj.title);//调用头部组件显示title文字方法
                    }else{
                        Controller.headContainer.CommonHead("changeTitle","保险箱");//调用头部组件显示title文字方法
                    }
                    getListData(1);//调用获取数据
                    //判断是否通知原生禁用侧滑和点击物理键返回
                    if(obj.pid != 0){
                        Shell.sendEvent("forwardAndGoback",{"isGoback":false,"pageName":Controller.pageName});//通知原生禁止侧滑和点击虚拟键返回退出应用
                    }else{
                        Shell.sendEvent("forwardAndGoback",{"isGoback":true,"pageName":Controller.pageName});//通知原生允许侧滑和点击虚拟键返回退出应用
                    }
                }
            });
            //监听列表点击事件
            this.iscrollContainer.bind("CELL_CLICK",function(event,arg){
                //判断当前点击的是文件还是文件夹
                if(parseInt(arg.isdir) == 1){
                    Controller.pid = arg.uuid;//重置pid
                    Controller.offset = 0;//重置数据请求起止位置
                    Controller.crumbsContainer.CommonCrumbs("generateNav",[{"text":arg.name,"pid":arg.uuid}]);//调用生成面包学方法
                    Controller.headContainer.CommonHead("changeTitle",arg.name);//调用头部组件显示title文字方法
                    getListData(1);//调用获取列表数据方法
                    Shell.sendEvent("forwardAndGoback",{"isGoback":false,"pageName":Controller.pageName});//通知原生禁止侧滑和点击虚拟键返回退出应用
                }else{
                    //判断当前文件是否可以预览
                    if(parseInt(arg.previewEnable) == 1){
                        getPrevData(arg.uuid);//调用获取组装预览需要的参数方法
                        Shell.sendEvent("showPreviewPage",Controller.previewData);//调用原生方法打开预览窗口
                    }else{
                        Controller.CommonToastContainer.CommonToast("showToast","当前文件不能预览");//显示飘窗提示
                        lock("yes");//锁定头部组件，搜索组件，面包屑组件，列表选中底部操作菜单组件
                        Controller.iscrollContainer.find("li").CommonCell("lockList","yes");//锁定所有列表禁止点击
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            Controller.CommonToastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            lock("no");//解锁头部组件，搜索组件，面包屑组件，列表选中底部操作菜单组件
                            Controller.iscrollContainer.find("li").CommonCell("lockList","no");//解锁所有列表允许点击
                        },1500);
                    }
                }
            });
            //监听列表勾选按钮被点击
            this.iscrollContainer.bind("CELL_SELECT",function(event,obj){
                //判断当前是取消还是选中
                if(obj.type == "yes"){
                    Controller.selectData.push(obj.data);
                }else{
                    //循环取消选中数据
                    for(var i = 0; i < Controller.selectData.length; i++){
                        if(Controller.selectData[i].uuid == obj.data.uuid){
                            Controller.selectData.splice(i,1);
                            break;
                        }
                    }
                } 
                listSelect();//调用列表选中操作方法
            });
            //监听滚动列表下拉刷新
            this.iscrollContainer.bind("ISCROLL_REFRESH",function(){
                Controller.iscrollContainer.find("li").CommonCell("lockList","yes");//锁定所有列表禁止点击
                lock("yes");//锁定头部组件，搜索组件，面包屑组件，列表选中底部操作菜单组件
                Controller.offset = 0;//从第0条数据开始获取
                Controller.selectSize = 2;//重置列表勾选图标大小 
                Controller.selectData = [];//清空选中数据
                getListData(2);//调用获取列表数据方法
            });
            //监听滚动列表上拉加载更多
            this.iscrollContainer.bind("ISCROLL_LOAD_MORE",function(){
                //判断当前列表选中底部菜单是否显示
                if(Controller.CommonBottonMenuContainer.attr("isShow") == "yes"){
                    Controller.selectSize = 1;
                }
                Controller.iscrollContainer.find("li").CommonCell("lockList","yes");//锁定所有列表禁止点击
                lock("yes");//锁定头部组件，搜索组件，面包屑组件，列表选中底部操作菜单组件
                Controller.offset = Controller.offset + 100;//重置请求数据位置
                getListData(3);//调用获取列表数据方法
            });
            //监听底部操作菜单按钮被点击
            this.CommonBottonMenuContainer.bind("OPERATION_BTN_CLICK",function(event,type){
                var ids = [];
                for(var i = 0; i < Controller.selectData.length; i++){
                    ids.push(Controller.selectData[i].uuid);
                }
                if(type == "inSafe"){
                    Shell.sendEvent("openWin",{"url":"/depositmoveout/index.html?token="+getUrl("token")+"&uuid="+ids.join(","),"open_type":true,"title":"移出保险箱"});
                }else if(type == "change"){
                    var obj = {
                        "uuid":Controller.selectData[0].fileinfo_id,
                        "title":Controller.selectData[0].name,
                        "ext":Controller.selectData[0].ext
                    }
                    Shell.sendEvent("openWin",{"url":"/djdocument/index.html?token="+getUrl("token")+"&pam="+encode(obj),"open_type":true,"title":"转为文档"});
                    console.log("/djdocument/index.html?token="+getUrl("token")+"&pam="+encode(obj));
                }
            });
            //监听搜索输入框被点击
            this.searchContainer.bind("NO_FUCOS_BTN_CLICK",function(){
                //初始化搜索组件
                Controller.depositSearchPanel = $("<div id='depositSearchPanelContainer' style='z-index:1;width:100%;height:100%;background:#fff;'></div>").appendTo($("body"));
                Controller.depositSearchPanel.DepositSearchPanel({
                    "commonToast":Controller.CommonToastContainer,
                    "uuid":Controller.pid,
                    "sort":Controller.sort,
                    "type":Controller.fileType
                });
                //监听搜索组件点击了取消
                Controller.depositSearchPanel.bind("SEARCH_PANEL_CANCEL",function(){
                    Controller.depositSearchPanel = null;
                });
            });
            //监听原生事件
            try{
                //监听原生预览点击上一个下一个文件或者上一张下一张图片事件
                api.addEventListener({name:"nextPrev"},function(arg){
                    //判断是否是当前页面的事件
                    if(arg.value.pageName == Controller.pageName){
                        //判断禁止用户一直触发
                        if(Controller.isNextPrev){
                            Controller.isNextPrev = false;//禁止用户点击再次触发
                            YsPreviewManager.abortAjax();//清除换取预览接口请求
                            getPrevData(arg.value.uuid);//调用获取组装预览需要的参数方法
                            //判断是否有缓存
                            if(arg.value.cacheUrl != ""){
                                Controller.previewData.url = arg.value.cacheUrl;//复制原生返回的预览地址
                                Shell.sendEvent("changePreviewFileAndImage",Controller.previewData);
                            }else{
                                Shell.sendEvent("changePreviewFileAndImage",Controller.previewData);
                                YsPreviewManager.SwapUrlWithUUID(Controller.currentData.fileinfoId,Controller.currentData.ext);//调用预览管理器换取预览地址
                            }
                        }
                    }
                });
                //监听原生触发侧滑和点击返回虚拟键事件
                api.addEventListener({name:"gobackLevel"},function(arg){
                    //判断是否是当前页面的事件
                    if(arg.value.pageName == Controller.pageName){
                        //判断是否显示了底部操作按钮 
                        if(Controller.CommonBottonMenuContainer.attr("isShow") == "no"){
                            Controller.headContainer.trigger("GOBACK_BTN_CLICK");
                        }
                    }
                });
                //监听原生抛出通知刷新刷新事件
                api.addEventListener({name:"commonRefresh"},function(arg){
                    //判断是否可以刷新
                    if(arg.value.pageName == Controller.pageName){
                        //判断是否显示了搜索输入框
                        if(Controller.depositSearchPanel != null && $("#depositSearchPanelContainer").length != 0){
                            //判断是否打开预览
                            if(arg.value.previewUUid != undefined && arg.value.previewUUid != null && arg.value.previewUUid != ""){
                                Controller.depositSearchPanel.DepositSearchPanel("searchListClick",arg.value.previewUUid);//调用进入预览方法
                            }else{
                                Controller.depositSearchPanel.DepositSearchPanel("searchRefresh");//调用搜索组件默认刷新事件
                                setTimeout(function(){
                                    getListData(1);//调用获取文件方法
                                },500);
                            }
                        }else{
                            //判断底部操作菜单是否显示
                            if(Controller.CommonBottonMenuContainer.attr("isShow") == "yes"){
                                Controller.headContainer.trigger("CANCE_BTN_CLICK");//抛出一个取消事件
                            }
                            //判断是否有pid主要是获取那层数据
                            if(arg.value.pid != undefined && arg.value.pid != null && arg.value.pid != ""){
                                Controller.pid = arg.value.pid;//获取第一层文件
                            }
                            //判断是否打开预览
                            if(arg.value.previewUUid != undefined && arg.value.previewUUid != null && arg.value.previewUUid != ""){
                                Controller.iscrollContainer.find("[uuid="+arg.value.previewUUid+"]").find(".fileName").click();  
                            }else{
                                Controller.offset = 0;//重置数据请求偏移量
                                setTimeout(function(){
                                    getListData(1);//调用获取文件方法
                                },500);
                            }
                        }
                    }
                });
            }catch(e){}
            //监听搜索组件排序筛选菜单展开 
            this.searchContainer.bind("SORTMENU_SHOW",function(evevt,arg){
                if(arg == "yes"){
                    Controller.headContainer.CommonHead("lock","yes");//锁定头部组件
                    Controller.crumbsContainer.CommonCrumbs("lock","yes");//锁定面包屑组件
                    Controller.iscrollContainer.find("li").CommonCell("lockList","yes");//锁定所有列表允许点击
                    Controller.iscrollContainer.CommonIscroll("isIscroll","yes");//禁止滚动容器滚动
                }else{
                    Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                    Controller.crumbsContainer.CommonCrumbs("lock","no");//解锁面包屑组件
                    Controller.iscrollContainer.find("li").CommonCell("lockList","no");//解锁所有列表允许点击
                    Controller.iscrollContainer.CommonIscroll("isIscroll","no");//允许滚动容器滚动
                }
            });
            //调用给body绑定点击事件（主要用于点击其它位置隐藏一些菜单操作
            bodyClick();
            //解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
            //给原生抛出加载完成事件
            Shell.sendPageReady(); 
            $("body").fadeTo("slow",1);
            //页面初始化成功获取列表数据
            getListData(1);
        }
    }
    //当点击body方法
    function bodyClick(){
        $("body").bind("click",function(event){
            //判读是否显示了排序下拉菜单
            if(event.target.className != "sortBtn" && $(".sortBtn").attr("is-show") == "yes"){
                Controller.searchContainer.CommonSearch("hideSortMenu");//调用搜索组件隐藏排序菜单
            }
        });
    }
    //锁定页面方法
    function lock(type){
        Controller.headContainer.CommonHead("lock",type);//锁定头部组件
        Controller.searchContainer.CommonSearch("lock",type);//锁定搜索组件
        Controller.crumbsContainer.CommonCrumbs("lock",type);//锁定面包屑组件
        Controller.CommonBottonMenuContainer.CommonBottonMenu("lock",type);//锁定底部操作菜单所有操作按钮
    }
    //显示或者隐藏底部操作菜单方法
    function showAndHideBottomMenu(type){
        var height = Controller.CommonBottonMenuContainer.outerHeight(true);//得到需要减去的高度 
        if(type == "show"){
            Controller.CommonBottonMenuContainer.CommonBottonMenu("gradually","yes");//调用底部菜单组件渐显渐隐效果方法
            Controller.CommonBottonMenuContainer.attr("isShow","yes");//改变底部操作菜单属性表示菜单已经显示
            Controller.iscrollContainer.CommonIscroll("changeIscrollContainerMinHeight",Controller.iscrollContainer.height() - height);//调用改变滚动容器高度方法
        }else{
            Controller.CommonBottonMenuContainer.CommonBottonMenu("gradually","no");//调用底部菜单组件渐显渐隐效果方法
            Controller.CommonBottonMenuContainer.attr("isShow","no");//改变底部操作菜单属性表示菜单已经隐藏
            Controller.iscrollContainer.CommonIscroll("changeIscrollContainerMinHeight",Controller.iscrollContainer.height() + height);//调用改变滚动容器高度方法
        }
    }
    //获取列表数据方法
    function getListData(type){
        //判断如果是初始化到2秒都还没有请求出数据就显示加载提示
        if(type == 1){
            Controller.showLoadAndError = setTimeout(function(){
                Controller.iscrollContainer.CommonIscroll("showLoadMask");//显示加载层
            },2000);
        }
        //请求参数
        var paramet = {"token":getUrl("token"),"pid":Controller.pid,"offset":Controller.offset,"sort":Controller.sort,"type":Controller.fileType,"mode":"app"};
        http(ServerConfig.domain+"/safe/getFileList",paramet,{
            success:function(arg){
                clearTimeout(Controller.showLoadAndError);//清除延时
                if(parseInt(arg.code) == 1){
                    generateList(type,arg.data.rows);//调用生成列表方法
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        //判断是初始化错误还是下拉刷新错误还是上拉加载更多错误
                        if(type == 1){//初始化错误
                            setTimeout(function(){
                                Controller.iscrollContainer.CommonIscroll("showErrorMask",arg.msg);//显示错误提示层
                            },500);
                        }else if(type == 2){//下拉刷新错误
                            setTimeout(function(){
                                Controller.iscrollContainer.CommonIscroll("refreshSuccessAndFail",arg.msg);//调用下拉刷新错误
                            },500);
                        }else if(type == 3){
                            setTimeout(function(){
                                Controller.iscrollContainer.CommonIscroll("loadMoreSuccessAndFail",arg.msg);//调用加载错误
                            },500);
                        }
                        setTimeout(function(){
                            lock("no");//解锁页面
                            Controller.isUploadRefresh = true;//上传完文件允许刷新
                        },800);
                    }
                }
            }
        });
    }
    //生成列表方法
    function generateList(type,dataArray){
        var cellArray = [];
        for(var i = 0; i < dataArray.length; i++){
            var cell = $("<li uuid='"+dataArray[i].uuid+"' fileInfoId='"+dataArray[i].fileinfo_id+"' previewEnable='"+dataArray[i].previewEnable+"' type='"+matchingFileType(dataArray[i].ext)+"' ext='"+dataArray[i].ext+"' style='width:100%;padding-left:0.15rem;box-sizing:border-box;'></li>").CommonCell({
                "commonIconUrl":skinConfig(global.skin).commonIcon,
                "shllIconUrl":skinConfig(global.skin).shllWebIon,
                "data":dataArray[i],
                "selectSize":Controller.selectSize
            });
            cellArray.push(cell);
        }
        //判断当前是初始化列表，还是下拉刷新，还是上拉加载更多
        if(type == 1){
            //判断有无数据
            if(cellArray != 0){
                Controller.iscrollContainer.CommonIscroll("initNode",cellArray);//调用滚动组件初始化数据
            }else{
                Controller.iscrollContainer.CommonIscroll("showListNoDataMask");//显示没有数据提示层
            }
        }else if(type == 2){
            setTimeout(function(){
                Controller.iscrollContainer.CommonIscroll("refreshSuccessAndFail");//刷新成功方法
            },500);
            //监听下拉刷新完成事件 
            Controller.iscrollContainer.unbind("REFRESH_COMPLETE").bind("REFRESH_COMPLETE",function(){
                //判断列表选中底部菜单是否显示
                if(Controller.CommonBottonMenuContainer.attr("isShow") == "yes"){
                    showAndHideBottomMenu("hide");//隐藏列表选中底部操作菜单
                    Controller.headContainer.CommonHead("showGobackBtn");//调用头部组件显示返回按钮
                }
                //判断有无数据
                if(cellArray.length != 0){
                    Controller.iscrollContainer.CommonIscroll("refreshNode",cellArray);//调用滚动组件添加下拉刷新数据
                }else{
                    Controller.iscrollContainer.CommonIscroll("emptyNode");//清空节点
                    Controller.iscrollContainer.CommonIscroll("showListNoDataMask");//显示没有数据提示层
                }
            });
        }else if(type == 3){
            setTimeout(function(){
                Controller.iscrollContainer.CommonIscroll("loadMoreSuccessAndFail");//加载成功方法
            },500);
            //监听上拉加载更多完成事件 
            Controller.iscrollContainer.unbind("LOAD_COMPLETE").bind("LOAD_COMPLETE",function(){
                Controller.iscrollContainer.CommonIscroll("addNode",cellArray);//调用滚动组件添加上拉的数据
                Controller.iscrollContainer.find("li").CommonCell("lockList","no");//解锁所有列表禁止点击
                //判断列表选中底部菜单是否显示
                if(Controller.CommonBottonMenuContainer.attr("isShow") == "yes" && cellArray.length != 0){
                    Controller.headContainer.CommonHead("showAllSelectBtn");//调用头部组件显示全选按钮
                    Controller.iscrollContainer.find("li").CommonCell("lock","yes");//锁定所有列表的文件图标和文件信息禁止点击
                }   
            });
        }
        if(type == 1){
            setTimeout(function(){
                lock("no");//解锁页面
                Controller.isUploadRefresh = true;//上传完文件允许刷新
                Controller.CommonBottonMenuContainer.CommonBottonMenu("hide");
            },300); 
        }else{
            setTimeout(function(){
                lock("no");//解锁页面
                Controller.isUploadRefresh = true;//上传完文件允许刷新
            },1800); 
        }
    }
    //获取预览组装预览参数
    function getPrevData(uuid){
        //调用找到当前预览文件所需的参数方法得到当前预览文件的信息
        Controller.currentData = getCurrentPreviewFileInformation({"content":Controller.iscrollContainer,"fileId":uuid});
        //组装原生和删除当前预览文件需要的数据
        Controller.previewData = {}//原生要的预览数据
        Controller.previewData.uuid = Controller.currentData.uuid;//当前预览的文件uuid
        Controller.previewData.fileinfoId = Controller.currentData.fileinfoId;//当前预览的文件fileinfoId
        Controller.previewData.type = Controller.currentData.type;//当前预览的文件类型
        Controller.previewData.name = Controller.currentData.fileName;//当前预览的文件名称
        Controller.previewData.error = "";//错误提示语
        Controller.previewData.url = "";//当前文件预览地址
        Controller.previewData.pageName = Controller.pageName;//当前在那个页面预览参数
        Controller.previewData.btnArray = [];//当前文件可操作按钮
        //判断档期那预览的文件是什么类型(调用找到上一个下一个图片或者文件id方法)
        if(Controller.currentData.type == "image"){
            Controller.previewData.prevFile = getPrevNextFileId({"fileId":uuid,"operateType":"prev","fileType":"auto","content":Controller.iscrollContainer});//上一个文件的uuid
            Controller.previewData.prevFileInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"prev","fileType":"auto","content":Controller.iscrollContainer});//上一个文件的fileinfoid
            Controller.previewData.nextFile = getPrevNextFileId({"fileId":uuid,"operateType":"next","fileType":"auto","content":Controller.iscrollContainer});//下一个文件uuid
            Controller.previewData.nextFileInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"next","fileType":"auto","content":Controller.iscrollContainer});//下一个文件的fileinfoid          
            Controller.previewData.prevImg = getPrevNextFileId({"fileId":uuid,"operateType":"prev","fileType":"image","content":Controller.iscrollContainer});//上一张图片的uuid
            Controller.previewData.prevImgInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"prev","fileType":"image","content":Controller.iscrollContainer});//上一张图片的fileinfoid
            Controller.previewData.nextImg = getPrevNextFileId({"fileId":uuid,"operateType":"next","fileType":"image","content":Controller.iscrollContainer});//下一张图片的uuid
            Controller.previewData.nextImgInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"next","fileType":"image","content":Controller.iscrollContainer});//下一张图片的fileinfoid
        }else{
            Controller.previewData.prevFile = getPrevNextFileId({"fileId":uuid,"operateType":"prev","fileType":"auto","content":Controller.iscrollContainer});//上一个文件uuid
            Controller.previewData.prevFileInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"prev","fileType":"auto","content":Controller.iscrollContainer});//上一个文件的fileinfoid
            Controller.previewData.nextFile = getPrevNextFileId({"fileId":uuid,"operateType":"next","fileType":"auto","content":Controller.iscrollContainer});//下一个文件的uuid
            Controller.previewData.nextFileInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"next","fileType":"auto","content":Controller.iscrollContainer});//下一个文件的fileinfoid
            Controller.previewData.prevImg = "";//上一张图片的uuid
            Controller.previewData.prevImgInfoid = "";//上一张图片的fileinfoid
            Controller.previewData.nextImg = "";//下一张图片uuid
            Controller.previewData.nextImgInfoid = "";//下一张图片的fileinfoid
            // var ext = ["doc","docx","xls","xlsx","ppt","pptx","txt"];
            // //判断当前预览文件是否可以协同处理
            // if(ext.indexOf(Controller.currentData.ext) > -1){
            //     Controller.previewData.btnArray.push({"name":"编辑","key":"edit","icon":""});
            // }
        }
        Controller.isNextPrev = true;//允许用户点击再次触发
    }
    //列表选中操作方法
    function listSelect(){
        //判断选中的数据条数
        if(Controller.selectData.length != 0){
            //判断是否选中多条数据
            if(Controller.selectData.length == 1){
                //判断是否显示了底部操作菜单
                if(Controller.CommonBottonMenuContainer.attr("isShow") == "no"){
                    showAndHideBottomMenu("show");//显示底部操作菜单
                    Controller.headContainer.CommonHead("showCancelBtn");//调用头部组件显示取消按钮
                    Controller.iscrollContainer.find("li").CommonCell("changeSelectSize",1);//调用列表组件改变勾选图标大小方法
                    Controller.iscrollContainer.find("li").CommonCell("lock","yes");//锁定列表图标和文件信息禁止点击
                    Controller.searchContainer.CommonSearch("lock","yes");//锁定搜索组件
                    Controller.crumbsContainer.CommonCrumbs("lock","yes");//锁定面包屑组件
                }
                //判读当前格式是否是笔记 
                if(Controller.selectData[0].ext == "ysnote"){
                    Controller.CommonBottonMenuContainer.CommonBottonMenu("lockOptBtn",[]);//解锁操作菜单
                }else{
                    Controller.CommonBottonMenuContainer.CommonBottonMenu("lockOptBtn",["转为文档"]);//解锁操作菜单
                }
            }else{
                Controller.CommonBottonMenuContainer.CommonBottonMenu("lockOptBtn",["转为文档"]);//解锁操作菜单
            }
            //判断当前列表是否全部被选中
            if(Controller.selectData.length == Controller.iscrollContainer.find("li").length){
                Controller.headContainer.CommonHead("showAllNoSelectBtn");//调用头部组件显示全不选按钮
            }else{
                Controller.headContainer.CommonHead("showAllSelectBtn");//调用头部组件显示全选按钮
            }
        }else{
            showAndHideBottomMenu("no");//隐藏底部操作菜单
            Controller.headContainer.CommonHead("hideCancelBtn");//调用头部组件隐藏取消按钮
            Controller.headContainer.CommonHead("showGobackBtn");//调用头部组件显示返回按钮
            Controller.iscrollContainer.find("li").CommonCell("changeSelectSize",2);//调用列表组件改变勾选图标大小方法
            Controller.iscrollContainer.find("li").CommonCell("lock","no");//解锁列表图标和文件信息禁止点击
            Controller.searchContainer.CommonSearch("lock","no");//解锁搜索组件
            Controller.crumbsContainer.CommonCrumbs("lock","no");//解锁面包屑组件
        }
    }
    return Controller;
});
