/*
*   2020年12月1日
*
*   个人空间首页的js控制器
*
*   开发者：付长建  Fastclick
*/
define(["jquery","Shell","Fastclick","CommonToast","CommonHead"],function($,Shell,Fastclick){
    var Controller = {
        toastContainer:null,
        inputPwdContainer:null,
        forgetPwdContainer:null,
        determineBtn:null,
        setPwdContainer:null,
        type:1,//控制当前是什么类型
        title:"设置保险箱密码",//头部文字  输入保险箱密码
        //页面加载成功执行的方法
        init:function(){
            Controller.type = getUrl("type");//获取类型
            if(Controller.type == 1){
                Controller.title = "设置保险箱密码";
            }else if(Controller.type == 2){
                Controller.title = "输入保险箱密码";
            }
            $("body").css("opacity",0);
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            //禁止整个页面滚动
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});
            //获取配置信息
            http(ServerConfig.domain+"/Setting/getGlobal",{"token":getUrl("token")},{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        global.userInfo = arg.data.userInfo;//得到用户信息
                        global.preview_config = arg.data.preview_config;//得到文件预览配置
                        global.is_thumb_model = arg.data.is_thumb_model;//得到是否显示搜索图
                        global.thumb_width_height_config = arg.data.thumb_width_height_config;//得到缩略图配置
                        global.skin = arg.data.skin_name;//得到皮肤配置
                        global.is_yingshuo = arg.data.is_yingshuo;//得到是否显示云笔记筛选选项
                        global.version = arg.data.version;//得到当前是哪个版本
                        Controller.create();//创建页面
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent("backLogin");//通知原生退出登录
                        }else{
                            try{
                                api.toast({msg:arg.msg,duration:2000,location:"middle"});
                            }catch(e){}
                        }
                    }
                }
            });
            //监听ajax请求错误
            $(window).bind("HTTP_REQUEST_ERROR",function(event,msg){
                try{
                    api.toast({msg:msg,duration:2000,location:"middle"});
                }catch(e){}
            });
        },
        //生成页面方法
        create:function(){
            this.toastContainer = $("<div></div>").CommonToast().appendTo($("body"));
            //初始化头部组件
            this.headContainer = $("<div></div>").appendTo($("body"));
            this.headContainer.CommonHead({"title":Controller.title,"isGoback":true});
            var maxContainer = $("<div style='width:100%;padding:0 0.25rem 0 0.25rem;box-sizing:border-box;overflow:hidden;'></div>").appendTo($("body"));
            
            //创建设置密码容器
            this.setPwdContainer = $("<div style='width:100%;margin-top:0.3rem;'></div>").appendTo(maxContainer);
            var form1 = $("<form style='width:100%;height:0.5rem;position:relative;'></form>").appendTo(this.setPwdContainer);
            $("<input class='pwd1' maxlength='6' placeholder='请设置6位密码（数字+字母）' style='width:100%;height:100%;padding-right:0.4rem;border-bottom:1px solid #ECECEC;box-sizing:border-box;font-size:0.15rem;' type='password'/>").appendTo(form1);
            var emptyIcon1 = $("<div class='emptyBtn1' style='width:0.4rem;height:100%;position:absolute;top:0;right:0;display:none;align-items:center;justify-content:center;'></div>").appendTo(form1);
            $("<img style='width:0.15rem;' src='"+skinConfig(global.skin).commonIcon+"signin_icon.png'/>").appendTo(emptyIcon1);
            var form2 = $("<form style='width:100%;height:0.5rem;position:relative;margin-top:0.2rem;'></form>").appendTo(this.setPwdContainer);
            $("<input class='pwd2' maxlength='6' placeholder='请再次确认密码' style='width:100%;height:100%;padding-right:0.4rem;border-bottom:1px solid #ECECEC;box-sizing:border-box;font-size:0.16rem;' type='password'/>").appendTo(form2);
            var emptyIcon2 = $("<div class='emptyBtn2' style='width:0.4rem;height:100%;position:absolute;top:0;right:0;display:none;align-items:center;justify-content:center;'></div>").appendTo(form2);
            $("<img style='width:0.15rem;' src='"+skinConfig(global.skin).commonIcon+"signin_icon.png'/>").appendTo(emptyIcon2);
            
            emptyIcon1[0].addEventListener("touchend",function(event){
                try {
                    event.stopPropagation();
                    event.preventDefault();
                }catch(event){
                    console.log('阻止冒泡失败');
                }
                form1.find("input").val("");
                emptyIcon1.css("display","none");
                Controller.determineBtn.css("opacity","0.5");
                Controller.determineBtn.attr("isData","no");
            },true);
            form1.find("input").bind("input change",function(){
                form1.find("input").val(form1.find("input").val().replace(/[^\a-\z\A-\Z0-9]/g,''));
                if(form1.find("input").val().replace(/[ ]/g,"") != ""){
                    emptyIcon1.css("display","flex");
                    if(form2.find("input").val().replace(/[ ]/g,"") != ""){
                        Controller.determineBtn.css("opacity","1");
                        Controller.determineBtn.attr("isData","yes");
                    }else{
                        Controller.determineBtn.css("opacity","0.5");
                        Controller.determineBtn.attr("isData","no");
                    }
                }else{
                    emptyIcon1.css("display","none");
                    Controller.determineBtn.css("opacity","0.5");
                    Controller.determineBtn.attr("isData","no");
                }
            });
            form1.submit(function(){
                return false;
            }); 

            emptyIcon2[0].addEventListener("touchend",function(event){
                try {
                    event.stopPropagation();
                    event.preventDefault();
                }catch(event){
                    console.log('阻止冒泡失败');
                }
                form2.find("input").val("");
                emptyIcon2.css("display","none");
                Controller.determineBtn.css("opacity","0.5");
                Controller.determineBtn.attr("isData","no");
            },true);
            form2.find("input").bind("input change",function(){
                form2.find("input").val(form2.find("input").val().replace(/[^\a-\z\A-\Z0-9]/g,''));
                if(form2.find("input").val().replace(/[ ]/g,"") != ""){
                    emptyIcon2.css("display","flex");
                    if(form1.find("input").val().replace(/[ ]/g,"") != ""){
                        Controller.determineBtn.css("opacity","1");
                        Controller.determineBtn.attr("isData","yes");
                    }else{
                        Controller.determineBtn.css("opacity","0.5");
                        Controller.determineBtn.attr("isData","no");
                    }
                }else{
                    emptyIcon2.css("display","none");
                    Controller.determineBtn.css("opacity","0.5");
                    Controller.determineBtn.attr("isData","no");
                }
            });
            form2.submit(function(){
                return false;
            }); 

            //创建输入密码容器
            this.inputPwdContainer = $("<div style='width:100%;margin-top:0.3rem;'></div>").appendTo(maxContainer);
            var form3 = $("<form style='width:100%;height:0.5rem;position:relative;'></form>").appendTo(this.inputPwdContainer);
            $("<input class='pwd3' maxlength='6' placeholder='请输入6位密码' style='width:100%;height:100%;padding-right:0.4rem;border-bottom:1px solid #ECECEC;box-sizing:border-box;font-size:0.15rem;' type='password'/>").appendTo(form3);
            var emptyIcon3 = $("<div class='emptyBtn3' style='width:0.4rem;height:100%;position:absolute;top:0;right:0;display:none;align-items:center;justify-content:center;'></div>").appendTo(form3);
            $("<img style='width:0.15rem;' src='"+skinConfig(global.skin).commonIcon+"signin_icon.png'/>").appendTo(emptyIcon3);
            emptyIcon3[0].addEventListener("touchend",function(event){
                try {
                    event.stopPropagation();
                    event.preventDefault();
                }catch(event){
                    console.log('阻止冒泡失败');
                }
                form3.find("input").val("");
                emptyIcon3.css("display","none");
                Controller.determineBtn.css("opacity","0.5");
                Controller.determineBtn.attr("isData","no");
            },true);
            form3.find("input").bind("input change",function(){
                form3.find("input").val(form3.find("input").val().replace(/[^\a-\z\A-\Z0-9]/g,''));
                if(form3.find("input").val().replace(/[ ]/g,"") != ""){
                    emptyIcon3.css("display","flex");
                    Controller.determineBtn.css("opacity","1");
                    Controller.determineBtn.attr("isData","yes");
                }else{
                    emptyIcon3.css("display","none");
                    Controller.determineBtn.css("opacity","0.5");
                    Controller.determineBtn.attr("isData","no");
                }
            });
            form3.submit(function(){
                return false;
            }); 

            var forgetPwd = $("<p isData='yes' style='width:100%;text-align:right;font-size:0.12rem;color:#666;margin-top:0.15rem;'>忘记保险箱密码？</p>").appendTo(this.inputPwdContainer);
            
            //忘记密码验证容器
            this.forgetPwdContainer = $("<div style='width:100%;margin-top:0.3rem;'></div>").appendTo(maxContainer);
            //判断是否有手机号
            var phone = "";
            if(global.userInfo.phone != undefined && global.userInfo.phone != null && global.userInfo.phone != ""){
                phone = global.userInfo.phone.substr(0,3) + "****" + global.userInfo.phone.substr(7);
            }else{
                phone = "请先绑定手机号...";
            }
            $("<p style='font-size:0.16rem;'>验证码将发送到手机号：<span style='color:"+skinConfig(global.skin).selectFontColor+"'>"+phone+"</span></p>").appendTo(this.forgetPwdContainer);
            var codeContainer = $("<div style='width:100%;height:0.5rem;display:flex;flex-direction:row;border-bottom:1px solid #ECECEC;box-sizing:border-box;margin-top:0.4rem;'></div>").appendTo(this.forgetPwdContainer);
            var form4 = $("<form style='width:100%;height:100%;position:relative;'></form>").appendTo(codeContainer);
            $("<input class='code' maxlength='6' placeholder='请输入短信验证码' type='tel' style='width:100%;height:100%;border:0;padding-right:0.4rem;box-sizing:border-box;'/>").appendTo(form4);
            var emptyIcon4 = $("<div class='emptyBtn4' style='width:0.4rem;height:100%;position:absolute;top:0;right:0;display:none;align-items:center;justify-content:center;'></div>").appendTo(form4);
            $("<img style='width:0.15rem;' src='"+skinConfig(global.skin).commonIcon+"signin_icon.png'/>").appendTo(emptyIcon4);
            $("<p style='width:1px;height:0.15rem;background:"+skinConfig(global.skin).backColor+";margin-top:0.175rem;'></p>").appendTo(codeContainer);
            $("<div isData='yes' style='width:1.2rem;height:100%;line-height:0.5rem;text-align:center;color:"+skinConfig(global.skin).selectFontColor+";font-size:0.14rem'>获取验证码</div>").appendTo(codeContainer);
            form4.css("width",codeContainer.width() - codeContainer.children("div").width() - 1 + "px");
            emptyIcon4[0].addEventListener("touchend",function(event){
                try {
                    event.stopPropagation();
                    event.preventDefault();
                }catch(event){
                    console.log('阻止冒泡失败');
                }
                form4.find("input").val("");
                emptyIcon4.css("display","none");
                Controller.determineBtn.css("opacity","0.5");
                Controller.determineBtn.attr("isData","no");
            },true);
            form4.find("input").bind("input change",function(){
                form4.find("input").val(form4.find("input").val().replace(/[^0-9]/g,''));
                if(form4.find("input").val().replace(/[ ]/g,"") != ""){
                    emptyIcon4.css("display","flex");
                    Controller.determineBtn.css("opacity","1");
                    Controller.determineBtn.attr("isData","yes");
                }else{
                    emptyIcon4.css("display","none");
                    Controller.determineBtn.css("opacity","0.5");
                    Controller.determineBtn.attr("isData","no");
                }
            });
            form4.submit(function(){
                return false;
            }); 
            
            //创建确定按钮
            this.determineBtn = $("<div isData='no' style='width:100%;height:0.5rem;margin-top:0.3rem;line-height:0.52rem;text-align:center;font-size:0.18rem;font-weight:bold;color:#fff;background:"+skinConfig(global.skin).linearBackColor+";opacity:0.5;border-radius:0.25rem;'>确定</div>").appendTo(maxContainer);

            //监听头部组件的返回按钮 
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                Shell.sendEvent("closeWin");//关闭当前页面
            });
            //给确定按钮绑定点击事件
            this.determineBtn.bind("click",function(){
                determineBtnClick($(this));//调用确定事件
            });
            //给忘记密码绑定点击事件
            forgetPwd.bind("click",function(){
                Controller.setPwdContainer.css("display","none");
                Controller.inputPwdContainer.css("display","none");
                Controller.forgetPwdContainer.css("display","");
                Controller.headContainer.CommonHead("changeTitle","忘记密码");
                Controller.determineBtn.html("下一步"); 
                Controller.type = 3;
            });
            //给获取验证码按钮绑定点击事件
            codeContainer.children("div").bind("click",function(){
                getCodeClick($(this));//调用获取验证码方法
            });
            //确定按钮按下抬起效果
            btnTextCommon(this.determineBtn);
            //忘记密码文字按下抬起效果
            btnTextCommon(forgetPwd);
            //发送文字按下抬起效果
            btnTextCommon(codeContainer.children("div"));
            //解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
            //给原生抛出加载完成事件
            Shell.sendPageReady();
            $("body").fadeTo("slow",1);
            //判断参数方法
            init();
        }
    }
    //所有的按钮和可以点击的文本按下和抬起事件方法
    function btnTextCommon(element){
        //给选项绑定手指按下事件
        element.bind('touchstart',function(){
            if(element.attr("isData") == "yes"){
                $(this).css("opacity","0.5");
            }
        });
        //给选项绑定手指抬起事件
        element.bind('touchend',function(){
            if(element.attr("isData") == "yes"){
                $(this).css("opacity","");
            }
        });
    }
    //点击确定
    function determineBtnClick(that){
        //判读是否可以点击去顶按钮
        if(that.attr("isData") == "no"){
            return;
        }
        //判断当前是什么类型点击确定
        if(Controller.type == 1){//设置密码
            var url = ServerConfig.domain+"/personal/editSafePassword";//设置密码接口
            var paramet = {"token":getUrl("token"),"password":$(".pwd1").val(),"confirm_password":$(".pwd2").val()};
        }else if(Controller.type == 2){//输入密码
            var url = ServerConfig.domain+"/personal/checkSafePassword";//输入密码检测是否正确接口
            var paramet = {"token":getUrl("token"),"password":$(".pwd3").val()};
        }else if(Controller.type == 3){//验证验证码
            var url = ServerConfig.domain+"/personal/checkCode";//检测验证码接口
            var paramet = {"token":getUrl("token"),"phone":global.userInfo.phone,"code":$(".code").val()};
        }
        http(url,paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    //判断是否进入保险箱页面
                    if(Controller.type == 1 || Controller.type == 2){
                        Shell.sendEvent("closeWin");//关闭当前页面
                        Shell.sendEvent("openWin",{"url":"/deposit/index.html?token="+getUrl("token"),"open_type":true,"title":"保险箱"});
                    }else{
                        Controller.type = 1;
                        Controller.determineBtn.html("确定"); 
                        Controller.determineBtn.attr("isData","no");
                        Controller.inputPwdContainer.css("display","none");
                        Controller.forgetPwdContainer.css("display","none");
                        Controller.setPwdContainer.css("display","");
                        Controller.headContainer.CommonHead("changeTitle","重置密码");
                    }
                }else{
                    Controller.toastContainer.CommonToast("showToast",arg.msg);//显示飘窗提示
                    //飘窗提示后2s后删除飘窗
                    setTimeout(function(){
                        Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                    },2000);
                }
            }
        });
    }
    //获取验证码方法
    function getCodeClick(that){
        if(that.attr("isData") == "yes"){
            that.attr("isData","no");
            //判断是否有手机号
            if(global.userInfo.phone != null && global.userInfo.phone != undefined && global.userInfo.phone != ""){
                var paramet = {"token":getUrl("token"),"phone":global.userInfo.phone};
                http(ServerConfig.domain+"/personal/sendCodeForSafe",paramet,{
                    success:function(arg){
                        if(parseInt(arg.code) == 1){
                            var inx = 60;
                            var time = setInterval(function(){
                                if(inx != 0){
                                    that.html(inx + "s后重新发送");
                                    inx = inx - 1;
                                }else{
                                    clearInterval(time);
                                    that.html("重新获取");
                                    that.attr("isData","yes");
                                }
                            },1000);
                        }else{
                            Controller.toastContainer.CommonToast("showToast",arg.msg);//显示飘窗提示
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.attr("isData","yes");
                                Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            },2000);
                        }
                    }
                });
            }else{
                Controller.toastContainer.CommonToast("showToast","未绑定手机号，请到我的-设置-联系客服处理");//显示飘窗提示
                //飘窗提示后2s后删除飘窗
                setTimeout(function(){
                    Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                    that.attr("isData","yes");
                },2000);
            }
        }
    }
    //判断参数方法
    function init(){
        Controller.setPwdContainer.css("display","none");
        Controller.inputPwdContainer.css("display","none");
        Controller.forgetPwdContainer.css("display","none");
        if(Controller.type == 1){
            Controller.setPwdContainer.css("display","");
            setTimeout(function(){
                $(".pwd1").focus();
            },500);
        }else if(Controller.type == 2){
            Controller.inputPwdContainer.css("display","");
            setTimeout(function(){
                $(".pwd3").focus();
            },500);
        }else{
            Controller.forgetPwdContainer.css("display","");
        }
    }
    return Controller;
});
