/*
*   2020年12月1日
*
*   所有页面都可以通用的js方法和配置
*
*   开发者：付长建
*/
// 壳化页面调用接口的域名配置
//成都测试：https://testnote.ys100.com/appweb
//成都演示：https://devnote.ys100.com/appweb
//成都正式：https://note.ys100.com/appweb

//大连测试：https://testsmartpen.ys100.com
//大连演示：https://devsmartpen.ys100.com
//大连正式：https://smartpen.ys100.com
var global = {};
var ServerConfig = {};
ServerConfig.domain = "https://note.ys100.com/appweb";//云盘
ServerConfig.djDomain = "https://smartpen.ys100edu.com";//笔记
ServerConfig.cloudDomain="https://cloudspace.ys100edu.com/appweb";//云空间
ServerConfig.cloudMerge="https://cloudspace.ys100edu.com/mergeweb";//云空间
// 追加转换文档配置
var NoteChange = {};
NoteChange.note_list = "https://service.ys100edu.com/word/discern/note/preview/list";//回显示列表
NoteChange.note_word = "https://service.ys100edu.com/word/discern/note/convert/word";//创建接口
NoteChange.note_result = "https://service.ys100edu.com/word/discern/note/convert/result";//轮询接口
NoteChange.note_cancel = "https://service.ys100edu.com/word/discern/note/convert/cancel";//取消接口
NoteChange.note_change_word = "https://service.ys100edu.com/word/discern/note/ocr/imageToWord2";//转换文档接口


/*
*   皮肤配置方法
*   接受一个参数
*   type:String,什么皮肤比如是蓝色还是红色主题
*   开发者：付长建
*/
function skinConfig(type){
    //红色版本
    var redyingshuo = {
        "shllWebIon":"../djcommon/img/red/",//图标配置路径
        "commonIcon":"../djcommon/img/common/",//通用的图标路径
        "skinUrl":"Ysmyspace",//拼接接口地址
        "linkshare":"Yslinkshare",//拼接接口地址（链接模块）
        "otherLink":"Ysothershare",//拼接接口地址（链接模块）
        "message":"Yssystemmessage",//获取消息数量，空间容量等配置信息接口
        "backColor":"#C82128",//纯色背景
        "linearBackColor":"linear-gradient(90deg, #CF000F 0%, #E50414 100%)",//渐显背景
        "selectFontColor":"#C82128",//选中字体颜色
        "bordeColor":"#C82128",//边框颜色
    };
    //蓝色版本
    var blueyingshuo = {
        "shllWebIon":"../djcommon/img/blue/",//图标配置路径
        "commonIcon":"../djcommon/img/common/",//通用的图标路径
        "skinUrl":"Myspace",//拼接接口地址
        "linkshare":"Linkshare",//拼接接口地址（链接模块）
        "otherLink":"Othershare",//拼接接口地址（链接模块）
        "message":"Systemmessage",//获取消息数量，空间容量等配置信息接口
        "backColor":"#367BD6",//纯色背景
        "linearBackColor":"#367BD6",//渐显背景
        "selectFontColor":"#367BD6",//选中字体颜色
        "bordeColor":"#367BD6",//边框颜色
    };
    if(type == "redyingshuo"){
        return redyingshuo;
    }else if(type == "blueyingshuo"){
        return blueyingshuo;
    }
}
/*
*   得到指定浏览器rul路径参数值
*   接受一个参数
*   name:String,你要获取的参数
*   开发者：付长建
*/
function getUrl(name){
    var Request = new Object();
    Request = GetRequest();
    var str = "";
    if(Request[name] != null && Request[name] != undefined){
        str = Request[name];
    }
    return str;//得到指定参数
}
//截取url参数方法
function GetRequest(){
    var url = location.search; //获取url中"?"符后的字串
    var theRequest = new Object();
        if (url.indexOf("?") != -1) {
            var str = url.substr(1);
            strs = str.split("&");
            for (var i = 0; i < strs.length; i++) {
                theRequest[strs[i].split("=")[0]] = decodeURI(strs[i].split("=")[1]);
            }
        }
    return theRequest;
}
/*
*   匹配文件图标方法
*   接受一个参数
*   type:String,文件的后缀名称
*   开发者：付长建
*/
function matchingFileIcon(type){
    var icon = {
        folder:['folder'],
        orgwithin:["orgwithin"],
        orgexternal:["orgexternal"],
        pdf:['pdf'],
        txt:["curl","dcurl","mcurl","scurl","sub","fly","flx","gv","3dml","spot","jad","wml","wmls","s", "asm","c", "cc", "cxx", "cpp", "h", "hh", "dic","htc","f", "for", "f77", "f90","hbs","java","lua","mkd","nfo","opml","*org","p", "pas","pde","sass","scss","etx","sfv","ymp","uu","vcs","vcf","dsc","appcache", "manifest","ics", "ifb","coffee", "litcoffee","css","csv","html", "htm", "shtml","jade","jsx","less","markdown", "md","mml","n3","txt", "text", "conf", "def", "list", "log", "in", "ini","rtx","*rtf","sgml", "sgm", "shex","slim", "slm","stylus", "styl","tsv","t", "tr", "roff", "man", "me", "ms","ttl","uri", "uris", "urls","vcard","vtt","*xml","yaml", "yml","js"],
        document:["doc", "dot","wps", "wks", "wcm", "wdb","docx","dotx"],
        xls:["xls", "xlm", "xla", "xlc", "xlt", "xlw","xlam","xlsb","xlsm","xltm","xlsx","xltx"],
        ppt:["ppt", "pps", "pot", "ppam", "pptm", "sldm","ppsm","potm","pptx","sldx","ppsx"],
        img:["btif","pti","psd","azv","uvi","uvvi","uvg","uvvg","djvu","djv","*sub","dwg","dxf","fbs","fpx","fst","mmr","rlc","ico","mdi","wdp","npx","tap","vtf","wbmp","xif","pcx","3ds","ras","cmx","fh", "fhc", "fh4", "fh5", "fh7","*ico","jng","sid","*bmp","*pcx","pic", "pct","pnm","pbm","pgm","ppm","rgb","tga","xbm","xpm","xwd","exr","apng","bmp","cgm","drle","emf","fits","g3","gif","heic","heics","heif","heifs","ief","jls","jp2", "jpg2","jpeg", "jpg", "jpe","jpm","jpx", "jpf","ktx","png","sgi","svg", "svgz","t38","tif", "tiff","tfx","webp","wmf","jpg"],
        audio:["uva", "uvva","eol","dra","dts","dtshd","lvp","pya","ecelp4800","ecelp7470","ecelp9600","rip","aac","aif", "aiff", "aifc","caf","flac","*m4a","mka","m3u","wax","wma","ram", "ra","rmp","*ra","*wav","*3gpp","adp","au", "snd","mid", "midi", "kar", "rmi","*mp3","m4a", "mp4a","mpga", "mp2", "mp2a", "mp3", "m2a", "m3a","oga", "ogg", "spx","s3m","sil","wav","*wav","weba","xm","MP3"],
        video:["uvh", "uvvh","uvm", "uvvm","uvp", "uvvp","uvs", "uvvs","uvv", "uvvv","dvb","fvt","mxu", "m4u","pyv","uvu","uvvu","viv","f4v","fli","flv","m4v","mkv", "mk3d", "mks","mng","asf", "asx","vob","wm","wmv","wmx","wvx","avi","movie","smv","3gp", "3gpp","3g2","h261","h263","h264","jpgv","*jpm", "jpgm","mj2", "mjp2","ts","mp4", "mp4v", "mpg4","mpeg", "mpg", "mpe", "m1v", "m2v","ogv","qt", "mov","webm","MP4","rmvb"],
        bt:["torrent"],
        zip:["zip","gz","tar","rar","bz","bz2", "boz","7z"],
        ysnote:["ysnote"],
        exe:["exe"],
        unknown:["unknown"]
    }
    var imgUrl = {
        folder:"file_icon.png",
        orgwithin:["sharespace_icon_zzn.png"],
        orgexternal:["sharespace_icon_zzw.png"],
        bt:"file_icon_bt.png",
        audio:"file_icon_music.png",
        video:"file_icon_sp.png",
        xls:"file_icon_xxs.png",
        document:"file_icon_word.png",
        ppt:"file_icon_ppt.png",
        img:"file_icon_pt.png",
        pdf:"file_icon_pdf.png",
        txt:"file_icon_txt.png",
        zip:"file_icon_ys.png",
        exe:"file_icon_qt.png",
        ysnote:"file_icon_ysnote.png",
        unknown:"file_icon_weishibi.png"
    }
    var suffix = "";
    var iocnImg = "";
    for(var i in icon){
        if(icon[i].indexOf(type) > -1){
            suffix = i;
            break;
        }
    }
    for(var i in imgUrl){
        if(i == suffix){
            iocnImg = imgUrl[i];
            break;
        }
    }
    //判读为空使用默认图片
    if(iocnImg == ""){
        iocnImg = imgUrl.unknown;
    }
    return iocnImg;
}
//公用ajax方法
function http(url,data,options){
    var src = url.substring(url.lastIndexOf("/") + 1,url.length);
    $.ajax({
        cache:false,
        type:data.ajaxType != undefined ? data.ajaxType : "POST",
        url:url,
        data:data,
        dataType:"json",
        success:function(data){
            options.success && options.success(data);
        },
        error:function(xhr,ajaxOptions,thrownError){
            if(src != "getSystemMessageTotal"){
                $(window).trigger("HTTP_REQUEST_ERROR","服务异常，请稍后再试!");
            }
            return false;
        }
    });
}
/*
*   单位转换方法函数
*   接受一个对象参数
*   {
*       type:String, 值为 B KB MB GB TB 注意全部大写 (非必传)
*       num:int, 需要转换的数值 注意值为整数或者小数不能是字符串等其它类型 (非必传)
*       offtb:String 值为 yes no 是否取消转换为TB (非必传)
*   }
*   开发者：付长建
*/
function spaceConvert(obj){
    var num = parseFloat(obj.num);
    var type = "MB";
    if(obj.type != undefined && obj.type != ""){
        type = obj.type;
    }
    var offtb = "no";
    if(obj.offtb != undefined && obj.offtb != ""){
        offtb = obj.offtb;
    }
    if(type == "KB"){
        num = 1024 * obj.num;
    }else if(type == "MB"){
        num = 1024 * 1024 * obj.num;
    }else if(type == "GB"){
        num = 1024 * 1024 * 1024 * obj.num;
    }else if(type == "TB"){
        num = 1024 * 1024 * 1024 * 1024 * obj.num;
    }
    if(num < 1024){
        if(num == 0){
            return num + "GB";
        }else{
            return num + "B";
        }
    }else if(num >= 1024 && num <1024 * 1024){
        return parseInt((num / 1024) * 100) / 100 + "KB";
    }else if(num >= 1024 * 1024 && num <1024 * 1024 * 1024){
        return parseInt((num / 1024 / 1024) * 100) / 100 + "MB";
    }else if(num >= 1024 * 1024 * 1024 && num < 1024 * 1024 * 1024 * 1024){
        return parseInt((num / 1024 / 1024 / 1024) * 100) / 100 + "GB";
    }else{
        if(offtb == "yes"){
            return parseInt((num / 1024 / 1024 / 1024) * 100) / 100 + "GB";
        }else{
            return parseInt((num / 1024 / 1024 / 1024 / 1024) * 100) / 100 + "TB";
        }
    }
}
/*
*   计算空间使用进度条方法
*   接受一个对象参数
*   {
*       type:String, 值为 KB MB GB TB 注意全部大写 (非必传)
*       num:int, 总空间值 注意值必须是整数或者小数，不能是字符串等其它类型 (必传)
*       use:int 已使用的空间 注意值必须是整数或者小数，不能是字符串等其它类型 (必传)
*   }
*   开发者：付长建
*/
function spaceUse(obj){
    var num = parseFloat(obj.num);
    var use = parseFloat(obj.use);
    var type = "MB";
    if(obj.type != undefined && obj.type != ""){
        type = obj.type;
    }
    if(type == "KB"){
        num = 1024 * obj.num;
        use = 1024 * obj.use;
    }else if(type == "MB"){
        num = 1024 * 1024 * obj.num;
        use = 1024 * 1024 * obj.use;
    }else if(type == "GB"){
        num = 1024 * 1024 * 1024 * obj.num;
        use = 1024 * 1024 * 1024 * obj.use;
    }else if(type == "TB"){
        num = 1024 * 1024 * 1024 * 1024 * obj.num;
        use = 1024 * 1024 * 1024 * 1024 * obj.use;
    }
    return use / num * 100;
}
/*
*   时间戳转换方法函数(将时间戳转换为时间格式)
*   接受一个对象参数
*   {
*       timeNumm:int, 时间戳 注意值必须是整数或者小数，不能是字符串等其它类型 (必传)
*       com:String, 时间拼接符 值 "-","/","&" (非必传)
*       sec:String 是否显示时分 值 yes no (非必传)
*       miao:String 是否显示秒 值 yes no (非必传)
*   }
*   开发者：付长建
*/
function timeConvert(obj){
    var time = new Date(parseInt(obj.timeNumm));
    var n = time.getFullYear();
    var y = time.getMonth() + 1;
    var r = time.getDate();
    var s = time.getHours();
    var f = time.getMinutes();
    var m = time.getSeconds();
    var add0 = function(numm){
        return numm < 10 ? "0" + numm : numm;
    }
    var com = "-";
    var sec = "no";
    var miao = "no";
    if(obj.com != undefined && obj.com != ""){
        com = obj.com;
    }
    if(obj.sec != undefined && obj.sec != ""){
        sec = obj.sec;
    }
    if(obj.miao != undefined && obj.miao != ""){
        miao = obj.miao;
    }
    if(sec == "yes"){
        if(com == "&"){
            if(miao == "yes"){
                return n + "年" + add0(y) + "月" + add0(r) + "日" +" " + add0(s) + "时" + add0(f) + "分" + add0(m) + "秒";
            }else{
                return n + "年" + add0(y) + "月" + add0(r) + "日" +" " + add0(s) + "时" + add0(f) + "分";
            }
        }else{
            if(miao == "yes"){
                return n + com + add0(y) + com + add0(r) + " " + add0(s) + ":" + add0(f) + ":" + add0(m);
            }else{
                return n + com + add0(y) + com + add0(r) + " " + add0(s) + ":" + add0(f);
            }
        }
    }else{
        if(com == "&"){
            return n + "年" + add0(y) + "月" + add0(r) + "日";
        }else{
            return n + com + add0(y) + com + add0(r);
        }
    }
}
/*
*   时间转换方法函数(将时间格式转换为时间戳)
*   接受一个参数
*   time:String,时间格式字符串  "2019-08-21 14:02:56" "2019-08-21"
*   开发者：付长建
*/
function timeStampConvert(time){
    var f = time.split(' ', 2);
    var d = (f[0] ? f[0] : '').split('-', 3);
    var t = (f[1] ? f[1] : '').split(':', 3);
    return (new Date(
            parseInt(d[0], 10) || null,
            (parseInt(d[1], 10) || 1) - 1,
            parseInt(d[2], 10) || null,
            parseInt(t[0], 10) || null,
            parseInt(t[1], 10) || null,
            parseInt(t[2], 10) || null
    )).getTime() / 1000;
}
/*
*   时间推算函数（指定到某一个时间段）
*   接受一个对象参数
*   minute:bool,是否显示时分秒
*   spl:String,拼接符
*   num:int,向前推多少月
*   type:int,控制向前还是向后推算月 1向前推 2向后推 默认向前推
*   开发者：付长建
*/
function getMonthBefor(obj){
    var currDate = new Date();
    var year = currDate.getFullYear();
    var month = currDate.getMonth() + 1;
    var date = currDate.getDate();
    var hms = currDate.getHours() + ':' + currDate.getMinutes() + ':' + (currDate.getSeconds() < 10 ? '0'+currDate.getSeconds() : currDate.getSeconds());
    var num = 0;
    var type = 1;
    if(obj.num != undefined && obj.num != ""){
        num = obj.num;
    }
    if(obj.type != undefined && obj.type != ""){
        type = obj.type;
    }
    var objes = calculate(year,month,num,type);
    year = objes.year;
    month = objes.month;
    month = (month < 10) ? ('0' + month) : month;
    var resultDate = ""
    var spl = "-"
    var minute = true;
    if(minute){
        resultDate = year + spl + month + spl + date + spl + hms
    }else{
        resultDate = year + spl + month + spl + date;
    }
    return resultDate;
}
//处理时间得到推算好的年月日方法
var years = 0;//年
var months = 0;//月
var yuenum = 0;//推算月
function calculate(year,month,num,type){
    if(type == 1){
        if(month > num){
            months = month - num;
        }else{
            years = year - 1;
            yuenum = yuenum + 12;
            if(month + yuenum > num){
                months = month + yuenum - num;
            }else{
                calculate(years,month,num,type);
            }
        }
    }else{
        if(month + num > 12){
            yuenum = 0;
            years = year + 1;
            yuenum = month + num - 12;
            if(yuenum > 12){
                months = yuenum - month;
                calculate(years,month,months,type);
            }else{
                months = yuenum;
            }
        }else{
            months = month + num;
        }
    }
    return {"year":years == 0 ? year : years,"month":months};
}
/*
*   兼容苹果刘海屏获取头部和底部安全区域方法
*   接受一个参数
*   type:String,获取头部还是底部安全区距离
*   开发者：付长建
*/
function phonexh(type){
    try{
        var u = navigator.userAgent;
        var isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
        if(isIOS){
            switch(type){
                case "top-compatible":{ //兼容安卓和ios，安卓壳是从安全区域渲染，ios是从顶部渲染
                    return api.safeArea.top;
                }
                case "bottom-compatible":{//兼容安卓
                    return api.safeArea.bottom;
                }
                case "top": {
                    return api.safeArea.top;
                }
                case "bottom-noBar": {
                    return api.safeArea.bottom;
                }
                case "bottom": {
                    return api.safeArea.bottom;
                }
                default: {
                    return api.safeArea.top;
                }
            }
        }else{
            switch (type) {
                case "top-compatible": {
                    return 0;
                }
                case "bottom-compatible": {
                    return 0;
                }
                case "top": {
                    return api.safeArea.top;
                }
                case "bottom-noBar": {
                    return api.safeArea.bottom;
                }
                case "bottom": {
                    return api.safeArea.bottom;
                }
                default: {
                    return api.safeArea.top;
                }
            }
        }
    }catch(e){
        return 0;
    }
}
//得到刘海屏底部距离方法
function bottomHeight(){
    var botHeig = phonexh("bottom");
    var u = navigator.userAgent;
    if(u.indexOf("iPhone") > -1){
        if(phonexh("bottom") == 0){
            botHeig = 50;
        }else{
            botHeig = phonexh("bottom") + 15;
        }
    }
    return botHeig;
}
//模仿原生开启窗口动画
function openPrimordial(content,type,tran){
    if(type == "yes"){
        setTimeout(function(){
            $(content).css({"transition":"all 0.3s","transform":"translate(-100px,0px)"});
        },50);
    }else{
        $(content).css({"transition":"all 0.3s","transform":"translate(0px,0px)"});
        setTimeout(function(){
            //判断是否需要去除动画时间
            if(tran == undefined || tran == null || tran == ""){
                $(content).css({"transition":"","transform":""});
            }else{
                $(content).css({"transform":""});
            }
        },310);
    }
}
/*
*   匹配文件类型方法
*   接受一个参数
*   type:String,文件的后缀名称
*   开发者：付长建
*/
function matchingFileType(type){
    var image = ["btif","pti","psd","azv","uvi","uvvi","uvg","uvvg","djvu","djv","*sub","dwg","dxf","fbs","fpx","fst","mmr","rlc","ico","mdi","wdp","npx","tap","vtf","wbmp","xif","pcx","3ds","ras","cmx","fh", "fhc", "fh4", "fh5", "fh7","*ico","jng","sid","*bmp","*pcx","pic", "pct","pnm","pbm","pgm","ppm","rgb","tga","xbm","xpm","xwd","exr","apng","bmp","cgm","drle","emf","fits","g3","gif","heic","heics","heif","heifs","ief","jls","jp2", "jpg2","jpeg", "jpg","jpe","jpm","jpx", "jpf","ktx","png","sgi","svg", "svgz","t38","tif", "tiff","tfx","webp","wmf","jpg"];
    var video = ["uvh", "uvvh","uvm", "uvvm","uvp", "uvvp","uvs", "uvvs","uvv","uvvv","dvb","fvt","mxu", "m4u","pyv","uvu","uvvu","viv","f4v","fli","flv","m4v","mkv", "mk3d", "mks","mng","asf", "asx","vob","wm","wmv","wmx","wvx","avi","movie","smv","3gp", "3gpp","3g2","h261","h263","h264","jpgv","*jpm", "jpgm","mj2", "mjp2","ts","mp4", "mp4v", "mpg4","mpeg", "mpg", "mpe", "m1v","m2v","ogv","qt", "mov","webm","MP4","rmvb","uva", "uvva","eol","dra","dts","dtshd","lvp","pya","ecelp4800","ecelp7470","ecelp9600","rip","aac","aif", "aiff", "aifc","caf","flac","*m4a","mka","m3u","wax","wma","ram", "ra","rmp","*ra","*wav","*3gpp","adp","au", "snd","mid", "midi", "kar", "rmi","*mp3","m4a", "mp4a","mpga", "mp2", "mp2a", "mp3", "m2a", "m3a","oga", "ogg","spx","s3m","sil","wav","*wav","weba","xm","MP3"];
    var document = ["curl","dcurl","mcurl","scurl","sub","fly","flx","gv","3dml","spot","jad","wml","wmls","s", "asm","c", "cc", "cxx", "cpp", "h", "hh", "dic","htc","f", "for", "f77", "f90","hbs","java","lua","mkd","nfo","opml","*org","p","pas","pde","sass","scss","etx","sfv","ymp","uu","vcs","vcf","dsc","appcache","manifest","ics", "ifb","coffee", "litcoffee","css","csv","html", "htm", "shtml","jade","jsx","less","markdown", "md","mml","n3","txt", "text", "conf","def", "list", "log", "in", "ini","rtx","*rtf","sgml", "sgm", "shex","slim", "slm","stylus", "styl","tsv","t", "tr", "roff", "man", "me", "ms","ttl","uri","uris", "urls","vcard","vtt","*xml","yaml", "yml","js","doc", "dot","wps", "wks", "wcm", "wdb","docx","dotx","pdf","xls", "xlm", "xla", "xlc", "xlt","xlw","xlam","xlsb","xlsm","xltm","xlsx","xltx","ppt", "pps", "pot", "ppam","pptm","sldm","ppsm","potm","pptx","sldx","ppsx","unknown","exe","ysnote","torrent"];
    if(image.indexOf(type) > -1){
        return "image";
    }else if(video.indexOf(type) > -1){
        return "video";
    }else if(document.indexOf(type) > -1){
        return "document";
    }else{
        return undefined;
    }
}
/*
*   找到当前预览文件所需要的参数
*   接受一个参数
*   obj:{
*       "fileId"://文件唯一id
*       "content"://要获取元素的父级元素
*   }
*   开发者：付长建
*/
function getCurrentPreviewFileInformation(objst){
    var obj = {}
    obj.type = objst.content.find("[uuid="+objst.fileId+"]").attr("type");//得到当前预览的文件类型
    obj.uuid = objst.fileId;//得到当前预览的文件的唯一id
    obj.fileinfoId = objst.content.find("[uuid="+objst.fileId+"]").attr("fileInfoId");//得到当前预览文件的fileInfoId
    obj.ext = objst.content.find("[uuid="+objst.fileId+"]").attr("ext");//得到当前预览文件的后缀
    obj.fileName = objst.content.find("[uuid="+objst.fileId+"]").find(".fileName").text();//得到当前预览文件的名称
    return obj;
}
/*
*   预览找到下一个上一个图片或者文件id方法
*   接受一个参数
*   obj:{
*       "fileId"://文件唯一id
*       "operateType"://获取上一张还是下一张或者上一个下一个文件 prev next
*       "fileType":"获取的文件类型"
*       "content"://要获取元素的父级元素
*   }
*   开发者：付长建
*/
function getPrevNextFileId(obj){
    var objData = "";
    //判断是文件还是图片
    if(obj.fileType == "image"){
        //判断是获取上一张还是下一张
        if(obj.operateType == "prev"){
            //判断是否还有上一张
            if(obj.content.find("[uuid="+obj.fileId+"]").prev().attr("uuid") != undefined){
                if(obj.content.find("[uuid="+obj.fileId+"]").prev().attr("type") != "image"){
                    var infoId = obj.content.find("[uuid="+obj.fileId+"]").prev().attr("uuid");
                    var objes = obj;
                        objes.fileId = infoId;
                        objData = getPrevNextFileId(objes);
                }else{
                    //判断当前图片是否能够预览
                    if(parseInt(obj.content.find("[uuid="+obj.fileId+"]").prev().attr("previewEnable")) == 1){
                        objData = obj.content.find("[uuid="+obj.fileId+"]").prev().attr("uuid");
                    }else{
                        var infoId = obj.content.find("[uuid="+obj.fileId+"]").prev().attr("uuid");
                        var objes = obj;
                        objes.fileId = infoId;
                        objData = getPrevNextFileId(objes);
                    }
                }
            }else{
                objData = "";
            }
        }else{
            //判断是否还有下一张图片
            if(obj.content.find("[uuid="+obj.fileId+"]").next().attr("uuid") != undefined){
                //判断文件类型是否等于图片
                if(obj.content.find("[uuid="+obj.fileId+"]").next().attr("type") != "image"){
                    var infoId = obj.content.find("[uuid="+obj.fileId+"]").next().attr("uuid");
                    var objes = obj;
                        objes.fileId = infoId;
                        objData = getPrevNextFileId(objes);
                }else{
                    //判断下一张图片是否可以预览
                    if(parseInt(obj.content.find("[uuid="+obj.fileId+"]").next().attr("previewEnable")) == 1){
                        objData = obj.content.find("[uuid="+obj.fileId+"]").next().attr("uuid");
                    }else{
                        var infoId = obj.content.find("[uuid="+obj.fileId+"]").next().attr("uuid");
                        var objes = obj;
                        objes.fileId = infoId;
                        objData = getPrevNextFileId(objes);
                    }
                }
            }else{
                objData = "";
            }
        }
    }else{
        //判断是获取上一张还是下一张
        if(obj.operateType == "prev"){
            //判断是否还有上一个文件
            if(obj.content.find("[uuid="+obj.fileId+"]").prev().attr("uuid") != undefined){
                //判断上一个文件是否可以预览
                if(parseInt(obj.content.find("[uuid="+obj.fileId+"]").prev().attr("previewEnable")) == 0){
                    var infoId = obj.content.find("[uuid="+obj.fileId+"]").prev().attr("uuid");
                    var objes = obj;
                        objes.fileId = infoId;
                        objData = getPrevNextFileId(objes);
                }else{
                    objData = infoId = obj.content.find("[uuid="+obj.fileId+"]").prev().attr("uuid");
                }
            }else{
                objData = "";
            }
        }else{
            //判断是否还有下一个文件
            if(obj.content.find("[uuid="+obj.fileId+"]").next().attr("uuid") != undefined){
                //判断下一个文件是否可以预览
                if(parseInt(obj.content.find("[uuid="+obj.fileId+"]").next().attr("previewEnable")) == 0){
                    var infoId = obj.content.find("[uuid="+obj.fileId+"]").next().attr("uuid");
                    var objes = obj;
                        objes.fileId = infoId;
                        objData = getPrevNextFileId(objes);
                }else{
                    objData = obj.content.find("[uuid="+obj.fileId+"]").next().attr("uuid");
                }
            }else{
                objData = "";
            }
        }
    }
    return objData;
}
/*
*   预览找到下一个上一个图片或者文件fileinfoid方法
*   接受一个参数
*   obj:{
*       "fileId"://文件唯一id
*       "operateType"://获取上一张还是下一张或者上一个下一个文件 prev next
*       "fileType":"获取的文件类型"
*       "content"://要获取元素的父级元素
*   }
*   开发者：付长建
*/
function getPrevNextFileinfoid(obj){
    var fileinfoid = "";
    //判断是文件还是图片
    if(obj.fileType == "image"){
        //判断是获取上一张还是下一张
        if(obj.operateType == "prev"){
            //判断是否还有上一张
            if(obj.content.find("[uuid="+obj.fileId+"]").prev().attr("uuid") != undefined){
                if(obj.content.find("[uuid="+obj.fileId+"]").prev().attr("type") != "image"){
                    var infoId = obj.content.find("[uuid="+obj.fileId+"]").prev().attr("uuid");
                    var objes = obj;
                        objes.fileId = infoId;
                        fileinfoid = getPrevNextFileinfoid(objes);
                }else{
                    //判断当前图片是否能够预览
                    if(parseInt(obj.content.find("[uuid="+obj.fileId+"]").prev().attr("previewEnable")) == 1){
                        fileinfoid = obj.content.find("[uuid="+obj.fileId+"]").prev().attr("fileinfoid");
                    }else{
                        var infoId = obj.content.find("[uuid="+obj.fileId+"]").prev().attr("uuid");
                        var objes = obj;
                        objes.fileId = infoId;
                        fileinfoid = getPrevNextFileinfoid(objes);
                    }
                }
            }else{
                fileinfoid = "";
            }
        }else{
            //判断是否还有下一张图片
            if(obj.content.find("[uuid="+obj.fileId+"]").next().attr("uuid") != undefined){
                //判断文件类型是否等于图片
                if(obj.content.find("[uuid="+obj.fileId+"]").next().attr("type") != "image"){
                    var infoId = obj.content.find("[uuid="+obj.fileId+"]").next().attr("uuid");
                    var objes = obj;
                        objes.fileId = infoId;
                        fileinfoid = getPrevNextFileinfoid(objes);
                }else{
                    //判断下一张图片是否可以预览
                    if(parseInt(obj.content.find("[uuid="+obj.fileId+"]").next().attr("previewEnable")) == 1){
                        fileinfoid = obj.content.find("[uuid="+obj.fileId+"]").next().attr("fileinfoid");
                    }else{
                        var infoId = obj.content.find("[uuid="+obj.fileId+"]").next().attr("uuid");
                        var objes = obj;
                        objes.fileId = infoId;
                        fileinfoid = getPrevNextFileinfoid(objes);
                    }
                }
            }else{
                fileinfoid = "";
            }
        }
    }else{
        //判断是获取上一张还是下一张
        if(obj.operateType == "prev"){
            //判断是否还有上一个文件
            if(obj.content.find("[uuid="+obj.fileId+"]").prev().attr("uuid") != undefined){
                //判断上一个文件是否可以预览
                if(parseInt(obj.content.find("[uuid="+obj.fileId+"]").prev().attr("previewEnable")) == 0){
                    var infoId = obj.content.find("[uuid="+obj.fileId+"]").prev().attr("uuid");
                    var objes = obj;
                        objes.fileId = infoId;
                        fileinfoid = getPrevNextFileinfoid(objes);
                }else{
                    fileinfoid = infoId = obj.content.find("[uuid="+obj.fileId+"]").prev().attr("fileinfoid");
                }
            }else{
                fileinfoid = "";
            }
        }else{
            //判断是否还有下一个文件
            if(obj.content.find("[uuid="+obj.fileId+"]").next().attr("uuid") != undefined){
                //判断下一个文件是否可以预览
                if(parseInt(obj.content.find("[uuid="+obj.fileId+"]").next().attr("previewEnable")) == 0){
                    var infoId = obj.content.find("[uuid="+obj.fileId+"]").next().attr("uuid");
                    var objes = obj;
                        objes.fileId = infoId;
                        fileinfoid = getPrevNextFileinfoid(objes);
                }else{
                    fileinfoid = obj.content.find("[uuid="+obj.fileId+"]").next().attr("fileinfoid");
                }
            }else{
                fileinfoid = "";
            }
        }
    }
    return fileinfoid;
}
/*
*   禁止页面触摸事件
*   开发者：付长建
*/
function bodyScroll(event){
    event.preventDefault();
}
/*
*   通过rul传参，将参数加密(解密)方法
*   obj:{},加密数据必须是对象
*   开发者：付长建
*/
function encode(obj){
    if(obj instanceof Object){
        return encodeURI(JSON.stringify(obj));
    }else{
        a;lert("加密数据只能是对象")
    }
}
/*
*   通过rul传参，将参数加密(解密)方法
*   str:"",解密数据必须是字符串
*   开发者：付长建
*/
function decode(str){
    if((typeof str == "string") && str.constructor == String){
        return JSON.parse(decodeURI(str));
    }else{
        alert("解密数据只能是字符串");
    }
}
