/*
 * 数据模型
 * 笔记-党建本数据模型
 * 薛原
 */
define(['jquery','RequestManager','TokenDataModel','Shell'],function($,RequestManager,TokenDataModel,Shell){
	var NoteBookDataModel = {}
	NoteBookDataModel.getDataApi = "/ctl/cpcapi/book/search_book";
	NoteBookDataModel.createBookApi = "/ctl/cpcapi/book/create_book";
	NoteBookDataModel.activeActiveApi = "/ctl/cpcapi/book/active_book";
	NoteBookDataModel.removeApi = "/ctl/cpcapi/book/remove_book";
	NoteBookDataModel.renameApi = "/ctl/cpcapi/book/rename_book";
	NoteBookDataModel.synYsnoteToCloudspaceApi = "/ctl/cpcapi/book/share_book"; //同步ysnote文件到云空间
    NoteBookDataModel.checkSynYsnoteFileToCloudspaceResultApi = "/ctl/task/cpc/check/status"; //同步结果轮询

    //同步ysnote文件到云空间状态轮询
	NoteBookDataModel.checkSynYsnoteFileToCloudspaceResult = function(taskId){
		var div = $("<div></div>");
		div.bind("MODEL_TOKEN_READY",function(e){
			div.unbind("MODEL_TOKEN_READY");
			var param = {};
			var data = {};
			param.data = data;
			var accountCode = TokenDataModel.ACCOUNT_CODE;
			data.accountCode = accountCode;
			data.token = TokenDataModel.TOKEN;
			data.taskId = taskId;
			param.url = TokenDataModel.getDomain()+NoteBookDataModel.checkSynYsnoteFileToCloudspaceResultApi;
			param.type = "post";
			param.dataType = "json";
			param.success = function(ret){
				if(ret.retCode == "SUCCESS"){
					$(window).trigger("CHECK_SYN_NOTE_BOOK_TO_CLOUDSPACE_RESULT",ret); //同步云空间成功
				}else if(ret.retCode == 'NO_AUTH'){
					Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
				}
			}
			param.error = function(ret){
				$(window).trigger("CHECK_SYN_NOTE_BOOK_TO_CLOUDSPACE_RESULT",{"data":"NET_ERROR"});
			}
			RequestManager.ajax(param);
		});
		TokenDataModel.getToken(div); //获取token;;
	}

	//同步ysnote文件到云空间
	NoteBookDataModel.synYsnoteFileToCloudspace = function(uuid){
		var div = $("<div></div>");
		div.bind("MODEL_TOKEN_READY",function(e){
			div.unbind("MODEL_TOKEN_READY");
			var param = {};
			var data = {};
			param.data = data;
			var accountCode = TokenDataModel.ACCOUNT_CODE;
			data.accountCode = accountCode;
			data.token = TokenDataModel.TOKEN;
			data.bookId = uuid;
			param.url = TokenDataModel.getDomain()+NoteBookDataModel.synYsnoteToCloudspaceApi;
			param.type = "post";
			param.dataType = "json";
			param.success = function(ret){
				//alert(JSON.stringify(ret));
				if(ret.retCode == "SUCCESS"){
					$(window).trigger("SYN_NOTE_BOOK_TO_CLOUDSPACE_SUCCESS",{"uuid":uuid,"taskId":ret.data.taskId,"status":ret.data.status}); //同步云空间成功
				}else if(ret.retCode == 'NO_AUTH'){
					Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
				}
			}
			param.error = function(ret){
				$(window).trigger("SYN_NOTE_BOOK_TO_CLOUDSPACE_ERROR"); //删除党建本失败
			}
			RequestManager.ajax(param);
		});
		TokenDataModel.getToken(div); //获取token;;
	}
	//删除党建本
	NoteBookDataModel.delete = function(uuid){
		var div = $("<div></div>");
		div.bind("MODEL_TOKEN_READY",function(e){
			div.unbind("MODEL_TOKEN_READY");
			var param = {};
			var data = {};
			param.data = data;
			var accountCode = TokenDataModel.ACCOUNT_CODE;
			data.accountCode = accountCode;
			data.token = TokenDataModel.TOKEN;
			data.bookId = uuid;
			param.url = TokenDataModel.getDomain()+NoteBookDataModel.removeApi;
			param.type = "post";
			param.dataType = "json";
			param.success = function(ret){
				if(ret.retCode == "SUCCESS"){
					$(window).trigger("REMOVE_NOTE_BOOK_SUCCESS",{"uuid":uuid}); //删除党建本成功
				}else if(ret.retCode == 'NO_AUTH'){
					Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
				}
			}
			param.error = function(ret){
				$(window).trigger("REMOVE_NOTE_BOOK_ERROR"); //删除党建本失败
			}
			RequestManager.ajax(param);
		});
		TokenDataModel.getToken(div); //获取token;;
	}

	
	
	//锁定党建本
	NoteBookDataModel.lock = function(uuid){
		var div = $("<div></div>");
		div.bind("MODEL_TOKEN_READY",function(e){
			div.unbind("MODEL_TOKEN_READY");
			var param = {};
			var data = {};
			param.data = data;
			var accountCode = TokenDataModel.ACCOUNT_CODE;
			data.accountCode = accountCode;
			data.token = TokenDataModel.TOKEN;
			data.activeFlag = "0";
			data.bookId = uuid;
			param.url = TokenDataModel.getDomain()+NoteBookDataModel.activeActiveApi;
			param.type = "post";
			param.dataType = "json";
			param.success = function(ret){
				if(ret.retCode == "SUCCESS"){
					$(window).trigger("LOCK_NOTE_BOOK_SUCCESS",{"uuid":uuid}); //锁定党建本成功
				}else if(ret.retCode == 'NO_AUTH'){
					Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
				}
			}
			param.error = function(ret){
				$(window).trigger("LOCK_NOTE_BOOK_ERROR"); //锁定党建本失败
			}
			RequestManager.ajax(param);
		});
		TokenDataModel.getToken(div); //获取token;;
	}
	//解锁党建本
	NoteBookDataModel.unlock = function(uuid){
		var div = $("<div></div>");
		div.bind("MODEL_TOKEN_READY",function(e){
			div.unbind("MODEL_TOKEN_READY");
			var param = {};
			var data = {};
			param.data = data;
			var accountCode = TokenDataModel.ACCOUNT_CODE;
			data.accountCode = accountCode;
			data.token = TokenDataModel.TOKEN;
			data.activeFlag = "1";
			data.bookId = uuid;
			param.url = TokenDataModel.getDomain()+NoteBookDataModel.activeActiveApi;
			param.type = "post";
			param.dataType = "json";
			param.success = function(ret){
				if(ret.retCode == "SUCCESS"){
					$(window).trigger("UNLOCK_NOTE_BOOK_SUCCESS",{"uuid":uuid}); //激活党建本成功 //一本被激活其他状态可能会发现改变
				}else if(ret.retCode == 'NO_AUTH'){
					Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
				}
			}
			param.error = function(ret){
				$(window).trigger("UNLOCK_NOTE_BOOK_ERROR"); //激活党建本失败
			}
			RequestManager.ajax(param);
		});
		TokenDataModel.getToken(div); //获取token;;
	}
	//新建党建本
	NoteBookDataModel.createData = function(bookName,bookType){
		var div = $("<div></div>");
		div.bind("MODEL_TOKEN_READY",function(e){
			div.unbind("MODEL_TOKEN_READY");								  
			var param = {};
			var data = {};
			param.data = data;
			var accountCode = TokenDataModel.ACCOUNT_CODE;
			data.accountCode = accountCode;
			data.token = TokenDataModel.TOKEN;
			
			data.bookName = bookName;
			data.bookType = bookType;
			if(parseInt(bookType) == 100 || parseInt(bookType) == 310){//拓思德
				data.penType = "4";
			}else if(parseInt(bookType) == 110){//腾千里
				data.penType = "1";
			}else{
				data.penType = "3";
			}
			param.url = TokenDataModel.getDomain()+NoteBookDataModel.createBookApi;
			param.type = "post";
			param.dataType = "json";
			param.success = function(ret){
				if(ret.retCode == "SUCCESS"){
					$(window).trigger("CREATE_NOTE_BOOK_DATA_SUCCESS",ret); //创建党建本成功
				}else if(ret.retCode == 'NO_AUTH'){
					Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
				}
			}
			param.error = function(ret){
				$(window).trigger("CREATE_NOTE_BOOK_DATA_ERROR",ret); //创建党建本失败
			}
			RequestManager.ajax(param);
		});
		TokenDataModel.getToken(div); //获取token;
	}
	//获取数据
	NoteBookDataModel.getData = function(){
		var div = $("<div></div>");
		div.bind("MODEL_TOKEN_READY",function(e){
			div.unbind("MODEL_TOKEN_READY");
			var param = {};
			var data = {};
			param.data = data;
			var accountCode = TokenDataModel.ACCOUNT_CODE;
			data.accountCode = accountCode;
			data.token = TokenDataModel.TOKEN;
			param.url = TokenDataModel.getDomain()+NoteBookDataModel.getDataApi;
			param.type = "post";
			param.dataType = "json";
			param.success = function(ret){
				if(ret.retCode == "SUCCESS"){
					localStorage.setItem("NoteBookData",JSON.stringify(ret));
					Shell.sendEvent("BookListDataChanged",{"data":ret.data});
					$(window).trigger("GET_NOTE_BOOK_DATA_SUCCESS",ret); //获取笔记列表数据成功
				}else if(ret.retCode == "NO_AUTH"){
					Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
				}else{
					param.error();
				}
			}
			param.error = function(ret){
				var data = localStorage.getItem("NoteBookData");
				if(data){
					data = JSON.parse(data);
					//console.log(data);
					Shell.sendEvent("BookListDataChanged",{"data":data.data});
					$(window).trigger("GET_NOTE_BOOK_DATA_SUCCESS",data); //获取笔记列表缓存数据成功
				}else{
					$(window).trigger("GET_NOTE_BOOK_DATA_ERROR"); //获取笔记列表数据失败
				}
			}
			RequestManager.ajax(param);
		});
		TokenDataModel.getToken(div); //获取token;
	}
	NoteBookDataModel.clearCacheData = function(){
		localStorage.setItem("NoteBookData",JSON.stringify([]));
	}
	return NoteBookDataModel;
});