/*
 * 数据模型
 * 笔记-党建笔数据模型
 * 薛原
 */
define(['jquery','RequestManager','TokenDataModel','Shell'],function($,RequestManager,TokenDataModel,Shell){
	var NotePenDataModel = {};
	NotePenDataModel.getDataApi = "/ctl/cpcapi/bindpen/get_cpc_bind_pen_list";
	NotePenDataModel.unbindApi = "/ctl/cpcapi/bindpen/unbind_pen";
	NotePenDataModel.backFactoryApi = "/ctl/cpcapi/bindpen/recovery_pen";
	NotePenDataModel.getNameApi = "/ctl/cpcapi/bindpen/get_pen_name_by_mac";
	NotePenDataModel.renameNameApi = "/ctl/cpcapi/bindpen/set_pen_name_by_mac";
	NotePenDataModel.setLinked = function(status){
		if(typeof(api) != "undefined"){
			api.setPrefs({
				key: 'PenLinked',
				value: status
			});
		}
	}
	
	NotePenDataModel.getLinked = function(){
		if(typeof(api) != "undefined"){
			var data = api.getPrefs({
				sync: true,
				key: 'PenLinked'
			});
			return data;
		}else{
			return 0;
		}
	}
	//获取本地已连接的笔
	//默认为空，最多只有1只笔,新的则替换
	NotePenDataModel.setLocationLinkedPen = function(data){
		if(typeof(data.autoLink) == "undefined"){
			data.autoLink = 0;
		}
		localStorage.setItem("NoteLinkedPenData",JSON.stringify(data));
	}
	NotePenDataModel.getPenName = function(mac){
		var div = $("<div></div>");
		div.bind("MODEL_TOKEN_READY",function(e){
			div.unbind("MODEL_TOKEN_READY");
			var param = {};
			var data = {};
			param.data = data;
			var accountCode = TokenDataModel.ACCOUNT_CODE;
			data.accountCode = accountCode;
			data.token = TokenDataModel.TOKEN;
			param.url = TokenDataModel.getDomain()+NotePenDataModel.getNameApi;
			data.macAddr = mac;
			data.deviceType = "android";
			try{
				data.deviceType = api.systemType;
			}catch(e){}
			param.type = "post";
			param.dataType = "json";
			param.success = function(ret){
				if(ret.retCode == "SUCCESS"){
					$(window).trigger("GET_PEN_NAME_SUCCESS",ret); //获取笔名字成功
				}else if(ret.retCode == 'NO_AUTH'){
					Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
				}
			}
			param.error = function(ret){
				//静默
			}
			RequestManager.ajax(param);
		});
		TokenDataModel.getToken(div); //获取token;
	},
	//默认为空，最多只有1只笔,新的则替换
	NotePenDataModel.getLocationLinkedPen = function(needEvent){
		var data;
		try{
			data = localStorage.getItem("NoteLinkedPenData");
			data = JSON.parse(data);
			//alert(data);
			$(window).trigger("GET_NOTE_LINKED_PEN_DATA_SUCCESS",data); //获取已经连接过的智能笔
		}catch(e){
			//alert(e);
		}
		return data;
	}
	//默认为空，最多只有1只笔,新的则替换
	NotePenDataModel.getLocationLinkedPenWithNoEvent = function(){
		try{
			data = localStorage.getItem("NoteLinkedPenData");
			data = JSON.parse(data);
		}catch(e){
			//alert(e);
		}
		return data;
	}
	
	//恢复出厂
	NotePenDataModel.backFactory = function(mac){
		var div = $("<div></div>");
		div.bind("MODEL_TOKEN_READY",function(e){
			div.unbind("MODEL_TOKEN_READY");
			var param = {};
			var data = {};
			param.data = data;
			var accountCode = TokenDataModel.ACCOUNT_CODE;
			data.accountCode = accountCode;
			data.token = TokenDataModel.TOKEN;
			//alert(TokenDataModel.TOKEN+" "+data.accountCode);
			param.url = TokenDataModel.getDomain()+NotePenDataModel.backFactoryApi;
			data.macAddr = mac;
			param.type = "post";
			param.dataType = "json";
			param.success = function(ret){
				if(ret.retCode == "SUCCESS"){
					NotePenDataModel.setLocationLinkedPen("");
					$(window).trigger("BACKFACTORY_NOTE_PEN_DATA_SUCCESS",ret); //笔恢复出厂成功
				}else if(ret.retCode == 'NO_AUTH'){
					Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
				}
			}
			param.error = function(ret){
				$(window).trigger("BACKFACTORY_NOTE_PEN_DATA_ERROR"); //笔恢复出厂失败
			}
			RequestManager.ajax(param);
		});
		TokenDataModel.getToken(div); //获取token;
	}
	//解除绑定(删除设备)
	NotePenDataModel.unbind = function(mac,snAddr){
		var div = $("<div></div>");
		div.bind("MODEL_TOKEN_READY",function(e){
			div.unbind("MODEL_TOKEN_READY");
			var param = {};
			var data = {};
			param.data = data;
			var accountCode = TokenDataModel.ACCOUNT_CODE;
			data.accountCode = accountCode;
			data.token = TokenDataModel.TOKEN;
			param.url = TokenDataModel.getDomain()+NotePenDataModel.unbindApi;
			data.macAddr = mac;
			param.type = "post";
			param.dataType = "json";
			param.success = function(ret){
				if(ret.retCode == "SUCCESS"){
					var location = NotePenDataModel.getLocationLinkedPen();
					if(location.mac == mac || location.mac == snAddr){
						NotePenDataModel.setLocationLinkedPen("");
					}
					$(window).trigger("UNBIND_NOTE_PEN_DATA_SUCCESS",ret); //解绑定笔成功
				}else if(ret.retCode == 'NO_AUTH'){
					Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
				}
			}
			param.error = function(ret){
				$(window).trigger("UNBIND_NOTE_PEN_DATA_ERROR"); //解绑定笔失败
			}
			RequestManager.ajax(param);
		});
		TokenDataModel.getToken(div); //获取token;
	}
	
	//获取数据
	NotePenDataModel.getData = function(){
		var div = $("<div></div>");
		div.bind("MODEL_TOKEN_READY",function(e){
			div.unbind("MODEL_TOKEN_READY");
			var param = {};
			var data = {};
			param.data = data;
			var accountCode = TokenDataModel.ACCOUNT_CODE;
			data.accountCode = accountCode;
			data.token = TokenDataModel.TOKEN;
			param.url = TokenDataModel.getDomain()+NotePenDataModel.getDataApi;
			param.type = "post";
			param.dataType = "json";
			param.success = function(ret){
				if(ret.retCode == "SUCCESS"){
					localStorage.setItem("NotePenData",JSON.stringify(ret));
					$(window).trigger("GET_NOTE_PEN_DATA_SUCCESS",ret); //获取智能笔列表数据成功
				}else if(ret.retCode == 'NO_AUTH'){
					Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
				}
			}
			param.error = function(ret){
				var data = localStorage.getItem("NotePenData");
				if(data){
					data = JSON.parse(data);
					$(window).trigger("GET_NOTE_PEN_DATA_SUCCESS",data); //获取智能笔列表缓存数据成功
				}else{
					$(window).trigger("GET_NOTE_PEN_DATA_ERROR"); //获取智能笔列表数据失败
				}
			}
			RequestManager.ajax(param);
		});
		TokenDataModel.getToken(div); //获取token;
	}
	
	//获取数据
	NotePenDataModel.getDataByLocal = function(){
		var data = localStorage.getItem("NotePenData");
		if(data){
			data = JSON.parse(data);
			$(window).trigger("GET_NOTE_PEN_DATA_SUCCESS",data); //获取智能笔列表缓存数据成功
		}else{
			$(window).trigger("GET_NOTE_PEN_DATA_ERROR"); //获取智能笔列表数据失败
		}
	}
	
	NotePenDataModel.clearCacheData = function(){
		NotePenDataModel.setLocationLinkedPen([]);
		localStorage.setItem("NotePenData",JSON.stringify([]));
	}
	return NotePenDataModel;
});