require.config({
    waitSeconds: 0,
    urlArgs: "v=1",
    packages: [{
            name: 'moment',
            location: '../libs/moment',
            main: 'moment'
        }
    ],
    //在打包压缩时将会把include中的模块合并到主文件中
    include:[
        "jquery","jqueryui","iscroll","Base64","Fastclick","Shell","YsPreviewManager","CommonHead","CommonToast",
        "CommonSearch","CommonCrumbs","CommonIscroll","CommonAdd","CommonAddPanel","CommonNewFolderAadRename","DangjianCell",
        "CommonCell","CommonBottonMenu","CommonShareMenu","CommonMoveCopy","CommonLinkSearch","DangjianCell","CommonSetPwd",
        "DepositSearchPanel","LinkCell","DjMyspaceSearchPanel","QuickPage","FootBottom","YsnoteCell","NoteHead","SliderBook","SearchPenState",
        "NewPenCell","NewBookCell"
	],
	//组件配置路径
    paths:{
        //以下的包从libs目录加载
        "jquery": "./libs/jquery",
		"jqueryui": "./libs/jquery-ui.min",//组件封装插件
		"iscroll": "./libs/iscroll-probe",//滚动插件
        "Base64": "./libs/base64",//加密插件
		"md5": "./libs/md5",//MD5加密插件
        "Fastclick":"./libs/fastclick",//解决移动端点击事件延迟300ms插件
        "Shell":"./widgets/core/Shellv2",//给元素交互组件
        "YsPreviewManager":"./widgets/core/YsPreviewManager",//预览管理器
		"swiper":"./libs/swiper-bundle.min",
        "base64":"./libs/base64",
		"phonexh":"./widgets/core/phonexh",
        "Download":"./widgets/core/Download",
		//以下组件从widgets加载
        "CommonHead":"./widgets/impl/CommonHead",//头部组件
        "CommonSearch":"./widgets/impl/CommonSearch",//搜索组件 
        "CommonCrumbs":"./widgets/impl/CommonCrumbs",//面包屑组件
        "CommonIscroll":"./widgets/impl/CommonIscroll",//内容滑动组件
        "CommonCell":"./widgets/impl/CommonCell",//列表组件 
        "CommonBottonMenu":"./widgets/impl/CommonBottonMenu",//列表底部操作菜单 
        "CommonToast":"./widgets/impl/CommonToast",//操作提示飘窗组件 
        "CommonShareMenu":"./widgets/impl/CommonShareMenu",//分享菜单组件 
        "CommonDeleteMask":"./widgets/impl/CommonDeleteMask",//删除通用组件 
        "CommonMoveCopy":"./widgets/impl/CommonMoveCopy",//移动和复制通用组件 
        "CommonNewFolderAadRename":"./widgets/impl/CommonNewFolderAadRename",//新建文件夹和重命名组件 
        "MySpaceSee":"./widgets/impl/MySpaceSee",//个人空间查看文件信息组件 
        "CommonSetLabel":"./widgets/impl/CommonSetLabel",//设置标签组件 
        "MySpaceSearchPanel":"./widgets/impl/MySpaceSearchPanel",//个人空间搜索panel组件 
        "CommonLinkSearch":"./widgets/impl/CommonLinkSearch",//创建链接分享组件 
        "CommonAdd":"./widgets/impl/CommonAdd",//添加组件 
        "CommonAddPanel":"./widgets/impl/CommonAddPanel",//添加panel组件 
        "DangjianCell":"./widgets/impl/DangjianCell",//云空间首页党建cell组件  
        "CommonSetPwd":"./widgets/impl/CommonSetPwd",//保险箱设置密码组件
        "DepositSearchPanel":"./widgets/impl/DepositSearchPanel",//保险箱搜索组件
        "LinkCell":"./widgets/impl/LinkCell",//我的链接cell组件 
        "DjMyspaceSearchPanel":"./widgets/impl/DjMyspaceSearchPanel",//党建首页搜索panel组件 
        "QuickPage":"./widgets/impl/QuickPage",//保险箱笔记转文档快捷定位页码组件 
        "FootBottom":"./widgets/impl/FootBottom",//保险箱笔记转文档底部导航组件 
        "YsnoteCell":"./widgets/impl/YsnoteCell",//保险箱笔记转文档cell组件 
        "ChangeMask":"./widgets/impl/ChangeMask",//保险箱笔记转文档转换弹窗组件
		"Navigations":"./widgets/impl/Navigations",
		"Header":"./widgets/impl/Header",
		"NewCloudCell":"./widgets/impl/NewCloudCell",
		"NewFileBottomOperation":"./widgets/impl/NewFileBottomOperation",
		"NewScroll":"./widgets/impl/NewScroll",
		"confirm":"./widgets/impl/confirm",
		"SkinManager":"./widgets/core/SkinManager",
		"style":"./widgets/plugin/style",
		"ByteFormat":"./widgets/core/ByteFormat",
		"DateFormat":"./widgets/core/DateFormat",
		"IconBox":"./widgets/impl/IconBox",
		"ImgBase":"./widgets/impl/ImgBase",
		"EmptyPanel":"./widgets/impl/EmptyPanel",
		"SubmitBtn":"./widgets/impl/SubmitBtn",
		"PopupAlert":"./widgets/impl/PopupAlert",
		"Popup":"./widgets/impl/Popup",
		//笔记部分
        'Config':'./widgets/core/Config',  //配置
        "ApiConfig":"./widgets/core/ApiConfig",
		//抽象类
        'Widget':'./widgets/abst/Widget',  //抽象基类 
        'Panel':'./widgets/abst/Panel',  //面板
        'Label':'./widgets/abst/Label', //文本  
		'Img':'./widgets/abst/Img', //图片
        'Btn':'./widgets/abst/Btn',   //按钮 
        'Input':'./widgets/abst/Input',   //输入框 
        'Textarea':'./widgets/abst/Textarea',   //文本域
        'Cell':'./widgets/abst/Cell',   //输入框 
		'Icon':'./widgets/abst/Icon',   //输入框 
        'BtnGroup':'./widgets/abst/BtnGroup',   //按钮组 
        'SelectBtn':'./widgets/abst/SelectBtn',   //按钮组 
		
		'ImgBtn':'./widgets/impl/ImgBtn',   //图片按钮 
		"PenStatusPanel":"./widgets/impl/PenStatusPanel",//笔状态容器
		"LinkPenPanel":"./widgets/impl/LinkPenPanel",//连接笔容器
		"BookSlider":"./widgets/impl/BookSlider", //笔记本轮播插件
		'BaseBtn':'./widgets/impl/BaseBtn',   //基本按钮   
		'NewHeader':'./widgets/impl/NewHeader', //头部组件
		'DownMenu':'./widgets/impl/DownMenu', //下拉菜单组件
		'TextBtn':'./widgets/impl/TextBtn', //文字按钮
		'PenCell':'./widgets/impl/PenCell', //党建笔cell
		'BookCell':'./widgets/impl/BookCell', //党建本cell
		'TitleList':'./widgets/impl/TitleList', //标题list
		'RightTextList':'./widgets/impl/RightTextList', //右侧文本list
		'RightSwitchList':'./widgets/impl/RightSwitchList', //右侧开关list
		'RightEnterList':'./widgets/impl/RightEnterList', //右侧入口list 


        //付长建新添加组件 
        "NoteHead":"./widgets/impl/NoteHead", //笔记模块主页的头部组件 
        "SliderBook":"./widgets/impl/SliderBook", //笔记模块主页的轮播滑块组件 
        "SearchPenState":"./widgets/impl/SearchPenState", //笔记模块主页检索笔组件 
        "NewPenCell":"./widgets/impl/NewPenCell", //笔cell组件
        "NewBookCell":"./widgets/impl/NewBookCell", //本子管理cell组件
		
		//数据模型类&网络管理类
		'RequestManager':"./widgets/core/RequestManager",	
		'TokenDataModel':"./model/TokenDataModel",	
		'NoteBookDataModel':"./model/NoteBookDataModel",	
		'NotePenDataModel':"./model/NotePenDataModel",	
    },
    //shim依赖配置
    shim: {
		swiper: ["css!../css/swiper-bundle.css"]
	},
    baseUrl:"../djcommon/js/", //资源基础路径   
    map:{
        '*': {
            css: './libs/css'
        }
	},
    charset:"utf-8" // 文件编码
});

require(["jquery"], function ($,undefined) {
    // 初始化
    require(["jqueryui"],function(global) {
        //加载相应模块
        if (ServerConfig.jsname) {
    	    var moduleJs = "../"+ServerConfig.jsname;
            require([moduleJs], function (module) {
				module.init()
            }, function (e) {
                console.error(e);
                // 这里可捕获模块加载的错误
            });
        }
    });
});
