/*
 * Cell抽象类
 *  @Author wenjiang 
 * 
*/
define(['Widget'],function(){  
	$.widget("ys.Cell",$.ys.Widget, { 
		//默认参数 
		enable:true,  
		_init: function () {
			this._super();
			//事件绑定
			this.element.bind("click",this, this._onCellClick);
			//this.element.bind("touchstart",this,this.mousedownClick);    
			//this.element.bind("touchend",this,this.mouseupClick); 
			this.element.attr("tapmode")  
		},
		//创建控件，控件生命周期内会运行多次
		_create: function () {},

		_onCellClick:function(e){ 

			//console.log("22222222222")
			// console.log(e)
			if(e.data.enable){
				
				e.data.element.trigger("CELL_CLICK");
				e.data.setLock();
			}
		},
		mousedownClick:function(e){
			
			e.data.element.css({"background-color":"#f0f8fd"})
		},
		mouseupClick:function(e){
			
			e.data.element.css({"background-color":"#ffffff"})
		},
		setLock:function(){ //加锁
			this.enable = false;
			setTimeout(function(param){
				param.setUnlock();
			},500,this);
		},
		setUnlock:function(){ //解锁
			this.enable = true;
		},
		//设置列表数据
		addElement: function(data){  
			this.element.append(data);  
			//加载完成向最大容器跑一个事件，让最大容器刷新
			this.element.trigger("COMPLETE");
		}, 
		// 释放控件
		destroy: function () {
			$.Widget.prototype.destroy.call(this);
		}
	});
}) 