/*
 * 图片组件抽象类
 * loadType参数，图片加载策略 0普通加载 1使劲加载 2.换图加载
 * @Date 2019/01/15    
*/
define(['Icon','Widget'],function(Icon){   
    $.widget("ys.Img",$.ys.Widget,{ 
        //默认参数
		_img:null,
		_src:null, 
		_needSecLoadCheck:false,//是否需要二次检测
		_secLoadCheckUrl:"",
        //初始化，控件生命周期内只运行一次
        _init: function () {     
			this._super();
			this._img = $("<img />");  
			//判断是否是头像引用
			if(this.options.isHead){
				this.element.css({"position":"relative","overflow":"hidden"});    
				this._img.css({"position":"absolute","margin":"50% 50%","transform":"translateX(-50%) translateY(-50%)"});
			}else{
				this.element.css("position","relative");  
				this._img.css("position","absolute");
				
			}
			
			this._img.Widget({"width":this.options.width,"height":this.options.height});
			this._img.hide();
			this._img.bind("error",this,this._onError);
			this._img.one("load",this,this._onLoad);
			
			//设备判断
			this.setSrc(this.options.src)
			this._img.appendTo(this.element); 
		},
		//设置图片地址，建议统一调用
		setSrc:function(src){
			var nowSrc = this._img.attr("src");
			if(src == nowSrc){
				return;
			}
			if(/@[0-9]{1}x\.(png|jpg|gif)$/i.test(src)){//如果是倍图
				var _this = this,realSrc ;
				realSrc = this.autoSrc(src)
				if(realSrc !== src){//如果是倍数改变
					_this._needSecLoadCheck = true;
					_this._secLoadCheckUrl = src;
				}
				this._img.attr("src",realSrc); 
			}else{
				this._img.attr("src",src); 
			}
			
		},
		_onLoad:function(e){
			//e.data._img.css("display",e.data.options.display!==undefined?e.data.options.display:"block");
			e.data._img.fadeIn();
			e.data.element.css("background","transparent");
			e.data.element.trigger("READY");
		},
		_onError:function(e){
			if(e.data._needSecLoadCheck){
				e.data._needSecLoadCheck = false;
				e.data._img.attr("src",e.data._secLoadCheckUrl); 
				e.data.element.css("background","transparent");
			}else{
				e.data._img.css("display","none");
				e.data.element.css("background","#ebebeb");
			}
		},
		setSize:function(obj){
			this._img.Widget({"width":obj.width,"height":obj.height});
		},
		setTypeImg:function(dic){
			return Icon.getIcon( dic.isdir == 1 ? 'folder' : (dic.ext || '') );
		},
		setTypeMaxImg:function(dic){
			if(dic.isShareDir){
				if(dic.way_type == "org"){
					return Icon.getIcon("share_folder_cross_org");
				}else{
					return Icon.getIcon("share_folder_base");
				}
			}
			return Icon.getIcon( dic.isdir == 1 ? 'folder' : (dic.ext || '') );
		},
		//创建控件，控件生命周期内会运行多次
		_create: function () {},
		// 释放控件
		destroy: function () {
			$.Widget.prototype.destroy.call(this);
		},
		changeSrc:function(src){ 
			//设备判断
			this._src = src;
			this.setSrc(src);
			this.options.src = src;
		}

    });
});  