/*
 * Label 文本组件抽象类 
 * Label说明： 无点击需求的单行文本显示内容，可控制颜色，大小，坐标
 * @Author wenjiang 
 * @Date 2019/2/25  
*/
define(['Widget'],function(){ 
	$.widget("ys.Label",$.ys.Widget,{ 
		//默认参数   
		//初始化，控件生命周期内只运行一次 
		_text:null,
		_init: function () { 
			this._super();
			this.options.fontFamily = "PingFang SC";
			if(this.options.whiteSpace){  
				this.element.css("white-space",this.options.whiteSpace);
			}else{
				this.element.css("white-space","nowrap");  
				this.element.css("overflow","hidden"); 
				this.element.css("text-overflow","ellipsis"); 
			}
			var that = this;
			if(typeof(this.options.repairPos) != "undefined" && this.options.repairPos){
				this.element.css({"font-family":"-apple-system-font, sans-serif"});
				setTimeout(function(){
					if(that.element.parent().length > 0){
						that.element.css({"display":"flex","align-items": "center","justify-content":"center"});
					}
				},100);
			}
			if(this.options.MaxtwoLine){
				this.element.css({"wordBreak":"break-all","display":"-webkit-box","WebkitLineClamp":"2","WebkitBoxOrient":"vertical","overflow":"hidden","white-space":"normal"})
			}
			if(this.options.MaxtwoLines){
				this.element.css({"wordBreak":"break-all","display":"-webkit-box","WebkitLineClamp":"3","WebkitBoxOrient":"vertical","overflow":"hidden","white-space":"normal"})
			}
			if(this.options.fontFamily){
				this.element.css("font-family",this.options.fontFamily);
			}
			if(this.options.fontSize){ 
				this.element.css("font-size",this.options.fontSize.replace("px","")*this.s+"rem");  
			}
			if(this.options.lineHeight){ 
				this.element.css("line-height",this.options.lineHeight.replace("px","")*this.s+"rem");  
			}
			if(this.options.text){  
				this.element.html(this.options.text);  
			}
			if(this.options.color){
				this.element.css("color",this.options.color);  
			}
			if(this.options.fontStyle){   
				this.element.css("font-weight", this.options.fontStyle);  
			} 
			if(this.options.fontWeight){
				this.element.css("font-weight", this.options.fontWeight);  
			}
			if(this.options.letterSpacing){
				this.element.css("letter-spacing",this.options.letterSpacing);
			}
		},
		getText:function(){
			return this.element.html();
		},   
		setText:function(text){
			this._text = text;
			this.element.text(text);
		},
		setColor:function(color){
			this.element.css("color",color);
		},
		getLabel:function(){
			return this.element
		},
		//创建控件，控件生命周期内会运行多次
		_create: function () {},
		// 释放控件
		destroy: function () {
			$.Widget.prototype.destroy.call(this);
		}
	});
}) 