/*
 * 容器组件抽象类 
 * Panel描述: 
 *      面板组件多用于组件组合时的载体，提供画线条功能
 *  	面板组件可进行位于面板上的组件管理，相互通信，等功能
 * @Author Zhang  
 * @Date 2019/01/15     
*/
define(['Widget'],function(require, exports){   
    $.widget("ys.Panel",$.ys.Widget,{
		 //初始化，控件生命周期内只运行一次
		 _init: function () {  
			this._nodeElements = []; 
			var relative = this.options.position || "relative";
			this.element.css("position", relative); 
			this.element.css("margin", "0 auto");   
			this._super();
			if(this.options.borderColor){    
				this.setBorderBottom(this.options.borderColor);
			}
			if(this.options.float){
				this.element.css("float", this.options.float); 
			}
			if(this.options.textAlign){
				this.element.css("text-align", this.options.textAlign); 
			}
		 }, 
        //默认参数
        //初始化，控件生命周期内只运行一次
        _create: function () {},
		//设置绝对定位的元素相对window水平居中
		alignSet:function(val){
			if(val == "center")
			this.element.find("> .h-center").each(function(){
				if($(this).css("position") == "absolute"){
					if($(this).hasClass("v-center")){
						if($(this).hasClass("resize-need")){
							var that = this;
							$(this).bind("RESIZE_END",function(){
								$(that).css("top",($(window).height()-$(that).height())/2+"px");
								$(that).css("left",($(window).width()-$(that).width())/2+"px");
								$(that).unbind("RESIZE_END");
							})
						}else{
							$(this).css("top",($(window).height()-$(this).height())/2+"px");
							$(this).css("left",($(window).width()-$(this).width())/2+"px");
						}
						
					}else{
						$(this).css("left",($(window).width()-$(this).width())/2+"px");
					}
				} 
			})  
		},
		//设置背景色
		setBgColor:function(color){
			this.element.css("background",color);  
		},
		//设置背景色
		setBgImg:function(img){ 
			this.element.css({   
				"background-image": "url("+img+")",  
				"background-size":"cover",
				"background-repeat":"no-repeat"
			});
		},
		setTransition:function(transition){
			this.element.css("transition",transition);
		},
		//设置边框角度
		setBorderRadius:function(val){
			this.element.css("border-radius",val);
		},
		//设置边框
		setBorderBottom:function(border){  
			this.element.css("border-bottom",border); 
		},
		//设置边框
		setBorder:function(border){  
			this.element.css("border",border);  
		},
		//修改margin值
		setBorderMargin:function(val){  
			this.element.css("margin",val);
		},
		addElement:function(element){  
			this.element.append(element);
		},
		addClear:function(){
			this.element.append("<div style='clear:both'></div>");
		}
    });
});    