/*
 * 按钮组件抽象类
 * Btn描述:  
 *     简单矩形元素/可点击 
 * 触发BTN_CLICK事件
*/
define(['skinManager','Btn'],function(skinManager,require, exports){
	$.widget("ys.SelectBtn",$.ys.Btn,{
		currentStatus:-2,
		StatusConst:{ON:1,OFF:0,PART:-1,CLOSED:-2},
		on:"/assets/img/appimg/Cloud/pt_touxuan1-2@3x.png",
		off:"/assets/img/appimg/Cloud/pt_touxuan1@3x.png",
		//默认参数
		//初始化，控件生命周期内只运行一次
		_init: function () {
			this._super();  
			this.element.addClass('select').Img({"src":this.off,"width":"9px","height":"9px"});
			
            this.selectImg = this.element.find('img');
			this.selectImg.style({marginLeft:'-4.5px',marginTop:'-4.5px',top:'50%',left:'50%'});

			var css = $.extend({"display":"block","width":"40px","height":"70px","lineHeight":"70px","position":"absolute","right":"0","top":"0"},this.options.css)
			
			this.element.style(css);

			this.element.bind('BTN_CLICK',this,function (e) {
				var _this = e.data;
				_this.element.trigger("BTN_SELECT",{status:_this.currentStatus,$El:_this})
				e.stopPropagation();
				e.preventDefault();
			})
			this.setSelect(this.options.status===undefined ? -2 : this.options.status)
			this.element.append(this.element)
		},
		//获取状态使用的常量
		getStatusConst:function () {
			return this.StatusConst;
		},
		//获取当前状态
		getStatus:function () {
			return this.currentStatus;
		},
		//设置选中状态
		setSelect:function(selectType){
			var Status = this.StatusConst;
            switch (selectType){
				//选中
                case Status.ON:{
                    this.currentStatus = 1;
                    this.element.addClass("selected").Img("setSrc",skinManager.CheckImg('cloud_list_selected_image',this.on));
                    this.selectImg.style({marginLeft:'-9px',marginTop:'-9px',height:'18px',width:'18px','opacity':1});
                    break;
				}
				//部分选中
                case Status.PART:{
                    this.currentStatus = -1;
                    this.element.removeClass("selected").Img("setSrc",skinManager.CheckImg('cloud_list_selected_image',this.on));
                    this.selectImg.style({marginLeft:'-9px',marginTop:'-9px',height:'18px',width:'18px','opacity':0.6});
                    break;
				}
				//关闭可选择状态
                case Status.CLOSED:{
                    this.currentStatus = -2;
                    this.element.removeClass("selected").Img("setSrc",this.off);
                    this.selectImg.style({marginLeft:'-4.5px',marginTop:'-4.5px',height:'9px',width:'9px'});
                    break;
				}
				//未选中
				case Status.OFF:{
                    this.currentStatus = 0;
                    this.element.removeClass("selected").Img("setSrc",this.off);
                    this.selectImg.style({marginLeft:'-9px',marginTop:'-9px',height:'18px',width:'18px','opacity':0.6});
                    break;
                }
            }
        },
		//创建控件，控件生命周期内会运行多次
		_create: function () {},
		// 释放控件
		destroy: function () {
			$.Widget.prototype.destroy.call(this);
		}
	});
})