/*
 * 输入框组件抽象类
*/
define(['Widget','style'],function(require, exports){
    $.widget("ys.Textarea",$.ys.Widget,{
        //默认参数
		_input:null,
		_label:null,
		_isFocus:false,
        //初始化，控件生命周期内只运行一次
        _init: function () {   
			this._super();
			// this.element.css("position","relative");
			this._input = $('<textarea></textarea>');
			if(this.options.maxLen){
				this.setMaxLen(this.options.maxLen)
			}
			if(this.options.style){
                this._input.style(this.options.style)
            }
			this._input.appendTo(this.element);
			this._input.attr('placeholder',this.options.placeholder)
			if(this.options.text){
				this._input.val(this.options.text);
			}
			this._input.bind('focus',this,this._triggerFocus)
			this._input.bind('blur',this,this._triggerBlur)
			this.element.append(this._input)
		},
		_triggerFocus:function(e){
			e.data.element.trigger('TXT_AREA_FOCUS')
		},
		_triggerBlur:function(e){
			e.data.element.trigger('TXT_AREA_BLUR')
		},
		getTextarea:function(){
			return this._input;
		},
		setMaxLen:function(len){
			this._input.attr("maxlength",len);
		},
		setValue:function(val){
			this._input.val(val);
		},
		getValue:function(){
            return this._input.val();
        },
		clearText:function(){
            this._input.val('');
		},
		setFocus:function(){
            this._input.focus()
		},
		setBlur:function(){
            this._input.blur()
		},
		
        //创建控件，控件生命周期内会运行多次
        _create: function () {},
        // 释放控件
        destroy: function () {
            $.Widget.prototype.destroy.call(this);
        }
    });
});  

