define({
    /**
        * 按人类阅读习惯格式化
        * @param {unit:{string},value:{int},point:{int},useUnit:{boolean}} obj 
        */
    human: function human(obj) {
        var size, index = 0, point = 1, negative;
        switch (typeof obj.value) {
            case 'string': {
                size = parseFloat(obj.value);
                if (isNaN(size)) {
                    // console.log("isNaN");
                    return "0B";
                }
                break;
            }
            case 'number': {
                size = obj.value;
                break;
            }
            default: {
                // console.log("不是字符串也不是数字");
                return "0B";
            }
        }
        if(size==0){
            return "0B";
        }else if(size<0){
            return "0B";//容错显示0
            negative = true
            size = Math.abs(size);
        }
        var unitArr = ["B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"];
        if (obj.unit) {//判断起始计算单位
            var start = unitArr.indexOf(obj.unit);
            start > 0 && unitArr.splice(0, start);
            start === 0 && (size = Math.floor(size))
            start = void 0;
        }
        if (typeof obj.point === 'number' && obj.point > -1) {//判断保留小数位数
            point = obj.point;
        }
        
        index = Math.floor(Math.log(size) / Math.log(1024));
        size = size / Math.pow(1024, index);
        if(size % 1 !== 0){//不是整型
            size = size.toFixed(point);//保留的小数位数
        }
        if(negative){
            size = 0- size;
        }
        return obj.useUnit === false ? size : size + unitArr[index];
    },
    /**
     * 将字符串或者按单位转换为整形byte值
     * @param {value:{string|number},unit:{string}} obj 
     */
    byte: function byte(obj) {
        var size, index, unitArr, unit;

        index = 0;

        if (typeof obj.unit === 'string') {
            unit = obj.unit.toUpperCase();
        }

        switch (typeof obj.value) {
            case 'string': {
                var matched = obj.value.match(/(\d+\.?\d*).*([KMGTPEZY]B)/i);
                if (matched && matched.length === 3) {
                    size = matched[1];
                    unit = matched[2].toUpperCase();
                } else {
                    size = parseFloat(obj.value);
                    // console.log("isNaN:" + isNaN(size));
                    return isNaN(size) ? 0 : Math.floor(size);
                }
                break;
            }
            case 'number': {
                size = obj.value;
                break;
            }
            default: {
                // console.log("不是字符串也不是数字");
                return 0;
            }
        }

        unitArr = ["B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"];
        index = unitArr.indexOf(unit);
        size = parseFloat(size);
        if (index < 0) {
            // console.log("没有单位");
            return parseInt(size);
        } else {
            return size * Math.pow(1024, index);
        }
    },
});