/*
 * 鹰硕预览管理器
 */
define(['Shell'],function(Shell){
	var YsPreviewManager = {
		"pageName":null,
		"currUUID":null, //当前uuid
		"currExt":null, //该文件后缀
		"currDownloadUrl":null, //当前文件的下载地址
		"currDownloadTaskID":null, //下载任务id
		"previewTaskID":null, //预览任务id
		"preview_type":null, //预览方式 uuid或url
		"storge_check_download_enable_url":null, //检测是否可下载接口
		"storge_download_task_begin_url":null, //下载任务投递接口
		"storge_download_task_check_url":null, //下载任务检测接口
		"preview_task_begin_url":null,//预览任务投递接口
		"preview_task_check_url":null,//预览任务检测接口
		"preview_task_result_url":null,//最终预览地址
		"successCallback":null, //成功回调
		"errorCallback":null, //失败回调
		"ajaxInstance":null, //ajax单例
		"tId":0,
		"queue":[],
		 //初始化
		"Init":function(pageName,preview_type, storge_check_download_enable_url, storge_download_task_begin_url,storge_download_task_check_url,preview_task_begin_url,preview_task_check_url,successCallback,errorCallback){
			YsPreviewManager.pageName = pageName;
			YsPreviewManager.preview_type = preview_type; //预览类型uuid或url
			YsPreviewManager.storge_check_download_enable_url = storge_check_download_enable_url; //检测文件是否能够下载地址
			YsPreviewManager.storge_download_task_begin_url = storge_download_task_begin_url; //下载任务投递地址
			YsPreviewManager.storge_download_task_check_url = storge_download_task_check_url; //下载任务检测地址
			YsPreviewManager.preview_task_begin_url = preview_task_begin_url; //预览任务投递接口
			YsPreviewManager.preview_task_check_url = preview_task_check_url;
			YsPreviewManager.successCallback = successCallback;
			YsPreviewManager.errorCallback = errorCallback;
		},
		"abortAjax":function(){
			if(YsPreviewManager.ajaxInstance != null){
				YsPreviewManager.ajaxInstance.abort();
				YsPreviewManager.ajaxInstance = null;
			}
		},
		"SwapUrlWithUUID":function(uuid,ext){
			YsPreviewManager.queue.push({"uuid":uuid});
			if(YsPreviewManager.ajaxInstance != null){
				YsPreviewManager.ajaxInstance.abort();
				YsPreviewManager.ajaxInstance = null;
			}
			YsPreviewManager.currUUID = uuid;
			YsPreviewManager.currExt = ext;
			if(YsPreviewManager.preview_type == "url"){
				var checkDownloadEnable = YsPreviewManager.getData(YsPreviewManager.storge_check_download_enable_url+ret.value.uuid);
				if(checkDownloadEnable.code == 1 && checkDownloadEnable.data.status ){ //判断到可以下载
					YsPreviewManager.createDownloadTask(uuid); //创建下载任务,获取文件临时下载地址
				}else{
					YsPreviewManager.queue.shift();
					var errorObj = {"error":"该文件无法下载,文件还未同步完成","code":100};
					YsPreviewManager.errorCallback(errorObj);
				}
			}else{
				YsPreviewManager.createPreviewTask(uuid);
			}
		},
		"createDownloadTask":function(lastuuid){
			var download = YsPreviewManager.getData(YsPreviewManager.storge_download_task_begin_url+'relation=[{"name":"预览临时文件4","isdir":0,"fileinfo_id":"'+YsPreviewManager.currUUID+'","pid":0,"uuid":1}]');
			if(download.code == 1 && download.data.status != "finish"){
				YsPreviewManager.currDownloadTaskID = download.data.id;
				YsPreviewManager.tId = setTimeout(function(){
					YsPreviewManager.checkDownloadTask(lastuuid);
				},100);
			}else if(download.code == 1 && download.data.status == "finish"){
				YsPreviewManager.currDownloadUrl = download.data.url;
				YsPreviewManager.createPreviewTask(lastuuid); //投递预览任务
			}else{
				YsPreviewManager.queue.shift();
				var errorObj = {"error":"下载任务无法投递","code":101};
				YsPreviewManager.errorCallback(errorObj);
			}
		},
		//检测下载任务
		"checkDownloadTask":function(lastuuid){
			var download = YsPreviewManager.getData(YsPreviewManager.storge_download_task_check_url+YsPreviewManager.currDownloadTaskID);
			if(download.code != 1 || download.data.status != "finish"){
				YsPreviewManager.tId = setTimeout(function(){
					YsPreviewManager.checkDownloadTask(lastuuid);
				},100); // 5000
			}else{
				YsPreviewManager.currDownloadUrl = download.data.url;
				YsPreviewManager.createPreviewTask(lastuuid); //投递预览任务
			}
		},
		"createPreviewTask":function(lastuuid){
			if(YsPreviewManager.preview_type == "url"){ //url方式投递下载任务
				var previewTask = YsPreviewManager.getData(YsPreviewManager.preview_task_begin_url+"ext="+YsPreviewManager.currExt+"&url="+YsPreviewManager.currDownloadUrl);
			}else{ //uuid方式投递下载任务
				var previewTask = YsPreviewManager.getData(YsPreviewManager.preview_task_begin_url+"ext="+YsPreviewManager.currExt+"&uuid="+YsPreviewManager.currUUID);
			}
			if(previewTask.code == 1 && previewTask.data.taskId){
				YsPreviewManager.previewTaskID = previewTask.data.taskId;
				YsPreviewManager.tId = setTimeout(function(){
					YsPreviewManager.checkPreviewTask(lastuuid); //检测预览任务
				},100);
			}else{
				YsPreviewManager.queue.shift();
				var errorObj = {"error":"预览任务无法投递","code":102};
				YsPreviewManager.errorCallback(errorObj);
			}
		},
		"checkPreviewTask":function(lastuuid){
			var previewTask = YsPreviewManager.getData(YsPreviewManager.preview_task_check_url+YsPreviewManager.previewTaskID);
			if(previewTask.code != 1 || !previewTask.data.complete){
				YsPreviewManager.tId = setTimeout(function(){
					YsPreviewManager.checkPreviewTask(lastuuid);
				},100); //5000
			}else{
				//取fileURL
				var u = navigator.userAgent;
				var isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
				var sendUrl;
				// 0712 去掉ios判断
				if(YsPreviewManager.currExt == "pdf"){
					sendUrl = previewTask.data.url;
				}else{ //ios
					sendUrl = previewTask.data.fileURL;
				}
				YsPreviewManager.preview_task_result_url = sendUrl; //fileURL原始路径
				var successObj = {"url":YsPreviewManager.preview_task_result_url,"code":1};
				if(YsPreviewManager.queue.length == 1){
					YsPreviewManager.queue.shift();
					YsPreviewManager.successCallback(successObj);
				}else{
					YsPreviewManager.queue.shift();
				}
			}
		},
		"getData":function(url){
			var retObj = {};
			YsPreviewManager.ajaxInstance = $.ajax({
				"url":url,
				"type":"get",
				"async":false,
				"dataType":"json",
				"success":function(ret){
					retObj = ret;
				},
				"error":function(ret){
					retObj.code = 0;
				}
			});
			return retObj;
		}
	}
	return YsPreviewManager;
});
