/*
*   2020年12月3日
*   
*   党建本cell组件
*
*   开发者：薛原 
*/
define(["Cell","BaseBtn","Img","ImgBtn","DownMenu"],function(){
	var rand;
    $.widget("ys.BookCell",$.ys.Cell,{
        //默认参数
        options:{},
		//改变标题
		changeTitle:function(title){
			this.options.name = title;
			this.element.find(".book-title").Label("setText",title);
		},
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
			var that = this;
			this.element.attr("data-id",this.options.uuid);
			this.element.attr("data-active",this.options.locked);
			this.element.attr("data-type",this.options.type);
			this.element.attr("data-more-click","on");
			rand = parseInt(Math.random()*10000000);
			this.setWidth("100%");
			this.setHeight("183px");
			this.css("position","relative");
			this.element.css("border-bottom","1px solid #EAEFF2");
			var img;
			img = "../djcommon/img/note/book_"+this.options.type+".png";
			var coverImg = $("<div></div>").Img({"src":img,"width":"106px","height":"145px"});
			coverImg.bind("click",this,this.onBookClick);
			coverImg.css("position","absolute");
			coverImg.Img("setLeft","14px");
			coverImg.Img("setTop","16px");
			this.element.append(coverImg);
			
			// var text = $("<div class='text' style='display:flex;align-items:center;justify-content:center;'></div>").Label({"fontSize":"12px","width":"55px","height":"20px","text":parseInt(this.options.locked)==1?"已启用":"已锁定","color":"#ffffff"});
			// text.css("border-radius","3rem");
			// text.css("background","rgba(200, 33, 40, 0.7)");
			// text.css("position","absolute");
			// text.Label("setLeft","62px");
			// text.Label("setTop","20px");
			// this.element.append(text);

			var str = parseInt(this.options.locked)==1?"已启用":"已锁定";
			var text = $("<div class='text'>"+str+"</div>").appendTo(this.element);
			text.css({
				"width":"3.4375rem",
				"font-size":"0.75rem",
				"color":"#CF000F",
				"background":"#ffffff",
				"border-radius":"1rem",
				"text-align":"center",
				"padding":"0.1875rem 0 0.0625rem 0",
				"box-sizing":"border-box",
				"position":"absolute",
				"top":"1.25rem",
				"left":"4rem",
				"transform":"scale(0.8,0.8)"
			});
			if(parseInt(this.options.locked) == 0){
				text.css("background","rgba(0,0,0,0.2)");
				text.css("color","#ffffff");
			}
			
			var mainText = $("<div class='mainText book-title'></div>").Label({"text":this.options.name,"fontSize":"15px","fontWeight":"600"});
			mainText.css("position","absolute");
			mainText.Label("setLeft","135px");
			mainText.Label("setTop","14px");
			this.element.append(mainText);
			
			var secText = $("<div class='secText'></div>").Label({"text":this.options.status,"fontSize":"12px","color":"#999999"});
			secText.css("position","absolute");
			secText.Label("setLeft","135px");
			secText.Label("setTop","49px");
			this.element.append(secText);
			
			var thrText = $("<div class='thrText'></div>").Label({"text":"上次书写时间："+this.options.lastWriteTime,"fontSize":"12px","color":"#999999"});
			thrText.css("position","absolute");
			thrText.Label("setLeft","135px");
			thrText.Label("setTop","80px");
			this.element.append(thrText);
			
			if(this.options.locked == 1){
				var dealBtn = $("<div class='deal'></div>").ImgBtn({"src":"../djcommon/img/note/book-do-lock.png","width":"32px","height":"32px"});
			}else{
				var dealBtn = $("<div class='deal'></div>").ImgBtn({"src":"../djcommon/img/note/book-do-unlock.png","width":"32px","height":"32px"});
			}
			dealBtn.bind("BTN_CLICK",function(e){
				if(parseInt(that.options.locked) == 1){
					that.element.trigger("LOCK",{"uuid":that.element.attr("data-id"),"type":that.options.type});
				}else{
					that.element.trigger("UNLOCK",{"uuid":that.element.attr("data-id")});
				}
			});
			dealBtn.css("position","absolute");
			dealBtn.ImgBtn("setLeft","135px");
			dealBtn.ImgBtn("setTop","130px");
			this.element.append(dealBtn);
			
			var shareBtn = $("<div></div>").ImgBtn({"src":"../djcommon/img/note/book-share.png","width":"32px","height":"32px"});
			shareBtn.css("position","absolute");
			shareBtn.ImgBtn("setLeft","175px");
			shareBtn.ImgBtn("setTop","130px");
			this.element.append(shareBtn);
			shareBtn.bind("BTN_CLICK",function(e){
				that.element.trigger("RENAME",{"uuid":that.element.attr("data-id"),"name":that.options.name});
			});
			
			var moreBtn = $("<div class='moreBtn'></div>").ImgBtn({"src":"../djcommon/img/note/book-more.png","width":"32px","height":"32px"});
			moreBtn.find("img").addClass("moreBtn"+rand);
			moreBtn.attr("data-status","hide");
			moreBtn.css("position","absolute");
			moreBtn.ImgBtn("setLeft","215px");
			moreBtn.ImgBtn("setTop","130px");
			this.element.append(moreBtn);
			moreBtn.bind("BTN_CLICK",this,this.onMoreBtnClick);
			
		},
		onBookClick:function(e){
			e.data.element.trigger("BOOK_CLICK",{"uuid":e.data.options.uuid,"type":e.data.options.type});
		},
		setLastWriteTime:function(time){
			this.element.find(".thrText").Label("setText","上次书写时间："+time);
		},
		setSecText:function(val){
			this.element.find(".secText").Label("setText",val);
		},
		setLastWriteTime:function(time){
			this.element.find(".thrText").Label("setText","上次书写时间："+time);
		},
		setBookLock:function(){
			this.options.locked = 0;
			// this.element.find(".text").Label("setText","已锁定");
			this.element.find(".text").html("已锁定");
			this.element.find(".text").css("background","rgba(0,0,0,0.2)");
			this.element.find(".text").css("color","#ffffff");
			this.element.attr("data-active",this.options.locked);
			this.element.find(".deal").ImgBtn("changeImgSrc","../djcommon/img/note/book-do-unlock.png");
		},
		setBookUnLock:function(){
			this.options.locked = 1;
			this.element.find(".text").css("background","#fff");
			this.element.find(".text").css("color","#CF000F");
			// this.element.find(".text").Label("setText","已启用");
			this.element.find(".text").html("已启用");
			this.element.attr("data-active",this.options.locked);
			this.element.find(".deal").ImgBtn("changeImgSrc","../djcommon/img/note/book-do-lock.png");
		},
		onMoreBtnClick:function(e){
			var that = e.data;
			if(e.data.element.attr("data-more-click") != "on"){
				return;
			}
			if(e.data.element.find(".moreBtn").attr("data-status") == "show"){
		        return;
			}
			var pos = e.data.element.find(".moreBtn").offset();
			if(e.data.options.locked == 1){
				that.element.trigger("DEAL",{"options":1,"uuid":that.element.attr("data-id")});
			}else{
				that.element.trigger("DEAL",{"options":2,"uuid":that.element.attr("data-id")});
			}
		},
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});