/*
*   2020年12月2日
*   
*   本子轮播插件
*
*   开发者：薛原 
*/
define(["swiper","Label","ImgBtn"],function(Swiper){
	var paginationArea;
	var clickLock = false;
    $.widget("ys.BookSlider",{
        //默认参数
        options:{},
		changeBookName:function(data){
			this.element.find("[data-id='"+data.uuid+"']").Label("setText",data.name);
		},
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
			var that = this;
            nameLabel = $("<div></div>").Label({"fontSize":"20px","width":"100%","height":"auto","textAlign":"center","fontWeight":"800"});
			
			var swiperPanel  = $('<div class="swiper-container"></div>');
			var swiperBox = $('<div class="swiper-wrapper swiperBox"></div>');
			swiperPanel.append(swiperBox);
			this.element.css("opacity",0);
			for(var i=0;i<this.options.bookData.length;i++){
				var one = $("<div id='slide"+this.options.bookData[i].uuid+"' class='swiper-slide'></div>").Panel();
				
				var nameLabel = $("<div class='nameLabel'></div>").Label({"fontSize":"20px","width":"100%","height":"auto","textAlign":"center","fontWeight":"800"});
				nameLabel.attr("data-id",this.options.bookData[i].uuid);
				nameLabel.css("opacity",0);
				nameLabel.Label("setText",this.options.bookData[i].name);
				nameLabel.Label("setPaddingTop","20px");
				nameLabel.Label("setPaddingBottom","20px");
				one.css("position","relative");
				one.css("width","375px");
				one.css("padding-left","70.5px");
				one.css("padding-right","70.5px");
				
				if(this.options.bookData[i].type == 0){
					var bookCover = $("<div class='bookCard'></div>").Img({"src":"../djcommon/img/note/book_add.png","width":"100%","height":"auto"});
					bookCover.bind("READY",function(){
					   that.element.css("opacity",1);
					   $(".bookCard").css("width",$(this).find("img").width()+"px");
					   $(".bookCard").css("height",$(this).find("img").height()+"px");
					   paginationArea.show();
					   $(".swiper-wrapper").css("margin-top",($(window).height()-that.element.offset().top-$(".swiper-wrapper").height() )/2+"px" );
					   $(".nameLabel").css("opacity",1);
					})
					bookCover.bind("click",this,this.onCreateBookBtnClick);
					bookCover.find("img").addClass("addImg");
				}else{
					var bookCover = $("<div class='bookCard'></div>").Img({"src":"../djcommon/img/note/book_"+this.options.bookData[i].type+".png","width":"100%","height":"auto"});
					bookCover.attr("book-id",this.options.bookData[i].uuid);
					bookCover.attr("book-type",this.options.bookData[i].bookType);
					bookCover.bind("click",this,this.onEnterBookBtnClick);
				}
				//bookCover.Img("setBottom","0px");
				one.append(nameLabel);
				one.append(bookCover);
				
				
				var textPanel = $("<div class='status-label'></div>").Panel({"width":"55px","height":"22px"});
				textPanel.css("border-radius","3rem");
				textPanel.css("position","absolute");
				textPanel.Panel("setTop","75px");
				textPanel.css({"display":"flex","align-items":"center","justify-content":"center","transform":"scale(0.8,0.8)"});
				if(this.options.bookData[i].type != 0){
					textPanel.html(this.options.bookData[i].status);
					if(this.options.bookData[i].status == "已启用"){
						// var text = $("<div></div>").Label({"fontSize":"13px","width":"auto","height":"auto","textAlign":"center","text":this.options.bookData[i].status,"color":"#CF000F"});
						textPanel.Panel("setBgColor","#ffffff");
						textPanel.css("color","#CF000F");
					}else{
						// var text = $("<div></div>").Label({"fontSize":"13px","width":"auto","height":"auto","textAlign":"center","text":this.options.bookData[i].status,"color":"#ffffff"});
						textPanel.Panel("setBgColor","rgba(0,0,0,0.3)");
						textPanel.css("color","#fff");
					}
					// text.css("font-family","-apple-system-font, sans-serif");
					// textPanel.append(text);
					one.append(textPanel);
				}
				one.append("<div style='height:100px'></div>");
				swiperBox.append(one);
				
			}
			this.element.append(swiperPanel);
			paginationArea = $('<ul class="swiper-pagination"></ul>');
			paginationArea.css("min-width","80px");
			paginationArea.css("height","50px");
			swiperPanel.append(paginationArea);
			//分页器逻辑
			var paginationPoint = $("<li></li>");
			paginationPoint.css({"width":"10px","height":"10px","border-radius":"5px","background":"#D4D2D2","margin-left":"5px","margin-right":"5px","float":"left"});
			paginationArea.hide();
			paginationArea.css("margin","0px auto");
			
        },
		onCreateBookBtnClick:function(e){
			e.data.element.trigger("CREATE_BOOK_BTN_CLICK");
		},
		onEnterBookBtnClick:function(e){
			if(clickLock == true){
				return;
			}
			clickLock = true;
			setTimeout(function(){
				clickLock = false;
			},1000);
			e.data.element.trigger("ENTER_BOOK_BTN_CLICK",{"bookId":$(this).attr("book-id"),"bookType":$(this).attr("book-type")});
		},
        init:function(){
			//return;
			var that = this;
			var swiper = new Swiper('.swiper-container', {
			setWrapperSize :true,
				on: {
					init: function(swiper){
						if(that.options.bookData.length == 1){
							that.element.find(".swiper-slide").css("margin-left","0%");
							that.element.find(".swiper-pagination").css("opacity",0);
						}else{
							that.element.find(".swiper-pagination").css("opacity",1);
						}
						$(".status-label").css("right",parseInt($($(".swiper-slide")[0]).css("padding-right").replace("px",""))+4+"px");
					}
				},
				slidesPerView: 'auto',
				centeredSlides: true,
				pagination: {
				    el: '.swiper-pagination',
				    dynamicBullets: true,
			    },
				//freeModeMomentum:true,
				//freeModeSticky:true,
				//freeModeMomentumRatio:0.3,
				freeMode : false,
				speed:300,
				//freeModeFluid : true,
				//simulateTouch:false
			});
			window.swiper = swiper;
			
		},
		//改变滑块的位置
		changeSildePosition:function(id){
			$(".swiperBox").prepend($("#slide"+id));
		},
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});