/*
*   2020年12月17日
*   
*   封装云空间手机端文档转换弹窗组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.ChangeMask",{
        //默认参数
        options:{
            title:"转换中",//头部提示语
            text:"转换需要一定时间，请耐心等待",//文本提示
            btnText:"取消转换",//取消按钮提示
            total:0,//数据总数
            isSignOut:true,//是否需要退出组件
        },
        _isClick:true,//防止多次点击
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            this.element.css({
                "width":"100%",
                "height":"100%",
                "position":"absolute",
                "top":"0",
                "left":"0",
                "transition":"all 0.3s",
                "opacity":"0",
                "display":"flex",
                "justify-content":"center",
                "align-items":"center"
            });
            //创建弹窗内容容器 transition:all 0.3s;transform:scale(0.5,0.5);
            this._contentContainer = $("<div style='width:3rem;transition:all 0.3s;transform:scale(0.5,0.5);box-shadow:rgba(0, 0, 0, 0.08) 1px 0.03rem 0.13rem 0.03rem;padding:0.3rem 0.2rem 0.2rem 0.2rem;box-sizing:border-box;background:#fff;border-radius:0.09rem;'></div>").appendTo(this.element);
            //创建弹窗头部组件
            this._headContainer = $("<div style='width:100%;text-align:center;font-size:0.16rem;font-weight:bold;'>"+this.options.title+"</div>").appendTo(this._contentContainer);
            //创建提示语
            this._tipsTitle = $("<p style='width:100%;font-size:0.12rem;color:#999;text-align:center;margin-top:0.2rem;'>"+this.options.text+"</p>").appendTo(this._contentContainer);
            //创建进度条元素
            var speedContainer = $("<div style='width:100%;display:flex;flex-direction:row;align-items:center;margin-top:0.1rem;'></div>").appendTo(this._contentContainer);
            this._speed = $("<div style='height:5px;background:#F3F3F3;border-radius:3px;'><div style='width:0px;height:100%;background:#1CB86A;border-radius:3px;'></div></div>").appendTo(speedContainer);
            this._timeContainer = $("<div style='margin:0 0 0 0.1rem;'></div>").appendTo(speedContainer);
            $("<img style='width:0.18rem;height:0.18rem;display:none;' src='"+skinConfig(global.skin).shllWebIon+"select_i.png'/>").appendTo(this._timeContainer);
            $("<span style='font-size:0.12rem;color:#999;'>0%</span>").appendTo(this._timeContainer);
            this._speed.css("width",speedContainer.width() - this._timeContainer.outerWidth(true) + "px");
            //创建取消转换操作容器
            this._canceContainer = $("<div style='width:100%;margin-top:0.32rem;display:flex;flex-direction:row;justify-content:center;'></div>").appendTo(this._contentContainer);
            this._canceltareBtn = $("<div style='width:1.18rem;height:0.4rem;background:#f3f3f3;border-radius:20px;font-size:0.16rem;font-weight:bold;color:#727272;line-height:0.4rem;text-align:center;'>取消转换</div>").appendTo(this._canceContainer);
            //创建取消和重新转换操作按钮容器
            this._againContainer =  $("<div style='width:100%;margin-top:0.32rem;display:none;flex-direction:row;justify-content:space-between;'></div>").appendTo(this._contentContainer);
            this._cancelBtn = $("<div style='width:1.18rem;height:0.4rem;background:#f3f3f3;border-radius:20px;font-size:0.16rem;font-weight:bold;color:#727272;line-height:0.4rem;text-align:center;'>取消</div>").appendTo(this._againContainer);
            this._againBtn = $("<div style='width:1.18rem;height:0.4rem;background:linear-gradient(90deg, #CF000F 0%, #E50414 100%);border-radius:20px;font-size:0.16rem;font-weight:bold;color:#727272;line-height:0.4rem;text-align:center;color:#fff;'>重新转换</div>").appendTo(this._againContainer);
            //创建成功操作容器
            this._successContainer = $("<div style='width:100%;margin-top:0.32rem;display:none;flex-direction:row;justify-content:space-between;'></div>").appendTo(this._contentContainer);
            this._successBtn = $("<div style='width:1.18rem;height:0.4rem;background:#f3f3f3;border-radius:20px;font-size:0.16rem;font-weight:bold;color:#727272;line-height:0.4rem;text-align:center;'>返回列表</div>").appendTo(this._successContainer);
            this._seeBtn = $("<div style='width:1.18rem;height:0.4rem;background:linear-gradient(90deg, #CF000F 0%, #E50414 100%);border-radius:20px;font-size:0.16rem;font-weight:bold;color:#727272;line-height:0.4rem;text-align:center;color:#fff;'>立即查看</div>").appendTo(this._successContainer);

            //给取消转换绑定点击事件
            this._canceltareBtn.bind("click",this,this._canceltareBtnClick);
            //给取消按钮绑定点击事件
            this._cancelBtn.bind("click",this,this._cancelBtnClick);
            //给重新转换按钮绑定点击事件
            this._againBtn.bind("click",this,this._againBtnClick);
            //给返回列表按钮绑定点击事件
            this._successBtn.bind("click",this,this._successBtnClick);
            //给立即查看按钮绑定点击事件
            this._seeBtn.bind("click",this,this._seeBtnClick);
            //取消转换按钮按下抬起效果
            this._btnTextCommon(this._canceltareBtn);
            //取消按钮按下抬起效果
            this._btnTextCommon(this._cancelBtn);
            //重新转换按钮按下抬起效果
            this._btnTextCommon(this._againBtn);
            //返回列表按钮按下抬起效果
            this._btnTextCommon(this._successBtn);
            //立即按钮按下抬起效果
            this._btnTextCommon(this._seeBtn);
        },
        //初始化主动执行
        _init:function(){
            this._isClick = true;
            setTimeout(function(that){
                that.element.css("opacity","1");
                that._contentContainer.css("transform","scale(1,1)");
            },10,this);
        },
        //点击取消转换按钮
        _canceltareBtnClick:function(event){
            //判断防止多次执行
            if(event.data._isClick){
                if(event.data.options.isSignOut){
                    event.data._isClick = false;
                    event.data.element.css("opacity","0");
                    event.data._contentContainer.css("transform","scale(0.5,0.5)");
                    setTimeout(function(){
                        event.data.destroy();
                    },310);
                }
                event.data.element.trigger("CANCELTARE_BTN_CLICK");//抛出取消转换事件
            }
        },
        //点击取消按钮
        _cancelBtnClick:function(event){
            //判断防止多次执行
            if(event.data._isClick){
                event.data._isClick = false;
                event.data.element.css("opacity","0");
                event.data._contentContainer.css("transform","scale(0.5,0.5)");
                event.data.element.trigger("CANCEL_BTN_CLICK");//抛出取消事件
                setTimeout(function(){
                    event.data.destroy();
                },310);
            }
        },
        //点击重新转换
        _againBtnClick:function(event){
            //判断防止多次执行
            if(event.data._isClick){
                event.data._isClick = false;
                event.data._headContainer.html("转换中");//重置头部title文字
                event.data._tipsTitle.html("转换需要一定时间，请耐心等待");//重置转换提示文字
                event.data._speed.children("div").css({"width":0,"background":"#1CB86A"});//改变进度条宽度和颜色
                event.data._timeContainer.css("margin","0 0 0 0.1rem");//重置转换中进度条样式
                event.data._timeContainer.children("img").css("display","none");//隐藏错误图标
                event.data._timeContainer.children("span").html("0%").css("display","");//隐藏错误图标
                event.data._againContainer.css("display","none");//隐藏取消和重新转换操作按钮容器
                event.data._canceContainer.css("display","flex");//显示取消转换操作按钮容器
                event.data.element.trigger("AGAIN_BTN_CLICK");//抛出重新转换事件
            }
        },
        //点击返回列表按钮
        _successBtnClick:function(event){
            //判断防止多次执行
            if(event.data._isClick){
                event.data._isClick = false;
                event.data.element.css("opacity","0");
                event.data._contentContainer.css("transform","scale(0.5,0.5)");
                event.data.element.trigger("SUCCESS_BTN_CLICK");//抛出我知道到了事件
                setTimeout(function(){
                    event.data.destroy();
                },310);
            }
        },
        //点击立即查看按钮
        _seeBtnClick:function(event){
            //判断防止多次执行
            if(event.data._isClick){
                event.data._isClick = false;
                event.data.element.css("opacity","0");
                event.data._contentContainer.css("transform","scale(0.5,0.5)");
                event.data.element.trigger("SEE_BTN_CLICK");//抛出立即查看事件
                setTimeout(function(){
                    event.data.destroy();
                },310);
            }
        },
        //元素按下抬起效果
        _btnTextCommon:function(element){
            //给选项绑定手指按下事件
            element.bind('touchstart',function(){
                $(this).css("opacity","0.5");
            });
            //给选项绑定手指抬起事件
            element.bind('touchend',function(){
                $(this).css("opacity","");
            });
        },
        //转换失败方法
        taealFail:function(txet){
            this._isClick = true;
            this._headContainer.html("转换失败");//设置title文字
            if(txet != null && txet != undefined && txet != ""){
                this._tipsTitle.html(txet);//设置失败错误提示语
            }else{
                this._tipsTitle.html("服务开小差了，请稍后再试...");//设置失败错误提示语
            }
            this._speed.children("div").css("background","#CF000F");//改变进度条的颜色
            this._timeContainer.css("margin","0.05rem 0 0 0.1rem");//改变进度条样式
            this._timeContainer.children("span").css("display","none");//隐藏百分比提示
            this._timeContainer.children("img").attr("src",skinConfig(global.skin).shllWebIon + "coles.png").css("display","");//显示错误提示
            this._canceContainer.css("display","none");//隐藏取消转换操作按钮容器
            this._againContainer.css("display","flex");//显示取消和重新转换操作容器
        },
        //转换成功方法
        successFun:function(txet){
            this._isClick = true;
            this._headContainer.html("转换成功");//设置title文字
            if(txet != null && txet != undefined && txet != ""){
                this._tipsTitle.html(txet);//设置提示语
            }else{
                this._tipsTitle.html("存储位置：云盘-保险箱");//设置提示语
            }
            this._timeContainer.css("margin","0.05rem 0 0 0.1rem");//改变进度条样式
            this._timeContainer.children("span").css("display","none");//隐藏百分比提示
            this._timeContainer.children("img").attr("src",skinConfig(global.skin).shllWebIon + "select_i.png").css("display","");//显示成功图标
            this._canceContainer.css("display","none");//隐藏取消转换操作按钮容器
            this._successContainer.css("display","flex");//显示成功操作按钮容器
        },
        //转换成功方法
        successFunEs:function(txet){
            this._isClick = true;
            this._headContainer.html("转换成功");//设置title文字
            if(txet != null && txet != undefined && txet != ""){
                this._tipsTitle.html(txet);//设置提示语
            }else{
                this._tipsTitle.html("存储位置：云盘-保险箱");//设置提示语
            }
            this._timeContainer.css("margin","0.05rem 0 0 0.1rem");//改变进度条样式
            this._timeContainer.children("span").css("display","none");//隐藏百分比提示
            this._timeContainer.children("img").attr("src",skinConfig(global.skin).shllWebIon + "select_i.png").css("display","");//显示成功图标
            this._canceContainer.css("display","none");//隐藏取消转换操作按钮容器
            // this._successContainer.css("display","flex");//显示成功操作按钮容器
        },
        //设置进度条方法
        setSpeed:function(numm){
            this._speed.children("div").css("width",numm);//设置进度条的宽度
            this._timeContainer.children("span").html(numm);//设置进度的百分比
        },
        //关闭弹窗方法
        closMask:function(){
            // this.element.css("opacity","0");
            this.element.fadeTo("fast",0);
            // this._contentContainer.css("transform","scale(0.5,0.5)");
            this.element.trigger("CANCELTARE_BTN_CLICK");//抛出取消转换事件
            setTimeout(function(that){
                that.destroy();
            },310,this);
        },
        //设置进度条方法
        setSpeedBatch:function(obj){
            // this._speed.children("div").css("width",numm);//设置进度条的宽度
            // this._timeContainer.children("span").html(numm);//设置进度的百分比
          
            var that = this;
            var everyWidth = ((1/this.options.total)*100).toFixed(2);//计算每次前进宽度百分比
            var num = Math.ceil((this.options.total - obj.arr.length)*everyWidth);
           
            //判断任务未完成时，进度条超出
            if(obj.arr.length != 0 && num >= 100){
                num = 99;
            }
            if(obj.arr.length == 0){
                num = 100;
            }
            this._speed.children("div").css("width", num + "%");
            this._timeContainer.children("span").html(num + "%");
        },
        //提供一个退出弹框的方法
        closeMsk:function(){
            var that = this;
            that.element.css("opacity","0");
            that._contentContainer.css("transform","scale(0.5,0.5)");
            setTimeout(function(){
                that.destroy();
            },310);
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
            this.element.remove();
        }
    });
});