/*
*   2020年11月16日
*
*   封装云空间手机端通用添加组件
*
*   开发者：付长建
*/
define(["Shell","CommonAddPanel"],function(Shell){
    $.widget("ys.CommonAdd",{
        //默认参数
        options:{
            title:"个人空间",//个人空间
            newAndSpace:{},//消息数量和空间容量
            pid:0,//新建需要使用的pid
            selectUrl:"",//壳上的选择文件目录页面
            uploadUrl:"",//壳上的上传接口
            menuData:[],//上传panel操作菜单
        },
        _isClick:true,//防止李勇不停的骚操作
        //创建控件，控件生命周期内会运行多次
        _create:function(){
            if(this.options.menuData.length == 0){
                alert("必须传入上传panel组件需要的底部操作菜单");
                return;
            }
            var that = this;
            // var padBottom = phonexh("bottom") == 0 ? 130 : phonexh("bottom") + 90;
            // var top = $("body").height() - padBottom;
            this.element.css({"z-index":"1","position":"absolute","bottom":"50px","right":"0.05rem","transition":"all 0.3s"});
            $("<img style='width:0.7rem;height:0.7rem;' src='"+skinConfig(global.skin).shllWebIon+"upload_icon.png'/>").appendTo(this.element);
            this.element.attr("isShow","yes");//表示添加组件是显示状态
            //给添加组件绑定点击事件
            this.element.bind("click",this,this._addClick);
            //添加按钮按下抬起效果
            this._btnTextCommon(this.element);
        },
        //点击添加按钮组件
        _addClick:function(event){
            if(event.data._isClick){
                event.data._isClick = false;//禁止点击添加按钮
                $("#bottonMenuContainer").css("opacity","0");
                Shell.sendEvent("hideTabBar",{"hide":true});//隐藏底部导航栏
                //初始化上传添加panel组件
                var commonPanelContainer = $("<div id='addPanel' style='z-index:1;width:100%;height:100%;background:#fff;opacity:0;'></div>").appendTo($("body"));
                commonPanelContainer.CommonAddPanel({
                    "menuData":event.data.options.menuData,//操作菜单
                    "newAndSpace":event.data.options.newAndSpace//消息数量和空间容量
                });
                //监听上传panel组件点击了关闭图标事件
                commonPanelContainer.bind("ADD_PANEL_CANCEL",function(){
                    Shell.sendEvent("hideTabBar",{"hide":false});//显示底部导航栏
                    $("#bottonMenuContainer").css("opacity","1");
                    setTimeout(function(){
                        event.data._isClick = true;//允许点击添加按钮
                    },500);
                });
                //监听操作按钮点击
                commonPanelContainer.bind("OPTION_CLICK",function(e,type){
                    commonPanelContainer.CommonAddPanel("closePanel");//关闭上传panel组件
                    Shell.sendEvent("hideTabBar",{"hide":false});//显示底部导航栏
                    //上传事件参数（原生需要的参数）
                    var upload = {
                        "name":event.data.options.title,//上传到那个空间
                        "selectUrl":event.data.options.selectUrl,
                        "uploadUrl":event.data.options.uploadUrl,
                        "param":{
                            "pid":event.data.options.pid,
                        },
                    };
                    //判读点击了什么按钮
                    if(type == "newDoc"){//文档
                        Shell.sendEvent("openWin",{"url":"/djmyspacenewdoc/index.html?token="+getUrl("token")+"&cloudToken="+getUrl("cloudToken")+"&pid="+event.data.options.pid,"open_type":true,"title":"新建文档"});
                    }else if(type == "newTable"){//表格
                        Shell.sendEvent("openWin",{"url":"/djmyspacenewtable/index.html?token="+getUrl("token")+"&cloudToken="+getUrl("cloudToken")+"&pid="+event.data.options.pid,"open_type":true,"title":"新建表格"});
                    }else if(type == "newSlide"){//幻灯片
                        Shell.sendEvent("openWin",{"url":"/djmyspacenewppt/index.html?token="+getUrl("token")+"&cloudToken="+getUrl("cloudToken")+"&pid="+event.data.options.pid,"open_type":true,"title":"新建幻灯片"});
                    }else if(type == "newFolder"){//文件夹
                        Shell.sendEvent("openWin",{"url":"/djmyspacenewfolder/index.html?token="+getUrl("token")+"&cloudToken="+getUrl("cloudToken")+"&pid="+event.data.options.pid,"open_type":true,"title":"新建文件夹"});
                    }else if(type == "uploadImg"){
                        upload.type = "Image";
                        Shell.sendEvent("updateImageOrVideo",upload);
                    }else if(type == "uploadVideo"){
                        upload.type = "Video";
                        Shell.sendEvent("updateImageOrVideo",upload);
                    }else if(type == "photograph"){
                        upload.type = "photograph";
                        Shell.sendEvent("updateImageOrVideo",upload);
                    }
                });
            }
        },
        //所有的按钮和可以点击的文本按下和抬起事件方法
        _btnTextCommon:function(element){
            var wid = element.width();
            var windowHeid = $(window).height() - wid - 40;
            var windowWid = $(window).width() - wid;
            //给选项绑定手指按下事件
            element.bind('touchstart',function(e){
                $(this).css({"opacity":"0.5","transition":""});
                element.bind("touchmove",function(e){
                    // e.preventDefault();
                    var touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
                    var x = touch.pageX - wid / 2;
                    var y = touch.pageY - wid / 2;
                    if(y > windowHeid){
                        y = windowHeid;
                    }else if(y < 30){
                        y = 30;
                    }
                    if(x > windowWid){
                        x = windowWid;
                    }else if(x < 1){
                        x = 0;
                    }
                    element.css({"left":x + "px","top":y + "px","bottom":"","right":""});
                });
            });
            //给选项绑定手指抬起事件
            element.bind('touchend',function(){
                $(this).css({"opacity":"","transition":"all 0.3s"});
                element.unbind("touchmove");
            });
        },
        //显示添加组件
        showAdd:function(){
            this.element.css("z-index","1");
            this.element.css("opacity","1");
            setTimeout(function(that){
                that.element.attr("isShow","yes");
            },310,this);
        },
        //隐藏添加组件
        hideAdd:function(){
            this.element.css("opacity","0");
            setTimeout(function(that){
                that.element.css("z-index","-1");
                that.element.attr("isShow","yes");
            },310,this);
        },
        //锁定添加组件yes是锁定no是解除锁定
        lock:function(type){
            if(type == "yes"){
                this.element.css({"pointer-events":"none"});
            }else{
                this.element.css({"pointer-events":""});
            }
        },
        //改变pid方法
        changePid:function(pid){
            this.options.pid = pid;
        },
        //改变消息数量和空间大小信息方法
        changeMyspaceNumm:function(obj){
            this.options.newAndSpace = obj;
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this);
        }
    });
});
