/*
*   2020年11月16日
*   
*   封装云空间手机端通用添加panel组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.CommonAddPanel",{
        //默认参数
        options:{
            menuData:[],//菜单数据
            newAndSpace:{},//消息数量和空间容量
        },
        _spaceContainer:null,//空间使用情况容器
        _nummContainer:null,//空间使用数值容器
        _addOptionMenuContainer:null,//添加菜单选项容器
        _seatContent:null,//占位元素
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            //给初始化元素设定指定的css样式
            this.element.css({
                "position":"absolute",
                "top":this.element.height() + "px",
                "left":0,
                "transition":"all 0.3s",
                "overflow":"hidden"
            });
            //创建头部空间使用情况容器
            var padTop = phonexh("top") == 0 ? "0.4rem" : "0.6rem";
            this._spaceContainer = $("<div style='padding:"+padTop+" 0.25rem 0 0.25rem;box-sizing:border-box;'></div>").appendTo(this.element);
            this._nummContainer = $("<p style='width:100%;font-size:0.14rem;'></p>").appendTo(this._spaceContainer);
            $("<span>空间使用</span>").appendTo(this._nummContainer);
            $("<span style='color:"+skinConfig(global.skin).selectFontColor+";margin-left:0.05rem;'></span>").appendTo(this._nummContainer);
            $("<span> / </span>").appendTo(this._nummContainer);
            $("<span></span>").appendTo(this._nummContainer);
            //创建空间使用进度条
            var spaceProgress = $("<div style='width:150px;height:3px;margin-top:0.07rem;background-color:rgb(230,230,230);border-radius:0.02rem;overflow:hidden;'></div>").appendTo(this._spaceContainer);
            this._progress = $("<div style='width:0%;height:100%;background:"+skinConfig(global.skin).backColor+";border-top-right-radius:0.02rem;border-bottom-right-radius:0.02rem;'></div>").appendTo(spaceProgress);
            $("<p style='width:100%;font-size:0.12rem;color:#999;margin-top:0.1rem;'>禁止新建/上传色情，暴力等违禁文件</p>").appendTo(this._spaceContainer);
            //创建占位元素
            this._seatContent = $("<div></div>").appendTo(this.element);
            //创建添加选项菜单容器
            this._addOptionMenuContainer = $("<div style='width:100%;padding-bottom:0.1rem;'></div>").appendTo(this.element);
            this._optionConatiner = $("<ul style='width:100%;display:flex;flex-direction:row;flex-wrap:wrap;'></ul>").appendTo(this._addOptionMenuContainer);
            for(var i = 0; i < this.options.menuData.length; i++){
                var li = $("<li type='"+this.options.menuData[i].type+"' style='width:25%;margin-bottom:0.2rem;display:flex;flex-direction:column;flex-shrink:0;align-items:center;justify-content:center;'></li>").appendTo(this._optionConatiner);
                $("<img style='widht:0.6rem;height:0.6rem;' src='"+this.options.menuData[i].icon+"'/>").appendTo(li);
                $("<span style='font-size:0.12rem;font-weight:bold;margin-top:0.05rem;'>"+this.options.menuData[i].text+"</span>").appendTo(li);
            }
            //创建关闭组件图标按钮
            this._closeContainer = $("<div style='width:100%;display:flex;justify-content:center;'></div>").appendTo(this._addOptionMenuContainer);
            $("<img style='width:0.7rem;height:0.7rem;' src='"+skinConfig(global.skin).commonIcon+"icon_gb.png'/>").appendTo(this._closeContainer);
            //设置占位元素的高度进行占位
            this._seatContent.css("height",this.element.height() - this._spaceContainer.outerHeight(true) - this._addOptionMenuContainer.outerHeight(true) + "px");
            //调用改变消息数量和空间容量方法
            this.changeSpace(this.options.newAndSpace);
            //给关闭图标绑定点击事件
            this._closeContainer.find("img").bind("click",this,this._closeClick);
            //给所有操作按钮绑定点击事件
            this._optionConatiner.find("li").bind("click",this,this._optionClick);
            //关闭按钮按下抬起效果
            this._btnTextCommon(this._closeContainer.find("img"));
            //操作按钮按下抬起效果
            this._btnTextCommon(this._optionConatiner.find("li"));
        },
        //组件初始化成功主动执行
        _init:function(){
            setTimeout(function(that){
                that.element.css({"top":"0px","opacity":1});
            },50,this);
            //兼容安卓
            setTimeout(function(that){
                that._seatContent.css("height",that.element.height() - that._spaceContainer.outerHeight(true) - that._addOptionMenuContainer.outerHeight(true) + "px");
            },200,this);
        },
        //所有的按钮和可以点击的文本按下和抬起事件方法
        _btnTextCommon:function(element){
            //给选项绑定手指按下事件
            element.bind('touchstart',function(){
                $(this).css("opacity","0.5");
            });
            //给选项绑定手指抬起事件
            element.bind('touchend',function(){
                $(this).css("opacity","");
            });
        },
        //点击关闭图标
        _closeClick:function(event){
            event.data.element.css({"top":event.data.element.height() + "px"});
            event.data.element.trigger("ADD_PANEL_CANCEL");
            setTimeout(function(){
                event.data.element.css({"opacity":0});
            },100);
            setTimeout(function(){
                event.data.destroy();
            },310);
        },
        //关闭组件
        closePanel:function(){
            this.element.css("top",this.element.height() + "px");
            setTimeout(function(that){
                that.element.css("opacity","0");
            },100,this);
            setTimeout(function(that){
                that.element.trigger("ADD_PANEL_CANCEL");
                that.destroy();
            },310,this);
        },
        //操作按钮点击事件
        _optionClick:function(event){
            event.data.element.trigger("OPTION_CLICK",$(this).attr("type"));
        },
        //改变空间容量方法
        changeSpace:function(obj){
            this._nummContainer.children("span").eq(1).html(spaceConvert({"num":obj.capacity_used,"type":"B"}));
            this._nummContainer.children("span").eq(3).html(spaceConvert({"num":obj.capacity,"type":"MB"}));
            this._progress.css("width",spaceUse({"num":obj.capacity,"use":obj.capacity_used / 1024 / 1024}) + "%");
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
            this.element.remove();
        }
    });
});