/*
*   2020年10月28日
*   
*   封装云空间手机端通用列表选中底部操作菜单组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.CommonBottonMenu",{
        //默认参数
        options:{
            btnMenu:[],//底部操作菜单
        },
        _maxContainer:null,//内容最大容器
        _isClick:true,//防止用户不停点击
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            //判断是否传入了底部操作菜单
            if(this.options.btnMenu.length == 0){
                alert("请传入操作菜单");
                return;
            }
            // var padd = phonexh("bottom") == 0 ? "0.2rem" : phonexh("bottom") / 2 / 100 + "rem";
            var padd = phonexh("bottom") == 0 ? "0.2rem" : "0.1rem";
            this._maxContainer = $("<ul style='width:100%;padding-bottom:"+padd+";display:flex;flex-wrap:wrap;border-top:1px solid #ECECEC;box-sizing:border-box;transition:all 0.3s;'></ul>").appendTo(this.element);
            if(this.options.btnMenu.length <= 3){
                this._maxContainer.css("justify-content","center");
            }
            //循环生成底部菜单
            for(var i = 0; i < this.options.btnMenu.length; i++){
                var li = $("<li type='"+this.options.btnMenu[i].type+"' style='width:25%;margin-top:0.2rem;display:flex;flex-direction:column;align-items:center;flex-shrink:0;'></li>").appendTo(this._maxContainer);
                $("<img style='width:0.4rem;height:0.4rem;' src='"+this.options.btnMenu[i].icon+"'/>").appendTo(li);
                $("<span style='font-size:0.12rem;font-weight:bold;margin-top:0.05rem;'>"+this.options.btnMenu[i].text+"</span>").appendTo(li);
            }
            //给操作按钮绑定点击事件
            this._maxContainer.find("li").bind("click",this,this._operationBtnClick);
            //操作按钮按下抬起效果
            this._btnTextCommon(this._maxContainer.find("li"));
        },
        //点击操作按钮
        _operationBtnClick:function(event){
            if(event.data._isClick){
                event.data._isClick = false;
                event.data.element.trigger("OPERATION_BTN_CLICK",$(this).attr("type"));
                setTimeout(function(){
                    event.data._isClick = true;
                },500);
            }
        },
        //所有的按钮和可以点击的文本按下和抬起事件方法
        _btnTextCommon:function(element){
            //给选项绑定手指按下事件
            element.bind('touchstart',function(){
                $(this).css("opacity","0.5");
            });
            //给选项绑定手指抬起事件
            element.bind('touchend',function(){
                $(this).css("opacity","");
            });
        },
        //锁定操作按钮方法
        lockOptBtn:function(dataArray){
            this._maxContainer.find("li").css({"pointer-events":"","opacity":""});
            for(var i = 0; i < dataArray.length; i++){
                this._maxContainer.find("li").each(function(){
                    if($(this).children("span").html() == dataArray[i]){
                        $(this).css({"pointer-events":"none","opacity":"0.5"});
                        return true;
                    }
                });
            }   
        },
        //锁定所有按钮不能点击
        lock:function(type){
            if(type == "yes"){
                this._maxContainer.css({"pointer-events":"none","opacity":"0.5"});
            }else{
                this._maxContainer.css({"pointer-events":"","opacity":""});
            }
        },
        //渐显渐隐效果
        gradually:function(type){
            if(type == "yes"){
                this._maxContainer.css("opacity","1");
            }else{
                this._maxContainer.css("opacity","0");
            }
        },
        //隐藏底部操作菜单
        hide:function(){
            this._maxContainer.css("opacity","0");
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});