/*
*   2020年10月27日
*   
*   封装云空间手机端通用列表组件
*
*   开发者：付长建 
*/
define([],function(){
    var isClick = true;
    $.widget("ys.CommonCell",{
        //默认参数
        options:{
            commonIconUrl:"../common2/img/djcommon/",//通用文件图标路径
            shllIconUrl:"../common2/img/red/",//皮肤配置对应的文件图标路径
            isSelect:true,//是否开启勾选框
            selectSize:2,//勾选图标大小
            data:null,//当前这条数据
        },
        _maxContainer:null,//元素最大容器
        _iconContainer:null,//文件图标容器元素
        _fileInformationContainer:null,//文件信息容器元素
        _fileName:null,//文件名称元素
        _fileTime:null,//文件上传时间
        _fileSize:null,//文件大小
        _selectContainer:null,//勾选容器元素
        _isClick:true,//控制用户不停的点击勾选按钮
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            //判断是否置顶
            if(this.options.data.is_up != undefined && this.options.data.is_up != null && this.options.data.is_up != ""){
                if(parseInt(this.options.data.is_up) != 0){
                    this.element.css("background","#f8f8f8");//给当前列表添加背景颜色表示当前是置顶的
                }
            }
            //创建最大容器
            this._maxContainer = $("<div style='width:100%;border-bottom:1px solid #ECECEC;padding:0.15rem 0 0.15rem 0;box-sizing:border-box;display:flex;flex-direction:row;'></div>").appendTo(this.element);
            var icon = parseInt(this.options.data.isdir) == 1 ? "folder" : this.options.data.ext;
            //创建文件图标元素
            this._iconContainer = $("<div style='width:0.45rem;position:relative;display:flex;justify-content:center;flex-shrink:0;'></div>").appendTo(this._maxContainer);
            
            $("<img class='fileIcon' style='width:0.18rem;height:0.18rem;margin-top:0.04rem;' src='"+this.options.commonIconUrl+""+matchingFileIcon(icon)+"'/>").appendTo(this._iconContainer);
            //判断是否开启缩略图
            if(global.is_thumb_model == "yes"){
                //判断是否可以对接缩略图
                if(this.options.data.file_type == "image" && ["png","jpg","jpeg","heic"].indexOf(this.options.data.ext) != -1){
                    var iconSrc = "";
                    //判断是哪个版本的缩略图
                    if(global.version == "alone" || global.small_img_must_alone == true){
						iconSrc = global.preview_config.thumb_config.get_thumb + "?uuid="+this.options.data.fileinfo_id+"&width="+global.thumb_width_height_config.width+"&height="+global.thumb_width_height_config.height+"&downUrl="+encodeURIComponent(global.get_image_url+"?id="+this.options.data.fileinfo_id)+"&ext="+this.options.data.ext;
					}else{
						iconSrc = global.preview_config.thumb_config.get_thumb + "?uuid="+this.options.data.fileinfo_id+"&width="+global.thumb_width_height_config.width+"&height="+global.thumb_width_height_config.height;
                    }
                    var img = new Image();
                    img.src = iconSrc;
					img.onload = function(){
                        that._iconContainer.children("img").attr("src",iconSrc);
                        that._iconContainer.css("justify-content","");
                        that._iconContainer.children("img").css({"width":"0.32rem","height":"0.32rem","border-radius":"0.04rem"});
                    };
                }   
            }
            //创建文件信息和勾选最大容器
            var fileInformationSelectContainer = $("<div style='width:100%;display:flex;flex-direction:row;justify-content:space-between;'></div>").appendTo(this._maxContainer);
            //创建文件信息容器
            this._fileInformationContainer = $("<div style='width:2.6rem;overflow:hidden;'></div>").appendTo(fileInformationSelectContainer);
            var ext = parseInt(this.options.data.isdir) == 1 ? "" : "." + this.options.data.ext;//后缀
            this._fileName = $("<p class='fileName' style='width:100%;font-size:0.16rem;font-weight:bold;display:-webkit-box;overflow:hidden;text-overflow:ellipsis;-webkit-line-clamp:3;-webkit-box-orient:vertical;word-wrap:break-word;'>"+this.options.data.name+""+ext+"</p>").appendTo(this._fileInformationContainer);
            var fileTimeSizeContainer = $("<div style='margin-top:0.08rem;'></div>").appendTo(this._fileInformationContainer);
            this._fileTime = $("<span style='font-size:0.12rem;color:#999;'>"+this.options.data.createtime+"</span>").appendTo(fileTimeSizeContainer);
            var fileSize = parseInt(this.options.data.isdir) == 1 ? "" : this.options.data.file_size_format;//得到文件大小
            this._fileSize = $("<span style='font-size:0.12rem;color:#999;margin-left:0.1rem;'>"+fileSize+"</span>").appendTo(fileTimeSizeContainer);
            //判断初始化元素是否有text属性（这个是回收站特有）
            if(this.element.attr("text") != undefined){
                $("<span style='font-size:0.12rem;color:#999;margin-left:0.1rem;'>"+this.element.attr("text")+"天</span>").appendTo(fileTimeSizeContainer);
            }
            //判断是否开启了勾选
            if(this.options.isSelect){
                //创建勾选元素容器
                this._selectContainer = $("<div class='isSelect' isSelect='no' style='width:0.48rem;height:100%;display:flex;align-items:center;justify-content:center;flex-shrink:0;'></div>").appendTo(fileInformationSelectContainer);
                var setIconSize = parseInt(this.options.selectSize) == 2 ? "0.09rem" : "0.18rem";
                $("<img style='width:"+setIconSize+";height:"+setIconSize+";' src='"+this.options.commonIconUrl+"pt_touxuan.png'/>").appendTo(this._selectContainer);
                //给勾选容器绑定点击事件
                this._selectContainer.bind("click",this,this._selectClick);
            }else{
                //设置文件信息容器的宽度
                // this._fileInformationContainer.css("width",($(window).width() - 80) / 100 + "rem");
            }
            //设置文件信息容器的宽度
            // this._fileInformationContainer.css("width",($(window).width() - 120) / 100 + "rem");
            //给文件信息容器绑定点击事件
            this._fileInformationContainer.bind("click",this,this._fileCellClick);
            //给文件图标容器绑定点击事件
            this._iconContainer.bind("click",this,this._fileCellClick);
        },
        //点击文件图标和文件信息
        _fileCellClick:function(event){
            //判断是否可以抛出点击事件
            if(isClick){
                isClick = false;
                event.data.element.trigger("CELL_CLICK",event.data.options.data);
                setTimeout(function(){
                    isClick = true;
                },300);
            }
        },
        //点击勾选图标容器
        _selectClick:function(event){
            //判断是否可以抛出点击事件
            if(isClick){
                isClick = false;
                //判断当前是选中还是取消选中
                if($(this).attr("isSelect") == "no"){
                    $(this).attr("isSelect","yes");
                    $(this).children("img").attr("src",event.data.options.shllIconUrl + "pt_touxuan.png");
                }else{
                    $(this).attr("isSelect","no");
                    $(this).children("img").attr("src",event.data.options.commonIconUrl + "pt_touxuan.png");
                }
                event.data.element.trigger("CELL_SELECT",{"type":$(this).attr("isSelect"),"data":event.data.options.data});
                setTimeout(function(){
                    isClick = true;
                },300);
            }
        },
        //改变勾选按钮大小方法1是变大2是变小
        changeSelectSize:function(type){
            //判断是变大还是变小
            if(type == 1){
                this._selectContainer.children("img").css({"width":"0.18rem","height":"0.18rem"});
            }else{
                this._selectContainer.children("img").css({"width":"0.09rem","height":"0.09rem"});
            }
        },
        //选中方法
        allSelect:function(){
            this._selectContainer.children("img").attr("src",this.options.shllIconUrl + "pt_touxuan.png");
            this._selectContainer.attr("isSelect","yes");
        },
        //取消选中方法
        cancelSelect:function(){
            this._selectContainer.children("img").attr("src",this.options.commonIconUrl + "pt_touxuan.png");
            this._selectContainer.attr("isSelect","no");
        },
        //获取当前数据方法
        getData:function(){
            return this.options.data;
        },
        //锁定信息元素和图标元素方法yes表示锁定no表示解锁
        lock:function(type){
            if(type == "yes"){
                this._fileInformationContainer.css("pointer-events","none");
                this._iconContainer.css("pointer-events","none");
            }else{
                this._fileInformationContainer.css("pointer-events","");
                this._iconContainer.css("pointer-events","");
            }
        },
        //锁定整个列表
        lockList:function(type){
            if(type == "yes"){
                this.element.css("pointer-events","none");
            }else{
                this.element.css("pointer-events","");
            }
        },
        //添加未查看文件夹的红点
        addRedPoint:function(){
            $("<div style='width:0.08rem;height:0.08rem;position:absolute;left:0;top:0;background-color:red;border-radius:100px'></div>").appendTo(this._iconContainer);
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});