/*
*   2020年10月21日
*   
*   封装云空间手机端面包屑通用组件
*
*   开发者：付长建 
*/
define(["iscroll"],function(iscroll){
    $.widget("ys.CommonCrumbs",{
        //默认参数
        options:{
            navData:[{"text":"云盘","pid":0}],//默认面包屑第一个
        },
        _iscroll:null,//滚动插件
        _maxContainer:null,//最大元素 
        _defaultNavContainer:null,//默认面包屑容器
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            //创建最大容器
            this._maxContainer = $("<div style='width:100%;height:100%;overflow:hidden;display:flex;flex-direction:row;'></div>").appendTo(this.element);
            //创建默认面包屑容器
            this._defaultNavContainer = $("<ul style='height:100%;display:flex;flex-direction:row;flex-shrink:0;'></ul>").appendTo(this._maxContainer);
            //创建包屑容器
            this._crumbsContainer = $("<div id='CommonCrumbsIscroll' style='height:100%;display:flex;flex-direction:row;flex-shrink:0;overflow:hidden;'></div>").appendTo(this._maxContainer);
            //调用生成默认面包屑导航方法
            this.generateDefaultNav(this.options.navData);
            //创建面包屑横向滚动内容容器
            this._crumbsContentContainer = $("<ul style='min-width:"+(this._crumbsContainer.width() + 1)+"px;height:100%;display:flex;flex-direction:row;'></ul>").appendTo(this._crumbsContainer);
            //初始化滚动插件
            this._iscroll = new iscroll("#CommonCrumbsIscroll",{
                scrollX:true,  
                scrollY:false, 
                click:that._iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });
        },
        //判读设备函数
        _iScrollClick:function(){
            if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
            if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
            if (/Silk/i.test(navigator.userAgent)) return false;
            if (/Android/i.test(navigator.userAgent)) {
            var s=navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
                return parseFloat(s[0]+s[3]) < 44 ? false : true
            }
        },
        //重置滚动容器的宽度方法
        _resetIscrollContainerWidth:function(){
            var wid = 0;
            this._crumbsContentContainer.find("li").each(function(){
                wid += $(this).width();
            });
            //判断所有的子元素宽度相加是否大于父级元素
            if(wid >= this._crumbsContainer.width()){
                this._crumbsContentContainer.css("min-width",wid + "px");//设置面包屑滚动容器的宽度
                this._iscroll.refresh();//刷新高度
                this._iscroll.scrollTo(this._iscroll.maxScrollX,0,300);//保持一直滚动在最右边
            }else{
                this._crumbsContentContainer.css("min-width",this._crumbsContainer.width() + 1 + "px");//设置面包屑滚动容器的宽度
                this._iscroll.refresh();//刷新高度
            }
        },
        //锁定和解锁面包屑组件yes表示锁定no表示解锁
        lock:function(type){
            if(type == "yes"){
                this._maxContainer.css({"pointer-events":"none","opacity":"0.7"});
            }else{
                this._maxContainer.css({"pointer-events":"","opacity":""});
            }
        },
        //生成默认面包屑导航方法
        generateDefaultNav:function(defaultArray){
            for(var i = 0; i < defaultArray.length; i++){
                var li = $("<li pid='"+defaultArray[i].pid+"' style='height:100%;display:flex;flex-direction:row;align-items:center;flex-shrink:0;'></li>").appendTo(this._defaultNavContainer);
                $("<span style='font-size:0.12rem;color:"+skinConfig(global.skin).selectFontColor+";font-weight:bold;'>"+defaultArray[i].text+"</span>").appendTo(li);
                $("<img style='width:0.06rem;height:0.09rem;margin:0 0.07rem 0 0.1rem;' src='"+skinConfig(global.skin).commonIcon+"arrow_icon.png'/>").appendTo(li);
                //判断是否生成箭头图标并改变文字颜色和箭头图标
                if(defaultArray.length > 1 && i < defaultArray.length - 1){
                    li.children("span").css("color","#999"); 
                }
                li.bind("click",this,this._defaultNavClick);//给默认面包屑绑定点击事件
            }
            //隐藏默认面包屑最后一个的箭头图标
            this._defaultNavContainer.find("li:last-child").children("img").css("opacity","0");
            //设置可以横向滚动面包屑容器的最小宽度
            this._crumbsContainer.css("width",this._maxContainer.width() - this._defaultNavContainer.width() + "px");
        },
        //生成面包学导航方法
        generateNav:function(navArray){
            this._crumbsContentContainer.find("li:last-child").children("span").css("color","#999");//改变滚动面包屑文字颜色
            this._crumbsContentContainer.find("li:last-child").children("img").css("display","");//显示滚动面包屑的箭头图标
            //循环生成新的面包屑组件
            for(var i = 0; i < navArray.length; i++){
                var li = $("<li pid='"+navArray[i].pid+"' style='height:100%;display:flex;flex-direction:row;align-items:center;flex-shrink:0;'></li>").appendTo(this._crumbsContentContainer);
                $("<span style='font-size:0.12rem;color:"+skinConfig(global.skin).selectFontColor+";font-weight:bold;'>"+navArray[i].text+"</span>").appendTo(li);
                $("<img style='width:0.06rem;height:0.09rem;margin:0 0.07rem 0 0.1rem;display:none;' src='"+skinConfig(global.skin).commonIcon+"arrow_icon.png'/>").appendTo(li);
                //判断是否是批量添加
                if(navArray.length > 1 && i < navArray.length - 1){
                    li.children("span").css("color","#999");
                    li.children("img").css("display","");//显示默认面包屑最后一个箭头图标
                }
                li.bind("click",this,this._navClick);//给滚动容器的下面的面包屑绑定点击事件
            }
            //改变默认面包屑最后一个面包屑的文字颜色
            this._defaultNavContainer.find("li:last-child").children("span").css("color","#999");
            this._defaultNavContainer.find("li:last-child").children("img").css("opacity","");//显示默认面包屑最后一个箭头图标
            //调用重置面包屑滚动容器的宽度方法
            this._resetIscrollContainerWidth();
        },
        //清空滚动容器里面的面包屑
        emptyNav:function(){
            this._crumbsContentContainer.find("li").remove();//清空滚动容器下面的面包屑
            this._defaultNavContainer.find("li:last-child").children("span").css("color",skinConfig(global.skin).selectFontColor);//改变默认面包屑最后一个面包屑的文字颜色
            this._defaultNavContainer.find("li:last-child").children("img").css("opacity","0");//隐藏默认面包屑最后一个箭头图标
            this._crumbsContentContainer.css("min-width",this._crumbsContainer.width() + 1 + "px");//设置面包屑滚动容器的宽度
            this._iscroll.refresh();//刷新高度
        },
        //点击默认面包屑
        _defaultNavClick:function(event){
            event.data.emptyNav();//调用清空滚动容器里面的面包屑
            event.data.element.trigger("NAV_CLICK",{"title":$(this).children("span").html(),"pid":$(this).attr("pid")});//抛出面包屑被点击事件
        },
        //点击滚动容器下面的面包屑
        _navClick:function(event){
            $(this).nextAll().remove();
            $(this).children("span").css("color",skinConfig(global.skin).selectFontColor);
            $(this).children("img").css("display","none");
            event.data._resetIscrollContainerWidth();//调用重置滚动容器宽度方法
            event.data.element.trigger("NAV_CLICK",{"title":$(this).children("span").html(),"pid":$(this).attr("pid")});//抛出面包屑被点击事件
        },
        //获取上一层pid和文件名方法
        getPid:function(){
            var obj = {}
            //判断面包屑节点的长度
            if($(this._crumbsContentContainer.find("li")).length == 1){
                obj.title = "";
                obj.pid = 0;
                this.emptyNav();//调用清空滚动容器里面的面包屑
            }else{
                obj.title = this._crumbsContentContainer.find("li:last-child").prev().children("span").html();
                obj.pid = this._crumbsContentContainer.find("li:last-child").prev().attr("pid");
                this._crumbsContentContainer.find("li:last-child").prev().children("span").css("color",skinConfig(global.skin).selectFontColor);
                this._crumbsContentContainer.find("li:last-child").prev().children("img").css("display","none");
                this._crumbsContentContainer.find("li:last-child").remove();
            }
            this._resetIscrollContainerWidth();//调用重置滚动容器宽度方法
            return obj;
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});