/*
*   2020年11月2日
*   
*   封装云空间手机端通用删除提示组件，询问组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.CommonDeleteMask",{
        //默认参数
        options:{
            title:"删除提示！",
            text:"确定要删除这1个文件吗？删除后15天内可以在回收站找回",
            determineBtn:"确定"
        },
        _headContainer:null,//头部元素
        _cancelBtn:null,//取消按钮
        _determineBtn:null,//确定按钮
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            this.element.css({
                "width":"3rem",
                "position":"absolute",
                "top":"50%",
                "left":"50%",
                // "transform":"scale(0.5,0.5)",
                "padding":"0.2rem",
                "box-sizing":"border-box",
                "background":"#fff",
                "box-shadow":"rgba(0, 0, 0, 0.08) 1px 0.03rem 0.13rem 0.03rem",
                "border-radius":"0.05rem",
                // "transition":"all 0.3s",
                "opacity":"0",
                // "display":"none"
            });
            //创建头部
            this._headContainer = $("<div style='width:100%;display:flex;align-items:center;justify-content:center;font-size:0.16rem;font-weight:bold;'>"+this.options.title+"</div>").appendTo(this.element);
            //创建提示语
            this._textContainer = $("<div style='width:100%;font-size:0.12rem;color:#999;text-align:center;line-height:1.7;margin-top:0.15rem;'>"+this.options.text+"</div>").appendTo(this.element);
            //创建确认和取消按钮容器
            var determineCancelContainer = $("<div style='width:100%;margin-top:0.3rem;display:flex;flex-direction:row;justify-content:space-between;'></div>").appendTo(this.element);
            //创建取消按钮
            this._cancelBtn = $("<div style='width:1.2rem;height:0.4rem;display:flex;align-items:center;justify-content:center;font-size:0.16rem;color:"+skinConfig(global.skin).selectFontColor+";border:1px solid "+skinConfig(global.skin).bordeColor+";border-radius:0.2rem;box-sizing:border-box;'>取消</div>").appendTo(determineCancelContainer);
            //创建确定按钮
            this._determineBtn = $("<div style='width:1.2rem;height:0.4rem;color:#fff;display:flex;align-items:center;justify-content:center;font-size:0.16rem;border-radius:0.2rem;background:"+skinConfig(global.skin).linearBackColor+"'>"+this.options.determineBtn+"</div>").appendTo(determineCancelContainer);
            this.element.css({"margin-top":"-" + this.element.outerHeight(true) / 2 + "px","margin-left":"-" + this.element.outerWidth(true) / 2 + "px"});
            //给取消按钮绑定点击事件
            this._cancelBtn.bind("click",this,this._cancelBtnClick);
            //给确定按钮绑定点击事件
            this._determineBtn.bind("click",this,this._determineBtnClick);
            //取消按钮按下抬起效果
            this._btnTextCommon(this._cancelBtn);
            //确定按钮按下抬起效果
            this._btnTextCommon(this._determineBtn);
        },
        //初始化主动执行
        _init:function(){
            setTimeout(function(that){
                // that.element.css("display","");
                // setTimeout(function(){
                //     that.showMask();
                // },20);
                that.showMask();
            },10,this);
        },
        //点击取消按钮
        _cancelBtnClick:function(event){
            event.stopPropagation();
            event.data.hideMask();
            setTimeout(function(){
                event.data.element.trigger("DELETE_MASK_CANCEL");
                event.data.destroy();
            },310);
        },
        //点击确定按钮
        _determineBtnClick:function(event){
            event.stopPropagation();
            event.data.element.trigger("DELETE_MASK_DETERMINE");
        },
        //隐藏询问弹窗
        hideMask:function(){
            // this.element.css({"transform":"scale(0.5,0.5)","opacity":"0"});
            this.element.fadeTo("fast",0);
            this.element.attr("isShow","no");
        },
        //显示询问弹窗
        showMask:function(){
            // this.element.css({"transform":"scale(1,1)","opacity":"1"});
            this.element.fadeTo("fast",1);
            this.element.attr("isShow","yes"); 
        },
        //改变提示标题方法
        changeTitle:function(title){
            this._headContainer.html(title);
        },
        //改变提示内容方法
        changeText:function(text){
            this._textContainer.html(text);
        },
        //改变确定按钮文字方法
        changeDetermineBtn:function(text){
            this._determineBtn.html(text);
        },
        //删除弹框
        removeMask:function(){
            this.hideMask();
            setTimeout(function(that){
                that.destroy();
            },310,this);
        },
        //所有的按钮和可以点击的文本按下和抬起事件方法
        _btnTextCommon:function(element){
            //给选项绑定手指按下事件
            element.bind('touchstart',function(){
                $(this).css("opacity","0.5");
            });
            //给选项绑定手指抬起事件
            element.bind('touchend',function(){
                $(this).css("opacity","");
            });
        },
        //释放控件(清除控件)
        destroy:function(){
            this.element.remove();
            $.Widget.prototype.destroy.call(this); 
        }
    });
});