/*
*   2020年10月16日
*   
*   封装云空间手机端头部通用组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.CommonHead",{
        //默认参数
        options:{
            //筛选菜单数据 
            screenMenu:[
                {"text":"全部","type":"all","icon":"tabbar_icon_sort.png"},
                {"text":"最近","type":"near","icon":"tabbar_icon_sort.png"},
                {"text":"文档","type":"document","icon":"tabbar_icon_sort.png"},
                {"text":"图片","type":"image","icon":"tabbar_icon_sort.png"},
                {"text":"音乐","type":"music","icon":"tabbar_icon_sort.png"},
                {"text":"视频","type":"video","icon":"tabbar_icon_sort.png"},
                {"text":"其它","type":"other","icon":"tabbar_icon_sort.png"}
            ],
            addScreenMenu:{},//添加菜单数据属性 numm addData{}
            isGoback:false,//是否显示返回按钮（注意返回按钮和筛选按钮不能共存，所以只能开启一个）
            isScreen:false,//是否显示筛选按钮（注意返回按钮和筛选按钮不能共存，所以只能开启一个）
            isCancel:false,//是否显示取消按钮（注意取消按钮，消息中心传输列表按钮，关闭按钮，确定按钮，和保存按钮，不能共存只能开启一个）
            isPreservation:false,//是否显示保存按钮（注意保存按钮，消息中心传输列表按钮，关闭按钮，确定按钮，和取消按钮，完成按钮不能共存只能开启一个）
            isNewsTransmission:false,//是否显示消息中心入口和传输列表入口按钮（注意消息中心入口和传输列表入口按钮，关闭按钮，确定按钮，保存按钮，和取消按钮，不能共存只能开启一个）
            isDetermine:false,//是否开启确定按钮（注意确定按钮，消息中心传输列表按钮，取消按钮，关闭按钮，完成按钮，和保存按钮，不能共存只能开启一个）
            isComplete:false,//是否显示完成按钮（注意完成按钮，消息中心传输列表按钮，取消按钮，关闭按钮，和保存按钮，确定按钮，不能共存只能开启一个）
            isClose:false,//是否显示关闭按钮（注意关闭按钮，消息中心传输列表按钮，取消按钮，确定按钮，和保存按钮，不能共存只能开启一个）
            title:"",//头部title文字
            fontWeigth:"bold",//全选和全不选和取消按钮是否字体是否加粗
            isGobackEvent:"click",//给返回按钮绑定什么事件（主要是在新建组件里面需要使用到）
            isNews:true,//是否显示消息中心按钮
        },
        _maxContainer:null,//组件内容体最大容器
        _title:null,//头部文字显示容器
        _screenContainer:null,//筛选按钮容器
        _screenMenuContainer:null,//筛选菜单容器
        _textIconContainer:null,//筛选按钮容器
        _allChoose:null,//全选按钮
        _cancelChoose:null,//取消全选
        _goback:null,//返回按钮
        _rightContainer:null,//右边操作按钮容器
        _newsTransmissionContainer:null,//消息中心入口按钮和传输列表入口容器
        _transmissionContainer:null,//传输列表按钮
        _newsContainer:null,//消息中心按钮
        _cancelBtn:null,//取消按钮
        _preservationBtn:null,//保存按钮
        _determineBtn:null,//确定按钮
        _completeBtn:null,//完成按钮
        _closeBtn:null,//关闭按钮
        _isClick:true,//防止用户不停点击
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            //给初始化元素添加css样式主要是怕使用者忘记添加
            this.element.css({"width":"100%","padding-top":phonexh("top") + "px","box-sizing":"border-box"});
            //创建组件内容体最大元素
            this._maxContainer = $("<div style='width:100%;height:0.44rem;position:relative;'></div>").appendTo(this.element);
            //创建title元素
            var titleContainer = $("<div style='width:100%;height:100%;display:flex;flex-direction:row;align-items:center;justify-content:center;'></div>").appendTo(this._maxContainer);
            this._title = $("<span style='max-width:1.85rem;font-size:0.18rem;font-weight:bold;text-overflow:ellipsis;white-space: nowrap;-webkit-line-clamp:1;-webkit-box-orient:vertical;overflow:hidden;'>"+this.options.title+"</span>").appendTo(titleContainer);
            //创建文件类型筛选，全选，全不选，返回，传输列表，消息中心入口，保存，关闭，确定，取消按钮容器
            var operationBtnContainer = $("<div class='operationBtnContainer' style='width:100%;height:100%;position:absolute;bottom:0;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-between;'></div>").appendTo(this._maxContainer); 
            //左边文件筛选，全选，取消全选，返回按钮容器
            this._leftContainer = $("<div style='height:100%;display:flex;flex-direction:row;align-items:center;justify-content:center;'></div>").appendTo(operationBtnContainer);
            //创建筛选按钮
            this._screenContainer = $("<div is-show='no' class='screenContainer' style='height:100%;position:relative;display:none;'></div>").appendTo(this._leftContainer);
            this._textIconContainer = $("<div class='screenBtn' style='height:100%;display:flex;flex-direction:row;align-items:center;justify-content:center;'></div>").appendTo(this._screenContainer);
            $("<span class='screenBtn' style='font-size:0.18rem;font-weight:bold;margin-right:0.1rem;'>全部</span>").appendTo(this._textIconContainer);
            $("<img class='screenBtn' style='width:0.08rem;transform:rotate(0deg);transition:all 0.3s' src='"+skinConfig(global.skin).commonIcon+"tabbar_icon_arrow.png'/>").appendTo(this._textIconContainer);
            //判断是否开启了筛选按钮
            if(this.options.isScreen){
                //创建筛选菜单
                this._screenMenuContainer = $("<ul style='z-index:-1;width:1.4rem;padding:0 0.1rem 0 0.1rem;box-sizing:border-box;background:#fff;box-shadow:1px 0.03rem 0.13rem 0.03rem rgba(0,0,0,0.08);border-radius:0.08rem;position:absolute;left:0;top:0.44rem;transform:scale(0.7);transform-origin:0 0;opacity:0;'></ul>").appendTo(this._screenContainer);
            }
            //创建全选按钮
            this._allChoose = $("<div style='height:100%;display:none;flex-direction:row;align-items:center;justify-content:center;font-size:0.15rem;font-weight:"+this.options.fontWeigth+";'>全选</div>").appendTo(this._leftContainer);
            //创建取消全选按钮
            this._cancelChoose = $("<div style='height:100%;display:none;flex-direction:row;align-items:center;justify-content:center;font-size:0.15rem;font-weight:"+this.options.fontWeigth+";'>反选</div>").appendTo(this._leftContainer);
            //创建返回按钮
            this._goback = $("<div class='goback' style='height:100%;display:none;flex-direction:row;align-items:center;justify-content:center;font-size:0.15rem;padding-right:0.2rem;box-sizing:border-box;'></div>").appendTo(this._leftContainer);
            $("<img style='width:0.1rem;height:0.18rem;' src='"+skinConfig(global.skin).commonIcon+"icon_back.png'/>").appendTo(this._goback);
            //右边传输列表，消息中心，取消按钮容器
            this._rightContainer = $("<div class='headRight' style='height:100%;display:flex;flex-direction:row;align-items:center;justify-content:center;'></div>").appendTo(operationBtnContainer);
            //创建消息中心入口和传输列表入口容器
            this._newsTransmissionContainer = $("<div style='height:100%;display:none;flex-direction:row;align-items:center;justify-content:center;'></div>").appendTo(this._rightContainer);
            //传输列表入口按钮
            this._transmissionContainer = $("<div style='width:0.32rem;height:0.32rem;border-radius:50%;margin-right:0.15rem;position:relative;'></div>").appendTo(this._newsTransmissionContainer);
            $("<img style='width:100%;height:100%;' src='"+skinConfig(global.skin).commonIcon+"icon_cs.png'/>").appendTo(this._transmissionContainer);
            $("<span style='padding:0rem 0.07rem 0rem 0.07rem;box-sizing:border-box;border-radius:0.12rem;background:red;font-size:0.12rem;color:#fff;position:absolute;top:0;left:0.18rem;transform:scale(0.8);'></span>").appendTo(this._transmissionContainer);
            //消息中心入口按钮
            this._newsContainer = $("<div style='width:0.32rem;height:0.32rem;border-radius:50%;position:relative;'></div>").appendTo(this._newsTransmissionContainer);
            $("<img style='width:100%;height:100%;' src='"+skinConfig(global.skin).commonIcon+"icon_xx.png'/>").appendTo(this._newsContainer);
            $("<span style='padding:0rem 0.07rem 0rem 0.07rem;box-sizing:border-box;border-radius:0.12rem;background:red;font-size:0.12rem;color:#fff;position:absolute;top:0;left:0.18rem;transform:scale(0.8);'></span>").appendTo(this._newsContainer);
            //创建取消按钮
            this._cancelBtn = $("<div style='height:100%;display:none;flex-direction:row;align-items:center;justify-content:center;font-size:0.15rem;font-weight:"+this.options.fontWeigth+";'>取消</div>").appendTo(this._rightContainer);
            //创建保存按钮
            this._preservationBtn = $("<div style='height:100%;display:none;flex-direction:row;align-items:center;justify-content:center;font-size:0.15rem;font-weight:"+this.options.fontWeigth+";'>保存</div>").appendTo(this._rightContainer);
            //创建确定按钮
            this._determineBtn = $("<div class='determine' style='height:100%;display:none;flex-direction:row;align-items:center;justify-content:center;font-size:0.15rem;font-weight:"+this.options.fontWeigth+";'>确定</div>").appendTo(this._rightContainer);
            //创建完成按钮
            this._completeBtn = $("<div style='height:100%;display:none;flex-direction:row;align-items:center;justify-content:center;font-size:0.15rem;font-weight:"+this.options.fontWeigth+";'>完成</div>").appendTo(this._rightContainer);
            //创建关闭按钮
            this._closeBtn = $("<div style='height:100%;display:none;flex-direction:row;align-items:center;justify-content:center;font-size:0.15rem;font-weight:"+this.options.fontWeigth+";'>关闭</div>").appendTo(this._rightContainer);

            //判断是否开启了筛选按钮
            if(this.options.isScreen){
                //调用生成筛选菜单方法
                this._generateScreenMenu(this._screenMenuContainer);
            }
            //调用点击筛选按钮方法
            this._screenMenuShowAndHide(this._rightContainer);
            //调用点击全选按钮方法
            this._allChooseClick(this);
            //调用点击全不选按钮方法
            this._cancelChooseClick(this);
            //调用点击返回按钮方法
            this._gobackClick(this);
            //调用点击传输列表按钮方法
            this._transmissionBtnClick(this);
            //调用点击消息中心按钮方法
            this._newsBtnClick(this);
            //调用点击取消按钮方法
            this._cancelBtnClick(this);
            //调用点击保存按钮方法
            this._preservationBtnClick(this);
            //调用点击确定按钮方法
            this._determineBtnClick(this);
            //调用点击完成按钮方法
            this._completeBtnClick(this);
            //调用点击关闭按钮方法
            this._closeBtnClick(this);
            
            //筛选按钮按下和抬起效果
            this._btnTextCommon(this._textIconContainer);
            //全选按钮按下抬起效果
            this._btnTextCommon(this._allChoose);
            //取消全选按钮按下抬起效果
            this._btnTextCommon(this._cancelChoose);
            //返回按钮按下抬起效果
            this._btnTextCommon(this._goback);
            //传输列表按钮按下抬起效果
            this._btnTextCommon(this._transmissionContainer);
            //消息中心按钮按下抬起效果
            this._btnTextCommon(this._newsContainer);
            //取消按钮按下抬起效果
            this._btnTextCommon(this._cancelBtn);
            //调用初始化参数判断方法
            this._isGobackAndIsScreen();
        },
        //生成筛选菜单方法
        _generateScreenMenu(container){
            //判断是否有添加的菜单数据
            if(JSON.stringify(this.options.addScreenMenu) != "{}"){ 
                this.options.screenMenu.splice(this.options.addScreenMenu.numm,0,this.options.addScreenMenu.addData);
            }
            for(var i = 0; i < this.options.screenMenu.length; i++){
                var li = $("<li type='"+this.options.screenMenu[i].type+"' style='width:100%;height:0.4rem;border-bottom:1px solid #ECECEC;box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-between;'></li>").appendTo(container);
                $("<span style='font-szie:0.15rem;font-weight:bold;display:flex;align-items:center;justify-content:center;'>"+this.options.screenMenu[i].text+"</span>").appendTo(li);
                var iconContainer = $("<div style='display:none;align-items:center;justify-content:center;'></div>").appendTo(li);
                $("<img style='width:0.08rem;height:0.065rem;' src='"+skinConfig(global.skin).shllWebIon+""+this.options.screenMenu[i].icon+"'/>").appendTo(iconContainer);
                if(i == 0){
                    li.children("span").css("color",skinConfig(global.skin).selectFontColor);
                    li.children("div").css("display","flex");
                }else if(i == this.options.screenMenu.length - 1){
                    li.css("border","0");
                }
                li.bind("click",this,this._screenMenuClick);//给选项绑定点击事件
                this._btnTextCommon(li);//选项的按下和抬起效果
            }
        },
        //点击筛选按钮方法
        _screenMenuShowAndHide:function(rightContainer){
            var that = this;
            this._screenContainer.bind("click",function(){
                if($(this).attr("is-show") == "no"){
                    $(this).children("ul").css("transition","");
                    $(this).children("div").children("img").css("transition","");
                    $(this).children("ul").css({"z-index":"1","opacity":"1","transform":"scale(1)"});
                    $(this).children("div").children("img").css("transform","rotate(-180deg)");
                    rightContainer.css("pointer-events","none");
                    $(this).attr("is-show","yes");
                    setTimeout(function(that){
                        $(that).children("ul").css("transition","all 0.3s");
                        $(that).children("div").children("img").css("transition","all 0.3s");
                    },10,$(this));
                }else{
                    $(this).children("ul").css({"transform":"scale(0.7)","opacity":"0","z-index":"-1"});
                    $(this).children("div").children("img").css("transform","rotate(0deg)");
                    rightContainer.css("pointer-events","");
                    $(this).attr("is-show","no");
                }
                that.element.trigger("SCREENMENU_SHOW",$(this).attr("is-show"));
            }); 
        },
        //点击筛选菜单选项方法
        _screenMenuClick:function(event){
            event.stopPropagation();
            event.data._screenContainer.children("div").children("span").html($(this).children("span").html());
            event.data._screenContainer.children("ul").find("li").children("span").css("color","#333");
            event.data._screenContainer.children("ul").find("li").children("div").css("display","none");
            event.data._screenContainer.children("ul").css({"transform":"scale(0.7)","opacity":"0","z-index":"-1"}); 
            event.data._screenContainer.children("div").children("img").css("transform","rotate(0deg)");
            event.data._screenContainer.attr("is-show","no");
            $(this).children("span").css("color",skinConfig(global.skin).selectFontColor);
            $(this).children("div").css("display","flex");
            event.data._rightContainer.css("pointer-events","");
            event.data.element.trigger("SCREEN_MENU_CLICK",$(this).attr("type"));
            event.data.element.trigger("SCREENMENU_SHOW","no");
        },
        //点击全选按钮方法
        _allChooseClick:function(that){
            this._allChoose.bind("click",function(){
                that.element.trigger("ALL_SELECT_BTN_CLICK");
            });
        },
        //点击全不选按钮方法
        _cancelChooseClick:function(that){
            this._cancelChoose.bind("click",function(){
                that.element.trigger("ALL_NO_SELECT_BTN_CLICK");
            });
        },
        //点击返回按钮方法
        _gobackClick:function(that){
            //这里判断一下绑定什么事件 
            if(this.options.isGobackEvent == "click"){
                this._goback.bind("click",function(){
                    //判断用户不停点击
                    if(that._isClick){
                        that._isClick = false;
                        that.element.trigger("GOBACK_BTN_CLICK");
                        setTimeout(function(){
                            that._isClick = true;
                        },300);
                    }
                });
            }else{
                this._goback.bind("touchend",function(event){
                    event.stopPropagation();
                    event.preventDefault();
                    //判断用户不停点击
                    if(that._isClick){
                        that._isClick = false;
                        that._goback.css("opacity","");
                        that.element.trigger("GOBACK_BTN_CLICK");
                        setTimeout(function(){
                            that._isClick = true;
                        },300);
                    }
                });
            }
        },
        //点击传输列表按钮方法
        _transmissionBtnClick:function(that){
            this._transmissionContainer.bind("click",function(){
                that.element.trigger("TRANSMISSION_BTN_CLICK");
            });
        },
        //点击消息中心按钮方法
        _newsBtnClick:function(that){
            this._newsContainer.bind("click",function(){
                that.element.trigger("NEWS_BTN_CLICK");
            });
        },
        //点击取消按钮方法
        _cancelBtnClick:function(that){
            this._cancelBtn.bind("click",function(){
                that.element.trigger("CANCE_BTN_CLICK");
            });
        },
        //点击保存按钮方法
        _preservationBtnClick:function(that){
            this._preservationBtn.bind("click",function(){
                that.element.trigger("PEWSERVATION_BTN_CLICK");
            });
        },
        //点击确定按钮方法
        _determineBtnClick:function(that){
            this._determineBtn.bind("click",function(event){
                //判断用户不停点击
                if(that._isClick){
                    that._isClick = false;
                    that.element.trigger("DETERMINE_BTN_CLICK");
                    setTimeout(function(){
                        that._isClick = true;
                    },300);
                }
            });
        },
        //点击完成按钮方法
        _completeBtnClick:function(that){
            this._completeBtn.bind("click",function(){
                //判断用户不停点击
                if(that._isClick){
                    that._isClick = false;
                    that.element.trigger("COMPLETE_BTN_CLICK");
                    setTimeout(function(){
                        that._isClick = true;
                    },300);
                }
            });
        },
        //点击关闭按钮方法
        _closeBtnClick:function(that){
            this._closeBtn.bind("click",function(){
                that.element.trigger("CLOSE_BTN_CLICK");
            });
        },
        //所有的按钮和可以点击的文本按下和抬起事件方法
        _btnTextCommon:function(element){
            //给选项绑定手指按下事件
            element.bind('touchstart',function(){
                $(this).css("opacity","0.5");
            });
            //给选项绑定手指抬起事件
            element.bind('touchend',function(){
                $(this).css("opacity","");
            });
        },
        //初始化参数判断方法
        _isGobackAndIsScreen:function(){
            //判断是否显示返回按钮
            if(this.options.isGoback){
                if(!this.options.isScreen){
                    this._goback.css("display","flex");
                }else{
                    alert("筛选按钮和按钮按钮不能同时显示");
                    return;
                }
            }
            //判断是否显示筛选按钮
            if(this.options.isScreen){
                if(!this.options.isGoback){
                    this._screenContainer.css("display","");
                }else{
                    alert("筛选按钮和按钮按钮不能同时显示");
                    return;
                }
            }
            //判断是否显示消息中心和传输列表按钮
            if(this.options.isNewsTransmission){
                if(!this.options.isCancel && !this.options.isPreservation && !this.options.isDetermine && !this.options.isClose){
                    this._newsTransmissionContainer.css("display","flex");
                    if(!this.options.isNews){
                        this._newsContainer.css("display","none");
                        this._transmissionContainer.css("margin-right","0");
                    }
                }else{
                    alert("注意消息中心入口和传输列表入口按钮，关闭按钮，确定按钮，保存按钮，和取消按钮，不能共存只能开启一个");
                    return;
                }
            }
            //判断是否显示取消按钮
            if(this.options.isCancel){
                if(!this.options.isNewsTransmission && !this.options.isPreservation && !this.options.isDetermine && !this.options.isClose){
                    this._cancelBtn.css("display","flex");
                }else{
                    alert("注意取消按钮，消息中心传输列表按钮，关闭按钮，确定按钮，和保存按钮，不能共存只能开启一个");
                    return;
                }
            }
            //判断是否显示保存按钮
            if(this.options.isPreservation){
                if(!this.options.isCancel && !this.options.isNewsTransmission && !this.options.isDetermine && !this.options.isClose){
                    this._preservationBtn.css("display","flex");
                }else{
                    alert("注意保存按钮，消息中心传输列表按钮，关闭按钮，确定按钮，和取消按钮，不能共存只能开启一个");
                    return;
                }
            }
            //判断是否显示确定按钮按钮  
            if(this.options.isDetermine){
                if(!this.options.isCancel && !this.options.isNewsTransmission && !this.options.isPreservation && !this.options.isClose){
                    this._determineBtn.css("display","flex");
                }else{
                    alert("注意确定按钮，消息中心传输列表按钮，取消按钮，关闭按钮，和保存按钮，不能共存只能开启一个");
                    return;
                }
            }
            //判断是否显示确定按钮按钮  
            if(this.options.isComplete){
                if(!this.options.isCancel && !this.options.isNewsTransmission && !this.options.isPreservation && !this.options.isClose){
                    this._completeBtn.css("display","flex");
                }else{
                    alert("注意完成按钮，消息中心传输列表按钮，取消按钮，关闭按钮，和保存按钮，不能共存只能开启一个");
                    return;
                }
            }
            //判断是否显示关闭按钮按钮  
            if(this.options.isClose){
                if(!this.options.isCancel && !this.options.isNewsTransmission && !this.options.isPreservation && !this.options.isDetermine){
                    this._closeBtn.css("display","flex");
                }else{
                    alert("注意关闭按钮，消息中心传输列表按钮，取消按钮，确定按钮，和保存按钮，不能共存只能开启一个");
                    return;
                }
            }
        },
        //锁定和解锁头部组件yes表示锁定no表示解锁
        lock:function(type){
            if(type == "yes"){
                $(".operationBtnContainer").css({"pointer-events":"none"});
            }else{
                $(".operationBtnContainer").css({"pointer-events":""});
            }
        },
        //设置头部title文字，传值表示显示不传值表示隐藏
        changeTitle:function(text){
            if(text != undefined && text != null && text != ""){
                this._title.html(text);
            }else{
                this._title.html("");
            }
        },
        //设置消息数量方法
        changeNewNumm:function(numm){
            //判断传入值
            if(parseInt(numm) != 0){
                //判读当前数值是否大于99
                if(parseInt(numm) > 99){
                    this._newsContainer.children("span").html("99").css({"display":"block","width":"","height":"","align-items":"","justify-content":"","padding":"0rem 0.07rem 0rem 0.07rem","border-radius":"0.12rem"});
                    this._newsContainer.children("span").css({"padding":"0 0.08rem 0 0.05rem"});
                    $("<span style='position:absolute;margin-top:-0.03rem;margin-left:-0.01rem;'>+</span>").appendTo(this._newsContainer.children("span")); 
                }else{
                    this._transmissionContainer.children("span").html(numm).css({"display":"flex","width":"0.18rem","height":"0.18rem","padding":"","align-items":"center","justify-content":"center","border-radius":"50%"});
                }
            }else{
                this._newsContainer.children("span").html(numm).css("display","none");
            }
        },
        //设置上传下载数量方法
        changeUploadDowNUmm:function(numm){
            //判断传入值
            if(parseInt(numm) != 0){
                //判读当前数值是否大于99
                if(parseInt(numm) > 99){
                    this._transmissionContainer.children("span").html("99").css({"display":"block","width":"","height":"","align-items":"","justify-content":"","padding":"0rem 0.07rem 0rem 0.07rem","border-radius":"0.12rem"});
                    this._transmissionContainer.children("span").css({"padding":"0 0.08rem 0 0.05rem"});
                    $("<span style='position:absolute;margin-top:-0.03rem;margin-left:-0.01rem;'>+</span>").appendTo(this._transmissionContainer.children("span")); 
                }else{
                    this._transmissionContainer.children("span").html(numm).css({"display":"flex","width":"0.18rem","height":"0.18rem","padding":"","align-items":"center","justify-content":"center","border-radius":"50%"});
                }
                this._transmissionContainer.children("img").attr("src",skinConfig(global.skin).commonIcon + "icon_cs.gif");
            }else{
                this._transmissionContainer.children("span").html(numm).css("display","none");
                this._transmissionContainer.children("img").attr("src",skinConfig(global.skin).commonIcon + "icon_cs.png");
            }
        },
        //显示筛选按钮
        showScreenBtn:function(){
            this._allChoose.css("display","none");
            this._cancelChoose.css("display","none");
            this._goback.css("display","none");
            this._screenContainer.css("display","");
        },
        //显示全选按钮
        showAllSelectBtn:function(){
            this._cancelChoose.css("display","none");
            this._goback.css("display","none");
            this._screenContainer.css("display","none");
            this._allChoose.css("display","flex");
        },
        //显示全不选按钮
        showAllNoSelectBtn:function(){
            this._goback.css("display","none");
            this._screenContainer.css("display","none");
            this._allChoose.css("display","none");
            this._cancelChoose.css("display","flex");
        },
        //显示返回按钮
        showGobackBtn:function(){
            this._screenContainer.css("display","none");
            this._allChoose.css("display","none");
            this._cancelChoose.css("display","none");
            this._goback.css("display","flex");
        },
        //显示消息中心入口和传输列表入口按钮
        showNewsAndTransmissionBtn:function(){
            this._cancelBtn.css("display","none");
            this._preservationBtn.css("display","none");
            this._determineBtn.css("display","none");
            this._closeBtn.css("display","none");
            this._completeBtn.css("display","none");
            this._newsTransmissionContainer.css("display","flex");
        },
        //显示取消按钮
        showCancelBtn:function(){
            this._newsTransmissionContainer.css("display","none");
            this._preservationBtn.css("display","none");
            this._determineBtn.css("display","none");
            this._closeBtn.css("display","none");
            this._completeBtn.css("display","none");
            this._cancelBtn.css("display","flex");
        },
        //隐藏取消按钮
        hideCancelBtn:function(){
            this._cancelBtn.css("display","none");
        },
        //显示保存按钮
        showPreservationBtn:function(){
            this._newsTransmissionContainer.css("display","none");
            this._cancelBtn.css("display","none");
            this._determineBtn.css("display","none");
            this._closeBtn.css("display","none");
            this._completeBtn.css("display","none");
            this._preservationBtn.css("display","flex");
        },
        //显示确定按钮
        showDetermine:function(){
            this._newsTransmissionContainer.css("display","none");
            this._cancelBtn.css("display","none");
            this._closeBtn.css("display","none");
            this._preservationBtn.css("display","none");
            this._completeBtn.css("display","none");
            this._determineBtn.css("display","flex");
        },
        //隐藏确定按钮
        hideDetermine:function(){
            this._newsTransmissionContainer.css("display","none");
            this._cancelBtn.css("display","none");
            this._closeBtn.css("display","none");
            this._preservationBtn.css("display","none");
            this._completeBtn.css("display","none");
            this._determineBtn.css("display","none");
        },
        //显示完成按钮
        showCompleteBtn:function(){
            this._newsTransmissionContainer.css("display","none");
            this._cancelBtn.css("display","none");
            this._closeBtn.css("display","none");
            this._preservationBtn.css("display","none");
            this._determineBtn.css("display","none");
            this._completeBtn.css("display","flex");
        },
        //显示关闭按钮
        showClose:function(){
            this._newsTransmissionContainer.css("display","none");
            this._cancelBtn.css("display","none");
            this._determineBtn.css("display","none");
            this._preservationBtn.css("display","none");
            this._completeBtn.css("display","none");
            this._closeBtn.css("display","flex");
        },
        //隐藏筛选菜单
        hideScreenMenu:function(){
            this._screenMenuContainer.css({"transform":"scale(0.7)","opacity":"0","z-index":"-1"});
            this._textIconContainer.children("img").css("transform","rotate(0deg)");
            this._rightContainer.css("pointer-events","");
            this._screenContainer.attr("is-show","no");
            this.element.trigger("SCREENMENU_SHOW","no");
        },
        //隐藏返回按钮
        hideGobackBtn:function(){
            this._goback.css("display","none");
        },
        //改变取消按钮和全选按钮全不选按钮的颜色表示禁用状态（yes表示禁用no表示启用）
        changeCancelAllBtnColor:function(type){
            if(type == "yes"){
                this._allChoose.css("opacity","0.5");
                this._cancelChoose.css("opacity","0.5");
                this._cancelBtn.css("opacity","0.5");
            }else{
                this._allChoose.css("opacity","");
                this._cancelChoose.css("opacity","");
                this._cancelBtn.css("opacity","");
            }
        },
        //改变取消按钮颜色（表示禁止点击）
        changeCancelBtnColor:function(type){
            if(type == "yes"){
                this._cancelBtn.css("opacity","0.5");
            }else{
                this._cancelBtn.css("opacity","");
            }
        },
        //改变返回按钮颜色（表示禁止点击）
        changeGobackBtnColor:function(type){
            if(type == "yes"){
                this._goback.css("opacity","0.5");
            }else{
                this._goback.css("opacity","");
            } 
        },
        //改变确定按钮颜色（表示禁止点击）
        changeDetermineBtnColor:function(type){
            if(type == "yes"){
                this._determineBtn.css("opacity","0.5");
            }else{
                this._determineBtn.css("opacity","");
            } 
        },
        //改变完成按钮颜色（表示禁止点击）
        changeCompleteBtnColor:function(type){
            if(type == "yes"){
                this._completeBtn.css("opacity","0.5");
            }else{
                this._completeBtn.css("opacity","");
            } 
        },
        //改变右边操作按钮颜色（表示禁止点击）
        changeBtnColor:function(type){
            if(type == "yes"){
                this._rightContainer.css("opacity","0.5");
            }else{
                this._rightContainer.css("opacity","");
            } 
        },
        //改变左边操作按钮演示（表示禁止点击）
        changeLeftBtnColor:function(type){
            if(type == "yes"){
                this._leftContainer.css("opacity","0.5");
            }else{
                this._leftContainer.css("opacity","");
            } 
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});