/*
*   2020年10月23日
*   
*   封装云空间手机端滑动通用组件
*
*   开发者：付长建 
*/
define(["iscroll"],function(iscroll){
    $.widget("ys.CommonIscroll",{
        //默认参数
        options:{
            isRefresh:true,//是否开启下拉刷新
            isLoad:true,//是否开启上拉加载
            loadNumm:100,//每次加的载数据量（注意：这个参数直接控制了是否会抛出上拉加载更多）
            isUploadBtn:true,//是否开启没有数据上传按钮
            uploadBtn:"立即上传",//滚动容器上传按钮文字
            listNoDataText:"暂无数据！",//列表没有数据提示语
            searchNoDataText:"没有找到你要的数据！",//搜索没有数据提示语 
            isPaddingBottom:"0px",//滚动容器的下padding值
        },
        _iscroll:null,//滚动插件
        _iscrollContainer:null,//滚动容器
        _refreshElement:null,//下拉刷新元素
        _loadElement:null,//上拉加载更多元素
        _listNoDataMask:null,//列表没有数据提示层
        _searchNoDataMask:null,//搜索没有数据提示层
        _uploadBtn:null,//上传按钮元素
        _isRefresh:1,//是否可以刷新（注意：1表示不能显示刷新元素，2表示可以显示刷新元素，3表示可以下拉刷新）
        _isTimes:true,//控制下拉刷新多次执行参数
        _loadMore:false,//是否还有上拉加载更多数据
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            //判断初始化元素是否有id
            if(this.element.attr("id") == "" || this.element.attr("id") == null || this.element.attr("id") == undefined){
                alert("初始化元素必须要有一个唯一id");
                return;
            }
            //创建滚动数据容器
            this._iscrollContainer = $("<ul style='width:100%;min-height:"+(this.element.height() + 1)+"px;padding-bottom:"+this.options.isPaddingBottom+";box-sizing:border-box;position:relative;'></ul>").appendTo(this.element);
            //初始化滚动插件
            this._iscroll = new iscroll("#" + this.element.attr("id"),{
                click:that._iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });
            //判断是否开启了下拉刷新
            if(this.options.isRefresh){
                this.element.css("position","relative");
                //创建下拉刷新元素
                this._refreshElement = $("<div class='refreshElement' style='width:100%;height:0.8rem;position:absolute;left:0;top:-0.8rem;display:flex;flex-direction:column;align-items:center;opacity:0;'></div>").prependTo(this.element);
                var refreshIconContainer = $("<div style='width:0.44rem;height:0.44rem;margin-top:0.08rem;display:flex;align-items:center;justify-content:center;'></div>").appendTo(this._refreshElement);
                $("<img style='width:width:0.22rem;height:0.22rem;' src='"+skinConfig(global.skin).shllWebIon+"pull_load.png'/>").appendTo(refreshIconContainer);
                $("<span style='font-size:0.12rem;color:#999;'>下拉刷新</span>").appendTo(this._refreshElement);
            }
            //判断是否开启了上拉加载更多
            if(this.options.isLoad){
                this._loadElement = $("<div class='loadElement' style='width:100%;height:0.5rem;display:flex;flex-direction:row;align-items:center;justify-content:center;'></div>");
                $("<img style='width:0.22rem;' src='"+skinConfig(global.skin).shllWebIon+"pull_load.png'/>").appendTo(this._loadElement);
                $("<span style='font-size:0.13rem;color:#666;margin-left:0.1rem;'>上拉加载更多</span>").appendTo(this._loadElement);
            }
            //创建没有数据提示层
            this._listNoDataMask = $("<div style='width:100%;height:"+this.element.height()+"px;display:none;flex-direction:column;align-items:center;'></div>").appendTo(this._iscrollContainer);
            $("<img style='width:2.4rem;height:2rem;margin-top:0.5rem;' src='"+skinConfig(global.skin).shllWebIon+"no_data.png'/>").appendTo(this._listNoDataMask);
            $("<span style='fond-size:0.14rem;color:#898D97;margin-top:0.1rem;'>"+this.options.listNoDataText+"</span>").appendTo(this._listNoDataMask);
            //判断是否有上传按钮
            if(this.options.isUploadBtn){
                this._uploadBtn = $("<div style='width:1.1rem;height:0.4rem;display:flex;margin-top:0.2rem;align-items:center;justify-content:center;font-size:0.15rem;color:#fff;background:"+skinConfig(global.skin).backColor+";border-radius:0.2rem;'>"+this.options.uploadBtn+"</div>").appendTo(this._listNoDataMask);
                this._uploadBtn.bind("click",this,this._uploadBtnClick);//如果开启了上传按钮给上传按钮绑定点击事件
            }
            //创建搜索没有数据提示层
            this._searchNoDataMask = $("<div style='width:100%;height:"+this.element.height()+"px;display:none;flex-direction:column;align-items:center;'></div>").appendTo(this._iscrollContainer);
            $("<img style='width:2.4rem;height:2rem;margin-top:0.8rem;' src='"+skinConfig(global.skin).shllWebIon+"search_no_data.png'/>").appendTo(this._searchNoDataMask);
            $("<span style='fond-size:0.14rem;color:#898D97;margin-top:0.1rem;'>"+this.options.searchNoDataText+"</span>").appendTo(this._searchNoDataMask);
            //创建加载提示层
            this._loadMask = $("<div style='width:100%;height:"+this.element.height()+"px;display:none;flex-direction:column;align-items:center;justify-content:center;'></div>").appendTo(this._iscrollContainer);
            $("<img class='iconRotate' style='width:0.25rem;height:0.25rem;position:relative;top:-0.5rem;' src='"+skinConfig(global.skin).shllWebIon+"load.png'/>").appendTo(this._loadMask);
            //创建错误提示层
            this._errorMask = $("<div style='width:100%;height:"+this.element.height()+"px;display:none;flex-direction:column;align-items:center;justify-content:center;'></div>").appendTo(this._iscrollContainer);
            $("<img style='width:2.4rem;height:2rem;margin-top:-1rem;' src='"+skinConfig(global.skin).shllWebIon+"error_icon.png'/>").appendTo(this._errorMask);
            $("<span style='fond-size:0.14rem;color:#898D97;margin-top:0.1rem;'>服务开小差了!</span>").appendTo(this._errorMask);
            //判断是否开启了下拉刷新
            if(this.options.isRefresh){
                this._touchstart();//调用滚动容器手指按下事件
                this._touchmove();//调用滚动容器手指移动事件
                this._touchend();//调用滚动容器手指抬起事件
            }
            this._monitorStartScroll();//调用监听滚动容器滚动事件
            this._monitorEndScroll();//调用监听容器滚动结束事件
        },
        //判读设备函数（主要解决点击事件失效问题）
        _iScrollClick:function(){
            if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
            if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
            if (/Silk/i.test(navigator.userAgent)) return false;
            if (/Android/i.test(navigator.userAgent)) {
            var s=navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
                return parseFloat(s[0]+s[3]) < 44 ? false : true
            }
        },
        //监听滚动容器滚动事件
        _monitorStartScroll:function(){
            var that = this;//改变this指向
            this._iscroll.on("scroll",function(){
                //判断是否开启了下拉刷新和上拉加载更多
                if(that.options.isRefresh){
                    //判断下拉刷新元素是否跟着下拉
                    if(parseInt(this.y) >= 0 && that._isRefresh == 2){
                        that._refreshElement.css("opacity","");
                        that._refreshElement.css("top","-" + (that._refreshElement.height() - parseInt(this.y)) + "px");//定位下拉刷新元素
                        //判断改变下拉刷新元素文字提示
                        if(parseInt(this.y) >= that._refreshElement.height()){
                            that._refreshElement.children("span").html("松开刷新");
                        }else{
                            that._refreshElement.children("span").html("下拉刷新");
                        }
                    }else{
                        //判断是否可以刷新
                        if(that._isRefresh == 3){
                            //判断是否到刷新点
                            if(parseInt(this.y) <= that._refreshElement.height()){
                                //判断多次执行 
                                if(that._isTimes){
                                    that._isTimes = false;
                                    that._iscroll.options.bounce = false;//关闭回弹效果
                                    that._iscroll.enabled = false;//禁止最大容器滑动
                                    that._refreshElement.children("div").children("img").addClass("iconRotate");
                                    that._refreshElement.children("span").html("正在刷新");
                                    that._iscrollContainer.css("transform","translate(0px, "+that._refreshElement.height()+"px) translateZ(0px)");
                                    that.element.trigger("ISCROLL_REFRESH");//抛出下拉刷新事件
                                }
                            }
                        }else{
                            that._refreshElement.css("opacity","0");
                        }
                    }
                    //判断是否开启上来加载更多
                    if(that.options.isLoad){
                        //判断是否还有上拉加载更多的数据
                        if(that._loadMore){
                            if(parseInt(this.y) * -1 >= parseInt(this.maxScrollY) * -1){
                                //判断多次执行 
                                if(that._isTimes){
                                    that._isTimes = false;
                                    that._iscroll.options.bounce = false;//关闭回弹效果
                                    that._iscroll.enabled = false;//禁止最大容器滑动
                                    that._iscrollContainer.css("transform","translate(0px, "+parseInt(this.maxScrollY)+"px) translateZ(0px)");
                                    that._loadElement.children("img").addClass("iconRotate");
                                    that._loadElement.children("span").html("正在加载，请稍后...");
                                    that.element.trigger("ISCROLL_LOAD_MORE");//抛出上拉加载更多事件
                                }
                            }
                        }
                    }
                }
                that.element.trigger("SCROLL_SLL");//抛出滚动事件
            });
        },
        //监听容器滚动结束事件
        _monitorEndScroll:function(){
            //判断是否开启了上拉加载更多和下拉刷新
            var that = this;//改变this指向
            this._iscroll.on("scrollEnd",function(){
                if(that.options.isRefresh){
                    //判断是否可以刷新
                    if(that._isRefresh == 1 || that._isRefresh == 2){
                        that._refreshElement.css("top","-" + that._refreshElement.height() + "px");//定位下拉刷新元素   
                    }
                }
                that.element.trigger("SCROLL_END");//抛出滚动结束事件
            });
        },
        //滚动容器手指按下事件
        _touchstart:function(){
            var that = this;
            this._iscrollContainer.bind("touchstart",function(){
                //判断当前是否正在刷新
                if(that._isTimes){
                    //判断当手指触摸屏幕时，当前滚动距离
                    if(parseInt(that._iscroll.y) >= -1){
                        that._isRefresh = 2;
                    }else{
                        that._isRefresh = 1;
                    }
                }
            });
        },
        //滚动容器手指移动事件
        _touchmove:function(){
            var that = this;
            this._iscrollContainer.bind("touchmove",function(){
                //判断当前是否正在刷新
                if(that._isTimes){
                    //判断下拉距离
                    if(parseInt(that._iscroll.y) >= that._refreshElement.height()){
                        that._refreshElement.css("top","0px");//定位下拉刷新元素
                    }
                }
            });
        },
        //滚动容器手指抬起事件
        _touchend:function(){
            var that = this;
            this._iscrollContainer.bind("touchend",function(){
                //判断当前是否正在刷新
                if(that._isTimes){
                    //判断下拉距离
                    if(parseInt(that._iscroll.y) >= that._refreshElement.height()){
                        that._isRefresh = 3;
                        that._refreshElement.css("top","0px");//定位下拉刷新元素
                    }
                }
            }); 
        },
        //点击上传按钮
        _uploadBtnClick:function(event){
            event.data.element.trigger("UPLOAD_BTN_CLICK");//抛出上传按钮被点击
        },
        //第一次初始化数据方法
        initNode:function(nodeArray){
            this.emptyNode();//调用清空节点方法
            //循环生成列表
            for(var i = 0; i < nodeArray.length; i++){
                nodeArray[i].appendTo(this._iscrollContainer);
            }
            //判断是否开启了更多
            if(this.options.isLoad){
                //判断当前列表容器的高度是否够一屏（如果不够一屏即使开启了上拉加载更多也不添加上拉加载更多元素）
                if(this._iscrollContainer.height() > this.element.height() + 1){
                    //判断是否需要添加更多
                    var str = nodeArray.length / this.options.loadNumm + "";
                    if(str.indexOf(".") == -1){
                        this._loadElement.appendTo(this._iscrollContainer);//添加上拉加载更多元素
                        this._loadElement.children("span").html("上拉加载更多");
                        this._loadElement.children("img").css("display","");
                        this._loadMore = true;//还有上拉加载更多数据
                    }else{
                        this._loadElement.appendTo(this._iscrollContainer);//添加上拉加载更多元素
                        this._loadElement.children("img").css("display","none");
                        this._loadElement.children("span").html("- 没有更多了 -");
                        this._loadMore = false;//没有上拉加载更多数据
                    }
                }else{
                    this._loadMore = false;//没有上拉加载更多数据
                }
            }
            this._isRefresh = 1;//允许下拉刷新
            this._isTimes = true;//允许下拉刷新
            this._iscroll.options.bounce = true;//开启回弹效果
            this._iscroll.enabled = true;//允许最大容器滑动
            this._iscroll.refresh();//刷新高度
        },
        //下拉刷新生成数据方法
        refreshNode:function(nodeArray){
            this.initNode(nodeArray);
        },
        //上拉加载更多生成数据方法
        addNode:function(nodeArray){
            //循环生成列表
            for(var i = 0; i < nodeArray.length; i++){
                this._iscrollContainer.children(".loadElement").before(nodeArray[i]);
            }
            //判断改变上拉加载更多元素
            var str = nodeArray.length / this.options.loadNumm + "";
            if(str.indexOf(".") == -1){
                this._loadMore = true;//还有上拉加载更多数据
                this._loadElement.children("img").attr("src",skinConfig(global.skin).shllWebIon + "pull_load.png");
                this._loadElement.children("span").html("上拉加载更多");
            }else{
                this._loadElement.children("img").css("display","none");
                this._loadElement.children("span").html("- 没有更多了 -");
                this._loadMore = false;//没有上拉加载更多数据
            }
            //判断是否有数据
            if(nodeArray.length == 0){
                this._loadElement.children("img").css("display","none");
                this._loadElement.children("span").html("- 没有更多了 -");
                this._loadMore = false;//没有上拉加载更多数据
            }
            this._isRefresh = 1;//允许下拉刷新
            this._isTimes = true;//允许下拉刷新
            this._iscroll.options.bounce = true;//开启回弹效果
            this._iscroll.enabled = true;//允许最大容器滑动
            this._iscroll.refresh();//刷新高度
        },
        //搜索数据
        searchNode:function(nodeArray){
            this.initNode(nodeArray);
        },
        //显示立即上传按钮
        showUploadBtn:function(){
            this._uploadBtn.css("display","flex");
        },
        //隐藏立即上传按钮
        hideUploadBtn:function(){
            this._uploadBtn.css("display","none");
        },
        //显示列表没有数据提示层
        showListNoDataMask:function(text){
            this.emptyNode();
            this._listNoDataMask.css("display","flex");
            if(text != undefined || text != null || text != ""){
                this._listNoDataMask.children("span").html(text);
            }
            this.refreshList();
        },
        //隐藏列表没有数据提示层
        hideListNoDataMask:function(){
            this._listNoDataMask.css("display","none");
        },
        //显示搜索没有数据提示层
        showSearchNoDataMask:function(text){
            this.emptyNode();
            this._searchNoDataMask.css("display","flex");
            if(text != undefined || text != null || text != ""){
                this._searchNoDataMask.children("span").html(text);
            }
            this.refreshList();
        },
        //隐藏搜索没有数据提示层
        hideSearchNoDataMask:function(){
            this._searchNoDataMask.css("display","none");
        },
        //显示加载提示层
        showLoadMask:function(){
            this._isTimes = false;//禁止下拉刷新
            this._iscroll.options.bounce = false;//关闭回弹效果
            this._iscroll.enabled = false;//禁止滚动容器刷新
            this._searchNoDataMask.css("display","none");
            this._errorMask.css("display","none");
            this._listNoDataMask.css("display","none");
            this._loadMask.css("display","flex");
        },
        //隐藏加载提示层
        hideLoadMask:function(){
            this._isTimes = true;//禁止下拉刷新
            this._iscroll.options.bounce = true;//关闭回弹效果
            this._iscroll.enabled = true;//禁止滚动容器刷新
            this._listNoDataMask.css("display","none"); 
        },
        //显示错误提示层
        showErrorMask:function(text){
            this._searchNoDataMask.css("display","none");
            this._loadMask.css("display","none");
            this._listNoDataMask.css("display","none");
            this._errorMask.css("display","flex");
            if(text == undefined || text == null || text == ""){
                this._errorMask.children("span").html("服务开小差了!");
            }else{
                this._errorMask.children("span").html(text);
            }
        },
        //下拉刷新成功和失败方法text为空表示成功不为空表示失败
        refreshSuccessAndFail:function(text){
            this._refreshElement.children("div").children("img").removeClass("iconRotate");
            //判断是成功还是失败
            if(text == undefined || text == null || text == ""){
                this._refreshElement.children("span").html("刷新成功");
                this._refreshElement.children("div").children("img").attr("src",skinConfig(global.skin).shllWebIon + "more_success_icon.png");
            }else{
                this._refreshElement.children("span").html(text); 
                this._refreshElement.children("div").children("img").attr("src",skinConfig(global.skin).shllWebIon + "no_more.png");
            }
            //为了让用户看清楚到底时刷新成功还是失败这里采用延迟1200毫秒执行回弹
            setTimeout(function(that){
                var refreshElementHeight = parseInt(that._refreshElement.height());//获取下拉刷新元素的高度
                var time = setInterval(function(){//开启一个定时器模拟回弹效果
                    if(refreshElementHeight > 0){
                        refreshElementHeight = refreshElementHeight - 2;
                        that._refreshElement.css("top","-" + (that._refreshElement.height() - refreshElementHeight) + "px");
                        that._iscrollContainer.css("transform","translate(0px, "+refreshElementHeight+"px) translateZ(0px)");
                    }else{
                        clearInterval(time); 
                        that._refreshElement.css("top","-" + that._refreshElement.height() + "px");
                        that._refreshElement.children("div").children("img").attr("src",skinConfig(global.skin).shllWebIon + "pull_load.png");
                        that.element.trigger("REFRESH_COMPLETE");//抛出下拉刷新完成事件
                        that._isRefresh = 1;//允许下拉刷新
                        that._isTimes = true;//允许下拉刷新
                        that._iscroll.options.bounce = true;//开启回弹效果
                        that._iscroll.enabled = true;//允许最大容器滑动
                        that._iscrollContainer.css("transform","translate(0px, 0px) translateZ(0px)");
                    }
                },5);
            },1000,this);
        },
        //上拉加载更多成功方法和失败方法
        loadMoreSuccessAndFail:function(text){
            var that = this;
            //判断是成功还是失败
            this._loadElement.children("img").removeClass("iconRotate");
            if(text == undefined || text == null || text == ""){
                this._loadElement.children("img").attr("src",skinConfig(global.skin).shllWebIon + "more_success_icon.png");
                this._loadElement.children("span").html("加载成功");
                //延迟1200毫秒抛出加载完成事件
                setTimeout(function(){
                    that.element.trigger("LOAD_COMPLETE");//抛出上拉加载更多完成事件
                    that._loadElement.children("img").attr("src",skinConfig(global.skin).shllWebIon + "pull_load.png");
                },1000);  
            }else{
                this._loadElement.children("span").html(text);
                this._loadElement.children("img").attr("src",skinConfig(global.skin).shllWebIon + "no_more.png");
                //为了让用户看清楚到底时刷新成功还是失败这里采用延迟1200毫秒执行回弹
                setTimeout(function(){
                    that._iscroll.options.bounce = true;//开启回弹效果
                    that._iscroll.enabled = true;//允许最大容器滑动
                    var maxScrollY = that._iscroll.maxScrollY + that._loadElement.height();//得到滚动容器最大坐标
                    that._iscroll.scrollTo(0,maxScrollY,400);//滚动到指定位置
                    setTimeout(function(){
                        that._isRefresh = 1;//允许下拉刷新
                        that._isTimes = true;//允许下拉刷新
                        that._loadElement.children("img").attr("src",skinConfig(global.skin).shllWebIon + "pull_load.png");
                        that._loadElement.children("span").html("上拉加载更多");
                        that.element.trigger("LOAD_COMPLETE");//抛出上拉加载更多完成事件
                    },400);
                },1000);
            }
        },
        //清空所有列表方法
        emptyNode:function(){
            this._searchNoDataMask.css("display","none");
            this._loadMask.css("display","none");
            this._listNoDataMask.css("display","none");
            this._errorMask.css("display","none");
            this._iscrollContainer.find("li").remove();
            this._iscrollContainer.find(".loadElement").remove();
            this.refreshList();//刷新高度
        },
        //改变滚动容器的最小高度和那些遮罩提示的高度
        changeIscrollContainerMinHeight:function(height){
            this.element.css("transition","all 0.3s");
            this.element.css("height",height + "px");
            setTimeout(function(that){
                that.element.css("transition","");
                that._iscrollContainer.css("min-height",height + 1 + "px");
                that._listNoDataMask.css("height",height + "px");
                that._searchNoDataMask.css("height",height + "px");
                that._loadMask.css("height",height + "px");
                that._errorMask.css("height",height + "px");
                that._iscroll.refresh();
                that.element.trigger("CHANGE_COMPLETE");
            },310,this)
            
        },
        //锁定和解锁所有列表组件yes表示锁定no表示解锁
        lock:function(type){
            if(type == "yes"){
                this._iscrollContainer.css("pointer-events","none");
                this._iscrollContainer.children("div").css("pointer-events","none");
                this._iscrollContainer.children("li").css("pointer-events","none");
                this._isRefresh = 1;//允许下拉刷新
                this._isTimes = false;//禁止下拉刷新
                this._iscroll.options.bounce = false;//关闭回弹效果
                this._iscroll.enabled = false;//禁止滚动容器刷新
            }else{
                this._iscrollContainer.css("pointer-events","");
                this._iscrollContainer.children("div").css("pointer-events","");
                this._iscrollContainer.children("li").css("pointer-events","");
                this._isRefresh = 1;//允许下拉刷新
                this._isTimes = true;//禁止下拉刷新
                this._iscroll.options.bounce = true;//关闭回弹效果
                this._iscroll.enabled = true;//禁止滚动容器刷新
            }
        },
        //刷新方法
        refreshList:function(){
            this._isRefresh = 1;//允许下拉刷新
            this._isTimes = true;//禁止下拉刷新
            this._iscroll.options.bounce = true;//关闭回弹效果
            this._iscroll.enabled = true;//禁止滚动容器刷新
            this._iscroll.refresh();//刷新高度
        },
        //添加单一节点方法
        addElement:function(node){
            node.prependTo(this._iscrollContainer);
        },
        //禁止滚动容器滚动
        isIscroll:function(type){
            if(type == "yes"){
                this._iscroll.options.bounce = false;//关闭回弹效果
                this._iscroll.enabled = false;//禁止滚动容器滚动
            }else{
                this._iscroll.options.bounce = true;//开启回弹效果
                this._iscroll.enabled = true;//允许滚动容器滚动
            }
        },
        //改变滚动容器的位置
        setIscroll:function(numm){
            var height = numm - this._iscrollContainer.css("transform").replace(/[^0-9\-,]/g,'').split(',')[5];
            this._iscroll.scrollTo(0,-height,300);
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});