/*
*   2020年11月13日
*   
*   封装云空间手机端通用错误提示飘窗组件
*
*   开发者：付长建 
*/
define(["Shell","CommonHead","CommonToast"],function(Shell){
    $.widget("ys.CommonLinkSearch",{
        //默认参数
        options:{
            timeArray:["1天","15天","30天","永久"],
            pwdArray:["A","B","C","D","E","F","G","H","I","J","K","R","M","N","O","P","Q","S","T","U","V","W","S","Y","Z","X"],
            commonToast:null,//飘窗提示
            url:"",//创建链接接口
            uuid:"",//文件id
            name:""//文件名称
        },
        _headContainer:null,//头部组件
        _linkTimeContainer:null,//链接有效期板块（没有点击下一步之前内容容器）
        _timeContainer:null,//有效时间选择外层容器
        _timeContent:null,//有效时间选择容器
        _pwdSwitchContainer:null,//密码开关容器
        _pwdSwitch:null,//密码开关
        _btnContainer:null,//按钮容器
        _btn:null,//按钮元素
        _time:null,//创建链接时间
        _isClick:true,//防止多次执行
        _pwd:"",//密码
        _validTime:"",//有效时间
        _validTimeText:"永久",//时间显示文字
        _linkUrl:"",//创建成功的链接
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            //给初始化元素添加css样式
            this.element.css({
                "position":"fixed",
                "top":"0",
                "left":this.element.width() + "px",
                "box-shadow":"-6px 3px 4px 1px rgba(0, 37, 87, 0.04)",
                "transition":"all 0.3s",
                "overflow":"hidden"
            });
            //初始化头部组件
            this._headContainer = $("<div style='background:#fff;'></div>").appendTo(this.element);
            this._headContainer.CommonHead({"isGoback":true,"title":"创建链接"});

            //创建文件分享有效期板块
            this._linkTimeContainer = $("<div style='width:100%;margin-top:0.1rem;'></div>").appendTo(this.element);
            this._timeContainer = $("<div style='width:100%;background:#fff;overflow:hidden;'></div>").appendTo(this._linkTimeContainer);
            $("<p style='font-size:0.14rem;margin:0.1rem 0 0.15rem 0;padding-left:0.15rem;box-sizing:border-box;'>文件分享有效期</p>").appendTo(this._timeContainer);
            this._timeContent = $("<ul style='width:100%;display:flex;flex-direction:row;margin-bottom:0.1rem;'></ul>").appendTo(this._timeContainer);
            for(var i = 0; i < this.options.timeArray.length; i++){
                var li = $("<li style='width:25%;height:0.3rem;display:flex;flex-direction:row;align-items:center;justify-content:center;flex-shrink:0;'></li>").appendTo(this._timeContent);
                var selectContainer = $("<div style='width:0.19rem;height:0.19rem;border:1px solid #ECECEC;box-sizing:border-box;display:flex;align-items:center;justify-content:center;border-radius:50%;'></div>").appendTo(li);
                $("<div style='width:0.11rem;height:0.11rem;border-radius:50%;background:"+skinConfig(global.skin).backColor+";display:none;'></div>").appendTo(selectContainer);
                $("<span style='font-size:0.12rem;color:rgb(66,78,103);margin-left:0.05rem;font-weight:bold;'>"+this.options.timeArray[i]+"</span>").appendTo(li);
                if(i == this.options.timeArray.length - 1){
                    selectContainer.children("div").css("display","");
                    li.addClass("select");
                }
            }
            //创建密码开关容器
            var pwdContainer = $("<div style='width:100%;height:0.44rem;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;background:#fff;display:flex;flex-direction:row;margin-top:0.2rem;justify-content:space-between;'></div>").appendTo(this._linkTimeContainer);
            $("<p style='height:100%;display:flex;align-items:center;font-size:0.14rem;'>加密分享</p>").appendTo(pwdContainer);
            this._pwdSwitchContainer = $("<div style='height:100%;display:flex;align-items:center;'></div>").appendTo(pwdContainer);
            this._pwdSwitch = $("<div isSwitch='no' style='width:52px;height:30px;border-radius:0.2rem;border:1px solid #dfdfdf;box-sizing:border-box;background:#fff;position:relative;transition:all 0.3s;'></div>").appendTo(this._pwdSwitchContainer);
            $("<div style='width:28px;height:28px;border-radius:50%;background:#fff;box-shadow:0 1px 3px rgba(0, 0, 0, 0.4);position:absolute;top:0;left:0;transition:all 0.3s;'></div>").appendTo(this._pwdSwitch);
           
            //链接创建成功板块
            this._successContainer = $("<div style='width:100%;padding:0.1rem 0.15rem 0.1rem 0.15rem;margin-top:0.1rem;box-sizing:border-box;background:#fff;display:none;'></div>").appendTo(this.element);
            $("<p style='width:100%;height:0.4rem;line-height:0.4rem;font-size:0.16rem;color:rgb(102,102,102);display:-webkit-box;-webkit-line-clamp:1;-webkit-box-orient:vertical;text-overflow:ellipsis;white-space:nowrap;overflow:hidden;'></p>").appendTo(this._successContainer);
            $("<p style='width:100%;height:0.4rem;line-height:0.4rem;font-size:0.16rem;color:rgb(102,102,102);'></p>").appendTo(this._successContainer);
            $("<p style='width:100%;height:0.4rem;line-height:0.4rem;font-size:0.16rem;color:rgb(102,102,102);'></p>").appendTo(this._successContainer);

            //创建按钮
            this._btnContainer = $("<div style='width:100%;height:0.5rem;padding:0 0.3rem 0 0.3rem;box-sizing:border-box;margin-top:0.8rem;'></div>").appendTo(this.element);
            this._btn = $("<div data='next' style='width:100%;height:100%;display:flex;align-items:center;justify-content:center;background:"+skinConfig(global.skin).linearBackColor+";font-size:0.18rem;color:#fff;border-radius:0.25rem;'>下一步</div>").appendTo(this._btnContainer);

            //监听头部组件点击返回按钮
            this._headContainer.bind("GOBACK_BTN_CLICK",function(){
                that.element.css("transition","0.3s");
                that.element.css("left",that.element.width() + 10 + "px");
                that.element.trigger("LINK_GOBACK_CLOSE");
                setTimeout(function(){
                    that.destroy();
                },310);
            });
            //给有效时间选项绑定点击事件
            this._timeContent.find("li").bind("click",this,this._timeSelectClick);
            //给加密分享按钮绑定点击事件
            this._pwdSwitch.bind("click",this,this._pwdSwitchClick);
            //给按钮绑定点击事件
            this._btn.bind("click",this,this._btnClick);
            //按钮按下抬起效果
            this._btnTextCommon(this._btn);
            //给初始化元素绑定点击事件主要防止事件冒泡
            this.element.bind("click",function(event){
                event.stopPropagation();
            });
            //给初始化元素绑定手指事件
            this._finger();
        },
        //组件手指事件
        _finger:function(){
            var that = this;
            var pageX = 0;
            this.element.on("touchstart",function(e){
                var touch = e.originalEvent,startX = touch.changedTouches[0].pageX;
                if(startX <= 80){
                    $(this).css("transition","");
                    $(this).on("touchmove",function(e){
                        e.preventDefault();
                        touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
                        pageX = touch.pageX;
                        if(pageX > 0){
                            $(this).css("left",pageX + "px");
                        }
                    });
                }
            }).on("touchend",function(){
                $(this).css("transition","0.3s");
                if(pageX >= 50){
                    that._headContainer.trigger("GOBACK_BTN_CLICK");
                }else{
                    $(this).css("left","0px");
                }
                $(this).off("touchmove");
            });
        },
        //组件初始化成功主动执行
        _init:function(){
            this._time = null,//创建链接时间
            this._isClick = true;//防止多次执行
            this._pwd = "";//密码
            this._validTime = "";//有效时间
            this._validTimeText = "永久";//有效时间文字
            this._linkUrl = "";//创建成功的链接
            setTimeout(function(that){
                that.element.css("left","0px");
            },50,this);
        },
        //点击时间选项方法
        _timeSelectClick:function(event){
            event.data._timeContainer.find("li").removeClass("select");
            event.data._timeContainer.find("li").children("div").children("div").css("display","none");
            $(this).addClass("select");
            $(this).children("div").children("div").css("display","");
            event.data._validTime = Date.parse(new Date()) / 1000;//有效时间
            if($(this).children("span").html() == "1天"){
                event.data._validTime = event.data._validTime + 24 * 60 * 60;
                event.data._validTimeText = "1天";
            }else if($(this).children("span").html() == "15天"){
                event.data._validTime = event.data._validTime + 15 * 24 * 60 * 60;
                event.data._validTimeText = "15天";
            }else if($(this).children("span").html() == "30天"){
                event.data._validTime = event.data._validTime + 30 * 24 * 60 * 60;
                event.data._validTimeText = "30天";
            }else if($(this).children("span").html() == "永久"){
                event.data._validTime = 0;
                event.data._validTimeText = "";
            }
        },
        //点击密码开关
        _pwdSwitchClick:function(event){
            if($(this).attr("isSwitch") == "no"){
                $(this).children("div").css("left","22px");
                $(this).css({"background":skinConfig(global.skin).backColor,"border-color":skinConfig(global.skin).backColor});
                $(this).attr("isSwitch","yes");	
                for(var i = 0; i < 4; i++){
                    event.data._pwd = event.data._pwd + event.data.options.pwdArray[Math.floor(Math.random() * event.data.options.pwdArray.length)];
                }
            }else{
                $(this).children("div").css("left","0px");
                $(this).css({"background":"#fff","border-color":"#dfdfdf"});
                $(this).attr("isSwitch","no");
                event.data._pwd = "";
            }
        },
        //点击下一步和完成并复制链接按钮
        _btnClick:function(event){
            //判读多次执行
            if(event.data._isClick){
                event.data._isClick = false;
                event.data._headContainer.CommonHead("lock","yes");//锁定头部组件禁止点击
                event.data._headContainer.CommonHead("changeGobackBtnColor","yes");//改变返回按钮的颜色
                //判断当前下一步还是完成并复制按钮
                if($(this).attr("data") == "next"){
                    $(this).attr("data","success");
                    event.data._establishLink();//调用创建链接方法
                }else{
                    Shell.sendEvent("copyLink",{"name":event.data._linkUrl});
                    event.data.options.commonToast.CommonToast("showToast","复制成功");
                    setTimeout(function(){
                        event.data.options.commonToast.CommonToast("hideToast");
                        setTimeout(function(){
                            event.data.element.css("left",event.data.element.width() + 10 + "px");
                            event.data.element.trigger("LINK_GOBACK_CLOSE");
                            setTimeout(function(){
                                event.data.destroy();
                            },310);
                        },300);
                    },1500);
                }
            }
        },
        //创建链接方法
        _establishLink:function(){
            var that = this;
            //如果两秒都还没有得到接口返回提示正在创建链接提示
            that._time = setTimeout(function(){
                that.options.commonToast.CommonToast("showToast","正在创建链接，请稍后...");
            },2000);
            //请求参数
            var paramet = {"token":getUrl("token"),"uuid":that.options.uuid,"name":that.options.name,"visit_password":that._pwd,"overtime":that._validTime,"type":0};
            http(that.options.url,paramet,{
                success:function(arg){
                    clearTimeout(that._time);//清除延时
                    if(parseInt(arg.code) == 1){
                        //判断飘窗是否显示了
                        if(that.options.commonToast.attr("isShow") != "no"){
                            that.options.commonToast.CommonToast("showToast","创建成功");//显示飘窗提示
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                                that._headContainer.CommonHead("lock","no");//解锁头部组件禁止点击
                                that._isClick = true;//允许点击
                                that._headContainer.CommonHead("changeGobackBtnColor","no");//改变返回按钮的颜色
                            },1500);  
                        }else{
                            that._headContainer.CommonHead("lock","no");//解锁头部组件禁止点击
                            that._headContainer.CommonHead("changeGobackBtnColor","no");//改变返回按钮的颜色
                            that._isClick = true;//允许点击
                        }
                        that._linkUrl = "链接：" + arg.data.url + (that._pwd != "" ? " 密码：" + that._pwd : "");
                        that._successContainer.find("p").eq(0).html("链接：" + arg.data.url);
                        that._successContainer.find("p").eq(1).html("分享文件有效期：" + that._validTimeText);
                        //判断是否有密码
                        if(that._pwd != ""){
                            that._successContainer.find("p").eq(2).html("提取密码：" + that._pwd);
                        }else{
                            that._successContainer.find("p").eq(2).css("display","none");
                        }
                        that._linkTimeContainer.css("display","none");
                        that._successContainer.css("display","");
                        that._btnContainer.css("margin-top","0.88rem");
                        that._headContainer.CommonHead("changeTitle","复制链接");//改变头部title文字
                        that._btn.html("完成并复制链接");
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            //判断飘窗是否显示了
                            if(that.options.commonToast.attr("isShow") == "no"){
                                that.options.commonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            }else{
                                that.options.commonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            }
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                                that._headContainer.CommonHead("lock","no");//解锁头部组件禁止点击
                                that._headContainer.CommonHead("changeGobackBtnColor","no");//改变返回按钮的颜色
                                that._isClick = true;//允许点击
                            },1500);
                        }
                    }
                }
            });
        },
        //所有的按钮和可以点击的文本按下和抬起事件方法
        _btnTextCommon:function(element){
            //给选项绑定手指按下事件
            element.bind('touchstart',function(){
                $(this).css("opacity","0.5");
            });
            //给选项绑定手指抬起事件
            element.bind('touchend',function(){
                $(this).css("opacity","");
            });
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
            this.element.remove();
        }
    });
});