/*
*   2020年11月4日
*   
*   封装云空间手机端通用移动和复制组件
*
*   开发者：付长建 
*/
define(["Shell","CommonHead","CommonSearch","CommonIscroll","CommonCell","CommonNewFolderAadRename"],function(Shell){
    $.widget("ys.CommonMoveCopy", {
        //默认参数
        options:{
            headTitle:"移动",//头部文字
            effectText:"正在移动...",//动效提示文字
            successText:"移动成功",//成功提示
            failText:"移动失败",//失败提示
            listUrl:"",//获取列表接口
            searchUrl:"",//搜索列表接口
        },
        _CommonHeadContainer:null,//头部组件
        _CommonSearchContainer:null,//搜索组件
        _effect:null,//动效元素
        _listIscrollContainer:null,//列表滚动容器
        _CommonNewFolderAadRenameContainer:null,//新建文件夹组件
        _newBtn:null,//新建文件夹按钮
        _determineBtn:null,//确定按钮
        _time:null,//加载定时器（主要控制2秒没有请求到数据显示加载提示层使用）
        _animationTime:null,//动画定时器
        _navArray:[],//层级进入数据（主要是用于点击头部返回按钮需要使用）
        _pid:0,//父级文件夹的id
        _keyword:"",//搜索关键字
        _isClick:true,//防止多次执行
        _wid:0,//动画宽度
        _title:"",//头部title文字（主要是用于移动或者复制成功抛出去给js控制器使用）
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            //给初始化元素设定指定的css样式
            this.element.css({
                "position":"fixed",
                "top":0,
                "left":this.element.width() + "px",
                "background":"#fff",
                "box-shadow":"-6px 3px 4px 1px rgba(0, 37, 87, 0.04)",
                "transition":"all 0.3s",
                "overflow":"hidden"
            });
            //初始化头部组件
            this._CommonHeadContainer = $("<div></div>").appendTo(this.element);
            this._CommonHeadContainer.CommonHead({"title":this.options.headTitle,"isCancel":true,"fontWeigth":500});
            //初始化搜索组件
            this._CommonSearchContainer = $("<div style='width:100%;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;box-shadow:0px 3px 4px 1px rgba(0, 37, 87, 0.03);background:#fff;'></div>").appendTo(this.element);
            this._CommonSearchContainer.CommonSearch();
            //创建复制移动动效模块
            var effectContainer = $("<div style='width:100%;height:0.4rem;position:relative;'></div>").appendTo(this.element);
            $("<p style='width:100%;height:100%;background:#f8f8f8;padding-left:0.15rem;line-height:0.4rem;box-sizing:border-box;font-size:0.12rem;color:#999;'>选中目标文件夹</p>").appendTo(effectContainer);
            this._effect = $("<div style='width:100%;height:100%;background:#424E67;position:absolute;top:0;display:none;'></div>").appendTo(effectContainer);
            $("<div style='width:0%;height:100%;background:"+skinConfig(global.skin).backColor+";'></div>").appendTo(this._effect);
            $("<p style='width:100%;height:100%;font-size:0.14rem;color:#fff;position:absolute;top:0;padding-left:0.15rem;box-sizing:border-box;line-height:0.4rem;'>"+this.options.effectText+" 0%</p>").appendTo(this._effect);
            //创建滚动容器
            this._listIscrollContainer = $("<div id='moveCopyContainer' style='width:100%;overflow:hidden;'></div>").appendTo(this.element);
            //创建底部确定按钮和新建文件夹按钮
            var bottom = 0;
            if(phonexh("bottom") != 0){
                if(phonexh("bottom") <= 49 || phonexh("bottom") <= 50){
                    bottom = 0;
                }else{
                    bottom = "0.2rem";
                }
            }
            var newDetermineContainer = $("<div style='width:100%;padding-bottom:"+bottom+";box-sizing:border-box;background:#fff;'></div>").appendTo(this.element);
            var newDetermine = $("<div style='width:100%;height:0.64rem;display:flex;flex-direction:row;border-top:1px solid #ECECEC;box-sizing:border-box;'></div>").appendTo(newDetermineContainer);
            this._newBtn = $("<div style='width:0.73rem;height:100%;display:flex;flex-direction:column;align-items:center;justify-content:center;flex-shrink:0;border-right:1px solid #ECECEC;box-sizing:border-box;'></div>").appendTo(newDetermine);
            $("<img style='width:0.18rem;height:0.2rem;' src='"+skinConfig(global.skin).commonIcon+"new_folder_icon.png'/>").appendTo(this._newBtn);
            $("<span style='font-size:0.14rem;margin-top:0.03rem;'>新建</span>").appendTo(this._newBtn);
            var determineContainer = $("<div style='width:100%;height:100%;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;display:flex;align-items:center;'></div>").appendTo(newDetermine);
            this._determineBtn = $("<p style='width:100%;height:0.4rem;line-height:0.4rem;text-align:center;font-size:0.16rem;color:#fff;background:"+skinConfig(global.skin).linearBackColor+";border-radius:0.2rem;'>确定</p>").appendTo(determineContainer);
            //计算滚动容器的高度
            this._listIscrollContainer.css("height",this.element.height() - this._CommonHeadContainer.outerHeight(true) - this._CommonSearchContainer.height() - effectContainer.height() - newDetermineContainer.outerHeight(true) + "px");
            //初始化滚动组件
            this._listIscrollContainer.CommonIscroll({"isRefresh":false,"isLoad":false,"isUploadBtn":false});
            
            //新建文件夹按钮按下抬起效果
            this._btnTextCommon(this._newBtn);
            //确定按钮按下抬起效果
            this._btnTextCommon(this._determineBtn);
            //给确定按钮绑定点击事件
            this._determineBtn.bind("click",this,this._determineBtnClick);
            //给新建文件夹按钮绑定点击事件
            this._newBtn.bind("click",this,this._newFolderBtnClick);
            //监听头部组件点击返回按钮 
            this._CommonHeadContainer.bind("GOBACK_BTN_CLICK",function(){
                //判读防止多次执行
                if(that._isClick){
                    that._isClick = false;//禁止点击
                    that._keyword = "";//重置搜索关键字
                    that._CommonSearchContainer.CommonSearch("emptyVal");//调用搜索组件清空搜索输入框值方法
                    that._lock("no");//调用锁定页面可以操作的元素方法
                    that._navArray.splice(that._navArray.length - 1,1);//去掉面包屑最后一个
                    //判断是否返回到最外层了
                    if(that._navArray.length != 0){
                        that._CommonHeadContainer.CommonHead("changeTitle",that._navArray[that._navArray.length - 1].name);//调用头部组件显示title文字方法
                        that._title = that._navArray[that._navArray.length - 1].name;
                        that._pid = that._navArray[that._navArray.length - 1].uuid;
                    }else{
                        that._CommonHeadContainer.CommonHead("hideGobackBtn");//调用头部组件隐藏返回按钮方法
                        that._title = "";
                        that._CommonHeadContainer.CommonHead("changeTitle",that.options.headTitle);//调用头部组件显示title文字方法
                        that._pid = 0;
                    }
                    that._getListData();//调用获取列表数据方法
                }
            });
            //监听头部组件点击取消
            this._CommonHeadContainer.bind("CANCE_BTN_CLICK",function(){
                that.element.trigger("MOVE_COPY_CANCE_BTN_CLICK");
                that.removeElement();//清除组件
            });
            //监听列表被点击 
            this._listIscrollContainer.bind("CELL_CLICK",function(event,arg){
                //判断多次执行
                if(that._isClick){
                    that._isClick = false;//禁止点击
                    that._keyword = "";//重置搜索关键字
                    that._title = arg.name;//头部title文字
                    that._CommonSearchContainer.CommonSearch("emptyVal");//调用搜索组件清空搜索输入框值方法
                    that._CommonHeadContainer.CommonHead("showGobackBtn");//调用头部组件显示返回按钮方法
                    that._CommonHeadContainer.CommonHead("changeTitle",arg.name);//调用头部组件显示title文字方法
                    that._pid = arg.uuid;//重置请求数据的pid
                    that._getListData();//调用获取列表数据方法
                    //组装返回按钮被点击需要的数据
                    var obj = {};
                    obj.uuid = arg.uuid;
                    obj.name = arg.name;
                    that._navArray.push(obj);
                }
            });
            //监听搜索组件搜索事件 
            this._CommonSearchContainer.bind("SEARCH_BTN_CLICK",function(event,val){
                //判断多次执行
                if(that._isClick){
                    that._isClick = false;//禁止点击
                    that._keyword = val;//重置搜索关键字
                    that._getListData();//调用获取列表数据方法
                    that._lock("no");//调用解锁页面可以操作的元素方法
                }
            });
            //监听搜索组件点击了清空图标 
            this._CommonSearchContainer.bind("EMPTY_BTN_CLICK",function(){
                //判断多次执行
                if(that._isClick){
                    that._isClick = false;//禁止点击
                    that._keyword = "";//重置搜索关键字
                    that._getListData();//调用获取列表数据方法
                    that._lock("no");//调用解锁页面可以操作的元素方法
                }
            });
            //实时监听输入框的值发生改变
            this._CommonSearchContainer.bind("INPUT_CHANGE_VAL",function(event,val){
                //判读值是否为空
                if(val != ""){
                    that._lock("yes");//调用锁定页面可以操作的元素方法
                }else{
                    that._lock("no");//调用解锁页面可以操作的元素方法
                }
            });
            //监听输入框获取焦点 
            this._CommonSearchContainer.bind("INPUT_FOCUS",function(event,val){
                //判读值是否为空
                if(val != ""){
                    that._lock("yes");//调用锁定页面可以操作的元素方法
                }else{
                    that._lock("no");//调用解锁页面可以操作的元素方法
                }
            });
            //给初始化元素绑定手指事件
            this._finger();
        },
        //组件手指事件
        _finger:function(){
            var that = this;
            var pageX = 0;
            this.element.on("touchstart",function(e){
                var touch = e.originalEvent,startX = touch.changedTouches[0].pageX;
                if(startX <= 80){
                    $(this).css("transition","");
                    $(this).on("touchmove",function(e){
                        e.preventDefault();
                        touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
                        pageX = touch.pageX;
                        if(pageX > 0){
                            $(this).css("left",pageX + "px");
                        }
                    });
                }
            }).on("touchend",function(){
                $(this).css("transition","0.3s");
                if(pageX >= 50){
                    that._CommonHeadContainer.trigger("CANCE_BTN_CLICK");
                }else{
                    $(this).css("left","0px");
                }
                $(this).off("touchmove");
            });
        },
        //组件初始化成功主动执行
        _init:function(){
            this._keyword = "";//重置搜索关键字
            this._navArray = [];//重置面包屑
            this._time = null;//加载定时器（主要控制2秒没有请求到数据显示加载提示层使用）
            this._animationTime = null;//动画定时器
            this._wid = 0;//动画宽度
            this._pid = 0;//父级文件夹的id
            this._title = "";//头部title文字
            this._CommonSearchContainer.CommonSearch("emptyVal");//调用搜索组件清空搜索输入框值方法
            this._lock("no");//调用锁定页面可以操作的元素方法
            this._wid = 0;//重置动画宽度
            setTimeout(function(that){
                that.element.css("left",0);
                setTimeout(function(){
                    that._getListData();//调用获取列表数据方法
                },310);
            }, 50,this);
        },
        //元素按下抬起效果
        _btnTextCommon:function(element){
            //给选项绑定手指按下事件
            element.bind('touchstart',function(){
                $(this).css("opacity","0.5");
            });
            //给选项绑定手指抬起事件
            element.bind('touchend',function(){
                $(this).css("opacity","");
            });
        },
        //获取列表接口(搜索公用)
        _getListData:function(){
            var that = this;
            this._time = setTimeout(function(){
                that._listIscrollContainer.CommonIscroll("showLoadMask");//显示加载层
            },2000);
            //请求参数
            var paramet = {"token":getUrl("token"),"uuid":this._pid,"keyword":this._keyword,"type":"part"};
            //判断是搜索还是获取列表
            var url = this.options.listUrl;//列表接口
            if(this._keyword != ""){
                url = this.options.searchUrl;//搜索接口
            }
            http(url,paramet,{
                success:function(arg){
                    that._isClick = true;//允许点击
                    clearTimeout(that._time);//清除延时
                    if(parseInt(arg.code) == 1){
                        that._generateList(arg.data.list);//调用生成列表方法
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            that._listIscrollContainer.CommonIscroll("showErrorMask",arg.msg);//显示错误提示层
                        }
                    }
                }
            });
        },
        //生成列表方法
        _generateList:function(dataArray){
            var cellArray = [];
            for(var i = 0; i < dataArray.length; i++){
                var cell = $("<li style='width:100%;padding-left:0.15rem;box-sizing:border-box;'></li>").CommonCell({
                    "commonIconUrl":skinConfig(global.skin).commonIcon,
                    "shllIconUrl":skinConfig(global.skin).shllWebIon,
                    "data":dataArray[i],
                    "isSelect":false
                });
                cellArray.push(cell);
            }
            //判读是否有数据
            if(cellArray != 0){
                this._listIscrollContainer.CommonIscroll("initNode",cellArray);
            }else{
                this._listIscrollContainer.CommonIscroll("emptyNode");//清空节点
                //判断是搜索没有数据还是列表没有数据
                if(this._keyword == ""){
                    this._listIscrollContainer.CommonIscroll("showListNoDataMask","该目录下没有文件夹");//显示没有数据提示层
                }else{
                    this._listIscrollContainer.CommonIscroll("showSearchNoDataMask","没有找到你要的文件夹");//显示没有搜索数据提示层
                }
            }
        },
        //锁定页面可以操作的元素方法
        _lock:function(type){
            this._listIscrollContainer.CommonIscroll("lock",type);//锁定和解锁列表
            this._CommonHeadContainer.CommonHead("lock",type);//锁定和解锁头部
            this._CommonHeadContainer.CommonHead("changeCancelBtnColor",type);//调用头部改变取消按钮颜色方法
            this._CommonHeadContainer.CommonHead("changeGobackBtnColor",type);//调用头部改变返回按钮颜色方法
            if(type == "yes"){
                this._newBtn.css({"pointer-events":"none","opacity":"0.5"});//锁定新建按钮
                this._determineBtn.css({"pointer-events":"none","opacity":"0.5"});//锁定确定按钮
            }else{
                this._newBtn.css({"pointer-events":"","opacity":""});//解锁新建按钮
                this._determineBtn.css({"pointer-events":"","opacity":""});//解锁确定按钮
            }
        },
        //点击确定按钮
        _determineBtnClick:function(event){
            //防止多次执行
            if(event.data._isClick){
                event.data._isClick = false;//禁止点击
                event.data._CommonHeadContainer.CommonHead("lock","yes");//锁定头部组件禁止点击
                event.data._CommonSearchContainer.CommonSearch("lock","yes");//锁定搜索组件禁止点击
                event.data.element.trigger("DETERMINE_BTN_CLICK",event.data._pid);
            }
        },
        //点击新建文件夹按钮
        _newFolderBtnClick:function(event){
            //判读多次执行
            if(event.data._isClick){
                event.data._isClick = false;//禁止点击
                openPrimordial(event.data.element,"yes");//调用模仿原生开启窗口动画
                //初始化新建文件夹组件
                event.data._CommonNewFolderAadRenameContainer = $("<div style='z-index:4;width:100%;height:100%;'></div>").appendTo($("body"));
                event.data._CommonNewFolderAadRenameContainer.CommonNewFolderAadRename();
                //监听新建确定按钮被点击
                event.data._CommonNewFolderAadRenameContainer.bind("NEW_DETERMINE_BTN_CLICK",function(e,val){
                    event.data.element.trigger("NEW_FOLDER",{"pid":event.data._pid,"name":val});//给js控制器抛出新建文件夹事件
                });
                //监听新建文件组件点击了返回 
                event.data._CommonNewFolderAadRenameContainer.bind("NEW_GOBACK_BTN_CLICK",function(){
                    openPrimordial(event.data.element,"no");//调用模仿原生开启窗口动画
                    event.data._isClick = true;//允许点击
                });
            }
        },
        //新建文件夹成功方法 1是成功 2是取消 3是失败
        newFolderSuccess:function(type){
            if(type == 1){
                this._isClick = true;//禁止点击
                this._getListData();//调用获取列表数据方法
                this._CommonNewFolderAadRenameContainer.CommonNewFolderAadRename("removeElement");//调用新建文件夹组件删除组件方法
            }else if(type == 2){
                this._CommonNewFolderAadRenameContainer.CommonNewFolderAadRename("lock","no");//调用新建文件夹组件解除方法
            }else if(type == 3){
                this._CommonNewFolderAadRenameContainer.CommonNewFolderAadRename("lock","no");//调用新建文件夹组件解除方法
            }
            this._isClick = true;//允许点击
            this._CommonHeadContainer.CommonHead("lock","no");//解锁头部组件禁止点击
            this._CommonSearchContainer.CommonSearch("lock","no");//解锁搜索组件禁止点击
        },
        //显示动画方法
        showAnimation:function(){
            this._effect.css("display","");
            this._animationTime = setInterval(function(that){
                if(that._wid < 98){
                    that._wid += 2;
                    that._effect.children("div").css("width",that._wid + "%");
                    that._effect.children("p").html(that.options.effectText + " " + that._wid + "%");
                }else{
                    clearInterval(that._animationTime);
                }
            },20,this);
        },
        //成功完成方法
        successComplete:function(text){
            clearInterval(this._animationTime);
            this._animationTime = setInterval(function(that){
                if(that._wid < 98){
                    that._wid += 2;
                    that._effect.children("div").css("width",that._wid + "%");
                    that._effect.children("p").html(that.options.effectText + " " + that._wid + "%");
                }else{
                    clearInterval(that._animationTime);
                    that._effect.children("div").css({"width":"100%"});
                    if(text != undefined && text != null && text != ""){
                        that._effect.children("p").html(text);
                    }else{
                        that._effect.children("p").html(that.options.successText);
                    }
                    that._isClick = true;//允许点击
                    that._CommonHeadContainer.CommonHead("lock","no");//解锁头部组件禁止点击
                    that._CommonSearchContainer.CommonSearch("lock","no");//解锁搜索组件禁止点击
                    //延迟2s关闭组件
                    setTimeout(function(){
                        that.removeElement();//调用删除组件方法
                        that.element.trigger("SUCCESS_COMPLETE",{"nav":that._navArray,"pid":that._pid,"title":that._title});//抛出当前移动到那个文件夹路径面包屑出去
                    },1500);
                }
            },20,this);
        },
        //失败完成方法
        failComplete:function(text){
            clearInterval(this._animationTime);
            this._wid = 0;
            this._effect.children("div").css("width","100%");
            if(text != undefined && text != null && text != ""){
                this._effect.children("p").html(text);
            }else{
                this._effect.children("p").html(this.options.failText);
            }
            this._isClick = true;//允许点击
            this._CommonHeadContainer.CommonHead("lock","no");//解锁头部组件禁止点击
            this._CommonSearchContainer.CommonSearch("lock","no");//解锁搜索组件禁止点击
            //延迟2s将失败提示去除
            setTimeout(function(that){
                that._effect.children("div").css("width","0%");
                that._effect.children("p").html(that.options.effectText + " " + "0%");
                that._effect.css("display","none");
            },1500,this);
        },
        //删除组件
        removeElement:function(){
            this.element.css("left",(this.element.width() + 10) + "px");
            setTimeout(function(that){
                that.destroy();
            },310,this);
        },
        //改变属性方法使其可以操作
        changeAttribute:function(){
            this._isClick = true;//允许
            this._CommonHeadContainer.CommonHead("lock","no");//解锁头部组件禁止点击
            this._CommonSearchContainer.CommonSearch("lock","no");//解锁搜索组件禁止点击
        },
        //动画暂停方法
        animationStop:function(){
            clearInterval(this._animationTime);//清除动画
        },
        //初始化动画方法
        initAnimation:function(){
            this._effect.css("display","none");
            this._effect.children("div").css("width","0%");
            this._effect.children("p").html(this.options.effectText + " " + "0%");
            this._isClick = true;//允许
            this._wid = 0;//重置动画宽度
            this._CommonHeadContainer.CommonHead("lock","no");//解锁头部组件禁止点击
            this._CommonSearchContainer.CommonSearch("lock","no");//解锁搜索组件禁止点击
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this);
            this.element.remove();
        }
    });
});