/*
*   2020年11月5日
*   
*   封装云空间手机端通用新建文件夹和重命名组件
*
*   开发者：付长建 
*/
define(["CommonHead"],function(){
    $.widget("ys.CommonNewFolderAadRename",{
        //默认参数
        options:{
            title:"新建文件夹",//头部title文字
            defaultVal:"新建文件夹",//默认输入框值
        },
        _CommonHeadContainer:null,//头部组件
        _emptyIcon:null,//清空值图标
        _maskContainer:null,//遮罩元素（控制多次点击问题）
        _isClick:true,//防止多次执行
        _isWinHeight:$("body").height(),//当前设备的高度
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            //给初始化元素设定指定的css样式
            this.element.css({
                "position":"fixed",
                "top":"0",
                "left":this.element.width() + "px",
                "background":"#fff",
                "box-shadow":"-6px 3px 4px 1px rgba(0, 37, 87, 0.04)",
                "transition":"all 0.3s",
                "overflow":"hidden"
            });
            //初始化头部组件
            this._CommonHeadContainer = $("<div class='isHeadContainer'></div>").appendTo(this.element);
            this._CommonHeadContainer.CommonHead({"title":this.options.title,"isGoback":true,"isDetermine":true,"fontWeigth":500,"isGobackEvent":"touchend"});
            //创建输入框
            var inputContainer = $("<div style='width:100%;height:0.5rem;padding:0 0.2rem 0 0.2rem;box-sizing:border-box;margin-top:0.9rem;position:relative;'></div>").appendTo(this.element);
            var form = $("<form style='width:100%;height:100%;'></form>").appendTo(inputContainer);
            this._input = $("<input value='"+this.options.defaultVal+"' style='width:100%;height:100%;padding-right:0.3rem;border-bottom:1px solid #ECECEC;box-sizing:border-box;font-size:0.14rem;' type='text'/>").appendTo(form);
            this._emptyIcon = $("<div class='emptyBtn' style='width:0.5rem;height:100%;position:absolute;top:0;right:0;display:flex;align-items:center;justify-content:center;'></div>").appendTo(inputContainer);
            $("<img style='width:0.15rem;' src='"+skinConfig(global.skin).commonIcon+"signin_icon.png'/>").appendTo(this._emptyIcon);
            //创建遮罩层
            this._maskContainer = $("<div style='width:100%;height:100%;position:absolute;top:0;left:0;display:none;'></div>").appendTo(this.element);
            //给清除输入框的值的图标绑定事件
            inputContainer.find(".emptyBtn")[0].addEventListener("touchend",function(event){
                try {
                    event.stopPropagation();
                    event.preventDefault();
                }catch(event){
                    console.log('阻止冒泡失败');
                }
                that._input.val("");
                that._emptyIcon.children("img").css("display","none");
                that._input.focus();
                that._CommonHeadContainer.CommonHead("changeDetermineBtnColor","yes");//调用头部组件改变确定按钮的颜色（表示禁用）
            },true);
            //禁止表单提交
            inputContainer.find("form").submit(function(){
                return false;
            });
            //实时监听输入框的值发生改变
            this._input.bind("input change",function(){
                if(that._input.val().replace(/[ ]/g,"") != ""){
                    that._emptyIcon.children("img").css("display","");
                    that._CommonHeadContainer.CommonHead("changeDetermineBtnColor","no");//调用头部组件改变确定按钮的颜色（表示禁用）
                }else{
                    that._emptyIcon.children("img").css("display","none");
                    that._CommonHeadContainer.CommonHead("changeDetermineBtnColor","yes");//调用头部组件改变确定按钮的颜色（表示禁用）
                }
            });
            //给输入框绑定软键盘监听事件
            this._input.keypress(function(event){
                if(event.keyCode == 13){
                    $(this).blur();
                }
            }); 
            //为了兼容苹果点击了完成按钮也能触发搜索所以这里全部做失去焦点触发搜索 
            this._input.bind("blur",function(){
                //判断值是否为空
                if(that._input.val().replace(/[ ]/g,"") != ""){
                    that._isClick = false;//禁止点击
                    that.lock("yes");//调用锁定方法
                    that.element.trigger("NEW_DETERMINE_BTN_CLICK",that._input.val().replace(/[ ]/g,""));
                    setTimeout(function(){
                        that._isClick = true;//允许点击
                    },300);
                }else{
                    that._CommonHeadContainer.CommonHead("changeDetermineBtnColor","yes");//调用头部组件改变确定按钮的颜色（表示禁用）
                }
            });
            //监听头部组件点击了返回按钮
            this._CommonHeadContainer.bind("GOBACK_BTN_CLICK",function(){
                that.removeElement();//调用删除组件
            }); 
            //监听头部组件点击了确定按钮
            this._CommonHeadContainer.bind("DETERMINE_BTN_CLICK",function(){
                //判断多次执行
                if(that._isClick){
                    that._input.blur();
                }
            }); 
            //主要是兼容小屏幕手机不能滑动问题
            if(this._isWinHeight < 667){
                document.body.removeEventListener("touchmove",bodyScroll,{passive:false});
            }
            //给初始化元素绑定手指事件
            this._finger();
        },
        //组件手指事件
        _finger:function(){
            var that = this;
            var pageX = 0;
            this.element.on("touchstart",function(e){
                var touch = e.originalEvent,startX = touch.changedTouches[0].pageX;
                if(startX <= 80){
                    $(this).css("transition","");
                    $(this).on("touchmove",function(e){
                        e.preventDefault();
                        touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
                        pageX = touch.pageX;
                        if(pageX > 0){
                            $(this).css("left",pageX + "px");
                        }
                    });
                }
            }).on("touchend",function(){
                $(this).css("transition","0.3s");
                if(pageX >= 50){
                    that._CommonHeadContainer.trigger("GOBACK_BTN_CLICK");
                }else{
                    $(this).css("left","0px");
                }
                $(this).off("touchmove");
            });
        },
        //组件初始化成功主动执行
        _init:function(){
            setTimeout(function(that){
                that.element.css("left","0px");
                setTimeout(function(){
                    that._input.focus();//默认获取焦点
                    that._input.select();//默认选中输入框的值
                },300);
            },50,this);
        },
        //删除组件
        removeElement:function(){
            this.element.css("transition","0.3s");
            this.element.css("left",(this.element.width() + 10) + "px");
            this.element.trigger("NEW_GOBACK_BTN_CLICK");
            setTimeout(function(that){
                //主要是兼容小屏幕手机不能滑动问题
                if(that._isWinHeight < 667){
                    document.body.addEventListener("touchmove",bodyScroll,{passive:false});
                }
                that.destroy();
            },310,this);
        },
        //解除锁定和锁定方法
        lock:function(type){
            if(type == "yes"){
                this._maskContainer.css("display","");
                this._CommonHeadContainer.CommonHead("changeGobackBtnColor","yes"); 
                this._CommonHeadContainer.CommonHead("changeBtnColor","yes");
            }else{
                this._maskContainer.css("display","none");
                this._CommonHeadContainer.CommonHead("changeGobackBtnColor","no"); 
                this._CommonHeadContainer.CommonHead("changeBtnColor","no");
            }
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
            this.element.remove();
        }
    });
});