    /*
*   2020年10月20日
*   
*   封装云空间手机端搜索通用组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.CommonSearch",{
        //默认参数
        options:{
            //排序数据
            sortMenuData:[
                {"type":"name","text":"按名称排序","icon":"tabbar_icon_sort_nm.png","selectIcon":"tabbar_icon_sort.png"},
                {"type":"createtime","text":"按时间排序","icon":"tabbar_icon_sort_time.png","selectIcon":"tabbar_icon_sort.png"}
            ],
            isSortBtn:false,//是否显示排序按钮（注意：排序按钮不能和取消，关闭，搜索按钮共存默认只能显示一个）
            isCanceBtn:false,//是否显示取消按钮（注意：取消按钮不能和排序，关闭，搜索按钮共存默认只能显示一个）
            isCloseBtn:false,//是否显示关闭按钮（注意：关闭按钮不能和取消，排序，搜索按钮共存默认只能显示一个）
            isSearchBtn:false,//是否显示搜索按钮（注意：搜索按钮不能和取消，关闭，排序按钮共存默认只能显示一个）
            isInputClickFocus:true,//是否可以点击获取焦点
            isHead:false,//是否是头部使用
            isFocus:false,//是否默认获取焦点
            selectType:"createtime",//默认按时间排序
            fontWeigth:"bold",//全选和全不选和取消按钮是否字体是否加粗
            isGobackEvent:"click",//取消按钮绑定什么事件（主要是兼容失去焦点事件）
        },
        _maxContainer:null,//最大容器
        _searchBtnContainer:null,//搜索按钮容器给
        _sortBtnContainer:null,//创建排序按钮
        _cancelBtn:null,//取消按钮
        _closeBtn:null,//关闭按钮
        _searchBtn:null,//搜索按钮
        _sortMenuContainer:null,//排序菜单容器
        _sortMenuContent:null,//排序内容容器
        _emptyBtn:null,//清空输入框值按钮
        _inputContainer:null,//搜索输入框容器
        _operationContainer:null,//操作按钮容器
        _isClick:true,//防止多次触发
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            //判读是否在头部使用
            if(this.options.isHead){
                //给初始化元素添加css样式主要是怕使用者忘记添加
                this.element.css({"padding-top":phonexh("top") + "px","box-sizing":"border-box"});
            }
            //创建最大容器
            this._maxContainer = $("<div style='width:100%;height:0.44rem;display:flex;flex-direction:row;justify-content:space-between;align-items:center;'></div>").appendTo(this.element);
            //创建搜索输入框容器
            this._inputContainer = $("<div style='height:0.32rem;display:flex;flex-direction:row;border-radius:0.16rem;overflow:hidden;background:#F5F5F5;'></div>").appendTo(this._maxContainer);
            //创建搜索按钮
            this._searchBtnContainer = $("<div style='width:0.32rem;height:100%;display:flex;align-items:center;justify-content:flex-end;background:#F5F5F5;'></div>").appendTo(this._inputContainer);
            $("<img style='width:0.15rem;margin-right:0.05rem;' src='"+skinConfig(global.skin).commonIcon+"search_icon.png'/>").appendTo(this._searchBtnContainer);
            //创建包裹输入框的form标签（主要用于搜索软键盘确定或者搜索按钮）
            var form = $("<form style='height:100%;'></form>").appendTo(this._inputContainer);
            //创建输入框
            this._searchInput = $("<input maxlength='12' style='width:100%;height:100%;background:#F5F5F5;font-size:0.14rem;padding:0 0.05rem 0 0.05rem;box-sizing:border-box;' type='search' placeholder='请输入关键词'/>").appendTo(form);
            //创建清空输入框值按钮
            this._emptyBtn = $("<div class='emptyBtn' style='width:0.4rem;height:100%;display:flex;align-items:center;justify-content:center;'></div>").appendTo(this._inputContainer);
            $("<img style='width:0.15rem;display:none' src='"+skinConfig(global.skin).commonIcon+"signin_icon.png'/>").appendTo(this._emptyBtn);
            //判读是否可以获取焦点
            if(!this.options.isInputClickFocus){
                this._searchInput.attr("readonly","readonly");
                //判读是否默认获取焦点
                if(this.options.isFocus){
                    alert("你已经设置输入框不能点击获取焦点，所以不能默认获取焦点");
                }
                this._inputContainer.bind("click",this,this._inputContainerClick);//当不能输入框不能获取焦点输入框容器绑定点击事件
                //输入框按下抬起效果
                this._btnTextCommon(this._inputContainer);
            }else{
                this._btnTextCommon(this._emptyBtn);//清空输入框值按钮按下抬起效果
                //判读是否默认获取焦点
                if(this.options.isFocus){
                    this._searchInput.focus();
                    this.element.trigger("INPUT_FOCUS",this._searchInput.val().replace(/[ ]/g,""));
                } 
                //给输入框绑定一个点击事件
                this._searchInput.bind("click",function(){
                    that.element.trigger("INPUT_FOCUS",that._searchInput.val().replace(/[ ]/g,""));
                });
                //禁止表单提交
                this._inputContainer.find("form").submit(function(){
                    return false;
                });
                //给清除输入框的值的图标绑定事件
                this._inputContainer.find(".emptyBtn")[0].addEventListener("touchend",function(event) {
                    try {
                        event.stopPropagation();
                        event.preventDefault();
                    }catch(event){
                        console.log('阻止冒泡失败');
                    }
                    that._searchInput.val("");
                    that._emptyBtn.children("img").css("display","none");
                    that._searchInput.focus();
                    that.element.trigger("EMPTY_BTN_CLICK");
                },true);
                //给输入框绑定软键盘监听事件
                this._searchInput.keypress(function(event){
                    if(event.keyCode == 13){
                        $(this).blur();
                    }
                }); 
                //为了兼容苹果点击了完成按钮也能触发搜索所以这里全部做失去焦点触发搜索 
                this._searchInput.bind("blur",function(){
                    that.element.trigger("SEARCH_BTN_CLICK",that._searchInput.val().replace(/[ ]/g,""));
                });
                //实时监听输入框的值发生改变
                this._searchInput.bind("input change",function(){
                    if(that._searchInput.val().replace(/[ ]/g,"") != ""){
                        that._emptyBtn.children("img").css("display","");
                    }else{
                        that._emptyBtn.children("img").css("display","none");
                    }
                    that.element.trigger("INPUT_CHANGE_VAL",that._searchInput.val().replace(/[ ]/g,""));
                });
            }
            //创建操作按钮容器
            this._operationContainer = $("<div style='height:100%;'></div>").appendTo(this._maxContainer);
            //创建排序按钮
            this._sortBtnContainer = $("<div is-show='no' class='sortBtn' style='height:100%;display:none;align-items:center;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;'></div>").appendTo(this._operationContainer);
            $("<img class='sortBtn' style='width:0.19rem;height:0.19rem;' src='"+skinConfig(global.skin).commonIcon+"tabbar_icon_sort.png'/>").appendTo(this._sortBtnContainer);
            //创建取消按钮
            this._cancelBtn = $("<div style='height:100%;display:none;align-items:center;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;font-size:0.15rem;font-weight:"+this.options.fontWeigth+";'>取消</div>").appendTo(this._operationContainer);
            //创建关闭按钮
            this._closeBtn = $("<div style='height:100%;display:none;align-items:center;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;font-size:0.15rem;font-weight:"+this.options.fontWeigth+";'>关闭</div>").appendTo(this._operationContainer);
            //创建搜索按钮
            this._searchBtn = $("<div style='height:100%;display:none;align-items:center;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;font-size:0.15rem;font-weight:"+this.options.fontWeigth+";'>搜索</div>").appendTo(this._operationContainer);
            //判断是否开启了下拉排序按钮
            if(this.options.isSortBtn){
                //创建排序菜单容器
                this._sortMenuContainer = $("<div style='z-index:-1;width:100%;height:0.8rem;position:absolute;top:"+this._maxContainer.height()+"px;left:0;overflow:hidden;'></div>").appendTo(this.element);
                //创建排序内容容器
                this._sortMenuContent = $("<ul style='width:100%;height:0.8rem;position:absolute;top:-0.8rem;left:0;transition:all 0.3s;'></ul>").appendTo(this._sortMenuContainer);
                //循环生成排序选项
                for(var i = 0; i < this.options.sortMenuData.length; i++){
                    var li = $("<li type='"+this.options.sortMenuData[i].type+"' style='width:100%;height:0.4rem;padding-left:0.15rem;box-sizing:border-box;background:#fff;'></li>").appendTo(this._sortMenuContent);
                    var contentContainer = $("<div style='width:100%;height:100%;display:flex;flex-direction:row;justify-content:space-between;border-bottom:1px solid #ECECEC;box-sizing:border-box;'></div>").appendTo(li);
                    var nameContainer = $("<div style='height:100%;display:flex;align-items:center;'></div>").appendTo(contentContainer);
                    $("<img class='iconCell' icon='"+this.options.sortMenuData[i].icon+"' style='width:0.15rem;' src='"+skinConfig(global.skin).commonIcon+""+this.options.sortMenuData[i].icon+"'/>").appendTo(nameContainer);
                    $("<span class='textCell' style='margin-left:0.1rem;'>"+this.options.sortMenuData[i].text+"</span>").appendTo(nameContainer);
                    var iconContainer = $("<div style='height:100%;display:flex;align-items:center;'></div>").appendTo(contentContainer);
                    $("<img class='select_icon' style='width:0.08rem;height:0.065rem;margin-right:0.15rem;display:none;' src='"+skinConfig(global.skin).shllWebIon+""+this.options.sortMenuData[i].selectIcon+"'/>").appendTo(iconContainer);
                    if(i == 0){
                        li.css("border-top","1px solid #ECECEC");
                    }else if(i == this.options.sortMenuData.length - 1){
                        contentContainer.css("border",0);
                    }
                    //根据当前是按什么排序的选中排序菜单选项
                    if(this.options.sortMenuData[i].type == this.options.selectType){
                        nameContainer.children("img").attr("src",skinConfig(global.skin).shllWebIon + this.options.sortMenuData[i].icon);
                        nameContainer.children("span").css("color",skinConfig(global.skin).selectFontColor);
                        iconContainer.children("img").css("display","");
                    }
                    //给选项绑定点击事件
                    li.bind("click",this,this._optionClick);
                }
            }
            //调用初始化参数判断方法
            this._isGobackAndIsScreen();
            //设置搜索容器的宽度
            if(this._operationContainer.outerWidth(true) == 0){
                this.element.css("padding-right","0.15rem");
            }
            this._inputContainer.css("width",this._maxContainer.width() - this._operationContainer.outerWidth(true) - 1 + "px");
            //设置form标签宽度
            form.css("width",this._inputContainer.width() - this._searchBtnContainer.width() - this._emptyBtn.width() + "px");

            //点击排序按钮
            this._sortBtnClick(this._inputContainer);
            //调用点击取消按钮方法
            this._cancelBtnClick(this);
            //调用点击关闭按钮方法
            this._closeBtnnClick(this);

            //操作容器按下抬起效果
            this._btnTextCommon(this._operationContainer);
            //搜索图标按下抬起效果
            this._btnTextCommon(this._searchBtnContainer);
        },
        //初始化参数判断方法
        _isGobackAndIsScreen:function(){
            //判断是否显示排序按钮
            if(this.options.isSortBtn){
                if(!this.options.isCanceBtn && !this.options.isCloseBtn && !this.options.isSearchBtn){
                    this._sortBtnContainer.css("display","flex");
                }else{
                    alert("注意：排序按钮不能和取消，关闭，搜索按钮共存默认只能显示一个");
                    return;
                }
            }
            //判断是否显示取消按钮 
            if(this.options.isCanceBtn){
                if(!this.options.isSortBtn && !this.options.isCloseBtn && !this.options.isSearchBtn){
                    this._cancelBtn.css("display","flex");
                }else{
                    alert("注意：取消按钮不能和排序，关闭，搜索按钮共存默认只能显示一个");
                    return;
                }
            }
            //判断是否显示关闭按钮 
            if(this.options.isCloseBtn){
                if(!this.options.isCanceBtn && !this.options.isSortBtn && !this.options.isSearchBtn){
                    this._closeBtn.css("display","flex");
                }else{
                    alert("注意：关闭按钮不能和取消，排序，搜索按钮共存默认只能显示一个");
                    return;
                }
            }
            //判断是否显示搜索按钮 
            if(this.options.isSearchBtn){
                if(!this.options.isCanceBtn && !this.options.isCloseBtn && !this.options.isSortBtn){
                    this._searchBtn.css("display","flex");
                }else{
                    alert("注意：搜索按钮不能和取消，关闭，排序按钮共存默认只能显示一个");
                    return;
                }
            }
        },
        //所有的按钮和可以点击的文本按下和抬起事件方法
        _btnTextCommon:function(element){
            //给选项绑定手指按下事件
            element.bind('touchstart',function(){
                $(this).css("opacity","0.5");
            });
            //给选项绑定手指抬起事件
            element.bind('touchend',function(){
                $(this).css("opacity","");
            });
        },
        //点击排序按钮
        _sortBtnClick:function(inputContainer){
            var that = this;
            this._sortBtnContainer.bind("click",function(){
                if($(this).attr("is-show") == "no"){
                    that.element.css("position","relative");
                    inputContainer.css("pointer-events","none");
                    that._sortMenuContainer.css("z-index","1");
                    that._sortMenuContent.css({"top":0,"box-shadow":"0px 3px 4px 1px rgba(0, 37, 87, 0.05)"});
                    $(this).attr("is-show","yes");
                    setTimeout(function(){
                        that._sortMenuContainer.css("overflow","");
                    },200);
                }else{
                    that._sortMenuContent.css({"top":"-0.9rem","box-shadow":""});
                    setTimeout(function(){
                        inputContainer.css("pointer-events","");
                        that.element.css("position","");
                        that._sortMenuContainer.css("z-index","-1");
                    },300);
                    that._sortMenuContainer.css("overflow","hidden");
                    $(this).attr("is-show","no");
                }
                that.element.trigger("SORTMENU_SHOW",$(this).attr("is-show"));
            });
        },
        //点击取消按钮方法
        _cancelBtnClick:function(that){
            //这里判断一下绑定什么事件 
            if(this.options.isGobackEvent == "click"){
                this._cancelBtn.bind("click",function(){
                    that.element.trigger("CANCE_BTN_CLICK");
                });
            }else{
                this._cancelBtn.bind("touchend",function(event){
                    event.stopPropagation();
                    event.preventDefault();
                    that._operationContainer.css("opacity","");
                    that.element.trigger("CANCE_BTN_CLICK");
                });
            }
        },
        //点击关闭按钮方法
        _closeBtnnClick:function(that){
            //这里判断一下绑定什么事件 
            if(this.options.isGobackEvent == "click"){
                this._closeBtn.bind("click",function(){
                    that.element.trigger("CLOSE_BTN_CLICK");
                });
            }else{
                this._closeBtn.bind("touchend",function(event){
                    event.stopPropagation();
                    event.preventDefault();
                    that._operationContainer.css("opacity","");
                    that.element.trigger("CLOSE_BTN_CLICK");
                });
            }
        },
        //当输入框不能获取焦点时，点击输入框
        _inputContainerClick:function(event){
            //防止多次执行
            if(event.data._isClick){
                event.data._isClick = false;
                event.data.element.trigger("NO_FUCOS_BTN_CLICK");
                setTimeout(function(){
                    event.data._isClick = true;
                },500);
            }
        },
        //点击排序菜单选项方法
        _optionClick:function(event){
            event.stopPropagation();
            event.data.hideSortMenu();//调用隐藏菜单方法
            event.data._sortMenuContent.find("li").each(function(){
                $(this).find(".iconCell").attr("src",skinConfig(global.skin).commonIcon + $(this).find(".iconCell").attr("icon"));
                $(this).find(".textCell").css("color","#000");
                $(this).find(".select_icon").css("display","none");
            });
            $(this).find(".iconCell").attr("src",skinConfig(global.skin).shllWebIon + $(this).find(".iconCell").attr("icon"));
            $(this).find(".textCell").css("color",skinConfig(global.skin).selectFontColor);
            $(this).find(".select_icon").css("display","");
            setTimeout(function(that){
                event.data.element.trigger("SORT_MENU_OPTION_CLICK",that.attr("type"));
            },100,$(this));
        },
        //点击清空输入框值按钮方法
        emptyVal:function(){
            this._searchInput.val("");
            this._emptyBtn.children("img").css("display","none");
        },
        //设置输入框val值
        setInputValue:function(text){
            this._searchInput.val(text);
            this._emptyBtn.children("img").css("display","");
        },
        //锁住组件禁止点击  
        lock:function(type){
            if(type == "yes"){
                this.element.css({"pointer-events":"none","opacity":"0.7"});
            }else{
                this.element.css({"pointer-events":"","opacity":""});
            }
        },
        //锁定操作按钮方法
        lockBtn:function(type){
            if(type == "yes"){
                this._operationContainer.css({"pointer-events":"none"});
            }else{
                this._operationContainer.css({"pointer-events":""});
            }
        },
        //锁住搜索输入框 
        searchInput:function(type){
            if(type == "yes"){
                this._inputContainer.css("pointer-events","none");
            }else{
                this._inputContainer.css("pointer-events","");
            }
        },
        //隐藏排序菜单
        hideSortMenu:function(){
            this._sortMenuContent.css("top","-1rem");
            setTimeout(function(that){
                that._inputContainer.css("pointer-events","");
                that.element.css("position","");
                that._sortMenuContainer.css("z-index","-1");
            },300,this);
            this._sortMenuContainer.css("overflow","hidden");
            this._sortBtnContainer.attr("is-show","no");
            this.element.trigger("SORTMENU_SHOW","no");
        },
        //显示排序按钮
        showSortBtn:function(){
            this._cancelBtn.css("display","none");
            this._closeBtn.css("display","none");
            this._searchBtn.css("display","none");
            this._sortBtnContainer.css("display","flex");
        },
        //显示关闭按钮
        showCloseBtn:function(){
            this._cancelBtn.css("display","none");
            this._searchBtn.css("display","none");
            this._sortBtnContainer.css("display","none");
            this._closeBtn.css("display","flex");
        },
        //显示取消按钮
        showCancelBtn:function(){
            this._searchBtn.css("display","none");
            this._sortBtnContainer.css("display","none");
            this._closeBtn.css("display","none");
            this._cancelBtn.css("display","flex");
        },
        //显示搜索按钮
        showSearchBtn:function(){
            this._sortBtnContainer.css("display","none");
            this._closeBtn.css("display","none");
            this._cancelBtn.css("display","none");
            this._searchBtn.css("display","flex");
        },
        //设置搜索输入框值方法
        setSearchVal:function(val){
            this._searchInput.val(val);
            this._emptyBtn.children("img").css("display","");
        },
        //获取焦点方法
        getFocus:function(){
            this._searchInput.focus();
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});