/*
*   2020年11月9日
*   
*   封装云空间手机端通用设置标签组件
*
*   开发者：付长建 
*/
define(["CommonHead"],function(){
    $.widget("ys.CommonSetLabel",{
        //默认参数
        options:{
            uuid:"",//当前设置的文件id
            title:"设置标签",//头部title文字
            CommonToast:null,//飘窗提示组件
            getLabelUrl:"",//获取标签回显接口
            setLabelUrl:"",//设置新标签接口
        },
        _maxContainer:null,//最大内容容器
        _labelContentContainer:null,//标签容器
        _labelArray:[],//添加标签数组
        _changeLabel:[],//判断标签是否发生改变
        _isClick:true,//判断多次执行
        _isCompleteBtn:false,//是否可以点击完成按钮
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            //给初始化元素设定指定的css样式
            this.element.css({
                "position":"fixed",
                "top":"0",
                "left":this.element.width() + "px",
                "background":"#fff",
                "box-shadow":"-6px 3px 4px 1px rgba(0, 37, 87, 0.04)",
                "transition":"all 0.3s",
                "overflow":"hidden"
            });
            //初始化头部组件 
            this._headContainer = $("<div></div>").appendTo(this.element);
            this._headContainer.CommonHead({"isGoback":true,"title":this.options.title,"isComplete":true,"isGobackEvent":"touchend"});
            //创建最大容器
            this._maxContainer = $("<div style='width:100%;padding:0.65rem 0.25rem 0 0.25rem;box-sizing:border-box;'></div>").appendTo(this.element);
            //创建输入框和添加按钮元素
            this._inputAddBtnContainer = $("<div style='width:100%;height:0.4rem;display:flex;flex-direction:row;justify-content:space-between;'></div>").appendTo(this._maxContainer);
            var form = $("<form style='height:100%;position:relative;'></form>").appendTo(this._inputAddBtnContainer);
            $("<input maxlength='6' style='width:100%;height:100%;padding:0 0.4rem 0 0.1rem;border-radius:0.2rem;border:1px solid #ECECEC;box-sizing:border-box;font-size:0.14rem;' type='text' placeholder='请输入自定义标签，最多6个字'/>").appendTo(form);
            var emptyIcon = $("<div class='emptyBtn' style='width:0.4rem;height:100%;position:absolute;top:0;right:0;display:none;align-items:center;justify-content:center;'></div>").appendTo(form);
            $("<img style='width:0.15rem;' src='"+skinConfig(global.skin).commonIcon+"signin_icon.png'/>").appendTo(emptyIcon);
            $("<div style='width:0.65rem;height:100%;text-align:center;line-height:0.38rem;font-size:0.16rem;color:"+skinConfig(global.skin).selectFontColor+";border:1px solid "+skinConfig(global.skin).bordeColor+";border-radius:0.2rem;box-sizing:border-box;opacity:0.5;'>添加</div>").appendTo(this._inputAddBtnContainer);
            form.css("width",this._inputAddBtnContainer.width() - this._inputAddBtnContainer.children("div").width() - 20 + "px");
            //创建标签容器
            this._labelContentContainer = $("<div style='width:100%;padding-top:0.2rem;box-sizing:border-box;display:flex;flex-direction:row;flex-wrap:wrap;'></div>").appendTo(this._maxContainer);
            this._headContainer.CommonHead("changeCompleteBtnColor","yes");//默认禁止点击
            //给清除输入框的值的图标绑定事件阻止失去焦点
            $(emptyIcon)[0].addEventListener("touchend",function(event){
                try {
                    event.stopPropagation();
                    event.preventDefault();
                }catch(event){
                    console.log('阻止冒泡失败');
                }
                form.children("input").val("");
                form.children("input").focus();
                emptyIcon.css("display","none");
                that._inputAddBtnContainer.children("div").css("opacity","0.5");
            },true);
            //给添加按钮绑定事件，禁止失去焦点
            $(this._inputAddBtnContainer.children("div"))[0].addEventListener("touchend",function(event){
                try {
                    event.stopPropagation();
                    event.preventDefault();
                }catch(event){
                    console.log('阻止冒泡失败');
                }
                that._isClick = false;//禁止执行完成事件
                //判断当前添加的标签是否是重复的
                if(that._changeLabel.indexOf(form.children("input").val().replace(/[ ]/g,"")) > -1){
                    that.options.CommonToast.CommonToast("showToast","已有“ "+form.children("input").val().replace(/[ ]/g,"")+" ”这个标签，请不要重复添加...")
                    setTimeout(function(){
                        that.options.CommonToast.CommonToast("hideToast");//消失提示飘窗
                    },2000);
                }else{
                    if(form.children("input").val().replace(/[ ]/g,"") != ""){
                        that._changeLabel.push(form.children("input").val().replace(/[ ]/g,""));
                        that._generateLabel();//调用生成标签方法
                        form.children("input").val("");
                        emptyIcon.css("display","none");
                        that._inputAddBtnContainer.children("div").css("opacity","0.5");
                        setTimeout(function(){
                            that._isClick = true;//允许执行完成事件
                        },300);
                        that._isComplete();//调用判断是否可以点击完成按钮
                    }
                }
            },true);
            //禁止表单提交
            form.submit(function(){
                return false;
            });
            //实时监听输入框的值发生改变
            form.children("input").bind("input change",function(){
                if($(this).val().replace(/[ ]/g,"") != ""){
                    emptyIcon.css("display","flex");
                    that._inputAddBtnContainer.children("div").css("opacity","");
                }else{
                    emptyIcon.css("display","none");
                    that._inputAddBtnContainer.children("div").css("opacity","0.5");
                }
            });
            //给输入框绑定软键盘监听事件
            form.children("input").keypress(function(event){
                if(event.keyCode == 13){
                    $(this).blur();
                }
            }); 
            //为了兼容苹果点击了完成按钮也能触发搜索所以这里全部做失去焦点触发搜索 
            form.children("input").bind("blur",function(){
                //判断值是否为空
                if($(this).val().replace(/[ ]/g,"") != ""){
                    that._isClick = false;//禁止执行完成事件
                    //判断当前添加的标签是否是重复的
                    if(that._changeLabel.indexOf($(this).val().replace(/[ ]/g,"")) > -1){
                        that.options.CommonToast.CommonToast("showToast","已有“ "+$(this).val().replace(/[ ]/g,"")+" ”这个标签，请不要重复添加...")
                        setTimeout(function(){
                            that.options.CommonToast.CommonToast("hideToast");//消失提示飘窗
                        },2000);
                    }else{
                        that._changeLabel.push($(this).val().replace(/[ ]/g,""));
                        that._generateLabel();
                        form.children("input").val("");
                        emptyIcon.css("display","none");
                        that._inputAddBtnContainer.children("div").css("opacity","0.5");
                        setTimeout(function(){
                            that._isClick = true;//允许执行完成事件
                        },300);
                        that._isComplete();//调用判断是否可以点击完成按钮
                    }
                }
            });
            //监听页面点击返回按钮
            this._headContainer.bind("GOBACK_BTN_CLICK",function(){
                that.element.css("transition","0.3s");
                that.element.css("left",that.element.width() + 10 + "px");
                that.element.trigger("SET_LABEL_CLOSE");
                setTimeout(function(){
                    that.destroy();
                },310);
            });
            //监听头部组件点击完成事件 
            this._headContainer.bind("COMPLETE_BTN_CLICK",function(){
                //判断多次执行
                if(that._isClick){
                    //判读标签是否发生改变
                    if(that._isCompleteBtn){
                        that._setLabel();//调用设置标签方法
                    }
                }
            });
            //给初始化元素绑定手指事件
            this._finger();
        },
        //组件手指事件
        _finger:function(){
            var that = this;
            var pageX = 0;
            this.element.on("touchstart",function(e){
                var touch = e.originalEvent,startX = touch.changedTouches[0].pageX;
                if(startX <= 80){
                    $(this).css("transition","");
                    $(this).on("touchmove",function(e){
                        e.preventDefault();
                        touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
                        pageX = touch.pageX;
                        if(pageX > 0){
                            $(this).css("left",pageX + "px");
                        }
                    });
                }
            }).on("touchend",function(){
                $(this).css("transition","0.3s");
                if(pageX >= 50){
                    that._headContainer.trigger("GOBACK_BTN_CLICK");
                }else{
                    $(this).css("left","0px");
                }
                $(this).off("touchmove");
            });
        },
        //组件初始化完成主动执行
        _init:function(){
            this._labelArray = [];
            this._changeLabel = [];
            this._isClick = true;//判断多次执行
            this._isCompleteBtn = false;//是否可以点击完成按钮
            setTimeout(function(that){
                that.element.css("left","0px");
                that._getFileSee();//调用获取当前文件回显标签信息
            },50,this);
        },
        //获取当前文件回显标签信息
        _getFileSee:function(){
            var that = this;
            //如果两秒都还没有得到接口返回提示正在重命名提示
            this._time = setTimeout(function(){
                that.options.CommonToast.CommonToast("showToast","正在获取标签信息，请稍后...");
                that._headContainer.CommonHead("lock","yes");//锁定头部组件禁止点击
                that._inputAddBtnContainer.find("form").css("pointer-events","none");//锁住输入框
            },2000);
            //请求参数
            var paramet = {"token":getUrl("token"),"uuid":this.options.uuid};
            http(that.options.getLabelUrl,paramet,{
                success:function(arg){
                    clearTimeout(that._time);//清除延时
                    if(parseInt(arg.code) == 1){
                        //判断飘窗是否显示了
                        if(that.options.CommonToast.attr("isShow") != "no"){
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.CommonToast.CommonToast("hideToast");//掉飘窗消失方法
                                that._headContainer.CommonHead("lock","no");//解锁头部组件禁止点击
                                that._inputAddBtnContainer.find("form").css("pointer-events","");//解锁输入框
                            },1500);  
                        }
                        //判断是否有标签
                        if(arg.data.info[0].file_label != ""){
                            that._labelArray = arg.data.info[0].file_label.split(",");//将标签字符串转换成数组
                            that._changeLabel = arg.data.info[0].file_label.split(",");//将标签字符串转换成数组
                            that._generateLabel();//调用生成标签方法
                        }
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            //判断飘窗是否显示了
                            if(that.options.CommonToast.attr("isShow") == "no"){
                                that.options.CommonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            }else{
                                that.options.CommonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            }
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.CommonToast.CommonToast("hideToast");//掉飘窗消失方法
                                that._headContainer.CommonHead("lock","no");//锁定头部组件禁止点击
                                that._inputAddBtnContainer.find("form").css("pointer-events","");//解锁输入框
                            },1500);
                        }
                    }
                }
            });
        },
        //生成标签方法
        _generateLabel:function(){
            this._labelContentContainer.children("div").remove();
            for(var i = 0; i < this._changeLabel.length; i++){
                var label = $("<div style='height:0.32rem;padding:0 0.1rem 0 0.1rem;margin:0.1rem 0.1rem 0 0;box-sizing:border-box;background:rgb(236,236,236);border-radius:0.16rem;display:flex;align-items:center;flex-shrink:0;'></div>").appendTo(this._labelContentContainer);
                $("<span style='font-size:0.14rem;margin-top:-0.02rem;'>"+this._changeLabel[i]+"</span>").appendTo(label);
                $("<img style='width:0.15rem;height:0.15rem;margin-left:0.1rem;' src='"+skinConfig(global.skin).commonIcon+"signin_icon.png'/>").appendTo(label);
                label.children("img").bind("click",this,this._labelIconClick);
            }
        },
        //点击标签×图标
        _labelIconClick:function(event){
            //循环去掉改变数据
            for(var i = 0; i < event.data._changeLabel.length; i++){
                if(event.data._changeLabel[i] == $(this).parent().children("span").html()){
                    event.data._changeLabel.splice(i,1);
                    break;
                }
            }
            $(this).parent().remove();
            event.data._isComplete();//调用判断是否可以点击完成按钮
        },
        //设置标签方法
        _setLabel:function(){
            var that = this;
            //如果两秒都还没有得到接口返回提示正在重命名提示
            this._time = setTimeout(function(){
                that.options.CommonToast.CommonToast("showToast","正在设置标签，请稍后...");
                that._headContainer.CommonHead("lock","yes");//锁定头部组件禁止点击
                that._inputAddBtnContainer.find("form").css("pointer-events","none");//锁住输入框
            },2000);
            //请求参数
            var paramet = {"token":getUrl("token"),"file_id":this.options.uuid,"file_label":that._changeLabel.join(",")};
            http(that.options.setLabelUrl,paramet,{
                success:function(arg){
                    clearTimeout(that._time);//清除延时
                    if(parseInt(arg.code) == 1){
                        //判断飘窗是否显示了
                        if(that.options.CommonToast.attr("isShow") == "no"){
                            that.options.CommonToast.CommonToast("showToast","设置成功");//显示飘窗提示
                        }else{
                            that.options.CommonToast.CommonToast("changeText","设置成功");//显示飘窗提示
                        }
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            that.options.CommonToast.CommonToast("hideToast");//掉飘窗消失方法
                            that.element.css("left",that.element.width() + 10 + "px");
                            that.element.trigger("SET_LABEL_CLOSE");
                            setTimeout(function(){
                                that.destroy();
                            },300);
                        },1500);
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            //判断飘窗是否显示了
                            if(that.options.CommonToast.attr("isShow") == "no"){
                                that.options.CommonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            }else{
                                that.options.CommonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            }
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.CommonToast.CommonToast("hideToast");//掉飘窗消失方法
                                that._headContainer.CommonHead("lock","no");//锁定头部组件禁止点击
                                that._inputAddBtnContainer.find("form").css("pointer-events","");//解锁输入框
                            },1500);
                        }
                    }
                }
            });
        },
        //判读是否可以点击完成按钮
        _isComplete:function(){
            //判读标签是否发上改变
            if(this._changeLabel.length != 0){
                //判读改变标签数组和元素数组是否一样长
                if(this._changeLabel.length == this._labelArray.length){
                    for(var i = 0; i < this._changeLabel.length; i++){
                        this._isCompare(this._changeLabel[i]);//调用递归判断改变标签数组是否和原始标签数组值一样
                    }
                }else{
                    this._headContainer.CommonHead("changeCompleteBtnColor","no");//默认禁止点击
                    this._isCompleteBtn = true;//允许点击完成按钮
                }
            }else{
                //判断原始数据是否为空
                if(this._labelArray.length == 0){
                    this._headContainer.CommonHead("changeCompleteBtnColor","yes");//默认禁止点击
                    this._isCompleteBtn = false;//禁止点击完成按钮
                }else{
                    this._headContainer.CommonHead("changeCompleteBtnColor","no");//允许点击
                    this._isCompleteBtn = true;//允许点击完成按钮
                }
            }
        },
        //递归判断改变标签数组是否和原始标签数组值一样
        _isCompare:function(text){
            for(var i = 0; i < this._labelArray.length; i++){
                if(this._labelArray[i] == text){
                    this._headContainer.CommonHead("changeCompleteBtnColor","yes");//默认禁止点击
                    this._isCompleteBtn = false;//禁止点击完成按钮
                    break;
                }else{
                    this._headContainer.CommonHead("changeCompleteBtnColor","no");//默认禁止点击
                    this._isCompleteBtn = true;//允许点击完成按钮
                }
            }
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
            this.element.remove();
        }
    });
});