/*
*   2020年12月2日
*   
*   封装云空间手机端通用设置密码，修改密码组件
*
*   开发者：付长建 
*/
define(["Shell"],function(Shell){
    $.widget("ys.CommonSetPwd",{
        //默认参数
        options:{
            CommonToast:null,//飘窗提示组件
        },
        _headContainer:null,//头部组件
        _setPwdContainer:null,//设置密码容器
        _inputPwdContainer:null,//输入密码容器
        _forgetPwdContainer:null,//忘记密码验证容器
        _determineBtn:null,//确定按钮
        _type:1,//控制当前是什么类型
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            //给初始化元素设定指定的css样式
            this.element.css({
                "position":"fixed",
                "top":0,
                "left":this.element.width() + "px",
                "background":"#fff",
                "box-shadow":"-6px 3px 4px 1px rgba(0, 37, 87, 0.04)",
                "transition":"all 0.3s",
                "overflow":"hidden"
            });
            //初始化头部组件
            this._headContainer = $("<div></div>").appendTo(this.element);
            this._headContainer.CommonHead({"title":"设置保险箱密码","isGoback":true});
            var maxContainer = $("<div style='width:100%;padding:0 0.25rem 0 0.25rem;box-sizing:border-box;overflow:hidden;'></div>").appendTo(this.element);
           
            //创建设置密码容器
            this._setPwdContainer = $("<div style='width:100%;margin-top:0.3rem;'></div>").appendTo(maxContainer);
            var form1 = $("<form style='width:100%;height:0.5rem;position:relative;'></form>").appendTo(this._setPwdContainer);
            $("<input class='pwd1' placeholder='请设置6位密码（数字+字母）' style='width:100%;height:100%;padding-right:0.4rem;border-bottom:1px solid #ECECEC;box-sizing:border-box;font-size:0.15rem;' type='password'/>").appendTo(form1);
            var emptyIcon1 = $("<div class='emptyBtn1' style='width:0.4rem;height:100%;position:absolute;top:0;right:0;display:none;align-items:center;justify-content:center;'></div>").appendTo(form1);
            $("<img style='width:0.15rem;' src='"+skinConfig(global.skin).commonIcon+"signin_icon.png'/>").appendTo(emptyIcon1);
            var form2 = $("<form style='width:100%;height:0.5rem;position:relative;margin-top:0.2rem;'></form>").appendTo(this._setPwdContainer);
            $("<input class='pwd2' placeholder='请再次确认密码' style='width:100%;height:100%;padding-right:0.4rem;border-bottom:1px solid #ECECEC;box-sizing:border-box;font-size:0.16rem;' type='password'/>").appendTo(form2);
            var emptyIcon2 = $("<div class='emptyBtn2' style='width:0.4rem;height:100%;position:absolute;top:0;right:0;display:none;align-items:center;justify-content:center;'></div>").appendTo(form2);
            $("<img style='width:0.15rem;' src='"+skinConfig(global.skin).commonIcon+"signin_icon.png'/>").appendTo(emptyIcon2);
            emptyIcon1[0].addEventListener("touchend",function(event){
                try {
                    event.stopPropagation();
                    event.preventDefault();
                }catch(event){
                    console.log('阻止冒泡失败');
                }
                form1.find("input").val("");
                emptyIcon1.css("display","none");
                that._determineBtn.css("opacity","0.5");
                that._determineBtn.attr("isData","no");
            },true);
            form1.find("input").bind("input change",function(){
                if(form1.find("input").val().replace(/[ ]/g,"") != ""){
                    emptyIcon1.css("display","flex");
                    if(form2.find("input").val().replace(/[ ]/g,"") != ""){
                        that._determineBtn.css("opacity","1");
                        that._determineBtn.attr("isData","yes");
                    }else{
                        that._determineBtn.css("opacity","0.5");
                        that._determineBtn.attr("isData","no");
                    }
                }else{
                    emptyIcon1.css("display","none");
                    that._determineBtn.css("opacity","0.5");
                    that._determineBtn.attr("isData","no");
                }
            });
            form1.submit(function(){
                return false;
            }); 
            form1.find("input").bind("onkeyup",function(){
                var text = form1.find("input").val().replace(/[^\d|chun]/g,'');
                form1.find("input").val(text);
            });
            emptyIcon2[0].addEventListener("touchend",function(event){
                try {
                    event.stopPropagation();
                    event.preventDefault();
                }catch(event){
                    console.log('阻止冒泡失败');
                }
                form2.find("input").val("");
                emptyIcon2.css("display","none");
                that._determineBtn.css("opacity","0.5");
                that._determineBtn.attr("isData","no");
            },true);
            form2.find("input").bind("input change",function(){
                if(form2.find("input").val().replace(/[ ]/g,"") != ""){
                    emptyIcon2.css("display","flex");
                    if(form1.find("input").val().replace(/[ ]/g,"") != ""){
                        that._determineBtn.css("opacity","1");
                        that._determineBtn.attr("isData","yes");
                    }else{
                        that._determineBtn.css("opacity","0.5");
                        that._determineBtn.attr("isData","no");
                    }
                }else{
                    emptyIcon2.css("display","none");
                    that._determineBtn.css("opacity","0.5");
                    that._determineBtn.attr("isData","no");
                }
            });
            form2.submit(function(){
                return false;
            }); 
            form2.find("input").bind("onkeyup",function(){
                var text = form2.find("input").val().replace(/[^\d|chun]/g,'');
                form2.find("input").val(text);
            });
            
            //创建输入密码容器
            this._inputPwdContainer = $("<div style='width:100%;margin-top:0.3rem;'></div>").appendTo(maxContainer);
            var form3 = $("<form style='width:100%;height:0.5rem;position:relative;'></form>").appendTo(this._inputPwdContainer);
            $("<input class='pwd3' placeholder='请输入6位密码' style='width:100%;height:100%;padding-right:0.4rem;border-bottom:1px solid #ECECEC;box-sizing:border-box;font-size:0.15rem;' type='password'/>").appendTo(form3);
            var emptyIcon3 = $("<div class='emptyBtn3' style='width:0.4rem;height:100%;position:absolute;top:0;right:0;display:none;align-items:center;justify-content:center;'></div>").appendTo(form3);
            $("<img style='width:0.15rem;' src='"+skinConfig(global.skin).commonIcon+"signin_icon.png'/>").appendTo(emptyIcon3);
            emptyIcon3[0].addEventListener("touchend",function(event){
                try {
                    event.stopPropagation();
                    event.preventDefault();
                }catch(event){
                    console.log('阻止冒泡失败');
                }
                form3.find("input").val("");
                emptyIcon3.css("display","none");
                that._determineBtn.css("opacity","0.5");
                that._determineBtn.attr("isData","no");
            },true);
            form3.find("input").bind("input change",function(){
                if(form3.find("input").val().replace(/[ ]/g,"") != ""){
                    emptyIcon3.css("display","flex");
                    that._determineBtn.css("opacity","1");
                    that._determineBtn.attr("isData","yes");
                }else{
                    emptyIcon3.css("display","none");
                    that._determineBtn.css("opacity","0.5");
                    that._determineBtn.attr("isData","no");
                }
            });
            form3.submit(function(){
                return false;
            }); 
            form3.find("input").bind("onkeyup",function(){
                var text = form3.find("input").val().replace(/[^\d|chun]/g,'');
                form3.find("input").val(text);
            });
            var forgetPwd = $("<p isData='yes' style='width:100%;text-align:right;font-size:0.12rem;color:#666;margin-top:0.15rem;'>忘记保险箱密码？</p>").appendTo(this._inputPwdContainer);
            
            //忘记密码验证容器
            this._forgetPwdContainer = $("<div style='width:100%;margin-top:0.3rem;'></div>").appendTo(maxContainer);
            var phone = global.userInfo.phone.substr(0,3) + "****" + global.userInfo.phone.substr(7);
            $("<p style='font-size:0.16rem;'>验证码将发送到手机号：<span style='color:"+skinConfig(global.skin).selectFontColor+"'>"+phone+"</span></p>").appendTo(this._forgetPwdContainer);
            var codeContainer = $("<div style='width:100%;height:0.5rem;display:flex;flex-direction:row;border-bottom:1px solid #ECECEC;box-sizing:border-box;margin-top:0.4rem;'></div>").appendTo(this._forgetPwdContainer);
            var form4 = $("<form style='width:100%;height:100%;position:relative;'></form>").appendTo(codeContainer);
            $("<input class='code' placeholder='请输入短信验证码' type='number' style='width:100%;height:100%;border:0;padding-right:0.4rem;box-sizing:border-box;'/>").appendTo(form4);
            var emptyIcon4 = $("<div class='emptyBtn4' style='width:0.4rem;height:100%;position:absolute;top:0;right:0;display:none;align-items:center;justify-content:center;'></div>").appendTo(form4);
            $("<img style='width:0.15rem;' src='"+skinConfig(global.skin).commonIcon+"signin_icon.png'/>").appendTo(emptyIcon4);
            $("<p style='width:1px;height:0.15rem;background:"+skinConfig(global.skin).backColor+";margin-top:0.175rem;'></p>").appendTo(codeContainer);
            $("<div isData='yes' style='width:1.2rem;height:100%;line-height:0.5rem;text-align:center;color:"+skinConfig(global.skin).selectFontColor+";font-size:0.14rem'>获取验证码</div>").appendTo(codeContainer);
            form4.css("width",codeContainer.width() - codeContainer.children("div").width() - 1 + "px");
            emptyIcon4[0].addEventListener("touchend",function(event){
                try {
                    event.stopPropagation();
                    event.preventDefault();
                }catch(event){
                    console.log('阻止冒泡失败');
                }
                form4.find("input").val("");
                emptyIcon4.css("display","none");
                that._determineBtn.css("opacity","0.5");
                that._determineBtn.attr("isData","no");
            },true);
            form4.find("input").bind("input change",function(){
                if(form4.find("input").val().replace(/[ ]/g,"") != ""){
                    emptyIcon4.css("display","flex");
                    that._determineBtn.css("opacity","1");
                    that._determineBtn.attr("isData","yes");
                }else{
                    emptyIcon4.css("display","none");
                    that._determineBtn.css("opacity","0.5");
                    that._determineBtn.attr("isData","no");
                }
            });
            form4.submit(function(){
                return false;
            }); 
            
            //创建确定按钮
            this._determineBtn = $("<div isData='no' style='width:100%;height:0.5rem;margin-top:0.3rem;line-height:0.5rem;text-align:center;font-size:0.18rem;font-weight:bold;color:#fff;background:"+skinConfig(global.skin).linearBackColor+";opacity:0.5;border-radius:0.25rem;'>确定</div>").appendTo(maxContainer);
            //给确定按钮绑定点击事件
            this._determineBtn.bind("click",this,this._determineBtnClick);
            //给忘记密码绑定点击事件
            forgetPwd.bind("click",this,this._forgetPwdTextClick);
            //给获取验证码按钮绑定点击事件
            codeContainer.children("div").bind("click",this,this._getCodeClick);
            //确定按钮按下抬起效果
            this._btnTextCommon(this._determineBtn);
            //忘记密码文字按下抬起效果
            this._btnTextCommon(forgetPwd);
            //发送文字按下抬起效果
            this._btnTextCommon(codeContainer.children("div"));
            //监听头部组件的返回按钮 
            this._headContainer.bind("GOBACK_BTN_CLICK",function(){
                that.deletePanel();//删除组件
            });
            //绑定手指事件
            this._finger();
        },
        //手指事件
        _finger:function(){
            var that = this;
            var pageX = 0;
            this.element.on("touchstart",function(e){
                var touch = e.originalEvent,startX = touch.changedTouches[0].pageX;
                if(startX <= 80){
                    $(this).css("transition","");
                    $(this).on("touchmove",function(e){
                        e.preventDefault();
                        touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
                        pageX = touch.pageX;
                        if(pageX > 0){
                            $(this).css("left",pageX + "px");
                        }
                    });
                }
            }).on("touchend",function(){
                $(this).css("transition","0.3s");
                if(pageX >= 50){
                    that._headContainer.trigger("GOBACK_BTN_CLICK");
                }else{
                    $(this).css("left","0px");
                }
                $(this).off("touchmove");
            });
        },
        //组件初始化成功主动执行
        init:function(obj){
            this._setPwdContainer.css("display","none");
            this._inputPwdContainer.css("display","none");
            this._forgetPwdContainer.css("display","none");
            this.element.css("left","0px");
            this._headContainer.CommonHead("changeTitle",obj.title);
            this._type = obj.type;
            if(obj.type == 1){
                this._setPwdContainer.css("display","");
            }else if(obj.type == 2){
                this._inputPwdContainer.css("display","");
            }else{
                this._forgetPwdContainer.css("display","");
            }
        },
        //删除组件
        deletePanel:function(){
            this.element.css("left",(this.element.width() + 10) + "px");
            this.element.trigger("SET_PWD_HIDE");
            setTimeout(function(that){
                that.destroy();
            },310,this);
        },
        //所有的按钮和可以点击的文本按下和抬起事件方法
        _btnTextCommon:function(element){
            //给选项绑定手指按下事件
            element.bind('touchstart',function(){
                if(element.attr("isData") == "yes"){
                    $(this).css("opacity","0.5");
                }
            });
            //给选项绑定手指抬起事件
            element.bind('touchend',function(){
                if(element.attr("isData") == "yes"){
                    $(this).css("opacity","");
                }
            });
        },
        //点击确定按钮
        _determineBtnClick:function(event){
            //判读是否可以点击去顶按钮
            if($(this).attr("isData") == "no"){
                return;
            }
            //判断当前是什么类型点击确定
            if(event.data._type == 1){//设置密码
                var url = ServerConfig.domain+"/personal/editSafePassword";//设置密码接口
                var paramet = {"token":getUrl("token"),"password":$(".pwd1").val(),"confirm_password":$(".pwd2").val()};
            }else if(event.data._type == 2){//输入密码
                var url = ServerConfig.domain+"/personal/checkSafePassword";//输入密码检测是否正确接口
                var paramet = {"token":getUrl("token"),"password":$(".pwd3").val()};
            }else if(event.data._type == 3){//验证验证码
                var url = ServerConfig.domain+"/personal/checkCode";//检测验证码接口
                var paramet = {"token":getUrl("token"),"phone":global.userInfo.phone,"code":$(".code").val()};
            }
            http(url,paramet,{
                success:function(arg){
                    console.log(arg);
                    if(parseInt(arg.code) == 1){
                        //判断是否进入保险箱页面
                        if(event.data._type == 1 || event.data._type == 2){
				            Shell.sendEvent("openWin",{"url":"/deposit/deposit.html?token="+getUrl("token"),"open_type":true,"title":"保险箱"});
                            //延迟2s销毁设置密码组件
                            setTimeout(function(){
                                event.data.deletePanel();
                            },500);
                        }else{
                            event.data._type = 1;
                            event.data._determineBtn.html("确定"); 
                            event.data._determineBtn.attr("isData","no");
                            event.data._inputPwdContainer.css("display","none");
                            event.data._forgetPwdContainer.css("display","none");
                            event.data._setPwdContainer.css("display","");
                            event.data._headContainer.CommonHead("changeTitle","重置密码");
                        }
                    }else{
                        event.data.options.CommonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            event.data.options.CommonToast.CommonToast("hideToast");//掉飘窗消失方法
                        },2000);
                    }
                }
            });
        },
        //点击忘记密码文字
        _forgetPwdTextClick:function(event){
            event.data._setPwdContainer.css("display","none");
            event.data._inputPwdContainer.css("display","none");
            event.data._forgetPwdContainer.css("display","");
            event.data._headContainer.CommonHead("changeTitle","忘记密码");
            event.data._determineBtn.html("下一步"); 
            event.data._type = 3;
        },
        //获取验证码方法
        _getCodeClick:function(event){
            var that = $(this);
            if(that.attr("isData") == "yes"){
                that.attr("isData","no");
                var paramet = {"token":getUrl("token"),"phone":global.userInfo.phone};
                http(ServerConfig.domain+"/personal/sendCodeForSafe",paramet,{
                    success:function(arg){
                        console.log(arg);
                        if(parseInt(arg.code) == 1){
                            var inx = 60;
                            var time = setInterval(function(){
                                if(inx != 0){
                                    that.html(inx + "s后重新发送");
                                    inx = inx - 1;
                                }else{
                                    clearInterval(time);
                                    that.html("获取验证码");
                                    that.attr("isData","no");
                                }
                            },1000);
                        }else{
                            event.data.options.CommonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.attr("isData","yes");
                                event.data.options.CommonToast.CommonToast("hideToast");//掉飘窗消失方法
                            },2000);
                        }
                    }
                });
            }
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
            this.element.remove();
        }
    });
});