/*
*   2020年10月30日
*   
*   封装云空间手机端通用分享菜单组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.CommonShareMenu",{
        //默认参数
        options:{
            menuData:[],//菜单数据
        },
        _maxContainer:null,//最大容器
        _cancelBtn:null,//取消按钮
        _isClick:true,//防止不停触发
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            //判断是否传入组件菜单
            if(this.options.menuData.length == 0){
                alert("请传入操作菜单");
                return;
            }
            this.element.css({
                "width":"100%",
                "position":"fixed",
                "bottom":"-250px",
                "background":"#fff",
                "transition":"all 0.3s"
            });
            var padd = phonexh("bottom") == 0 ? 0 : 0;
            $("<p style='width:100%;height:0.6rem;display:flex;align-items:center;justify-content:center;font-size:0.15rem;font-weight:bold;box-shadow: rgba(0, 37, 87, 0.03) 0px -3px 4px 1px;'>文件分享</p>").appendTo(this.element);
            this._maxContainer = $("<ul style='width:100%;display:flex;flex-wrap:wrap;justify-content:center;padding-bottom:0.3rem;box-sizing:border-box;'></ul>").appendTo(this.element);
            //循环生成底部菜单
            for(var i = 0; i < this.options.menuData.length; i++){
                var li = $("<li type='"+this.options.menuData[i].type+"' style='width:25%;display:flex;flex-direction:column;align-items:center;flex-shrink:0;'></li>").appendTo(this._maxContainer);
                $("<img style='width:0.4rem;height:0.4rem;' src='"+this.options.menuData[i].icon+"'/>").appendTo(li);
                $("<span style='font-size:0.12rem;font-weight:bold;margin-top:0.05rem;'>"+this.options.menuData[i].text+"</span>").appendTo(li);
            }
            $("<p style='width:100%;height:0.1rem;background:#f7f7f7;'></p>").appendTo(this.element);
            var cancelContainer = $("<div style='width:100%;padding-bottom:"+padd+";box-sizing:border-box;'></div>").appendTo(this.element);
            this._cancelBtn = $("<p style='width:100%;height:0.5rem;display:flex;align-items:center;justify-content:center;font-size:0.15rem;'>取消</p>").appendTo(cancelContainer);
            this.element.css("bottom","-" + this.element.outerHeight(true) + "px");
            //给取消按钮绑定按下抬起效果
            this._btnTextCommon(this._cancelBtn);
            //操作按钮按下抬起效果
            this._btnTextCommon(this._maxContainer.find("li"));
            //给所有的操作按钮绑定带你就事件
            this._maxContainer.find("li").bind("click",this,this._shareBtnClick);
            //给取消按钮绑定取消事件
            this._cancelBtn.bind("click",this,this._cancelBtnClick);
        },
        //初始化主动执行
        _init:function(){
            setTimeout(function(that){
                that.element.css("bottom","0");
                setTimeout(function(){
                    that.element.attr("isShow","yes");
                    that.element.trigger("SHAER_MENU_SHOW");
                },300);
            },50,this);
        },
        //删除组件
        removeElement:function(){
            this.element.css("bottom","-" + this.element.outerHeight(true) + "px");   
            this.element.trigger("SHARE_CANCEL_BTN_CLICK");
            setTimeout(function(that){
                that.destroy();
            },310,this);
        },
        //点击操作按钮方法
        _shareBtnClick:function(event){
            event.stopPropagation();
            if(event.data._isClick){
                event.data._isClick = false;
                event.data.element.trigger("SHARE_BTN_CLICK",$(this).attr("type"));
                setTimeout(function(){
                    event.data._isClick = true;
                },300);
            }
        },
        //点击取消按钮
        _cancelBtnClick:function(event){
            event.stopPropagation();
            event.data.element.attr("isShow","no");
            if(event.data._isClick){
                event.data._isClick = false;
                event.data.removeElement();
                setTimeout(function(){
                    event.data._isClick = true;
                },500);
            }
        },
        //所有的按钮和可以点击的文本按下和抬起事件方法
        _btnTextCommon:function(element){
            //给选项绑定手指按下事件
            element.bind('touchstart',function(){
                $(this).css("opacity","0.5");
            });
            //给选项绑定手指抬起事件
            element.bind('touchend',function(){
                $(this).css("opacity","");
            });
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
            this.element.remove();
        }
    });
});