/*
*   2020年10月27日
*   
*   封装云空间手机端通用错误提示飘窗组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.CommonToast",{
        //默认参数
        options:{
            errorText:"未知错误",//错误提示
        },
        _maxContainer:null,//最大容器
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            this.element.attr("isShow","no");//主要用于调用方来判读飘窗是否显示
            this.element.css({
                "z-index":"-999",
                "position":"absolute",
                "top":"50%",
                "left":"50%",
                "transform":"translate(-50%,-50%) scale(0.5,0.5)",
                "padding":"0.08rem 0.15rem",
                "box-sizing":"border-box",
                "background":"rgba(0,0,0,0.6)",
                "border-radius":"0.25rem",
                "transition":"all 0.3s",
                "opacity":"0"
            });
            this._maxContainer = $("<div></div>").appendTo(this.element);
            $("<span style='font-size:0.14rem;color:#fff;white-space:nowrap;'>"+this.options.errorText+"</span>").appendTo(this._maxContainer);
        },
        //显示跳窗提示
        showToast:function(text){
            if(text != undefined || text != null || text != ""){
                this._maxContainer.children("span").html(text);
            }
            this.element.css("z-index","999");
            this.element.css({"transform":"translate(-50%,-50%) scale(1,1)","opacity":"1"});
            setTimeout(function(that){
                that.element.attr("isShow","yes");
            },310,this);
        },
        //隐藏飘窗
        hideToast:function(){
            this.element.css({"transform":"translate(-50%,-300%) scale(0,0)","opacity":"0"});
            setTimeout(function(that){
                that.element.css("z-index","-1");
            },150,this);
            setTimeout(function(that){
                that.element.attr("isShow","no");
                that.element.css({"transform":"translate(-50%,-50%) scale(0,0)","opacity":"0"});
            },310,this);
        },
        //改变提示语方法
        changeText:function(text){
            this._maxContainer.children("span").html(text);
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
            this.element.remove();
        }
    });
});