/*
*   2020年11月10日
*   
*   封装云空间手机端个人空间搜索panel组件
*
*   开发者：付长建 
*/
define(["Shell","YsPreviewManager","CommonSearch","CommonIscroll","CommonCell","CommonBottonMenu","CommonShareMenu","CommonDeleteMask"],function(Shell,YsPreviewManager){
    $.widget("ys.DjMyspaceSearchPanel",{
        //默认参数
        options:{
            commonToast:null,//飘窗组件
            uuid:0,//搜索那一层的文件
            sort:"createtime",//排序
            type:"all"//搜索的文件类型
        },
        _historyData:[],//历史搜索数据
        _key:"",//搜索关键字
        _offset:0,//数据请求偏移量
        _selectSize:2,//控制新生成的节点勾选图标大小，参数2是小，1是大
        _selectData:[],//列表选中数据
        _pageName:"DjMyspaceSearchPanel",//预览类型，主要是那个页面进行预览
        _previewData:{},//预览文件数据（这个主要是给原生用和删除当前正在预览的文件判断是否还有下一张上一张或者下一个上一个文件使用的）
        _currentData:{},//当前预览文件的数据（这个主要是用来控制器用和换取预览地址的和给原生提供当前预览的文件信息的）
        _isNextPrev:true,//防止用户一只触发上一张下一张事件
        _paddingBottom:null,//底部安全区
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            this._paddingBottom = phonexh("bottom") == 0 ? 0 : 0;//底部安全区
            //初始化预览管理器
            YsPreviewManager.Init(
                that._pageName,
                global.preview_config.preview_config.type,
                global.preview_config.preview_config.type=="url"?global.preview_config.preview_config.storageStatus+"?uid=1&uuid=":"",
                global.preview_config.preview_config.type=="url"?global.preview_config.preview_config.task+"?user_id=1&":"",
                global.preview_config.preview_config.type=="url"?global.preview_config.download_check_task_url+"?id=":"",
                global.preview_config.preview_config.type=="url"?global.preview_config.preview_config.encode+"?origin=2&appName=dj&":global.preview_config.preview_config.encode+"?origin=1&appName=dj&",
                global.preview_config.preview_config.encodeStatus+"?task=",
                function(successObj){
                    that._previewData.url = successObj.url;//赋值获取到的预览地址
                    Shell.sendEvent("changePreviewFileAndImage",that._previewData);
                },function(errorObj){
                    that._previewData.error = errorObj.error;
                    Shell.sendEvent("changePreviewFileAndImage",that._previewData);
                }
            )
            //给初始化元素设定指定的css样式
            this.element.css({
                "position":"fixed",
                "top":this.element.height() + "px",
                "left":0,
                "transition":"all 0.3s",
                "overflow":"hidden"
            });
            //初始化搜索组件 
            this._searchContainer = $("<div style='width:100%;padding-left:0.15rem;border-bottom:1px solid #ECECEC;box-sizing:border-box;'></div>").appendTo(this.element);
            this._searchContainer.CommonSearch({"isCloseBtn":true,"isHead":true,"isGobackEvent":"touchend"});
            this._maxContainer = $("<div style='width:100%;height:"+(this.element.height() - this._searchContainer.outerHeight(true))+"px;transition:all 0.3s;overflow:hidden;background:#fff;'></div>").appendTo(this.element);
            //创建历史搜索和滚动容器的父级容器
            this._historyIscrollContainer = $("<div style='width:"+(this.element.width() * 2)+"px;height:100%;display:flex;flex-direction:row;transition:all 0.3s;'></div>").appendTo(this._maxContainer);
            //创建历史搜索容器
            this._historyContainer = $("<div style='width:"+this.element.width()+"px;height:100%;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;flex-shrink:0;'></div>").appendTo(this._historyIscrollContainer);
            //创建历史搜索标题和清空历史搜索图标原始
            this._historyTitleEmpty = $("<div style='width:100%;height:0.5rem;display:flex;flex-direction:row;justify-content:space-between;'></div>").appendTo(this._historyContainer);
            $("<span style='font-size:0.16rem;font-weight:bold;display:flex;align-items:center;'>搜索历史</span>").appendTo(this._historyTitleEmpty);
            $("<div style='display:none;align-items:center;'><img style='width:0.15rem;height:0.15rem;' src='"+skinConfig(global.skin).commonIcon+"icon_delete.png'/></div>").appendTo(this._historyTitleEmpty);
            //创建历史搜索过的关键字容器
            this._historyKeyContainer = $("<div style='width:100%;display:flex;flex-direction:row;flex-wrap:wrap;'></div>").appendTo(this._historyContainer);
            //创建列表滚动容器
            this._iscrollContainer = $("<div id='mySpaceSearchContainer' style='width:"+this.element.width()+"px;height:"+(this._maxContainer.height() - this._paddingBottom)+"px;position:relative;overflow:hidden;'></div>").appendTo(this._historyIscrollContainer);
            this._iscrollContainer.CommonIscroll({"isUploadBtn":false,"isPosition":false});
            //初始化文件列表选中底部操作菜单组件
            this._bottonMenuContainer = $("<div isShow='no' style='width:100%;transition:all 0.3s;'></div>").appendTo(this.element);
            this._bottonMenuContainer.CommonBottonMenu({
                "btnMenu":[
                    {"text":"下载","type":"download","icon":skinConfig(global.skin).commonIcon + "download_icon.png"},
                    {"text":"移动","type":"move","icon":skinConfig(global.skin).commonIcon + "move_icon.png"},
                    {"text":"分享","type":"share","icon":skinConfig(global.skin).commonIcon + "share_icon.png"},
                    {"text":"复制","type":"copy","icon":skinConfig(global.skin).commonIcon + "copy_icon.png"},
                    {"text":"删除","type":"delete","icon":skinConfig(global.skin).commonIcon + "delete_icon.png"},
                    {"text":"重命名","type":"rename","icon":skinConfig(global.skin).commonIcon + "rename_icon.png"},
                ]
            });
            
            //给清空历史搜索图标绑定点击事件
            this._historyTitleEmpty.children("div").bind("click",this,this._emptyHistory);//给清空历史搜索图标绑定点击事件
            //监听搜索组件点击了清空val值图标 
            this._searchContainer.bind("EMPTY_BTN_CLICK",function(){
                that._key = "";//设置搜索关键字
                that._historyIscrollContainer.css("margin-left","0px");//切换列表容器
                setTimeout(function(){
                    that._iscrollContainer.CommonIscroll("emptyNode");//清空所有节点
                },310);
            });
            //监听搜索组件val值实时发生改变
            this._searchContainer.bind("INPUT_CHANGE_VAL",function(event,key){
                //判断值为空显示历史搜索容器
                if(key == ""){
                    that._historyIscrollContainer.css("margin-left","0px");//切换列表容器
                    setTimeout(function(){
                        that._iscrollContainer.CommonIscroll("emptyNode");//清空所有节点
                    },310);
                }
            });
            //监听搜索组件搜索事件
            this._searchContainer.bind("SEARCH_BTN_CLICK",function(event,key){
                //判读搜索关键字是为空
                if(key != ""){
                    that._key = key;//重置搜索关键字
                    that._offset = 0;//重置请求数据偏移量
                    that._searchHistoryShare();//调用触发搜索组件的搜索和点击历史搜索标签相同逻辑
                }
            });
            //监听滚动组件下拉刷新
            this._iscrollContainer.bind("ISCROLL_REFRESH",function(){
                that._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
                that._lock("yes");//锁定页面
                that._selectData = [];//清空列表选中数据
                that._selectSize = 2;//重置列表勾选图标大小 
                that._offset = 0;//重置请求数据偏移量
                that._getSearchData(2);//调用获取搜索列表数据方法
            });
            //监听滚动容器上拉加载更多
            this._iscrollContainer.bind("ISCROLL_LOAD_MORE",function(){
                //判断当前列表选中底部菜单是否显示
                if(that._bottonMenuContainer.attr("isShow") == "yes"){
                    that._selectSize = 1;//重置控制新生成的节点勾选图标大小，参数2是小，1是大
                }
                that._lock("yes");//锁定页面
                that._offset = that._offset + 100;//重置请求数据偏移量
                that._getSearchData(3);//调用获取搜索列表数据方法
            });
            //监听列表选中事件
            this._iscrollContainer.bind("CELL_SELECT",function(event,obj){
                //判断当前是取消还是选中
                if(obj.type == "yes"){
                    that._selectData.push(obj.data);
                }else{
                    //循环取消选中数据
                    for(var i = 0; i < that._selectData.length; i++){
                        if(that._selectData[i].uuid == obj.data.uuid){
                            that._selectData.splice(i,1);
                            break;
                        }
                    }
                } 
                that._listSelect();//调用列表选中操作方法
            });
            //监听列表点击事件
            this._iscrollContainer.bind("CELL_CLICK",function(event,arg){
                //判断当前点击的是文件还是文件夹并且当前点击文件是可以预览的
                if(parseInt(arg.isdir) != 1 && parseInt(arg.previewEnable) == 1){
                    that._getPrevData(arg.uuid);//调用获取组装预览需要的参数方法
                    Shell.sendEvent("showPreviewPage",that._previewData);//调用原生方法打开预览窗口
                }else{
                    that.options.commonToast.CommonToast("showToast","当前文件不能预览");//显示飘窗提示
                    //飘窗提示后2s后删除飘窗
                    setTimeout(function(){
                        that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                    },1500);
                }
            });
            //监听搜索组件点击了取消按钮事件 
            this._searchContainer.bind("CANCE_BTN_CLICK",function(){
                that._selectData = [];//重置选中数据
                that._showAndHideBottomMenu("hide");//隐藏底部菜单
                that._selectSize = 2;//重置列表勾选图标大小 
                that._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
                that._searchContainer.CommonSearch("showCloseBtn");//显示关闭按钮
                that._iscrollContainer.find("li").CommonCell("changeSelectSize",2);//调用列表组件改变勾选图标大小方法
                that._iscrollContainer.find("li").CommonCell("lock","no");//解锁列表图标和文件信息禁止点击
                that._iscrollContainer.find("li").CommonCell("cancelSelect");//取消选中列表
            });
            //监听搜索组件点击了关闭按钮
            this._searchContainer.bind("CLOSE_BTN_CLICK",function(){
                that.element.trigger("SEARCH_PANEL_CANCEL");
                that.element.css("top",that.element.height() + "px");
                setTimeout(function(){
                    that.element.css("opacity","0");
                },100);
                setTimeout(function(){
                    that.destroy();
                },310);
            });
            //监听列表选中底部操作操作按钮被点击
            this._bottonMenuContainer.bind("OPERATION_BTN_CLICK",function(event,type){
                var ids = [];
                for(var i = 0; i < that._selectData.length; i++){
                    ids.push(that._selectData[i].uuid);
                }
                if(type == "move"){
                    Shell.sendEvent("openWin",{"url":"/djmyspacemove/index.html?token="+getUrl("token")+"&cloudToken="+getUrl("cloudToken")+"&uuid="+ids.join(","),"open_type":true,"title":"移动"});
                }else if(type == "copy"){
                    Shell.sendEvent("openWin",{"url":"/djmyspacecopy/index.html?token="+getUrl("token")+"&cloudToken="+getUrl("cloudToken")+"&uuid="+ids.join(","),"open_type":true,"title":"复制"});
                }else if(type == "rename"){
                    Shell.sendEvent("openWin",{"url":"/djmyspacerename/index.html?token="+getUrl("token")+"&cloudToken="+getUrl("cloudToken")+"&pam="+encode(that._selectData[0]),"open_type":true,"title":"重命名"});
                }else if(type == "download"){
                    that._lock("yes");//锁定页面
                    that._getDownloadFile(ids.join(","));//调用获取下载文件方法
                }else if(type == "delete"){
                    that._lock("yes");//锁定页面
                    //初始化删除提示组件
                    var deleteMaskContainer = $("<div style='z-index:1;'></div>").appendTo($("body"));
                    deleteMaskContainer.CommonDeleteMask({"text":"确定要删除这"+that._selectData.length+"个文件吗？删除后15天内可以在回收站找回"});
                    //监听取消事件  
                    deleteMaskContainer.bind("DELETE_MASK_CANCEL",function(){
                        that._lock("no");//锁定页面
                    });
                    //监听确定事件
                    deleteMaskContainer.bind("DELETE_MASK_DETERMINE",function(){
                        deleteMaskContainer.CommonDeleteMask("removeMask");//调用询问组件的隐藏组件方法
                        that._deleteFile(ids.join(","),0);//调用删除方法
                    });
                }else if(type == "inSafe"){
                    that._lock("yes");//调用锁定页面方法
                    that.options.commonToast.CommonToast("showToast","移入中，请稍后...");//显示飘窗提示
                    that._moveDeposit(ids.join(","),-1);//调用移入方法
                }else if(type == "share"){
                    that._showAndHideBottomMenu("hide");//隐藏底部操作菜单
                    //初始化分享菜单组件
                    var shareMenuContainer = $("<div style='z-index:1;' id='shareMenu'></div>").appendTo($("body"));
                    shareMenuContainer.CommonShareMenu({"menuData":global.share_way_config});
                    //监听分享菜单显示 
                    shareMenuContainer.bind("SHAER_MENU_SHOW",function(){
                        that._lock("yes");//调用锁定页面方法（主要是禁止点击和滑动）
                    });
                    //监听分享菜单取消分享
                    shareMenuContainer.bind("SHARE_CANCEL_BTN_CLICK",function(){
                        that._lock("no");//调用解锁页面方法
                        that._showAndHideBottomMenu("show");//调用显示和隐藏列表选中底部操作菜单
                    });
                    //监听分享菜单底部操作按钮被点击 
                    shareMenuContainer.bind("SHARE_BTN_CLICK",function(event,type){
                        var name = "";//分享的文件名称
                        if(that._selectData.length > 1){
                            name = that._selectData[0].name + "等...";
                        }else{
                            name = that._selectData[0].name;
                        }
                        //判断点击是哪个操作按钮
                        if(type == "wxsession"){
                            that._createThirdShare(name,ids.join(","),"wechat");//调用微信分享，微信朋友圈，qq分享方法
                        }else if(type == "mobileQQ"){
                            that._createThirdShare(name,ids.join(","),"qq");//调用微信分享，微信朋友圈，qq分享方法
                        }else if(type == "wxgroup"){
                            that._createThirdShare(name,ids.join(","),"friends");//调用微信分享，微信朋友圈，qq分享方法
                        }else{
                            Shell.sendEvent("openWin",{"url":"/djmyspacecreatelink/index.html?token="+getUrl("token")+"&cloudToken="+getUrl("cloudToken")+"&pam="+encode({"name":name,"uuid":ids.join(",")}),"open_type":true,"title":"创建链接"});
                        }
                    });
                }
            });
            //清空历史搜索图标按下效果
            this._btnTextCommon(this._historyTitleEmpty.children("div"));
            //监听原生事件
            try{
                //监听原生预览点击上一个下一个文件或者上一张下一张图片事件
                api.addEventListener({name:"nextPrev"},function(arg){
                    //判断是否是当前页面的事件
                    if(arg.value.pageName == that._pageName){
                        //判断禁止用户一直触发
                        if(that._isNextPrev){
                            that._isNextPrev = false;//禁止用户点击再次触发
                            YsPreviewManager.abortAjax();//清除换取预览接口请求
                            that._getPrevData(arg.value.uuid);//调用获取组装预览需要的参数方法
                            //判断是否有缓存
                            if(arg.value.cacheUrl != ""){
                                that._previewData.url = arg.value.cacheUrl;//复制原生返回的预览地址
                                Shell.sendEvent("changePreviewFileAndImage",that._previewData);
                            }else{
                                Shell.sendEvent("changePreviewFileAndImage",that._previewData);
                                YsPreviewManager.SwapUrlWithUUID(that._currentData.fileinfoId,that._currentData.ext);//调用预览管理器换取预览地址
                            }
                        }
                    }
                });
                //监听原生预览点击了文件操作按钮
                api.addEventListener({name:"operationBtnClick"},function(arg){
                    //判断是否是当前页面的事件
                    if(arg.value.pageName == that._pageName){
                        //判断点击的是那个按钮
                        if(arg.value.type == "download"){
                            that._getDownloadFile(arg.value.uuid);//调用下载方法
                        }else if(arg.value.type == "delete"){
                            that._prevDeleteFile(arg.value.uuid,0);//调用预览删除方法
                        }else if(arg.value.type == "share"){
                            Shell.sendEvent("openWin",{"url":"/djmyspacecreatelink/index.html?token="+getUrl("token")+"&cloudToken="+getUrl("cloudToken")+"&pam="+encode({"name":arg.value.name,"uuid":arg.value.uuid}),"open_type":true,"title":"创建链接"});
                        }else if(arg.value.type == "edit"){
                            that._prevCoordinationUrl(arg.value.uuid,arg.value.name);//调用获取协同地址方法
                        }
                    }
                });
                //监听原生预览窗口和协同窗口关闭
                api.addEventListener({name:"closePreview"},function(arg){
                    //判断是否可以刷新
                    if(arg.value.pageName == that._pageName){
                        that._offset = 0;//重置数据请求偏移量
                        that._getSearchData(1);//调用获取文件方法
                    }
                });
            }catch(e){}
        },
        //锁定页面
        _lock:function(type){
            this._searchContainer.CommonSearch("lock",type);//锁定搜索组件
            this._iscrollContainer.find("li").CommonCell("lockList",type);//锁定所有列表
            this._bottonMenuContainer.CommonBottonMenu("lock",type);//锁定底部操作菜单
            this._iscrollContainer.CommonIscroll("isIscroll",type);//锁定滚动容器
        },
        //组件初始化完成主动执行
        _init:function(){
            this._historyData = [];//历史搜索数据
            this._key = "";//搜索关键字
            this._offset = 0;//数据请求偏移量
            this._selectSize = 2;//控制新生成的节点勾选图标大小，参数2是小，1是大
            this._selectData = [];//列表选中数据
            this._pageName = "DjMyspaceSearchPanel",//预览类型，主要是那个页面进行预览
            this._previewData = {};//预览文件数据（这个主要是给原生用和删除当前正在预览的文件判断是否还有下一张上一张或者下一个上一个文件使用的）
            this._currentData = {};//当前预览文件的数据（这个主要是用来控制器用和换取预览地址的和给原生提供当前预览的文件信息的）
            this._isNextPrev = true;//防止用户一只触发上一张下一张事件
            setTimeout(function(that){
                that.element.css("top","0px");
                setTimeout(function(){
                    that.element.css("opacity",1);
                },20);
                //判读是否有历史搜索记录
                if(window.localStorage.getItem("mySpace"+global.userInfo.id) != null && window.localStorage.getItem("mySpace"+global.userInfo.id) != undefined && window.localStorage.getItem("mySpace"+global.userInfo.id) != ""){
                    that._historyData = window.localStorage.getItem("mySpace"+global.userInfo.id).split(",");//得到历史搜索数据
                    that._generateHistoryData();//调用生成历史搜索记录方法
                }else{
                    setTimeout(function(){
                        that._searchContainer.CommonSearch("getFocus");//获取焦点
                    },300);
                }
            },50,this);
            //这句主要是兼容安卓遇到底部导航栏不占位置问题
            setTimeout(function(that){
                that._maxContainer.css("height",that.element.height() - that._searchContainer.outerHeight(true) + "px");
            },100,this);
        },
        //所有的按钮和可以点击的文本按下和抬起事件方法
        _btnTextCommon:function(element){
            //给选项绑定手指按下事件
            element.bind('touchstart',function(){
                $(this).css("opacity","0.5");
            });
            //给选项绑定手指抬起事件
            element.bind('touchend',function(){
                $(this).css("opacity","");
            });
        },
        //点击清空历史搜索记录图标方法
        _emptyHistory:function(event){
            event.data._historyKeyContainer.children("div").remove();//清空所有历史搜索标签
            event.data._historyData = [];//清空历史搜索数组
            window.localStorage.removeItem("mySpace"+global.userInfo.id);//清空缓存的历史搜索
            event.data._historyTitleEmpty.children("div").css("display","none");//隐藏清空历史搜索图标
        },
        //设置历史搜索缓存方法
        _setHistoryData:function(){
            window.localStorage.setItem("mySpace"+global.userInfo.id,this._historyData.join(","));
        },
        //生成历史搜索记录方法
        _generateHistoryData:function(){
            this._historyTitleEmpty.children("div").css("display","flex");
            this._historyKeyContainer.children("div").remove();
            for(var i = 0; i < this._historyData.length; i++){
                var label = $("<div style='height:0.29rem;border-radius:0.15rem;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;background:#F5F5F5;font-size:0.14rem;color:#666;margin-right:0.1rem;line-height:0.29rem;flex-shrink:0;margin-bottom:0.15rem;'>"+this._historyData[i]+"</div>").appendTo(this._historyKeyContainer);
                label.bind("click",this,this._historyLabelClick);
            }
        },
        //点击历史搜索标签
        _historyLabelClick:function(event){
            event.data._key = $(this).html();//设置搜索关键字
            event.data._searchContainer.CommonSearch("setSearchVal",$(this).html());//设置输入框的值
            event.data._searchHistoryShare();//调用触发搜索组件的搜索和点击历史搜索标签相同逻辑
        },
        //触发搜索组件的搜索和点击历史搜索标签相同逻辑
        _searchHistoryShare:function(){
            this._lock("yes");//锁定页面
            this._historyIscrollContainer.css("margin-left","-" + this.element.width() + "px");//切换列表容器
            //判读当前关键字在历史搜索标签数组里面是否存在
            if(this._historyData.indexOf(this._key) > -1){
                //改变历史搜索顺序
                for(var i = 0; i < this._historyData.length; i++){
                    if(this._historyData[i] == this._key){
                        this._historyData.splice(i,1);
                        break;
                    }
                }
            }
            this._historyData.unshift(this._key);//将当前点击这个历史搜索标签添加到历史搜索标签数组第一个
            this._setHistoryData();//调用设置历史搜索缓存方法
            this._searchContainer.CommonSearch("searchInput","yes");//锁住搜索输入框
            setTimeout(function(that){
                that._generateHistoryData();//调用生成历史搜索标签方法重新生成历史搜索标签
            },300,this);
            setTimeout(function(that){
                that._offset = 0;//重置数据请求偏移量
                that._getSearchData(1);//调用获取搜索列表数据方法
            },200,this);
        },
        //列表选中操作方法
        _listSelect:function(){
            //判读选中数据的长度
            if(this._selectData.length != 0){
                this._searchContainer.CommonSearch("searchInput","yes");//锁住搜索输入框
                if(this._selectData.length == 1){
                    //判读底部菜单是否显示
                    if(this._bottonMenuContainer.attr("isShow") == "no"){
                        this._showAndHideBottomMenu("show");//显示底部菜单
                        this._searchContainer.CommonSearch("showCancelBtn");//显示取消按钮
                        this._iscrollContainer.find("li").CommonCell("changeSelectSize",1);//调用列表组件改变勾选图标大小方法
                        this._iscrollContainer.find("li").CommonCell("lock","yes");//锁定列表图标和文件信息禁止点击
                    }
                    //判断当前选中数据是否是置顶的
                    if(parseInt(this._selectData[0].is_up) == 0){//没有置顶
                        this._bottonMenuContainer.CommonBottonMenu("lockOptBtn",["取消置顶"]);//调用列表选中底部操作菜单组件锁定按钮和解锁操作按钮方法
                    }else{
                        this._bottonMenuContainer.CommonBottonMenu("lockOptBtn",["置顶"]);//调用列表选中底部操作菜单组件锁定按钮和解锁操作按钮方法
                    }
                }else{
                    this._bottonMenuContainer.CommonBottonMenu("lockOptBtn",["取消置顶","重命名","查看信息","置顶","设置标签"]);//调用列表选中底部操作菜单组件锁定按钮和解锁操作按钮方法
                }
            }else{
                this._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
                this._showAndHideBottomMenu("hide");//隐藏底部菜单
                this._searchContainer.CommonSearch("showCloseBtn");//显示关闭按钮
                this._iscrollContainer.find("li").CommonCell("changeSelectSize",2);//调用列表组件改变勾选图标大小方法
                this._iscrollContainer.find("li").CommonCell("lock","no");//解锁列表图标和文件信息禁止点击
            }
        },
        //显示隐藏文件列表选中底部操作菜单方法
        _showAndHideBottomMenu:function(type){
            var height = this._bottonMenuContainer.outerHeight(true);//得到需要减去的高度
            if(type == "show"){
                this._maxContainer.css("height",this._maxContainer.height() - height + "px");
                this._iscrollContainer.CommonIscroll("changeIscrollContainerMinHeight",this._iscrollContainer.height() - height + this._paddingBottom);//调用改变滚动容器高度方法
                this._bottonMenuContainer.attr("isShow","yes");//改变底部操作菜单属性表示菜单已经显示
            }else{
                this._maxContainer.css("height",this._maxContainer.height() + height + "px");
                this._iscrollContainer.CommonIscroll("changeIscrollContainerMinHeight",this._iscrollContainer.height() + height - this._paddingBottom);//调用改变滚动容器高度方法
                this._bottonMenuContainer.attr("isShow","no");//改变底部操作菜单属性表示菜单已经隐藏
            }
        },
        //获取组装预览需要的参数方法
        _getPrevData:function(uuid){
            //调用找到当前预览文件所需的参数方法得到当前预览文件的信息
            this._currentData = getCurrentPreviewFileInformation({"content":this._iscrollContainer,"fileId":uuid});
            //组装原生和删除当前预览文件需要的数据
            this._previewData = {}//原生要的预览数据
            this._previewData.uuid = this._currentData.uuid;//当前预览的文件uuid
            this._previewData.fileinfoId = this._currentData.fileinfoId;//当前预览的文件fileinfoId
            this._previewData.type = this._currentData.type;//当前预览的文件类型
            this._previewData.name = this._currentData.fileName;//当前预览的文件名称
            this._previewData.error = "";//错误提示语
            this._previewData.url = "";//当前文件预览地址
            this._previewData.pageName = this._pageName;//当前在那个页面预览参数
            this._previewData.btnArray = [{"name":"下载","key":"download","icon":""},{"name":"删除","key":"delete","icon":""},{"name":"分享","key":"share","icon":""}];//当前文件可操作按钮
            //判断档期那预览的文件是什么类型(调用找到上一个下一个图片或者文件id方法)
            if(this._currentData.type == "image"){
                this._previewData.prevFile = getPrevNextFileId({"fileId":uuid,"operateType":"prev","fileType":"auto","content":this._iscrollContainer});//上一个文件的uuid
                this._previewData.prevFileInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"prev","fileType":"auto","content":this._iscrollContainer});//上一个文件的fileinfoid
                this._previewData.nextFile = getPrevNextFileId({"fileId":uuid,"operateType":"next","fileType":"auto","content":this._iscrollContainer});//下一个文件uuid
                this._previewData.nextFileInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"next","fileType":"auto","content":this._iscrollContainer});//下一个文件的fileinfoid          
                this._previewData.prevImg = getPrevNextFileId({"fileId":uuid,"operateType":"prev","fileType":"image","content":this._iscrollContainer});//上一张图片的uuid
                this._previewData.prevImgInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"prev","fileType":"image","content":this._iscrollContainer});//上一张图片的fileinfoid
                this._previewData.nextImg = getPrevNextFileId({"fileId":uuid,"operateType":"next","fileType":"image","content":this._iscrollContainer});//下一张图片的uuid
                this._previewData.nextImgInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"next","fileType":"image","content":this._iscrollContainer});//下一张图片的fileinfoid
            }else{
                this._previewData.prevFile = getPrevNextFileId({"fileId":uuid,"operateType":"prev","fileType":"auto","content":this._iscrollContainer});//上一个文件uuid
                this._previewData.prevFileInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"prev","fileType":"auto","content":this._iscrollContainer});//上一个文件的fileinfoid
                this._previewData.nextFile = getPrevNextFileId({"fileId":uuid,"operateType":"next","fileType":"auto","content":this._iscrollContainer});//下一个文件的uuid
                this._previewData.nextFileInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"next","fileType":"auto","content":this._iscrollContainer});//下一个文件的fileinfoid
                this._previewData.prevImg = "";//上一张图片的uuid
                this._previewData.prevImgInfoid = "";//上一张图片的fileinfoid
                this._previewData.nextImg = "";//下一张图片uuid
                this._previewData.nextImgInfoid = "";//下一张图片的fileinfoid
                var ext = ["doc","docx","xls","xlsx","ppt","pptx","txt"];
                //判断当前预览文件是否可以协同处理
                if(ext.indexOf(this._currentData.ext) > -1){
                    this._previewData.btnArray.push({"name":"编辑","key":"edit","icon":""});
                }
            }
            this._isNextPrev = true;//允许用户点击再次触发
        },
        //获取搜索列表数据方法
        _getSearchData:function(type){
            var that = this;
            //判读当前是搜索还是下拉刷新还是上拉加载更多
            if(type == 1){
                var getTime = setTimeout(function(){
                    that._iscrollContainer.CommonIscroll("showLoadMask");//显示加载层
                },2000);
            }
            //请求参数
            var paramet = {"token":getUrl("cloudToken"),"uuid":that.options.uuid,"offset":that._offset,"sort":that.options.sort,"type":that.options.type,"keyword":that._key,"order":"desc"};
            http(ServerConfig.cloudDomain+"/"+skinConfig(global.skin).skinUrl+"/searchFile",paramet,{
                success:function(arg){
                    clearTimeout(getTime);//清除延时
                    if(parseInt(arg.code) == 1){
                        that._generateList(type,arg.data.rows);//调用生成列表方法
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            //判读当前是搜索还是下拉刷新还是上拉加载更多
                            if(type == 1){//搜索错误
                                setTimeout(function(){
                                    that._iscrollContainer.CommonIscroll("showErrorMask",arg.msg);//显示错误提示层
                                },500);
                            }else if(type == 2){//下拉刷新错误
                                setTimeout(function(){
                                    that._iscrollContainer.CommonIscroll("refreshSuccessAndFail",arg.msg);//调用下拉刷新错误
                                },500);
                            }else if(type == 3){//上拉加载更多
                                setTimeout(function(){
                                    that._iscrollContainer.CommonIscroll("loadMoreSuccessAndFail",arg.msg);//调用加载错误
                                },500);
                            } 
                        }
                    }
                }
            });
        },
        //生成列表方法
        _generateList:function(type,dataArray){
            var that = this;
            var cellArray = [];
            for(var i = 0; i < dataArray.length; i++){
                var cell = $("<li uuid='"+dataArray[i].uuid+"' previewEnable='"+dataArray[i].previewEnable+"' fileInfoId='"+dataArray[i].fileinfo_id+"' type='"+matchingFileType(dataArray[i].ext)+"' ext='"+dataArray[i].ext+"' style='width:100%;padding-left:0.15rem;box-sizing:border-box;'></li>").CommonCell({
                    "commonIconUrl":skinConfig(global.skin).commonIcon,
                    "shllIconUrl":skinConfig(global.skin).shllWebIon,
                    "data":dataArray[i],
                    "selectSize":this._selectSize
                });
                cellArray.push(cell);
            }
            //判读当前是搜索还是下拉刷新还是上拉加载更多
            if(type == 1){//搜索
                that._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
                //判断是否有数据
                if(cellArray.length != 0){
                    that._iscrollContainer.CommonIscroll("searchNode",cellArray);//添加搜索数据
                }else{
                    that._iscrollContainer.CommonIscroll("showSearchNoDataMask");//显示搜索没有数据提示层
                }
            }else if(type == 2){//下拉刷新
                setTimeout(function(){
                    that._iscrollContainer.CommonIscroll("refreshSuccessAndFail");//刷新成功方法
                },500);
                //监听下拉刷新完成事件 
                that._iscrollContainer.unbind("REFRESH_COMPLETE").bind("REFRESH_COMPLETE",function(){ 
                    //判读底部操作菜单是否显示
                    if(that._bottonMenuContainer.attr("isShow") == "yes"){
                        that._showAndHideBottomMenu("hide");//隐藏底部操作菜单
                        that._searchContainer.CommonSearch("showCloseBtn");//显示关闭按钮
                    }
                    //判断有无数据
                    if(cellArray.length != 0){
                        that._iscrollContainer.CommonIscroll("refreshNode",cellArray);//更新刷新节点
                    }else{
                        that._iscrollContainer.CommonIscroll("emptyNode");//情况节点
                        that._iscrollContainer.CommonIscroll("showSearchNoDataMask");//显示没有数据提示层
                    }
                });
            }else if(type == 3){//上拉加载更多
                setTimeout(function(){
                    that._iscrollContainer.CommonIscroll("loadMoreSuccessAndFail");//加载成功方法
                },500);
                //监听上拉加载更多完成事件 
                that._iscrollContainer.unbind("LOAD_COMPLETE").bind("LOAD_COMPLETE",function(){
                    that._iscrollContainer.CommonIscroll("addNode",cellArray);//添加上拉加载出来的新节点 
                    //判读底部操作菜单是否显示
                    if(that._bottonMenuContainer.attr("isShow") == "yes"){
                        //判断是否有数据
                        if(cellArray.length != 0){
                            that._iscrollContainer.find("li").CommonCell("lock","yes");//锁定列表图标和文件信息禁止点击
                        }
                    }
                });
            }
            if(type == 1){
                setTimeout(function(){
                    that._lock("no");//解锁页面
                },100); 
            }else{
                setTimeout(function(){
                    that._lock("no");//解锁页面
                },1800); 
            }
        },
        //下载方法
        _getDownloadFile:function(uuid){
            var that = this;
            //如果两秒都还没有得到接口返回提示正在删除提示
            var dow = setTimeout(function(){
                that.options.commonToast.CommonToast("showToast","获取下载文件中，请稍后...");//显示飘窗提示
            },2000);
            //请求参数
            var paramet = {"token":getUrl("cloudToken"),"uuid":uuid};
            http(ServerConfig.cloudDomain+"/download/getDownLoadFile",paramet,{
                success:function(arg){
                    clearTimeout(dow);//清除延迟
                    if(parseInt(arg.code) == 1){
                        //判断是否有提示
                        if(that.options.commonToast.attr("isShow") != "no"){
                            that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                        }
                        that._lock("no");//解锁页面
                        Shell.sendEvent("download",{"list":arg.data.rows});//给原生发事件，并把下载文件发送给原生
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            //判断是否有提示
                            if(that.options.commonToast.attr("isShow") == "no"){
                                that.options.commonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            }else{
                                that.options.commonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            }
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                                that._lock("no");//解锁页面
                            },1500);
                        }
                    }
                }
            });
        },
        //删除方法
        _deleteFile:function(uuid,conflictUuid){
            var that = this;
            //如果两秒都还没有得到接口返回提示正在删除提示
            var delTime = setTimeout(function(){
                that.options.commonToast.CommonToast("showToast","删除中，请稍后...");//显示飘窗提示
            },2000);
            //请求参数
            var paramet = {"token":getUrl("cloudToken"),"uuid":uuid,"conflict_uuid":conflictUuid};
            http(ServerConfig.cloudDomain+"/recycle/removeFileToRecycle",paramet,{
                success:function(arg){
                    clearTimeout(delTime);//清除延迟
                    if(parseInt(arg.code) == 1){
                        that._searchContainer.trigger("CANCE_BTN_CLICK");//抛出取消事件件
                        Shell.sendEvent("commonChange",{"pageName":"djmyspace"});//通知原生我首页需要刷新
                        //判断是否有提示 
                        if(that.options.commonToast.attr("isShow") == "no"){
                            that.options.commonToast.CommonToast("showToast","删除成功");//显示飘窗提示
                        }else{
                            that.options.commonToast.CommonToast("changeText","删除成功");//改变提示文字
                        }
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            that._offset = 0;//重置偏移量
                            that._getSearchData(1);//获取列表数据
                        },1500);
                    }else{
                        //判断是否有提示
                        if(that.options.commonToast.attr("isShow") != "no"){
                            that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                        }
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else if(arg.msg == "创建有链接，是否删除"){
                            //初始化询问提示
                            var deleteMask = $("<div style='z-index:1;'></div>").appendTo($("body"));
                            deleteMask.CommonDeleteMask({
                                "title":"删除提示！",
                                "text":"当前文件创有链接，是否还要继续删除",
                                "determineBtn":"继续"
                            });
                            //监听取消事件
                            deleteMask.bind("DELETE_MASK_CANCEL",function(){
                                Shell.sendEvent("commonChange",{"pageName":"djmyspace"});//通知原生我首页需要刷新
                                that._searchContainer.trigger("CANCE_BTN_CLICK");//抛出取消事件件
                                setTimeout(function(){
                                    that._offset = 0;//重置偏移量
                                    that._getSearchData(1);//获取列表数据
                                },500);
                            });
                            //监听确定事件
                            deleteMask.bind("DELETE_MASK_DETERMINE",function(){
                                deleteMask.CommonDeleteMask("removeMask");//调用询问组件删除方法
                                that._deleteFile(uuid,arg.data.conflict_uuid);//调用自己本身
                            });
                        }else{
                            //判断是否有提示
                            if(that.options.commonToast.attr("isShow") == "no"){
                                that.options.commonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            }else{
                                that.options.commonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            }
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                                that._lock("no");//解锁页面
                            },1500);
                        }
                    }
                }
            });
        },
        //预览删除文件方法
        _prevDeleteFile:function(uuid,conflictUuid){
            var that = this;
            //请求参数
            var paramet = {"token":getUrl("cloudToken"),"uuid":uuid,"conflict_uuid":conflictUuid};
            http(ServerConfig.cloudDomain+"/recycle/removeFileToRecycle",paramet,{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        Shell.sendEvent("commonChange",{"pageName":"djmyspace"});//通知原生我首页需要刷新
                        that._offset = 0;//重置偏移量
                        that._getSearchData(1);//获取列表数据
                        Shell.sendEvent("deleteFile",{"code":1,"msg":"删除成功"});//告诉原生删除结果
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else if(arg.msg == "创建有链接，是否删除"){ 
                            that._prevDeleteFile(uuid,arg.data.conflict_uuid);//调用自己本身
                        }else{
                            Shell.sendEvent("deleteFile",{"code":0,"msg":arg.msg});//告诉原生删除结果
                        }
                    }
                }
            });
        },
        //移入保险箱方法
        _moveDeposit:function(uuid,conflictUuid){
            var that = this;
            //请求参数
            var paramet = {"token":getUrl("token"),"uuid":uuid,"pid":0,"conflict_uuid":conflictUuid};
            http(ServerConfig.domain+"/safe/moveIn",paramet,{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        that._searchContainer.trigger("CANCE_BTN_CLICK");//抛出取消事件件
                        Shell.sendEvent("commonChange",{"pageName":"djmyspace"});//通知原生我首页需要刷新
                        //判断是否有提示 
                        if(that.options.commonToast.attr("isShow") == "no"){
                            that.options.commonToast.CommonToast("showToast","移入成功");//显示飘窗提示
                        }else{
                            that.options.commonToast.CommonToast("changeText","移入成功");//改变提示文字
                        }
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            that._offset = 0;//重置偏移量
                            that._getSearchData(1);//获取列表数据
                        },1500);
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else if(arg.msg == "重名冲突"){
                            that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            //初始化询问提示
                            var deleteMask = $("<div style='z-index:1;'></div>").appendTo($("body"));
                            deleteMask.CommonDeleteMask({
                                "title":"冲突提示！",
                                "text":"保险箱内已有相同文件（夹），是否继续，如果继续系统将自动重命名",
                                "determineBtn":"继续"
                            });
                            //监听取消事件
                            deleteMask.bind("DELETE_MASK_CANCEL",function(){
                                that._searchContainer.trigger("CANCE_BTN_CLICK");//抛出取消事件件
                                Shell.sendEvent("commonChange",{"pageName":"djmyspace"});//通知原生我首页需要刷新
                                setTimeout(function(){
                                    that._offset = 0;//重置偏移量
                                    that._getSearchData(1);//获取列表数据
                                },500);
                            });
                            //监听确定事件
                            deleteMask.bind("DELETE_MASK_DETERMINE",function(){
                                deleteMask.CommonDeleteMask("removeMask");//调用询问组件删除方法
                                moveDeposit(uuid,arg.data.conflict_uuid)//调用自己本身
                            });
                        }else{
                            //判断是否有提示 
                            if(that.options.commonToast.attr("isShow") == "no"){
                                that.options.commonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            }else{
                                that.options.commonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            }
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                                that._lock("no");//调用解锁页面方法
                            },1500);
                        }
                    }
                }
            });
        },
        //微信朋友圈，qq，微信分享方法
        _createThirdShare:function(name,uuid,type){
            var paramet = {"token":getUrl("cloudToken"),"name":name,"uuid":uuid,"type":1};
            http(ServerConfig.cloudDomain+"/"+skinConfig(global.skin).linkshare+"/createTask",paramet,{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        var data= {
                            url:arg.data.url,//分享链接
                            title:"文件分享：" + name,
                            content:"给你分享了"+ uuid.length +"文件，快来下载吧",
                            image:ServerConfig.domain.replace("/appweb","/shell_web") + skinConfig(global.skin).shllWebIon.replace("..","") + "search_icon.png",
                            type:type// qq | wechat | friends
                        };
                        Shell.sendEvent("ThirdPartyShare",data);
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            that.options.commonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            },1500);
                        }
                    }
                }
            });
        },
        //获取预览协同地址
        _prevCoordinationUrl:function(uuid,name){
            var that = this;
            //请求参数
            var ext = "";
            if(this._currentData.ext == "docx" || this._currentData.ext == "doc"){
                ext = "word";
            }else if(this._currentData.ext == "xlsx" || this._currentData.ext == "xls"){
                ext = "excel";
            }else if(this._currentData.ext == "pptx" || this._currentData.ext == "ppt"){
                ext = "ppt";
            }else if(this._currentData.ext == "txt"){
                ext = "txt";
            }
            var paramet = {"token":getUrl("cloudToken"),"uuid":uuid,"document_type":ext,"name":name};
            http(ServerConfig.cloudDomain+"/"+skinConfig(global.skin).skinUrl+"/getDocumentPreviewUrl",paramet,{
                success:function(arg){
                    if(parseInt(arg.code) == 1 && arg.data.url != ""){
                        Shell.sendEvent("setCoordinationUrl",{"url":arg.data.url});//告诉原生协同地址
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            that.options.commonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            },1500);
                        }
                    }
                }
            });
        },
        //模拟搜索组件刷新方法
        searchRefresh:function(){
            //判读是否显示底部操作按钮
            if(this._bottonMenuContainer.attr("isShow") == "yes"){
                this._searchContainer.trigger("CANCE_BTN_CLICK");//抛出取消事件
            }
            this._offset = 0;//重置请求数据偏移量
            setTimeout(function(that){
                that._getSearchData(1);//调用获取搜索列表数据方法
            },500,this);
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
            this.element.remove();
        }
    });
});