/*
*   2020年12月6日
*   
*   封装云空间手机端我的链接分享任务cell组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.LinkCell",{
        //默认参数
        options:{
            commonIconUrl:"../common2/img/djcommon/",//通用文件图标路径
            shllIconUrl:"../common2/img/red/",//皮肤配置对应的文件图标路径
            isSelect:true,//是否开启勾选框
            selectSize:2,//勾选图标大小
            icon:"",//任务图标
            data:null,//当前这条数据
        },
        _maxContainer:null,//元素最大容器
        _iconContainer:null,//文件图标容器元素
        _fileInformationContainer:null,//文件信息容器元素
        _fileName:null,//文件名称元素
        _selectContainer:null,//勾选容器元素
        _isClick:true,//控制用户不停的点击勾选按钮
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            //创建最大容器
            this._maxContainer = $("<div style='width:100%;border-bottom:1px solid #ECECEC;padding:0.15rem 0 0.15rem 0;box-sizing:border-box;display:flex;flex-direction:row;'></div>").appendTo(this.element);
            //创建文件图标元素
            this._iconContainer = $("<div style='width:0.45rem;position:relative;display:flex;justify-content:center;flex-shrink:0;'></div>").appendTo(this._maxContainer);
            $("<img class='fileIcon' style='width:0.18rem;height:0.18rem;margin-top:0.04rem;' src='"+this.options.icon+"'/>").appendTo(this._iconContainer);
            //创建文件信息和勾选最大容器
            var fileInformationSelectContainer = $("<div style='width:100%;display:flex;flex-direction:row;justify-content: space-between;'></div>").appendTo(this._maxContainer);
            //创建文件信息容器
            this._fileInformationContainer = $("<div></div>").appendTo(fileInformationSelectContainer);
            this._fileName = $("<p class='fileName' style='width:100%;font-size:0.16rem;font-weight:bold;display:-webkit-box;overflow:hidden;text-overflow:ellipsis;-webkit-line-clamp:3;-webkit-box-orient:vertical;word-wrap:break-word;'>"+this.options.data.name+"</p>").appendTo(this._fileInformationContainer);
            var fileTimeSizeContainer = $("<div style='margin-top:0.08rem;'></div>").appendTo(this._fileInformationContainer);
            var time = this.options.data.createtime == undefined ? this.options.data.date_time : this.options.data.createtime;
            $("<span style='font-size:0.12rem;color:#999;'>"+time+"</span>").appendTo(fileTimeSizeContainer);
            $("<span class='visit' numm='"+this.options.data.visit_times+"' style='font-size:0.12rem;color:#999;margin-left:0.1rem;'>浏览"+this.options.data.visit_times+"次</span>").appendTo(fileTimeSizeContainer);
            $("<span style='font-size:0.12rem;color:#999;margin-left:0.1rem;'>下载"+this.options.data.download_times+"次</span>").appendTo(fileTimeSizeContainer);
            //判断是否开启了勾选
            if(this.options.isSelect){
                //创建勾选元素容器
                this._selectContainer = $("<div class='isSelect' isSelect='no' style='width:0.48rem;height:100%;display:flex;align-items:center;justify-content:center;flex-shrink:0;'></div>").appendTo(fileInformationSelectContainer);
                var setIconSize = parseInt(this.options.selectSize) == 2 ? "0.09rem" : "0.18rem";
                $("<img style='width:"+setIconSize+";height:"+setIconSize+";' src='"+this.options.commonIconUrl+"pt_touxuan.png'/>").appendTo(this._selectContainer);
                //给勾选容器绑定点击事件
                this._selectContainer.bind("click",this,this._selectClick);
                //设置文件信息容器的宽度
                this._fileInformationContainer.css("width",($(window).width() - 120) / 100 + "rem");
            }else{
                //设置文件信息容器的宽度
                this._fileInformationContainer.css("width",($(window).width() - 80) / 100 + "rem");
            }
            //给文件信息容器绑定点击事件
            this._fileInformationContainer.bind("click",this,this._fileCellClick);
            //给文件图标容器绑定点击事件
            this._iconContainer.bind("click",this,this._fileCellClick);
        },
        //点击文件图标和文件信息
        _fileCellClick:function(event){
            //判断是否可以抛出点击事件
            if(event.data._isClick){
                event.data._isClick = false;
                event.data.element.trigger("CELL_CLICK",event.data.options.data);
                setTimeout(function(){
                    event.data._isClick = true;
                },300);
            }
        },
        //点击勾选图标容器
        _selectClick:function(event){
            //判断是否可以抛出点击事件
            if(event.data._isClick){
                event.data._isClick = false;
                //判断当前是选中还是取消选中
                if($(this).attr("isSelect") == "no"){
                    $(this).attr("isSelect","yes");
                    $(this).children("img").attr("src",event.data.options.shllIconUrl + "pt_touxuan.png");
                }else{
                    $(this).attr("isSelect","no");
                    $(this).children("img").attr("src",event.data.options.commonIconUrl + "pt_touxuan.png");
                }
                event.data.element.trigger("CELL_SELECT",{"type":$(this).attr("isSelect"),"data":event.data.options.data});
                setTimeout(function(){
                    event.data._isClick = true;
                },300);
            }
        },
        //改变勾选按钮大小方法1是变大2是变小
        changeSelectSize:function(type){
            //判断是变大还是变小
            if(type == 1){
                this._selectContainer.children("img").css({"width":"0.18rem","height":"0.18rem"});
            }else{
                this._selectContainer.children("img").css({"width":"0.09rem","height":"0.09rem"});
            }
        },
        //选中方法
        allSelect:function(){
            this._selectContainer.children("img").attr("src",this.options.shllIconUrl + "pt_touxuan.png");
            this._selectContainer.attr("isSelect","yes");
        },
        //取消选中方法
        cancelSelect:function(){
            this._selectContainer.children("img").attr("src",this.options.commonIconUrl + "pt_touxuan.png");
            this._selectContainer.attr("isSelect","no");
        },
        //获取当前数据方法
        getData:function(){
            return this.options.data;
        },
        //锁定信息元素和图标元素方法yes表示锁定no表示解锁
        lock:function(type){
            if(type == "yes"){
                this._fileInformationContainer.css("pointer-events","none");
                this._iconContainer.css("pointer-events","none");
            }else{
                this._fileInformationContainer.css("pointer-events","");
                this._iconContainer.css("pointer-events","");
            }
        },
        //锁定整个列表
        lockList:function(type){
            if(type == "yes"){
                this.element.css("pointer-events","none");
            }else{
                this.element.css("pointer-events","");
            }
        },
        //改变浏览次数方法
        changeVisit:function(){
            this.element.find(".visit").attr("numm",(parseInt(this.element.find(".visit").attr("numm")) + 1));
            this.element.find(".visit").html("浏览"+parseInt(this.element.find(".visit").attr("numm"))+"次");
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});