/*
*   2020年12月5日
*   
*   智能笔连接容器插件
*
*   开发者：薛原 
*/
define(["iscroll","Shell","Panel","Label","Img",'BaseBtn',"PenCell"],function(IScroll,Shell){
	var linkedHistory;
	var linkImg = $("<div></div>").Img({"src":"../djcommon/img/note/bt.png","width":"90px","height":"90px"});
	linkImg.css("position","absolute");
	linkImg.Img("setTop","63px");
	linkImg.Img("setLeft","17px");
	
	var myScroll;
	var searchPenData = [];
	var linkTimer;
	var foundMacArr = [];
	var linking = false;
    $.widget("ys.LinkPenPanel",$.ys.Panel,{
        //默认参数
        options:{},
        _maxContainer:null,//最大容器
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
			this.element.addClass("LinkPenPanel");
			this.setBgColor("#ffffff");
			this.setWidth("100%");
			this.setHeight("202px");
            this.element.css({"box-shadow":"0px 2px 14px 2px rgba(0, 0, 0, 0.04)"});
			//this.setSearchStatus();
        },
		show:function(){
			var that = this;
			linking = false;
			this.element.animate({"top":"0px"},"5000",function(){
				that.element.find(".searchMainText").animate({"opacity":1},500,function(){
					that.element.find(".searchSecText").animate({"opacity":1},500);
					that.element.find(".cancellinkBtn").animate({"opacity":1},500);
				});
			});
		},
		hide:function(){
			var that = this;
			this.element.trigger("LINK_PEN_HIDE");
			this.element.animate({"top":"-1000px"},500,function(){
				$("#link-pen-wrapper").remove();
				myScroll = null;
				searchPenData = [];
				foundMacArr = [];
			    that.element.hide();
			});
			Shell.sendEvent("lockTabBar",{"lock":false});
		},
		setSearchingStatusWithNoEvent:function(){
			foundMacArr = [];
			searchPenData = [];
			if(linkTimer){
				clearInterval(linkTimer);
				linkTimer = 0;
			}
			this.setHeight("202px");
			var that = this;
			this.element.empty();
			var linkImg = $("<div></div>").Img({"src":"../djcommon/img/note/line.png","width":"90px","height":"90px"});
			linkImg.css("position","absolute");
			linkImg.Img("setTop","63px");
			linkImg.Img("setLeft","17px");
			this.addElement(linkImg);
			var mainText = $("<div class='mainText searchMainText'></div>").Label({"text":"设备搜索中...","fontSize":"20px","fontWeight":"800","letterSpacing":"2px"});
			mainText.css("opacity",0);
			mainText.Label("setLeft","125px");
			mainText.Label("setTop","61px");
			mainText.css("position","absolute");
			this.addElement(mainText);
			
			var secText = $("<div class='secText searchSecText'></div>").Label({"text":"请保持有线笔接口与手机连接，确保绿","fontSize":"14px","color":"#666666"});
			secText.css("opacity",0);
			secText.Label("setLeft","125px");
			secText.Label("setTop","94px");
			secText.css("position","absolute");
			this.addElement(secText);
			var secText = $("<div class='secText searchSecText'></div>").Label({"text":"灯闪烁","fontSize":"14px","color":"#666666"});
			secText.css("opacity",0);
			secText.Label("setLeft","125px");
			secText.Label("setTop","120px");
			secText.css("position","absolute");
			this.addElement(secText);
			
			var searchTimerValText = $("<div class='searchTimerValText'></div>").Label({"text":"5S","fontSize":"15px","color":"#666666"});
			searchTimerValText.Label("setRight","30px");
			searchTimerValText.Label("setTop","70px");
			searchTimerValText.css("position","absolute");
			this.addElement(searchTimerValText);
			linkTimer = setInterval(function(){
				var time = parseInt(searchTimerValText.Label("getText").replace("S",""));
				time--;
				searchTimerValText.Label("setText",time+"S");
				if(time == 0){
					clearInterval(linkTimer);
				}
			},1000);
			var cancelLinkBtn = $("<div class='cancellinkBtn'></div>").BaseBtn({"text":"暂不连接","width":"74px","height":"32px","fontSize":"13px","textColor":"#999999"});
			cancelLinkBtn.css("opacity",0);
			cancelLinkBtn.css("border-radius","3rem");
			cancelLinkBtn.css("border","1px solid #999999");
			cancelLinkBtn.css("position","absolute");
			cancelLinkBtn.BaseBtn("setLeft","125px");
			cancelLinkBtn.BaseBtn("setTop","150px");
			cancelLinkBtn.bind("BTN_CLICK",this,this.cancelScanLink);
			this.element.append(cancelLinkBtn);
			
			var relLinkBtn = $("<div class='relinkBtn'></div>").BaseBtn({"text":"重新搜索","width":"74px","height":"32px","fontSize":"13px","bgColor":"linear-gradient(-90deg, #CF000F, #E50414)","textColor":"#ffffff"});
			relLinkBtn.css("border-radius","3rem");
			relLinkBtn.css("border","1px solid #E50414");
			relLinkBtn.css("position","absolute");
			relLinkBtn.BaseBtn("setLeft","125px");
			relLinkBtn.BaseBtn("setTop","120px");
			relLinkBtn.hide();
			relLinkBtn.bind("BTN_CLICK",this,this.relLink);
			this.element.append(relLinkBtn);
			
			if(this.element.offset().top == 0){
				that.element.find(".searchMainText").animate({"opacity":1},500,function(){
					that.element.find(".searchSecText").animate({"opacity":1},500);
					that.element.find(".cancellinkBtn").animate({"opacity":1},500);
				});
			}
		},
		//设置为搜索状态
		setSearchingStatus:function(data){
			if(typeof(data) != "undefined" && data && data.split("|").length > 0){
				linkedHistory = data;
			}
			foundMacArr = [];
			searchPenData = [];
			if(linkTimer){
				clearInterval(linkTimer);
				linkTimer = 0;
			}
			this.setHeight("202px");
			var that = this;
			this.element.empty();
			this.addElement(linkImg);
			var mainText = $("<div class='mainText searchMainText'></div>").Label({"text":"设备搜索中...","fontSize":"20px","fontWeight":"800","letterSpacing":"2px"});
			mainText.css("opacity",0);
			mainText.Label("setLeft","125px");
			mainText.Label("setTop","61px");
			mainText.css("position","absolute");
			this.addElement(mainText);
			
			var secText = $("<div class='secText searchSecText'></div>").Label({"text":"请打开智能笔，确保绿灯常亮","fontSize":"14px","color":"#666666"});
			secText.css("opacity",0);
			secText.Label("setLeft","125px");
			secText.Label("setTop","94px");
			secText.css("position","absolute");
			this.addElement(secText);
			
			var searchTimerValText = $("<div class='searchTimerValText'></div>").Label({"text":"60S","fontSize":"15px","color":"#666666"});
			searchTimerValText.Label("setRight","30px");
			searchTimerValText.Label("setTop","70px");
			searchTimerValText.css("position","absolute");
			this.addElement(searchTimerValText);
			linkTimer = setInterval(function(){
				var time = parseInt(searchTimerValText.Label("getText").replace("S",""));
				time--;
				searchTimerValText.Label("setText",time+"S");
				if([3,6,9,12,15,18,21,24,27,30,33,36,39,42,45,48,51,54].indexOf(time) != -1){
					/*api.toast({
						msg: 'SCAN_YS_PEN_CHECK',
						duration: 1000,
						location: 'middle'
					});*/
					that.element.trigger("SCAN_YS_PEN_CHECK");
				}else if([1,4,7,10,13,16,19,22,25,28,31,34,37,40,43,46,49,52,55].indexOf(time) != -1){
					/*api.toast({
						msg: 'SCAN_YS_PEN_GET_RESULT',
						duration: 1000,
						location: 'middle'
					});*/
					that.element.trigger("SCAN_YS_PEN_GET_RESULT");
				}
				if(time == 0){
					clearInterval(linkTimer);
					linkTimer = null;
					searchTimerValText.remove();
					searchTimerValText = null;
					if(foundMacArr.length == 0){
						that.setSearchFailStatus();
					}else{
						that.setSearchSuccessStatus();
					}
					that.element.trigger("SCAN_YS_PEN_END");
				}
			},1000);
			var cancelLinkBtn = $("<div class='cancellinkBtn'></div>").BaseBtn({"text":"暂不连接","width":"74px","height":"32px","fontSize":"13px","textColor":"#999999"});
			cancelLinkBtn.css("opacity",0);
			cancelLinkBtn.css("border-radius","3rem");
			cancelLinkBtn.css("border","1px solid #999999");
			cancelLinkBtn.css("position","absolute");
			cancelLinkBtn.BaseBtn("setLeft","125px");
			cancelLinkBtn.BaseBtn("setTop","120px");
			cancelLinkBtn.bind("BTN_CLICK",this,this.cancelScanLink);
			this.element.append(cancelLinkBtn);
			
			var relLinkBtn = $("<div class='relinkBtn'></div>").BaseBtn({"text":"重新搜索","width":"74px","height":"32px","fontSize":"13px","bgColor":"linear-gradient(-90deg, #CF000F, #E50414)","textColor":"#ffffff"});
			relLinkBtn.css("border-radius","3rem");
			relLinkBtn.css("border","1px solid #E50414");
			relLinkBtn.css("position","absolute");
			relLinkBtn.BaseBtn("setLeft","125px");
			relLinkBtn.BaseBtn("setTop","120px");
			relLinkBtn.hide();
			relLinkBtn.bind("BTN_CLICK",this,this.relLink);
			this.element.append(relLinkBtn);
			that.element.trigger("SCAN_YS_PEN_BEGEN");
			if(this.element.offset().top == 0){
				that.element.find(".searchMainText").animate({"opacity":1},500,function(){
					that.element.find(".searchSecText").animate({"opacity":1},500);
					that.element.find(".cancellinkBtn").animate({"opacity":1},500);
				});
			}
		},
		//设置为有线笔发现状态
		setFoundHasPenStatus:function(data){
			if(linkTimer){
				clearInterval(linkTimer);
				linkTimer = 0;
			}
			this.element.empty();
			//this.addElement(linkImg);
			var linkImg = $("<div></div>").Img({"src":"../djcommon/img/note/line.png","width":"90px","height":"90px"});
			linkImg.css("position","absolute");
			linkImg.Img("setTop","63px");
			linkImg.Img("setLeft","17px");
			this.addElement(linkImg);
			var mainText = $("<div class='mainText'></div>").Label({"text":"检测到当前设备","fontSize":"20px","fontWeight":"800","letterSpacing":"2px"});
			this.setHeight("202px");
			mainText.Label("setLeft","125px");
			mainText.Label("setTop","61px");
			mainText.css("position","absolute");
			this.addElement(mainText);
			var secText = $("<div class='secText'></div>").Label({"text":"PID:"+data.PID+"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;VID:"+data.VID,"fontSize":"14px","color":"#999999"});
			secText.Label("setLeft","125px");
			secText.Label("setTop","94px");
			secText.css("position","absolute");
			this.addElement(secText);
			
			var linkBtn = $("<div class='relinkBtn'></div>").BaseBtn({"text":"连接","width":"74px","height":"32px","fontSize":"13px","bgColor":"linear-gradient(-90deg, #CF000F, #E50414)","textColor":"#ffffff"});
			linkBtn.css("border-radius","3rem");
			linkBtn.css("border","1px solid #E50414");
			linkBtn.css("position","absolute");
			linkBtn.BaseBtn("setLeft","210px");
			linkBtn.BaseBtn("setTop","120px");
			linkBtn.bind("BTN_CLICK",this,this.linkHasLinePen);
			this.element.append(linkBtn);
			
			var cancelLinkBtn = $("<div class='cancellinkBtn'></div>").BaseBtn({"text":"暂不连接","width":"74px","height":"32px","fontSize":"13px","textColor":"#999999"});
			cancelLinkBtn.css("border-radius","3rem");
			cancelLinkBtn.css("border","1px solid #999999");
			cancelLinkBtn.css("position","absolute");
			cancelLinkBtn.BaseBtn("setLeft","121px");
			cancelLinkBtn.BaseBtn("setTop","120px");
			cancelLinkBtn.bind("BTN_CLICK",this,this.cancelLink);
			this.element.append(cancelLinkBtn);
		},
		//设置为权限不足
		setPowerFailStatus:function(){
			if(linkTimer){
				clearInterval(linkTimer);
				linkTimer = 0;
			}
			this.element.empty();
			this.addElement(linkImg);
			var mainText = $("<div class='mainText'></div>").Label({"text":"请确认已开启蓝牙","fontSize":"20px","fontWeight":"800","letterSpacing":"2px"});
			this.setHeight("202px");
			mainText.Label("setLeft","125px");
			mainText.Label("setTop","61px");
			mainText.css("position","absolute");
			this.addElement(mainText);
			
			var secText = $("<div class='secText'></div>").Label({"text":"及定位权限","fontSize":"20px","fontWeight":"800","letterSpacing":"2px"});
			secText.Label("setLeft","125px");
			secText.Label("setTop","87px");
			secText.css("position","absolute");
			this.addElement(secText);
			
			var relLinkBtn = $("<div class='relinkBtn'></div>").BaseBtn({"text":"重新搜索","width":"74px","height":"32px","fontSize":"13px","bgColor":"linear-gradient(-90deg, #CF000F, #E50414)","textColor":"#ffffff"});
			relLinkBtn.css("border-radius","3rem");
			relLinkBtn.css("border","1px solid #E50414");
			relLinkBtn.css("position","absolute");
			relLinkBtn.BaseBtn("setLeft","210px");
			relLinkBtn.BaseBtn("setTop","120px");
			relLinkBtn.bind("BTN_CLICK",this,this.rePower);
			this.element.append(relLinkBtn);
			
			var cancelLinkBtn = $("<div class='cancellinkBtn'></div>").BaseBtn({"text":"暂不连接","width":"74px","height":"32px","fontSize":"13px","textColor":"#999999"});
			cancelLinkBtn.css("border-radius","3rem");
			cancelLinkBtn.css("border","1px solid #999999");
			cancelLinkBtn.css("position","absolute");
			cancelLinkBtn.BaseBtn("setLeft","121px");
			cancelLinkBtn.BaseBtn("setTop","120px");
			cancelLinkBtn.bind("BTN_CLICK",this,this.cancelLink);
			this.element.append(cancelLinkBtn);
		},
		//设置为搜索失败状态
		setSearchFailStatus:function(){
			if(linkTimer){
				clearInterval(linkTimer);
				linkTimer = 0;
			}
			this.element.empty();
			this.addElement(linkImg);
			var mainText = $("<div class='mainText'></div>").Label({"text":"未找到设备","fontSize":"20px","fontWeight":"800","letterSpacing":"2px"});
			mainText.Label("setLeft","125px");
			mainText.Label("setTop","61px");
			mainText.css("position","absolute");
			this.addElement(mainText);
			
			var secText = $("<div class='secText'></div>").Label({"text":"请打开智能笔，确保绿灯闪烁","fontSize":"14px","color":"#666666"});
			secText.Label("setLeft","125px");
			secText.Label("setTop","94px");
			secText.css("position","absolute");
			this.addElement(secText);
			
			var relLinkBtn = $("<div class='relinkBtn'></div>").BaseBtn({"text":"重新搜索","width":"74px","height":"32px","fontSize":"13px","bgColor":"#E50414","textColor":"#ffffff"});
			relLinkBtn.css("border-radius","3rem");
			relLinkBtn.css("border","1px solid #E50414");
			relLinkBtn.css("position","absolute");
			relLinkBtn.BaseBtn("setLeft","121px");
			relLinkBtn.BaseBtn("setTop","120px");
			relLinkBtn.bind("BTN_CLICK",this,this.relLink);
			this.element.append(relLinkBtn);
			
			var cancelLinkBtn = $("<div class='cancellinkBtn'></div>").BaseBtn({"text":"暂不连接","width":"74px","height":"32px","fontSize":"13px","textColor":"#999999"});
			cancelLinkBtn.css("border-radius","3rem");
			cancelLinkBtn.css("border","1px solid #999999");
			cancelLinkBtn.css("position","absolute");
			cancelLinkBtn.BaseBtn("setLeft","210px");
			cancelLinkBtn.BaseBtn("setTop","120px");
			cancelLinkBtn.bind("BTN_CLICK",this,this.cancelLink);
			this.element.append(cancelLinkBtn);
			mainText.css("opacity",0);
			secText.css("opacity",0);
			relLinkBtn.css("opacity",0);
			cancelLinkBtn.css("opacity",0);
			var that = this;
			mainText.animate({"opacity":1},500,function(){
				secText.animate({"opacity":1},500);
				relLinkBtn.animate({"opacity":1},500);
				cancelLinkBtn.animate({"opacity":1},500);
			});
		},
		setSearchSuccessStatus:function(){
			if(linkTimer){
				clearInterval(linkTimer);
				linkTimer = 0;
			}
			var that = this;
			this.element.find(".searchMainText").Label("setText","已找到"+foundMacArr.length+"个设备");
			var u = navigator.userAgent;
			if(u.indexOf('Android') > -1 || u.indexOf('Linux') > -1){
				this.element.find(".searchSecText").Label("setText","请确认蓝牙笔笔身的MAC码段");
			}else{
				this.element.find(".searchSecText").Label("setText","请确认蓝牙笔笔身的SN码段");
			}
			this.element.find(".searchMainText").css("opacity",0);
			this.element.find(".searchSecText").css("opacity",0);
			this.element.find(".cancellinkBtn").css("opacity",0);
			this.element.find(".searchMainText").animate({"opacity":1},500,function(){
				that.element.find(".searchSecText").animate({"opacity":1},500);
				that.element.find(".relinkBtn").show();
				that.element.find(".relinkBtn").animate({"opacity":1},500);
			});
		},
		//设置为搜索结果状态
		setSearchResultStatus:function(findData){
			try{
				if(linkedHistory){
					var linkedHistoryArr = linkedHistory.split("|");
				}
				if(findData.length == 0){
					return;
				}
				this.element.attr("data-base-height",$(this.element).height());
				penData = [];
				for(var i=0;i<findData.length;i++){
					var one = {};
					if(typeof(linkedHistoryArr) != "undefined" && linkedHistoryArr[0] == findData[i].macAddress){
						one.nearLinkTime = linkedHistoryArr[1];
					}
					one.mac = findData[i].macAddress;
					one.name = "蓝牙笔";
					one.penType = findData[i].penType;
					penData.push(one);
				}
			}catch(e){
				//alert(e);
			}
			searchPenData = penData;
			
			this.setHeight("100%");
			if(!myScroll){
				for(var i=0;i<searchPenData.length;i++){
					if(foundMacArr.indexOf(searchPenData[i].mac) == -1){
						foundMacArr.push(searchPenData[i].mac);
					}
				}
				var scrollPanel = $("<div id='link-pen-wrapper'></div>");
				scrollPanel.css("overflow","hidden");
				var popCloseBtn = $("<div class='popCloseBtn'></div>").ImgBtn({"src":"../djcommon/img/note/pop-close.png","width":"32px","height":"32px"});
				popCloseBtn.bind("BTN_CLICK",this,this.cancelScanLink);
				popCloseBtn.ImgBtn("setMarginLeft","-16px");
				popCloseBtn.ImgBtn("setMarginTop","-16px");
				popCloseBtn.css("position","fixed");
				popCloseBtn.ImgBtn("setLeft","50%");
				popCloseBtn.ImgBtn("setBottom","51px");
				scrollPanel.css("margin-top","1px");
				var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
				line.css("border-top","0px solid #EAEFF2"); 
				this.element.append(line);
				line.css("margin-top",linkImg.height()+linkImg.offset().top*2-1+"px");
				var ul = $("<ul class='wrapper-ul'></ul>");
				scrollPanel.append(ul);
			
				this.element.append(scrollPanel);
				this.element.append(popCloseBtn);
				
				scrollPanel.css("height",$(window).height()-linkImg.height()-linkImg.offset().top*2-popCloseBtn.height()-51+"px");
				for(var i=0;i<penData.length;i++){
					penData[i].labelText = "连接";
					var li = $("<li></li>").PenCell(penData[i]);
					li.css("opacity",0);
					if(linking){
						li.PenCell("setBtnDisable");
					}
					li.animate({"opacity":1},500);
					li.bind("CELL_BTN_CLICK",this,this.onCellBtnClick);
					if(typeof(penData[i].nearLinkTime) != "undefined"){
					    ul.prepend(li);
					}else{
						ul.append(li);
					}
				}
				ul.css("min-height",parseInt(scrollPanel.css("height").replace("px",""))+1+"px");
				myScroll = new IScroll("#link-pen-wrapper",{
					bounceTime:300,//配置滑动回弹时间
				});
			}else{
				try{
					for(var i=0;i<penData.length;i++){
						penData[i].labelText = "连接";
						if(foundMacArr.indexOf(penData[i].mac) == -1){
							foundMacArr.push(searchPenData[i].mac);
							var li = $("<li></li>").PenCell(penData[i]);
							if(linking){
								li.PenCell("setBtnDisable");
							}
							li.css("opacity",0);
							li.animate({"opacity":1},500);
							li.bind("CELL_BTN_CLICK",this,this.onCellBtnClick);
							if(typeof(searchPenData[i].nearLinkTime) != "undefined"){
								this.element.find(".wrapper-ul").prepend(li);
							}else{
							    this.element.find(".wrapper-ul").append(li);
							}
						}
					}
				}catch(e){
					alert(e);
				}
			}
			myScroll.refresh();
		},
		//连接按钮被点击
		onCellBtnClick:function(e,data){
			linking = true;
			var that = $(this);
			$(this).PenCell("setBtnText","连接中");
			setTimeout(function(){
				try{
					that.siblings().each(function(){
						if($(this).hasClass("pen-cell")){
							$(this).PenCell("setBtnEnable");
						}
					});
					that.PenCell("setBtnText","连接");
					that.PenCell("setBtnEnable");
				}catch(e){}
				linking = false;
			},5000);
			$(this).PenCell("setBtnDisable");
			$(this).siblings().each(function(){
				if($(this).hasClass("pen-cell")){
					$(this).PenCell("setBtnDisable");
				}
			});
			e.data.element.trigger("START_LINK",data);
		},
		//重新获取授权
		rePower:function(e){
			e.data.element.trigger("RE_POWER");
		},
		//连接有线笔
		linkHasLinePen:function(e){
			e.data.element.trigger("LINK_HAS_LINE_PEN");
		},
		relLink:function(e){
			e.data.setHeight("202px");
			e.data.element.find(".popCloseBtn").remove();
			if(myScroll){
				myScroll.destroy();
				myScroll = null;
			}
			e.data.setSearchingStatus();
			e.data.element.trigger("LINK_PEN_HIDE");
		},
		cancelLink:function(e){
			if(linkTimer){
				clearInterval(linkTimer);
				linkTimer = 0;
			}
			e.data.hide();
		},
		cancelScanLink:function(e){
			if(linkTimer){
				clearInterval(linkTimer);
				linkTimer = 0;
			}
			if(typeof(e) != "undefined"){
				e.data.element.find(".popCloseBtn").remove();
				e.data.element.trigger("SCAN_YS_PEN_END");
				e.data.hide();
			}else{
				this.element.find(".popCloseBtn").remove();
				this.element.trigger("SCAN_YS_PEN_END");
				this.hide();
			}
		},
		cancelScanLinkAtOnce:function(){
			try{
				clearInterval(linkTimer);
				linkTimer = 0;
				$(".LinkPenPanel").css({"top":"-1000px"});
				$(".LinkPenPanel").hide();
			}catch(e){
			}
		},
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});