/*
*   2020年11月10日
*   
*   封装云空间手机端个人空间搜索panel组件
*
*   开发者：付长建 
*/
define(["Shell","YsPreviewManager","CommonSearch","CommonIscroll","CommonCell","CommonBottonMenu","CommonShareMenu","CommonDeleteMask","CommonMoveCopy","CommonNewFolderAadRename","MySpaceSee","CommonSetLabel"],function(Shell,YsPreviewManager){
    $.widget("ys.MySpaceSearchPanel",{
        //默认参数
        options:{
            commonToast:null,//飘窗组件
            uuid:0,//搜索那一层的文件
            sort:"createtime",//排序
            type:"all"//搜索的文件类型
        },
        _searchContainer:null,//搜索组件
        _maxContainer:null,//内容体最大容器
        _historyIscrollContainer:null,//历史搜索和滚动容器的父级容器
        _historyContainer:null,//历史搜索容器
        _historyTitleEmpty:null,//历史搜索标题和清空历史搜索图标元素
        _iscrollContainer:null,//列表滚动容器
        _bottonMenuContainer:null,//列表选中底部菜单组件
        _shareMenuContainer:null,//分享菜单组件
        _moveContainer:null,//移动组件
        _copyContainer:null,//复制组件
        _renameContainer:null,//重命名组件
        _deleteMask:null,//询问弹框组件
        _historyData:[],//历史搜索数据
        _key:"",//搜索关键字
        _time:null,//加载延时定时器
        _offset:0,//数据请求偏移量
        _selectSize:2,//控制新生成的节点勾选图标大小，参数2是小，1是大
        _selectData:[],//列表选中数据
        _conflict_uuid:0,//删除遇到创有链接的文件（冲突id）
        _isMoveCopyRefresh:false,//移动和复制文件是否新建文件夹，当点击了移动复制组件的取消按钮是否刷新参数
        _pageName:"myspaceSearch",//预览类型，主要是那个页面进行预览
        _previewData:{},//预览文件数据（这个主要是给原生用和删除当前正在预览的文件判断是否还有下一张上一张或者下一个上一个文件使用的）
        _currentData:{},//当前预览文件的数据（这个主要是用来控制器用和换取预览地址的和给原生提供当前预览的文件信息的）
        _isNextPrev:true,//防止用户一只触发上一张下一张事件
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            //初始化预览管理器
            YsPreviewManager.Init(
                that._pageName,
                global.preview_config.preview_config.type,
                global.preview_config.preview_config.type=="url"?global.preview_config.preview_config.storageStatus+"?uid=1&uuid=":"",
                global.preview_config.preview_config.type=="url"?global.preview_config.preview_config.task+"?user_id=1&":"",
                global.preview_config.preview_config.type=="url"?global.preview_config.download_check_task_url+"?id=":"",
                global.preview_config.preview_config.type=="url"?global.preview_config.preview_config.encode+"?origin=2&":global.preview_config.preview_config.encode+"?origin=1&",
                global.preview_config.preview_config.encodeStatus+"?task=",
                function(successObj){
                    that._previewData.url = successObj.url;//赋值获取到的预览地址
                    Shell.sendEvent("changePreviewFileAndImage",that._previewData);
                },function(errorObj){
                    that._previewData.error = errorObj.error;
                    Shell.sendEvent("changePreviewFileAndImage",that._previewData);
                }
            )
            //给初始化元素设定指定的css样式
            this.element.css({
                "position":"absolute",
                "top":this.element.height() + "px",
                "left":0,
                "transition":"all 0.3s",
                "overflow":"hidden"
            });
            //初始化搜索组件 
            this._searchContainer = $("<div style='width:100%;padding-left:0.15rem;border-bottom:1px solid #ECECEC;box-sizing:border-box;'></div>").appendTo(this.element);
            this._searchContainer.CommonSearch({"isCloseBtn":true,"isHead":true,"isGobackEvent":"touchend"});
            this._maxContainer = $("<div style='width:100%;height:"+(this.element.height() - this._searchContainer.outerHeight(true))+"px;transition:all 0.3s;overflow:hidden;background:#fff;'></div>").appendTo(this.element);
            //创建历史搜索和滚动容器的父级容器
            this._historyIscrollContainer = $("<div style='width:"+(this.element.width() * 2)+"px;height:100%;display:flex;flex-direction:row;transition:all 0.3s;'></div>").appendTo(this._maxContainer);
            //创建历史搜索容器
            this._historyContainer = $("<div style='width:"+this.element.width()+"px;height:100%;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;flex-shrink:0;'></div>").appendTo(this._historyIscrollContainer);
            //创建历史搜索标题和清空历史搜索图标原始
            this._historyTitleEmpty = $("<div style='width:100%;height:0.5rem;display:flex;flex-direction:row;justify-content:space-between;'></div>").appendTo(this._historyContainer);
            $("<span style='font-size:0.16rem;font-weight:bold;display:flex;align-items:center;'>搜索历史</span>").appendTo(this._historyTitleEmpty);
            $("<div style='display:none;align-items:center;'><img style='width:0.15rem;height:0.15rem;' src='"+skinConfig(global.skin).commonIcon+"icon_delete.png'/></div>").appendTo(this._historyTitleEmpty);
            //创建历史搜索过的关键字容器
            this._historyKeyContainer = $("<div style='width:100%;display:flex;flex-direction:row;flex-wrap:wrap;'></div>").appendTo(this._historyContainer);
            //创建列表滚动容器
            var paddingBottom = phonexh("bottom") == 0 ? 0 : 10;//是否给滚动容器设置padding值
            this._iscrollContainer = $("<div id='mySpaceSearchContainer' style='width:"+this.element.width()+"px;height:100%;position:relative;overflow:hidden;'></div>").appendTo(this._historyIscrollContainer);
            this._iscrollContainer.CommonIscroll({"isUploadBtn":false,"isPosition":false,"isPaddingBottom":paddingBottom});
            //初始化文件列表选中底部操作菜单组件
            this._bottonMenuContainer = $("<div isShow='no' style='width:100%;transition:all 0.3s;'></div>").appendTo(this.element);
            this._bottonMenuContainer.CommonBottonMenu({
                "btnMenu":[
                    {"text":"下载","type":"download","icon":skinConfig(global.skin).commonIcon + "download_icon.png"},
                    {"text":"移动","type":"move","icon":skinConfig(global.skin).commonIcon + "move_icon.png"},
                    {"text":"分享","type":"share","icon":skinConfig(global.skin).commonIcon + "share_icon.png"},
                    {"text":"复制","type":"copy","icon":skinConfig(global.skin).commonIcon + "copy_icon.png"},
                    {"text":"删除","type":"delete","icon":skinConfig(global.skin).commonIcon + "delete_icon.png"},
                    {"text":"重命名","type":"rename","icon":skinConfig(global.skin).commonIcon + "rename_icon.png"},
                    {"text":"置顶","type":"topping","icon":skinConfig(global.skin).commonIcon + "topping_icon.png"},
                    {"text":"取消置顶","type":"cancelTopping","icon":skinConfig(global.skin).commonIcon + "cancel_topping_icon.png"},
                    {"text":"设置标签","type":"setLabel","icon":skinConfig(global.skin).commonIcon + "set_label_icon.png"},
                    {"text":"查看信息","type":"see","icon":skinConfig(global.skin).commonIcon + "see_icon.png"}
                ]
            });

            //给清空历史搜索图标绑定点击事件
            this._historyTitleEmpty.children("div").bind("click",this,this._emptyHistory);//给清空历史搜索图标绑定点击事件
            //监听搜索组件点击了清空val值图标 
            this._searchContainer.bind("EMPTY_BTN_CLICK",function(){
                that._key = "";//设置搜索关键字
                that._historyIscrollContainer.css("margin-left","0px");//切换列表容器
                setTimeout(function(){
                    that._iscrollContainer.CommonIscroll("emptyNode");//清空所有节点
                },310);
            });
            //监听搜索组件val值实时发生改变
            this._searchContainer.bind("INPUT_CHANGE_VAL",function(event,key){
                //判断值为空显示历史搜索容器
                if(key == ""){
                    that._historyIscrollContainer.css("margin-left","0px");//切换列表容器
                    setTimeout(function(){
                        that._iscrollContainer.CommonIscroll("emptyNode");//清空所有节点
                    },310);
                }
            });
            //监听搜索组件搜索事件
            this._searchContainer.bind("SEARCH_BTN_CLICK",function(event,key){
                //判读搜索关键字是为空
                if(key != ""){
                    that._key = key;//重置搜索关键字
                    that._offset = 0;//重置请求数据偏移量
                    that._searchHistoryShare();//调用触发搜索组件的搜索和点击历史搜索标签相同逻辑
                }
            });
            //监听滚动组件下拉刷新
            this._iscrollContainer.bind("ISCROLL_REFRESH",function(){
                //判断底部操作菜单是否显示
                if(that._bottonMenuContainer.attr("isShow") == "yes"){
                    that._bottonMenuContainer.CommonBottonMenu("lock","yes");//调用锁定底部操作菜单所有操作按钮
                }
                that._searchContainer.CommonSearch("lockBtn","yes");//锁定搜索输入框操作按钮
                that._searchContainer.CommonSearch("searchInput","yes");//锁定搜索输入框
                that._iscrollContainer.find("li").CommonCell("lockList","yes");//锁定列表图标和文件信息禁止点击
                that._selectSize = 2;//重置列表勾选图标大小 
                that._offset = 0;//重置请求数据偏移量
                that._getSearchData(2);//调用获取搜索列表数据方法
            });
            //监听滚动容器上拉加载更多
            this._iscrollContainer.bind("ISCROLL_LOAD_MORE",function(){
                //判断当前列表选中底部菜单是否显示
                if(that._bottonMenuContainer.attr("isShow") == "yes"){
                    that._selectSize = 1;//重置控制新生成的节点勾选图标大小，参数2是小，1是大
                    that._bottonMenuContainer.CommonBottonMenu("lock","yes");//调用锁定底部操作菜单所有操作按钮
                }
                that._searchContainer.CommonSearch("lockBtn","yes");//锁定搜索输入框操作按钮
                that._searchContainer.CommonSearch("searchInput","yes");//锁定搜索输入框
                that._iscrollContainer.find("li").CommonCell("lockList","yes");//锁定列表图标和文件信息禁止点击
                that._offset = that._offset + 100;//重置请求数据偏移量
                that._getSearchData(3);//调用获取搜索列表数据方法
            });
            //监听列表选中事件
            this._iscrollContainer.bind("CELL_SELECT",function(event,obj){
                //判断当前是取消还是选中
                if(obj.type == "yes"){
                    that._selectData.push(obj.data);
                }else{
                    //循环取消选中数据
                    for(var i = 0; i < that._selectData.length; i++){
                        if(that._selectData[i].uuid == obj.data.uuid){
                            that._selectData.splice(i,1);
                            break;
                        }
                    }
                } 
                that._listSelect();//调用列表选中操作方法
            });
            //监听列表点击事件
            this._iscrollContainer.bind("CELL_CLICK",function(event,arg){
                //判断当前点击的是文件还是文件夹并且当前点击文件是可以预览的
                if(parseInt(arg.isdir) != 1 && parseInt(arg.previewEnable) == 1){
                    that._getPrevData(arg.uuid);//调用获取组装预览需要的参数方法
                    Shell.sendEvent("showPreviewPage",that._previewData);//调用原生方法打开预览窗口
                }else{
                    that.options.commonToast.CommonToast("showToast","当前文件不能预览");//显示飘窗提示
                    //飘窗提示后2s后删除飘窗
                    setTimeout(function(){
                        that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                    },1500);
                }
            });
            //监听搜索组件点击了取消按钮事件 
            this._searchContainer.bind("CANCE_BTN_CLICK",function(){
                that._selectData = [];//重置选中数据
                that._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
                that._showAndHideBottomMenu("hide");//隐藏底部菜单
                that._searchContainer.CommonSearch("showCloseBtn");//显示关闭按钮
                that._iscrollContainer.find("li").CommonCell("changeSelectSize",2);//调用列表组件改变勾选图标大小方法
                that._iscrollContainer.find("li").CommonCell("lock","no");//解锁列表图标和文件信息禁止点击
                that._iscrollContainer.find("li").CommonCell("cancelSelect");//取消选中列表
            });
            //监听搜索组件点击了关闭按钮
            this._searchContainer.bind("CLOSE_BTN_CLICK",function(){
                that.element.trigger("SEARCH_PANEL_CANCEL");
                that.element.css("top",that.element.height() + "px");
                setTimeout(function(){
                    that.element.css("opacity","0");
                },100);
                setTimeout(function(){
                    that.destroy();
                },310);
            });
            //监听列表选中底部操作操作按钮被点击
            this._bottonMenuContainer.bind("OPERATION_BTN_CLICK",function(event,type){
                if(type == "share"){
                    that._showAndHideBottomMenu("hide");//隐藏底部操作菜单
                    that._searchContainer.CommonSearch("lockBtn","yes");//锁定搜索输入框操作按钮
                    //初始化分享菜单组件
                    that._shareMenuContainer = $("<div style='z-index:1;' id='shareMenu'></div>").appendTo($("body"));
                    that._shareMenuContainer.CommonShareMenu({"menuData":global.share_way_config});
                    //监听分享菜单显示 
                    that._shareMenuContainer.bind("SHAER_MENU_SHOW",function(){
                        that._iscrollContainer.CommonIscroll("lock","yes");//锁定所有文件列表
                    });
                    //监听分享菜单取消分享
                    that._shareMenuContainer.bind("SHARE_CANCEL_BTN_CLICK",function(){
                        that._iscrollContainer.CommonIscroll("lock","no");//解锁所有文件列表
                        that._showAndHideBottomMenu("show");//显示底部操作菜单
                        that._searchContainer.CommonSearch("lockBtn","no");//解锁搜索输入框操作按钮
                    });
                    //监听分享菜单操作按钮被点击
                    that._shareMenuContainer.bind("SHARE_BTN_CLICK",function(event,type){
                        var name = "";//分享的文件名称
                        var uuidArray = [];//分享的文件id
                        for(var i = 0; i < that._selectData.length; i++){
                            uuidArray.push(that._selectData[i].uuid);
                        }
                        if(that._selectData.length > 1){
                            name = that._selectData[0].name + "等...";
                        }else{
                            name = that._selectData[0].name;
                        }
                        //判断点击是哪个操作按钮
                        if(type == "wxsession"){
                            that._searchCreateThirdShare(name,uuidArray,"wechat");//调用微信分享，微信朋友圈，qq分享方法
                        }else if(type == "mobileQQ"){
                            that._searchCreateThirdShare(name,uuidArray,"qq");//调用微信分享，微信朋友圈，qq分享方法
                        }else if(type == "wxgroup"){
                            that._searchCreateThirdShare(name,uuidArray,"friends");//调用微信分享，微信朋友圈，qq分享方法
                        }else{
                            openPrimordial(that.element,"yes");//调用模仿原生开启窗口动画
                            openPrimordial(that._shareMenuContainer,"yes");//调用模仿原生开启窗口动画
                            //初始化连接分享组件
                            var linkSearchContainer = $("<div style='z-index:1;width:100%;height:100%;background:#f8f8f8;'></div>").appendTo($("body"));
                            linkSearchContainer.CommonLinkSearch({
                                "url":ServerConfig.domain+"/"+skinConfig(global.skin).linkshare+"/createTask",//创建链接接口
                                "name":name,//要分享的文名称
                                "uuid":uuidArray.join(","),//要分享的文件id
                                "commonToast":that.options.commonToast//飘窗提示组件
                            });
                            //监听链接分享组件点击返回按钮或者创建链接复制成功
                            linkSearchContainer.bind("LINK_GOBACK_CLOSE",function(){
                                openPrimordial(that.element,"no");//调用模仿原生开启窗口动画
                                openPrimordial(that._shareMenuContainer,"no",1);//调用模仿原生开启窗口动画
                            });
                        }
                    });
                }else if(type == "download"){
                    that._bottonMenuContainer.CommonBottonMenu("lock","yes");//锁定底部操作菜单所有操作按钮
                    that._searchContainer.CommonSearch("lockBtn","yes");//锁定搜索输入框操作按钮
                    that._searchContainer.CommonSearch("searchInput","yes");//锁定搜索输入框
                    that._iscrollContainer.CommonIscroll("lock","yes");//锁定所有文件列表
                    that._getDownloadFile();//调用获取下载文件方法
                }else if(type == "delete"){
                    that._searchContainer.CommonSearch("lockBtn","yes");//锁定搜索输入框操作按钮
                    that._bottonMenuContainer.CommonBottonMenu("lock","yes");//锁定底部操作菜单所有操作按钮
                    that._iscrollContainer.CommonIscroll("lock","yes");//锁定所有文件列表
                    //初始化删除提示组件
                    that._deleteMask = $("<div id='inquiry' style='z-index:2;'></div>").appendTo($("body"));
                    that._deleteMask.CommonDeleteMask({"text":"确定要删除这"+that._selectData.length+"个文件吗？删除后15天内可以在回收站找回"});
                    //监听取消事件  
                    that._deleteMask.bind("DELETE_MASK_CANCEL",function(){
                        that._searchContainer.CommonSearch("lockBtn","no");//解锁搜索输入框操作按钮
                        that._bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单所有操作按钮
                        that._iscrollContainer.CommonIscroll("lock","no");//解锁所有文件列表
                        that._conflict_uuid = 0;//重置删除冲突id
                    });
                    //监听确定事件
                    that._deleteMask.bind("DELETE_MASK_DETERMINE",function(){
                        that._deleteMask.CommonDeleteMask("hideMask");//调用询问组件的隐藏组件方法
                        setTimeout(function(){
                            that._searchDeleteFile();//调用搜索删除方法
                        },300);
                    });
                }else if(type == "move"){
                    openPrimordial(that.element,"yes");//调用模仿原生开启窗口动画
                    //初始化移动组件
                    that._moveContainer = $("<div style='z-index:3;width:100%;height:100%;'></div>").appendTo($("body"));
                    that._moveContainer.CommonMoveCopy({
                        "headTitle":"移动",//头部文字
                        "effectText":"正在移动...",//动效提示文字
                        "successText":"移动成功",//成功提示
                        "failText":"移动失败",//失败提示
                        "listUrl":ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/getDirList",//列表接口
                        "searchUrl":ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/getDirList"//搜索数据接口
                    }); 
                    //监听移动组件点击了头部的取消事件 
                    that._moveContainer.bind("MOVE_COPY_CANCE_BTN_CLICK",function(){
                        openPrimordial(that.element,"no");//调用模仿原生开启窗口动画
                        //判断是否需要刷新列表
                        if(that._isMoveCopyRefresh){
                            that._moveCopyCompleteCancel();//调用搜索移动文件和复制文件点击取消和移动完成复制完成相同逻辑方法
                        }
                    });
                    //监听新建文件夹确定事件 
                    that._moveContainer.bind("NEW_FOLDER",function(event,obj){
                        that._searchNewFolder(obj,0,that._moveContainer);//调用搜索移动和复制文件新建文件夹方法
                    });
                    //监听移动组件点击确定事件 
                    that._moveContainer.bind("DETERMINE_BTN_CLICK",function(event,pid){
                        var isMove = true;//是否可以移动
                        for(var i = 0; i < that._selectData.length; i++){
                            if(that._selectData[i].pid == pid){
                                isMove = false;//禁止移动
                            }else{
                                isMove = true;//允许移动
                                break;
                            }
                        }
                        //判断是否可以移动
                        if(isMove){
                            that._moveContainer.CommonMoveCopy("showAnimation");//调用动画开始方法
                            that._searchMoveFileFolder(pid,0);//调用搜索移动文件或者文件夹方法
                        }else{
                            that.options.commonToast.CommonToast("showToast","同一级目录不能移动！");//显示飘窗提示
                            //飘窗提示后2s后删除飘窗 
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                                setTimeout(function(){
                                    that._moveContainer.CommonMoveCopy("changeAttribute");//调用移动改变属性方法使其可以操作
                                },310);
                            },1500);
                        }
                    }); 
                    //监听移动组件成功方法抛出的事件 
                    that._moveContainer.bind("SUCCESS_COMPLETE",function(event,obj){
                        that._moveCopyCompleteCancel();//调用搜索移动文件和复制文件点击取消和移动完成复制完成相同逻辑方法
                    });
                }else if(type == "copy"){
                    openPrimordial(that.element,"yes");//调用模仿原生开启窗口动画
                    //初始化复制组件
                    that._copyContainer = $("<div style='z-index:3;width:100%;height:100%;'></div>").appendTo($("body"));
                    that._copyContainer.CommonMoveCopy({
                        "headTitle":"复制",//头部文字
                        "effectText":"正在复制...",//动效提示文字
                        "successText":"复制成功",//成功提示
                        "failText":"复制失败",//失败提示
                        "listUrl":ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/getDirList",//列表接口
                        "searchUrl":ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/getDirList"//搜索数据接口
                    }); 
                    //监听复制组件点击了头部的取消事件 
                    that._copyContainer.bind("MOVE_COPY_CANCE_BTN_CLICK",function(){
                        openPrimordial(that.element,"no");//调用模仿原生开启窗口动画
                        //判断是否需要刷新列表
                        if(that._isMoveCopyRefresh){
                            that._moveCopyCompleteCancel();//调用搜索移动文件和复制文件点击取消和移动完成复制完成相同逻辑方法
                        }
                    });
                    //监听新建文件夹确定事件 
                    that._copyContainer.bind("NEW_FOLDER",function(event,obj){
                        that._searchNewFolder(obj,0,that._copyContainer);//调用搜索移动和复制文件新建文件夹方法
                    });
                    //监听复制组件点击确定事件 
                    that._copyContainer.bind("DETERMINE_BTN_CLICK",function(event,pid){
                        that._copyContainer.CommonMoveCopy("showAnimation");//调用动画开始方法
                        that._searchCopyFileFolder(pid,"copy",-1);//调用复制文件或者文件夹方法
                    }); 
                    //监听移动组件成功方法抛出的事件 
                    that._copyContainer.bind("SUCCESS_COMPLETE",function(event,obj){
                        that._moveCopyCompleteCancel();//调用搜索移动文件和复制文件点击取消和移动完成复制完成相同逻辑方法
                    });
                }else if(type == "topping"){
                    that._bottonMenuContainer.CommonBottonMenu("lock","yes");//调用锁定底部操作菜单所有操作按钮
                    that._iscrollContainer.CommonIscroll("lock","yes");//锁定所有文件列表
                    that._searchContainer.CommonSearch("lockBtn","yes");//锁定搜索输入框操作按钮
                    that._searchSetTopping(1);//调用置顶和取消置顶方法
                }else if(type == "cancelTopping"){
                    that._bottonMenuContainer.CommonBottonMenu("lock","yes");//调用锁定底部操作菜单所有操作按钮
                    that._iscrollContainer.CommonIscroll("lock","yes");//锁定所有文件列表
                    that._searchContainer.CommonSearch("lockBtn","yes");//锁定搜索输入框操作按钮
                    that._searchSetTopping(2);//调用置顶和取消置顶方法
                }else if(type == "rename"){
                    openPrimordial(that.element,"yes");//调用模仿原生开启窗口动画
                    var title = that._selectData[0].isdir == "1" ? "文件夹" : "文件";//得到当前是重命名文件还是文件夹
                    //初始化重命名组件
                    that._renameContainer = $("<div style='z-index:1;width:100%;height:100%;'></div>").appendTo($("body"));
                    that._renameContainer.CommonNewFolderAadRename({
                        "title":"重命名" + title,
                        "defaultVal":that._selectData[0].name
                    });
                    //监听重名组件点击返回 
                    that._renameContainer.bind("NEW_GOBACK_BTN_CLICK",function(){
                        openPrimordial(that.element,"no");//调用模仿原生开启窗口动画
                    });
                    //监听重命名组件抛出的确定事件 
                    that._renameContainer.bind("NEW_DETERMINE_BTN_CLICK",function(event,val){
                        //判断重命名后的文件或者文件夹名称是否和之前一样
                        if(val != that._selectData[0].name){
                            that._searchRenameFileFolder(title,val,0);//调用重命名文件和文件夹方法
                        }else{
                            that.options.commonToast.CommonToast("showToast",title + "名称未发生改变");//显示飘窗提示
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                                that._renameContainer.CommonNewFolderAadRename("lock","no");//调用重命名组件解除方法
                            },1500);
                        }
                    });
                }else if(type == "see"){
                    openPrimordial(that.element,"yes");//调用模仿原生开启窗口动画
                    //初始化查看文件信息组件 
                    var title = that._selectData[0].isdir == "1" ? "文件夹" : "文件";//得到当前是查看文件夹信息还是查看文件信息
                    var seeContainer = $("<div style='z-index:1;width:100%;height:100%;'></div>").appendTo($("body"));
                    seeContainer.MySpaceSee({
                        "uuid":that._selectData[0].uuid,//当前查看的文件id
                        "title":"查看"+title+"信息",//头部文字信息
                        "icon":that._iscrollContainer.find("[uuid="+that._selectData[0].uuid+"]").find(".fileIcon").attr("src"),//文件图标
                        "CommonToast":that.options.commonToast//飘窗提示组件
                    });
                    //监听查看文件组件点击返回
                    seeContainer.bind("SEE_GOBACK_CLOSE",function(){
                        openPrimordial(that.element,"no");//调用模仿原生开启窗口动画
                    });
                }else if(type == "setLabel"){
                    openPrimordial(that.element,"yes");//调用模仿原生开启窗口动画
                    //初始化设置标签组件
                    var setLabelContainer = $("<div style='z-index:1;width:100%;height:100%;'></div>").appendTo($("body"));
                    setLabelContainer.CommonSetLabel({
                        "uuid":that._selectData[0].uuid,//当前查看的文件id
                        "CommonToast":that.options.commonToast,//飘窗提示组件
                        "getLabelUrl":ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/getFileInfo",//获取标签回显接口
                        "setLabelUrl":ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/saveMySpaceFileLabel"//设置新标签接口
                    });
                    //监听设置标签组件关闭
                    setLabelContainer.bind("SET_LABEL_CLOSE",function(){
                        openPrimordial(that.element,"no");//调用模仿原生开启窗口动画
                    });
                }
            });
            //清空历史搜索图标按下效果
            this._btnTextCommon(this._historyTitleEmpty.children("div"));
            //监听原生事件
            try{
                //监听原生预览点击上一个下一个文件或者上一张下一张图片事件
                api.addEventListener({name:"nextPrev"},function(arg){
                    //判断是否是当前页面的事件
                    if(arg.value.pageName == that._pageName){
                        //判断禁止用户一直触发
                        if(that._isNextPrev){
                            that._isNextPrev = false;//禁止用户点击再次触发
                            YsPreviewManager.abortAjax();//清除换取预览接口请求
                            that._getPrevData(arg.value.uuid);//调用获取组装预览需要的参数方法
                            //判断是否有缓存
                            if(arg.value.cacheUrl != ""){
                                that._previewData.url = arg.value.cacheUrl;//复制原生返回的预览地址
                                Shell.sendEvent("changePreviewFileAndImage",that._previewData);
                            }else{
                                Shell.sendEvent("changePreviewFileAndImage",that._previewData);
                                YsPreviewManager.SwapUrlWithUUID(that._currentData.fileinfoId,that._currentData.ext);//调用预览管理器换取预览地址
                            }
                        }
                    }
                });
                //监听原生预览点击了文件操作按钮
                api.addEventListener({name:"operationBtnClick"},function(arg){
                    //判断是否是当前页面的事件
                    if(arg.value.pageName == that._pageName){
                        //判断点击的是那个按钮
                        if(arg.value.type == "download"){
                            that._prevDownloadFile(arg.value.uuid);//调用预览下载方法
                        }else if(arg.value.type == "delete"){
                            that._prevDeleteFile(arg.value.uuid);//调用预览删除方法
                        }else if(arg.value.type == "share"){
                            openPrimordial(that.element,"yes");//调用模仿原生开启窗口动画
                            //初始化预览分享连接分享组件
                            var prevSearchLink = $("<div style='z-index:1;width:100%;height:100%;background:#f8f8f8;'></div>").appendTo($("body"));
                            prevSearchLink.CommonLinkSearch({
                                "url":ServerConfig.domain+"/"+skinConfig(global.skin).linkshare+"/createTask",//创建链接接口
                                "name":arg.value.name,//要分享的文名称
                                "uuid":arg.value.uuid,//要分享的文件id
                                "commonToast":that.options.commonToast//飘窗提示组件
                            });
                            //监听预览分享链接分享组件点击返回按钮或者创建链接复制成功
                            prevSearchLink.bind("LINK_GOBACK_CLOSE",function(){
                                openPrimordial(that.element,"no");//调用模仿原生开启窗口动画
                            });
                        }else if(arg.value.type == "edit"){
                            that._prevCoordinationUrl(arg.value.uuid,arg.value.name);//调用获取协同地址方法
                        }
                    }
                });
                //监听原生预览窗口和协同窗口关闭
                api.addEventListener({name:"closePreview"},function(arg){
                    //判断是否可以刷新
                    if(arg.value.pageName == that._pageName){
                        that._offset = 0;//重置数据请求偏移量
                        that._getSearchData(1);//调用获取文件方法
                    }
                });
            }catch(e){}
        },
        //组件初始化完成主动执行
        _init:function(){
            this._historyData = [];//历史搜索数据
            this._key = "";//搜索关键字
            this._time = null;//加载延时定时器
            this._offset = 0;//数据请求偏移量
            this._selectSize = 2;//控制新生成的节点勾选图标大小，参数2是小，1是大
            this._selectData = [];//列表选中数据
            this._conflict_uuid = 0;//删除遇到创有链接的文件（冲突id）
            this._isMoveCopyRefresh = false;//移动和复制文件是否新建文件夹，当点击了移动复制组件的取消按钮是否刷新参数
            this._pageName = "myspaceSearch",//预览类型，主要是那个页面进行预览
            this._previewData = {};//预览文件数据（这个主要是给原生用和删除当前正在预览的文件判断是否还有下一张上一张或者下一个上一个文件使用的）
            this._currentData = {};//当前预览文件的数据（这个主要是用来控制器用和换取预览地址的和给原生提供当前预览的文件信息的）
            this._isNextPrev = true;//防止用户一只触发上一张下一张事件
            setTimeout(function(that){
                that.element.css("top","0px");
                //判读是否有历史搜索记录
                if(window.localStorage.getItem("mySpace") != null && window.localStorage.getItem("mySpace") != undefined && window.localStorage.getItem("mySpace") != ""){
                    that._historyData = window.localStorage.getItem("mySpace").split(",");//得到历史搜索数据
                    that._generateHistoryData();//调用生成历史搜索记录方法
                }else{
                    setTimeout(function(){
                        that._searchContainer.CommonSearch("getFocus");//获取焦点
                    },300);
                }
            },50,this);
            //这句主要是兼容安卓遇到底部导航栏不占位置问题
            setTimeout(function(that){
                that._maxContainer.css("height",that.element.height() - that._searchContainer.outerHeight(true) + "px");
            },150,this);
        },
        //所有的按钮和可以点击的文本按下和抬起事件方法
        _btnTextCommon:function(element){
            //给选项绑定手指按下事件
            element.bind('touchstart',function(){
                $(this).css("opacity","0.5");
            });
            //给选项绑定手指抬起事件
            element.bind('touchend',function(){
                $(this).css("opacity","");
            });
        },
        //设置历史搜索缓存方法
        _setHistoryData:function(){
            window.localStorage.setItem("mySpace",this._historyData.join(","));
        },
        //生成历史搜索记录方法
        _generateHistoryData:function(){
            this._historyTitleEmpty.children("div").css("display","flex");
            this._historyKeyContainer.children("div").remove();
            for(var i = 0; i < this._historyData.length; i++){
                var label = $("<div style='height:0.29rem;border-radius:0.15rem;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;background:#F5F5F5;font-size:0.14rem;color:#666;margin-right:0.1rem;line-height:0.29rem;flex-shrink:0;margin-bottom:0.15rem;'>"+this._historyData[i]+"</div>").appendTo(this._historyKeyContainer);
                label.bind("click",this,this._historyLabelClick);
            }
        },
        //点击历史搜索标签
        _historyLabelClick:function(event){
            event.data._key = $(this).html();//设置搜索关键字
            event.data._searchContainer.CommonSearch("setSearchVal",$(this).html());//设置输入框的值
            event.data._searchHistoryShare();//调用触发搜索组件的搜索和点击历史搜索标签相同逻辑
        },
        //触发搜索组件的搜索和点击历史搜索标签相同逻辑
        _searchHistoryShare:function(){
            this._historyIscrollContainer.css("margin-left","-" + this.element.width() + "px");//切换列表容器
            //判读当前关键字在历史搜索标签数组里面是否存在
            if(this._historyData.indexOf(this._key) > -1){
                //改变历史搜索顺序
                for(var i = 0; i < this._historyData.length; i++){
                    if(this._historyData[i] == this._key){
                        this._historyData.splice(i,1);
                        break;
                    }
                }
            }
            this._historyData.unshift(this._key);//将当前点击这个历史搜索标签添加到历史搜索标签数组第一个
            this._setHistoryData();//调用设置历史搜索缓存方法
            setTimeout(function(that){
                that._generateHistoryData();//调用生成历史搜索标签方法重新生成历史搜索标签
            },300,this);
            this._searchContainer.CommonSearch("searchInput","yes");//锁住搜索输入框
            this._offset = 0;//重置数据请求偏移量
            this._getSearchData(1);//调用获取搜索列表数据方法
        },
        //点击清空历史搜索记录图标方法
        _emptyHistory:function(event){
            event.data._historyKeyContainer.children("div").remove();//清空所有历史搜索标签
            event.data._historyData = [];//清空历史搜索数组
            window.localStorage.removeItem("mySpace");//清空缓存的历史搜索
            event.data._historyTitleEmpty.children("div").css("display","none");//隐藏清空历史搜索图标
        },
        //获取搜索列表数据方法
        _getSearchData:function(type){
            var that = this;
            //判读当前是搜索还是下拉刷新还是上拉加载更多
            if(type == 1){
                this._time = setTimeout(function(){
                    that._iscrollContainer.CommonIscroll("showLoadMask");//显示加载层
                },2000);
            }
            //请求参数
            var paramet = {"token":getUrl("token"),"uuid":that.options.uuid,"offset":that._offset,"sort":that.options.sort,"type":that.options.type,"keyword":that._key,"order":"desc"};
            http(ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/searchFile",paramet,{
                success:function(arg){
                    clearTimeout(that._time);//清除延时
                    if(type != 1){
                        setTimeout(function(){
                            that._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
                            that._searchContainer.CommonSearch("lockBtn","no");//解锁搜索输入框操作按钮
                            that._iscrollContainer.find("li").CommonCell("lockList","no");//解锁列表图标和文件信息禁止点击
                        },2300);
                    }else{
                        setTimeout(function(){
                            that._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
                        },300);
                    }
                    if(parseInt(arg.code) == 1){
                        //这里做延迟主要是防止生成节点卡断(只有搜索的时候才做延迟)
                        if(type == 1){
                            setTimeout(function(){
                                that._generateList(type,arg.data.rows);//调用生成列表方法
                            },100);
                        }else{
                            that._generateList(type,arg.data.rows);//调用生成列表方法
                        }
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            //判读当前是搜索还是下拉刷新还是上拉加载更多
                            if(type == 1){//搜索错误
                                setTimeout(function(){
                                    that._iscrollContainer.CommonIscroll("showErrorMask",arg.msg);//显示错误提示层
                                },500);
                            }else if(type == 2){//下拉刷新错误
                                setTimeout(function(){
                                    that._iscrollContainer.CommonIscroll("refreshSuccessAndFail",arg.msg);//调用下拉刷新错误
                                },500);
                            }else if(type == 3){//上拉加载更多
                                setTimeout(function(){
                                    that._iscrollContainer.CommonIscroll("loadMoreSuccessAndFail",arg.msg);//调用加载错误
                                },500);
                            } 
                        }
                    }
                }
            });
        },
        //生成列表方法
        _generateList:function(type,dataArray){
            var that = this;
            var cellArray = [];
            for(var i = 0; i < dataArray.length; i++){
                var cell = $("<li uuid='"+dataArray[i].uuid+"' previewEnable='"+dataArray[i].previewEnable+"' fileInfoId='"+dataArray[i].fileinfo_id+"' type='"+matchingFileType(dataArray[i].ext)+"' ext='"+dataArray[i].ext+"' style='width:100%;padding-left:0.15rem;box-sizing:border-box;'></li>").CommonCell({
                    "commonIconUrl":skinConfig(global.skin).commonIcon,
                    "shllIconUrl":skinConfig(global.skin).shllWebIon,
                    "data":dataArray[i],
                    "selectSize":this._selectSize
                });
                cellArray.push(cell);
            }
            //判读当前是搜索还是下拉刷新还是上拉加载更多
            if(type == 1){//搜索
                that._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
                //判断是否有数据
                if(cellArray.length != 0){
                    that._iscrollContainer.CommonIscroll("searchNode",cellArray);//添加搜索数据
                }else{
                    that._iscrollContainer.CommonIscroll("showSearchNoDataMask");//显示搜索没有数据提示层
                }
            }else if(type == 2){//下拉刷新
                setTimeout(function(){
                    that._iscrollContainer.CommonIscroll("refreshSuccessAndFail");//刷新成功方法
                },500);
                //监听下拉刷新完成事件 
                that._iscrollContainer.unbind("REFRESH_COMPLETE").bind("REFRESH_COMPLETE",function(){ 
                    //判读底部操作菜单是否显示
                    if(that._bottonMenuContainer.attr("isShow") == "yes"){
                        that._selectData = [];//清空列表选中数据
                        that._showAndHideBottomMenu("hide");//隐藏底部操作菜单
                        that._searchContainer.CommonSearch("showCloseBtn");//显示关闭按钮
                        that._bottonMenuContainer.CommonBottonMenu("lock","no");//调用解锁底部操作菜单所有操作按钮
                    }
                    //判断有无数据
                    if(cellArray.length != 0){
                        that._iscrollContainer.CommonIscroll("refreshNode",cellArray);//更新刷新节点
                    }else{
                        that._iscrollContainer.CommonIscroll("emptyNode");//情况节点
                        that._iscrollContainer.CommonIscroll("showSearchNoDataMask");//显示没有数据提示层
                    }
                });
            }else if(type == 3){//上拉加载更多
                setTimeout(function(){
                    that._iscrollContainer.CommonIscroll("loadMoreSuccessAndFail");//加载成功方法
                },500);
                //监听上拉加载更多完成事件 
                that._iscrollContainer.unbind("LOAD_COMPLETE").bind("LOAD_COMPLETE",function(){
                    that._iscrollContainer.CommonIscroll("addNode",cellArray);//添加上拉加载出来的新节点 
                    //判读底部操作菜单是否显示
                    if(that._bottonMenuContainer.attr("isShow") == "yes"){
                        //判断是否有数据
                        if(cellArray.length != 0){
                            that._iscrollContainer.find("li").CommonCell("lock","yes");//锁定列表图标和文件信息禁止点击
                        }
                        that._bottonMenuContainer.CommonBottonMenu("lock","no");//调用解锁底部操作菜单所有操作按钮
                    }
                });
            }
        },
        //显示隐藏文件列表选中底部操作菜单方法
        _showAndHideBottomMenu:function(type){
            var height = this._bottonMenuContainer.outerHeight(true);//得到需要减去的高度
            if(type == "show"){
                this._maxContainer.css("height",this._maxContainer.height() - height + "px");
                this._iscrollContainer.CommonIscroll("changeIscrollContainerMinHeight",this._maxContainer.height() - height);//调用改变滚动容器高度方法
                this._bottonMenuContainer.attr("isShow","yes");//改变底部操作菜单属性表示菜单已经显示
            }else{
                this._maxContainer.css("height",this._maxContainer.height() + height + "px");
                this._iscrollContainer.CommonIscroll("changeIscrollContainerMinHeight",this._maxContainer.height() + height);//调用改变滚动容器高度方法
                this._bottonMenuContainer.attr("isShow","no");//改变底部操作菜单属性表示菜单已经隐藏
            }
        },
        //列表选中操作方法
        _listSelect:function(){
            //判读选中数据的长度
            if(this._selectData.length != 0){
                this._searchContainer.CommonSearch("searchInput","yes");//锁住搜索输入框
                if(this._selectData.length == 1){
                    //判读底部菜单是否显示
                    if(this._bottonMenuContainer.attr("isShow") == "no"){
                        this._showAndHideBottomMenu("show");//显示底部菜单
                        this._searchContainer.CommonSearch("showCancelBtn");//显示取消按钮
                        this._iscrollContainer.find("li").CommonCell("changeSelectSize",1);//调用列表组件改变勾选图标大小方法
                        this._iscrollContainer.find("li").CommonCell("lock","yes");//锁定列表图标和文件信息禁止点击
                    }
                    //判断当前选中数据是否是置顶的
                    if(parseInt(this._selectData[0].is_up) == 0){//没有置顶
                        this._bottonMenuContainer.CommonBottonMenu("lockOptBtn",["取消置顶"]);//调用列表选中底部操作菜单组件锁定按钮和解锁操作按钮方法
                    }else{
                        this._bottonMenuContainer.CommonBottonMenu("lockOptBtn",["置顶"]);//调用列表选中底部操作菜单组件锁定按钮和解锁操作按钮方法
                    }
                }else{
                    this._bottonMenuContainer.CommonBottonMenu("lockOptBtn",["取消置顶","重命名","查看信息","置顶","设置标签"]);//调用列表选中底部操作菜单组件锁定按钮和解锁操作按钮方法
                }
            }else{
                this._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
                this._showAndHideBottomMenu("hide");//隐藏底部菜单
                this._searchContainer.CommonSearch("showCloseBtn");//显示关闭按钮
                this._iscrollContainer.find("li").CommonCell("changeSelectSize",2);//调用列表组件改变勾选图标大小方法
                this._iscrollContainer.find("li").CommonCell("lock","no");//解锁列表图标和文件信息禁止点击
            }
        },
        //搜索移动文件和复制文件点击取消和移动完成复制完成相同逻辑
        _moveCopyCompleteCancel:function(){
            openPrimordial(this.element,"no");//调用模仿原生开启窗口动画
            this._isMoveCopyRefresh = false;//关闭移动和复制组件不需要刷新
            this._selectData = [];//重置选中数据
            this._offset = 0;//重置请求数据偏移量
            this._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
            this._searchContainer.CommonSearch("showCloseBtn");//显示关闭按钮
            this._showAndHideBottomMenu("hide");//调用隐藏菜单方法
            this._getSearchData(1);//调用获取搜索数据方法（模拟刷新）
        },
        //搜索删除方法
        _searchDeleteFile:function(){
            var that = this;
            //如果两秒都还没有得到接口返回提示正在删除提示
            that._time = setTimeout(function(){
                that.options.commonToast.CommonToast("showToast","删除中，请稍后...");//显示飘窗提示
            },2000);
            //得到删除文件的uuid
            var uuidArray = [];
            for(var i = 0; i < that._selectData.length; i++){
                uuidArray.push(that._selectData[i].uuid);
            }
            //请求参数
            var paramet = {"token":getUrl("token"),"uuid":uuidArray.join(","),"conflict_uuid":that._conflict_uuid};
            http(ServerConfig.domain+"/recycle/removeFileToRecycle",paramet,{
                success:function(arg){
                    clearTimeout(that._time);//清除延迟
                    if(parseInt(arg.code) == 1){
                        //判断是否显示了询问弹框
                        if($("#inquiry").length != 0){
                            that._deleteMask.CommonDeleteMask("removeMask");//调用询问组件删除方法
                        }
                        that.conflict_uuid = 0;//重置删除冲突id
                        //判断是否有提示
                        if(that.options.commonToast.attr("isShow") == "no"){
                            that.options.commonToast.CommonToast("showToast","删除成功");//显示飘窗提示
                        }else{
                            that.options.commonToast.CommonToast("changeText","删除成功");//改变提示文字
                        }
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            that._searchContainer.CommonSearch("lockBtn","no");//解锁搜索输入框操作按钮
                            that._bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单所有操作按钮
                            that._iscrollContainer.CommonIscroll("lock","no");//解锁所有文件列表
                            that._searchContainer.CommonSearch("showCloseBtn");//显示关闭按钮
                            that._showAndHideBottomMenu("hide");//隐藏底部操作菜单
                            that._selectData = [];//重置选中数据
                            that._offset = 0;//重置偏移量
                            setTimeout(function(){
                                that._getSearchData(1);//调用
                            },300);
                        },1500);
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else if(arg.msg == "创建有链接，是否删除"){
                            //判断是否有提示
                            if(that.options.commonToast.attr("isShow") != "no"){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            }
                            that._deleteMask.CommonDeleteMask("changeText","当前文件创有链接，是否还要继续删除");//调用询问组件改变提示内容方法
                            that._deleteMask.CommonDeleteMask("changeDetermineBtn","继续");//调用询问组件改变确定按钮文字方法
                            that._deleteMask.CommonDeleteMask("showMask");//调用询问组件的显示组件方法
                            that.conflict_uuid = arg.data.conflict_uuid;//得到冲突id
                        }else{
                            //判断是否有提示
                            if(that.options.commonToast.attr("isShow") == "no"){
                                that.options.commonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            }else{
                                that.options.commonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            }
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                                that._searchContainer.CommonSearch("lockBtn","no");//解锁搜索输入框操作按钮
                                that._bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单所有操作按钮
                                that._iscrollContainer.CommonIscroll("lock","no");//解锁所有文件列表
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            },1500);
                        }
                    }
                }
            });
        },
        //搜索移动和复制文件新建文件夹方法
        _searchNewFolder:function(obj,rename,content){
            var that = this;
            //如果两秒都还没有得到接口返回提示正在删除提示
            that._time = setTimeout(function(){
                that.options.commonToast.CommonToast("showToast","新建中，请稍后...");//显示飘窗提示
            },2000);
            //请求参数
            var paramet = {"token":getUrl("token"),"pid":obj.pid,"name":obj.name,"rename":rename};
            http(ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/addFolder",paramet,{
                success:function(arg){
                    clearTimeout(that._time);//清除延时
                    if(parseInt(arg.code) == 1){
                        that._isMoveCopyRefresh = true;//当点击了移动和复制文件组件的取消按钮需要刷新
                        //判断是否有提示
                        if(that.options.commonToast.attr("isShow") == "no"){
                            that.options.commonToast.CommonToast("showToast","新建成功");//显示飘窗提示
                        }else{
                            that.options.commonToast.CommonToast("changeText","新建成功");//改变提示文字
                        }
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            content.CommonMoveCopy("newFolderSuccess",1);//调用移动组件新建文件夹成功方法
                        },1500);
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else if(arg.msg == "同名文件夹存在"){
                            //判断是否有提示
                            if(that.options.commonToast.attr("isShow") != "no"){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            }
                            //初始化删除提示组件
                            that._deleteMask = $("<div id='inquiry' style='z-index:5;'></div>").appendTo($("body"));
                            that._deleteMask.CommonDeleteMask({
                                "title":"冲突提示！",
                                "text":"当前目录内已有相同文件夹，是否继续，如果继续系统将自动重命名",
                                "determineBtn":"继续"
                            });
                            //监听取消事件
                            that._deleteMask.bind("DELETE_MASK_CANCEL",function(){
                                content.CommonMoveCopy("newFolderSuccess",2);//调用移动组件新建文件夹成功方法
                            });
                            //监听确定事件
                            that._deleteMask.bind("DELETE_MASK_DETERMINE",function(){
                                that._deleteMask.CommonDeleteMask("removeMask");//调用询问组件删除方法
                                that._searchNewFolder(obj,1,content);//调用自己本身
                            });
                        }else{
                            //判断是否有提示
                            if(that.options.commonToast.attr("isShow") == "no"){
                                that.options.commonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            }else{
                                that.options.commonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            }
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                                content.CommonMoveCopy("newFolderSuccess",3);//调用移动组件新建文件夹成功方法
                            },1500);
                        }
                    }
                }
            });
        },
        //搜索移动文件方法
        _searchMoveFileFolder:function(pid,conflictUuid){
            var that = this;
            //得到移动的uuid
            var uuidArray = [];
            for(var i = 0; i < that._selectData.length; i++){
                uuidArray.push(that._selectData[i].uuid);
            }
            //请求参数
            var paramet = {"token":getUrl("token"),"pid":pid,"uuid":uuidArray.join(","),"conflict_uuid":conflictUuid};
            http(ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/moveFile",paramet,{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        that._moveContainer.CommonMoveCopy("successComplete");//调用移动组件成功方法
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else if(arg.msg == "文件冲突,请解决冲突文件"){
                            //（在移动的时候下面的逻辑永远不会执行，这里之所以留着是怕以后需要重命名逻辑）
                            that._moveContainer.CommonMoveCopy("animationStop");//调用移动组件暂停动画方法
                            //初始化询问提示组件
                            that._deleteMask = $("<div id='inquiry' style='z-index:3;'></div>").appendTo($("body"));
                            that._deleteMask.CommonDeleteMask({
                                "title":"冲突提示！",
                                "text":"当前目录内已有相同文件（文件夹），是否继续，如果继续系统将自动重命名",
                                "determineBtn":"继续"
                            });
                            //监听取消事件  
                            that._deleteMask.bind("DELETE_MASK_CANCEL",function(){
                                that._moveContainer.CommonMoveCopy("initAnimation");//调用移动组件初始化动画方法
                            });
                            //监听确定事件
                            that._deleteMask.bind("DELETE_MASK_DETERMINE",function(){
                                that._deleteMask.CommonDeleteMask("removeMask");//调用询问组件删除方法
                                moveFileFolder(pid,arg.data.conflict_uuid);//调用自己本身
                            });
                        }else{
                            that._moveContainer.CommonMoveCopy("failComplete",arg.msg);//调用移动组件失败方法
                        }
                    }
                }
            });
        },
        //搜索复制文件方法(后端是需要两步实现复制，第一步复制，第二步粘贴)
        _searchCopyFileFolder:function(pid,type,conflictUuid){
            var that = this;
            //得到移动的uuid
            var uuidArray = [];
            for(var i = 0; i < that._selectData.length; i++){
                uuidArray.push(that._selectData[i].uuid);
            }
            var url = ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/copyFile";//复制接口
            var paramet = {"token":getUrl("token"),"pid":pid,"uuid":uuidArray.join(",")};
            if(type == "paste"){
                url = ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/pasteFile";//粘贴接口
                paramet = {"token":getUrl("token"),"uuid":pid,"conflict_uuid":conflictUuid};
            }
            http(url,paramet,{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        //判断是复制成功还是粘贴成功
                        if(type == "copy"){
                            that._searchCopyFileFolder(pid,"paste",conflictUuid);//调用自己本身
                        }else{
                            that._copyContainer.CommonMoveCopy("successComplete");//调用移动组件成功方法
                        }
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else if(arg.msg == "重名冲突"){ 
                            that._copyContainer.CommonMoveCopy("animationStop");//调用移动组件暂停动画方法
                            //初始化删除提示组件
                            that._deleteMask = $("<div id='inquiry' style='z-index:3;'></div>").appendTo($("body"));
                            that._deleteMask.CommonDeleteMask({
                                "title":"冲突提示！",
                                "text":"当前文件夹内已有相同文件（文件夹），是否继续，如果继续系统将自动重命名",
                                "determineBtn":"继续"
                            });
                            //监听取消事件  
                            that._deleteMask.bind("DELETE_MASK_CANCEL",function(){
                                that._copyContainer.CommonMoveCopy("initAnimation");//调用移动组件初始化动画方法
                            });
                            //监听确定事件
                            that._deleteMask.bind("DELETE_MASK_DETERMINE",function(){
                                that._deleteMask.CommonDeleteMask("removeMask");//调用询问组件删除方法
                                that._searchCopyFileFolder(pid,"paste",arg.data.conflict_uuid);//调用自己本身
                            });
                        }else{
                            that._copyContainer.CommonMoveCopy("failComplete");//调用移动组件失败方法
                        }
                    }
                }
            });
        },
        //搜索置顶和取消置顶方法
        _searchSetTopping:function(type){
            var that = this;
            var msg = type == 1 ? "置顶中，请稍后..." : "取消置顶中，请稍后...";
            //如果两秒都还没有得到接口返回提示正在置顶提示
            that._time = setTimeout(function(){
                that.options.commonToast.CommonToast("showToast",msg);//显示飘窗提示
            },2000);
            var paramet = {"token":getUrl("token"),"uuid":that._selectData[0].uuid};
            var url = type == 1 ? "stickUp" : "cancelStickUp";//后端接口方法名
            http(ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/"+url,paramet,{
                success:function(arg){
                    clearTimeout(that._time);//清除延迟
                    if(parseInt(arg.code) == 1){
                        //判断是否有提示
                        var successMsg = type == 1 ? "置顶成功" : "取消置顶成功";
                        if(that.options.commonToast.attr("isShow") == "no"){
                            that.options.commonToast.CommonToast("showToast",successMsg);//显示飘窗提示
                        }else{
                            that.options.commonToast.CommonToast("changeText",successMsg);//改变提示文字
                        }
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            that._selectData = [];//重置选中数据
                            that._offset = 0;//重置偏移量
                            that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            that._searchContainer.CommonSearch("showCloseBtn");//显示关闭按钮
                            that._bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单所有操作按钮
                            that._iscrollContainer.CommonIscroll("lock","no");//解锁所有文件列表
                            that._searchContainer.CommonSearch("lockBtn","no");//解锁搜索输入框操作按钮
                            that._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
                            that._showAndHideBottomMenu("hide");//隐藏菜单
                            setTimeout(function(){
                                that._getSearchData(1);//获取列表数据
                            },300);
                        },1500);
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            //判断是否有提示
                            if(that.options.commonToast.attr("isShow") == "no"){
                                that.options.commonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            }else{
                                that.options.commonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            }
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                                that._bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单所有操作按钮
                                that._iscrollContainer.CommonIscroll("lock","no");//解锁所有文件列表
                                that._searchContainer.CommonSearch("lockBtn","no");//解锁搜索输入框操作按钮
                            },1500);
                        }
                    }
                }
            });
        },
        //搜索重命名文件方法
        _searchRenameFileFolder:function(type,name,rename){
            var that = this;
            //如果两秒都还没有得到接口返回提示正在重命名提示
            that._time = setTimeout(function(){
                that.options.commonToast.CommonToast("showToast","正在重命名，请稍后...");//显示飘窗提示
            },2000);
            var url = ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/renameFolder";//重命名文件夹接口
            //判断是重命名文件还是文件夹
            if(type == "文件"){
                url = ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/renameFile";//重命名文件接口
            }
            var paramet = {"token":getUrl("token"),"uuid":that._selectData[0].uuid,"name":name,"rename":rename};
            http(url,paramet,{
                success:function(arg){
                    clearTimeout(that._time);//清除延迟
                    if(parseInt(arg.code) == 1){
                        //判断是否有提示
                        if(that.options.commonToast.attr("isShow") == "no"){
                            that.options.commonToast.CommonToast("showToast","重命名成功");//显示飘窗提示
                        }else{
                            that.options.commonToast.CommonToast("changeText","重命名成功");//改变提示文字
                        }
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            that._renameContainer.CommonNewFolderAadRename("removeElement");//调用重命名组件删除组件方法
                            that._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
                            that._searchContainer.CommonSearch("showCloseBtn");//显示关闭按钮
                            that._showAndHideBottomMenu("hide");//隐藏菜单
                            that._selectData = [];//重置选中数据
                            that._offset = 0;//重置偏移量
                            setTimeout(function(){
                                that._getSearchData(1);//获取列表数据
                            },300);
                        },1500);
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else if(arg.msg == "同名文件存在" || arg.msg == "同名文件夹存在"){
                            //判断是否有提示
                            if(that.options.commonToast.attr("isShow") != "no"){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            }
                            //初始化询问弹框
                            var text = arg.msg == "同名文件存在" ? "文件" : "文件夹";//得到是文件冲突还是文件夹冲突
                            that._deleteMask = $("<div id='inquiry' style='z-index:1;'></div>").appendTo($("body"));
                            that._deleteMask.CommonDeleteMask({
                                "title":"冲突提示！",
                                "text":"当前目录已有相同"+text+"名称，是否继续如果继续系统将自动重命名",
                                "determineBtn":"继续"
                            });
                            //监听取消事件
                            that._deleteMask.bind("DELETE_MASK_CANCEL",function(){
                                that._renameContainer.CommonNewFolderAadRename("lock","no");//调用重命名组件解除方法
                            });
                            //监听确定事件
                            that._deleteMask.bind("DELETE_MASK_DETERMINE",function(){
                                that._deleteMask.CommonDeleteMask("removeMask");//调用询问组件删除方法
                                that._searchRenameFileFolder(type,name,1);//调用自己本身
                            });
                        }else{
                            //判断是否有提示
                            if(that.options.commonToast.attr("isShow") == "no"){
                                that.options.commonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            }else{
                                that.options.commonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            }
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            },1500);
                        }
                    }
                }
            });
        },
        //微信朋友圈，qq，微信分享方法
        _searchCreateThirdShare:function(name,uuid,type){
            var that = this;
            var paramet = {"token":getUrl("token"),"name":name,"uuid":uuid.join(","),"type":1};
            http(ServerConfig.domain+"/"+skinConfig(global.skin).linkshare+"/createTask",paramet,{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        var data= {
                            url:arg.data.url,//分享链接
                            title:"文件分享：" + name,
                            content:"给你分享了"+ uuid.length +"文件，快来下载吧",
                            image:ServerConfig.domain.replace("/appweb","/shell_web") + skinConfig(global.skin).shllWebIon.replace("..","") + "search_icon.png",
                            type:type// qq | wechat | friends
                        };
                        console.log(data);
                        Shell.sendEvent("ThirdPartyShare",data);
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            that.options.commonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            },1500);
                        }
                    }
                }
            });
        },
        //获取下载文件
        _getDownloadFile:function(){
            var that = this;
            var ids = [];//需要下载的文件数组
            for(var i = 0; i < that._selectData.length; i++){
                ids.push(that._selectData[i].uuid);
            }
            //如果两秒都还没有得到接口返回提示正在删除提示
            that._time = setTimeout(function(){
                that.options.commonToast.CommonToast("showToast","获取下载文件中，请稍后...");//显示飘窗提示
            },2000);
            //请求参数
            var paramet = {"token":getUrl("token"),"uuid":ids.join(",")};
            http(ServerConfig.domain+"/download/getDownLoadFile",paramet,{
                success:function(arg){
                    clearTimeout(that._time);//清除延迟
                    if(parseInt(arg.code) == 1){
                        //判断是否有提示
                        if(that.options.commonToast.attr("isShow") != "no"){
                            that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                        }
                        that._searchContainer.CommonSearch("lockBtn","no");//解锁搜索输入框操作按钮
                        that._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
                        that._iscrollContainer.CommonIscroll("lock","no");//解锁所有文件列表
                        that._bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单所有操作按钮
                        Shell.sendEvent("download",{"list":arg.data.rows});//给原生发事件，并把下载文件发送给原生
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            //判断是否有提示
                            if(that.options.commonToast.attr("isShow") == "no"){
                                that.options.commonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            }else{
                                that.options.commonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            }
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that._bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单所有操作按钮
                                that._searchContainer.CommonSearch("lockBtn","no");//解锁搜索输入框操作按钮
                                that._searchContainer.CommonSearch("searchInput","no");//解锁搜索输入框
                                that._iscrollContainer.CommonIscroll("lock","no");//解锁所有文件列表
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            },1500);
                        }
                    }
                }
            });
        },
        //获取组装预览需要的参数方法
        _getPrevData:function(uuid){
            //调用找到当前预览文件所需的参数方法得到当前预览文件的信息
            this._currentData = getCurrentPreviewFileInformation({"content":this._iscrollContainer,"fileId":uuid});
            //组装原生和删除当前预览文件需要的数据
            this._previewData = {}//原生要的预览数据
            this._previewData.uuid = this._currentData.uuid;//当前预览的文件uuid
            this._previewData.fileinfoId = this._currentData.fileinfoId;//当前预览的文件fileinfoId
            this._previewData.type = this._currentData.type;//当前预览的文件类型
            this._previewData.name = this._currentData.fileName;//当前预览的文件名称
            this._previewData.error = "";//错误提示语
            this._previewData.url = "";//当前文件预览地址
            this._previewData.pageName = this._pageName;//当前在那个页面预览参数
            this._previewData.btnArray = [{"name":"下载","key":"download","icon":""},{"name":"删除","key":"delete","icon":""},{"name":"分享","key":"share","icon":""}];//当前文件可操作按钮
            //判断档期那预览的文件是什么类型(调用找到上一个下一个图片或者文件id方法)
            if(this._currentData.type == "image"){
                this._previewData.prevFile = getPrevNextFileId({"fileId":uuid,"operateType":"prev","fileType":"auto","content":this._iscrollContainer});//上一个文件的uuid
                this._previewData.prevFileInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"prev","fileType":"auto","content":this._iscrollContainer});//上一个文件的fileinfoid
                this._previewData.nextFile = getPrevNextFileId({"fileId":uuid,"operateType":"next","fileType":"auto","content":this._iscrollContainer});//下一个文件uuid
                this._previewData.nextFileInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"next","fileType":"auto","content":this._iscrollContainer});//下一个文件的fileinfoid          
                this._previewData.prevImg = getPrevNextFileId({"fileId":uuid,"operateType":"prev","fileType":"image","content":this._iscrollContainer});//上一张图片的uuid
                this._previewData.prevImgInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"prev","fileType":"image","content":this._iscrollContainer});//上一张图片的fileinfoid
                this._previewData.nextImg = getPrevNextFileId({"fileId":uuid,"operateType":"next","fileType":"image","content":this._iscrollContainer});//下一张图片的uuid
                this._previewData.nextImgInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"next","fileType":"image","content":this._iscrollContainer});//下一张图片的fileinfoid
            }else{
                this._previewData.prevFile = getPrevNextFileId({"fileId":uuid,"operateType":"prev","fileType":"auto","content":this._iscrollContainer});//上一个文件uuid
                this._previewData.prevFileInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"prev","fileType":"auto","content":this._iscrollContainer});//上一个文件的fileinfoid
                this._previewData.nextFile = getPrevNextFileId({"fileId":uuid,"operateType":"next","fileType":"auto","content":this._iscrollContainer});//下一个文件的uuid
                this._previewData.nextFileInfoid = getPrevNextFileinfoid({"fileId":uuid,"operateType":"next","fileType":"auto","content":this._iscrollContainer});//下一个文件的fileinfoid
                this._previewData.prevImg = "";//上一张图片的uuid
                this._previewData.prevImgInfoid = "";//上一张图片的fileinfoid
                this._previewData.nextImg = "";//下一张图片uuid
                this._previewData.nextImgInfoid = "";//下一张图片的fileinfoid
                var ext = ["doc","docx","xls","xlsx","ppt","pptx","txt"];
                //判断当前预览文件是否可以协同处理
                if(ext.indexOf(this._currentData.ext) > -1){
                    this._previewData.btnArray.push({"name":"编辑","key":"edit","icon":""});
                }
            }
            this._isNextPrev = true;//允许用户点击再次触发
        },
        //获取协同地址方法
        _prevCoordinationUrl:function(uuid,name){
            var that = this;
            //请求参数
            var ext = "";
            if(this._currentData.ext == "docx" || this._currentData.ext == "doc"){
                ext = "word";
            }else if(this._currentData.ext == "xlsx" || this._currentData.ext == "xls"){
                ext = "excel";
            }else if(this._currentData.ext == "pptx" || this._currentData.ext == "ppt"){
                ext = "ppt";
            }else if(this._currentData.ext == "txt"){
                ext = "txt";
            }
            var paramet = {"token":getUrl("token"),"uuid":uuid,"document_type":ext,"name":name};
            http(ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/getDocumentPreviewUrl",paramet,{
                success:function(arg){
                    if(parseInt(arg.code) == 1 && arg.data.url != ""){
                        Shell.sendEvent("setCoordinationUrl",{"url":arg.data.url});//告诉原生协同地址
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            that.options.commonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            },1500);
                        }
                    }
                }
            });
        },
        //预览下载文件方法
        _prevDownloadFile:function(uuid){
            var that = this;
            //请求参数
            var paramet = {"token":getUrl("token"),"uuid":uuid};
            http(ServerConfig.domain+"/download/getDownLoadFile",paramet,{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        Shell.sendEvent("download",{"list":arg.data.rows});//给原生发事件，并把下载文件发送给原生
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            that.options.commonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.commonToast.CommonToast("hideToast");//掉飘窗消失方法
                            },1500);
                        }
                    }
                }
            });
        },
        //预览删除文件方法
        _prevDeleteFile:function(uuid){
            var that = this;
            //请求参数
            var paramet = {"token":getUrl("token"),"uuid":uuid,"conflict_uuid":this._conflict_uuid};
            http(ServerConfig.domain+"/recycle/removeFileToRecycle",paramet,{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        that._offset = 0;//重置偏移量
                        that._getSearchData(1);//获取列表数据
                        that._conflict_uuid = 0;//重置删除冲突id
                        Shell.sendEvent("deleteFile",{"code":1,"msg":"删除成功"});//告诉原生删除结果
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else if(arg.msg == "创建有链接，是否删除"){ 
                            that._conflict_uuid = arg.data.conflict_uuid;//得到冲突id
                            that._prevDeleteFile(uuid);//调用自己本身
                        }else{
                            Shell.sendEvent("deleteFile",{"code":0,"msg":arg.msg});//告诉原生删除结果
                        }
                    }
                }
            });
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
            this.element.remove();
        }
    });
});