/*
*   2020年11月9日
*   
*   封装云空间手机端个人空间查看文件信息组件
*
*   开发者：付长建 
*/
define(["CommonHead"],function(){
    $.widget("ys.MySpaceSee",{
        //默认参数
        options:{
            uuid:"",//当前查看文件的uuid
            title:"查看信息",
            icon:"",//文件图标
            CommonToast:null,//飘窗提示
        },
        _headContainer:null,//头部组件
        _maxContentContainer:null,//内容体最大容器
        _fileSizeContainer:null,//文件大小元素
        _fileTypeContainer:null,//文件类型元素
        _fileOwnerContainer:null,//文件所有者元素
        _fileModifyTimeContainer:null,//文件修改时间元素
        _fileModifyNmaeContainer:null,//文件修改者元素
        _fileLastModifyTimeContainer:null,//文件上次修改时间元素
        _time:null,//数据请求时间参数
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            //给初始化元素设定指定的css样式
            this.element.css({
                "position":"fixed",
                "top":"0",
                "left":this.element.width() + "px",
                "background":"#fff",
                "box-shadow":"-6px 3px 4px 1px rgba(0, 37, 87, 0.04)",
                "transition":"all 0.3s",
                "overflow":"hidden"
            });
            //初始化头部组件 
            this._headContainer = $("<div></div>").appendTo(this.element);
            this._headContainer.CommonHead({"isGoback":true,"title":this.options.title});
            //创建内容体最大容器
            this._maxContentContainer = $("<div style='width:100%;padding:0.5rem 0.3rem 0.3rem;box-sizing:border-box;'></div>").appendTo(this.element);
            //创建文件icon和文件名称元素
            this._iconNameContainer = $("<div style='width:100%;padding-bottom:0.15rem;display:flex;flex-direction:row;border-bottom:1px solid #ECECEC;box-sizing:border-box;'></div>").appendTo(this._maxContentContainer);
            $("<img style='width:0.36rem;height:0.36rem;border-radius:0.02rem;' src='"+this.options.icon+"'/>").appendTo(this._iconNameContainer);
            $("<span class='valElement' style='max-width:2.5rem;margin-left:0.1rem;font-size:0.16rem;line-height:0.36rem;font-weight:bold;display:-webkit-box;text-overflow:ellipsis;-webkit-line-clamp:1;-webkit-box-orient:vertical;word-wrap:break-word;overflow:hidden;'>--</span>").appendTo(this._iconNameContainer);
            //创建文件大小元素
            this._fileSizeContainer = $("<div style='width:100%;display:flex;flex-direction:row;margin-top:0.2rem;'></div>").appendTo(this._maxContentContainer);
            $("<span style='font-size:0.14rem;color:rgb(102,102,102);'>大&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;小：</span>").appendTo(this._fileSizeContainer);
            $("<span class='valElement' style='font-size:0.14rem;'>--</span>").appendTo(this._fileSizeContainer);
            //创建文件类型元素
            this._fileTypeContainer = $("<div style='width:100%;display:flex;flex-direction:row;margin-top:0.2rem;'></div>").appendTo(this._maxContentContainer);
            $("<span style='font-size:0.14rem;color:rgb(102,102,102);'>类&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;型：</span>").appendTo(this._fileTypeContainer);
            $("<span class='valElement' style='font-size:0.14rem;'>--</span>").appendTo(this._fileTypeContainer);
            //创建文件所有者元素
            this._fileOwnerContainer = $("<div style='width:100%;display:flex;flex-direction:row;margin-top:0.2rem;'></div>").appendTo(this._maxContentContainer);
            $("<span style='font-size:0.14rem;color:rgb(102,102,102);'>所&nbsp;&nbsp;有&nbsp;&nbsp;者：</span>").appendTo(this._fileOwnerContainer);
            $("<span class='valElement' style='font-size:0.14rem;'>--</span>").appendTo(this._fileOwnerContainer);
            //创建文件修改时间元素
            this._fileModifyTimeContainer = $("<div style='width:100%;display:flex;flex-direction:row;margin-top:0.2rem;'></div>").appendTo(this._maxContentContainer);
            $("<span style='font-size:0.14rem;color:rgb(102,102,102);'>创建时间：</span>").appendTo(this._fileModifyTimeContainer);
            $("<span class='valElement' style='font-size:0.14rem;'>--</span>").appendTo(this._fileModifyTimeContainer);
            //创建文件修改者元素
            this._fileModifyNmaeContainer = $("<div style='width:100%;display:flex;flex-direction:row;margin-top:0.2rem;'></div>").appendTo(this._maxContentContainer);
            $("<span style='font-size:0.14rem;color:rgb(102,102,102);'>修&nbsp;&nbsp;改&nbsp;&nbsp;者：</span>").appendTo(this._fileModifyNmaeContainer);
            $("<span class='valElement' style='font-size:0.14rem;'>--</span>").appendTo(this._fileModifyNmaeContainer);
            //创建文件上次修改时间元素
            this._fileLastModifyTimeContainer = $("<div style='width:100%;display:flex;flex-direction:row;margin-top:0.2rem;'></div>").appendTo(this._maxContentContainer);
            $("<span style='font-size:0.14rem;color:rgb(102,102,102);'>上次修改：</span>").appendTo(this._fileLastModifyTimeContainer);
            $("<span class='valElement' style='font-size:0.14rem;'>--</span>").appendTo(this._fileLastModifyTimeContainer);
            //创建文件标签元素
            this._fileLabelContainer = $("<div style='width:100%;display:flex;flex-direction:row;margin-top:0.2rem;'></div>").appendTo(this._maxContentContainer);
            $("<span style='font-size:0.14rem;color:rgb(102,102,102);'>标&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;签：</span>").appendTo(this._fileLabelContainer);
            $("<span class='valElement' style='font-size:0.14rem;'>--</span>").appendTo(this._fileLabelContainer);

            //监听页面点击返回按钮
            this._headContainer.bind("GOBACK_BTN_CLICK",function(){
                that.element.css("transition","0.3s");
                that.element.css("left",that.element.width() + 10 + "px");
                that.element.trigger("SEE_GOBACK_CLOSE");
                setTimeout(function(){
                    that.destroy();
                },310);
            });
            //给初始化元素绑定手指事件
            this._finger();
        },
        //组件手指事件
        _finger:function(){
            var that = this;
            var pageX = 0;
            this.element.on("touchstart",function(e){
                var touch = e.originalEvent,startX = touch.changedTouches[0].pageX;
                if(startX <= 80){
                    $(this).css("transition","");
                    $(this).on("touchmove",function(e){
                        e.preventDefault();
                        touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
                        pageX = touch.pageX;
                        if(pageX > 0){
                            $(this).css("left",pageX + "px");
                        }
                    });
                }
            }).on("touchend",function(){
                $(this).css("transition","0.3s");
                if(pageX >= 50){
                    that._headContainer.trigger("GOBACK_BTN_CLICK");
                }else{
                    $(this).css("left","0px");
                }
                $(this).off("touchmove");
            });
        },
        //组件初始化完成主动执行
        _init:function(){
            setTimeout(function(that){
                that.element.css("left","0px");
                that._getFileSee();//调用获取文件信息方法
            },50,this);
        },
        //获取文件信息
        _getFileSee:function(){
            var that = this;
            //如果两秒都还没有得到接口返回提示正在重命名提示
            this._time = setTimeout(function(){
                that.options.CommonToast.CommonToast("showToast","正在获取文件信息，请稍后...");
                that._headContainer.CommonHead("lock","yes");//锁定头部组件禁止点击
            },2000);
            //请求参数
            var paramet = {"token":getUrl("token"),"uuid":this.options.uuid};
            http(ServerConfig.domain+"/"+skinConfig(global.skin).skinUrl+"/getFileInfo",paramet,{
                success:function(arg){
                    clearTimeout(that._time);//清除延时
                    if(parseInt(arg.code) == 1){
                        //判断飘窗是否显示了
                        if(that.options.CommonToast.attr("isShow") != "no"){
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.CommonToast.CommonToast("hideToast");//掉飘窗消失方法
                                that._headContainer.CommonHead("lock","no");//锁定头部组件禁止点击
                            },1500);
                        }
                        var name = arg.data.info[0].isdir == "1" ? "" : "." + arg.data.info[0].ext;
                        that._iconNameContainer.children(".valElement").html(arg.data.info[0].name + name);//文件名称
                        //判断是否是文件夹
                        if(arg.data.info[0].isdir == "1"){
                            that._fileSizeContainer.children(".valElement").html("--").css("color","#999");//大小
                        }else{
                            that._fileSizeContainer.children(".valElement").html(arg.data.info[0].file_size_format);//大小
                        }
                        var fileType = arg.data.info[0].isdir == "1" ? "folder" : arg.data.info[0].ext;//文件后缀
                        that._fileTypeContainer.children(".valElement").html(that._matchingFileType(fileType));//类型
                        that._fileOwnerContainer.children(".valElement").html(arg.data.info[0].owner_name);//所有者
                        that._fileModifyTimeContainer.children(".valElement").html(arg.data.info[0].createtime);//修改时间
                        that._fileModifyNmaeContainer.children(".valElement").html(arg.data.info[0].changer_name);//修改者
                        that._fileLastModifyTimeContainer.children(".valElement").html(arg.data.info[0].updatetime);//上次修改时间
                        //判断是否有标签
                        if(arg.data.info[0].file_label == ""){
                            that._fileLabelContainer.children(".valElement").html("暂无").css("color","#999");//标签
                        }else{
                            that._fileLabelContainer.children(".valElement").html(arg.data.info[0].file_label);//标签
                        }
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            //判断飘窗是否显示了
                            if(that.options.CommonToast.attr("isShow") == "no"){
                                that.options.CommonToast.CommonToast("showToast",arg.msg);//显示飘窗提示
                            }else{
                                that.options.CommonToast.CommonToast("changeText",arg.msg);//改变提示文字
                            }
                            //飘窗提示后2s后删除飘窗
                            setTimeout(function(){
                                that.options.CommonToast.CommonToast("hideToast");//掉飘窗消失方法
                                that._headContainer.CommonHead("lock","no");//锁定头部组件禁止点击
                            },1500);
                        }
                    }
                }
            });
        },
        //匹配文件类型方法
        _matchingFileType:function(type){
            var folder = ["folder"];
            var ysnote = ["ysnote"];
            var zip = ["zip","gz","tar","rar","bz","bz2", "boz","7z"];
            var video = ["uvh", "uvvh","uvm", "uvvm","uvp", "uvvp","uvs", "uvvs","uvv", "uvvv","dvb","fvt","mxu", "m4u","pyv","uvu","uvvu","viv","f4v","fli","flv","m4v","mkv", "mk3d", "mks","mng","asf", "asx","vob","wm","wmv","wmx","wvx","avi","movie","smv","3gp", "3gpp","3g2","h261","h263","h264","jpgv","*jpm", "jpgm","mj2", "mjp2","ts","mp4", "mp4v", "mpg4","mpeg", "mpg", "mpe", "m1v", "m2v","ogv","qt", "mov","webm","MP4","rmvb"];
            var audio = ["uva", "uvva","eol","dra","dts","dtshd","lvp","pya","ecelp4800","ecelp7470","ecelp9600","rip","aac","aif", "aiff", "aifc","caf","flac","*m4a","mka","m3u","wax","wma","ram", "ra","rmp","*ra","*wav","*3gpp","adp","au", "snd","mid", "midi", "kar", "rmi","*mp3","m4a", "mp4a","mpga", "mp2", "mp2a", "mp3", "m2a", "m3a","oga", "ogg", "spx","s3m","sil","wav","*wav","weba","xm","MP3"];
            var images = ["btif","pti","psd","azv","uvi","uvvi","uvg","uvvg","djvu","djv","*sub","dwg","dxf","fbs","fpx","fst","mmr","rlc","ico","mdi","wdp","npx","tap","vtf","wbmp","xif","pcx","3ds","ras","cmx","fh", "fhc", "fh4", "fh5", "fh7","*ico","jng","sid","*bmp","*pcx","pic", "pct","pnm","pbm","pgm","ppm","rgb","tga","xbm","xpm","xwd","exr","apng","bmp","cgm","drle","emf","fits","g3","gif","heic","heics","heif","heifs","ief","jls","jp2", "jpg2","jpeg", "jpg","jpe","jpm","jpx", "jpf","ktx","png","sgi","svg", "svgz","t38","tif", "tiff","tfx","webp","wmf","jpg"];
            var document = ["curl","dcurl","mcurl","scurl","sub","fly","flx","gv","3dml","spot","jad","wml","wmls","s", "asm","c", "cc", "cxx", "cpp", "h", "hh", "dic","htc","f", "for", "f77", "f90","hbs","java","lua","mkd","nfo","opml","*org","p","pas","pde","sass","scss","etx","sfv","ymp","uu","vcs","vcf","dsc","appcache","manifest","ics", "ifb","coffee","litcoffee","css","csv","html","htm","shtml","jade","jsx","less","markdown","md","mml","n3","txt","text","conf","def", "list", "log", "in", "ini","rtx","*rtf","sgml", "sgm", "shex","slim", "slm","stylus", "styl","tsv","t", "tr", "roff", "man", "me", "ms","ttl","uri","uris", "urls","vcard","vtt","*xml","yaml", "yml","js","doc", "dot","wps", "wks", "wcm", "wdb","docx","dotx","pdf","xls", "xlm", "xla", "xlc", "xlt", "xlw","xlam","xlsb","xlsm","xltm","xlsx","xltx","ppt", "pps", "pot", "ppam","pptm", "sldm","ppsm","potm","pptx","sldx","ppsx","unknown","exe","ysnote","torrent"];
            if(folder.indexOf(type) > -1){
                return "文件夹";
            }else if(ysnote.indexOf(type) > -1){
                return "云笔记";
            }else if(zip.indexOf(type) > -1){
                return "压缩包";
            }else if(video.indexOf(type) > -1){
                return "视频";
            }else if(audio.indexOf(type) > -1){
                return "音频";
            }else if(images.indexOf(type) > -1){
                return "图片";
            }else if(document.indexOf(type) > -1){
                return "文档";
            }else{
                return "未知";
            }
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
            this.element.remove();
        }
    });
});