/*
*   2020年7月10日
*   
*   封装共享空间导航组件
*
*   开发者：刘佳奇 
*/
define(['jquery','Shell','ApiConfig','confirm','NewHeader'], function ($,Shell,ApiConfig,confirm) {
    $.widget("ys.Navigations", {
        //默认参数
        options: {
        },
        myShare:null,//我的共享
        otherShare:null,//他人共享
        teamSpace:null,//团队空间
        organizationalSpace:null,//组织空间
        isOppt:true,
        _isTeam:true,
        _isGroup:true,
        //创建元素，在生命周期内多次运行
        _create: function () {
            var that = this;
            //初始化元素的css样式
            this.element.css({
                "width": "100%",
                "flex-wrap": "wrap",
                "padding-left":"0.15rem",
                "box-sizing": "border-box",
                "padding": "0.9rem",
                "display": "flex",
                "justify-content": "space-between",
                "font-size":"0.75rem",
                "font-weight":"bold"
            });
            this.myShare = $("<div data='myShare' style='text-align: center;width: 48.5%;height: 8rem;background: #fff;border-radius: 10px'></div>").appendTo(this.element);
            $("<img style='width:2.3rem;height:2.3rem;margin-top: 2.1rem;' src='../djcommon/img/group_icon_1@3x.png'/>").appendTo(this.myShare);
            $("<div style='padding-top:0.44rem' >我的共享</div>").appendTo(this.myShare);
            this.otherShare = $("<div data='otherShare' style='text-align: center;position:relative;width: 48.5%;height: 8rem;background: #fff;border-radius: 10px'></div>").appendTo(this.element);
            $("<img style='width:2.3rem;height:2.3rem;margin-top: 2.1rem;' src='../djcommon/img/group_icon_2@3x.png'/>").appendTo(this.otherShare);
            $("<div style='padding-top: 0.44rem'>他人共享</div>").appendTo(this.otherShare);
            $("<span  id='newNummes' style='height:1rem;text-align:center;line-height:1rem;background:#C82228;color:#FEFEFE;font-size:0.625rem;border-radius:0.5rem;position:absolute;left:6rem;top:1.7rem;display:none;padding-left: 5px;padding-right: 5px'></span>").appendTo(this.otherShare);
            this.teamSpace = $("<div data='teamSpace' style='text-align: center;width: 48.5%;height: 8rem;background: #fff;border-radius: 10px;margin-top: 0.6rem'></div>").appendTo(this.element);
            $("<img style='width:2.3rem;height:2.3rem;margin-top: 2.1rem;' src='../djcommon/img/group_icon_3@3x.png'/>").appendTo(this.teamSpace);
            $("<div style='padding-top: 0.44rem'>团队空间</div>").appendTo(this.teamSpace);
            this.organizationalSpace = $("<div data='organizationalSpace' style='text-align: center;width: 48.5%;height: 8rem;background: #fff;border-radius: 10px;margin-top: 0.6rem'></div>").appendTo(this.element);
            $("<img style='width:2.3rem;height:2.3rem;margin-top: 2.1rem;' src='../djcommon/img/group_icon_4@3x.png'/>").appendTo(this.organizationalSpace);
            $("<div style='padding-top: 0.44rem'>组织空间</div>").appendTo(this.organizationalSpace);
            this.element.children("div").bind("click",this,this._optClick);
            this.TeamSpaceFile();
            this.OrgSpaceFile();
            this.changeTotal();
        },
        _optClick:function(event){
            if($(this).attr("data") == "myShare"){
                if(event.data.isOppt){
                    event.data.isOppt = false;
                    Shell.sendEvent('openWin', {title:"我的共享",url:ApiConfig.api.get(ServerConfig.domain+'/groupspace/newShareSpaceMyShare?token='+global.token+"&",{name:"我的共享",id:"my",})});
                }
            }else if($(this).attr("data") == "otherShare"){
                if(event.data.isOppt){
                    event.data.isOppt = false;
                    Shell.sendEvent('openWin', {title:"他人共享",url:ApiConfig.api.get(ServerConfig.domain+'/groupspace/newShareSpaceOthersShare?token='+global.token+"&",{name:"他人共享",id:"other",})});
                }
            }else if($(this).attr("data") == "teamSpace"){
                console.log(event.data._isTeam)
                if(!event.data._isTeam){
                    try{
                        api.toast({msg: '你还没有团队额，快去加入吧!',duration: 2000,location: 'middle'});
                    }catch(e){}
                    return;
                }
                if(event.data.isOppt){
                    event.data.isOppt = false;
                    Shell.sendEvent('openWin', {title:"团队空间",url:ApiConfig.api.get(ServerConfig.domain+'/groupspace/newTeamSpaceFileList?token='+global.token)});
                }
            }else{
                console.log(event.data._isGroup)
                if(!event.data._isGroup){
                    try{
                        api.toast({msg: '你还没有组织额，快去加入吧!',duration: 2000,location: 'middle'});
                 }catch(e){}
                    return;
                }
                if(event.data.isOppt){
                    event.data.isOppt = false;
                    Shell.sendEvent('openWin', {title:"组织空间",url:ApiConfig.api.get(ServerConfig.domain+'/groupspace/newOrgSpaceFileList?token='+global.token)});
                }
            }
            setTimeout(function(){
                event.data.isOppt = true;
            },1000); 
        },
        //改变谈人共享消息数量方法
        changeTotal:function(numm){
            if(numm == undefined || numm == null || numm == ""){
                return;
            }
            if(parseInt(numm) != 0){
                $("#newNummes").html(numm).css("display","");
            }else{
                $("#newNummes").html("").css("display","none");
            }
        },
        //检测团队是否存在
        TeamSpaceFile:function(){
            var that = this;
            $.ajax({
                url:ServerConfig.domain +"/Ysgroupspace/departmentSpaceCheckDepartment?token="+global.token,
                type:'POST', //GET
                async:true,    //或false,是否异步
                dataType:'json',    //返回的数据格式：json/xml/html/script/jsonp/text
                success:function(arg){
                    if(arg.code == 1){
                        that._isTeam = true
                    }else{
                        that._isTeam = false   
                    }
                },
                error:function(xhr,textStatus){
                    api.toast({msg: '网络异常，稍后重试',duration: 2000,location: 'middle'});
                }
            });
        },
        //检测组织是否存在
        OrgSpaceFile:function(){
            var that = this;
            $.ajax({
                url:ServerConfig.domain +"/Ysorgspace/orgSpaceCheckOrg?token="+global.token,
                type:'POST', //GET
                async:true,    //或false,是否异步
                dataType:'json',    //返回的数据格式：json/xml/html/script/jsonp/text
                success:function(arg){
                    if(arg.code == 1){
                        that._isGroup = true
                    }else{
                        that._isGroup = false   
                    }
                },
                error:function(xhr,textStatus){
                    api.toast({msg: '网络异常，稍后重试',duration: 2000,location: 'middle'});
                }
            });
        },
        //释放控件(清除控件)
        destroy: function () {
            $.Widget.prototype.destroy.call(this);
        }
    });
});