/*
*   2021年4月6日
*   
*   封装云笔记本子管理cell组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.NewBookCell",{
        //默认参数
        options:{
            data:null//列表数据
        },
        isClick:true,//防止多次点击参数
        //创建控件，控件生命周期内会运行多次
        _create:function(){
            this.bookIconContainer = $("<div style='width:1.06rem;height:1.45rem;background:url("+this.options.data.coverUrl+");background-repeat:no-repeat;background-size:cover;position:relative;flex-shrink:0;'></div>").appendTo(this.element);
            $("<p style='width:0.5rem;height:24px;line-height:23px;text-align:center;background:rgba(255,255,255,0.4);border-radius:12px;font-size:0.1rem;font-weight:500;color:#fff;transform:scale(0.7);position:absolute;top:0;right:-0.04rem;'>已锁定</p>").appendTo(this.bookIconContainer);
            //创建本子详细信息元素
            var bookInformationContainer = $("<div style='margin-left:0.15rem;display:flex;flex-direction:column;position:relative;'></div>").appendTo(this.element);
            this.bookName = $("<p style='font-size:0.15rem;color:#000;font-weight:bold;word-break: break-all;text-overflow: ellipsis;overflow: hidden;display: -webkit-box;-webkit-line-clamp: 1;-webkit-box-orient: vertical;'>"+this.options.data.bookName+"</p>").appendTo(bookInformationContainer)
            var write = parseInt(this.options.data.pageCount) == 0 ? "未书写" : "已书写：" + parseInt(this.options.data.pageCount) + "页"
            $("<p style='font-size:0.12rem;color:#999;font-weight:500;margin-top:0.1rem;'>"+write+"</p>").appendTo(bookInformationContainer);
            var lastUpdateDate = parseInt(this.options.data.pageCount) == 0 ? "本子创建时间：" + this.options.data.lastUpdateDate : "上次书写时间：" + this.options.data.lastUpdateDate;
            $("<p style='font-size:0.12rem;color:#999;font-weight:500;margin-top:0.1rem;'>"+lastUpdateDate+"</p>").appendTo(bookInformationContainer);
            //创建操作按钮btn元素
            var btnContainer = $("<div style='display:flex;flex-direction:row;position:absolute;left:0;bottom:0;'></div>").appendTo(bookInformationContainer)
            this.lockIcon = $("<img style='width:0.32rem;height:0.32rem;' src='../djcommon/img/note/book-do-lock.png'>").appendTo(btnContainer);
            this.renameIcon = $("<img style='width:0.32rem;height:0.32rem;margin:0 0.1rem 0 0.1rem;' src='../djcommon/img/note/book-share.png'>").appendTo(btnContainer);
            this.moreIcon = $("<img style='width:0.32rem;height:0.32rem;' src='../djcommon/img/note/book-more.png'>").appendTo(btnContainer);
            //创建更多菜单元素
            this.moreMenu = $("<ul data='no' class='moreMenu' style='z-index:-1;width:0.98rem;height:0.8rem;background:#fff;box-shadow:0px 2px 12px 3px rgba(188,191,194,0.2);border-radius:0.05rem;position:absolute;right:-"+(btnContainer.width() - 81) / 100 +"rem;bottom:0.49rem;transition:all 0.2s;opacity:0;transform:scale(0.7);'></ul>").appendTo(btnContainer);
            $("<span style='font-size:18px;color:#fff;position:absolute;left:38%;bottom:-15px;'>▼</span>").appendTo(this.moreMenu);
            $("<li data='synchro' style='width:100%;height:0.4rem;line-height:0.38rem;text-align:center;border-bottom:1px solid #ECECEC;box-sizing:border-box;font-size:0.12rem;color:#000;font-weight:500;'>同步到云端</li>").appendTo(this.moreMenu);
            $("<li data='delete' style='width:100%;height:0.4rem;line-height:0.38rem;text-align:center;font-size:0.12rem;color:#000;font-weight:500;'>删除</li>").appendTo(this.moreMenu);
            //调用改变本子状态方法
            this.changeBookState(parseInt(this.options.data.activeFlag));

            //给锁定操作按钮绑定点击事件
            this.lockIcon.bind("click",this,this._lockIconClick);
            //给重命名操作按钮绑定点击事件
            this.renameIcon.bind("click",this,this._renameIconClick);
            //给更多操作按钮绑定点击事件
            this.moreIcon.bind("click",this,this._moreIconClick);
            //给菜单的选项绑定点击事件
            this.moreMenu.children("li").bind("click",this,this._moreOptionClick);
        },
        //当用户点击锁定按钮
        _lockIconClick:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("LOCK_BTN_CLICK",{"dataType":$(this).attr("dataType"),"data":event.data.options.data});//抛出锁定点击事件
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //当用户点击重命名按钮
        _renameIconClick:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("RENAME_BTN_CLICK",event.data.options.data);//抛出重命名点击事件
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //当用户点击更多菜单按钮
        _moreIconClick:function(event){
            event.stopPropagation();
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("MORE_BTN_CLICK",{"type":event.data.moreMenu.attr("data"),"data":event.data.options.data});//抛出更多点击事件
                setTimeout(function(){
                    event.data.isClick = true;
                },200);
            }
        },
        //当用户点击了菜单选项
        _moreOptionClick:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("MORE_OPTION_BTN_CLICK",{"type":$(this).attr("data"),"data":event.data.options.data});//抛出菜单选项被点击
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //显示更多菜单
        showMore:function(){
            this.moreMenu.attr("data","yes").css({"z-index":"1","transform":"scale(1)","opacity":"1"});
        },
        //隐藏更多菜单
        hideMore:function(){
            this.moreMenu.attr("data","no").css({"z-index":"-1","transform":"scale(0.7)","opacity":"0"});
        },
        //改变当前本子的状态和换图标
        changeBookState:function(type){
            if(parseInt(type) == 1){
                this.bookIconContainer.children("p").html("已启用").css("background","rgba(255,255,255,0.2)");
                this.lockIcon.attr("src","../djcommon/img/note/book-do-lock.png");
                this.lockIcon.attr("dataType",0);
            }else{
                this.bookIconContainer.children("p").html("已锁定").css("background","rgba(0,0,0,0.2)");
                this.lockIcon.attr("src","../djcommon/img/note/book-do-unlock.png");
                this.lockIcon.attr("dataType",1);
            }
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});