/*
 * CloudCell 列表cell
 * 作者：wenjiang
*/
define(['ByteFormat','DateFormat','ImgBtn','Img','Panel','Label','Btn','Widget','Cell','IconBox'],function(ByteFormat,DateFormat){
	$.widget("ys.NewCloudCell",$.ys.Cell, {
        enable:true,
        _namelabel:null,
        _detaillabel:null,
        _iconImg:null,
        _mainBox:null,
        _rightImgBtn:null,
        _init: function () {
            this._super();
            var material = this.options.dataDic;
            this.element.css({"border-bottom-color":"#ececec","overflow":"hidden"});
            this.element.css({"border-bottom-width":"1px","border-bottom-style":"solid"});
            this.element.css("position","relative");

            this._iconImg = $("<div style='float:left;'></div>")
			this._iconImg.IconBox({"width":"24px","height":"24px","data":material});
            //this._iconImg.Img({"src":'/assets/img/appimg/Cloud/ic_unkown.png',"width":"18px","height":"18px"});
            this._iconImg.css({"margin-left":this.s*25+"rem","margin-top":23*this.s+"rem"})
            //var imgString = this._iconImg.Img("setTypeImg",material);
            //this._iconImg.Img("changeSrc",imgString);
			
            this.element.append(this._iconImg)

            this._mainBox= $("<div class='mainBoxCell'></div>")
            this._mainBox.attr("tapmode")
            this.element.append(this._mainBox)
            this._mainBox.css({
                "position":"relative",
                "width":260*this.s+"rem",
                "padding-top":12*this.s+"rem",
                "height":60*this.s+"rem",
                "clear":"none",
                "margin-left":63*this.s+"rem"
            })

            this._namelabel = $("<div></div>");
            this._namelabel.Label({"text":material.name,"color":"#333333","fontSize":"16px"});
            this._namelabel.css({"font-weight":"bold"})
            this._mainBox.append(this._namelabel)
            var time = material.createtime;

            if(this.options.type =="recycle"){
                time = material.delete_time;
            }
            if(time>1 && time.toString().length===10){
                time = DateFormat(time*1000,"yyyy-MM-dd hh:mm")
            }
            this._detaillabel = $("<div></div>");
            this._detaillabel.Label({"text":time,"color":"#9999999","fontSize":"12px", marginTop:"2px"});
            this._mainBox.append(this._detaillabel)
            this._fileSizeLabel = $("<span></span>");
            var size = ByteFormat.human({value:material.file_size});
            // console.log("size:"+size);
            this._fileSizeLabel.Label({"text":size,"color":"#9999999","fontSize":"12px", marginLeft:"10px"});
            this._detaillabel.append(this._fileSizeLabel)

            this._imageBtnPanel= $("<div></div>").Btn();
            this._imageBtnPanel.attr("tapmode")
            this._imageBtnPanel.css({ "position":"absolute","width":50*this.s+"rem","height":62*this.s+"rem","top":0,"right":0,"background":"#fff"})
            this.element.append(this._imageBtnPanel)

            this._rightImgBtn = $("<div></div>");
            this._rightImgBtn.ImgBtn({"src":"../djcommon/img/pt_touxuan1@3x.png","tapSrc":"../djcommon/img/redyingshuo/pt_touxuan1-2@3x.png","width":"9px","height":"9px"});
            this._rightImgBtn.css({"margin-top":27*this.s+"rem","margin-left":25*this.s+"rem","position":"absolute","pointer-events":"none"});
            this._imageBtnPanel.append(this._rightImgBtn);

            if(material.isdir == 1){
                this._fileSizeLabel.html("")
            }else{
                this._namelabel.html(material.name+(material.ext ? ("."+material.ext) : ''))
            }
            if(this.options.type =="recycle"){
                this._dayLabel = $("<span></span>");
                this._dayLabel.Label({"text":material.restore_day+"天","color":"#9999999","fontSize":"12px", marginLeft:"10px"});
                this._detaillabel.append(this._dayLabel)

            }

            this.element.attr("data-name",material.name)
            this.element.attr("status",this._rightImgBtn.ImgBtn("getStatus"));

            this.element.bind("CELL_CLICK",this,this._BaseCarListClick);

            this._imageBtnPanel.bind("BTN_CLICK",this,this._onBtnClick);


        },
		triggerClick:function(){
            this.element.trigger("TRIGGER_CELL_CLICK",this.options.dataDic);
        },
        _BaseCarListClick:function(e){
            e.data.element.trigger("ACTION_CELL_CLICK",e.data.options.dataDic);
        },
        getBtnStatus:function(){
           return  this._rightImgBtn.ImgBtn("getStatus");
        },
        _onBtnClick:function(e){
            e.data._rightImgBtn.ImgBtn("setImgSrc");
            var number = e.data._rightImgBtn.ImgBtn("getStatus");
            if(parseInt(number) == 1){
                e.data.element.addClass("selected");
            }else{
                e.data.element.removeClass("selected");
            }
            e.data.element.attr("status",number);
            e.data.element.trigger("CELL_IMAGBTN_CLICK",number);
        },
        setImgBtnSize:function(obj){
            if(obj == 1){
                this._rightImgBtn.ImgBtn("setSize",{"width":"18px","height":"18px"});
                this._rightImgBtn.css({"margin-top":22*this.s+"rem","margin-left":20*this.s+"rem"});
            }else{
                this._rightImgBtn.ImgBtn("setSize",{"width":"9px","height":"9px"});
                this._rightImgBtn.css({"margin-top":27*this.s+"rem","margin-left":25*this.s+"rem"});
                this.element.removeClass("selected");
            }
        },
        setAllSelect:function(obj){
            if(obj == 1){
                this.element.addClass("selected");
                this._rightImgBtn.ImgBtn("setStatusSrc",1);
            }else{
                this.element.removeClass("selected");
                this._rightImgBtn.ImgBtn("setStatusSrc",0);
            }
        },
        getData:function(){
            return this.options.dataDic;
        },
        //创建控件，控件生命周期内会运行多次
        _create: function () {},
        // 释放控件
        destroy: function () {
            $.Widget.prototype.destroy.call(this);
        }
    });
})
