define(['Shell','Panel', 'ImgBase', 'phonexh', 'style'], function (Shell) {
    $.widget("ys.NewFileBottomOperation", $.ys.Panel, {
        _containDiv: null,
        showState:false,
        _SelectedDisable: [], //多选禁用按钮的tag名集合
        //默认参数
        //初始化，控件生命周期内只运行一次
        _init: function () {
            this._super();
            $("body").css({"overflow": "hidden"});
            if(typeof this.options.autoSetTabBar === 'undefined'){
                this.options.autoSetTabBar = true;//参数为是否自动设置壳上的tabBar的显示和隐藏，true是
            }
            this.element.css({
                "z-index": 40000,
                "width": "100%",
                "position": "absolute",
                "background":this.options.background || "#f8f8f8",
                "padding-top": "20px",
            });
            var dataArr = this.options.btnConfig||[
                {
                    tag: 'storage',
                    name: '转存',
                    src: '../djcommon/img/operate/pop_icon_zc@3x.png',
                    srcActive: '../djcommon/img/operate/pop_icon_zc@3x.png',
                },
                {
                    tag: 'download',
                    name: '下载',
                    src: '../djcommon/img/operate/pop_icon_download@3x.png',
                    srcActive: '../djcommon/img/operate/pop_icon_download@3x.png'
                },
                {
                    tag: 'see',
                    name: '查看信息',
                    src: '../djcommon/img/operate/pop_icon_check@3x.png',
                    srcActive: '../djcommon/img/operate/pop_icon_check@3x.png'
                },
                {
                    tag: 'log',
                    name: '操作记录',
                    src: '../djcommon/img/operate/pop_icon_record@3x.png',
                    srcActive: '../djcommon/img/operate/pop_icon_record@3x.png',
                }
            ]

            this.setMenu(dataArr);
            this._SelectedDisable = this.options.selectDisale||['see', 'storage','download','log']; //多选禁用按钮的tag名集合

            this.element.css("bottom","-"+this.element.outerHeight(true)+"px");
        },
        _close: function () {
            Shell.sendEvent("filterClose");
        },
        setMenu:function(dataArr){
            this.element.empty();
            this.element.css({'text-align': dataArr.length<4 ? 'center' : 'left'})
            if(dataArr.length>0){
                for (var i = 0; i < dataArr.length; i++) {
                    this._createLi(dataArr[i]);
                }
            }
        },
        _createLi: function (data) {
            var li = $('<div class="operation-btn"><div class="iconTypes"></div><div class="textName">' + data.name + '</div></div>');
            li.css({
                "display": "inline-block",
                "width": "25%",
                "text-align": "center"
            }).style({"height": "54px","marginBottom": "20px"});
            li.find('.iconTypes').ImgBase({
                width: '32px',
                height: '32px',
                src: data.src
            });
            li.find('img').css('left', 0);
            li.find('.iconTypes').css({
                margin: '0 auto'
            });
            this.cssEle(li.find('.textName'), {
                "lineHeight": "32px",
                "fontSize": "12px",
                "fontWeight": "bold",
                "color": "rgba(0,0,0,1)"
            })
            li.Btn();
            li.attr('data-event', data.tag).attr('id','tag_'+data.tag);
            li.bind('BTN_CLICK', this, function (e) {
                if ($(this).attr('data-disabled') === '1') {
                    e.preventDefault();
                    e.stopPropagation();
                    return false;
                }
                e.data.element.trigger("BOTTOM_OPERATION_CLICK", this.dataset.event);
            });
            this.element.append(li);
        },
        //设置某个tag按钮，是否为禁用状态
        setIconStatus:function (tagName,status) {
            var icon = this.element.find('#tag_'+tagName)
            console.log(status,icon)
            if (status) {
                icon.css({
                    "opacity": "1",
                    'pointer-events': 'auto'
                }).attr('data-disabled', '0')
            } else {
                icon.css({
                    "opacity": "0.6",
                    'pointer-events': 'none'
                }).attr('data-disabled', '1')
            }
        },
        setDisabledArr:function (arr) {
            this._SelectedDisable =  arr
        },
        setDataType: function (obj) {
            console.log("setDataType:" + JSON.stringify(obj));
            var li = this.element.find('.operation-btn'),
                that = this;
            if (obj.length > 1) {
                li.each(function (index, element) {
                    var current = $(element);
                    if (that._SelectedDisable.indexOf(current.attr('data-event')) < 0) {
                        current.css({
                            "opacity": "1",
                            'pointer-events': 'auto'
                        }).attr('data-disabled', '0');
                    } else {
                        current.css({
                            "opacity": "0.6",
                            'pointer-events': 'none'
                        }).attr('data-disabled', '1')
                    }
                });
            } else if (obj.length === 1) {
                li.css({
                    "opacity": "1",
                    'pointer-events': 'auto'
                }).attr('data-disabled', '0')
            } else {
                li.css({
                    "opacity": "0.6",
                    'pointer-events': 'none'
                }).attr('data-disabled', '1')
            }
        },
        show: function () {
            this.element.css("display","");
            this.showState = true;
            this.element.trigger("BOTTOM_OPERATE_SHOW",{show:true});
            this.element.animate({
                "bottom": "0px"
            }, 300, function () {
				$(window).trigger("VIEW_PORT_SIZE_CHANGE");
            });
        },
        hide: function () {
            var that = this;
            this.element.animate({
                "bottom": "-" + that.element.outerHeight(true) + "px"
            },300,function () {
                that.element.css("display","none");
                that.element.trigger("BOTTOM_OPERATE_SHOW",{show:false});
                that.showState = false;
                $(window).trigger("VIEW_PORT_SIZE_CHANGE");
            });
        },
        getShowState:function (params) {
            return this.showState
        },
        //创建控件，控件生命周期内会运行多次
        _create: function () {},
        // 释放控件
        destroy: function () {
            $.Widget.prototype.destroy.call(this);
        }
    });
})