/*
*   2021年4月1日
*   
*   封装云笔记笔列表cell组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.NewPenCell",{
        //默认参数
        options:{
            data:null//列表数据
        },
        isClick:true,//防止多次点击参数
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            this.penContainer = $("<div style='display:flex;flex-direction:column;'></div>").appendTo(this.element);
            $("<div style='font-size:0.16rem;font-weight:500;color:#000;margin-top:0.1rem;'>"+this.options.data.penName+"</div>").appendTo(this.penContainer);
            $("<p style='font-size:12px;font-weight:500;color:#999;margin:0.05rem 0 0.1rem 0;'>"+this.options.data.macAddress+"</p>").appendTo(this.penContainer);
            this.linkContainer = $("<div style='display:flex;align-items:center;'></div>").appendTo(this.element);
            $("<p class='fcjBtn' style='width:0.8rem;height:32px;line-height:30px;text-align:center;font-size:12px;color:#000;font-weight:500;border:1px solid #DCDCDC;box-sizing:border-box;border-radius:15px;background:#fff;'>连接</p>").appendTo(this.linkContainer);
            //给cell的按钮绑定点击事件
            this.linkContainer.children("p").bind("click",this,this._linkBtnClick);
        },
        //当点击连接按钮
        _linkBtnClick:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("LINK_BTN_CLICK",{"penData":event.data.options.data,"type":$(this).html()});//抛出cell按钮被点击
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //锁定组件
        locking:function(){
            this.linkContainer.children("p").css({"pointer-events":"none","opacity":"0.5"});
        },
        //解锁组件
        lockout:function(){
            this.linkContainer.children("p").css({"pointer-events":"","opacity":""});
        },
        //改变按钮文字
        changeBtnName:function(text){
            this.linkContainer.children("p").html(text);
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});