/*
*   2021年3月30日
*   
*   封装云笔记首页头部状态组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.NoteHead",{
        //默认参数
        options:{
            isLinkPen:false//是否开启安卓手机有线笔
        },
        maxContainer:null,//内容体最大容器
        androidStateContainer:null,//安卓手机未连接状态
        iosStateContainer:null,//ios手机未连接状态
        linkPenStateContainer:null,//ios和安卓手机连接状态
        bluetoothPenBtn:null,//蓝牙笔按钮
        wiredPenBtn:null,//有线笔按钮
        linkBtn:null,//ios未连接状态的连接按钮
        electricContainer:null,//笔连接成功电量和电池图标容器
        detailsBtn:null,//笔连接成功详情按钮
        isClick:true,//是否可以点击
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this
            var pad = (phonexh("top") + 20) / 100 + "rem";
            that.element.css({"width":"100%","padding":""+ pad +" .15rem 0 .15rem","box-sizing":"border-box"});
            //创建内容体
            that.maxContainer = $("<div style='width:100%;height:0.75rem;box-shadow:0px 2px 0.15rem rgba(0,0,0,0.05);border-radius:0.1rem;'></div>").appendTo(that.element);
            
            //判断是否开始了安卓手机显示有线笔
            if(this.options.isLinkPen){
                //判断当前是什么设备
                var u = navigator.userAgent;
                if(u.indexOf('Android') > -1 || u.indexOf('Linux') > -1){//安卓
                    this.androidStateContainer = $("<div style='width:100%;height:100%;border-radius:0.1rem;display:flex;flex-direction:row;'></div>").appendTo(this.maxContainer);
                    this.bluetoothPenBtn = $("<div style='height:100%;margin-left:0.42rem;display:flex;flex-direction:row;align-items:center;'></div>").appendTo(this.androidStateContainer);
                    $("<img style='width:0.39rem;height:0.39rem;' src='../djcommon/img/note/bt.png'/>").appendTo(this.bluetoothPenBtn);
                    $("<span style='font-size:0.14rem;font-weight:500;color:#000;margin-left:0.1rem;'>蓝牙笔</span>").appendTo(this.bluetoothPenBtn);
                    this.wiredPenBtn = $("<div style='height:100%;margin-left:0.42rem;display:flex;flex-direction:row;align-items:center;'></div>").appendTo(this.androidStateContainer);
                    $("<img style='width:0.39rem;height:0.39rem;' src='../djcommon/img/note/line.png'/>").appendTo(this.wiredPenBtn);
                    $("<span style='font-size:0.14rem;font-weight:500;color:#000;margin-left:0.1rem;'>有线笔</span>").appendTo(this.wiredPenBtn);
                    //给安卓手机蓝牙笔图标绑定点击事件
                    this.bluetoothPenBtn.children("img").bind("click",this,this._bluetoothPenBtn);
                    //给安卓手机有线笔图标绑定点击事件
                    this.wiredPenBtn.children("img").bind("click",this,this._wiredPenBtn);
                }else{
                    this._generate();//调用生成ios和安卓手机通用未连接状态原生
                }
            }else{
                this._generate();//调用生成ios和安卓手机通用未连接状态原生
            }
            //安卓和ios连接笔状态
            this.linkPenStateContainer = $("<div style='width:100%;height:100%;border-radius:0.1rem;display:none;flex-direction:row;justify-content:space-between;'></div>").appendTo(this.maxContainer);
            var stateDetailsContainer = $("<div style='height:100%;display:flex;flex-direction:column;margin-left:0.15rem;'></div>").appendTo(this.linkPenStateContainer);
            this.penName = $("<span style='font-size:0.18rem;font-weight:800;color:#000;margin-top:0.1rem;'>蓝牙笔</span>").appendTo(stateDetailsContainer);
            var linkcontainer = $("<div style='height:0.3rem;display:flex;flex-direction:row;align-items:center;'></div>").appendTo(stateDetailsContainer);
            $("<img style='width:0.12rem;height:0.12rem;' src='../djcommon/img/note/link_status_1.png'/>").appendTo(linkcontainer);
            $("<span style='font-size:0.12rem;color:#666;font-weight:500;margin-left:0.1rem;'>已连接</span>").appendTo(linkcontainer);
            this.electricContainer = $("<div style='height:100%;display:none;flex-direction:row;align-items:center;'></div>").appendTo(linkcontainer);
            $("<span style='display:inline-block;width:1px;height:0.12rem;background:#D2D2D2;margin:0 0.18rem 0 0.15rem;'></span>").appendTo(this.electricContainer);
            $("<img style='width:0.1rem;height:0.13rem;' src='../djcommon/img/note/power_full.png'/>").appendTo(this.electricContainer);
            $("<p style='font-size:0.12rem;color:#666;font-weight:500;margin-left:0.1rem;'>电量：50%</p>").appendTo(this.electricContainer);
            var linkBtnContainer = $("<div style='height:100%;display:flex;flex-direction:row;margin-right:0.15rem;align-items:center;'></div>").appendTo(this.linkPenStateContainer);
            this.detailsBtn = $("<div style='width:0.65rem;height:0.32rem;border:1px solid #CF000F;border-radius:0.16rem;color:#CF000F;font-size:0.12rem;font-weight:500;display:flex;justify-content:center;align-items:center;'>详情</div>").appendTo(linkBtnContainer);
            
            //给详情按钮绑定点击事件
            this.detailsBtn.bind("click",this,this._detailsBtn);
        },
        //生成ios和安卓手机通用未连接状态原生
        _generate:function(){
            this.iosStateContainer = $("<div style='width:100%;height:100%;border-radius:0.1rem;display:flex;flex-direction:row;justify-content:space-between;'></div>").appendTo(this.maxContainer);
            var stateContainer = $("<div style='height:100%;display:flex;flex-direction:column;margin-left:0.15rem;'></div>").appendTo(this.iosStateContainer);
            this.penNames = $("<span style='font-size:0.18rem;font-weight:800;color:#000;margin-top:0.1rem;'>蓝牙笔</span>").appendTo(stateContainer);
            $("<div style='height:0.3rem;display:flex;flex-direction:row;align-items:center;'><img style='width:0.12rem;height:0.12rem;' src='../djcommon/img/note/link_status_0.png'/><span style='font-size:0.12rem;color:#666;font-weight:500;margin-left:0.1rem;'>未连接</span></div>").appendTo(stateContainer);
            var linkBtnContainer = $("<div style='height:100%;display:flex;flex-direction:row;margin-right:0.15rem;align-items:center;'></div>").appendTo(this.iosStateContainer);
            this.linkBtn = $("<div style='width:0.65rem;height:0.32rem;border:1px solid #CF000F;border-radius:0.16rem;color:#CF000F;font-size:0.12rem;font-weight:500;display:flex;justify-content:center;align-items:center;pointer-events:none;opacity:0.5;'>连接</div>").appendTo(linkBtnContainer);
            //给ios手机连接按钮绑定点击事件
            this.linkBtn.bind("click",this,this._bluetoothPenBtn);
        },
        //点击蓝牙笔图标
        _bluetoothPenBtn:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("RETRIEVAL_BLUETOOTH_PEN_BTN_CLICK");//抛出检索蓝牙笔事件
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //点击有线笔图标
        _wiredPenBtn:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("RETRIEVAL_WIRED_PEN_BTN_CLICK");//抛出检索有线笔事件
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //点击连接成功的详情按钮
        _detailsBtn:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("PEN_LINH_BTN_CLICK");//抛出笔连接详情按钮
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //改变当前笔的连接状态方法 changeState(1,{"numm":"79","penName":"张三的笔"});
        changeState:function(obj){
            var u = navigator.userAgent;
            if(parseInt(obj.type) == 1){//判读是否是连接状态
                if(this.options.isLinkPen){//判断是否开始了安卓手机显示有线笔
                    if(u.indexOf('Android') > -1 || u.indexOf('Linux') > -1){//判断当前是什么设备
                        this.androidStateContainer.css("display","none");//隐藏安卓有线笔未连接状态
                    }else{
                        this.iosStateContainer.css("display","none");//隐藏ios和安卓通用未连接状态
                    }
                }else{
                    this.iosStateContainer.css("display","none");//隐藏ios和安卓通用未连接状态
                }
                this.penName.html(obj.penData.penName);//赋值当前连接的笔名称
                this.linkPenStateContainer.css("display","flex");//显示安卓和ios通用连接状态
                this.electricContainer.css("display","flex");//显示连接电量和电量图标
                //判断是否传入了电量
                if(obj.penData.numm != undefined && obj.penData.numm != null && obj.penData.numm != ""){
                    if(parseInt(obj.penData.numm) == -1){
                        this.electricContainer.children("p").html("电量：获取中...");
                        return;
                    }
                    this.electricContainer.children("p").html("电量：" + obj.penData.numm +"%");
                    //判断当前电量改变电池图标
                    if(parseInt(obj.penData.numm) >= 80){
                        this.electricContainer.children("img").attr("src","../djcommon/img/note/power_full.png");
                    }else if(parseInt(obj.penData.numm) <= 80 && parseInt(obj.penData.numm) >= 50){
                        this.electricContainer.children("img").attr("src","../djcommon/img/note/power_icon.png");
                    }else if(parseInt(obj.penData.numm) <= 50 && parseInt(obj.penData.numm) >= 20){
                        this.electricContainer.children("img").attr("src","../djcommon/img/note/power_middle.png");
                    }else if(parseInt(obj.penData.numm) <= 20 && parseInt(obj.penData.numm) >= 0){
                        this.electricContainer.children("img").attr("src","../djcommon/img/note/power_low.png");
                    }
                }else{
                    alert("请传入电量信息...");
                }
            }else{
                //判断当前是否开启了安卓手机有线笔
                if(this.options.isLinkPen){
                    if(u.indexOf('Android') > -1 || u.indexOf('Linux') > -1){//判断当前是什么设备
                        this.androidStateContainer.css("display","flex");//显示安卓有线笔未连接状态
                    }else{
                        this.iosStateContainer.css("display","flex");//显示未连接状态
                    }
                }else{
                    this.iosStateContainer.css("display","flex");//显示未连接状态
                }
                this.linkPenStateContainer.css("display","none");//隐藏安卓和ios通用连接状态
                this.electricContainer.css("display","none");//隐藏连接电量和电量图标
                this.penName.html("蓝牙笔");//改变已连接笔名称
                this.penNames.html("蓝牙笔");//改变未连接笔名称
                this.detailsBtn.css({"pointer-events":"","opacity":""});//解锁详情按钮
            }
        },
        //改变已笔名称方法
        changeConnectPenName:function(text){
            this.penName.html(text);//赋值当前连接的笔名称
        },
        //改变未连接状态名称方法
        changePenName:function(text){
            this.penNames.html(text);
        },
        //改变电量信息方法
        changeElectric:function(numm){
            this.electricContainer.children("p").html("电量："+numm+"%");
            //判断当前电量改变电池图标
            if(parseInt(numm) >= 80){
                this.electricContainer.children("img").attr("src","../djcommon/img/note/power_full.png");
            }else if(parseInt(numm) <= 80 && parseInt(numm) >= 50){
                this.electricContainer.children("img").attr("src","../djcommon/img/note/power_icon.png");
            }else if(parseInt(numm) <= 50 && parseInt(numm) >= 20){
                this.electricContainer.children("img").attr("src","../djcommon/img/note/power_middle.png");
            }else if(parseInt(numm) <= 20 && parseInt(numm) >= 0){
                this.electricContainer.children("img").attr("src","../djcommon/img/note/power_low.png");
            }
        },
        //解锁连接按钮
        lockoutConnectBtn:function(){
            this.linkBtn.css({"pointer-events":"","opacity":""});//解锁连接按钮
        },
        //锁定详情按钮 
        lockingDetailsBtn:function(){
            this.detailsBtn.css({"pointer-events":"none","opacity":"0.5"});//解锁详情按钮
        },
        //解锁详情按钮
        lockoutDetailsBtn:function(){
            this.detailsBtn.css({"pointer-events":"","opacity":""});//解锁详情按钮
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});