/*
*   2020年12月3日
*   
*   智能笔cell组件
*
*   开发者：薛原 
*/
define(["Cell","BaseBtn"],function(){
	var startX;
	var ismoving = false;
	var baseElementPosX = [];
    $.widget("ys.PenCell",$.ys.Cell,{
        //默认参数
        options:{},
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
			this.options.isEnable = true;
			this.setWidth("100%");
			this.setHeight("65px");
			this.element.css("background","#ffffff");
			if(typeof(this.options.nearLinkTime) != "undefined"){
				this.setHeight("93px");
			}
			var u = navigator.userAgent;
			if(u.indexOf('Android') > -1 || u.indexOf('Linux') > -1){
				this.element.attr("data-mac",this.options.mac);
			}else{
				this.element.attr("data-mac",(!!!this.options.snAddr) ? this.options.mac : this.options.snAddr);
			}
			
			this.css("position","relative");
			this.element.addClass("pen-cell");
			if(typeof(this.options.noNeedBorderTop) != "undefined" && this.options.noNeedBorderTop == true){
			}else{
				this.element.css("border-top","1px solid #EAEFF2");
			}
			this.element.attr("mode","default");
			
			var mainText = $("<div class='mainText'></div>").Label({"text":this.options.name,"fontSize":"16px","fontWeight":"600"});
			mainText.css("position","absolute");
			mainText.Label("setLeft","15px");
			mainText.Label("setTop","10px");
			this.element.append(mainText);
			

			if(u.indexOf('Android') > -1 || u.indexOf('Linux') > -1){
				var secText = $("<div class='secText'></div>").Label({"text":this.options.mac,"fontSize":"12px","color":"#999999"});
			}else{
				var secText = $("<div class='secText'></div>").Label({"text":  (!!!this.options.snAddr) ? this.options.mac : this.options.snAddr,"fontSize":"12px","color":"#999999"});
			}
			
			secText.css("position","absolute");
			secText.Label("setLeft","15px");
			secText.Label("setTop","41px");
			this.element.append(secText);
			if(typeof(this.options.nearLinkTime) != "undefined"){
				var date = new Date();
				date.setTime(this.options.nearLinkTime);
				var year = date.getFullYear();
				var month = date.getMonth();
				month = month+1<10?"0"+(month+1):month+1;
				var date = date.getDate();
				date = date<10?"0"+date:date;
				var thrText = $("<div class='thrText'></div>").Label({"text":"最近连接："+year+"-"+month+"-"+date,"fontSize":"12px","color":"#666666"});
				thrText.css("position","absolute");
				thrText.Label("setLeft","15px");
				thrText.Label("setBottom","10px");
				this.element.append(thrText);
			}
			
			
			
			if( typeof(this.options.style) != "undefined" && this.options.style == "red"){
				var bindBtn = $("<div class='linkBtn'></div>").BaseBtn({"text":this.options.labelText?this.options.labelText:"连接","width":"80px","height":"32px","fontSize":"12px","textColor":"#ffffff","noNeedAutoUnlock":true});
				bindBtn.BaseBtn("changeBgColor","linear-gradient(90deg, #CF000F 0%, #E50414 100%)");
			}else{
				var bindBtn = $("<div class='linkBtn'></div>").BaseBtn({"text":this.options.labelText?this.options.labelText:"连接","width":"80px","height":"32px","fontSize":"12px","textColor":"#000000","noNeedAutoUnlock":true});
				bindBtn.css("border","1px solid #DCDCDC");
			}
			bindBtn.css("border-radius","3rem");
			bindBtn.css("position","absolute");
			bindBtn.BaseBtn("setRight","15px");
			if(typeof(this.options.nearLinkTime) != "undefined"){
				bindBtn.BaseBtn("setTop","29px");
			}else{
				bindBtn.BaseBtn("setTop","17px");
			}
			this.element.append(bindBtn);
			bindBtn.bind("BTN_CLICK",this,this.onBtnClick);
			var that = this;
			if(this.options.needDelete){ //需要侧滑删除功能
			    var delBtn = $("<div class='delete'></div>").BaseBtn({"text":"删除","height":"65px","bgColor":"red","textColor":"#ffffff","width":"65px"});
				delBtn.bind("BTN_CLICK",this,this.onDelBtnClick);
				delBtn.BaseBtn("hideText");
				delBtn.css("position","absolute");
				delBtn.BaseBtn("setRight","-65px");
				this.element.append(delBtn);
				this.element.bind("touchstart",function(e){
					if($(e.target).html() == "连接"){
						that.options.isEnable = false;
					}
					var _touch = e.originalEvent.targetTouches[0];
   					var _x= _touch.pageX;
					startX = _x;
					if(baseElementPosX.length == 0){
						that.element.find("*").each(function(){
							baseElementPosX.push($(this).offset().left);
						});
					}
				})
				this.element.bind("touchmove",function(e){
					if(that.options.isEnable == false){
						return;
					}
					if(ismoving){
						return;
					}
					if(typeof(that.options.style) != "undefined" && that.options.style == "red"){
						return;
					}
					var _touch = e.originalEvent.targetTouches[0];
   					var _x= _touch.pageX;
					//console.log(_x-startX);
					if(_x-startX < -50){ //左划
					    ismoving = true;
						that.element.trigger("ENTER_DELETE_MODE");
						that.element.find("*").each(function(index){
							$(this).animate({"left":baseElementPosX[index] - 65 +"px"},200,function(){
						        ismoving = false;
								that.element.attr("mode","delete");
								delBtn.BaseBtn("showText");
							});
						});
					}else if(_x-startX > 20){ //右划
						ismoving = true;
						that.element.find("*").each(function(index){
							$(this).animate({"left":baseElementPosX[index]},65,function(){
								ismoving = false;
								that.element.attr("mode","default");
								delBtn.BaseBtn("hideText");
							});
						});
					}
				})
			}
		},
		//退出删除模式
		cancelDeleteMode:function(){
			if(!this.options.needDelete){
				return;
			}
			if(this.element.attr("mode") == "default"){
				return;
			}
			ismoving = true;
			var that = this;
			this.element.find("*").each(function(index){
				$(this).animate({"left":baseElementPosX[index]},65,function(){
					ismoving = false;
					that.element.attr("mode","default");
					that.element.find(".delete").BaseBtn("hideText");
				});
			});
		},
		setToDefault:function(){
			this.options.style = null;
			try{
				this.element.find(".linkBtn").css("border","1px solid #DCDCDC");
				this.element.find(".linkBtn").BaseBtn("changeText","连接");
				this.element.find(".linkBtn").BaseBtn("changeTextColor","#000000");
				this.element.find(".linkBtn").BaseBtn("changeBgColor","#ffffff");
			}catch(e){
				alert(e);
			}
		},
		setToLinked:function(){
			this.options.style = "red";
			try{
				this.element.find(".linkBtn").css("border","0");
				this.element.find(".linkBtn").BaseBtn("changeText","断开连接");
				this.element.find(".linkBtn").BaseBtn("changeTextColor","#ffffff");
				this.element.find(".linkBtn").BaseBtn("changeBgColor","linear-gradient(90deg, #CF000F 0%, #E50414 100%)");
			}catch(e){
				alert(e);
			}
		},
		getStyleStatus:function(){
			return this.options.style;
		},
		onDelBtnClick:function(e){
			e.data.element.trigger("DELETE_BTN_CLICK",e.data.options);
		},
		setBtnDisable:function(){
			this.cancelDeleteMode();
			this.options.isEnable = false;
			this.element.find(".linkBtn").BaseBtn("setDisable");
		},
		setBtnEnable:function(){
			this.options.isEnable = true;
			this.element.find(".linkBtn").BaseBtn("setEnable");
		},
		setBtnText:function(text){
			this.element.find(".linkBtn").BaseBtn("changeText",text);
		},
		//按钮被点击
		onBtnClick:function(e){
			e.data.element.trigger("CELL_BTN_CLICK",e.data.options);
		},
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});