/*
*   2020年12月2日
*   
*   笔状态容器插件
*
*   开发者：薛原 
*/
define(["Panel","Label","Img",'BaseBtn'],function(){
	var status = 0;
	var clickSign = true;
    $.widget("ys.PenStatusPanel",$.ys.Panel,{
        //默认参数
        options:{},
        _maxContainer:null,//最大容器
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
			this.setBorderRadius("10px");
			this.setWidth("345px");
			this.setHeight("76px");
			this.setMarginLeft("30px");
			this.setMarginRight("30px");
            this.element.css({"box-shadow":"0px 2px 14px 2px rgba(0, 0, 0, 0.03)"});
			
			var mainText = $("<div class='mainText'></div>").Label({"text":"蓝牙笔","fontSize":"18px","fontWeight":"800","letterSpacing":"2px"});
			mainText.Label("setLeft","15px");
			mainText.Label("setTop","12px");
			mainText.css("position","absolute");
			this.element.append(mainText);
			
			var linkStatusIcon = $("<div class='linkStatusIcon'></div>").Img({"src":"../djcommon/img/note/link_status_1.png","width":"12px","height":"12px"});
			linkStatusIcon.css("position","absolute");
			linkStatusIcon.Img("setLeft","18px");
			linkStatusIcon.Img("setBottom","17px");
			this.element.append(linkStatusIcon);
			
			var linkStatusLabel = $("<div class='linkStatusLabel'></div>").Label({"text":"未连接","fontSize":"14px"});
			linkStatusLabel.css("position","absolute");
			linkStatusLabel.Label("setLeft","38px");
			linkStatusLabel.Label("setBottom","13px");
			
			linkStatusLabel.Label("setColor","#666666");
			this.element.append(linkStatusLabel);
			
			var line = $("<div class='line'></div>").Panel();
			line.css({"width":"10px","height":"20px","border-left":"1px solid #D2D2D2","position":"absolute"});
			line.Panel("setLeft","92px");
			line.Panel("setBottom","12px");
			this.element.append(line);
			
			var powerIcon = $("<div class='powerIcon'></div>").Img({"src":"../djcommon/img/note/power_icon.png","width":"10px","height":"13px"});
			powerIcon.css("opacity",0);
			powerIcon.css("position","absolute");
			powerIcon.Img("setLeft","110px");
			powerIcon.Img("setBottom","17px");
			this.element.append(powerIcon);
			
			var powerValLabel = $("<div class='powerValLabel'></div>").Label({"text":"电量：获取中...","fontSize":"14px","color":"#666666"});
			powerValLabel.css("position","absolute");
			powerValLabel.Label("setLeft","130px");
			powerValLabel.Label("setBottom","13px");
			this.element.append(powerValLabel);
			
			var detailBtn = $("<div class='detailBtn'></div>").BaseBtn({"text":"详情","width":"60px","height":"32px","fontSize":"13px"});
			detailBtn.css("border-radius","3rem");
			detailBtn.css("border","1px solid #DCDCDC");
			detailBtn.css("position","absolute");
			detailBtn.BaseBtn("setRight","22px");
			detailBtn.BaseBtn("setTop","22px");
			this.element.append(detailBtn);
			detailBtn.bind("BTN_CLICK",this,this.onDetailBtnClick);
			
			var linkBtn = $("<div class='linkBtn'></div>").BaseBtn({"text":"连接","width":"60px","height":"32px","fontSize":"13px","textColor":"#CF000F"});
			linkBtn.css("border-radius","3rem");
			linkBtn.css("border","1px solid #CF000F");
			linkBtn.css("position","absolute");
			linkBtn.BaseBtn("setRight","22px");
			linkBtn.BaseBtn("setTop","22px");
			this.element.append(linkBtn);
			linkBtn.bind("BTN_CLICK",this,this.onLinkBtnClick);
			linkBtn.hide();
			this.changeLinkStatus(0);

        },
		onLinkBtnClick:function(e){
			e.data.element.trigger("LINK_BTN_CLICK");
		},
		//详情按钮点击
		onDetailBtnClick:function(e){
			e.data.element.trigger("DETAIL_BTN_CLICK");
		},
		getStatus:function(){
			return status;
		},
		changeLinkStatusForIos:function(val){
			if(val == 0){
				status = 0;
				this.element.find(".powerIcon").hide();
				this.element.find(".powerValLabel").hide();
				this.element.find(".detailBtn").hide();
				this.element.find(".linkBtn").show();
				this.element.find(".line").hide();
				this.element.find(".linkStatusIcon").Img("setSrc","../djcommon/img/note/link_status_0.png");
				this.element.find(".linkStatusLabel").Label("setText","未连接");
				this.element.find(".mainText").Label("setText","蓝牙笔");
			}else if(val == 1){ 
				status = 1;
				this.element.find(".powerIcon").show();
				this.element.find(".powerValLabel").show();
				this.element.find(".detailBtn").show();
				this.element.find(".linkBtn").hide();
				this.element.find(".line").show();
				this.element.find(".linkStatusIcon").Img("setSrc","../djcommon/img/note/link_status_1.png");
				this.element.find(".linkStatusLabel").Label("setText","已连接");
			}else{
				status = 2;
			}
		},
		//改变连接状态 0已连接 1未连接 2同步中
		changeLinkStatus:function(val){
			var that = this;
			var os;
			try{
				os = api.systemType;
			}catch(e){
				os = "android";
			}
			if(os == "ios"){
				this.changeLinkStatusForIos(val);
				return;
			}
			if(val == 0){
				status = 0;
				this.element.find(".mainText").hide();
				this.element.find(".linkStatusIcon").hide();
				this.element.find(".linkStatusLabel").hide();
				if(this.element.find(".chooseArea").length == 0){
					var chooseArea = $("<div class='chooseArea'><div class='pen-panel' style='float:left;width:50%'><div class='bt' style='float:left'></div><div class='name-pen' style='float:left'></div></div><div class='hasline-panel' style='float:left;width:50%;'><div class='hasline' style='float:left'></div><div class='name-hasline' style='float:left'></div></div><div style='clear:both'></div></div>");
					this.element.append(chooseArea);
					chooseArea.find(".bt").Img({"src":"../djcommon/img/note/bt.png","width":"39px","height":"39px"});
					chooseArea.find(".hasline").Img({"src":"../djcommon/img/note/line.png","width":"39px","height":"39px"});
					chooseArea.find(".name-pen").Label({"text":"蓝牙笔","height":"39px","fontSize":"14px","lineHeight":"39px","marginLeft":"10px"});
					chooseArea.find(".name-hasline").Label({"text":"有线笔","height":"39px","fontSize":"14px","lineHeight":"39px","marginLeft":"10px"});
					chooseArea.find(".pen-panel").bind("click",function(){
						if(!clickSign){
							return;
						}
						clickSign = false;
						setTimeout(function(){
							clickSign = true;
						},2000);
						that.element.find(".linkBtn").trigger("BTN_CLICK");
					});
					chooseArea.find(".hasline-panel").bind("click",function(){
						if(!clickSign){
							return;
						}
						clickSign = false;
						setTimeout(function(){
							clickSign = true;
						},2000);
						that.element.trigger("LINE_BTN_CLICK"); //有线笔连接被点击
					});
					
					chooseArea.find(".pen-panel").Panel();
					chooseArea.find(".pen-panel").Panel("setMarginTop","19px");
					chooseArea.find(".pen-panel").Panel("setPaddingLeft","42px");
					chooseArea.find(".hasline-panel").Panel();
					chooseArea.find(".hasline-panel").Panel("setMarginTop","19px");
					chooseArea.find(".hasline-panel").Panel("setPaddingLeft","42px");
				}
				this.element.find(".chooseArea").show();
				this.element.find(".powerIcon").hide();
				this.element.find(".powerValLabel").hide();
				this.element.find(".detailBtn").hide();
				this.element.find(".linkBtn").hide();
				this.element.find(".line").hide();
				//this.element.find(".linkStatusIcon").Img("setSrc","../djcommon/img/note/link_status_0.png");
				//this.element.find(".linkStatusLabel").Label("setText","未连接");
				//this.element.find(".mainText").Label("setText","党建笔");
			}else if(val == 1){ 
				status = 1;
				this.element.find(".chooseArea").hide();
				this.element.find(".mainText").show();
				this.element.find(".linkStatusIcon").show();
				this.element.find(".linkStatusLabel").show();
				this.element.find(".powerIcon").show();
				this.element.find(".powerValLabel").show();
				this.element.find(".detailBtn").show();
				this.element.find(".linkBtn").hide();
				this.element.find(".line").show();
				this.element.find(".linkStatusIcon").Img("setSrc","../djcommon/img/note/link_status_1.png");
				this.element.find(".linkStatusLabel").Label("setText","已连接");
			}else{
				status = 2;
			}
		},
		hidePowerArea:function(){
			this.element.find(".line").hide();
			this.element.find(".powerIcon").hide();
			this.element.find(".powerValLabel").hide();
		},
		showPowerArea:function(){
			this.element.find(".powerIcon").show();
			this.element.find(".powerValLabel").show();
		},
		//修改主标题文字
        changeMainLabelText:function(text){
			this.element.find(".mainText").Label("setText",text);
		},
		//电量改变
		changePowerVal:function(val){
			$(".powerIcon").css("opacity",1);
			if( parseInt(val.replace("%","")) >= 80 ){
				$(".powerIcon").Img("setSrc","../djcommon/img/note/power_full.png");
			}else if( parseInt(val.replace("%","")) <= 20 ){
				$(".powerIcon").Img("setSrc","../djcommon/img/note/power_low.png");
			}else{
				$(".powerIcon").Img("setSrc","../djcommon/img/note/power_middle.png");
			}
			this.element.find(".powerValLabel").Label("setText","电量："+val);
		},
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});