
/**
 * 弹窗基类
 */
define(["Shell",'Widget',"style"],function(Shell){
	$.widget("ys.Popup",$.ys.Widget,{
		//默认参数
		//初始化，控件生命周期内只运行一次
		_init: function () {
            this._super();
			this._mask = $('<div id="mask" style="position: fixed;top:0;left: 0;right: 0;bottom: 0;background: rgba(0,0,0,.3);z-index:50000;,"transition":"all .3s ease,left .3s ease""></div>');
			if(this.options.maskCss){
				this._mask.style(this.options.maskCss)
            }
            
            this._mask.bind("touchstart",this,this._stopEvent);
            this._mask.bind("touchmove",this,this._stopEvent);
            this._mask.bind("touchend",this,this._stopEvent);
            this._mask.bind("touchcancel",this,this._stopEvent);
            
            this.element.append(this._mask).appendTo('body');

            var that = this;
            if(this.options.disableMaskClick != true){
                this._mask.bind("click",function(){
                    that.element.trigger('MASK_CLICK')
                    that.close();
                });
            }
        },
        _stopEvent:function(e){
			if(e.data && e.data.element && e.data.element.find("input").length > 0){
			}else{
				try {
					e.stopPropagation();
					e.preventDefault();
				} catch (e) {
					console.log('阻止冒泡失败')
				}
			}
        },
        close:function () {
            this.hide()
        },
        open:function () {
            this.show();
        },
        show:function(){
            this._mask.show();
            this.element.show();
            this.element.trigger("POPUP_HIDDEN",{hide:false})
        },
        hide:function(){
            this._mask.hide();
            this.element.hide();
            this.element.trigger("POPUP_HIDDEN",{hide:true})
        },	
		//创建控件，控件生命周期内会运行多次
		_create: function () {},
		// 释放控件
		destroy: function () {
			$.Widget.prototype.destroy.call(this);
		}
	});
})