/*
*   2020年12月16日
*   
*   封装保险箱笔记转文档快捷定位页码组件
*
*   开发者：付长建 
*/
define(["iscroll"],function(iscroll){
    $.widget("ys.QuickPage",{
        //默认参数
        options:{},
        _iscroll:null,//滚动插件 refresh()
        _pageContainer:null,//页码容器
        _pageContent:null,//页码内容容器
        _isClick:true,//是否允许点击页码
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var that = this;
            this.element.css({
                "width":"100%",
                "height":"0.49rem",
                "padding":"0 0.15rem 0 0.15rem",
                "border-top":"1px solid #EAEFF2",
                "border-bottom":"1px solid #EAEFF2",
                "box-sizing":"border-box",
            });
            //创建页码滚动容器
            this._pageContainer = $("<div id='pageContainer' style='width:100%;height:100%;overflow:hidden;'></div>").appendTo(this.element);
            //创建页码内容滚动容器
            this._pageContent = $("<ul style='min-width:"+(this._pageContainer.width() + 1)+"px;height:100%;display:flex;flex-direction:row;align-items:center;flex-wrap:wrap'></ul>").appendTo(this._pageContainer);
            $("<span style='font-size:0.12rem;color:#999;'>快捷定位页码获取中，请稍后...</span>").appendTo(this._pageContent);
            //初始化滚动插件
            this._iscroll = new iscroll("#pageContainer",{
                scrollX:true,  
                scrollY:false, 
                click:that._iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });
        },
        //判读设备函数
        _iScrollClick:function(){
            if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
            if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
            if (/Silk/i.test(navigator.userAgent)) return false;
            if (/Android/i.test(navigator.userAgent)) {
            var s=navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
                return parseFloat(s[0]+s[3]) < 44 ? false : true
            }
        },
        //生成页码方法（参数：页码总数）
        generatePage:function(numm){
            this._pageContent.children("span").remove();
            var page = [];
            for(var i = 1; i <= numm; i++){
                var obj = {};
                var str = i;
                if(i % 15 == 1){
                    obj.inx = str;
                    if((i + 14) <= numm){
                        obj.str = str + " - " + (i + 14);
                    }else{
                        obj.str = str + " - " + numm;
                    }
                    page.push(obj);
                    console.log(obj);
                }
            }  
            for(var i = 0; i < page.length; i++){
                var li = $("<li data='"+page[i].inx+"' style='width:0.7rem;height:0.24rem;font-size:0.12rem;margin-right:0.13rem;box-sizing:border-box;border-radius:0.12rem;display:flex;align-items:center;justify-content:center;background:#EFF0F3;'>"+page[i].str+"</li>").appendTo(this._pageContent);
                if(i == 0){
                    li.css({
                        "border":"1px solid #C82128",
                        "background":"#F4D3D4",
                        "color":"#C82128"
                    });
                }
                if(i == page.length - 1){
                    li.css("margin-right",0);
                }
                //给页码绑定点击事件
                li.bind("click",this,this._pageClick);
            }
            this._pageContent.css("width",this._pageContent.find("li").outerWidth(true) * this._pageContent.find("li").length - 13 + "px");
            this._iscroll.refresh();
        },
        //点击页码
        _pageClick:function(event){
            if(event.data._isClick){
                event.data._pageContent.find("li").css({"border":"","background":"#EFF0F3","color":"#333"});
                $(this).css({"border":"1px solid #C82128","background":"#F4D3D4","color":"#C82128"}); 
                event.data.element.trigger("PAGE_CLICK",$(this).attr("data"));
            }
        },
        //设置允许页码点击方法
        allowClick:function(type){
            if(type == "yes"){
                this._isClick = true;
            }else{
                this._isClick = false;
            }
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});