/*
*   2021年3月31日
*   
*   封装云笔记首页检索笔组件
*
*   开发者：付长建 
*/
define(["Shell","iscroll","NewPenCell"],function(Shell,iscroll){
    $.widget("ys.SearchPenState",{
        //默认参数
        options:{},
        iscroll:null,//滚动容器
        time:null,//倒计时
        isClick:true,//控制连续触发点击事件方法
        isCancel:true,//是否抛出取消搜索事件
        penType:1,//当前是蓝牙笔还是有线笔
        isGenerate:true,//这个参数主要控制在倒计时刚刚为0得时候突然检测到笔数据或者在刚刚点击了暂不连接原生还未收到取消检索事件突然返回笔信息突然生成笔列表
        linkPenData:null,//检测到的有线笔数据
        penData:[],//当前列表有的笔数据
        isStop:true,//是否需要给原生发送停止扫描
        isBordenrTop:true,//搜索列表第一个不需要上边框
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            var pad = (phonexh("top") + 20) / 100 + "rem";
            this.element.css({
                "z-index":"-1",
                "width":"100%",
                "position":"fixed",
                "top":"0px",
                "left":"0px",
                "height":$(window).height() - phonexh("bottom") + "px",
                "box-sizing":"border-box",
            });
            //创建头部检测笔信息容器
            this.penInformationContainer = $("<div style='width:100%;padding:"+pad+" 0.15rem 0.45rem 0.15rem;box-sizing:border-box;box-shadow:0px 1px 0.1rem 1px rgba(0,0,0,0.03);background:#fff;display:flex;flex-direction:row;transition:all 0.3s;'></div>").appendTo(this.element);
            //创建笔图标元素
            this.penImgContainer = $("<div style='width:0.9rem;height:0.9rem;border-radius:50%;margin-top:0.1rem;overflow:hidden;'></div>").appendTo(this.penInformationContainer);
            $("<img style='width:100%;height:100%;' src='../djcommon/img/note/bt.png'/>").appendTo(this.penImgContainer);
            //创建状态信息容器
            var stateInformation = $("<div style='width:"+(this.penInformationContainer.width() - this.penImgContainer.width() - 20)+"px;margin-left:18px;'></div>").appendTo(this.penInformationContainer);
            //创建搜索标题文本和搜索倒计时元素
            this.searchTieleTimeContainer = $("<div style='display:flex;flex-direction:row;justify-content:space-between;align-items:center;'></div>").appendTo(stateInformation);
            $("<p style='font-size:0.2rem;color:#000;font-weight:800;'>搜索设备中...</p>").appendTo(this.searchTieleTimeContainer);
            $("<span style='font-size:0.14rem;color:#666;font-weight:500;'>60s</span>").appendTo(this.searchTieleTimeContainer);
            //创建搜索提示永远文本信息 
            this.searchText = $("<p style='font-size:0.14rem;font-weight:500;color:#666;margin:0.1rem 0 0.13rem 0;'>确保手机与笔进行连接，绿灯闪烁</p>").appendTo(stateInformation);
            //创建蓝牙重新搜索和暂不连接按钮容器（这个主要是蓝牙笔使用）
            this.againNotBtnContainer = $("<div style='display:flex;flex-direction:row;'></div>").appendTo(stateInformation);
            $("<div style='width:0.74rem;height:32px;margin-right:15px;text-align:center;line-height:31px;background:linear-gradient(-90deg,#CF000F,#E50414);border-radius:16px;font-size:12px;font-weight:bold;color:#fff;display:none;transition:all 0.3s;opacity:0;'>重新搜索</div>").appendTo(this.againNotBtnContainer);
            $("<p style='width:0.74rem;height:32px;font-size:12px;font-weight:bold;color:#999;text-align:center;line-height:31px;border:1px solid #999;border-radius:16px;'>暂不连接</p>").appendTo(this.againNotBtnContainer);
            //创建有线笔重新搜索和暂不连接和连接按钮容器（这个主要是有线笔使用）
            this.againNotBtnLinkContainer = $("<div style='display:none;flex-direction:row;'></div>").appendTo(stateInformation);
            $("<div style='width:0.74rem;height:32px;margin-right:15px;text-align:center;line-height:31px;background:linear-gradient(-90deg,#CF000F,#E50414);border-radius:16px;font-size:12px;font-weight:bold;color:#fff;transition:all 0.3s;opacity:0;display:none;'>重新搜索</div>").appendTo(this.againNotBtnLinkContainer);
            $("<span style='display:none;width:0.74rem;height:32px;margin-right:15px;text-align:center;line-height:31px;background:linear-gradient(-90deg,#CF000F,#E50414);border-radius:16px;font-size:12px;font-weight:bold;color:#fff;transition:all 0.3s;opacity:0;'>连接</span>").appendTo(this.againNotBtnLinkContainer);
            $("<p style='width:0.74rem;height:32px;font-size:12px;font-weight:bold;color:#999;text-align:center;line-height:31px;border:1px solid #999;border-radius:16px;'>暂不连接</p>").appendTo(this.againNotBtnLinkContainer);
            this.penInformationContainer.css("transform","translateY(-"+this.penInformationContainer.outerHeight(true) + 2 +"px)");
            
            //创建搜索到笔的容器 
            this.searchPenContainer = $("<div data='1' style='width:100%;background:#fff;transition:all 0.3s;opacity:0;display:none;'></div>").appendTo(this.element);
            //创建滚动iscroll容器
            this.iscrollContainer = $("<div id='iscrollContainer' style='width:100%;overflow:hidden;'></div>").appendTo(this.searchPenContainer);
            this.iscrollContent = $("<ul style='width:100%;'></ul>").appendTo(this.iscrollContainer);
            //创建底部关闭按钮（表示暂不连接）元素
            this.closeImg = $("<div style='width:100%;height:1rem;display:flex;align-items:center;justify-content:center;'></div>").appendTo(this.searchPenContainer);
            $("<div class='img' style='width:0.32rem;position:relative;top:-0.1rem;'><img style='width:0.32rem;position:relative;top:-0.1rem;' src='../djcommon/img/note/pop-close.png'/></div>").appendTo(this.closeImg);
            //初始化滚动插件
            var that = this;
            this.iscroll = new iscroll("#iscrollContainer",{
                click:that._iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });

            //给蓝牙连接状态下的暂不链接绑定点击事件
            this.againNotBtnContainer.children("p").bind("click",this,this._notBtnClick);
            //给有线笔连接状态下的暂不链接绑定点击事件
            this.againNotBtnLinkContainer.children("p").bind("click",this,this._notBtnClick);
            //给蓝牙连接状态下的重新搜索绑定点击事件
            this.againNotBtnContainer.children("div").bind("click",this,this._againBtnClick);
            //给有线笔连接状态下的暂不链接绑定点击事件
            this.againNotBtnLinkContainer.children("div").bind("click",this,this._againBtnClick);
            //给搜索出来的笔列表容器的关闭按钮绑定点击事件 
            this.closeImg.children(".img").bind("click",this,this._notBtnClick);
            //给蓝牙笔的连接按钮绑定点击事件
            this.againNotBtnLinkContainer.children("span").bind("click",this,this._linkConnectClick);
            //监听列表cell组件抛出的按钮被点击事件 
            this.iscrollContent.bind("LINK_BTN_CLICK",this,this._linkCellClick);
        },
        //判读设备函数（主要解决点击事件失效问题）
        _iScrollClick:function(){
            if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
            if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
            if (/Silk/i.test(navigator.userAgent)) return false;
            if (/Android/i.test(navigator.userAgent)) {
            var s = navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
                return parseFloat(s[0]+s[3]) < 44 ? false : true
            }
        },
        //显示头部连接状态信息方法(1是蓝牙笔2是有线笔)
        show:function(type){
            this.penType = type;
            this.element.css("z-index","2");
            this.searchTieleTimeContainer.children("span").css("display","").html("60s");
            //判断是有线笔还是蓝牙笔
            if(parseInt(type) == 1){
                this.penImgContainer.find("img").attr("src","../djcommon/img/note/bt.png");
                this.searchText.html("请打开智能笔，确保绿灯闪烁").css("display","");
                this.againNotBtnLinkContainer.css("display","none");
                this.againNotBtnContainer.css("display","flex");
                this.againNotBtnContainer.children("div").css("display","none");
            }else{
                this.penImgContainer.find("img").attr("src","../djcommon/img/note/zhangyibi.png");
                this.searchText.html("确保手机与笔进行连接，绿灯闪烁").css("display","");
                this.againNotBtnContainer.css("display","none");
                this.againNotBtnLinkContainer.css("display","flex");
                this.againNotBtnLinkContainer.children("div").css("display","none");
                this.againNotBtnLinkContainer.children("span").css("display","none");
            }
            this.searchTieleTimeContainer.children("p").html("搜索设备中...");
            this.penInformationContainer.css("transform","translateY(0px)");
            this.isGenerate = true;
            this.isCancel = true;
            this.isStop = true;
            var timeNumm = 60;
            try{
                Shell.sendEvent("lockTabBar",{"lock":true});//锁定底部导航
            }catch(e){}
            //开启倒计时
            this.time = setInterval(function(that){
                if(timeNumm > 1){
                    timeNumm -- 
                    that.searchTieleTimeContainer.children("span").html(timeNumm + "s");
                }else{
                    that.isGenerate = false;
                    that.isCancel = false;
                    that.isStop = false;
                    timeNumm -- 
                    that.searchTieleTimeContainer.children("span").html(timeNumm + "s");
                    clearInterval(that.time);
                    //判断是否检测到数据
                    if(parseInt(that.searchPenContainer.attr("data")) == 2){
                        that.searchTieleTimeContainer.children("p").html("已找到"+that.iscrollContent.find("li").length+"个设备");
                        that.searchText.html("请确认笔身的ID码").css("display","");
                        that.penImgContainer.find("img").attr("src","../djcommon/img/note/mac.png");
                    }else{
                        that.searchTieleTimeContainer.children("p").html("未找到设备");
                    }
                    if(parseInt(type) == 1){
                        that.againNotBtnContainer.children("div").css("display","");
                        setTimeout(function(){
                            that.againNotBtnContainer.children("div").css("opacity",1);
                        },10);
                    }else{
                        that.againNotBtnLinkContainer.children("div").css("display","");
                        setTimeout(function(){
                            that.againNotBtnLinkContainer.children("div").css("opacity",1);
                        },10);
                    }
                    setTimeout(function(){
                        that.searchTieleTimeContainer.children("span").css("display","none");
                    },300);
                    that.element.trigger("CANCEL_SEARCH_PEN",type);//抛出取消搜索事件 参数type主要是区分当前是蓝牙笔还是无线笔
                }
            },1000,this);
            setTimeout(function(that){
                that.element.trigger("SEARCH_PEN_STATE_SHOW",type);//抛出搜索笔状态显示事件 参数type主要是区分当前是蓝牙笔还是无线笔
            },500,this);
        },
        //隐藏搜索笔组件
        hide:function(){
            if(this.isClick){
                this.isClick = false;
                this.isGenerate = false;
                this.isBordenrTop = true;
                this.penData = [];
                clearInterval(this.time);
                this.penInformationContainer.css("transform","translateY(-"+(this.penInformationContainer.outerHeight(true) + 2)+"px)");
                //判断是否显示了列表容器
                if(parseInt(this.searchPenContainer.attr("data")) == 2){
                    this.searchPenContainer.css("opacity","0");
                    this.searchPenContainer.attr("data","1");
                    try{
                        Shell.sendEvent("hideTabBar",{"hide":false});//显示底部的导航
                    }catch(e){}
                    setTimeout(function(that){
                        if(global.deviceType == "android"){
                            that.element.css("height",(that.element.height() - 49) + "px");
                        }
                        that.searchPenContainer.css("display","none");
                    },300,this);
                }
                setTimeout(function(that){
                    try{
                        Shell.sendEvent("lockTabBar",{"lock":false});//解锁底部导航
                    }catch(e){}
                    that.element.css("z-index","-1");
                    if(that.isCancel){
                        that.element.trigger("CANCEL_SEARCH_PEN",that.penType);//抛出取消搜索事件 参数type主要是区分当前是蓝牙笔还是无线笔
                    }
                    that.isClick = true;
                },500,this);
            }
        },
        //权限没有开启
        equipmentError:function(){
            clearInterval(this.time);
            this.searchTieleTimeContainer.children("p").html("请确认是否已开启蓝牙及定位权限");
            this.searchTieleTimeContainer.children("span").css("display","none");
            this.searchText.css("display","none");
            //判断是有线笔还是蓝牙笔
            if(parseInt(this.penType) == 1){
                this.againNotBtnContainer.css("margin-top","0.15rem");
                this.againNotBtnContainer.children("div").css("display","");
                setTimeout(function(that){
                    that.againNotBtnContainer.children("div").css("opacity","1");
                },10,this);
                //判断是否显示了列表容器
                if(parseInt(this.searchPenContainer.attr("data")) == 2){
                    this.searchPenContainer.attr("data","1");
                    setTimeout(function(that){
                        that.searchPenContainer.css("display","none");
                    },300,this);
                    try{
                        Shell.sendEvent("hideTabBar",{"hide":false});//隐藏底部的导航
                    }catch(e){}
                }
            }else{
                this.againNotBtnLinkContainer.css("margin-top","0.15rem");
                this.againNotBtnLinkContainer.children("div").css("display","");
                setTimeout(function(that){
                    that.againNotBtnLinkContainer.children("div").css("opacity","1");
                },10,this);
            }
        },
        //点击了暂不链接方法
        _notBtnClick:function(event){
            event.data.hide();//调用隐藏搜索笔组件
        },
        //点击重新搜索方法
        _againBtnClick:function(event){
            if(event.data.isClick){
                event.data.iscrollContent.children("li").remove();//清空已有列表
                event.data.iscroll.refresh();//刷新高度
                event.data.iscroll.scrollTo(0,0);//滚动到指定位置
                event.data.isClick = false;
                event.data.searchTieleTimeContainer.children("p").html("搜索设备中...");
                event.data.searchTieleTimeContainer.children("span").css("display","").html("60s");
                event.data.penImgContainer.find("img").attr("src","../djcommon/img/note/bt.png");
                event.data.againNotBtnContainer.css("margin-top","");
                event.data.againNotBtnLinkContainer.css("margin-top","");
                event.data.isGenerate = true;
                event.data.isCancel = true;
                event.data.isStop = true;
                event.data.penData = [];
                //判断当前是蓝牙笔搜索还是有线笔搜索
                if(parseInt(event.data.penType) == 1){
                    event.data.againNotBtnContainer.children("div").css("opacity",0);
                    event.data.searchText.html("请打开智能笔，确保绿灯闪烁").css("display","");
                    setTimeout(function(){
                        event.data.againNotBtnContainer.children("div").css("display","none");
                    },350);
                }else{
                    event.data.againNotBtnLinkContainer.children("div").css("opacity",0);
                    event.data.searchText.html("确保手机与笔进行连接，绿灯闪烁").css("display","");
                    setTimeout(function(){
                        event.data.againNotBtnLinkContainer.children("div").css("display","none");
                    },350);
                }
                clearInterval(event.data.time);
                var timeNumm = 60;
                event.data.time = setInterval(function(){
                    if(timeNumm > 1){
                        timeNumm --;
                        event.data.searchTieleTimeContainer.children("span").html(timeNumm + "s");
                    }else{
                        timeNumm --;
                        event.data.isGenerate = false;
                        event.data.isCancel = false;
                        event.data.isStop = false;
                        event.data.searchTieleTimeContainer.children("span").html(timeNumm + "s");
                        clearInterval(event.data.time);
                        //判断是否检测到数据
                        if(parseInt(event.data.searchPenContainer.attr("data")) == 2){
                            event.data.searchTieleTimeContainer.children("p").html("已找到"+event.data.iscrollContent.find("li").length+"个设备");
                            event.data.searchText.html("请确认笔身的ID码").css("display","");
                            event.data.penImgContainer.find("img").attr("src","../djcommon/img/note/mac.png");
                        }else{
                            event.data.searchTieleTimeContainer.children("p").html("未找到设备");
                        }
                        if(parseInt(event.data.penType) == 1){
                            event.data.againNotBtnContainer.children("div").css("display","");
                            setTimeout(function(){
                                event.data.againNotBtnContainer.children("div").css("opacity",1);
                            },10);
                        }else{
                            event.data.againNotBtnLinkContainer.children("div").css("display","");
                            setTimeout(function(){
                                event.data.againNotBtnLinkContainer.children("div").css("opacity",1);
                            },10);
                        }
                        setTimeout(function(){
                            event.data.searchTieleTimeContainer.children("span").css("display","none");
                        },300);
                        event.data.element.trigger("CANCEL_SEARCH_PEN",event.data.penType);//抛出取消搜索事件 参数type主要是区分当前是蓝牙笔还是无线笔
                    }
                },1000);
                setTimeout(function(){
                    event.data.iscroll.refresh();//刷新高度
                    event.data.iscroll.scrollTo(0,0);//滚动到指定位置
                    event.data.element.trigger("AGAIN_SEARCH_PEN",event.data.penType);//抛出重新搜索事件 参数type主要是区分当前是蓝牙笔还是无线笔
                    event.data.isClick = true;
                },500);
            }
        },
        //蓝牙笔添加检索到笔列表方法
        addPenData:function(dataArray){
            //判断是否还要在生成数据
            if(this.isGenerate){
                //判断是否有数据
                if(dataArray.length > 0){
                    //判断显示检索到的笔列表最大容器是否显示
                    if(parseInt(this.searchPenContainer.attr("data")) == 1){
                        this.searchPenContainer.attr("data","2");
                        this.searchPenContainer.css("display","");
                        try{
                            Shell.sendEvent("hideTabBar",{"hide":true});//隐藏底部的导航
                        }catch(e){}
                        setTimeout(function(that){
                            that.searchPenContainer.css("opacity","1");
                            //判断设备
                            if(global.deviceType == "android"){
                                that.element.css("height",(that.element.height() + 49) + "px");
                            }
                            that.searchPenContainer.css("height",(that.element.height() - that.penInformationContainer.outerHeight(true) + phonexh("bottom")) + "px");
                            that.iscrollContainer.css("height",(that.searchPenContainer.height() - that.closeImg.height()) + "px");
                            that.iscrollContent.css("min-height",that.iscrollContainer.height() + 1 + "px");
                        },50,this);
                    }
                    this.penData = this._duplicate(this.penData.concat(dataArray));//调用数组去重方法
                    this.iscrollContent.find("li").remove();
                    //循环生成数据
                    for(var i = 0; i < this.penData.length; i++){
                        var time = $("<li penId='"+this.penData[i].macAddress+"' style='width:100%;padding:0 0.15rem 0 0.15rem;border-top:1px solid #EAEFF2;box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-between;'></li>").appendTo(this.iscrollContent);
                        time.NewPenCell({"data":this.penData[i]});
                    }
                    //获取缓存数据看看是否有连接过的数据
                    var cacheConnectData = JSON.parse(localStorage.getItem("connectData"));
                    if(cacheConnectData != undefined && cacheConnectData != null && cacheConnectData != ""){
                        this.iscrollContent.prepend($("[penId='"+cacheConnectData.macAddress+"']"));
                        $("[penId='"+cacheConnectData.macAddress+"']").children("div").eq(0).children("p").css("margin-bottom","0.06rem");
                        $("[penId='"+cacheConnectData.macAddress+"']").children("div").eq(0).append("<span style='font-size:12px;color:#666;font-weight:500;margin-bottom:0.1rem;'>本设备最近连接记录："+cacheConnectData.connectTime+"</span>");
                    }
                    this.iscroll.refresh();//刷新高度
                    this.iscroll.scrollTo(0,this.iscroll.maxScrollY,300);//滚动到指定位置
                }
            }
        },
        //数组去重方法
        _duplicate:function(dataArray){
            var arr = [];//存id
            var newArr = [];//存新数组
            for(var i = 0; i < dataArray.length; i++){
                if(arr.indexOf(dataArray[i].macAddress) == -1){
                    arr.push(dataArray[i].macAddress);
                    newArr.push(dataArray[i]);
                }
            }
            return newArr;
        },
        //有线笔检测到笔方法
        getLink:function(obj){
            //判断是否要改变状态，如果是倒计时进入0秒才检测出来就不需要在改变状态了让用户再次检索
            if(this.isGenerate){
                clearInterval(this.time);
                this.linkPenData = obj;
                this.searchTieleTimeContainer.children("p").html("检测到当前设备");
                this.searchTieleTimeContainer.children("span").css("display","none");
                this.searchText.html("PID：" + obj.mac);
                this.againNotBtnLinkContainer.children("div").css("display","none");
                this.againNotBtnLinkContainer.children("span").css("display","inline-block");
                setTimeout(function(that){
                    that.againNotBtnLinkContainer.children("span").css("opacity",1);
                },10,this);
            }
        },
        //当点击有线笔的连接按钮
        _linkConnectClick:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.againNotBtnLinkContainer.children("span").css({"pointer-events":"none","opacity":"0.5"});
                event.data.againNotBtnLinkContainer.children("p").css({"pointer-events":"none","opacity":"0.5"});
                event.data.element.trigger("LINL_CONNECT_CLICK",event.data.linkPenData);//抛出有线笔连接事件
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //有线笔连接失败
        linkConnectError:function(){
            this.againNotBtnLinkContainer.children("span").css({"pointer-events":"","display":"none","opacity":0});
            this.againNotBtnLinkContainer.children("p").css({"pointer-events":"","opacity":""});
            this.againNotBtnLinkContainer.children("div").css({"display":"","opacity":1});
        },
        //当点击了cell组件的连接按钮
        _linkCellClick:function(event,obj){
            clearInterval(event.data.time);
            event.data.isGenerate = false;//拒绝在次加载数据
            event.data.iscroll.enabled = false;//禁止滚动容器刷新
            event.data.searchTieleTimeContainer.children("p").html("已找到"+event.data.iscrollContent.find("li").length+"个设备");
            event.data.searchText.html("请确认笔身的ID码");
            event.data.penImgContainer.find("img").attr("src","../djcommon/img/note/mac.png");
            event.data.searchTieleTimeContainer.children("span").css("display","none");
            event.data.iscrollContent.find("li").NewPenCell("locking");//锁定所有笔列表 
            event.data.iscrollContent.find("[penId='"+obj.penData.macAddress+"']").NewPenCell("changeBtnName","连接中...");
            event.data.againNotBtnContainer.children("div").css({"pointer-events":"none","opacity":"0.5"});
            event.data.againNotBtnContainer.children("p").css({"pointer-events":"none","opacity":"0.5"});
            event.data.closeImg.children("img").css({"pointer-events":"none","opacity":"0.5"});
            event.data.element.trigger("CONNECT_BTN_CLICK",{"isStop":event.data.isStop,"penData":obj.penData,"penType":event.data.penType});//抛出蓝牙笔列表cell按钮点击事件 isStop 是否给原生发送停止扫描事件 penData 当前需要连接的笔信息 penType 当前连接笔的类型 1是蓝牙笔 2 是有线笔
        },
        //蓝牙笔连接失败(解锁)
        connectError:function(){
            this.isCancel = false;//这个时候如果放弃连接就不需要在抛搜索取消事件了
            this.iscroll.enabled = true;//允许滚动容器刷新
            this.iscrollContent.find("li").NewPenCell("lockout");//解锁所有笔列表
            this.iscrollContent.find("li").NewPenCell("changeBtnName","连接");
            this.againNotBtnContainer.children("div").css({"display":"","pointer-events":"","opacity":1});
            this.againNotBtnContainer.children("p").css({"pointer-events":"","opacity":""});
            this.closeImg.children("img").css({"pointer-events":"","opacity":""});
        },
        //不需要抛出取消事件
        noCancel:function(){
            this.isCancel = false;
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});