/*
*   2021年3月30日
*   
*   封装云笔记首页轮播滑块组件
*
*   开发者：付长建 
*/
define(["swiper"],function(Swiper){
    $.widget("ys.SliderBook",{
        //默认参数
        options:{},
        swiper:null,
        maxContainer:null,//滑动最大容器
        isClick:true,//是否可以点击
        bookWid:"70%",
        bookDataArray:[],//本子数据
        bookVisibleDataArray:[],//本子可见数据
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            if($(window).width() == 360 && $(window).height() == 547){
                this.bookWid = "55%";
            }
            this.maxContainer = $("<div style='width:100%;transition:all 1.5s;opacity:0;'></div>").appendTo(this.element);
            
            //创建滑块容器
            var sliderContainer = $("<div class='swiper-container' style='width:100%;'></div>").appendTo(this.maxContainer);
            this.wrapperContainer = $("<div class='swiper-wrapper' style='padding-bottom:0.3rem;padding-top:0.1rem;'></div>").appendTo(sliderContainer);
            
            //创建默认展示第一块滑块 
            this.firstSlidContainer = $("<div class='swiper-slide' dataText='笔记整理'></div>").appendTo(this.wrapperContainer);
            var SlidContainer = $("<div class='SlidContainer' style='width:"+this.bookWid+";position:relative;box-shadow:0px 0.03rem 0.08rem rgba(0,0,0,0.1);border-radius:0.02rem 0.1rem 0.1rem 0.02rem;overflow:hidden;pointer-events:none;'></div>").appendTo(this.firstSlidContainer);
            $("<img style='width:100%;opacity:0' src='../djcommon/img/note/100.png'/>").appendTo(SlidContainer);
            this.firstContent = $("<div style='width:100%;max-height:100%;position:absolute;top:0px;left:0px;display:flex;flex-flow:wrap;justify-content:space-evenly;'></div>").appendTo(SlidContainer);
            
            //创建添加本子滑块
            this.addBookContainer = $("<div class='swiper-slide' dataText='新建本子'></div>").appendTo(this.wrapperContainer);
            var addImgContainer = $("<div class='addImgContainer' style='width:"+this.bookWid+";position:relative;box-shadow:0px 0.03rem 0.08rem rgba(0,0,0,0.1);border-radius:0.02rem 0.1rem 0.1rem 0.02rem;overflow:hidden;pointer-events:none;'></div>").appendTo(this.addBookContainer);
            $("<img style='width:100%;' src='../djcommon/img/note/book_add.png'/>").appendTo(addImgContainer);

            //创建分页器
            $("<div class='swiper-pagination'></div>").appendTo(sliderContainer);  
            //初始化插件
            var that = this;
            this.swiper = new Swiper(".swiper-container",{
                observer: true,                  //修改swiper自己或子元素时，自动初始化swiper
                observeParents: true,            //修改swiper的父元素时，自动初始化swiper
                touchRatio: 1,                   //解决滑动卡顿
                pagination:{
                    el:".swiper-pagination",
                    dynamicBullets:true,
                },
                on:{
                    touchEnd:function(swiper,event){
                        setTimeout(function(){
                            that.bookName.html($(".swiper-slide-active").attr("dataText"));
                            //隐藏底部智能笔管理按钮和书写时光轴按钮
                            if($(".swiper-slide-active").index() == 0){
                                notebookTimeAxisContainer.css({"opacity":1,"pointer-events":""});
                            }else{
                                notebookTimeAxisContainer.css({"opacity":0,"pointer-events":"none"});
                            }

                            // 判断是否显示 我的微视频 按钮
                            if($(".swiper-slide-active").index() != 0 && that.bookVisibleDataArray[$(".swiper-slide-active").index() - 1] != undefined) {
                                notebookTimeAxisContainer.css({"display":"none","pointer-events":"none"});
                                let bookClassArr = that.bookVisibleDataArray[$(".swiper-slide-active").index() - 1].bookClassify?that.bookVisibleDataArray[$(".swiper-slide-active").index() - 1].bookClassify.split(','):[]
                                if(bookClassArr.some(a => a == '10')) {
                                    $(that.microVideo).css({"opacity":1,"pointer-events":""})
                                    // alert(JSON.stringify(that.bookVisibleDataArray[$(".swiper-slide-active").index() - 1]))
                                    $(that.microVideo).attr('target',JSON.stringify(that.bookVisibleDataArray[$(".swiper-slide-active").index() - 1]))
                                } else {
                                    $(that.microVideo).css({"opacity":0,"pointer-events":"none"})
                                    $(that.microVideo).attr('target',-1)
                                }  
                            } else {
                                notebookTimeAxisContainer.css({"display":"flex","pointer-events":""});
                                $(".timeAxis").css({"display":"none","pointer-events":"none"});
                                $(that.microVideo).css({"opacity":0,"pointer-events":"none"})
                            }
                            // 判断如果第0页，微课按钮隐藏，智能本管理和书写时光轴按钮容器和元素 显示
                            if($(".swiper-slide-active").index() == 0) {
                                $(that.microVideo).css({"display":"none","pointer-events":"none"})
                                $(".timeAxis").css({"display":"flex","pointer-events":""});
                            } else {
                                $(that.microVideo).css({"display":"","pointer-events":""})
                            }
                        },200);
                    },
                    // 判断如果最后一页
                    slideChangeTransitionStart: function(swiper){
                        if(swiper.isEnd) {
                            $(".timeAxis").css({"display":"none","pointer-events":"none"});
                        }
                      }
                }
                
            });

            //创建本子名称元素
            this.bookName = $("<div style='width:100%;text-align:center;margin-top:5px;font-size:0.18rem;font-weight:500;color:#000;'>笔记整理</div>").appendTo(this.maxContainer);
            //我的微视频 按钮
            this.microVideo = $("<div id='microVideo' style='width:1.3rem;height:36px;line-height:34px;margin:0 auto; margin-top:0.10rem;text-align:center;border-radius:0.22rem;transition:all 0.3s;box-sizing:border-box;background:linear-gradient(180deg, #CF000F 0%, #E30514 100%);'></div>").appendTo(this.maxContainer);
            $("<img style='width:0.2rem;height:0.2rem;position:relative;top:-2px;' src='../djcommon/img/note/ic_wsp@3x.png'/>").appendTo(this.microVideo);
            $("<span style='font-size:0.15rem;color:#fff;font-weight:500;margin-left:0.05rem;'>我的微视频</span>").appendTo(this.microVideo);
            //创建智能本管理和书写时光轴按钮容器和元素 
            var notebookTimeAxisContainer = $("<div class='timeAxis' style='width:100%;padding:0.10rem 0.4rem 0 0.4rem;box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-between;transition:all 0.3s;display:none;pointer-events:none;'></div>").appendTo(this.maxContainer);
            this.notebook = $("<div style='width:1.3rem;height:36px;line-height:34px;text-align:center;border:1px solid #C82128;border-radius:0.22rem;box-sizing:border-box;'></div>").appendTo(notebookTimeAxisContainer);
            $("<img style='width:0.2rem;height:0.2rem;position:relative;top:-2px;' src='../djcommon/img/note/ic_znbgl_red.png'/>").appendTo(this.notebook);
            $("<span style='font-size:0.15rem;color:#C82128;font-weight:500;margin-left:0.05rem;'>智能本管理</span>").appendTo(this.notebook);
            this.timeAxis = $("<div style='width:1.3rem;height:36px;line-height:34px;text-align:center;border-radius:0.22rem;box-sizing:border-box;background:linear-gradient(180deg, #CF000F 0%, #E30514 100%);'></div>").appendTo(notebookTimeAxisContainer);
            $("<img style='width:0.2rem;height:0.2rem;position:relative;top:-2px;' src='../djcommon/img/note/ic_sx_white.png'/>").appendTo(this.timeAxis);
            $("<span style='font-size:0.15rem;color:#fff;font-weight:500;margin-left:0.05rem;'>书写时光轴</span>").appendTo(this.timeAxis);
            
            //给智能本管理按钮绑定点击事件
            this.notebook.bind("click",this,this._notebookClick);
            //给时书写光轴按钮绑定点击事件
            this.timeAxis.bind("click",this,this._timeAxisClick);
            //给添加本子滑块绑定点击事件 
            addImgContainer.bind("click",this,this._addBook);
            //给第一块分类绑定点击事件
            SlidContainer.bind("click",this,this._arrangementClick);
            //我的微视频绑定点击事件
            this.microVideo.bind("click",this,this._weishiClick);
            //我的微视频按钮默认隐藏
            $(this.microVideo).css({"opacity":0,"pointer-events":"none"})
        },
        //点击智能本管理按钮
        _notebookClick:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("NOTE_BOOK_CLICK");
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //点击书写时光轴按钮
        _timeAxisClick:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("TIME_AXIS_CLICK");
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //点击进入笔记整理方法
        _arrangementClick:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("ARRANGEMENT_BTN_CLICK");//抛出点击了整理笔记按钮事件
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //点击添加本子方法
        _addBook:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("ADD_BOOK_CLICK");//抛出点击了添加本子事件
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //点击本子方法 
        _bookClick:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("BOOK_BTN_CLICK",JSON.parse($(this).attr("data")));//抛出点击了本子事件
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //我的微视频 按钮点击方法
        _weishiClick:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                var microVideoBtn = document.getElementById("microVideo") // 获取按钮
                event.data.element.trigger("WEISHI_BTN_CLICK",JSON.parse(microVideoBtn.getAttribute("target")));//抛出点击了按钮事件
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //生成第一块滑块里面的内容方法
        generateFirstblockDefaultContent:function(dataArray){ 
            this.firstContent.children("div").remove();//清空节点
            dataArray = dataArray.slice(0,4);//只取数组前面4条数据进行显示
            $(".defaultNo").remove();//清除默认的没有数据的提示
            if(dataArray.length != 0){
                for(var i = 0; i < dataArray.length; i++){
                    var itme = $("<div style='width:45%;margin-top:0.35rem;'></div>").appendTo(this.firstContent);
                    $("<img style='width:100%;' src='../djcommon/img/note/img_fenlei.png'/>").appendTo(itme);
                    $("<p style='max-width:100%;padding-left:0.04rem;box-sizing:border-box;text-align:left;font-size:0.12rem;color:#2A2A2A;margin-top:0.1rem;text-overflow:ellipsis;overflow:hidden;white-space:nowrap;'>"+dataArray[i].categoryName+"</p>").appendTo(itme);
                }
                //判断是当前数据是单数还是双数（主要解决flex布局居中问题）
                if(dataArray.length % 2 != 0){
                    $("<div style='width:45%;'></div>").appendTo(this.firstContent);//添加一个占位
                }
                //给第一块滑块绑定点击事件
                // this.firstContent.unbind("click").bind("click",this,this._arrangementClick);
            }else{
                var itme = $("<div class='defaultNo' style='width:100%;min-height:100%;display:flex;flex-direction:column;align-items:center;justify-content:center;'></div>").appendTo(this.firstContent);
                $("<img style='width:0.87rem;height:0.67rem;' src='../djcommon/img/note/img_fenlei_ew.png'/>").appendTo(itme);
                $("<span style='font-size:0.14rem;color:#999;font-weight:400;'>暂无内容</span>").appendTo(itme);
                var btn = $("<p style='width:1.3rem;height:0.36rem;line-height:0.34rem;text-align:center;border-radius:0.22rem;background:#F3F3F3;font-size:0.15rem;color:#000;font-weight:500;margin-top:0.4rem;'>进入笔记整理</p>").appendTo(itme);
                // btn.bind("click",this,this._arrangementClick);
            }
        },  
        
        //更新本子滑块
        generateBook:function(dataArray){
            this.bookDataArray = dataArray;
            this.bookVisibleDataArray = [];
            $(".fcjSlide").remove();
            for(var i = 0; i < dataArray.length; i++){
                //判读本子是否显示
                if(parseInt(dataArray[i].visible) == 1){
                    var slider = $("<div bookId='"+dataArray[i].id+"' class='swiper-slide fcjSlide' dataText='"+dataArray[i].bookName+"'></div>");
                    var book = $("<div data='"+JSON.stringify(dataArray[i])+"' style='width:"+this.bookWid+";position:relative;box-shadow:0px 0.03rem 0.08rem rgba(0,0,0,0.1);border-radius:0.02rem 0.1rem 0.1rem 0.02rem;overflow:hidden;'></div>").appendTo(slider);
                    if(parseInt(dataArray[i].activeFlag) == 1){
                        $("<span style='display:inline-block;width:0.5rem;height:20px;text-align:center;line-height:20px;font-size:12px;color:#CF000F;position:absolute;top:7px;right:15px;background:#fff;border-radius:10px;'>已启用</span>").appendTo(book);
                    }else{
                        $("<span style='display:inline-block;width:0.5rem;height:20px;text-align:center;line-height:20px;font-size:12px;color:#fff;position:absolute;top:7px;right:15px;background:rgba(0,0,0,0.3);border-radius:10px;'>已锁定</span>").appendTo(book);
                    }
                    $("<img style='width:100%;' src='"+dataArray[i].coverUrl+"'/>").appendTo(book);
                    this.addBookContainer.before(slider);//添加到兄弟节点之前
                    $(".timeAxis").css({"display":"none","pointer-events":"none"});
                    
                    book.bind("click",this,this._bookClick);//给本子绑定点击事件
                    // 填入数据
                    this.bookVisibleDataArray.push(dataArray[i])
                }
            }

            this.swiper.update();//调用插件方法更新本子
            this.swiper.slideTo(1,0);//显示第一块 

            // 判断是否显示 我的微视频 按钮
            if($(".swiper-slide-active").index() == 0) {
                $(this.microVideo).css({"display":"none"})
            } else {
                $(this.microVideo).css({"display":""})
            }
            
            if(this.bookVisibleDataArray !='') {
                let bookClassArr = this.bookVisibleDataArray[$(".swiper-slide-active").index() - 1].bookClassify?this.bookVisibleDataArray[$(".swiper-slide-active").index() - 1].bookClassify.split(','):[]
                if(bookClassArr.some(a => a == '10')) {
                    $(this.microVideo).css({"opacity":1,"pointer-events":""})
                    // alert(JSON.stringify(this.bookVisibleDataArray[$(".swiper-slide-active").index() - 1]))
                    $(this.microVideo).attr('target',JSON.stringify(this.bookVisibleDataArray[$(".swiper-slide-active").index() - 1]))
                } else {
                    $(this.microVideo).css({"opacity":0,"pointer-events":"none"})
                    $(this.microVideo).attr('target',-1)
                }
            }

            this.bookName.html($(".swiper-slide-active").attr("dataText"));//赋值本子名称
            setTimeout(function(that){
                $(".SlidContainer").css("pointer-events","");
                $(".addImgContainer").css("pointer-events","");
                that.maxContainer.css("opacity",1);
                $(".timeAxis").css({"display":"none","pointer-events":"none"});
            },50,this);
        },
        //改变本子位置方法
        changeBookPosition:function(ids){
            var data = [];
            if($("[bookId='"+ids+"']").length == 0){
                //集合中不包含当前的本子
                for(var i = 0; i < this.bookDataArray.length; i++){
                    if(this.bookDataArray[i].id == ids){
                        this.bookDataArray[i].visible = 1;
                        data.unshift(this.bookDataArray[i]);
                    }else{
                        data.push(this.bookDataArray[i]);
                    }
                }
            }else{
                //集合中包含当前书写的本子
                for(var i = 0; i < this.bookDataArray.length; i++){
                    if(this.bookDataArray[i].id == ids){
                        data.unshift(this.bookDataArray[i]);
                    }else{
                        data.push(this.bookDataArray[i]);
                    }
                }
            }
            this.generateBook(data);
        },
        //释放控件(清除控件)
        destroy:function(){
            this.bookVisibleDataArray = [];
            $.Widget.prototype.destroy.call(this); 
        }
    });
});