/*
*   2020年12月17日
*   
*   封装保险箱笔记转文档笔记cell组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.YsnoteCell",{
        //默认参数
        options:{},
        isClick:true,//防止多次执行
        //创建控件，控件生命周期内会运行多次
        _create:function(){
            //创建内容容器
            this._contentContainer = $("<div style='width:100%;height:100%;position:relative;background-image:url("+this.options.data.recordUrl+"); background-repeat:no-repeat;background-size:100% 100%;'></div>").appendTo(this.element);
            //创建勾选元素
            this._selectIcon = $("<div isSelect='no' style='width:0.3rem;height:0.3rem;border-radius:50%;border:3px solid #E6E6E6;box-sizing:border-box;background:rgba(0,0,0,0.2);position:absolute;top:0.03rem;right:0.03rem;'></div>").appendTo(this._contentContainer);
            //创建页码元素
            this._page = $("<div style='width:0.3rem;height:0.24rem;background:rgba(0,0,0,0.3);border-radius:0.08rem 0px 0.08rem 0px;position:absolute;bottom:0;right:0;display:flex;justify-content:center;align-items:center;'></div>").appendTo(this._contentContainer);
            var page = this.options.data.pageNo <= 0 ? "前页" : this.options.data.pageNo;
            $("<span style='display:inline-block;font-size:0.12rem;color:#fff;transform:scale(0.8,0.8)'>"+page+"</span>").appendTo(this._page);
            //给勾选框绑定点击事件
            this._selectIcon.bind("click",this,this._clickSelect);
            //给cell绑定点击事件
            this._contentContainer.bind("click",this,this._cellClick);
        },
        //点击勾选框
        _clickSelect:function(event){
            event.stopPropagation();
            //判断是选中还是取消选中
            if($(this).attr("isSelect") == "no"){
                $(this).attr("isSelect","yes");
                $(this).css({
                    "background":"url("+skinConfig(global.skin).shllWebIon+"pt_touxuan.png)",
                    "background-size":"100%"
                });
            }else{
                $(this).attr("isSelect","no");
                $(this).css({
                    "background":"rgba(0,0,0,0.3)",
                    "background-size":""
                });
            }
            // alert("_clickSelect")
            event.data.element.trigger("YSNETCELL_SELECT",{"type":$(this).attr("isSelect"),"data":event.data.options.data});//抛出勾选事件
            
        },
        //选中方法
        checkSelect:function(type){
            if(type == "yes"){
                this._selectIcon.attr("isSelect","yes");
                this._selectIcon.css({
                    "background":"url("+skinConfig(global.skin).shllWebIon+"pt_touxuan.png)",
                    "background-size":"100%"
                });
            }else{
                this._selectIcon.attr("isSelect","no");
                this._selectIcon.css({
                    "background":"rgba(0,0,0,0.3)",
                    "background-size":""
                });
            }
        },
        //点击cell
        _cellClick:function(event){
            if(event.data.isClick){
                event.data.isClick = false;
                event.data.element.trigger("YSNET_CELL_CLICK",event.data.options.data);//抛出点击事件
                setTimeout(function(){
                    event.data.isClick = true;
                },500);
            }
        },
        //获取数据
        getData:function(){
            return this.options.data;
        },
        //默认选中方法
        defaultClick:function(){
            this._selectIcon.click();
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});