/*
*   2020年12月16日
*
*   保险箱笔记转为文档页面js控制器
*
*   开发者：付长建 
*/
define(["jquery","Shell","Fastclick","CommonToast","CommonHead","CommonIscroll","FootBottom","YsnoteCell","ChangeMask"],function($,Shell,Fastclick){
    var Controller = {
        data:null,//上一个页面传递过来的参数
        selectData:[],//选中数据数组
        taskId:null,//转换任务id
        previewUUid:null,//预览文件uuid
        //页面加载成功执行的方法
        init:function(){
            Controller.data = decode(getUrl("pam"));
            $("body").css("opacity",0);
            //设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            //禁止整个页面滚动
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});
            //获取配置信息
            http(ServerConfig.domain+"/Setting/getGlobal",{"token":getUrl("token")},{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        global.userInfo = arg.data.userInfo;//得到用户信息
                        global.preview_config = arg.data.preview_config;//得到文件预览配置
                        global.is_thumb_model = arg.data.is_thumb_model;//得到是否显示搜索图
                        global.thumb_width_height_config = arg.data.thumb_width_height_config;//得到缩略图配置
                        global.skin = arg.data.skin_name;//得到皮肤配置
                        global.is_yingshuo = arg.data.is_yingshuo;//得到是否显示云笔记筛选选项
                        global.version = arg.data.version;//得到当前是哪个版本
                        global.noet = arg.data.text_recognise_config;//得到转换服务地址
                        Controller.create();//调用创建页面方法
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            try{
                                api.toast({msg:arg.msg,duration:2000,location:"middle"});
                            }catch(e){}
                        }
                    }
                }
            });
            //监听ajax请求错误
            $(window).bind("HTTP_REQUEST_ERROR",function(event,msg){
                try{
                    api.toast({msg:msg,duration:2000,location:"middle"});
                }catch(e){}
            });
        },
        //生成页面
        create:function(){
            //初始化飘窗组件
            this.toastContainer = $("<div></div>").CommonToast().appendTo($("body"));
            //初始化头部组件
            this.headContainer = $("<div></div>").appendTo($("body"));
            //判断是否需要云笔记选项
            this.headContainer.CommonHead({
                "isGoback":true,//是否显示返回按钮
                "title":Controller.data.title + "." + Controller.data.ext,  
            });
            //初始化滚动容器组件
            this.iscrollContainer = $("<div id='changeDowContainer' style='padding:0 0.15rem 0 0.15rem;box-sizing:border-box;overflow:hidden;'></div>").appendTo($("body"));
            //初始化底部foot组件
            this.footContainer = $("<div></div>").appendTo($("body"));
            this.footContainer.FootBottom();
            //初始化滚动组件
            this.iscrollContainer.css("height",$("body").height() - this.headContainer.outerHeight(true) - this.footContainer.outerHeight(true) + "px");//设置滚动组件的高度
            this.iscrollContainer.CommonIscroll({"isUploadBtn":false,"isRefresh":false,"isLoad":false,"isPaddingBottom":"0.15rem"});

            //监听返回按钮被点击
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                Shell.sendEvent("closeWin");//关闭当前页面
            });
            //监听cell组件勾选事件 
            this.iscrollContainer.bind("YSNETCELL_SELECT",function(event,obj){
                //判断当前是取消还是选中
                if(obj.type == "yes"){
                    Controller.selectData.push(obj.data);
                }else{
                    //循环取消选中数据
                    for(var i = 0; i < Controller.selectData.length; i++){
                        if(Controller.selectData[i].uuid == obj.data.uuid){
                            Controller.selectData.splice(i,1);
                            break;
                        }
                    }
                } 
                listSelect();//调用cell操作方法
            });
            //监听底部foot点击全选和全不选按钮  
            this.footContainer.bind("ALL_SELECT",function(event,type){
                Controller.iscrollContainer.find("li").YsnoteCell("checkSelect",type);//选中或者不选中cell
                Controller.selectData = [];//情况选中数据
                //判断是全选还是反选
                if(type == "yes"){ 
                    Controller.iscrollContainer.find("li").each(function(){
                        Controller.selectData.push($(this).YsnoteCell("getData"));
                    });
                    Controller.footContainer.FootBottom("setSelectNumm",Controller.iscrollContainer.find("li").length);//设置选中cell数量
                    Controller.headContainer.CommonHead("showDetermine");//调用头部组件显示确定按钮
                }else{
                    Controller.footContainer.FootBottom("setSelectNumm",0);//设置选中cell数量
                    Controller.headContainer.CommonHead("hideDetermine");//调用头部组件隐藏确定按钮
                }
            });
            //监听cell组件被点击 
            this.iscrollContainer.bind("YSNET_CELL_CLICK",function(event,obj){
                var mask = $("<div style='z-index:1;position:absolute;top:0;left:0;width:100%;height:100%;background:rgba(0,0,0,0.5);opacity:0;display:flex;justify-content:center;align-items:center;'></div>").appendTo($("body"));
                var imgContainer = $("<div style='width:100%;display:flex;justify-content:center;align-items:center;'></div>").appendTo(mask);
                $("<img style='max-width:30%;' src='"+obj.normal+"'/>").appendTo(imgContainer);
                //执行动画
                setTimeout(function(){
                    mask.stop().animate({"opacity":1},"fast");
                    imgContainer.find("img").stop().animate({"max-width":"100%"},"fast");
                    mask.bind("click",function(){
                        mask.stop().animate({"opacity":0},"fast");
                        imgContainer.find("img").stop().animate({"max-width":"30%"},"fast",function(){
                            mask.remove();
                        });
                    });
                },20);
            });
            //监听头部组件点击确定按钮
            this.headContainer.bind("DETERMINE_BTN_CLICK",function(){
                //初始化弹框提示
                Controller.changeMaskContainer = $("<div style='z-index:2;'></div>").appendTo($("body"));
                Controller.changeMaskContainer.ChangeMask();
                //循环生成
                var pageArray = [];
                for(var i = 0; i < Controller.selectData.length; i++){
                    pageArray.push(Controller.selectData[i].page);
                }
                pageArray.sort(function(x,y){return x-y;});//排序数组
                createTask(pageArray.join(","));//调用创建转换任务方法
                Controller.headContainer.CommonHead("changeGobackBtnColor","yes");//锁定头部组件返回按钮
                Controller.headContainer.CommonHead("changeDetermineBtnColor","yes");//锁定头部组件确定按钮
                Controller.footContainer.FootBottom("lock","yes");//锁定底部操作
                //监听弹窗组件点击取消事件
                Controller.changeMaskContainer.bind("CANCEL_BTN_CLICK",function(){
                    Controller.headContainer.CommonHead("changeGobackBtnColor","no");//解锁头部组件返回按钮
                    Controller.headContainer.CommonHead("changeDetermineBtnColor","no");//解锁头部组件确定按钮
                    Controller.footContainer.FootBottom("lock","no");//解锁头部组件
                });
                //监听弹窗组件点击返回列表事件
                Controller.changeMaskContainer.bind("SUCCESS_BTN_CLICK",function(){
                    Shell.sendEvent("closeWin");//关闭当前页面
                });
                //监听弹窗组件点击了取消转换事件 
                Controller.changeMaskContainer.bind("CANCELTARE_BTN_CLICK",function(){
                    if(Controller.taskId != null){
                        cancelTransform();//取消转换任务
                    }
                });
                //监听弹窗组件点击了重新转换
                Controller.changeMaskContainer.bind("AGAIN_BTN_CLICK",function(){
                    createTask(pageArray.join(","));//调用创建转换任务方法
                });
                //监听弹窗组件点击了立即查看事件
                Controller.changeMaskContainer.bind("SEE_BTN_CLICK",function(){
                    setTimeout(function(){
                        Shell.sendEvent("closeWin");//关闭当前页面
                        Shell.sendEvent("commonChange",{"pageName":"deposit","previewUUid":Controller.previewUUid});//通知原生保险箱页面需要刷新
                    },800);
                });
            });
            //解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
            //给原生抛出加载完成事件
            Shell.sendPageReady(); 
            $("body").fadeTo("slow",1);
            getYsnetList();//调用获取笔记数据方法
        }
    }
    //获取笔记回显列表数据
    function getYsnetList(){
        Controller.iscrollContainer.CommonIscroll("showLoadMask");//显示加载层
        //请求参数
        var paramet = {"token":getUrl("token"),"uuid":Controller.data.uuid,"user_id":global.userInfo.id,"width":105,"height":140};
        http(global.noet.note_list,paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    if(arg.data.status == "complete"){
                        getListCell(arg.data.list);//调用生成cell卡片方法
                    }else if(arg.data.status == "doing"){
                        setTimeout(function(){
                            getYsnetList();//调用自己本身轮询
                        },2000);
                    }else{
                        Controller.iscrollContainer.CommonIscroll("showErrorMask",arg.data.msg);//显示错误提示层
                    }
                }else{
                    //判断是否是退出登录了
                    if(arg.data.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        Controller.iscrollContainer.CommonIscroll("showErrorMask",arg.data.msg);//显示错误提示层
                    }
                }
            }
        });
    }
    //创建文档转换任务
    function createTask(page){
        //请求参数
        var paramet = {"token":getUrl("token"),"uuid":Controller.data.uuid,"user_id":global.userInfo.id,"ids":page};
        http(global.noet.note_word,paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    Controller.taskId = arg.data.taskID;//得到创建的任务id
                    transformDocument();//调用开始转换文档方法
                }else{
                    //判断是否是退出登录了
                    if(arg.data.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        Controller.toastContainer.CommonToast("showToast",arg.data.msg);//显示错误提示
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            Controller.headContainer.CommonHead("changeGobackBtnColor","no");//解锁头部组件返回按钮
                            Controller.headContainer.CommonHead("changeDetermineBtnColor","no");//解锁头部组件确定按钮
                            Controller.footContainer.FootBottom("lock","no");//解锁底部操作
                        },1500);
                    }
                }
            }
        });
    }
    //开始转换文档方法（这个方法需要轮询处理）
    function transformDocument(){
        //请求参数
        var paramet = {"token":getUrl("token"),"id":Controller.taskId};
        http(global.noet.note_result,paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    if(arg.data.status == "doing"){
                        var mix = ((100 / arg.data.sumNum) * arg.data.currNum);//得到一张图片占比进度多少并且计算出当前进度
                        if(mix == 0){
                            Controller.changeMaskContainer.ChangeMask("setSpeed","0%");//调用弹窗组件设置百分比方法;
                        }else{
                            var str = String(mix);
                            if(str.indexOf(".") != -1){
                                Controller.changeMaskContainer.ChangeMask("setSpeed",mix.toFixed(1) + "%");//调用弹窗组件设置百分比方法;
                            }else{
                                Controller.changeMaskContainer.ChangeMask("setSpeed",mix + "%");//调用弹窗组件设置百分比方法;
                            }
                        }
                        Controller.transformTime = setTimeout(function(){
                            transformDocument();//调用自己本身轮询
                        },2000);
                    }else if(arg.data.status == "complete"){
                        transformSuccess(arg.data);//调用后端存储方法
                    }else if(arg.data.status == "fail"){
                        Controller.changeMaskContainer.ChangeMask("taealFail");//调用提示弹出组件失败方法
                    }
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        Controller.toastContainer.CommonToast("showToast",arg.data.msg);//显示错误提示
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            Controller.headContainer.CommonHead("changeGobackBtnColor","no");//解锁头部组件返回按钮
                            Controller.headContainer.CommonHead("changeDetermineBtnColor","no");//解锁头部组件确定按钮
                            Controller.footContainer.FootBottom("lock","no");//解锁底部操作
                        },1500);
                    }
                }
            }
        });
    }
    //取消转换文档方法
    function cancelTransform(){
        clearTimeout(Controller.transformTime);
        //请求参数
        var paramet = {"token":getUrl("token"),"id":Controller.taskId};
        http(global.noet.note_cancel,paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    Controller.headContainer.CommonHead("changeGobackBtnColor","no");//解锁头部组件返回按钮
                    Controller.headContainer.CommonHead("changeDetermineBtnColor","no");//解锁头部组件确定按钮
                    Controller.footContainer.FootBottom("lock","no");//解锁底部操作
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        Controller.toastContainer.CommonToast("showToast",arg.data.msg);//显示错误提示
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            Controller.headContainer.CommonHead("changeGobackBtnColor","no");//解锁头部组件返回按钮
                            Controller.headContainer.CommonHead("changeDetermineBtnColor","no");//解锁头部组件确定按钮
                            Controller.footContainer.FootBottom("lock","no");//解锁底部操作
                        },1500);
                    }
                }
            }
        });
    }
    //转换完成调用后端存储方法
    function transformSuccess(obj){
        //请求参数
        var paramet = {"token":getUrl("token"),"pid":0,"name":Controller.data.title,"ext":obj.fileInfo.ext,"fileinfo_id":obj.fileInfo.uuid,"mime":obj.fileInfo.mime,"file_size":obj.fileInfo.size};
        http(ServerConfig.domain+"/Safe/addFileForChangeWord",paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    Controller.previewUUid = arg.data.file_id;//得到uuid主要是用户想预览使用
                    Shell.sendEvent("commonChange",{"pageName":"deposit","pid":0});//通知原生保险箱页面需要刷新
                    Controller.changeMaskContainer.ChangeMask("setSpeed","100%");//调用弹窗组件设置百分比方法
                    Controller.changeMaskContainer.ChangeMask("successFun");//调用提示弹出组件成功方法
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        Controller.changeMaskContainer.ChangeMask("taealFail",arg.msg);//调用提示弹出组件失败方法
                    }
                }
            }
        });
    }
    //生成cell卡片方法
    function getListCell(dataArray){
        Controller.iscrollContainer.find("ul").css({"min-height":"","display":"flex","flex-direction":"row","flex-wrap":"wrap","justify-content":"space-between"});
        var cellArray = [];
        for(var i = 0; i < dataArray.length; i++){
            var cell = $("<li class='ysnetCell"+i+"' style='width:30.6666667%;height:1.43rem;margin-top:0.15rem;border-radius:1px 0.08rem 0.08rem 0px;box-sizing:border-box;overflow:hidden;box-shadow:rgba(0, 37, 87, 0.2) 1px 0px 4px 0px;'></li>").YsnoteCell({"data":dataArray[i]});
            cellArray.push(cell);
        }
        Controller.iscrollContainer.CommonIscroll("initNode",cellArray);//调用滚动组件初始化数据
        Controller.footContainer.FootBottom("allowClick");//允许底部foot点击全选按钮
    }
    //选中cell操作方法
    function listSelect(){
        if(Controller.selectData.length != 0){
            Controller.headContainer.CommonHead("showDetermine");//调用头部组件显示确定按钮
            if(Controller.selectData.length == Controller.iscrollContainer.find("li").length){
                Controller.footContainer.FootBottom("changeAllSelect","yes");
            }else{
                Controller.footContainer.FootBottom("changeAllSelect","no");
            }
        }else{
            Controller.headContainer.CommonHead("hideDetermine");//调用头部组件隐藏确定按钮
        }
        Controller.footContainer.FootBottom("setSelectNumm",Controller.selectData.length);//设置选中cell数量
    }
    return Controller;
});
