/*
*   2020年12月8日
*
*   个人空间移动文件页面
*
*   开发者：付长建
*/
define(["jquery","Shell","Fastclick","CommonToast","CommonHead","CommonSearch","CommonIscroll","CommonCell","CommonDeleteMask"],function($,Shell,Fastclick){
    var Controller = {
        maxContainer:null,//页面最大元素
        headContainer:null,//头部组件
        searchContainer:null,//搜索组件
        crumbsContainer:null,//面包屑组件
        iscrollContainer:null,//滚动容器组件
        newDetermineContainer:null,//底部新建和确定按钮容器
        pid:0,//目录pid
        keyword:"",//搜索关键字
        navArray:[],//层级进入数据（主要是用于点击头部返回按钮需要使用）
        isClick:true,//防止用户多次触发
        isCopyClick:true,//防止用户多次触发
        pageName:"djmyspacecopy",//当前页面
        wid:0,//动画宽度
        title:"",//头部title文字（主要是用于移动或者复制成功抛出去给js控制器使用）
        batchTotal:0,//批量操作的数据量
        batchId:"",//储存的批量任务id
        cancelBtn:null,//批量操作需要的取消按钮
        isCancelChange:false,//是否处于取消任务状态
        batch_id_arr:[],//批量id数组
        firstBatchConflictId:"",//批量操作第一次冲突id
        //页面加载成功执行的方法
        init:function(){
            $("body").css("opacity",0);
            //设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            //禁止整个页面滚动
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});
            //获取配置信息
            // 替换云空间配置接口 0715
            http(ServerConfig.cloudDomain+"/Setting/getGlobal",{"token":getUrl("cloudToken")},{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        global.userInfo = arg.data.userInfo;//得到用户信息
                        global.preview_config = arg.data.preview_config;//得到文件预览配置
                        global.is_thumb_model = arg.data.is_thumb_model;//得到是否显示搜索图
                        global.thumb_width_height_config = arg.data.thumb_width_height_config;//得到缩略图配置
                        global.skin = arg.data.skin_name;//得到皮肤配置
                        global.is_yingshuo = arg.data.is_yingshuo;//得到是否显示云笔记筛选选项
                        global.version = arg.data.version;//得到当前是哪个版本
                        Controller.create();//调用创建页面方法
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            try{
                                api.toast({msg:arg.msg,duration:2000,location:"middle"});
                            }catch(e){}
                        }
                    }
                }
            });
            //监听ajax请求错误
            $(window).bind("HTTP_REQUEST_ERROR",function(event,msg){
                try{
                    api.toast({msg:msg,duration:2000,location:"middle"});
                }catch(e){}
            });
        },
        //生成页面
        create:function(){
            //创建飘窗提示元素
            Controller.toastContainer = $("<div></div>").CommonToast().appendTo($("body"));
            //创建页面最大容器元素
            this.maxContainer = $("<div style='width:100%;height:100%;background:#fff;position:relative;overflow:hidden;'></div>").appendTo($("body"));
            //创建页面头部
            this.headContainer = $("<div></div>").appendTo(this.maxContainer);
            this.headContainer.CommonHead({"title":"复制","isCancel":true,"fontWeigth":500});
            //初始化搜索组件
            this.searchContainer = $("<div style='width:100%;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;box-shadow:0px 3px 4px 1px rgba(0, 37, 87, 0.03);background:#fff;'></div>").appendTo(this.maxContainer);
            this.searchContainer.CommonSearch();
            //创建复制移动动效模块
            var effectContainer = $("<div style='width:100%;height:0.4rem;position:relative;'></div>").appendTo(this.maxContainer);
            $("<p style='width:100%;height:100%;background:#f8f8f8;padding-left:0.15rem;line-height:0.4rem;box-sizing:border-box;font-size:0.12rem;color:#999;'>选中目标文件夹</p>").appendTo(effectContainer);
            this.effect = $("<div style='width:100%;height:100%;background:#424E67;position:absolute;top:0;display:none;'></div>").appendTo(effectContainer);
            $("<div style='width:0%;height:100%;background:"+skinConfig(global.skin).backColor+";'></div>").appendTo(this.effect);
            $("<p style='width:100%;height:100%;font-size:0.14rem;color:#fff;position:absolute;top:0;padding-left:0.15rem;box-sizing:border-box;line-height:0.4rem;'>正在复制... 0%</p>").appendTo(this.effect);
            
            // 批量复制失败完成方法条
            this.effectBatchCopy = $("<div style='width:100%;height:100%;background:#424E67;position:absolute;top:0;display:none;'></div>").appendTo(effectContainer);
            $("<div style='width:0%;height:100%;background:"+skinConfig(global.skin).backColor+";'></div>").appendTo(this.effectBatchCopy);
            $("<p style='width:100%;height:100%;font-size:0.14rem;color:#fff;position:absolute;top:0;padding-left:0.15rem;box-sizing:border-box;line-height:0.4rem;'>正在复制... 0%</p>").appendTo(this.effectBatchCopy);
            
            //创建取消按钮
            this.cancelBtn = $("<span style='display:none;font-size:0.14rem;color:#fff;position:absolute;line-height:0.4rem;top:0;right:0.15rem;'>取消</span>").appendTo(this.effect);
            //创建滚动容器
            this.iscrollContainer = $("<div id='depositMoveOut' style='width:100%;overflow:hidden;'></div>").appendTo(this.maxContainer);
            //创建底部确定按钮和新建文件夹按钮
            var bottom = 0;
            if(phonexh("bottom") != 0){
                bottom = 0;
            }
            this.newDetermineContainer = $("<div style='width:100%;padding-bottom:"+bottom+";box-sizing:border-box;background:#fff;'></div>").appendTo(this.maxContainer);
            var newDetermine = $("<div style='width:100%;height:0.64rem;display:flex;flex-direction:row;border-top:1px solid #ECECEC;box-sizing:border-box;'></div>").appendTo(this.newDetermineContainer);
            this.newBtn = $("<div style='width:0.73rem;height:100%;display:flex;flex-direction:column;align-items:center;justify-content:center;flex-shrink:0;border-right:1px solid #ECECEC;box-sizing:border-box;'></div>").appendTo(newDetermine);
            $("<img style='width:0.18rem;height:0.2rem;' src='"+skinConfig(global.skin).commonIcon+"new_folder_icon.png'/>").appendTo(this.newBtn);
            $("<span style='font-size:0.14rem;margin-top:0.03rem;'>新建</span>").appendTo(this.newBtn);
            var determineContainer = $("<div style='width:100%;height:100%;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;display:flex;align-items:center;'></div>").appendTo(newDetermine);
            this.determineBtn = $("<p style='width:100%;height:0.4rem;line-height:0.4rem;text-align:center;font-size:0.16rem;color:#fff;background:"+skinConfig(global.skin).linearBackColor+";border-radius:0.2rem;'>确定</p>").appendTo(determineContainer);
            //计算滚动容器的高度
            this.iscrollContainer.css("height",this.maxContainer.height() - this.headContainer.outerHeight(true) - this.searchContainer.height() - effectContainer.height() - this.newDetermineContainer.outerHeight(true) + "px");
            //初始化滚动组件
            this.iscrollContainer.CommonIscroll({"isRefresh":false,"isLoad":false,"isUploadBtn":false});

            //监听头部组件点击返回按钮
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                //判读多次执行
                if(Controller.isClick){
                    Controller.isClick = false;//禁止点击
                    Controller.keyword = "";//重置搜索关键字
                    Controller.searchContainer.CommonSearch("emptyVal");//调用搜索组件清空搜索输入框值方法
                    Controller.navArray.splice(Controller.navArray.length - 1,1);//去掉面包屑最后一个
                    //判断是否返回到最外层了
                    if(Controller.navArray.length != 0){
                        Controller.headContainer.CommonHead("changeTitle",Controller.navArray[Controller.navArray.length - 1].name);//调用头部组件显示title文字方法
                        Controller.pid = Controller.navArray[Controller.navArray.length - 1].uuid;
                        Controller.title = Controller.navArray[Controller.navArray.length - 1].name;
                    }else{
                        Controller.headContainer.CommonHead("hideGobackBtn");//调用头部组件隐藏返回按钮方法
                        Controller.headContainer.CommonHead("changeTitle","复制");//调用头部组件显示title文字方法
                        Controller.pid = 0;
                        Controller.title = "";
                    }
                    getListData();//调用获取列表数据方法
                }
            });
            //监听头部组件点击取消
            this.headContainer.bind("CANCE_BTN_CLICK",function(){
                if(Controller.batchId != ""){
                    cancelTask(Controller.batchId);//调用取消任务的方法
                }
                Shell.sendEvent("closeWin");//关闭当前页面
            });
            //监听搜索组件搜索事件
            this.searchContainer.bind("SEARCH_BTN_CLICK",function(event,val){
                //判读多次执行
                if(Controller.isClick){
                    Controller.isClick = false;//禁止点击
                    Controller.keyword = val;//重置搜索关键字
                    //判断关键字是否为空
                    if(Controller.keyword == ""){
                        lock("no");//解锁页面
                    }
                    getListData();//调用获取列表数据方法
                }
            });
            //监听搜索组件点击了清空图标
            this.searchContainer.bind("EMPTY_BTN_CLICK",function(){
                //判读多次执行
                if(Controller.isClick){
                    Controller.isClick = false;//禁止点击
                    Controller.keyword = "";//重置搜索关键字
                    getListData();//调用获取列表数据方法
                }
            });
            //监听列表被点击
            this.iscrollContainer.bind("CELL_CLICK",function(event,arg){
                //判读多次执行
                if(Controller.isClick){
                    Controller.isClick = false;//禁止触发
                    Controller.title = arg.name;//头部title文字
                    lock("no");//解锁页面
                    Controller.keyword = "";//重置搜索关键字
                    Controller.searchContainer.CommonSearch("emptyVal");//调用搜索组件清空搜索输入框值方法
                    Controller.headContainer.CommonHead("showGobackBtn");//调用头部组件显示返回按钮方法
                    Controller.headContainer.CommonHead("changeTitle",arg.name);//调用头部组件显示title文字方法
                    Controller.pid = arg.uuid;//重置请求数据的pid
                    getListData();//调用获取列表数据方法
                    //组装返回按钮被点击需要的数据
                    var obj = {};
                    obj.uuid = arg.uuid;
                    obj.name = arg.name;
                    Controller.navArray.push(obj);
                }
            });
            //给新建文件夹按钮绑定点击事件
            this.newBtn.bind("click",function(){
                Shell.sendEvent("openWin",{"url":"/djmyspacecopynewfolder/index.html?token="+getUrl("token")+"&cloudToken="+getUrl("cloudToken")+"&pid="+Controller.pid,"open_type":true,"title":"新建文件夹"});
            });
            //给确定按钮绑定点击事件
            this.determineBtn.bind("click",function(){
                //判读多次执行
                if(Controller.isClick){
                    Controller.isClick = false;//禁止点击
                    lock("yes");//锁定整个页面
                    Controller.searchContainer.CommonSearch("lock","yes");//锁定搜索组件
                    Controller.iscrollContainer.CommonIscroll("isIscroll","yes");//禁止滚动容器滚动
                    //判断是否储存的有批量任务id
                    if(Controller.batchId != ""){
                        Controller.toastContainer.CommonToast("showToast","正在获取数据，请稍后...");//显示飘窗提示
                        testingTask(Controller.batchId);//调用批量检测任务的方法
                    }else{
                        testingTaskNumber(getUrl("uuid"),Controller.pid);//调用批量操作添加任务的方法
                    }
                }
            });

            //新建文件夹按钮按下抬起效果
            btnTextCommon(this.newBtn);
            //确定按钮按下抬起效果
            btnTextCommon(this.determineBtn);
            //调用获取列表方法
            getListData();
            //监听原生事件
            try{
                //监听原生需要刷新事件
                api.addEventListener({name:"commonRefresh"},function(arg){
                    //判断是否可以刷新
                    if(arg.value.pageName == Controller.pageName){
                        getListData();//调用获取列表方法
                        Controller.isClick = true;
                    }
                });
            }catch(e){}
            //解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
            //给原生抛出加载完成事件
            setTimeout(function(){
                Shell.sendPageReady();
                $("body").css({"transition":"all 0.3s","opacity":1});
                setTimeout(function(){
                    $("body").css({"transition":"","opacity":""});
                },310);
            },100);
        }
    }
    //锁定整个页面
    function lock(type){
        Controller.headContainer.CommonHead("lock",type);//锁定头部组件
        Controller.headContainer.CommonHead("changeCancelBtnColor",type);//调用头部改变取消按钮颜色方法
        Controller.headContainer.CommonHead("changeGobackBtnColor",type);//调用头部改变返回按钮颜色方法
        if(type == "yes"){
            Controller.newBtn.css({"pointer-events":"none","opacity":"0.5"});//锁定新建按钮
            Controller.determineBtn.css({"pointer-events":"none","opacity":"0.5"});//锁定确定按钮
        }else{
            Controller.newBtn.css({"pointer-events":"","opacity":""});//解锁新建按钮
            Controller.determineBtn.css({"pointer-events":"","opacity":""});//解锁确定按钮
        }
    }
    //按钮元素按下抬起效果
    function btnTextCommon(element){
        //给选项绑定手指按下事件
        element.bind('touchstart',function(){
            $(this).css("opacity","0.5");
        });
        //给选项绑定手指抬起事件
        element.bind('touchend',function(){
            $(this).css("opacity","");
        });
    }
    //获取列表数据(搜索公用)
    function getListData(){
        //2秒没有拿到数据就显示提示层
        Controller.time = setTimeout(function(){
            Controller.iscrollContainer.CommonIscroll("showLoadMask");//显示加载层
        },2000);
        //请求参数
        // 替换云空间接口
        var paramet = {"token":getUrl("cloudToken"),"uuid":Controller.pid,"keyword":Controller.keyword,"type":"part"};
        var url = ServerConfig.cloudDomain+"/"+skinConfig(global.skin).skinUrl+"/getDirList"//列表接口（搜索共用）
        http(url,paramet,{
            success:function(arg){
                clearTimeout(Controller.time);//清除延时
                if(parseInt(arg.code) == 1){
                    generateList(arg.data.list);//调用生成列表方法
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        Controller.listIscrollContainer.CommonIscroll("showErrorMask",arg.msg);//显示错误提示层
                    }
                }
            }
        });
    }
    //生成列表方法
    function generateList(dataArray){
        var cellArray = [];
        for(var i = 0; i < dataArray.length; i++){
            var cell = $("<li style='width:100%;padding-left:0.15rem;box-sizing:border-box;'></li>").CommonCell({
                "commonIconUrl":skinConfig(global.skin).commonIcon,
                "shllIconUrl":skinConfig(global.skin).shllWebIon,
                "data":dataArray[i],
                "isSelect":false
            });
            cellArray.push(cell);
        }
        //判读是否有数据
        if(cellArray != 0){
            Controller.iscrollContainer.CommonIscroll("initNode",cellArray);
        }else{
            Controller.iscrollContainer.CommonIscroll("emptyNode");//清空节点
            //判断是搜索没有数据还是列表没有数据
            if(Controller.keyword == ""){
                Controller.iscrollContainer.CommonIscroll("showListNoDataMask","该目录下没有文件夹");//显示没有数据提示层
            }else{
                Controller.iscrollContainer.CommonIscroll("showSearchNoDataMask","没有找到你要的文件夹");//显示没有搜索数据提示层
            }
        }
        Controller.isClick = true;//允许点击
    }
    //复制方法
    function copyFileFolder(){
        //请求参数
        // 0706替换云空间接口
        var paramet = {"token":getUrl("cloudToken"),"pid":Controller.pid,"uuid":getUrl("uuid")};
        http(ServerConfig.cloudDomain+"/"+skinConfig(global.skin).skinUrl+"/copyFile",paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    paste(-1);//调用粘贴方法
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        failComplete(arg.msg);//调用失败方法
                    }
                }
            }
        });
    }
    //粘贴方法
    function paste(conflictUuid){
        //请求参数
        // 替换云空间接口
        var paramet = {"token":getUrl("cloudToken"),"uuid":Controller.pid,"conflict_uuid":conflictUuid};
        http(ServerConfig.cloudDomain+"/"+skinConfig(global.skin).skinUrl+"/pasteFile",paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    Shell.sendEvent("commonChange",{"pageName":"djmyspace","nav":Controller.navArray,"pid":Controller.pid,"title":Controller.title});//通知原生首页需要刷新
                    successComplete();//调用移出成功方法
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else if(arg.msg == "重名冲突"){
                        animationStop();//调用动画暂停方法
                        Controller.isCopyClick = true;
                        //初始化冲突提示
                        var deleteMask = $("<div style='z-index:1;'></div>").appendTo($("body"));
                        deleteMask.CommonDeleteMask({
                            "title":"冲突提示！",
                            "text":"目标文件夹已有相同文件（夹），是否继续如果继续系统将自动重命名",
                            "determineBtn":"继续"
                        });
                        //监听取消事件
                        deleteMask.bind("DELETE_MASK_CANCEL",function(){
                            Shell.sendEvent("commonChange",{"pageName":"djmyspace"});//通知原生首页需要刷新
                            initAnimation();//调用重置动画方法
                        });
                        //监听确定事件
                        deleteMask.bind("DELETE_MASK_DETERMINE",function(){
                            // 防止多次点击
                            if(Controller.isCopyClick) {
                                Controller.isCopyClick = false;
                                deleteMask.CommonDeleteMask("removeMask");//调用询问组件删除方法
                                setTimeout(function(){
                                    paste(arg.data.conflict_uuid);//调用自己本身
                                }, 500);
                            }
                        });
                    }else{
                        failComplete(arg.msg);//调用失败方法
                    }
                }
            }
        });
    }
    //动画开始方法
    function showAnimation(){
        Controller.effect.css("display","");
        Controller.animationTime = setInterval(function(){
            if(Controller.wid < 98){
                Controller.wid += 2;
                Controller.effect.children("div").css("width",Controller.wid + "%");
                Controller.effect.children("p").html("正在复制" + " " + Controller.wid + "%");
            }else{
                clearInterval(Controller.animationTime);
            }
        },20);
    }
    //动画暂停方法
    function animationStop(){
        clearInterval(Controller.animationTime);//清除动画
    }
    //重置动画方法
    function initAnimation(){
        Controller.effect.css("display","none");
        Controller.cancelBtn.css("display","none");
        Controller.effect.children("div").css("width","0%");
        Controller.effect.children("p").html("正在复制" + " " + "0%");
        Controller.isClick = true;//允许点击
        Controller.wid = 0;//重置动画宽度
        lock("no");//解锁页面
        Controller.searchContainer.CommonSearch("lock","no");//解锁搜索组件
        Controller.iscrollContainer.CommonIscroll("isIscroll","no");//解锁滚动容器滚动
    }
    //成功完成方法
    function successComplete(text){
        clearInterval(Controller.animationTime);
        Controller.animationTime = setInterval(function(){
            if(Controller.wid < 98){
                Controller.wid += 2;
                Controller.effect.children("div").css("width",Controller.wid + "%");
                Controller.effect.children("p").html("正在复制" + " " + Controller.wid + "%");
            }else{
                clearInterval(Controller.animationTime);
                Controller.effect.children("div").css({"width":"100%"});
                if(text != undefined && text != null && text != ""){
                    Controller.effect.children("p").html(text);
                }else{
                    Controller.effect.children("p").html("复制成功");
                }
                //延迟2s关闭组件
                setTimeout(function(){
                    Shell.sendEvent("closeWin");//关闭当前页面
                },1500);
            }
        },20);
    }
    //失败完成方法
    function failComplete(text){
        clearInterval(Controller.animationTime);
        Controller.wid = 0;
        Controller.effect.children("div").css("width","100%");
        if(text != undefined && text != null && text != ""){
            Controller.effect.children("p").html(text);
        }else{
            Controller.effect.children("p").html("复制失败");
        }
        //延迟2s将失败提示去除
        setTimeout(function(){
            Controller.isClick = true;//禁止点击
            lock("no");//解锁整个页面
            Controller.searchContainer.CommonSearch("lock","no");//解锁搜索组件
            Controller.iscrollContainer.CommonIscroll("isIscroll","no");//解锁滚动容器滚动
            Controller.effect.children("div").css("width","0%");
            Controller.effect.children("p").html("正在复制..." + " " + "0%");
            Controller.effect.css("display","none");
            Controller.cancelBtn.css("display","none");
        },2000);
    }


    //批量复制失败完成方法
    function failCompleteBatchCopy(text){
        clearInterval(Controller.animationTime);
        Controller.wid = 0;
        Controller.effectBatchCopy.children("div").css("width","100%");
        Controller.effectBatchCopy.css("display","");
        if(text != undefined && text != null && text != ""){
            Controller.effectBatchCopy.children("p").html(text);
        }else{
            Controller.effectBatchCopy.children("p").html("复制失败");
        }
        //延迟2s将失败提示去除
        setTimeout(function(){
            Controller.isClick = true;//禁止点击
            lock("no");//解锁整个页面
            Controller.searchContainer.CommonSearch("lock","no");//解锁搜索组件
            Controller.iscrollContainer.CommonIscroll("isIscroll","no");//解锁滚动容器滚动
            Controller.effectBatchCopy.children("div").css("width","0%");
            Controller.effectBatchCopy.children("p").html("正在复制..." + " " + "0%");
            Controller.effectBatchCopy.css("display","none");
            Controller.cancelBtn.css("display","none");
            Shell.sendEvent("closeWin");//关闭当前页面
        },2000);
    }


    /****************批量操作***********************/
    //批量操作添加任务的方法
    function testingTaskNumber(id,target_file_id){
        $.ajax({
            cache:false,
            type:"POST",
            url:ServerConfig.cloudDomain+"/Filemapmultitask/addTask",
            data:{"token":getUrl("cloudToken"),"file_id":id,"space_type":"my_space","deal_type":"move","target_file_id":target_file_id},
            dataType:"json",
            async:false,
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    if(arg.data.need_batch_deal == "yes" && arg.data.task_id != ""){
                        Controller.toastContainer.CommonToast("showToast","正在获取数据，请稍后...");//显示飘窗提示
                        testingTask(arg.data.task_id);//调用批量检测任务的方法
                    }
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else if(arg.msg == "不需要批量操作"){
                        showAnimation();//显示动画
                        copyFileFolder();//调用复制文件方法
                    }else{
                        api.toast({msg:arg.msg,duration:2000,location:"middle"});
                        setTimeout(function(){
                            initAnimation();//调用重置动画方法
                        },1500)
                    }
                }
            },
            error:function(xhr,ajaxOptions,thrownError){ 
                api.toast({msg:"网络异常，请稍候再试...",duration:2000,location:"middle"});
            }
        });
    }
    //检测任务是否完成方法
    function testingTask(taskId){
        var paramet = {"token":getUrl("cloudToken"),"task_id":taskId};
        http(ServerConfig.cloudDomain+"/Filemapmultitask/checkTask",paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    //判断任务是否完成
                    if(arg.data.list.length == 0 && arg.msg == "任务没有完成"){
                        setTimeout(function(){
                            testingTask(taskId);//调用自己本身进行轮询
                        },1000);
                    }else{
                        Controller.toastContainer.CommonToast("hideToast");//飘窗消失方法
                        Controller.batchTotal = arg.data.list.length;
                        Controller.batch_id_arr = arg.data.list;//获取批量id数组
                        Controller.firstBatchConflictId = "";
                        batchCopy(taskId,arg.data.list,"-1");//调用批量复制的方法

                        Controller.cancelBtn.css("display","");
                        //监听取消按钮点击事件
                        Controller.cancelBtn.unbind("click").bind("click",function(){
                            Controller.isCancelChange = true;//是否处于取消任务状态
                            var commonCancelMsk = $("<div style='z-index:3;'></div>").appendTo($("body"));
                            commonCancelMsk.CommonDeleteMask({"text":"确定取消此次批量复制任务吗？"});
                            //监听取消事件  
                            commonCancelMsk.bind("DELETE_MASK_CANCEL",function(){
                                Controller.isCancelChange = false;//是否处于取消任务状态
                                batchCopy(taskId,Controller.batch_id_arr,"-1");//调用批量复制的方法
                            });
                            //监听确定事件
                            commonCancelMsk.bind("DELETE_MASK_DETERMINE",function(){
                                commonCancelMsk.CommonDeleteMask("removeMask");//调用询问组件的隐藏组件方法
                                Shell.sendEvent("commonChange",{"pageName":"djmyspace"});//通知原生首页需要刷新
                                initAnimation();//调用重置动画方法
                                Controller.batchId = taskId;
                                Controller.isCancelChange = false;//是否处于取消任务状态
                            });
                        });
                    }
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        try{
                            api.toast({msg:arg.msg,duration:2000,location:"middle"});
                        }catch(e){}
                    }
                }
            }
        });
    }
    //批量复制的方法
    function batchCopy(taskId,numberArr,conflict_uuid){
        var paramet = {"token":getUrl("cloudToken"),"task_id":taskId,"group_number":numberArr[0].group_number,"conflict_uuid":conflict_uuid};
        http(ServerConfig.cloudDomain+"/"+skinConfig(global.skin).skinUrl+"/batchCopyFile",paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    //判断是否处于取消任务状态
                    if(!Controller.isCancelChange){
                        numberArr.splice(0,1);//删除数组第一个数据
                        setSpeed(Controller.batchTotal,numberArr);//调用批量操作设置进度条的方法
                        Controller.batch_id_arr = numberArr;
                        //判断是否删除完成
                        if(numberArr.length > 0){
                            batchCopy(taskId,numberArr,"-1");
                        }else{
                            Shell.sendEvent("commonChange",{"pageName":"djmyspace","nav":Controller.navArray,"pid":Controller.pid,"title":Controller.title});//通知原生首页需要刷新
                            //延迟2s关闭组件
                            setTimeout(function(){
                                Shell.sendEvent("closeWin");//关闭当前页面
                            },1500);
                        }
                    }
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        cancelTask(taskId);//调用取消任务的方法
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else if(arg.msg == "文件冲突,请解决冲突文件"){
                        //判断是否存在第一次冲突id
                        if(Controller.firstBatchConflictId != ""){
                            batchCopy(taskId,numberArr,Controller.firstBatchConflictId);//调用自己本身
                            return;
                        }
                        //初始化冲突提示
                        var deleteMask = $("<div style='z-index:1;'></div>").appendTo($("body"));
                        deleteMask.CommonDeleteMask({
                            "title":"冲突提示！",
                            "text":"目标文件夹已有相同文件（夹），是否继续如果继续系统将自动重命名",
                            "determineBtn":"继续"
                        });
                        //监听取消事件
                        deleteMask.bind("DELETE_MASK_CANCEL",function(){
                            Shell.sendEvent("commonChange",{"pageName":"djmyspace"});//通知原生首页需要刷新
                            initAnimation();//调用重置动画方法
                            Controller.batchId = taskId;
                        });
                        //监听确定事件
                        deleteMask.bind("DELETE_MASK_DETERMINE",function(){
                            Controller.firstBatchConflictId = arg.data.conflict_uuid;
                            deleteMask.CommonDeleteMask("removeMask");//调用询问组件删除方法
                            batchCopy(taskId,numberArr,arg.data.conflict_uuid);//调用自己本身
                        });
                    }else{
                        failCompleteBatchCopy(arg.msg);//调用失败方法
                        cancelTask(taskId);//调用取消任务的方法
                    }
                }
            }
        });
    }
    //取消任务的方法
    function cancelTask(taskId){
        var paramet = {"token":getUrl("cloudToken"),"task_id":taskId};
        http(ServerConfig.cloudDomain+"/Filemapmultitask/cancelTask",paramet,{
            success:function(arg){
                if(arg.code == 1){
                    Controller.isCancelChange = false;//是否处于取消任务状态
                    Shell.sendEvent("commonChange",{"pageName":"djmyspace"});//通知原生首页需要刷新
                    initAnimation();//调用重置动画方法
                    Controller.batchId = "";
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        try{
                            api.toast({msg:arg.msg,duration:2000,location:"middle"});
                        }catch(e){}
                    }
                }
            }
        });
    }
    //批量操作设置进度条的方法
    function setSpeed(total,arr){
        Controller.effect.css("display","");
        var everyWidth = ((1/total)*100).toFixed(2);//计算每次前进宽度百分比
        var num = Math.ceil((total - arr.length)*everyWidth);
        //判断当批量操作完成后，进度条长度不足
        if(arr.length == 0 && num < 100){
            num = 100;
        }
        //判断进度条长度大于100%时，纠正为100%
        if(num >= 100){
            num = 100;
        }
        Controller.effect.children("div").css("width",num + "%");
        if(num == 100){
            Controller.effect.children("p").html("复制成功");
            Controller.cancelBtn.css("display","none");
        }else{
            Controller.effect.children("p").html("正在复制" + " " + num + "%");
        }
    }
    return Controller;
});
