/*
*   2020年12月8日
*
*   个人空间分享链接页面
*
*   开发者：付长建
*/
define(["jquery","Shell","Fastclick","CommonHead","CommonToast",],function($,Shell,Fastclick){
    var Controller = {
        data:{},//分享数据
        timeArray:["1天","15天","30天","永久"],
        pwdArray:["A","B","C","D","E","F","G","H","I","J","K","R","M","N","O","P","Q","S","T","U","V","W","S","Y","Z","X"],
        isClick:true,//防止不停触发点击事件
        _pwd:"",//密码
        _validTime:"",//有效时间
        _validTimeText:"永久",//时间显示文字
        _linkUrl:"",//创建成功的链接
        //页面加载成功执行的方法
        init:function(){
            $("body").css("opacity",0);
            Controller.data = decode(getUrl("pam"));
            //设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            //禁止整个页面滚动
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});
            //获取配置信息
            // 替换云空间配置接口 0715
            http(ServerConfig.cloudDomain+"/Setting/getGlobal",{"token":getUrl("cloudToken")},{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        global.userInfo = arg.data.userInfo;//得到用户信息
                        global.preview_config = arg.data.preview_config;//得到文件预览配置
                        global.is_thumb_model = arg.data.is_thumb_model;//得到是否显示搜索图
                        global.thumb_width_height_config = arg.data.thumb_width_height_config;//得到缩略图配置
                        global.skin = arg.data.skin_name;//得到皮肤配置
                        global.is_yingshuo = arg.data.is_yingshuo;//得到是否显示云笔记筛选选项
                        global.version = arg.data.version;//得到当前是哪个版本
                        Controller.create();//生成页面
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            try{
                                api.toast({msg:arg.msg,duration:2000,location:"middle"});
                            }catch(e){}
                        }
                    }
                }
            });
            //监听ajax请求错误
            $(window).bind("HTTP_REQUEST_ERROR",function(event,msg){
                try{
                    api.toast({msg:msg,duration:2000,location:"middle"});
                }catch(e){}
            });
        },
        //生成页面方法
        create:function(){
            //创建飘窗提示元素
            this.toastContainer = $("<div></div>").CommonToast().appendTo($("body"));
            ///初始化头部组件
            this._headContainer = $("<div style='background:#fff;'></div>").appendTo($("body"));
            this._headContainer.CommonHead({"isGoback":true,"title":"创建链接"});

            //创建文件分享有效期板块
            this._linkTimeContainer = $("<div style='width:100%;margin-top:0.1rem;'></div>").appendTo($("body"));
            this._timeContainer = $("<div style='width:100%;background:#fff;overflow:hidden;'></div>").appendTo(this._linkTimeContainer);
            $("<p style='font-size:0.14rem;margin:0.1rem 0 0.15rem 0;padding-left:0.15rem;box-sizing:border-box;'>文件分享有效期</p>").appendTo(this._timeContainer);
            this._timeContent = $("<ul style='width:100%;display:flex;flex-direction:row;margin-bottom:0.1rem;'></ul>").appendTo(this._timeContainer);
            for(var i = 0; i < Controller.timeArray.length; i++){
                var li = $("<li style='width:25%;height:0.3rem;display:flex;flex-direction:row;align-items:center;justify-content:center;flex-shrink:0;'></li>").appendTo(this._timeContent);
                var selectContainer = $("<div style='width:0.19rem;height:0.19rem;border:1px solid #ECECEC;box-sizing:border-box;display:flex;align-items:center;justify-content:center;border-radius:50%;'></div>").appendTo(li);
                $("<div style='width:0.11rem;height:0.11rem;border-radius:50%;background:"+skinConfig(global.skin).backColor+";display:none;'></div>").appendTo(selectContainer);
                $("<span style='font-size:0.12rem;color:rgb(66,78,103);margin-left:0.05rem;font-weight:bold;'>"+Controller.timeArray[i]+"</span>").appendTo(li);
                if(i == Controller.timeArray.length - 1){
                    selectContainer.children("div").css("display","");
                    li.addClass("select");
                }
            }

            //创建密码开关容器
            var pwdContainer = $("<div style='width:100%;height:0.44rem;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;background:#fff;display:flex;flex-direction:row;margin-top:0.2rem;justify-content:space-between;'></div>").appendTo(this._linkTimeContainer);
            $("<p style='height:100%;display:flex;align-items:center;font-size:0.14rem;'>加密分享</p>").appendTo(pwdContainer);
            this._pwdSwitchContainer = $("<div style='height:100%;display:flex;align-items:center;'></div>").appendTo(pwdContainer);
            this._pwdSwitch = $("<div isSwitch='no' style='width:52px;height:30px;border-radius:0.2rem;border:1px solid #dfdfdf;box-sizing:border-box;background:#fff;position:relative;transition:all 0.3s;'></div>").appendTo(this._pwdSwitchContainer);
            $("<div style='width:28px;height:28px;border-radius:50%;background:#fff;box-shadow:0 1px 3px rgba(0, 0, 0, 0.4);position:absolute;top:0;left:0;transition:all 0.3s;'></div>").appendTo(this._pwdSwitch);

            //链接创建成功板块
            this._successContainer = $("<div style='width:100%;padding:0.1rem 0.15rem 0.1rem 0.15rem;margin-top:0.1rem;box-sizing:border-box;background:#fff;display:none;'></div>").appendTo($("body"));
            $("<p style='width:100%;height:0.4rem;line-height:0.4rem;font-size:0.16rem;color:rgb(102,102,102);display:-webkit-box;-webkit-line-clamp:1;-webkit-box-orient:vertical;text-overflow:ellipsis;white-space:nowrap;overflow:hidden;'></p>").appendTo(this._successContainer);
            $("<p style='width:100%;height:0.4rem;line-height:0.4rem;font-size:0.16rem;color:rgb(102,102,102);'></p>").appendTo(this._successContainer);
            $("<p style='width:100%;height:0.4rem;line-height:0.4rem;font-size:0.16rem;color:rgb(102,102,102);'></p>").appendTo(this._successContainer);

            //创建按钮
            this._btnContainer = $("<div style='width:100%;height:0.5rem;padding:0 0.3rem 0 0.3rem;box-sizing:border-box;margin-top:0.8rem;'></div>").appendTo($("body"));
            this._btn = $("<div data='next' style='width:100%;height:100%;display:flex;align-items:center;justify-content:center;background:"+skinConfig(global.skin).linearBackColor+";font-size:0.18rem;color:#fff;border-radius:0.25rem;'>下一步</div>").appendTo(this._btnContainer);

            //监听头部组件点击返回按钮
            this._headContainer.bind("GOBACK_BTN_CLICK",function(){
                Shell.sendEvent("closeWin");//关闭当前页面
            });
            //给有效时间选项绑定点击事件
            this._timeContent.find("li").bind("click",function(){
                Controller._timeContainer.find("li").removeClass("select");
                Controller._timeContainer.find("li").children("div").children("div").css("display","none");
                $(this).addClass("select");
                $(this).children("div").children("div").css("display","");
                Controller._validTime = Date.parse(new Date()) / 1000;//有效时间
                if($(this).children("span").html() == "1天"){
                    Controller._validTime = Controller._validTime + 24 * 60 * 60;
                    Controller._validTimeText = "1天";
                }else if($(this).children("span").html() == "15天"){
                    Controller._validTime = Controller._validTime + 15 * 24 * 60 * 60;
                    Controller._validTimeText = "15天";
                }else if($(this).children("span").html() == "30天"){
                    Controller._validTime = Controller._validTime + 30 * 24 * 60 * 60;
                    Controller._validTimeText = "30天";
                }else if($(this).children("span").html() == "永久"){
                    Controller._validTime = 0;
                    Controller._validTimeText = "";
                }
            });
            //给加密分享按钮绑定点击事件
            this._pwdSwitch.bind("click",function(){
                if($(this).attr("isSwitch") == "no"){
                    $(this).children("div").css("left","22px");
                    $(this).css({"background":skinConfig(global.skin).backColor,"border-color":skinConfig(global.skin).backColor});
                    $(this).attr("isSwitch","yes");
                    for(var i = 0; i < 4; i++){
                        Controller._pwd = Controller._pwd + Controller.pwdArray[Math.floor(Math.random() * Controller.pwdArray.length)];
                    }
                }else{
                    $(this).children("div").css("left","0px");
                    $(this).css({"background":"#fff","border-color":"#dfdfdf"});
                    $(this).attr("isSwitch","no");
                    Controller._pwd = "";
                }
            });
            //给按钮绑定点击事件
            this._btn.bind("click",function(){
                //判读多次执行
                if(Controller.isClick){
                    Controller.isClick = false;
                    Controller._headContainer.CommonHead("lock","yes");//锁定头部组件禁止点击
                    Controller._headContainer.CommonHead("changeGobackBtnColor","yes");//改变返回按钮的颜色
                    //判断当前是下一步还是完成并复制按钮
                    if($(this).attr("data") == "next"){
                        $(this).attr("data","success");
                        establishLink();//调用创建链接方法
                    }else{
                        Shell.sendEvent("copyLink",{"name":Controller._linkUrl});
                        Controller.toastContainer.CommonToast("showToast","复制成功");
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");
                            Shell.sendEvent("closeWin");//关闭当前页面
                        },1500);
                    }
                }
            });

            //按钮按下抬起效果
            btnTextCommon(this._btn);
            //解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
            //通知原生加载完毕
            Shell.sendPageReady();
            $("body").fadeTo("slow",1);
        }
    }
    //所有的按钮和可以点击的文本按下和抬起事件方法
    function btnTextCommon(element){
        //给选项绑定手指按下事件
        element.bind('touchstart',function(){
            $(this).css("opacity","0.5");
        });
        //给选项绑定手指抬起事件
        element.bind('touchend',function(){
            $(this).css("opacity","");
        });
    }
    //创建链接方法
    function establishLink(){
        //如果两秒都还没有得到接口返回提示正在创建链接提示
        Controller._time = setTimeout(function(){
            Controller.toastContainer.CommonToast("showToast","正在创建链接，请稍后...");
        },2000);
        //请求参数
        // 0706替换云空间接口
        var paramet = {"token":getUrl("cloudToken"),"uuid":Controller.data.uuid,"name":Controller.data.name,"visit_password":Controller._pwd,"overtime":Controller._validTime,"type":0};
        http(ServerConfig.cloudDomain+"/"+skinConfig(global.skin).linkshare+"/createTask",paramet,{
            success:function(arg){
                clearTimeout(Controller._time);//清除延时
                if(parseInt(arg.code) == 1){
                    //判断飘窗是否显示了
                    if(Controller.toastContainer.attr("isShow") != "no"){
                        Controller.toastContainer.CommonToast("showToast","创建成功");//显示飘窗提示
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            Controller._headContainer.CommonHead("lock","no");//解锁头部组件禁止点击
                            Controller.isClick = true;//允许点击
                            Controller._headContainer.CommonHead("changeGobackBtnColor","no");//改变返回按钮的颜色
                        },1500);
                    }else{
                        Controller._headContainer.CommonHead("lock","no");//解锁头部组件禁止点击
                        Controller._headContainer.CommonHead("changeGobackBtnColor","no");//改变返回按钮的颜色
                        Controller.isClick = true;//允许点击
                    }
                    Controller._linkUrl = "链接：" + arg.data.url + (Controller._pwd != "" ? " 密码：" + Controller._pwd : "");
                    Controller._successContainer.find("p").eq(0).html("链接：" + arg.data.url);
                    Controller._successContainer.find("p").eq(1).html("分享文件有效期：" + Controller._validTimeText);
                    //判断是否有密码
                    if(Controller._pwd != ""){
                        Controller._successContainer.find("p").eq(2).html("提取密码：" + Controller._pwd);
                    }else{
                        Controller._successContainer.find("p").eq(2).css("display","none");
                    }
                    Controller._linkTimeContainer.css("display","none");
                    Controller._successContainer.css("display","");
                    Controller._btnContainer.css("margin-top","0.88rem");
                    Controller._headContainer.CommonHead("changeTitle","复制链接");//改变头部title文字
                    Controller._btn.html("完成并复制链接");
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        //判断飘窗是否显示了
                        if(Controller.toastContainer.attr("isShow") == "no"){
                            Controller.toastContainer.CommonToast("showToast",arg.msg);//显示飘窗提示
                        }else{
                            Controller.toastContainer.CommonToast("changeText",arg.msg);//改变提示文字
                        }
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            Controller._headContainer.CommonHead("lock","no");//解锁头部组件禁止点击
                            Controller._headContainer.CommonHead("changeGobackBtnColor","no");//改变返回按钮的颜色
                            Controller.isClick = true;//允许点击
                        },1500);
                    }
                }
            }
        });
    }
    return Controller;
});
