/*
*   2020年12月8日
*
*   个人空间重命名文件或者文件夹页面
*
*   开发者：付长建
*/
define(["jquery","Shell","Fastclick","CommonToast","CommonHead","CommonDeleteMask"],function($,Shell,Fastclick){
    var Controller = {
        isClik:true,//防止多次触发
        data:{},//重命名数据
        //页面加载成功执行的方法
        init:function(){
            Controller.data = decode(getUrl("pam"));
            $("body").css("opacity",0);
            //设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            //禁止整个页面滚动
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});
            //获取配置信息
            // 替换云空间配置接口 0715
            http(ServerConfig.cloudDomain+"/Setting/getGlobal",{"token":getUrl("cloudToken")},{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        global.userInfo = arg.data.userInfo;//得到用户信息
                        global.preview_config = arg.data.preview_config;//得到文件预览配置
                        global.is_thumb_model = arg.data.is_thumb_model;//得到是否显示搜索图
                        global.thumb_width_height_config = arg.data.thumb_width_height_config;//得到缩略图配置
                        global.skin = arg.data.skin_name;//得到皮肤配置
                        global.is_yingshuo = arg.data.is_yingshuo;//得到是否显示云笔记筛选选项
                        global.version = arg.data.version;//得到当前是哪个版本
                        Controller.create();//调用创建页面方法
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            try{
                                api.toast({msg:arg.msg,duration:2000,location:"middle"});
                            }catch(e){}
                        }
                    }
                }
            });
            //监听ajax请求错误
            $(window).bind("HTTP_REQUEST_ERROR",function(event,msg){
                try{
                    api.toast({msg:msg,duration:2000,location:"middle"});
                }catch(e){}
            });
        },
        //生成页面
        create:function(){
            //创建飘窗提示元素
            this.toastContainer = $("<div></div>").CommonToast().appendTo($("body"));
            //初始化头部组件
            this.headContainer = $("<div></div>").appendTo($("body"));
            var name = Controller.data.isdir == "1" ? "重命名文件夹" : "重命名文件";
            this.headContainer.CommonHead({"title":name,"isGoback":true,"isDetermine":true,"fontWeigth":500,"isGobackEvent":"touchend"});

            //创建输入框
            var inputContainer = $("<div style='width:100%;height:0.5rem;padding:0 0.2rem 0 0.2rem;box-sizing:border-box;margin-top:0.9rem;position:relative;'></div>").appendTo($("body"));
            var form = $("<form style='width:100%;height:100%;'></form>").appendTo(inputContainer);
            this.input = $("<input value='"+Controller.data.name+"' style='width:100%;height:100%;padding-right:0.3rem;border-bottom:1px solid #ECECEC;box-sizing:border-box;font-size:0.14rem;' type='text'/>").appendTo(form);
            this.emptyIcon = $("<div class='emptyBtn' style='width:0.5rem;height:100%;position:absolute;top:0;right:0;display:flex;align-items:center;justify-content:center;'></div>").appendTo(inputContainer);
            $("<img style='width:0.15rem;' src='"+skinConfig(global.skin).commonIcon+"signin_icon.png'/>").appendTo(this.emptyIcon);
            //创建遮罩层
            this.maskContainer = $("<div style='width:100%;height:100%;position:absolute;top:0;left:0;display:none;'></div>").appendTo($("body"));
            //给清除输入框的值的图标绑定事件
            inputContainer.find(".emptyBtn")[0].addEventListener("touchend",function(event){
                try {
                    event.stopPropagation();
                    event.preventDefault();
                }catch(event){
                    console.log('阻止冒泡失败');
                }
                Controller.input.val("");
                Controller.input.focus();
                Controller.emptyIcon.children("img").css("display","none");
                Controller.headContainer.CommonHead("changeDetermineBtnColor","yes");//调用头部组件改变确定按钮的颜色（表示禁用）
                Controller.isClik = false;
            },true);
            //禁止表单提交
            inputContainer.find("form").submit(function(){
                return false;
            });
            //监听头部组件点击返回按钮
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                Shell.sendEvent("closeWin");//关闭当前页面
            });
            //监听头部组件点击确定按钮
            this.headContainer.bind("DETERMINE_BTN_CLICK",function(){
                //判断多次执行
                if(Controller.isClik){
                    Controller.isClik = false;
                    //判断值是否为空
                    if(Controller.input.val().replace(/[ ]/g,"") != ""){
                        lock("yes");//锁定页面
                        fileRename(Controller.input.val(),0);
                    }
                }
            });
            //实时监听输入框的值发生改变
            this.input.bind("input change",function(){
                if(Controller.input.val().replace(/[ ]/g,"") != ""){
                    Controller.emptyIcon.children("img").css("display","");
                    Controller.headContainer.CommonHead("changeDetermineBtnColor","no");//调用头部组件改变确定按钮的颜色（表示禁用）
                    Controller.isClik = true;
                }else{
                    Controller.emptyIcon.children("img").css("display","none");
                    Controller.headContainer.CommonHead("changeDetermineBtnColor","yes");//调用头部组件改变确定按钮的颜色（表示禁用）
                    Controller.isClik = false;
                }
            });
            //给输入框绑定软键盘监听事件
            this.input.keypress(function(event){
                if(event.keyCode == 13){
                    Controller.headContainer.trigger("DETERMINE_BTN_CLICK");//模拟点击确定按钮
                }
            });
            //解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
            Shell.sendPageReady();
            $("body").fadeTo("slow",1);
            //给原生抛出加载完成事件
            setTimeout(function(){
                Controller.input.focus();//默认获取焦点
                Controller.input.select();//默认选中输入框的值
            },500);
        }
    }
    //解除锁定和锁定方法
    function lock(type){
        if(type == "yes"){
            Controller.maskContainer.css("display","");
            Controller.headContainer.CommonHead("changeGobackBtnColor","yes");
            Controller.headContainer.CommonHead("changeBtnColor","yes");
        }else{
            Controller.maskContainer.css("display","none");
            Controller.headContainer.CommonHead("changeGobackBtnColor","no");
            Controller.headContainer.CommonHead("changeBtnColor","no");
            Controller.isClik = true;
        }
    }
    //重命名方法
    function fileRename(name,rename){
        //判断名称是否改变
        if(name == Controller.data.name){
            Controller.toastContainer.CommonToast("showToast","文件名没有发生任何改变");//显示飘窗提示
            //飘窗提示后2s后删除飘窗
            setTimeout(function(){
                Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                lock("no");//解锁页面
            },1500);
            return;
        }
        //如果两秒都还没有得到接口返回提示正在删除提示
        Controller.time = setTimeout(function(){
            Controller.toastContainer.CommonToast("showToast","重命名中，请稍后...");//显示飘窗提示
        },2000);
        //判断是重命名文件还是文件夹
        // 替换云空间接口
        if(Controller.data.isdir == "1"){
            url = ServerConfig.cloudDomain+"/"+skinConfig(global.skin).skinUrl+"/renameFolder";//重命名文件夹接口
        }else{
            var url = ServerConfig.cloudDomain+"/"+skinConfig(global.skin).skinUrl+"/renameFile";//重命名文件接口
        }
        //请求参数
        var paramet = {"token":getUrl("cloudToken"),"uuid":Controller.data.uuid,"name":name,"rename":rename};
        http(url,paramet,{
            success:function(arg){
                clearTimeout(Controller.time);//清除延时
                if(parseInt(arg.code) == 1){
                    Shell.sendEvent("commonChange",{"pageName":"djmyspace"});//通知原生我首页需要刷新
                    //判断是否有提示
                    if(Controller.toastContainer.attr("isShow") == "no"){
                        Controller.toastContainer.CommonToast("showToast","重命名成功");//显示飘窗提示
                    }else{
                        Controller.toastContainer.CommonToast("changeText","重命名成功");//改变提示文字
                    }
                    //飘窗提示后2s后删除飘窗
                    setTimeout(function(){
                        Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                        Shell.sendEvent("closeWin");//关闭当前页面
                    },1500);
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else if(arg.msg == "同名文件存在" || arg.msg == "同名文件夹存在"){
                        //初始化冲突提示
                        var text = arg.msg == "同名文件存在" ? "文件" : "文件夹";//得到是文件冲突还是文件夹冲突
                        var deleteMask = $("<div style='z-index:1;'></div>").appendTo($("body"));
                        deleteMask.CommonDeleteMask({
                            "title":"冲突提示！",
                            "text":"当前目录已有相同"+text+"名称，是否继续如果继续系统将自动重命名",
                            "determineBtn":"继续"
                        });
                        //监听取消事件
                        deleteMask.bind("DELETE_MASK_CANCEL",function(){
                            lock("no");//解锁页面
                        });
                        //监听确定事件
                        deleteMask.bind("DELETE_MASK_DETERMINE",function(){
                            deleteMask.CommonDeleteMask("removeMask");//调用询问组件删除方法
                            fileRename(name,1);//调用自己本身
                        });
                    }else{
                        //判断是否有提示
                        if(Controller.toastContainer.attr("isShow") == "no"){
                            Controller.toastContainer.CommonToast("showToast",arg.msg);//显示飘窗提示
                        }else{
                            Controller.toastContainer.CommonToast("changeText",arg.msg);//改变提示文字
                        }
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            lock("no");//解锁页面
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                        },1500);
                    }
                }
            }
        });
    }
    return Controller;
});
