/*
*   2020年12月6日
*
*   链接分享首页js控制器
*
*   开发者：付长建
*/
define(["jquery","Shell","Fastclick","ApiConfig","CommonToast","CommonDeleteMask","CommonHead","CommonIscroll","CommonBottonMenu","LinkCell"],function($,Shell,Fastclick,ApiConfig){
    var Controller = {
        maxContainer:null,//页面最大容器
        toastContainer:null,//飘窗组件
        headContainer:null,//头部组件
        switchLabelContainer:null,//切换标签容器
        switchContainer:null,//切换容器
        myLinkIscroll:null,//我的链接滚动容器
        otherLinkIscroll:null,//他人链接滚动容器
        bottonMenuContainer:null,//底部操作菜单
        pageName:"linkshare",//主要用于监听原生事件刷新列表使用
        myOffset:0,//我的链接数据请求偏移量
        otherOffset:0,//他人链接数据请求偏移量
        selectData:[],//选中数据数组
        selectSize:2,//控制新生成的节点勾选图标大小参数2是小1是大
        //页面加载成功执行的方法
        init:function(){
            $("body").css("opacity",0);
            //设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            //禁止整个页面滚动
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});
            //获取配置信息
            //替换云空间配置接口 0715
            http(ServerConfig.cloudDomain+"/Setting/getGlobal",{"token":getUrl("cloudToken")},{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        global.userInfo = arg.data.userInfo;//得到用户信息
                        global.preview_config = arg.data.preview_config;//得到文件预览配置
                        global.is_thumb_model = arg.data.is_thumb_model;//得到是否显示搜索图
                        global.thumb_width_height_config = arg.data.thumb_width_height_config;//得到缩略图配置
                        global.skin = arg.data.skin_name;//得到皮肤配置
                        global.is_yingshuo = arg.data.is_yingshuo;//得到是否显示云笔记筛选选项
                        global.version = arg.data.version;//得到当前是哪个版本
                        Controller.create();//调用创建页面方法
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            try{
                                api.toast({msg:arg.msg,duration:2000,location:"middle"});
                            }catch(e){}
                        }
                    }
                }
            });
            //监听ajax请求错误
            $(window).bind("HTTP_REQUEST_ERROR",function(event,msg){
                try{
                    api.toast({msg:msg,duration:2000,location:"middle"});
                }catch(e){}
            });
        },
        //生成页面
        create:function(){
            //初始化飘窗组件
            this.toastContainer =$("<div></div>").CommonToast().appendTo($("body"));
            //创建页面最大容器元素
            this.maxContainer = $("<div style='width:100%;height:100%;background:#fff;overflow:hidden;'></div>").appendTo($("body"));
            //创建页面头部
            this.headContainer = $("<div></div>").appendTo(this.maxContainer);
            this.headContainer.CommonHead({
                "title":"分享链接",
                "isGoback":true
            });
            //创建分享链接和他人链接切换标签
            this.switchLabelContainer = $("<ul style='width:100%;height:0.44rem;display:flex;flex-direction:row;background:#fff;box-shadow:0px 3px 4px 1px rgba(0,37,87,0.06);position:relative;'></ul>").appendTo(this.maxContainer);
            var myLink = $("<li data='myLink' style='width:50%;height:100%;display:flex;flex-direction:column;align-items:center;justify-content:center;font-size:0.14rem;font-weight:bold;color:"+skinConfig(global.skin).selectFontColor+"'><span>我的链接</span></li>").appendTo(this.switchLabelContainer);
            $("<p style='width:15px;height:3px;border-radius:2px;background:"+skinConfig(global.skin).backColor+";margin-top:5px;transition:all 0.3s;opacity:1;'></p>").appendTo(myLink);
            var otherLink = $("<li data='otherLink' style='width:50%;height:100%;display:flex;flex-direction:column;align-items:center;justify-content:center;font-size:0.14rem;font-weight:bold;'><span>他人链接</span></li>").appendTo(this.switchLabelContainer);
            $("<p style='width:15px;height:3px;border-radius:2px;background:"+skinConfig(global.skin).backColor+";margin-top:5px;transition:all 0.3s;opacity:0;'></p>").appendTo(otherLink);
            //创建内容体最外层容器
            var safeHeight = phonexh("bottom") == 0 ? 0 : 0;
            var h = this.maxContainer.height() - this.headContainer.outerHeight(true) - this.switchLabelContainer.height() - safeHeight;
            var contentContainer = $("<div style='width:100%;height:"+h+"px;background:#fff;overflow:hidden;'></div>").appendTo(this.maxContainer);
            //创建切换容器
            this.switchContainer = $("<div style='width:"+(contentContainer.width() * 2)+"px;height:100%;display:flex;flex-direction:row;transition:all 0.3s ease-in;overflow:hidden;'></div>").appendTo(contentContainer);
            //创建我的链接滚动容器
            this.myLinkIscroll = $("<div id='myLink' style='width:"+contentContainer.width()+"px;height:100%;overflow:hidden;'></div>").appendTo(this.switchContainer);
            this.myLinkIscroll.CommonIscroll({"isUploadBtn":false});
            //创建他人链接滚动容器
            var otherLinkConatienr = $("<div style='width:"+contentContainer.width()+"px;height:100%;'></div>").appendTo(this.switchContainer);
            this.otherLinkIscroll = $("<div id='otherLink' style='width:100%;height:100%;overflow:hidden;'></div>").appendTo(otherLinkConatienr);
            this.otherLinkIscroll.CommonIscroll({"isUploadBtn":false});
            //创建他人分享链接底部操作菜单
            this.bottonMenuContainer = $("<div isShow='no' style='width:100%;background:#fff;'></div>").appendTo(otherLinkConatienr);
            this.bottonMenuContainer.CommonBottonMenu({
                "btnMenu":[
                    {"text":"移除链接","type":"deleteLink","icon":skinConfig(global.skin).commonIcon + "move_icon_link.png"},
                    {"text":"复制链接","type":"copyLink","icon":skinConfig(global.skin).commonIcon + "copy_icon_link.png"},
                ]
            });

            //监听头部组件点击返回
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                Shell.sendEvent("closeWin");//关闭当前页面
            });
            //监听头部组件全选事件
            this.headContainer.bind("ALL_SELECT_BTN_CLICK",function(){
                Controller.otherLinkIscroll.find("li").LinkCell("allSelect");//调用列表组件选中方法
                Controller.headContainer.CommonHead("showAllNoSelectBtn");//调用头部组件显示全不选按钮
                Controller.selectData = [];//清空选中数据
                //循环得到全选的所有数据
                Controller.otherLinkIscroll.find("li").each(function(){
                    Controller.selectData.push($(this).LinkCell("getData"));
                });
                Controller.bottonMenuContainer.CommonBottonMenu("lockOptBtn",["移除链接","复制链接"]);//调用列表选中底部操作菜单组件锁定按钮和解锁操作按钮方法
            });
            //监听头部组件全不选事件
            this.headContainer.bind("ALL_NO_SELECT_BTN_CLICK",function(){
                Controller.selectData = [];//清空选中数据
                Controller.headContainer.CommonHead("showAllSelectBtn");//调用头部组件显示全选按钮
                Controller.otherLinkIscroll.find("li").LinkCell("cancelSelect");//调用列表组件取消选中方法
                Controller.bottonMenuContainer.CommonBottonMenu("lockOptBtn",["移除链接","复制链接"]);//调用列表选中底部操作菜单组件锁定按钮和解锁操作按钮方法
            });
            //监听头部组件取消事件
            this.headContainer.bind("CANCE_BTN_CLICK",function(){
                Controller.selectSize = 2;//列表勾选框默认设置为小的
                Controller.selectData = [];//清空选中数据
                Controller.otherLinkIscroll.find("li").LinkCell("changeSelectSize",2);//调用列表组件改变勾选图标大小方法
                Controller.otherLinkIscroll.find("li").LinkCell("cancelSelect");//调用列表组件取消选中方法
                Controller.headContainer.CommonHead("showGobackBtn");//调用头部组件显示返回按钮
                Controller.headContainer.CommonHead("hideCancelBtn");//调用头部组件隐藏取消按钮
                Controller.otherLinkIscroll.find("li").LinkCell("lock","no");//解锁列表图标和文件信息禁止点击
                Controller.switchLabelContainer.css({"pointer-events":"","opacity":""});//解锁切换标签
                showAndHideBottomMenu("hide");//隐藏列表选中底部操作菜单
            });
            //监听点击我的链接列表
            this.myLinkIscroll.bind("CELL_CLICK",function(event,arg){
                // 替换云空间接口
                // Shell.sendEvent("openWin",{"title":"分享链接","url":ApiConfig.api.get(ServerConfig.domain+"/usercenter/usercenterShareDetail?token="+getUrl("token")+"&",arg)});
                Shell.sendEvent("openWin",{"title":"分享链接","url":ApiConfig.api.get(ServerConfig.cloudDomain+"/usercenter/usercenterShareDetail?token="+getUrl("cloudToken")+"&",arg)});
            });
            //监听我的链接分享下拉刷新
            this.myLinkIscroll.bind("ISCROLL_REFRESH",function(){
                Controller.myLinkIscroll.find("li").LinkCell("lockList","yes");//锁定所有列表禁止点击
                Controller.headContainer.CommonHead("lock","yes");//锁定头部组件
                Controller.switchLabelContainer.css({"pointer-events":"none","opacity":"0.5"});//锁定切换标签
                Controller.myOffset = 0;//从第0条数据开始获取
                getMyLinkListData(2);//调用获取列表数据方法
            });
            //监听我的链接上拉加载更多
            this.myLinkIscroll.bind("ISCROLL_LOAD_MORE",function(){
                Controller.myLinkIscroll.find("li").LinkCell("lockList","yes");//锁定所有列表禁止点击
                Controller.headContainer.CommonHead("lock","yes");//锁定头部组件
                Controller.switchLabelContainer.css({"pointer-events":"none","opacity":"0.5"});//锁定切换标签
                Controller.myOffset = Controller.myOffset + 100;//从第0条数据开始获取
                getMyLinkListData(3);//调用获取列表数据方法
            });
            //监听点击他人链接列表
            this.otherLinkIscroll.bind("CELL_CLICK",function(event,arg){
                testingOtherLink(arg);//调用点击他人链接分享检测是否需要输入密码方法
            });
            //监听他人链接列表勾选框被点击
            this.otherLinkIscroll.bind("CELL_SELECT",function(event,obj){
                //判断当前是取消还是选中
                if(obj.type == "yes"){
                    Controller.selectData.push(obj.data);
                }else{
                    //循环取消选中数据
                    for(var i = 0; i < Controller.selectData.length; i++){
                        if(Controller.selectData[i].uuid == obj.data.uuid){
                            Controller.selectData.splice(i,1);
                            break;
                        }
                    }
                }
                listSelect();//调用列表选中操作方法
            });
            //监听他人链接分享下拉刷新
            this.otherLinkIscroll.bind("ISCROLL_REFRESH",function(){
                Controller.selectData = [];//清空选中数据
                Controller.selectSize = 2;//控制选中图标勾选框大小
                Controller.otherLinkIscroll.find("li").LinkCell("lockList","yes");//锁定所有列表禁止点击
                Controller.headContainer.CommonHead("lock","yes");//锁定头部组件
                Controller.switchLabelContainer.css({"pointer-events":"none","opacity":"0.5"});//锁定切换标签
                Controller.bottonMenuContainer.CommonBottonMenu("lock","yes");//锁定底部操作菜单
                Controller.otherOffset = 0;//重置数据偏移量
                getOtherLinkListData(2);//调用获取他人链接列表数据方法
            });
            //监听他人链接上拉加载更多
            this.otherLinkIscroll.bind("ISCROLL_LOAD_MORE",function(){
                Controller.otherLinkIscroll.find("li").LinkCell("lockList","yes");//锁定所有列表禁止点击
                Controller.headContainer.CommonHead("lock","yes");//锁定头部组件
                Controller.switchLabelContainer.css({"pointer-events":"none","opacity":"0.5"});//锁定切换标签
                Controller.bottonMenuContainer.CommonBottonMenu("lock","yes");//锁定底部操作菜单
                Controller.otherOffset = Controller.otherOffset + 100;//重置数据偏移量
                getOtherLinkListData(3);//调用获取他人链接列表数据方法
            });
            //监听底部菜单操作选项被点击
            this.bottonMenuContainer.bind("OPERATION_BTN_CLICK",function(event,type){
                if(type == "deleteLink"){
                    Controller.headContainer.CommonHead("lock","yes");//锁定头部组件
                    Controller.otherLinkIscroll.find("li").LinkCell("lockList","yes");//锁定所有列表禁止点击
                    Controller.bottonMenuContainer.CommonBottonMenu("lock","yes");//锁定底部操作菜单
                    Controller.otherLinkIscroll.CommonIscroll("isIscroll","yes");//锁定滚动容器
                    deleteOtherLink();//调用删除他人链接方法
                }else{
                    copyOtherLink();//调用复制他人链接方法
                }
            });
            //监听我的链接点击取消分享事件
            try{
                //监听我的链接取消分享刷新事件
				api.addEventListener({name:"commonRefresh"},function(arg){
                    //判断是否是当前页面事件
                    if(arg.value.pageName == Controller.pageName){
                        Controller.myOffset = 0;//重置数据请求偏移量
                        getMyLinkListData(1);//调用获取我的分享文件方法
                    }
                });
            }catch(e){}


            //监听原生点击退出登录按钮移除当前页面所有的事件监听
            api.addEventListener({"name":"noticeRemoveAllEvent"},function(){
                removeAllEvent();//调用移除当前页面所有的事件监听方法
            });

            
            //给切换按钮绑定点击事件
            this.switchLabelContainer.find("li").bind("click",function(){
                Controller.switchLabelContainer.find("li").css("color","#000");
                Controller.switchLabelContainer.find("li").children("p").css("opacity","0");
                $(this).css("color",skinConfig(global.skin).selectFontColor);
                $(this).children("p").css("opacity","1");
                if($(this).attr("data") == "myLink"){
                    Controller.switchContainer.css("transform","translateX(0)");
                }else{
                    Controller.switchContainer.css("transform","translateX(-"+$(window).width()+"px)");
                }
            });
            //解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
            //通知原生加载完毕
            Shell.sendPageReady();
            $("body").fadeTo("slow",1);
            //调用获取我的链接列表方法
            getMyLinkListData(1);
            //调用获取他人链接列表方法
            getOtherLinkListData(1);
        }
    }

    //移除当前页面所有的事件监听方法
    function removeAllEvent(){
        try{
            api.removeEventListener({"name":"touchmove"});
            api.removeEventListener({"name":"commonRefresh"});
            setTimeout(function(){
                Shell.sendEvent("eventRemoveComplete");//通知原生事件移除完成
            },100);
        }catch(e){}
    }

    //获取我的链接列表数据方法
    function getMyLinkListData(type){
        //判断如果是初始化到2秒都还没有请求出数据就显示加载提示
        if(type == 1){
            Controller.myLinkTime = setTimeout(function(){
                Controller.myLinkIscroll.CommonIscroll("showLoadMask");//显示加载层
            },2000);
        }
        //请求参数
        // 替换云空间空间
        // var paramet = {"token":getUrl("token"),"offset":Controller.myOffset};
        var paramet = {"token":getUrl("cloudToken"),"offset":Controller.myOffset};
        http(ServerConfig.cloudDomain+"/"+skinConfig(global.skin).linkshare+"/getTaskList",paramet,{
            success:function(arg){
                clearTimeout(Controller.myLinkTime);//清除延时
                if(parseInt(arg.code) == 1){
                    generateMyLinkList(type,arg.data.rows);//调用生成列表方法
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        //判断是初始化错误还是下拉刷新错误还是上拉加载更多错误
                        if(type == 1){//初始化错误
                            setTimeout(function(){
                                Controller.myLinkIscroll.CommonIscroll("showErrorMask",arg.msg);//显示错误提示层
                            },500);
                        }else if(type == 2){//下拉刷新错误
                            setTimeout(function(){
                                Controller.myLinkIscroll.CommonIscroll("refreshSuccessAndFail",arg.msg);//调用下拉刷新错误
                            },500);
                        }else if(type == 3){
                            setTimeout(function(){
                                Controller.myLinkIscroll.CommonIscroll("loadMoreSuccessAndFail",arg.msg);//调用加载错误
                            },500);
                        }
                    }
                }
            }
        });
    }
    //生成我的链接列表方法
    function generateMyLinkList(type,dataArray){
        var cellArray = [];
        for(var i = 0; i < dataArray.length; i++){
            var cell = $("<li style='width:100%;padding-left:0.15rem;box-sizing:border-box;'></li>").LinkCell({
                "data":dataArray[i],
                "icon":skinConfig(global.skin).commonIcon + "details.png",
                "isSelect":false,
            });
            cellArray.push(cell);
        }
        //判断当前是初始化列表，还是下拉刷新，还是上拉加载更多
        if(type == 1){
            //判断有无数据
            if(cellArray != 0){
                Controller.myLinkIscroll.CommonIscroll("initNode",cellArray);//调用滚动组件初始化数据
            }else{
                Controller.myLinkIscroll.CommonIscroll("showListNoDataMask","你还没有分享过链接额");//显示没有数据提示层
            }
        }else if(type == 2){
            setTimeout(function(){
                Controller.myLinkIscroll.CommonIscroll("refreshSuccessAndFail");//刷新成功方法
            },500);
            //监听下拉刷新完成事件
            Controller.myLinkIscroll.unbind("REFRESH_COMPLETE").bind("REFRESH_COMPLETE",function(){
                //判断有无数据
                if(cellArray.length != 0){
                    Controller.myLinkIscroll.CommonIscroll("refreshNode",cellArray);//调用滚动组件添加下拉刷新数据
                }else{
                    Controller.myLinkIscroll.CommonIscroll("emptyNode");//清空节点
                    Controller.myLinkIscroll.CommonIscroll("showListNoDataMask","你还没有分享过链接额");//显示没有数据提示层
                }
                Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                Controller.switchLabelContainer.css({"pointer-events":"","opacity":""});//解锁切换标签
            });
        }else if(type == 3){
            setTimeout(function(){
                Controller.myLinkIscroll.CommonIscroll("loadMoreSuccessAndFail");//加载成功方法
            },500);
            //监听上拉加载更多完成事件
            Controller.myLinkIscroll.unbind("LOAD_COMPLETE").bind("LOAD_COMPLETE",function(){
                Controller.myLinkIscroll.CommonIscroll("addNode",cellArray);//调用滚动组件添加上拉的数据
                Controller.myLinkIscroll.find("li").LinkCell("lockList","no");//解锁所有列表允许点击
                Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                Controller.switchLabelContainer.css({"pointer-events":"","opacity":""});//解锁切换标签
            });
        }
    }
    //获取他人链接列表数据方法
    function getOtherLinkListData(type){
        //判断如果是初始化到2秒都还没有请求出数据就显示加载提示
        if(type == 1){
            Controller.otherLinkTime = setTimeout(function(){
                Controller.otherLinkIscroll.CommonIscroll("showLoadMask");//显示加载层
            },2000);
        }
        //请求参数
        // 替换云空间接口
        // var paramet = {"token":getUrl("token"),"offset":Controller.otherOffset};
        var paramet = {"token":getUrl("cloudToken"),"offset":Controller.otherOffset};
        http(ServerConfig.cloudDomain+"/"+skinConfig(global.skin).otherLink+"/getList",paramet,{
            success:function(arg){
                clearTimeout(Controller.otherLinkTime);//清除延时
                if(parseInt(arg.code) == 1){
                    generateOtherLinkList(type,arg.data.rows);//调用生成列表方法
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        //判断是初始化错误还是下拉刷新错误还是上拉加载更多错误
                        if(type == 1){//初始化错误
                            setTimeout(function(){
                                Controller.otherLinkIscroll.CommonIscroll("showErrorMask",arg.msg);//显示错误提示层
                            },500);
                        }else if(type == 2){//下拉刷新错误
                            setTimeout(function(){
                                Controller.otherLinkIscroll.CommonIscroll("refreshSuccessAndFail",arg.msg);//调用下拉刷新错误
                            },500);
                        }else if(type == 3){
                            setTimeout(function(){
                                Controller.otherLinkIscroll.CommonIscroll("loadMoreSuccessAndFail",arg.msg);//调用加载错误
                            },500);
                        }
                    }
                }
            }
        });
    }
    //生成他人链接列表方法
    function generateOtherLinkList(type,dataArray){
        var cellArray = [];
        for(var i = 0; i < dataArray.length; i++){
            var cell = $("<li uuid='"+dataArray[i].uuid+"' style='width:100%;padding-left:0.15rem;box-sizing:border-box;'></li>").LinkCell({
                "commonIconUrl":skinConfig(global.skin).commonIcon,
                "shllIconUrl":skinConfig(global.skin).shllWebIon,
                "data":dataArray[i],
                "icon":skinConfig(global.skin).commonIcon + "details.png",
            });
            cellArray.push(cell);
        }
        //判断当前是初始化列表，还是下拉刷新，还是上拉加载更多
        if(type == 1){
            //判断有无数据
            if(cellArray != 0){
                Controller.otherLinkIscroll.CommonIscroll("initNode",cellArray);//调用滚动组件初始化数据
            }else{
                Controller.otherLinkIscroll.CommonIscroll("showListNoDataMask","你还没有收藏过链接额");//显示没有数据提示层
            }
        }else if(type == 2){
            setTimeout(function(){
                Controller.otherLinkIscroll.CommonIscroll("refreshSuccessAndFail");//刷新成功方法
            },500);
            //监听下拉刷新完成事件
            Controller.otherLinkIscroll.unbind("REFRESH_COMPLETE").bind("REFRESH_COMPLETE",function(){
                //判断列表选中底部菜单是否显示
                if(Controller.bottonMenuContainer.attr("isShow") == "yes"){
                    showAndHideBottomMenu("hide");//隐藏列表选中底部操作菜单
                    Controller.headContainer.CommonHead("showGobackBtn");//调用头部组件显示返回按钮
                    Controller.headContainer.CommonHead("hideCancelBtn");//调用头部组件隐藏取消按钮
                    Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单
                }
                //判断有无数据
                if(cellArray.length != 0){
                    Controller.otherLinkIscroll.CommonIscroll("refreshNode",cellArray);//调用滚动组件添加下拉刷新数据
                }else{
                    Controller.otherLinkIscroll.CommonIscroll("emptyNode");//清空节点
                    Controller.otherLinkIscroll.CommonIscroll("showListNoDataMask","你还没有收藏过链接额");//显示没有数据提示层
                }
                Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                Controller.switchLabelContainer.css({"pointer-events":"","opacity":""});//解锁切换标签
            });
        }else if(type == 3){
            setTimeout(function(){
                Controller.otherLinkIscroll.CommonIscroll("loadMoreSuccessAndFail");//加载成功方法
            },500);
            //监听上拉加载更多完成事件
            Controller.otherLinkIscroll.unbind("LOAD_COMPLETE").bind("LOAD_COMPLETE",function(){
                Controller.otherLinkIscroll.CommonIscroll("addNode",cellArray);//调用滚动组件添加上拉的数据
                Controller.otherLinkIscroll.find("li").LinkCell("lockList","no");//解锁所有列表允许点击
                //判断列表选中底部菜单是否显示
                if(Controller.bottonMenuContainer.attr("isShow") == "yes" && cellArray.length != 0){
                    Controller.headContainer.CommonHead("showAllSelectBtn");//调用头部组件显示全选按钮
                    Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单
                    Controller.otherLinkIscroll.find("li").LinkCell("lock","yes");//锁定所有列表的文件图标和文件信息禁止点击
                }
                Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                Controller.switchLabelContainer.css({"pointer-events":"","opacity":""});//解锁切换标签
            });
        }
    }
    //显示隐藏底部操作菜单
    function showAndHideBottomMenu(type){
        var height = Controller.bottonMenuContainer.outerHeight(true);//得到需要减去的高度
        if(type == "show"){
            Controller.bottonMenuContainer.attr("isShow","yes");//改变底部操作菜单属性表示菜单已经显示
            Controller.otherLinkIscroll.CommonIscroll("changeIscrollContainerMinHeight",Controller.otherLinkIscroll.height() - height);//调用改变滚动容器高度方法
        }else{
            Controller.bottonMenuContainer.attr("isShow","no");//改变底部操作菜单属性表示菜单已经隐藏
            Controller.otherLinkIscroll.CommonIscroll("changeIscrollContainerMinHeight",Controller.otherLinkIscroll.height() + height);//调用改变滚动容器高度方法
        }
    }
    //列表选中操作方法
    function listSelect(){
        //判断选中的数据条数
        if(Controller.selectData.length != 0){
            //判断是否选中多条数据
            if(Controller.selectData.length == 1){
                //判断是否显示了底部操作菜单
                if(Controller.bottonMenuContainer.attr("isShow") == "no"){
                    showAndHideBottomMenu("show");//显示底部操作菜单
                    Controller.headContainer.CommonHead("showCancelBtn");//调用头部组件显示取消按钮
                    Controller.otherLinkIscroll.find("li").LinkCell("changeSelectSize",1);//调用列表组件改变勾选图标大小方法
                    Controller.otherLinkIscroll.find("li").LinkCell("lock","yes");//锁定列表图标和文件信息禁止点击
                    Controller.switchLabelContainer.css({"pointer-events":"none","opacity":"0.5"});//锁定切换标签
                }
                Controller.bottonMenuContainer.CommonBottonMenu("lockOptBtn",[]);//调用列表选中底部操作菜单组件锁定按钮和解锁操作按钮方法
            }else{
                Controller.bottonMenuContainer.CommonBottonMenu("lockOptBtn",["移除链接","复制链接"]);//调用列表选中底部操作菜单组件锁定按钮和解锁操作按钮方法
            }
            //判断当前列表是否全部被选中
            if(Controller.selectData.length == Controller.otherLinkIscroll.find("li").length){
                Controller.headContainer.CommonHead("showAllNoSelectBtn");//调用头部组件显示全不选按钮
            }else{
                Controller.headContainer.CommonHead("showAllSelectBtn");//调用头部组件显示全选按钮
            }
        }else{
            showAndHideBottomMenu("no");//隐藏底部操作菜单
            Controller.headContainer.CommonHead("showGobackBtn");//调用头部组件显示返回按钮
            Controller.headContainer.CommonHead("hideCancelBtn");//调用头部组件隐藏取消按钮
            Controller.otherLinkIscroll.find("li").LinkCell("changeSelectSize",2);//调用列表组件改变勾选图标大小方法
            Controller.otherLinkIscroll.find("li").LinkCell("lock","no");//解锁列表图标和文件信息禁止点击
            Controller.switchLabelContainer.css({"pointer-events":"","opacity":""});//解锁切换标签
        }
    }
    //移除他人链接方法
    function deleteOtherLink(){
        var time = setTimeout(function(){
            Controller.toastContainer.CommonToast("showToast","正在移除中，请稍后...");//显示飘窗提示
        },200);
        //请求参数
        // 替换云空间接口
        // var paramet = {"token":getUrl("token"),"uuid":Controller.selectData[0].uuid};
        var paramet = {"token":getUrl("cloudToken"),"uuid":Controller.selectData[0].uuid};
        http(ServerConfig.cloudDomain+"/"+skinConfig(global.skin).otherLink+"/deleteOtherShare",paramet,{
            success:function(arg){
                clearTimeout(time);//清除延时
                if(parseInt(arg.code) == 1){
                    Controller.headContainer.trigger("CANCE_BTN_CLICK");//抛出取消事件
                    //判断是否显示了飘窗提示
                    if(Controller.toastContainer.attr("isShow") == "no"){
                        Controller.toastContainer.CommonToast("showToast","移除成功");//显示飘窗提示
                    }else{
                        Controller.toastContainer.CommonToast("changeText","移除成功");//改变飘窗提示
                    }
                    setTimeout(function(){
                        Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                        Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                        Controller.otherLinkIscroll.find("li").LinkCell("lockList","no");//解锁所有列表禁止点击
                        Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单
                        Controller.otherLinkIscroll.CommonIscroll("isIscroll","no");//解锁滚动容器
                        Controller.otherOffset = 0;
                        getOtherLinkListData(1);//获取他人链接列表数据
                    },1500);
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        Controller.toastContainer.CommonToast("showToast",arg.msg);//显示飘窗提示
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                            Controller.otherLinkIscroll.find("li").LinkCell("lockList","no");//解锁所有列表禁止点击
                            Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单
                            Controller.otherLinkIscroll.CommonIscroll("isIscroll","no");//解锁滚动容器
                        },1500);
                    }
                }
            }
        });
    }
    //复制他人链接方法
    function copyOtherLink(){
        var linkUrl = "链接：" + Controller.selectData[0].short_link + (Controller.selectData[0].visit_password != "" ? " 密码：" + Controller.selectData[0].visit_password : "");
        Shell.sendEvent("copyLink",{"name":linkUrl});
        Controller.headContainer.trigger("CANCE_BTN_CLICK");//抛出取消事件
        Controller.toastContainer.CommonToast("showToast","复制成功");//显示飘窗提示
        setTimeout(function(){
            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
        },1500);
    }
    //点击他人链接分享检测是否需要输入密码
    function testingOtherLink(objst){
        //请求参数
        // 替换云空间接口
        // var paramet = {"token":getUrl("token"),"uuid":objst.uuid};
        var paramet = {"token":getUrl("cloudToken"),"uuid":objst.uuid};
        http(ServerConfig.cloudDomain+"/"+skinConfig(global.skin).otherLink+"/getShareInfo",paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    var obj = {};
                    obj.uuid = objst.uuid;
                    obj.fileName = objst.name;
                    obj.showSave = true;
                    obj.task_id = objst.lock_task_id;
                    //判断是否需要输入密码
                    if(arg.data.info != null){
                        obj.nickname = res.data.info.nickname;
                        obj.avatar = res.data.info.avatar;
                        Shell.sendEvent("openWin",{"title":"密码访问","url":ApiConfig.api.get(ServerConfig.cloudDomain+"/usercenter/usercenterOthershareDetailWithPassword?token="+getUrl("cloudToken")+"&",obj)});
                    }else{
                        Shell.sendEvent("openWin",{"title":objst.name,"url":ApiConfig.api.get(ServerConfig.cloudDomain+"/usercenter/usercenterOthershareDetail?token="+getUrl("cloudToken")+"&",obj)});
                    }
                    addViews(objst.task_id,objst.uuid);//调用增加浏览量方法
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        Controller.toastContainer.CommonToast("showToast",arg.msg);//显示飘窗提示
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                        },1500);
                    }
                }
            }
        });
    }
    //增加浏览量方法
    function addViews(taskId,uuid){
        //请求参数
        // 替换云空间接口
        // var paramet = {"token":getUrl("token"),"task_id":taskId};
        var paramet = {"token":getUrl("cloudToken"),"task_id":taskId};
        http(ServerConfig.cloudDomain+"/"+skinConfig(global.skin).linkshare+"/addVisiterTimes",paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    Controller.otherLinkIscroll.find("[uuid="+uuid+"]").LinkCell("changeVisit");//改变当前这条数据的浏览次数
                }
            }
        });
    }
    return Controller;
});
