/*
*   2020年12月2日
*
*   新建笔记-帮助的js控制器
*
*   开发者：薛原（付长建修改）
*/
define(["jquery","Shell","iscroll","Fastclick","CommonHead"], function ($,Shell,iscroll,Fastclick) {
    var Controller = {
        init:function(){
            //设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});//禁止整个页面滚动
			global.skin = "redyingshuo";//当前是红色皮肤
			Controller.create();//调用生成页面方法
        },
        //生成页面方法
		create:function(){
			//初始化头部组件
            this.headContainer = $("<div></div>").appendTo($("body"));
            this.headContainer.CommonHead({
                "isGoback":true,
                "title":"帮助"
            });
			//创建内容容器
			this.contentContainer = $("<div id='helpIscroll' style='width:100%;height:"+($("body").height() - this.headContainer.outerHeight(true))+"px;border-top:1px solid #EAEFF2;box-sizing:border-box;overflow:hidden;'></div>").appendTo($("body"));
			this.content = $("<div style='width:100%;min-height:"+(this.contentContainer.outerHeight(true) + 1)+"px;padding:0 0.15rem 0.3rem 0.15rem;box-sizing:border-box;overflow:hidden;'></div>").appendTo(this.contentContainer);
			$("<div style='display:flex;flex-direction:row;align-items:center;margin-top:0.2rem;'><span style='display:inline-block;width:0.06rem;height:0.06rem;border-radius:50%;background:#666;margin-right:0.12rem;'></span><span style='font-size:0.15rem;font-weight:bold;'>已启用与已锁定两种状态有什么区别？</span></div>").appendTo(this.content);
			var os;
			try{
				os = api.systemType;
			}catch(e){
				os = "android";
			}
			if(os == "android"){
			    var t1 = $("<div style='width:100%;display:flex;flex-direction:row;justify-content:space-between;margin:0.23rem 0 0.2rem 0;'><img style='width:49%;' src='../djcommon/img/note/b_icon_3android.png'/><img style='width:49%;' src='../djcommon/img/note/b_icon_4.png'/></div>").appendTo(this.content);
			}else{
				var t1 = $("<div style='width:100%;display:flex;flex-direction:row;justify-content:space-between;margin:0.23rem 0 0.2rem 0;'><img style='width:49%;' src='../djcommon/img/note/b_icon_3android.png'/><img style='width:49%;' src='../djcommon/img/note/b_icon_4.png'/></div>").appendTo(this.content);
			}
			t1.find("img").each(function(){
				$(this).bind("load",function(){
					$(this).css("height",$(this).width()/197*266);
				});
			});
			$("<p style='font-size:0.14rem;color:#666;line-height:0.24rem;'>1.已启用状态表示蓝牙笔在智能本上书写的内容会显示在此状态的智能本上。<br/>注：同类型的智能本只存在一个已启用的状态。<br/>2.已锁定表示蓝牙笔在智能本上书写的内容不会在此状态的智能本上显示。</p>").appendTo(this.content);
			$("<div style='display:flex;flex-direction:row;align-items:center;margin-top:0.3rem;'><span style='display:inline-block;width:0.06rem;height:0.06rem;border-radius:50%;background:#666;margin-right:0.12rem;'></span><span style='font-size:0.15rem;font-weight:bold;'>启用与锁定有什么区别？</span></div>").appendTo(this.content);
			var t2 = $("<div style='width:100%;display:flex;justify-content:center;margin:0.23rem 0 0.2rem 0;'><img style='max-width:100%;' src='../djcommon/img/note/b_icon_5.png'/></div>").appendTo(this.content);
			t2.find("img").each(function(){
				$(this).bind("load",function(){
					$(this).css("height",$(this).width()/345*422);
				});
			});
			$("<p style='font-size:0.14rem;color:#666;line-height:0.24rem;'>1.启用可以将正在锁定的智能本开启，另外其他已启用的智能本将自动锁定。<br/>2.已启用的智能本暂不支持锁定，至少要保留一本已启用的本子<br/>注：若要锁定智能本，可以新建智能本或者开启其他的智能本将其锁定。</p>").appendTo(this.content);
			$("<div style='display:flex;flex-direction:row;align-items:center;margin-top:0.3rem;'><span style='display:inline-block;width:0.06rem;height:0.06rem;border-radius:50%;background:#666;margin-right:0.12rem;'></span><span style='font-size:0.15rem;font-weight:bold;'>智能本名称能修改吗？</span></div>").appendTo(this.content);
			$("<p style='font-size:0.14rem;color:#666;margin-top:0.1rem;'>支持，但不支持重名。</p>").appendTo(this.content);
			$("<div style='display:flex;flex-direction:row;align-items:center;margin-top:0.3rem;'><span style='display:inline-block;width:0.06rem;height:0.06rem;border-radius:50%;background:#666;margin-right:0.12rem;'></span><span style='font-size:0.15rem;font-weight:bold;'>如何查看同步到云端的智能本？</span></div>").appendTo(this.content);
			var t3 = $("<div style='width:100%;display:flex;justify-content:center;margin:0.23rem 0 0.2rem 0;'><img style='max-width:100%;' src='../djcommon/img/note/b_icon_6.png'/></div>").appendTo(this.content);
			t3.find("img").each(function(){
				$(this).bind("load",function(){
					$(this).css("height",$(this).width()/345*422);
				});
			});
			$("<p style='font-size:0.14rem;color:#666;line-height:0.24rem;'>同步到云空间的智能本默认同步到此APP的云盘-保险箱文件夹中，需要输入密码进行查看。</p>").appendTo(this.content);
			$("<div style='display:flex;flex-direction:row;align-items:center;margin-top:0.3rem;'><span style='display:inline-block;width:0.06rem;height:0.06rem;border-radius:50%;background:#666;margin-right:0.12rem;'></span><span style='font-size:0.15rem;font-weight:bold;'>如何同步离线数据？</span></div>").appendTo(this.content);
			var t4 = $("<div style='width:100%;display:flex;justify-content:center;margin:0.23rem 0 0.2rem 0;'><img style='max-width:100%;' src='../djcommon/img/note/b_icon_7.png'/></div>").appendTo(this.content);
			t4.find("img").each(function(){
				$(this).bind("load",function(){
					$(this).css("height",$(this).width()/345*422);
				});
			});
			$("<p style='font-size:0.14rem;color:#666;line-height:0.24rem;'>离线数据是蓝牙笔未连接APP的情况下在智能本上书写内容而产生的数据。<br/>1.连接蓝牙笔之后系统自动检测是否存在离线数据，有则自动同步数据到已启用的智能本上。</p>").appendTo(this.content);
			$("<div style='display:flex;flex-direction:row;align-items:center;margin-top:0.3rem;'><span style='display:inline-block;width:0.06rem;height:0.06rem;border-radius:50%;background:#666;margin-right:0.12rem;'></span><span style='font-size:0.15rem;font-weight:bold;'>如何同步数据到保险箱？</span></div>").appendTo(this.content);
			var t5 = $("<div style='width:100%;display:flex;justify-content:center;margin:0.23rem 0 0.2rem 0;'><img style='max-width:100%;' src='../djcommon/img/note/b_icon_8.png'/></div>").appendTo(this.content);
			t5.find("img").each(function(){
				$(this).bind("load",function(){
					$(this).css("height",$(this).width()/345*422);
				});
			});
			$("<p style='font-size:0.14rem;color:#666;line-height:0.24rem;'>1.连接网络情况下，蓝牙笔连接APP进行书写时会实时同步数据到保险箱。<br/>2.未连接网络的情况下，书写实时同步数据到保险箱，在连接网络之后，可到智能本管理中手动同步数据到保险箱。</p>").appendTo(this.content);
			//点击返回按钮
			this.headContainer.bind("GOBACK_BTN_CLICK",function(){
				Shell.sendEvent("closeWin");//关闭当前页面
			});
			//初始化滚动插件
			this.iscroll = new iscroll("#helpIscroll",{
				tap:true,//开启自定义的点击事件
				bounceTime:300,//配置滑动回弹时间
				probeType:3//开启这个参数就可以每滑动1px获取一次值
			});
			//解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
			Shell.sendPageReady();
			$("body").fadeTo("slow",1,function(){
				Controller.iscroll.refresh();
			});	
		}
    }
    return Controller;
});
