/*
*   2020年12月3日
*
*   笔记-党建本管理的js控制器
*
*   开发者：薛原
*/
define(["jquery","Shell","Config",'iscroll',"Fastclick","NoteBookDataModel","TokenDataModel","NewHeader","Panel","Label","BaseBtn",'BookCell'], function ($,Shell,Config,IScroll,Fastclick,NoteBookDataModel,TokenDataModel) {
	var scrollPanel;
	var addBookBtnPanel;
	var myScroll;
	var currBookData;
	var deleteFlag = false; //删除标记
	var interWinLock = false;
    var Controller = {
        init:function(){
			
            Controller.create();//调用生成页面方法
			Config.adapter.setBaseRem();
			Controller.addEventListener();
			//通知原生关闭加载动画
			setTimeout(function(){
				Shell.sendPageReady();
			},100);
        },
        //生成页面方法
        create:function(){
			var header = $("<div class='header'></div>").NewHeader({"title":"智能本管理","rightTitle":"帮助"});
			header.bind("BACK_CLICK",function(){
				//关闭窗口
				Shell.sendEvent("closeWin");
			});
			header.bind("RIGHT_CLICK",function(){
				//帮助页面
				Shell.sendEvent("openWin",{"url":"/notebookhelp/noteBookHelp.html","open_type":true,"title":"帮助"});
			});
			$("body").append(header);
			var tsPanel = $("<div></div>").Panel({"width":"100%","height":"36px"});
			tsPanel.Panel("setBgColor","rgba(255, 107, 32,0.2)");
			tsPanel.Panel("setPaddingLeft","15px");
			tsPanel.Panel("setPaddingRight","15px");
			tsPanel.Panel("setPaddingTop","12px");
			tsPanel.Panel("setPaddingBottom","12px");
			var tsLabel = $("<div class='linkStatusLabel'></div>").Label({"text":"请注意：同类型智能本，只可启用一个更新书写内容！","fontSize":"12px","color":"rgba(255, 107, 32,1)"});
			tsPanel.Panel("addElement",tsLabel);
			$("body").append(tsPanel);
			
			addBookBtnPanel = $("<div></div>").Panel({"width":"100%","height":"110px"});
			$("body").append(addBookBtnPanel);
			
			var addBookBtn = $("<div class='linkBtn'></div>").BaseBtn({"text":"<font style='font-size:18px;margin-right:10px;'>+</font>新建智能本","width":"140px","height":"44px","fontSize":"15px","textColor":"#C82128"});
			addBookBtn.css({"opacity":0}).animate({"opacity":1});
			addBookBtn.css("border-radius","3rem");
			addBookBtn.css("border","1px solid #C82128");
			addBookBtn.css("position","absolute");
			addBookBtn.BaseBtn("setLeft","127px");
			addBookBtn.BaseBtn("setTop","30px");
			addBookBtnPanel.append(addBookBtn);
			addBookBtn.bind("BTN_CLICK",function(){
				if(interWinLock){
					return;
				}
				interWinLock = true;
				setTimeout(function(){
				    interWinLock = false;
				},1000);
			    Shell.sendEvent("openWin",{"url":"/notecreate/noteCreate.html","open_type":true,"title":"新建智能本"});
			});
			
			setTimeout(function(){
				NoteBookDataModel.getData();
			},200);
			//解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
		},
		checkSynTask:function(taskId){
			$(window).unbind("CHECK_SYN_NOTE_BOOK_TO_CLOUDSPACE_RESULT").bind("CHECK_SYN_NOTE_BOOK_TO_CLOUDSPACE_RESULT",function(e,data){
				if(data.data == "TASK_001" || data.data == "TASK_004" || data.data == "TASK_005"){
					Shell.sendEvent("CloseLockScreenArea");
					Shell.sendEvent("unLockSwitchActivity");
					try{
						api.toast({
							msg: "同步成功",
							duration: 1000,
							location: 'middle'
						});
					}catch(e){}
				}else{
					setTimeout(function(){
					   NoteBookDataModel.checkSynYsnoteFileToCloudspaceResult(taskId);
				    },2000);
				}
			});
			NoteBookDataModel.checkSynYsnoteFileToCloudspaceResult(taskId);
			
		},
		addEventListener:function(){
			var that = this;
			try{
				api.addEventListener({"name":"NOTE_BOOK_DATA_CHANGE"},function(e,data){
					NoteBookDataModel.getData();
				});
			}catch(e){
			}
			var that = this;
			try{
				api.addEventListener({"name":"SYN_OFFLINE_DATA_SUCCESS"},function(e,data){
					try{
						api.toast({
							msg: '同步离线数据成功',
							duration: 1000,
							location: 'middle'
						});
					}catch(e){}
				});
				api.addEventListener({"name":"SYN_OFFLINE_DATA_ERROR"},function(e,data){
					try{
						api.toast({
							msg: '同步离线数据失败',
							duration: 1000,
							location: 'middle'
						});
					}catch(e){}
				});
			}catch(e){
			}
			try{
				//重命名成功事件
				api.addEventListener({"name":"RenameNoteBookSuccess"},function(e){
					if($("[data-id='"+e.value.uuid+"']").length > 0){
						$("[data-id='"+e.value.uuid+"']").BookCell("changeTitle",e.value.name);
					}
				});
			}catch(e){
			}
			
			$(window).bind("SYN_NOTE_BOOK_TO_CLOUDSPACE_SUCCESS",function(e,data){
				if(data.status == "CPC_BOOK_0010"){
					api.toast({
						msg: '新本子没有书写内容，暂无法同步',
						duration: 1000,
						location: 'middle'
					});
					return;
				}
				try{
					/*api.toast({
						msg: '同步到云空间任务投递成功',
						duration: 1000,
						location: 'middle'
					});*/
					Shell.sendEvent("ShowLockScreenArea", {"title":"同步到云端","secText":""});
					Shell.sendEvent("LockSwitchActivity");
					Controller.checkSynTask(data.taskId);
				}catch(e){}
				
			});
			$(window).bind("SYN_NOTE_BOOK_TO_CLOUDSPACE_ERROR",function(e,data){
				try{
					api.toast({
						msg: '同步到云空间失败',
						duration: 1000,
						location: 'middle'
					});
				}catch(e){}
				
			});
			$(window).bind("REMOVE_NOTE_BOOK_SUCCESS",function(e,data){
				try{
					api.toast({
						msg: '删除智能本成功',
						duration: 1000,
						location: 'middle'
					});
				}catch(e){}
				$("[data-id='"+data.uuid+"']").remove();
				if($(".BookCell").length > 0){
					$(".header").NewHeader("addSecTitle","共"+$(".BookCell").length+"个智能本");
				}else{
					$(".header").NewHeader("removeSecTitle");
				}
				myScroll.refresh();
				//党建本数据发生改变
				deleteFlag = true;
				Shell.sendEvent("NOTE_BOOK_DATA_CHANGE");
				
			});
			$(window).bind("REMOVE_NOTE_BOOK_ERROR",function(e,data){
				try{
					api.toast({
						msg: '删除智能本失败',
						duration: 1000,
						location: 'middle'
					});
				}catch(e){}
			});
			$(window).bind("LOCK_NOTE_BOOK_SUCCESS",function(e,data){
				try{
					api.toast({
						msg: '锁定党建本成功',
						duration: 1000,
						location: 'middle'
					});
				}catch(e){}
				$("[data-id='"+data.uuid+"']").BookCell("setBookLock");
				//党建本数据发生改变
				Shell.sendEvent("NOTE_BOOK_DATA_CHANGE");
				
			});
			$(window).bind("LOCK_NOTE_BOOK_ERROR",function(e,data){
				try{
					api.toast({
						msg: '锁定智能本失败',
						duration: 1000,
						location: 'middle'
					});
				}catch(e){}
			});
			$(window).bind("UNLOCK_NOTE_BOOK_SUCCESS",function(e,data){
				try{
					api.toast({
						msg: '激活智能本成功',
						duration: 1000,
						location: 'middle'
					});
				}catch(e){}
				NoteBookDataModel.getData();
				//党建本数据发生改变
				Shell.sendEvent("NOTE_BOOK_DATA_CHANGE");
			});
			$(window).bind("UNLOCK_NOTE_BOOK_ERROR",function(e,data){
				try{
					api.toast({
						msg: '激活智能本失败',
						duration: 1000,
						location: 'middle'
					});
				}catch(e){}
			});
			//获取党建本成功
			$(window).bind("GET_NOTE_BOOK_DATA_SUCCESS",function(e,data){
								
				//判断是否重新实例化scroll组件
				if(deleteFlag == true){ //删除操作，不实例化
					deleteFlag = false;
					return;
				}
				
			    var bookData = [];
				for(var i=0;i<data.data.length;i++){
					var one = {};
					one.uuid = data.data[i].id;
					one.name = data.data[i].bookName;
					one.type = ""+(data.data[i].bookType);
					if(typeof(data.data[i].pageCount) == "undefined" || parseInt(data.data[i].pageCount) == 0){
						one.status = "未书写";
					}else{
						one.status = "已书写"+data.data[i].pageCount+"页";
					}
					one.locked = data.data[i].activeFlag;
					one.lastWriteTime = data.data[i].lastUpdateDate;
					bookData.push(one);
				}
				if(!currBookData){
					currBookData = bookData;
					if(scrollPanel){
						scrollPanel.remove();
						scrollPanel = null;
					}
				}else{ //判断有没有发生改变
					if(that.checkIsDiff(bookData)){ //发生了改变
						if(scrollPanel){
							scrollPanel.remove();
							scrollPanel = null;
						}
					    NoteBookDataModel.getData();
					}else{ //未发生改变
						for(var i=0;i<currBookData.length;i++){
							$("[data-id='"+currBookData[i].uuid+"']").BookCell("setLastWriteTime",currBookData[i].lastWriteTime);
							$("[data-id='"+currBookData[i].uuid+"']").BookCell("setSecText",currBookData[i].status);
							$("[data-id='"+currBookData[i].uuid+"']").BookCell("setLastWriteTime",currBookData[i].lastWriteTime);
							if(parseInt(currBookData[i].locked) == 0){
								$("[data-id='"+currBookData[i].uuid+"']").BookCell("setBookLock");
							}else{
								$("[data-id='"+currBookData[i].uuid+"']").BookCell("setBookUnLock");
							}
						}
						return;
					}
				}
				
				scrollPanel = $("<div id='wrapper'></div>");
				scrollPanel.css("overflow","hidden");
		        scrollPanel.css({"width":"100%","height":$(window).height()-addBookBtnPanel.offset().top-addBookBtnPanel.height()+"px"});
				$("body").append(scrollPanel);
				var ul = $("<ul></ul>");
				scrollPanel.append(ul);
				if(bookData.length > 0){
					$(".header").NewHeader("addSecTitle","共"+bookData.length+"个智能本");
				}
				for(var i=0;i<bookData.length;i++){
					console.log(bookData);
					var li = $("<li class='BookCell'></li>").BookCell(bookData[i]);
					li.bind("BOOK_CLICK",that,that.onBookClick);
					li.bind("SYN_CLOUD_SPACE",that,that.onSynCloudSpaceBtnClick);
					li.bind("SYN_OFFLINE_DATA",that,that.onSynOfflineDataClick);
					li.bind("DEAL",that,that.onDealBtnClick);
					//li.bind("DELETE",that,that.onDeleteBtnClick);
					li.bind("LOCK",that,that.onLockBtnClick);
					li.bind("UNLOCK",that,that.onUnlockBtnClick);
					li.bind("RENAME",that,that.onRenameBtnClick);
					ul.append(li);
				}
				ul.css("min-height",parseInt(scrollPanel.css("height").replace("px",""))+1+"px");
				//初始化滚动插件
				myScroll = new IScroll("#wrapper",{
					bounceTime:300,//配置滑动回弹时间
					probeType:3,
				});
				myScroll.on('scrollStart', function(){
					$(".BookCell").each(function(){
						$(this).attr("data-more-click","off");
					});
					Shell.sendEvent("LockSwitchActivity");
					myScroll.refresh();//刷新高度
				});
				myScroll.on('scrollEnd', function(){
					Shell.sendEvent("unLockSwitchActivity");
					$(".BookCell").each(function(){
						$(this).attr("data-more-click","on");
					});
					myScroll.refresh();//刷新高度
				});
				
			});
			if(typeof(api) == "undefined"){
				TokenDataModel.ACCOUNT_CODE = "3845536128749059108";
			}else{
				TokenDataModel.ACCOUNT_CODE = localStorage.getItem("accountCode");
			}
		},
		onBookClick:function(e,data){
			var uuid = data.uuid;
			var type = parseInt(data.type);
			if(interWinLock){
				return;
			}
			interWinLock = true;
			setTimeout(function(){
			    interWinLock = false;
			},1000);
			Shell.sendEvent("InterBook",{"bookId":uuid,"bookType":type});
		},
		//同步云空间功能点击
		onSynCloudSpaceBtnClick:function(e,data){
			
		},
		//同步离线数据功能点击
		onSynOfflineDataClick:function(e,data){
		},
		//删除党建本
		onDeleteBtnClick:function(uuid){
			try{
				api.addEventListener({"name":"AlertHasBeedClick"},function(e){
					api.removeEventListener({"name":"AlertHasBeedClick"});
					if(e.value.index == 1){
						//调用删除党建本
						NoteBookDataModel.delete(uuid);
					}
				});
				Shell.sendEvent("ShowMeTheAlert",{"title":"删除后将无法恢复笔记内容，确定要删除吗？","btn":["取消","确认"]});
			}catch(e){
				//alert(e);
			}
		},
		//锁定党建本
		onLockBtnClick:function(e,data){
			api.toast({
			    msg: '至少启用一个同类智能本',
				duration: 1000,
			    location: 'middle'
			});
			return;
			//判断是否是最后一个本子
			if($("[data-type='"+data.type+"']").length == 1){
				try{
					api.toast({
						msg: '至少启用一个同类智能本',
						duration: 1000,
						location: 'middle'
					});
				}catch(e){}
				return;
			}
			try{
				api.addEventListener({"name":"AlertHasBeedClick"},function(e){
					api.removeEventListener({"name":"AlertHasBeedClick"});
					if(e.value.index == 1){
						NoteBookDataModel.lock(data.uuid);
					}
				});
				Shell.sendEvent("ShowMeTheAlert",{"title":"锁定后书写的内容将停止更新，是否确定锁定？","btn":["取消","确认"]});
			}catch(e){
				//alert(e);
			}
		},
		//解锁党建本
		onUnlockBtnClick:function(e,data){
			try{
				api.addEventListener({"name":"AlertHasBeedClick"},function(e){
					api.removeEventListener({"name":"AlertHasBeedClick"});
					if(e.value.index == 1){
						NoteBookDataModel.unlock(data.uuid);
					}
				});
				Shell.sendEvent("ShowMeTheAlert",{"title":"启用后同类型已启用状态的智能本将自动锁定，是否确定启用？","btn":["取消","确认"]});
			}catch(e){
				//alert(e);
			}
		},
		//重命名党建本
		onRenameBtnClick:function(e,data){
			try{
				Shell.sendEvent("CallRenameNoteBook",{"uuid":data.uuid,"name":data.name,"url":TokenDataModel.getDomain()+NoteBookDataModel.renameApi});
			}catch(e){}
		},
		//操作按钮被点击
		onDealBtnClick:function(e,data){
			var uuid = data.uuid;
			api.addEventListener({"name":"ActionMenuOptionClick"},function(e){
				api.removeEventListener({"name":"ActionMenuOptionClick"});
				if(e.value.actionId == 0){ //同步到云空间
					NoteBookDataModel.synYsnoteFileToCloudspace(uuid);
				}else if(e.value.actionId == 1){ //同步离线数据
					//给刚哥发送同步离线数据事件
					Shell.sendEvent("SynOfflineDataStart",{"uuid":uuid});
				}else if(e.value.actionId == 2){ //删除
				    Controller.onDeleteBtnClick(uuid);
				}
			});
			var btnData = [];
			if(data.options == 1){
				//激活状态不能删除
				btnData.push({"actionId":0,"name":"同步到云端"});
				btnData.push({"actionId":3,"name":"取消"});
			}else{
				btnData.push({"actionId":0,"name":"同步到云端"});
				btnData.push({"actionId":2,"name":"删除"});
				btnData.push({"actionId":3,"name":"取消"});
			}
			Shell.sendEvent("ShowActionMenu",{
				"menuType":1,
				"btn":btnData
			});   
		},
		//判断数据有没有发生改变
		//以此来判断需不需要刷新
		checkIsDiff:function(data){
			var beforeUUIDs = [];
			var currUUIDs = [];
			for(var i=0;i<currBookData.length;i++){
				beforeUUIDs.push(currBookData[i].uuid);
			}
			beforeUUIDs.sort();
			for(var i=0;i<data.length;i++){
				currUUIDs.push(data[i].uuid);
			}
			currBookData = data;
			if(currUUIDs.sort().toString() == beforeUUIDs.sort().toString()){ //全等，不必刷新页面
				return false;
			}else{
				return true;
			}
		}
		
    }
    
    return Controller;
});
