const { data } = require("jquery");

/*
*   2021年3月22日
*
*   保险箱笔记转为文档页面js控制器
*
*   开发者：付长建
*/
define(["jquery","Shell","Fastclick","CommonToast","CommonHead","CommonIscroll","FootBottom","YsnoteCell","ChangeMask"],function($,Shell,Fastclick){
    var Controller = {
        selectData:[],//选中数据数组
        imgArray:[],//转换文档的图片数据
        bookPageList:[], //根据党建本ID查询党建本明细记录
        taskId:null,//转换任务id
        sum:0,//任务总批次
        transformTime:null,//轮询转换任务定时器
        isTrans:false,//是否开始轮询任务
        fileName:"",//转换得文件名称
        fileId:"",//转换成功文档得唯一id
        isClick:false,
        isBack:true, // 返回事件
        currentPage:'1000',
        //页面加载成功执行的方法
        init:function(){
            //设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            //禁止整个页面滚动
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});
            //获取配置信息
            // 替换云空间配置接口 0715
            http(ServerConfig.cloudDomain+"/Setting/getGlobal",{"token":getUrl("cloudToken")},{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        global.userInfo = arg.data.userInfo;//得到用户信息
                        global.preview_config = arg.data.preview_config;//得到文件预览配置
                        global.is_thumb_model = arg.data.is_thumb_model;//得到是否显示搜索图
                        global.thumb_width_height_config = arg.data.thumb_width_height_config;//得到缩略图配置
                        global.skin = arg.data.skin_name;//得到皮肤配置
                        global.is_yingshuo = arg.data.is_yingshuo;//得到是否显示云笔记筛选选项
                        global.version = arg.data.version;//得到当前是哪个版本
                        // global.noet = arg.data.text_recognise_config;//得到转换服务地址
                        Controller.create();//调用创建页面方法
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            try{
                                api.toast({msg:arg.msg,duration:2000,location:"middle"});
                            }catch(e){}
                        }
                    }
                }
            });
            //监听ajax请求错误
            $(window).bind("HTTP_REQUEST_ERROR",function(event,msg){
                try{
                    api.toast({msg:msg,duration:2000,location:"middle"});
                }catch(e){}
            });
            
        },
        //生成页面
        create:function(){
            //监听 coordination.html 发过来的事件
            api.addEventListener({"name":"backCoordination"},function(){
                Controller.isBack = true;
            });
            //初始化飘窗组件
            this.toastContainer = $("<div></div>").CommonToast().appendTo($("body"));
            //初始化头部组件
            this.headContainer = $("<div></div>").appendTo($("body"));
            //判断是否需要云笔记选项
            this.headContainer.CommonHead({
                "isGoback":true,//是否显示返回按钮
                "title":"选择页码",
            });
            //初始化滚动容器组件
            this.iscrollContainer = $("<div id='changeDowContainer' style='padding:0 0.15rem 0 0.15rem;box-sizing:border-box;overflow:hidden;'></div>").appendTo($("body"));
            //初始化底部foot组件
            this.footContainer = $("<div></div>").appendTo($("body"));
            this.footContainer.FootBottom();
            //初始化滚动组件
            this.iscrollContainer.css("height",$("body").height() - this.headContainer.outerHeight(true) - this.footContainer.outerHeight(true) + "px");//设置滚动组件的高度
            this.iscrollContainer.CommonIscroll({"isUploadBtn":false,"isRefresh":false,"isLoad":false,"isPaddingBottom":"0.15rem"});

            //监听返回按钮被点击
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                // 销毁组件
                Controller.iscrollContainer.find("li").YsnoteCell("destroy");
                // 清空内容
                Controller.iscrollContainer = $("<div id='changeDowContainer' style='padding:0 0.15rem 0 0.15rem;box-sizing:border-box;overflow:hidden;'></div>").appendTo($("body"));
                Shell.sendEvent("closeWin");//关闭当前页面
            });
            this.iscrollContainer.unbind("YSNETCELL_SELECT");
            //监听cell组件勾选事件
            this.iscrollContainer.bind("YSNETCELL_SELECT",function(event,obj){
                //判断当前是取消还是选中
                // alert('判断当前是取消还是选中:' + JSON.stringify(obj))
                if(Controller.isBack) {
                    if(obj.type == "yes"){
                        Controller.selectData.push(obj.data);
                    }else{
                        //循环取消选中数据
                        for(var i = 0; i < Controller.selectData.length; i++){
                            if(Controller.selectData[i].pageNo == obj.data.pageNo){
                                Controller.selectData.splice(i,1);
                                break;
                            }
                        }
                    }
                    listSelect();//调用cell操作方法
                }
                
            });
            //监听底部foot点击全选和全不选按钮
            this.footContainer.bind("ALL_SELECT",function(event,type){
                Controller.iscrollContainer.find("li").YsnoteCell("checkSelect",type);//选中或者不选中cell
                Controller.selectData = [];//清空选中数据
                //判断是全选还是反选
                if(type == "yes"){
                    Controller.iscrollContainer.find("li").each(function(){
                        Controller.selectData.push($(this).YsnoteCell("getData"));
                    });
                    Controller.footContainer.FootBottom("setSelectNumm",Controller.iscrollContainer.find("li").length);//设置选中cell数量
                    Controller.headContainer.CommonHead("showDetermine");//调用头部组件显示确定按钮
                }else{
                    Controller.footContainer.FootBottom("setSelectNumm",0);//设置选中cell数量
                    Controller.headContainer.CommonHead("hideDetermine");//调用头部组件隐藏确定按钮
                }
            });
            //监听cell组件被点击
            this.iscrollContainer.bind("YSNET_CELL_CLICK",function(event,obj){
                var mask = $("<div style='z-index:1;position:absolute;top:0;left:0;width:100%;height:100%;background:rgba(0,0,0,0.5);opacity:0;display:flex;justify-content:center;align-items:center;'></div>").appendTo($("body"));
                var imgContainer = $("<div style='width:100%;display:flex;justify-content:center;align-items:center;'></div>").appendTo(mask);
                $("<img style='max-width:30%;' src='"+obj.recordUrl+"'/>").appendTo(imgContainer);
                //执行动画
                setTimeout(function(){
                    mask.stop().animate({"opacity":1},"fast");
                    imgContainer.find("img").stop().animate({"max-width":"100%"},"fast");
                    mask.bind("click",function(){
                        mask.stop().animate({"opacity":0},"fast");
                        imgContainer.find("img").stop().animate({"max-width":"30%"},"fast",function(){
                            mask.remove();
                        });
                    });
                },20);
            });
            //监听头部组件点击确定按钮
            this.headContainer.bind("DETERMINE_BTN_CLICK",function(){
                Controller.isTrans = true;//允许轮询
                //初始化弹框提示
                Controller.changeMaskContainer = $("<div style='z-index:2;'></div>").appendTo($("body"));
                Controller.changeMaskContainer.ChangeMask();
                Controller.headContainer.CommonHead("changeGobackBtnColor","yes");//锁定头部组件返回按钮
                Controller.headContainer.CommonHead("changeDetermineBtnColor","yes");//锁定头部组件确定按钮
                Controller.footContainer.FootBottom("lock","yes");//锁定底部操作
                //监听弹窗组件点击了取消转换事件
                Controller.changeMaskContainer.bind("CANCELTARE_BTN_CLICK",function(){
                    Controller.isTrans = false;//标记轮询取消
                    Controller.headContainer.CommonHead("changeGobackBtnColor","no");//解锁头部组件返回按钮
                    Controller.headContainer.CommonHead("changeDetermineBtnColor","no");//解锁头部组件确定按钮
                    Controller.footContainer.FootBottom("lock","no");//解锁底部操作
                    cancelTransform();//取消转换任务
                });
                //这里为了更好的用户体验，采取延迟300毫秒要不然在原生转换图片时页面没有任何反馈
                setTimeout(function(){
                    //转文档
                    Controller.sum = Controller.selectData.length;//赋值总批次
                    Controller.taskId = null;//清空任务id
                    deliveryTransformation();//调用投递转换文档方法
                },300);
            });
            //解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
            //页面渲染完成开始监听原生抛出的事件

            try{
                //监听原生抛出来的数据
                api.addEventListener({"name":"sendPageImageData"},function(e){
                    if(Controller.isBack && Controller.fileName == ""){
                        Controller.fileName = e.value.fileName;//文件名称
                        Controller.currentPage = e.value.currentPage;
                        // 根据党建本ID查询党建本明细记录
                        getBookPageList();
                    }
                });
                //监听笔记首页发送过来的移除页面监听事件的事件
                api.addEventListener({name:"H5removeEvent"},function(arg){
                    removeAllEvent();//调用移除页面监听事件方法
                });
            }catch(e){}
            
            
            setTimeout(function(){
                //通知原生加载完毕
               Shell.sendPageReady();
           },300);
            $("body").fadeTo("slow",1);
        }
    }
    //移除页面监听事件方法
    function removeAllEvent(){
        try{
            api.removeEventListener({"name":"sendPageImageData"});//移除原生抛出来的数据
            // api.removeEventListener({"name":"sendImageResultData"});//移除原生转换base64图片转换完成事件
            api.removeEventListener({"name":"H5removeEvent"});//移除笔记首页发送过来的移除页面监听事件的事件
        }catch(e){}
    }
    //生成cell卡片方法
    function getListCell(dataArray,page){
        if(page === undefined || page === ""){
            // alert("请原生人员传入currentPage参数（当前是在第几页点击的转换）");
            return;
        }
        Controller.iscrollContainer.find("ul").css({"min-height":"","display":"flex","flex-direction":"row","flex-wrap":"wrap","justify-content":"space-between"});
        var cellArray = [];
        for(var i = 0; i < dataArray.length; i++){
            var cell = $("<li class='ysnetCell"+i+"' style='width:30.6666667%;height:1.43rem;margin-top:0.15rem;border-radius:1px 0.08rem 0.08rem 0px;box-sizing:border-box;overflow:hidden;box-shadow:rgba(0, 37, 87, 0.2) 1px 0px 4px 0px;'></li>").YsnoteCell({"data":dataArray[i]});
            if(Controller.selectData != ''){
                Controller.selectData.forEach(element => {
                    if(parseInt(element.page) == parseInt(dataArray[i].pageNo)){
                        cell.addClass("setDefault");
                    }
                });
            }else if(parseInt(dataArray[i].pageNo) == parseInt(page)){
                cell.addClass("setDefault");
            }
            cellArray.push(cell);
        }
        Controller.iscrollContainer.CommonIscroll("initNode",cellArray);//调用滚动组件初始化数据
        Controller.footContainer.FootBottom("allowClick");//允许底部foot点击全选按钮
        $(".setDefault").YsnoteCell("defaultClick");//调用cell组件默认选中事件
    }
    //选中cell操作方法
    function listSelect(){
        // alert('选中cell操作方法')
        if(Controller.selectData.length != 0){
            Controller.headContainer.CommonHead("showDetermine");//调用头部组件显示确定按钮
            if(Controller.selectData.length == Controller.iscrollContainer.find("li").length){
                Controller.footContainer.FootBottom("changeAllSelect","yes");
            }else{
                Controller.footContainer.FootBottom("changeAllSelect","no");
            }
        }else{
            Controller.headContainer.CommonHead("hideDetermine");//调用头部组件隐藏确定按钮
        }
        // alert('设置选中cell数量:' + Controller.selectData.length)
        Controller.footContainer.FootBottom("setSelectNumm",Controller.selectData.length);//设置选中cell数量
    }


    //根据党建本ID查询党建本明细记录
    function getBookPageList(){
        var smartPenData =  JSON.parse(localStorage.getItem("configData"))
        //请求参数
        var paramet = {"token":smartPenData.token,
            "accountCode":smartPenData.accountCode,
            "bookId":getUrl("bookId"),
            "noEmptyPageFlag":"1"   // 传给滕老师的参数，解决bug53382，转文档时内页空白且有图片不显示
        };
        // 接口判断
        Controller.ajaxTimeoutTest = $.ajax({
            cache:false,
            type:"POST",
            url:ServerConfig.djDomain+"/ctl/cpcapi/book/get_book_page_list",
            timeout:3000,
            data:paramet,
            dataType:"json",
            success:function(arg){
                if(arg.retCode == "SUCCESS"){
                    try{
                        setTimeout(function(){
                            // 插入数据
                            Controller.bookPageList = [...arg.data];
                            getListCell(Controller.bookPageList,Controller.currentPage);//调用生成cell卡片方法
                        },300);
                    }catch(e){}
                    
                   
                }else if(arg.retCode == "NO_AUTH"){
                    try{
                        Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                    }catch(e){}
                }else{

                    try{
                        api.toast({msg:arg.message,duration:1500,location:"middle"});
                    }catch(e){}
                }
            },
        });
    }

    
    //投递转换文档方法
    function deliveryTransformation(){
        //请求参数
        // 替换云空间配置接口 0715
        let imageList= Controller.selectData.map(img => {
            let data = {}
            data.page = img.pageNo
            data.data = img.strokeLayerUrl
            return data
        })
        var paramet = {"token":getUrl("cloudToken"),"images":JSON.stringify(imageList),"taskID":Controller.taskId,"userID":global.userInfo.id,"sum":Controller.sum};
        // alert(JSON.stringify(paramet))
        // alert("投递转换文档方法参数imageToWord: " + JSON.stringify(paramet));
        http(NoteChange.note_change_word,paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    // alert("投递转换文档方法成功：" + JSON.stringify(arg))
                    Controller.taskId = arg.data.taskID;//得到创建的任务id
                    //判断是否点击了取消
                    if(Controller.isTrans){
                        transformDocument();//调用开始转换文档方法
                    }
                    // }
                }else{
                    //判断是否是退出登录了
                    if(arg.data.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        Controller.changeMaskContainer.ChangeMask("closMask");//关闭弹窗
                        Controller.toastContainer.CommonToast("showToast",arg.message);//显示错误提示
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            Controller.changeMaskContainer.trigger("CANCELTARE_BTN_CLICK");//模拟点击取消按钮
                        },1500);
                    }
                }
            },
            error:function(res){
            },
        });
    }
    //开始转换文档方法（这个方法需要轮询处理）
    function transformDocument(){
        //判断是否取消了
        if(!Controller.isTrans){
            return;
        }
        //请求参数
        var paramet = {"token":getUrl("cloudToken"),"id":Controller.taskId};
        http(NoteChange.note_result,paramet,{
            success:function(arg){
                // alert(JSON.stringify(arg))
                if(parseInt(arg.code) == 1){
                    if(arg.data.status == "doing"){
                        var mix = ((100 / arg.data.sumNum) * arg.data.currNum);//得到一张图片占比进度多少并且计算出当前进度
                        if(mix == 0){
                            Controller.changeMaskContainer.ChangeMask("setSpeed","0%");//调用弹窗组件设置百分比方法;
                        }else{
                            var str = String(mix);
                            if(str.indexOf(".") != -1){
                                Controller.changeMaskContainer.ChangeMask("setSpeed",mix.toFixed(1) + "%");//调用弹窗组件设置百分比方法;
                            }else{
                                Controller.changeMaskContainer.ChangeMask("setSpeed",mix + "%");//调用弹窗组件设置百分比方法;
                            }
                        }
                        //2秒后调用自己本身进行轮询
                        Controller.transformTime = setTimeout(function(){
                            transformDocument();//调用自己本身轮询
                        },2000);
                    }else if(arg.data.status == "complete"){
                        clearTimeout(Controller.transformTime);//清掉定时器
                        transformSuccess(arg.data);//调用后端创建临时存放数据并拿到协同地址
                    }else if(arg.data.status == "fail"){
                        Controller.changeMaskContainer.ChangeMask("closMask");//关闭弹窗
                        Controller.toastContainer.CommonToast("showToast",arg.message);//显示错误提示
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            Controller.changeMaskContainer.trigger("CANCELTARE_BTN_CLICK");//模拟点击取消按钮
                        },1500);
                    }
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        Controller.changeMaskContainer.ChangeMask("closMask");//关闭弹窗
                        Controller.toastContainer.CommonToast("showToast",arg.message);//显示错误提示
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            Controller.changeMaskContainer.trigger("CANCELTARE_BTN_CLICK");//模拟点击取消按钮
                        },1500);
                    }
                }
            }
        });
    }
    //创建临时存放数据并拿到协同地址
    function transformSuccess(obj){
        //请求参数
        var smartPenData =  JSON.parse(localStorage.getItem("configData"))
        // 换成java接口
        var paramet = {"token":smartPenData.token,"accountCode":smartPenData.accountCode,"pid":0,"name":Controller.fileName,"ext":obj.fileInfo.ext,"fileinfo_id":obj.fileInfo.uuid,"mime":obj.fileInfo.mime,"file_size":obj.fileInfo.size,"file_id":""};
        http(ServerConfig.djDomain+"/ctl/cpcapi/temporarySpace/addFile",paramet,{
            success:function(arg){
                if(arg.retCode == "SUCCESS"){
                    Controller.fileId = arg.data.uuid;//得到文档转换成功文件唯一id
                    Controller.changeMaskContainer.ChangeMask("setSpeed","100%");//调用弹窗组件设置百分比方法
                    Controller.changeMaskContainer.ChangeMask("successFunEs","转换成功：2s后自动进入编辑");//调用提示弹出组件成功方法
                    setTimeout(function(){
                        Controller.changeMaskContainer.ChangeMask("closMask");//关闭弹窗
                        Controller.headContainer.CommonHead("changeGobackBtnColor","no");//解锁头部组件返回按钮
                        Controller.headContainer.CommonHead("changeDetermineBtnColor","no");//解锁头部组件确定按钮
                        Controller.footContainer.FootBottom("lock","no");//解锁头部组件
                        var dataPame = arg.data.url.split("/");
                        var http = dataPame[0]+"//"+dataPame[2];
                        var uuid = dataPame[4];
                        var token = dataPame[5];
                        // 传参
                        Controller.isBack = false;
                        Shell.sendEvent("openWin",{"url":"/coordination/coordination.html?token="+token+"&uuid="+uuid+"&http="+http+"&fileId="+Controller.fileId + "&accountCode=" + global.userInfo.username,"open_type":true,"title":Controller.fileName,"preview":true});//告诉原生协同地址
                    },2000);
                    
                }else{
                    //判断是否是退出登录了
                    if(arg.retCode == "NO_AUTH"){
                        try{
                            Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                        }catch(e){}
                    }else{
                        Controller.changeMaskContainer.ChangeMask("closMask");//关闭弹窗
                        Controller.toastContainer.CommonToast("showToast",arg.message);//显示错误提示
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            Controller.changeMaskContainer.trigger("CANCELTARE_BTN_CLICK");//模拟点击取消按钮
                        },1500);
                    }
                }
            }
        });
    }
    //取消转换文档方法
    function cancelTransform(){
        clearTimeout(Controller.transformTime);
        //请求参数
        // 替换云空间配置接口 0715
        var paramet = {"token":getUrl("cloudToken"),"id":Controller.taskId};
        http(NoteChange.note_cancel,paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){

                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        
                    }
                }
            }
        });
    }
    return Controller;
});
