/*
*   2021年4月29日
*
*   笔使用说明页面
*
*   开发者：付长建
*/
define(["jquery","Shell","Fastclick","iscroll"], function ($,Shell,Fastclick,iscroll) {
    var Controller = {
		iscroll:null,//滚动插件
		isClick:true,//防止点击事件多次执行
        init:function(){
			//设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});//禁止整个页面滚动
            //创建头部元素
            var maxHeadContainer = $("<div style='width:100%;padding-top:"+phonexh("top")+"px;border-bottom:1px solid rgb(236,236,236);box-sizing:border-box;'></div>").appendTo($("body"));
            this.headContent = $("<div style='width:100%;height:0.44rem;display:flex;flex-direction:row;justify-content:center;position:relative;'></div>").appendTo(maxHeadContainer);
            $("<div style='height:100%;display:flex;align-items:center;justify-content:center;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;position:absolute;top:0;left:0;'><img style='width:9px;height:16px;' src='../djcommon/img/common/icon_back@3x.png'/></div>").appendTo(this.headContent);
            $("<span style='display:flex;align-items:center;justify-content:center;font-size:0.18rem;font-weight:bold;color:#000;'>使用说明</span>").appendTo(this.headContent);
			//创建内容容器 
			var contentContainer = $("<div id='notePendesc' style='width:100%;height:"+($(window).height() - maxHeadContainer.outerHeight(true))+"px;overflow:hidden;'></div>").appendTo($("body"));
			var content = $("<div style='width:100%;min-height:"+(contentContainer.height() + 1)+"px;overflow:hidden;'></div>").appendTo(contentContainer);
			$("<img style='max-width:100%;' src='../djcommon/img/note/notependesc.png'/>").appendTo(content);
			//给头部的返回按钮绑定点击事件
            this.headContent.children("div").bind("click",goBackClick);
			//初始化筛选滚动插件
            this.iscroll = new iscroll("#notePendesc",{
                click:iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });
			//解决移动端点击事件300ms延迟问题
			Fastclick.attach(document.body);
            //通知原生加载完毕 
            Shell.sendPageReady(); 
            $("body").fadeTo("slow",1,function(){
				Controller.iscroll.refresh();
			});
        }
    }
	//判读设备函数（主要解决点击事件失效问题）
    function iScrollClick(){
        if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
        if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
        if (/Silk/i.test(navigator.userAgent)) return false;
        if (/Android/i.test(navigator.userAgent)) {
        var s = navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
            return parseFloat(s[0]+s[3]) < 44 ? false : true
        }
    }
	//点击头部返回按钮
	function goBackClick(){
		//判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("closeWin");//关闭当前页面
            }catch(e){}
        }
	}
    return Controller;
});
