/*
*   2020年12月2日
*
*   新建笔记-帮助的js控制器
*
*   开发者：薛原 (付长建改造)
*/
define(["jquery","Shell","Fastclick","iscroll","CommonHead"], function ($,Shell,Fastclick,iscroll) {
    var Controller = {
        init:function(){
			//设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
			$("html").css("font-size",$(window).width() / (375 / 100) + "px");
			global.skin = "redyingshuo";//当前是红色皮肤
			Controller.create();//调用生成页面方法
        },
        //生成页面方法
        create:function(){
			//初始化头部组件
            this.headContainer = $("<div></div>").appendTo($("body"));
            this.headContainer.CommonHead({
                "isGoback":true,
                "title":"帮助"
            });
			//创建内容容器
			this.contentContainer = $("<div id='helpIscroll' style='width:100%;height:"+($("body").height() - this.headContainer.outerHeight(true))+"px;border-top:1px solid #EAEFF2;box-sizing:border-box;overflow:hidden;'></div>").appendTo($("body"));
			this.content = $("<div style='width:100%;min-height:"+(this.contentContainer.outerHeight(true) + 1)+"px;padding:0 0.15rem 0.3rem 0.15rem;box-sizing:border-box;overflow:hidden;'></div>").appendTo(this.contentContainer);
			$("<div style='display:flex;flex-direction:row;align-items:center;margin-top:0.2rem;'><span style='display:inline-block;width:0.06rem;height:0.06rem;border-radius:50%;background:#666;margin-right:0.12rem;'></span><span style='font-size:0.15rem;font-weight:bold;'>如何创建智能本？</span></div>").appendTo(this.content);
			var t1 = $("<div style='width:100%;display:flex;justify-content:space-between;margin:0.23rem 0 0.2rem 0;'><img style='width:50%;' src='../djcommon/img/note/b_icon_2.png'/><img style='width:50%;' src='../djcommon/img/note/b_icon_1.png'/></div>").appendTo(this.content);
			t1.find("img").each(function(){
				$(this).bind("load",function(){
					$(this).css("height",$(this).width()/172*200);
				});
			});
			$("<p style='font-size:0.14rem;color:#666;line-height:0.24rem;'>1.进入新建智能本页面，会显示所有的您购买的智能本，选择一个您想要创建的智能本类型，点击确定即可创建成功。<br/>注意：新建智能本之后，之前的本子会自动锁上。书写的数据将同步到新建的本子上。</p>").appendTo(this.content);
			$("<div style='display:flex;flex-direction:row;align-items:center;margin-top:0.3rem;'><span style='display:inline-block;width:0.06rem;height:0.06rem;border-radius:50%;background:#666;margin-right:0.12rem;'></span><span style='font-size:0.15rem;font-weight:bold;'>最多可创建多少同类型智能本？</span></div>").appendTo(this.content);
			$("<p style='font-size:0.14rem;color:#666;margin-top:0.1rem;'>同一种类型的智能本最多可以创建1000个智能本</p>").appendTo(this.content);
			//点击返回按钮
			this.headContainer.bind("GOBACK_BTN_CLICK",function(){
				Shell.sendEvent("closeWin");//关闭当前页面
			});
			//通知原生关闭加载动画
			setTimeout(function(){
				Shell.sendPageReady();
				//初始化滚动插件
				this.iscroll = new iscroll("#helpIscroll",{
					tap:true,//开启自定义的点击事件
					bounceTime:300,//配置滑动回弹时间
					probeType:3//开启这个参数就可以每滑动1px获取一次值
				});
				this.iscroll.on("scrollStart",function(){
					Shell.sendEvent("LockSwitchActivity");
				});
				this.iscroll.on("scrollEnd",function(){
					Shell.sendEvent("unLockSwitchActivity");
				});
				// Controller.iscroll.refresh();
			},100);
			//解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
		}
    }
    return Controller;
});
