/*
*   2021年4月13日
*
*
*   开发者：熊世华
*/

define(["jquery","Shell","Fastclick","iscroll", "CommonHead", "CommonToast"],function($,Shell,Fastclick,iscroll){
    var Controller = {
        iscroll:null,//滚动插件
        headContainer: null,//头部组件
        pageName:"bookmanage",//当前页面的名称主要用于监听原生事件在本页面执行 
        isClick:true,//防止点击事件多次执行 
        selectTypeList: [],
        selectLableList: [],
        init:function(){
            var that = this;
            global = JSON.parse(localStorage.getItem("configData"));//获取配置信息
            //创建飘窗提示元素
            this.toastContainer = $("<div></div>").CommonToast().appendTo($("body"));

			//设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});//禁止整个页面滚动

            //初始化头部组件
            this.headContainer = $("<div style='border-bottom: 1px solid #EAEFF2;box-sizing:border-box'></div>").appendTo($("body"));
            //判断是否需要云笔记选项
            this.headContainer.CommonHead({
                "isGoback": true,//是否显示返回按钮
                "title": "归档整理",
            });

            // 监听返回按钮被点击
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                goBackClick(); // 关闭当前页面
            });

            //创建滚动容器
            var bottom = phonexh("bottom") == 0 ? 0 : 20;
            var maxIscrollContainer = $("<div id='maxIscrollContainer' style='width:100%;height:"+($(window).height() - this.headContainer.outerHeight(true) - bottom)+"px;overflow:hidden;background:#F9FBFD;'></div>").appendTo($("body"));

            this.iscrollContent = $("<div style='width:100%;min-height:"+(maxIscrollContainer.height() + 1)+"px;box-sizing:border-box;'></div>").appendTo(maxIscrollContainer);
            //初始化滚动插件
            this.iscroll = new iscroll("#maxIscrollContainer",{
                click:iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });

            // 输入标题
            this.inputTitle = $("<div style='background: #FFF;padding-bottom:.2rem;padding-left:.15rem;padding-right:.15rem'><h3 style='color: #000000;font-size:.15rem;padding:.16rem 0'>标题名称</h3><div class='inputBox'><input type='text' maxlength='20' placeholder='请输入标题' style='font-size:.14rem; width:100%;line-height:.2rem'></div></div>").appendTo(this.iscrollContent);
            
            // 优化点击
            this.inputTitle.on('click', '.inputBox', function() {
                $(this).find('input').focus();
            })

            // 过滤特殊表情
            this.inputTitle.on('input', 'input', function() {
                noEmoji($(this));
            })


            // 选择分类
            this.selectType = $("<div style='margin-top:.12rem;background: #FFF;'>"
                +"<div style='border-bottom:1px solid #EAEFF2;padding:.18rem .12rem'>"
                    +"<div style='display: flex;align-items: center;justify-content: space-between;'>"
                        +"<div style='display: flex;align-items: center;'>"
                            +"<img style='width:.16rem;height:.16rem;' src='../djcommon/img/common/ic_fl_list.png'/>"
                            +"<span style='color:#000000;font-size:.15rem;margin-left:.03rem;font-weight: bold;'>选择分类</span>"
                        +"</div>"
                        +"<div style='width: .55rem;height: .24rem;border: .01rem solid #C82128;border-radius: .12rem;display: flex;align-items: center;justify-content:center;color:#C82128' class='pi-button select' data-type='0'>选择</div>"
                    +"</div>"
                    +"<div class='typeContainer' style='display: flex;flex-wrap: wrap;'></div>"
                +"</div>"
                +"<div style='padding:.18rem .12rem'>"
                    +"<div style='display: flex;align-items: center;justify-content: space-between;'>"
                        +"<div style='display: flex;align-items: center;'>"
                            +"<img style='width:.16rem;height:.16rem;' src='../djcommon/img/common/ic_bq_list.png'/>"
                            +"<span style='color:#000000;font-size:.15rem;margin-left:.03rem;font-weight: bold;'>选择标签</span>"
                        +"</div>"
                        +"<div style='width: .55rem;height: .24rem;border: .01rem solid #C82128;border-radius: .12rem;display: flex;align-items: center;justify-content:center;color:#C82128' class='pi-button select' data-type='1'>选择</div>"
                    +"</div>"
                    +"<div class='labelContainer' style='display: flex;flex-wrap: wrap;'></div>"
                +"</div>"
            +"</div><div style='height:.8rem'></div>").appendTo(this.iscrollContent);
            
            // 确认按钮
            this.submitBtn = $("<div style='width:100%; padding:.1rem 0 .25rem 0; box-sizing:border-box;position:fixed;left:0;bottom: 0;background:#F9FBFD;display: flex;justify-content: center;'><p class='pi-button submit' style='width:3.1rem;height:.44rem;display: flex;align-items: center;justify-content: center;border-radius: .22rem;background:linear-gradient(270deg, #CF000F 0%, #E30514 100%);font-size:0.16rem;color:#fff;font-weight:500;'>确认</p></div>").appendTo('body');

            // 点击选择按钮
            this.selectType.on('click', '.select', function() {
                if(Controller.isClick) {
                    var type = $(this).data('type'),
                    title = type == 0 ? '选择分类' : '选择标签';
                    try{
                        Shell.sendEvent("openWin",{"url":"/pigeonholeselect/pigeonholeSelect.html?pageType=" + type,"open_type":true, "title": title});
                    }catch(e){}
                }
            })

            // 点击删除
            this.selectType.on('click', '.del', function() {
                var id = $(this).data('id'),
                type = $(this).data('type');
                
                if(type == 0) {
                    that.selectTypeList  = that.selectTypeList.filter(function(e) { return e.id != id });
                    addTypeList('.typeContainer', that.selectTypeList);
                    localStorage.setItem('selectTypeList', JSON.stringify(that.selectTypeList));
                } else if (type == 1) {
                    that.selectLableList  = that.selectLableList.filter(function(e) { return e.id != id });
                    addTypeList('.labelContainer', that.selectLableList);
                    localStorage.setItem('selectLableList', JSON.stringify(that.selectLableList));
                }
            })

            // 点击确定按钮
            this.submitBtn.on('click', '.submit', function() {
                if(that.isClick) {
                    var title = $.trim(that.inputTitle.find('input').val());
                    if(!title) {
                        return toast('请输入标题');
                    }
                    if(!that.selectTypeList.length) {
                        return toast('请选择分类');
                    }
                    that.isClick = false;
                    that.addPigeonholde(title);
                    
                }
            })

            // 监听分类和标签选择确定
            try {
                api.addEventListener({"name":"H5PigeonholeSelectSubmit"},function(){
                    that.getSelectData();
                });
            } catch (error) {
                
            }
            
            // 编辑状态请求详情
            if(getUrl("id")) {
                this.getArchiveDetail();
            }

            this.getSelectData();

            //通知原生加载完毕
            setTimeout(function(){
                //解决移动端点击事件300ms延迟问题
			    Fastclick.attach(document.body);
                Shell.sendPageReady();
            },100);

            //调用监听原生抛出来的所有事件
			// monitorAllEvent();

		},
        // 获取选择数据
        getSelectData() {
            var selectTypeList = localStorage.getItem('selectTypeList') && JSON.parse(localStorage.getItem('selectTypeList')),
            archiveTitle = localStorage.getItem('archiveTitle')
            selectLableList = localStorage.getItem('selectLableList') && JSON.parse(localStorage.getItem('selectLableList'));
            if(archiveTitle) {
                this.inputTitle.find('input').val(archiveTitle)
            }
            if(selectTypeList && selectTypeList.length) {
                this.selectTypeList = selectTypeList;
                addTypeList('.typeContainer', selectTypeList);
            };
            if(selectLableList && selectLableList.length) {
                this.selectLableList = selectLableList;
                addTypeList('.labelContainer', selectLableList);
            };
        },
        // 添加归档
        addPigeonholde(title) {
            var selectTypeList = this.selectTypeList,
            selectLableList = this.selectLableList,
            loading = new Loading();
            var paramet = {
                "accountCode": global.accountCode,
                "token": global.token,
                "categoryIds": selectTypeList.map(function(e) { return e.id.toString() }).join(','), // 分类
                "tagIds": selectLableList.map(function(e) { return e.id }).join(','), // 标签
                "archiveTitle": title, // 归档标题
            }, archiveId = getUrl('id'),
            URL = archiveId ? '/ctl/cpcapi/archive/update_archive' : '/ctl/cpcapi/archive/add_archive';
            // 编辑
            if(archiveId) {
                paramet.archiveId = archiveId;
            // 新增
            } else {
                paramet.bookId = getUrl('noteId'); // 本子ID
                paramet.pageNos = getUrl('pageList'); // 文件页码
            }
            loading.show();

            http(ServerConfig.djDomain + URL, paramet,{
                success:function(arg){
                    if(arg.retCode == "SUCCESS"){
                        var title = archiveId ? '修改成功' : '添加成功';
                        if(archiveId) {
                            Shell.sendEvent("H5UpdateArchiveSuccess"); // 修改成功事件
                        } else {
                            Shell.sendEvent("H5AddArchiveSuccess"); // 添加成功事件
                        }
                        setTimeout(function() {
                            loading.hide();
                            toast(title, function() {
                                var num = archiveId ? '' : 2;
                                goBackClick(num); // 返回上一页
                            })
                        }, 600)
                    }else if(arg.retCode == "NO_AUTH"){
                        loading.hide();
                        Controller.isClick = true;
                        try{
                            Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                        }catch(e){}
                    }else{
                        loading.hide();
                        Controller.isClick = true;
                        try{
                            api && api.toast({msg:arg.message,duration:1500,location:"middle"});
                        }catch(e){}
                    }
                }
            });
        },
        // 获取归档信息
        getArchiveDetail() {
            var data = localStorage.getItem("archiveDetails")&&JSON.parse(localStorage.getItem("archiveDetails")),
            archiveTitle = localStorage.getItem('archiveTitle'),
            selectTypeList = localStorage.getItem('selectTypeList')&& JSON.parse(localStorage.getItem('selectTypeList')),
            selectLableList = localStorage.getItem('selectLableList') && JSON.parse(localStorage.getItem('selectLableList'));
            if(data) {
                if(data.archiveTitle && !archiveTitle) {
                    this.inputTitle.find('input').val(data.archiveTitle)
                    localStorage.setItem("archiveTitle", data.archiveTitle);
                }

                if(data.categoryList && data.categoryList.length && !selectTypeList) {
                    this.selectTypeList = data.categoryList.map(function(e) {
                        return {
                            id: e.id.toString(),
                            name: e.categoryName
                        }
                    })
                    localStorage.setItem("selectTypeList", JSON.stringify(this.selectTypeList));
                }
                if(data.tagList && data.tagList.length && !selectLableList) {
                    this.selectLableList = data.tagList.map(function(e) {
                        return {
                            id: e.id,
                            name: e.tagName
                        }
                    })
                    localStorage.setItem("selectLableList", JSON.stringify(this.selectLableList));
                }
                
            }
        }
    }

     //监听原生抛出来的所有事件
	function monitorAllEvent(){
        //监听原生点击退出登录按钮移除当前页面所有的事件监听
        api.addEventListener({"name":"noticeRemoveAllEvent"},function(){
            removeAllEvent();//调用移除当前页面所有的事件监听方法
        });
    }

    //移除当前页面所有的事件监听方法
	function removeAllEvent(){
		try{
            Shell.sendEvent("H5removeEvent");//给笔详情页面，连接管理页面，本子管理页面发送一个移除事件监听事件
			api.removeEventListener({"name":"H5PigeonholeSelectSubmit"});
            api.removeEventListener({"name":"noticeRemoveAllEvent"});//移除原生点击退出登录按钮移除当前页面所有的事件监听
			
			setTimeout(function(){
				Shell.sendEvent("eventRemoveComplete");//通知原生事件移除完成
			},100);
		}catch(e){}
	}

    // 添加分类
    function addTypeList(dom, typeList) {
        var html = [],
        type = dom == '.typeContainer' ? 0 : 1;
        for(var i=0; i< typeList.length; i++) {
            html.push("<div style='min-width: .4rem;height: .3rem;padding: 0 0 0 .12rem;background: #EFF0F3;border-radius: .15rem;margin-right: .16rem;display: flex;align-items: center; justify-content: space-between;margin-top:.16rem;font-size:.13rem;color:#666666'><div style='max-width: 1.2rem;overflow: hidden;white-space: nowrap;text-overflow: ellipsis;'>"+ typeList[i].name +"</div><img class='del' data-type='"+ type +"' data-id='"+ typeList[i].id +"' style='width:.06rem;height:.06rem;padding:.08rem;' src='../djcommon/img/common/delete_tag.png'/></div>")
        }
        Controller.selectType.find(dom).html(html);
        Controller.iscroll.refresh();// 刷新高度
    }
    //判读设备函数（主要解决点击事件失效问题）
    function iScrollClick(){
        if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
        if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
        if (/Silk/i.test(navigator.userAgent)) return false;
        if (/Android/i.test(navigator.userAgent)) {
        var s = navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
            return parseFloat(s[0]+s[3]) < 44 ? false : true
        }
    }
    //当用户点击返回按钮
    function goBackClick(num){
        // 判读防止多次执行
        try{
            if(num) {
              Shell.sendEvent("closeWinMulti", { byNum: num });//关闭当前页面
            } else {
              Shell.sendEvent("closeWin");//关闭当前页面
            }
        }catch(e){}
    }

    // 吐司提示
    function toast(text, callBack, time = 1500) {
        Controller.toastContainer.CommonToast("showToast", text);//显示飘窗提示
        setTimeout(function(){
            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
            callBack && callBack();
        }, time);
    }

    // loading 加载
    function Loading() {
        var $loading;
        this.show = function() {
            $loading = $("<div class='loading' style='position: fixed;top:0;height: 100%;width: 100%;background: rgba(255, 255, 255, .5);z-index: 999;display: flex;align-items: center;justify-content: center;'><img class='iconRotate' style='width:.22rem;height:.22rem;' src='../djcommon/img/red/pull_load.png'/></div>").appendTo("body");
        }
        this.hide = function() {
            if($loading) {
                $loading.remove();
            }
        }
    }

    function noEmoji(dom) {
        var html = $(dom).val(),
           oldHtml = "";
        oldHtml = html;
        var reg = /[\uD83C|\uD83D|\uD83E][\uDC00-\uDFFF][\u200D|\uFE0F]|[\uD83C|\uD83D|\uD83E][\uDC00-\uDFFF]|[0-9|*|#]\uFE0F\u20E3|[0-9|#]\u20E3|[\u203C-\u3299]\uFE0F\u200D|[\u203C-\u3299]\uFE0F|[\u2122-\u2B55]|\u303D|[\A9|\AE]\u3030|\uA9|\uAE|\u3030/ig;
        
        if(html.match(reg)) {
           html = html.replace(reg, '');
        }
 
        if(html != oldHtml) {
            $(dom).val(html);
        }
    };

    return Controller;
});
