/*
*   2021年4月14日
*
*
*   开发者：熊世华
*/
define(["jquery","Shell","Fastclick","iscroll", "CommonHead", "CommonDeleteMask", "CommonToast"],function($,Shell, Fastclick, iscroll){
    var Controller = {
        iscroll:null,//滚动插件
        headContainer: null,//头部组件
        pageName:"bookmanage",//当前页面的名称主要用于监听原生事件在本页面执行 
        isClick: true,//防止点击事件多次执行
        pageType: getUrl('pageType') || 0, // 0 分类列表 1 标签维护
        editId: '',
        editName: '',
        nameList: [],
        init:function(){
            var pageType = this.pageType,
            that = this;
            global = JSON.parse(localStorage.getItem("configData"));//获取配置信息
            // global.skin = "redyingshuo"
            
            //解决移动端点击事件300ms延迟问题
			Fastclick.attach(document.body);

            //创建飘窗提示元素
            this.toastContainer = $("<div></div>").CommonToast().appendTo($("body"));

			//设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});//禁止整个页面滚动

            //初始化头部组件
            this.headContainer = $("<div style='border-bottom: 1px solid #EAEFF2;box-sizing:border-box'></div>").appendTo($("body"));
            //判断是否需要云笔记选项
            this.headContainer.CommonHead({
                "isGoback": true,//是否显示返回按钮
                "title": pageType == 0 ? "笔记整理" : "标签维护",
            });
            // 添加右侧筛选
            if(pageType == 0) {
                $('.headRight').html("<div class='more' style='height:100%;display:flex;flex-direction:row;align-items:center;justify-content:center;'><img style='width:.18rem;height:.18rem;' src='../djcommon/img/common/btn-more.png'/></div>")
            } else {
                $('.headRight').html("<div class='add' style='height:100%;display:flex;flex-direction:row;align-items:center;justify-content:center;'><img style='width:.18rem;height:.18rem;' src='../djcommon/img/common/btn-add.png'/></div>")
            }
            
            if(pageType == 0) {
                // 添加搜索框
                this.searchInput = $("<div style='margin: .16rem .15rem;background: #F5F5F5;border-radius: 16px;height:.32rem;display:flex;align-items:center;color:#C8C8C8'><img style='width:.18rem;height:.18rem;margin-right:.05rem;margin-left:.14rem' src='../djcommon/img/common/ic_search.png'/><span>请输入您的关键字</span></div>").appendTo($("body"));

                // 点击搜索框
                this.searchInput.on('click', function() {
                    try{
                        Shell.sendEvent("openWin",{"url":"/pigeonholenotesearch/pigeonholeNoteSearch.html","open_type":true, "title":""});
                    }catch(e){}
                })
            }
            

            // 创建滚动容器
            var bottom = phonexh("bottom") == 0 ? 0 : 20;
            var hearderHeight = pageType == 0 ? 64 : 0;
            var maxIscrollContainer = $("<div id='maxIscrollContainer' style='width:100%;height:"+($(window).height()- this.headContainer.outerHeight(true) - hearderHeight - bottom)+"px;overflow:hidden;'></div>").appendTo($("body"));

            this.iscrollContent = $("<ul style='width:100%;box-sizing:border-box;'></ul>").appendTo(maxIscrollContainer);

            // 添加遮罩层
            this.overlay = $("<div style='position: fixed;top: 0;left: 0;z-index: 1;width: 100%;height: 100%;background-color: rgba(0, 0, 0, 0);display:none'></div>").appendTo($("body"));
            // 添加底部弹框
            this.bottomSheet = $("<div style='width:100%;height:1.42rem;background: #fff;position: fixed;bottom:0;border-radius: 15px 15px 0px 0px;overflow: hidden;z-index: 2;font-size:.15rem;color:#313340;display:none;box-shadow: 0px 16px 13px 15px #999;'></div>").appendTo($("body"));
            
            // 初始化滚动插件
            this.iscroll = new iscroll("#maxIscrollContainer",{
                click:iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });

            // 监听返回按钮被点击
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                goBackClick(); // 关闭当前页面
            });

            // 点击显示扩展功能按钮
            $('.headRight').on('click', '.more', function() {
                that.bottomSheet.html("<div class='add' style='height:.44rem;display:flex;align-items:center;justify-content:center;border-bottom: .01rem solid #EDEDED;font-weight: bold;'>新增分类</div><div class='label' style='height:.44rem;display:flex;align-items:center;justify-content:center;border-bottom:.1rem solid #F9FAF9;font-weight: bold;'>标签维护</div><div class='cancel' style='height:.44rem;display:flex;align-items:center;justify-content:center;color:#666666;font-weight: 400'>取消</div>")
                that.overlay.show();
                locking();
                that.bottomSheet.slideDown("fast");
            });

            // 新增标签
            $('.headRight').on('click', '.add', function() {
                that.editId = ''; // 新增id置空
                that.editName = '';
                showEditType('新增笔记标签');
            })

            // 点击详情跳转
            this.iscrollContent.on('click', 'li', function() {
                if(that.pageType == 0) {
                    var id = $(this).data('id');
                    var name = $(this).data('name');
                    try{
                        Shell.sendEvent("openWin",{"url":"/pigeonholenote/pigeonholeNote.html?id=" + id + "&title=" + name,"open_type":true, "title": ''});
                    }catch(e){}
                }
            })

            // 点击编辑
            this.iscrollContent.on('click', 'li .edit', function(event) {
                event.stopPropagation();
                var rename = pageType == 0 ? "重命名" : "修改名称";
                that.bottomSheet.html("<div class='rename' style='height:.44rem;display:flex;align-items:center;justify-content:center;border-bottom: .01rem solid #EDEDED;font-weight: bold;'>"+ rename +"</div><div class='del' style='height:.44rem;display:flex;align-items:center;justify-content:center;border-bottom:.1rem solid #F9FAF9;font-weight: bold;'>删除</div><div class='cancel' style='height:.44rem;display:flex;align-items:center;justify-content:center;color:#666666;font-weight: 400'>取消</div>")
                that.editId = $(this).data('id');
                that.editName = $(this).data('name');
                locking();
                that.bottomSheet.slideDown("fast");
                setTimeout(function() {
                    that.overlay.show();
                }, 500)
            })

            // 点击遮罩层隐藏
            this.overlay.click(function() {
                $(this).hide();
                lockout();
                that.bottomSheet.slideUp("fast");
            })

            // 点击新增
            this.bottomSheet.on('click', '.add', function() {
                that.editId = ''; // 新增id置空
                that.editName = '';
                that.overlay.hide();
                lockout();
                that.bottomSheet.slideUp("fast");
                showEditType('新增笔记分类');
            })

            // 标签维护
            this.bottomSheet.on('click', '.label', function() {
                that.overlay.hide();
                lockout();
                that.bottomSheet.slideUp("fast");
                try{
                    Shell.sendEvent("openWin",{"url":"/pigeonholelist/pigeonholeList.html?pageType=1","open_type":true, "title":"标签维护"});
                }catch(e){}
            })

            // 点击重命名
            this.bottomSheet.on('click', '.rename', function() {
                var name = pageType == 0 ? "重命名" : "修改标签";
                that.overlay.hide();
                lockout();
                that.bottomSheet.slideUp("fast");
                showEditType(name);
            })

            // 点击删除
            this.bottomSheet.on('click', '.del', function() {
                that.overlay.hide();
                lockout();
                that.bottomSheet.slideUp("fast");
                showEeleteMask();
            })

            // 点击取消
            this.bottomSheet.on('click', '.cancel', function() {
                that.overlay.hide();
                lockout();
                that.bottomSheet.slideUp("fast");
            })

            try {
                // 监听修改成功
                api.addEventListener({"name":"H5UpdateArchiveSuccess"},function(){
                    that.getTypeList();
                });

                // 监听删除归档成功
                api.addEventListener({"name":"H5DeleteArchiveSuccess"},function(){
                    that.getTypeList();
                });
            } catch (error) {
                
            }

            // 点击搜索跳转
           this.getTypeList();
           //调用监听原生抛出来的所有事件
			monitorAllEvent();
		},
        // 获取分类列表
        getTypeList: function() {
            var paramet = {
                "accountCode": global.accountCode || "3845536128749069696",
                "token": global.token || "2b314dd8e2a306c84c1e337e1f0b5d84e1a26b8f"
            };
            var URL = this.pageType == 0 ? '/ctl/cpcapi/category/list' : '/ctl/cpcapi/tag/list'; // 0 分类 1 标签
            http(ServerConfig.djDomain + URL, paramet,{
                success:function(arg){
                    if(arg.retCode == "SUCCESS"){
                        if(arg.data) {
                            noData(arg.data);
                            addTypeList(arg.data);
                            Controller.nameList = arg.data.map(function(e) {
                                return {name: e.tagName || e.categoryName, id: e.id}
                            });
                        } else {
                            noData([]);
                            addTypeList([]);
                        }
                    }else if(arg.retCode == "NO_AUTH"){
                        try{
                            Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                        }catch(e){}
                    }else{
                        try{
                            api && api.toast({msg:arg.message,duration:1500,location:"middle"});
                        }catch(e){}
                    }
                    //通知原生加载完毕
                    setTimeout(function(){
                        Shell.sendPageReady();
                    },100);
                }
            });
        },
        // 修改分类
        editType: function() {
            var paramet = {
                "accountCode": global.accountCode,
                "token": global.token,
                "id": this.editId,
                "categoryName": $('.typeInput').val()
            }, pageType = this.pageType,
            URL = '';
            if(pageType == 0) {
                paramet.categoryName = $('.typeInput').val();
                URL = '/ctl/cpcapi/category/save';
            } else {
                paramet.tagName = $('.typeInput').val();
                URL = '/ctl/cpcapi/tag/save'
            }
            http(ServerConfig.djDomain + URL, paramet,{
                success: function(arg){
                    if(arg.retCode == "SUCCESS"){
                        var toastTiele = Controller.editId ? '修改成功' : '新增成功';
                        toast(toastTiele);
                        Controller.getTypeList();
                        if(pageType == 0) {
                          Shell.sendEvent("H5AddModifyDelete"); // 刷新首页
                        }
                    }else if(arg.retCode == "NO_AUTH"){
                        try{
                            Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                        }catch(e){}
                    }else{
                        try{
                            api.toast({msg:arg.message,duration:1500,location:"middle"});
                        }catch(e){}
                    }
                    Controller.isClick = true;
                }
            });
        },
        deleteType: function() {
            var paramet = {
                "accountCode": global.accountCode,
                "token": global.token,
                "id": this.editId
            }, pageType = this.pageType,
            URL = pageType == 0 ? '/ctl/cpcapi/category/delete' : '/ctl/cpcapi/tag/delete';

            http(ServerConfig.djDomain + URL, paramet,{
                success: function(arg){
                    if(arg.retCode == "SUCCESS"){
                        toast("删除成功");
                        Controller.getTypeList();
                        if(pageType == 0) {
                          Shell.sendEvent("H5AddModifyDelete"); // 刷新首页
                        }
                    }else if(arg.retCode == "NO_AUTH"){
                        try{
                            Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                        }catch(e){}
                    }else{
                        try{
                            api.toast({msg:arg.message,duration:1500,location:"middle"});
                        }catch(e){}
                    }
                    Controller.isClick = true;
                }
            });
        }
    }


    //监听原生抛出来的所有事件
	function monitorAllEvent(){
        //监听原生点击退出登录按钮移除当前页面所有的事件监听
        api.addEventListener({"name":"noticeRemoveAllEvent"},function(){
            removeAllEvent();//调用移除当前页面所有的事件监听方法
        });
    }

    //移除当前页面所有的事件监听方法
	function removeAllEvent(){
		try{
            Shell.sendEvent("H5removeEvent");//给笔详情页面，连接管理页面，本子管理页面发送一个移除事件监听事件
			api.removeEventListener({"name":"H5UpdateArchiveSuccess"});
			api.removeEventListener({"name":"H5DeleteArchiveSuccess"});
            api.removeEventListener({"name":"noticeRemoveAllEvent"});//移除原生点击退出登录按钮移除当前页面所有的事件监听
			
			setTimeout(function(){
				Shell.sendEvent("eventRemoveComplete");//通知原生事件移除完成
			},100);
		}catch(e){}
	}

    // 添加分类/标签数据pt_touxuan
    function addTypeList(typeList) {
        var html = [],
        pageType = Controller.pageType;
        if(pageType == 1) {
            Controller.headContainer.find('span').text('标签维护('+ typeList.length +')');
        }
        for(var i=0; i< typeList.length; i++) {
            var useCount = pageType == 0 ? (typeList[i].useCount || 0) + '个内容' : '';
            var name = pageType == 0 ? typeList[i].categoryName : typeList[i].tagName;
            var editHtml = name === "默认分类" && pageType == 0 ? "":"<div data-name='"+ name +"' data-id='"+ typeList[i].id +"' class='pi-button edit' style='width:.6rem;height:.24rem;color:#333333;font-size:.12rem;background: #F3F3F3;border-radius: 12px;display:flex;align-items: center;justify-content:center;'>编辑</div>"

            html.push("<li data-id='"+ typeList[i].id +"' data-name='"+ name +"' style='display:flex;align-items: center;justify-content: space-between;padding: .16rem .15rem;background: #FFF;border-bottom:.01rem solid #F9FBFD'><div><div style='color:#000000;font-weight: bold;font-size:.15rem'>"+ name +"</div><p style='margin-top:.04rem;color:#666666;font-size:.13rem'>"+ useCount +"</p></div>"+ editHtml +"</li>")
        }
        Controller.iscrollContent.html(html);
        Controller.iscroll.refresh();//刷新高度
    }

    // 显示弹窗
    function showEditType(name) {
        locking();
        var editName = Controller.editName;
        var editId = Controller.editId;
        var nameList = Controller.nameList;
        var inquiryMaskContainer = $("<div style='z-index:1;'></div>").appendTo($("body"));
        inquiryMaskContainer.CommonDeleteMask({"title": name,"determineBtn": "确认", "text":""});
        // 添加input
        inquiryMaskContainer.children('div:nth-child(2)').html("<div class='inputBox' style='background: #F6F7F9;border-radius: .22rem;margin:0 .16rem;box-sizing: border-box;margin-top:.25rem;padding:.12rem .10rem'><input class='typeInput' value='"+editName+"' type='text' maxlength='15' placeholder='请输入文本标题' style='font-size:.14rem; width:100%;line-height:.20rem;background: #F6F7F9;'></div>")

        inquiryMaskContainer.on('click', '.inputBox', function() {
            $(this).find('input').focus();
        })
        inquiryMaskContainer.on('input', 'input', function() {
            noEmoji($(this));
        })
        inquiryMaskContainer.css({
            marginTop: "-1.08rem"
        })

        inquiryMaskContainer.bind("DELETE_MASK_CANCEL",function(){
            lockout();//调用解锁页面方法
            // Controller.isClick = true;//允许点击了
        });
        //监听确定事件
        inquiryMaskContainer.bind("DELETE_MASK_DETERMINE",function(){
            var inputValue = $.trim($('.typeInput').val());
            if(!inputValue) {
                return toast('请输入文本');
            }
            // 编辑
            if(editName) {
                var repetitionName = nameList.find(function(e) { return e.name == inputValue && e.id !== editId });
                if(repetitionName) {
                    return toast('名称不能重名');
                }
            // 新增
            } else {
                if(nameList.find(function(e) { return e.name == inputValue })) {
                    return toast('名称不能重名');
                }
            }
            inquiryMaskContainer.CommonDeleteMask("removeMask");//调用询问组件的隐藏组件方法
            if(editName !== inputValue) {
                Controller.editType();
            }
            lockout();// 调用解锁页面方法
            console.log('执行次数')
        });
    }

    function showEeleteMask() {
        locking();//调用锁定页面方法
        //初始化询问组件
        var inquiryMaskContainer = $("<div style='z-index:1;'></div>").appendTo($("body"));
        inquiryMaskContainer.CommonDeleteMask({"title":"删除提示","text":"确定要删除该分类吗？"});
        //监听取消事件  
        inquiryMaskContainer.bind("DELETE_MASK_CANCEL",function(){
            lockout();//调用解锁页面方法
        });
        //监听确定事件
        inquiryMaskContainer.bind("DELETE_MASK_DETERMINE",function(){
            inquiryMaskContainer.CommonDeleteMask("removeMask");//调用询问组件的隐藏组件方法
            Controller.deleteType();
            lockout();//调用解锁页面方法
        });
    }

    // 锁定页面
    function locking() {
        Controller.headContainer.find(".operationBtnContainer, span").css({"pointer-events":"none","opacity":"0.5"});//锁定头部返回按钮
        $('#maxIscrollContainer, .addBtn').css({"pointer-events":"none","opacity":"0.5"})
        Controller.iscroll.enabled = false;//禁止滚动容器滚动
    }
    // 解锁
    function lockout() {
        Controller.headContainer.find(".operationBtnContainer, span").css({"pointer-events":"","opacity":"1"});
        $('#maxIscrollContainer, .addBtn').css({"pointer-events":"","opacity":"1"})
        Controller.iscroll.enabled = true;//禁止滚动容器滚动
    }
    //判读设备函数（主要解决点击事件失效问题）
    function iScrollClick(){
        if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
        if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
        if (/Silk/i.test(navigator.userAgent)) return false;
        if (/Android/i.test(navigator.userAgent)) {
        var s = navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
            return parseFloat(s[0]+s[3]) < 44 ? false : true
        }
    }


    //当用户点击返回按钮
    function goBackClick(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("closeWin");//关闭当前页面
            }catch(e){}
        }
    }

    //是否添加没有数据样式
    function noData(dataArray){
        if(dataArray.length == 0){
            Controller.iscrollContent.css({
                "background":"url(../djcommon/img/note/img_nodata_all.png)",
                "background-repeat":"no-repeat",
                "background-size":"2.54rem 1.21rem",
                "background-position":"50% 30%",
                "height": "100%"
            }); 
        }else{
            Controller.iscrollContent.css({
                "background":"",
                "background-repeat":"",
                "background-size":"",
                "background-position":""
            }); 
        }
    }

    // 吐司提示
    function toast(text, callBack, time = 1500) {
        Controller.toastContainer.CommonToast("showToast", text);//显示飘窗提示
        setTimeout(function(){
            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
            callBack && callBack();
        }, time);
    }

    // 过滤表情包
    function noEmoji(dom) {
        var html = $(dom).val(),
           oldHtml = "";
        oldHtml = html;
        var reg = /[\uD83C|\uD83D|\uD83E][\uDC00-\uDFFF][\u200D|\uFE0F]|[\uD83C|\uD83D|\uD83E][\uDC00-\uDFFF]|[0-9|*|#]\uFE0F\u20E3|[0-9|#]\u20E3|[\u203C-\u3299]\uFE0F\u200D|[\u203C-\u3299]\uFE0F|[\u2122-\u2B55]|\u303D|[\A9|\AE]\u3030|\uA9|\uAE|\u3030/ig;
        
        if(html.match(reg)) {
           html = html.replace(reg, '');
        }
 
        if(html != oldHtml) {
            $(dom).val(html);
        }
    };

    return Controller;
});
