/*
*   2021年4月14日
*
*
*   开发者：熊世华
*/
define(["jquery","Shell","Fastclick","iscroll", "CommonHead", "CommonDeleteMask"],function($,Shell,Fastclick,iscroll){
    var Controller = {
        iscroll:null,//滚动插件
        headContainer: null,//头部组件
        pageName:"bookmanage",//当前页面的名称主要用于监听原生事件在本页面执行 
        isClick:true,//防止点击事件多次执行 
        init:function(){
            var that = this;
            global = JSON.parse(localStorage.getItem("configData")) || {};//获取配置信息
			//设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});//禁止整个页面滚动

            //初始化头部组件
            this.headContainer = $("<div style='border-bottom: 1px solid #EAEFF2;box-sizing:border-box'></div>").appendTo($("body"));
            //判断是否需要云笔记选项
            this.headContainer.CommonHead({
                "isGoback": true,//是否显示返回按钮
                "title": getUrl("title") || "默认分类",
            });
            console.log(this.headContainer.outerHeight(true), '容器', ($(window).height()))
            
            // 创建滚动容器
            var bottom = phonexh("bottom") == 0 ? 0 : 20;
            var maxIscrollContainer = $("<div id='maxIscrollContainer' style='width:100%;height:"+($(window).height() - this.headContainer.outerHeight(true) - bottom)+"px;overflow:hidden;'></div>").appendTo($("body"));

            this.iscrollContent = $("<ul style='width:100%;box-sizing:border-box;'></ul>").appendTo(maxIscrollContainer);
            
            // 初始化滚动插件
            this.iscroll = new iscroll("#maxIscrollContainer",{
                click:iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });

            // 监听返回按钮被点击
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                goBackClick();//关闭当前页面
            });

            // 点击详情跳转
            this.iscrollContent.on('click', 'li', function() {
                var id = $(this).data('id');
                var categoryId = getUrl("id");
                console.log(id)
                try{
                    Shell.sendEvent("openWin",{"url":"/pigeonholenotedetails/pigeonholeNoteDetails.html?id=" + id +"&categoryId=" + categoryId,"open_type":true, "title": '笔记详情'});
                }catch(e){}
            })

            
            try {
                // 监听修改成功
                api.addEventListener({"name":"H5UpdateArchiveSuccess"},function(){
                    that.getNoteList();
                });
                // 监听删除归档成功
                api.addEventListener({"name":"H5DeleteArchiveSuccess"},function(){
                    that.getNoteList();
                });

            } catch (error) {
                
            }

           this.getNoteList();
            //调用监听原生抛出来的所有事件
			monitorAllEvent();
		},
        // 获取分类笔记列表
        getNoteList: function() {
            var paramet = {
                "accountCode": global.accountCode,
                "token": global.token,
                "categoryIds": getUrl("id") || "7304855974511635337",
                "tagIds": "",
                "archiveTitle": ""
            };
            var URL = '/ctl/cpcapi/archive/get_archive_list'; // 0 分类 1 标签
            http(ServerConfig.djDomain + URL, paramet,{
                success:function(arg){
                    if(arg.retCode == "SUCCESS"){
                        console.log(arg, '请求')
                        if(arg.data) {
                            noData(arg.data);
                            addTypeList(arg.data);
                        } else {
                            addTypeList([]);
                            noData([]);
                        }
                    }else if(arg.retCode == "NO_AUTH"){
                        try{
                            Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                        }catch(e){}
                    }else{
                        try{
                            api && api.toast({msg:arg.message,duration:1500,location:"middle"});
                        }catch(e){}
                    }
                    //通知原生加载完毕
                    setTimeout(function(){
                        //解决移动端点击事件300ms延迟问题
                        Fastclick.attach(document.body);
                        Shell.sendPageReady();  
                    },100);
                }
            });
        }
    }

     //监听原生抛出来的所有事件
	function monitorAllEvent(){
        //监听原生点击退出登录按钮移除当前页面所有的事件监听
        api.addEventListener({"name":"noticeRemoveAllEvent"},function(){
            removeAllEvent();//调用移除当前页面所有的事件监听方法
        });
    }

    //移除当前页面所有的事件监听方法
	function removeAllEvent(){
		try{
            Shell.sendEvent("H5removeEvent");//给笔详情页面，连接管理页面，本子管理页面发送一个移除事件监听事件
			api.removeEventListener({"name":"H5UpdateArchiveSuccess"});
			api.removeEventListener({"name":"H5DeleteArchiveSuccess"});
            api.removeEventListener({"name":"noticeRemoveAllEvent"});//移除原生点击退出登录按钮移除当前页面所有的事件监听
            
			
			setTimeout(function(){
				Shell.sendEvent("eventRemoveComplete");//通知原生事件移除完成
			},100);
		}catch(e){}
	}

    // 添加分类/标签数据
    function addTypeList(typeList) {
        var html = [];
        for(var i=0; i< typeList.length; i++) {
            var tagList = typeList[i].tagList;
            var label = "";
            if(tagList && tagList.length) {
                tagList.forEach(function(e) {
                    var html = "<div style='padding: 0 .08rem;height:.16rem;display:flex;align-items: center;border-radius: .15rem;background: #EFF0F3;margin-right:.08rem'>"+ e.tagName +"</div>";
                    label+= html
                })
            }

            var name = typeList[i].archiveTitle;
            var createTime = typeList[i].createTime.indexOf('-') > -1 ? typeList[i].createTime.replace(/-/g,'/'):typeList[i].createTime;
            var coverImg = typeList[i].thumbUrl ? typeList[i].thumbUrl: "../djcommon/img/common/img_note-mr.png";
            html.push("<li data-id='"+ typeList[i].id +"' style='display:flex;align-items: center;justify-content: space-between;padding: .16rem 0;margin: 0 .15rem;background: #FFF;border-bottom:.01rem solid #F9FBFD'><div style='width:.56rem; height:.73rem;color:#333333;display:flex;margin-right:.06rem'><img style='width:100%;box-shadow: 0px 2px 5px rgba(0, 0, 0, 0.1);' src='"+ coverImg +"'/></div><div style='flex:1'><div style='width:2.8rem;color:#000000;font-weight: bold;font-size:.15rem;overflow: hidden;white-space: nowrap;text-overflow: ellipsis;'>"+ name +"</div><p style='color:#999999;font-size:.12rem;margin-top:.08rem;margin-bottom:.14rem'>"+ createTime +"</p><div style='color:#666666;font-size:.11rem;display:flex;flex-wrap: wrap;height: .16rem;overflow: hidden;'>"+ label +"</div></div></li>")
        }
        Controller.iscrollContent.html(html);
        Controller.iscroll.refresh();//刷新高度
    }

    //判读设备函数（主要解决点击事件失效问题）
    function iScrollClick(){
        if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
        if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
        if (/Silk/i.test(navigator.userAgent)) return false;
        if (/Android/i.test(navigator.userAgent)) {
        var s = navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
            return parseFloat(s[0]+s[3]) < 44 ? false : true
        }
    }


    //当用户点击返回按钮
    function goBackClick(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("closeWin");//关闭当前页面
            }catch(e){}
        }
    }


    //是否添加没有数据样式
    function noData(dataArray){
        if(dataArray.length == 0){
            Controller.iscrollContent.css({
                "background":"url(../djcommon/img/note/img_nodata_all.png)",
                "background-repeat":"no-repeat",
                "background-size":"2.54rem 2rem",
                "background-position":"50% 30%",
                "height": "100%"
            }); 
        }else{
            Controller.iscrollContent.css({
                "background":"",
                "background-repeat":"",
                "background-size":"",
                "background-position":""
            }); 
        }
    }
    return Controller;
});
