/*
*   2021年4月14日
*
*
*   开发者：熊世华
*/
define(["jquery","Shell","Fastclick","iscroll", "CommonHead", "CommonDeleteMask", "CommonToast"],function($,Shell,Fastclick,iscroll){
    var Controller = {
        iscroll:null,//滚动插件
        headContainer: null,//头部组件
        pageName:"bookmanage",//当前页面的名称主要用于监听原生事件在本页面执行 
        isClick:true,//防止点击事件多次执行 
        archiveDetails: null,
        init:function(){
            var that = this;
            global = JSON.parse(localStorage.getItem("configData")) || {};//获取配置信息
            global.skin = "redyingshuo"

			//设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});//禁止整个页面滚动

            //初始化头部组件
            this.headContainer = $("<div style='border-bottom: 1px solid #EAEFF2;box-sizing:border-box'></div>").appendTo($("body"));
            //判断是否需要云笔记选项
            this.headContainer.CommonHead({
                "isGoback": true,//是否显示返回按钮
                "title": "笔记详情",
            });

            //创建飘窗提示元素
            this.toastContainer = $("<div></div>").CommonToast().appendTo($("body"));

            // 添加右侧筛选
            $('.headRight').html("<div style='height:100%;display:flex;flex-direction:row;align-items:center;justify-content:center;'><img style='width:.18rem;height:.18rem;' src='../djcommon/img/common/ic-edit_xq.png'/></div>")
        
            // 创建滚动容器
            var bottom = phonexh("bottom") == 0 ? 0 : 20;
            var maxIscrollContainer = $("<div id='maxIscrollContainer' style='width:100%;height:"+($(window).height() - this.headContainer.outerHeight(true) - bottom)+"px;overflow:hidden;'></div>").appendTo($("body"));

            this.iscrollContent = $("<ul style='width:100%;box-sizing:border-box;padding:.15rem'></ul>").appendTo(maxIscrollContainer);

            // 添加遮罩层
            this.overlay = $("<div style='position: fixed;top: 0;left: 0;z-index: 1;width: 100%;height: 100%;background-color: rgba(0, 0, 0, 0);display:none'></div>").appendTo($("body"));
            // 添加底部弹框
            this.bottomSheet = $("<div style='width:100%;height:1.42rem;background: #fff;position: fixed;bottom:0;border-radius: 15px 15px 0px 0px;overflow: hidden;z-index: 2;font-size:.15rem;color:#313340;display:none;box-shadow: 0px 16px 13px 15px #999;'></div>").appendTo($("body"));
            
            // 初始化滚动插件
            this.iscroll = new iscroll("#maxIscrollContainer",{
                click:iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });

            // 监听返回按钮被点击
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                goBackClick();//关闭当前页面
            });

            // 点击编辑
            $('.headRight').click(function() {
                that.bottomSheet.html("<div class='edit' style='height:.44rem;display:flex;align-items:center;justify-content:center;border-bottom: .01rem solid #EDEDED;font-weight: bold;'>修改笔记信息</div><div class='del' style='height:.44rem;display:flex;align-items:center;justify-content:center;border-bottom:.1rem solid #F9FAF9;font-weight: bold;'>移除笔记</div><div class='cancel' style='height:.44rem;display:flex;align-items:center;justify-content:center;color:#666666;font-weight: 400'>取消</div>")
                that.overlay.show();
                locking();
                that.bottomSheet.slideDown("fast");
            });

            // 点击遮罩层
            this.overlay.click(function() {
                $(this).hide();
                lockout();
                that.bottomSheet.slideUp("fast");
            })

            // 点击修改笔记信息
            this.bottomSheet.on('click', '.edit', function() {
                var id = getUrl("id");
                that.overlay.hide();
                that.bottomSheet.slideUp("fast");
                lockout();
                localStorage.removeItem("archiveTitle");
                localStorage.removeItem("selectLableList");
                localStorage.removeItem("selectTypeList");
                localStorage.setItem('archiveDetails', JSON.stringify(that.archiveDetails));
                Shell.sendEvent("openWin",{"url":"/pigeonholeclear/pigeonholeClear.html?id=" + id,"open_type":true, "title": '归档整理'});
            })
            // 点击移除笔记
            this.bottomSheet.on('click', '.del', function() {
                that.overlay.hide();
                that.bottomSheet.slideUp("fast");
                showEeleteMask();
            })

            // 点击取消
            this.bottomSheet.on('click', '.cancel', function() {
                that.overlay.hide();
                lockout();
                that.bottomSheet.slideUp("fast");
            })

           this.getPigDetails();

            // 监听修改成功
            try {
                api.addEventListener({"name":"H5UpdateArchiveSuccess"},function(){
                    that.getPigDetails();
                });
            } catch (error) {
                
            }
            //调用监听原生抛出来的所有事件
			monitorAllEvent();
		},
        // 获取分类列表
        getPigDetails: function() {
            var paramet = {
                "accountCode": global.accountCode,
                "token": global.token,
                "archiveId": getUrl("id")
            };
            http(ServerConfig.djDomain + '/ctl/cpcapi/archive/get_detail', paramet,{
                success:function(arg){
                    if(arg.retCode == "SUCCESS"){
                        console.log(arg, '请求')
                        if(arg.data) {
                            Controller.archiveDetails = arg.data;
                            if(arg.data.pageList) {
                                noData(arg.data.pageList);
                                createHtml(arg.data.archiveTitle, arg.data.pageList);
                            }
                        } else {
                            noData([]);
                        }
                    }else if(arg.retCode == "NO_AUTH"){
                        try{
                            Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                        }catch(e){}
                    }else{
                        try{
                            api && api.toast({msg:arg.message,duration:1500,location:"middle"});
                        }catch(e){}
                    }
                    //通知原生加载完毕
                    setTimeout(function(){
                        //解决移动端点击事件300ms延迟问题
                        Fastclick.attach(document.body);
                        Shell.sendPageReady();
                    },100);
                }
            });
        },
        // 删除归档信息
        deletePig: function() {
            var paramet = {
                "accountCode": global.accountCode,
                "token": global.token,
                "archiveId": getUrl("id"),
                "categoryId": getUrl("categoryId") || ""
            };
            http(ServerConfig.djDomain + '/ctl/cpcapi/archive/delete_archive_category', paramet,{
                success:function(arg){
                    if(arg.retCode == "SUCCESS"){
                        Shell.sendEvent("H5DeleteArchiveSuccess"); // 修改成功事件
                        toast('移除成功', function() {
                            goBackClick();
                        })
                    }else if(arg.retCode == "NO_AUTH"){
                        try{
                            Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                        }catch(e){}
                    }else{
                        try{
                            api && api.toast({msg:arg.message,duration:1500,location:"middle"});
                        }catch(e){}
                    }
                }
            });
        }
    }

     //监听原生抛出来的所有事件
	function monitorAllEvent(){
        //监听原生点击退出登录按钮移除当前页面所有的事件监听
        api.addEventListener({"name":"noticeRemoveAllEvent"},function(){
            removeAllEvent();//调用移除当前页面所有的事件监听方法
        });
    }

    //移除当前页面所有的事件监听方法
	function removeAllEvent(){
		try{
            Shell.sendEvent("H5removeEvent");//给笔详情页面，连接管理页面，本子管理页面发送一个移除事件监听事件
			api.removeEventListener({"name":"H5UpdateArchiveSuccess"});
            api.removeEventListener({"name":"noticeRemoveAllEvent"});//移除原生点击退出登录按钮移除当前页面所有的事件监听
			
			setTimeout(function(){
				Shell.sendEvent("eventRemoveComplete");//通知原生事件移除完成
			},100);
		}catch(e){}
	}

    function showEeleteMask() {
        //初始化询问组件
        var inquiryMaskContainer = $("<div style='z-index:1;'></div>").appendTo($("body"));
        inquiryMaskContainer.CommonDeleteMask({"title":"移除提示","text":"确定移除该笔记吗？"});
        //监听取消事件  
        inquiryMaskContainer.bind("DELETE_MASK_CANCEL",function(){
            // 取消
            lockout();
        });
        //监听确定事件
        inquiryMaskContainer.bind("DELETE_MASK_DETERMINE",function(){
            inquiryMaskContainer.CommonDeleteMask("removeMask");//调用询问组件的隐藏组件方法
            lockout();
            Controller.deletePig();
        });
    }

    // 添加分类/标签数据pt_touxuan
    function createHtml(title, typeList) {
        var html = ["<li style='font-size:.15rem;font-weight: bold;color:#000000;margin-top:.02rem;margin-bottom:.12rem'>"+ title +"</li>"];
        for(var i=0; i< typeList.length; i++) {
            html.push("<li style='margin-bottom:.2rem;box-shadow: 0px 2px 15px rgba(0, 0, 0, 0.03);'><img style='width:100%;' src='"+ typeList[i].recordUrl +"'/></li>")
        }
        Controller.iscrollContent.html(html);
        
        // 判断图片是否加载完成
        $("li img").each(function() {
            $(this).load(function() {
                Controller.iscroll.refresh();//刷新高度
            })
        })
    }

    //判读设备函数（主要解决点击事件失效问题）
    function iScrollClick(){
        if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
        if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
        if (/Silk/i.test(navigator.userAgent)) return false;
        if (/Android/i.test(navigator.userAgent)) {
        var s = navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
            return parseFloat(s[0]+s[3]) < 44 ? false : true
        }
    }


    //是否添加没有数据样式
    function noData(dataArray){
        if(dataArray.length == 0){
            Controller.iscrollContent.css({
                "background":"url(../djcommon/img/note/img_nodata_all.png)",
                "background-repeat":"no-repeat",
                "background-size":"2.54rem 1.21rem",
                "background-position":"50% 30%",
                "height": "100%"
            }); 
        }else{
            Controller.iscrollContent.css({
                "background":"",
                "background-repeat":"",
                "background-size":"",
                "background-position":""
            }); 
        }
    }

    // 吐司提示
    function toast(text, callBack, time = 1500) {
        Controller.toastContainer.CommonToast("showToast", text);//显示飘窗提示
        setTimeout(function(){
            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
            callBack && callBack();
        }, time);
    }

    //当用户点击返回按钮
    function goBackClick(){
        //判读防止多次执行
        try{
            Shell.sendEvent("closeWin");//关闭当前页面
        }catch(e){}
    }

    // 锁定页面
    function locking() {
        Controller.headContainer.find(".operationBtnContainer, span").css({"pointer-events":"none","opacity":"0.5"});//锁定头部返回按钮
        Controller.iscrollContent.css({"pointer-events":"none","opacity":"0.5"});
        Controller.iscroll.enabled = false;//禁止滚动容器滚动
    }
    // 解锁
    function lockout() {
        Controller.headContainer.find(".operationBtnContainer, span").css({"pointer-events":"","opacity":"1"});
        Controller.iscrollContent.css({"pointer-events":"","opacity":"1"});
        Controller.iscroll.enabled = true;//禁止滚动容器滚动
    }

    return Controller;
});