/*
*   2021年4月14日
*
*
*   开发者：熊世华
*/
define(["jquery","Shell","Fastclick","iscroll", "CommonHead", "CommonDeleteMask"],function($, Shell, Fastclick, iscroll){
    var Controller = {
        iscroll:null,//滚动插件
        headContainer: null,//头部组件
        pageName:"bookmanage",//当前页面的名称主要用于监听原生事件在本页面执行 
        isClick:true,//防止点击事件多次执行
        init:function(){
            global = JSON.parse(localStorage.getItem("configData")) || {};//获取配置信息
            var that = this;
			//设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});//禁止整个页面滚动

            // 添加搜索框
            this.searchInput = $("<div style='display: flex;align-items:center;border-bottom:1px solid #EAEFF2;padding-top:"+ phonexh("top") + "px;box-sizing:border-box'><div class='inputBox' style='flex:1;margin: .07rem .15rem;background: #F5F5F5;border-radius: 16px;height:.32rem;display:flex;align-items:center;color:#C8C8C8;overflow: hidden;'><img style='width:.18rem;height:.18rem;margin-right:.05rem;margin-left:.14rem' src='../djcommon/img/common/ic_search.png'/><form action='/' style='flex:1' οnsubmit='return false;'><input type='search' maxlength='20' placeholder='请输入您的关键字' style='font-size:.14rem; width:100%;background: #F5F5F5;height:.22rem;line-height:.22rem'><input type='text' style='display:none;' /></form></div><div class='cancel' style='margin-right:.14rem;color:#000000;font-size:.15rem;font-weight: bold;'>取消</div></div>").appendTo($("body"));
            // 增加获取焦点灵敏度
            this.searchInput.on('click', '.inputBox', function() {
                $(this).find('input').focus();
            })
            // 创建滚动容器
            var bottom = phonexh("bottom") == 0 ? 0 : 20;
            var maxIscrollContainer = $("<div id='maxIscrollContainer' style='width:100%;height:"+($(window).height() - this.searchInput.outerHeight(true) - bottom)+"px;overflow:hidden;'></div>").appendTo($("body"));

            this.iscrollContent = $("<ul style='width:100%;box-sizing:border-box;'></ul>").appendTo(maxIscrollContainer);
            
            // 初始化滚动插件
            this.iscroll = new iscroll("#maxIscrollContainer",{
                click:iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });

            // 点击取消按钮
            this.searchInput.on('click', '.cancel', function() {
                goBackClick();
            })

            // 点击详情跳转
            this.iscrollContent.on('click', 'li', function() {
                Controller.searchInput.find('input').blur(); // 失去焦点
                var id = $(this).data('id');
                try{
                    Shell.sendEvent("openWin",{"url":"/pigeonholenotedetails/pigeonholeNoteDetails.html?id=" + id,"open_type":true, "title": '分类列表'});
                }catch(e){}
            })

            // 点击搜索
            this.searchInput.bind('keydown', 'form', function(e) {
                if(e.keyCode == 13) {
                    $(this).find('input[type=search]').blur();
                    var value = $.trim($(this).find('input[type=search]').val());
                    if(!value) return;
                    that.getSearchList(value);
                }
            })

            try {
                // 监听删除归档成功
                api.addEventListener({"name":"H5DeleteArchiveSuccess"},function(){
                    var value = $.trim(that.searchInput.find('input[type=search]').val());
                    that.getSearchList(value);
                });
            } catch (error) {}
            
            //解决移动端点击事件300ms延迟问题
			Fastclick.attach(document.body);
            //通知原生加载完毕
            setTimeout(function(){
                Shell.sendPageReady();
            },100);

            //调用监听原生抛出来的所有事件
			monitorAllEvent();
           
		},
        // 获取搜索列表
        getSearchList: function(value) {
            var paramet = {
                "accountCode": global.accountCode,
                "token": global.token,
                "categoryIds": "",
                "tagIds": "",
                "archiveTitle": value
            };
            var URL = '/ctl/cpcapi/archive/get_archive_list'; // 0 分类 1 标签
            http(ServerConfig.djDomain + URL, paramet,{
                success:function(arg){
                    if(arg.retCode == "SUCCESS"){
                        console.log(arg, '请求')
                        if(arg.data) {
                            noData(arg.data);
                            addTypeList(arg.data);
                        } else {
                            addTypeList([]);
                            noData([]);
                        }
                    }else if(arg.retCode == "NO_AUTH"){
                        try{
                            Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                        }catch(e){}
                    }else{
                        console.log('失败了')
                        try{
                            api && api.toast({msg:arg.message,duration:1500,location:"middle"});
                        }catch(e){}
                    }
                    // Controller.isClick = true;
                }
            });
        }
    }

     //监听原生抛出来的所有事件
	function monitorAllEvent(){
        //监听原生点击退出登录按钮移除当前页面所有的事件监听
        api.addEventListener({"name":"noticeRemoveAllEvent"},function(){
            removeAllEvent();//调用移除当前页面所有的事件监听方法
        });
    }

    //移除当前页面所有的事件监听方法
	function removeAllEvent(){
		try{
            Shell.sendEvent("H5removeEvent");//给笔详情页面，连接管理页面，本子管理页面发送一个移除事件监听事件
			api.removeEventListener({"name":"H5DeleteArchiveSuccess"});
            api.removeEventListener({"name":"noticeRemoveAllEvent"});//移除原生点击退出登录按钮移除当前页面所有的事件监听
			
			setTimeout(function(){
				Shell.sendEvent("eventRemoveComplete");//通知原生事件移除完成
			},100);
		}catch(e){}
	}

    // 添加分类/标签数据
    function addTypeList(typeList) {
        var html = [];
        for(var i=0; i< typeList.length; i++) {
            var tagList = typeList[i].tagList;
            var label = "";
            if(tagList && tagList.length) {
                tagList.forEach(function(e) {
                    var html = "<div style='padding: 0 .08rem;height:.16rem;display:flex;align-items: center;border-radius: .15rem;background: #EFF0F3;margin-right:.08rem'>"+ lightKeyword(e.tagName) +"</div>";
                    label+= html
                })
            }

            var name = lightKeyword(typeList[i].archiveTitle);
            var createTime = typeList[i].createTime.indexOf('-') > -1 ? typeList[i].createTime.replace(/-/g,'/'):typeList[i].createTime;
            var coverImg = typeList[i].thumbUrl ? typeList[i].thumbUrl: "../djcommon/img/common/img_note-mr.png";
            html.push("<li data-id='"+ typeList[i].id +"' style='display:flex;align-items: center;justify-content: space-between;padding: .16rem 0;margin: 0 .15rem;background: #FFF;border-bottom:.01rem solid #F9FBFD'><div style='width:.56rem; height:.73rem;color:#333333;display:flex;margin-right:.06rem'><img style='width:100%;box-shadow: 0px 2px 5px rgba(0, 0, 0, 0.1);' src='"+ coverImg +"'/></div><div style='flex:1'><div style='width:2.8rem;color:#000000;font-weight: bold;font-size:.15rem;overflow: hidden;white-space: nowrap;text-overflow: ellipsis;'>"+ name +"</div><p style='color:#999999;font-size:.12rem;margin-top:.08rem;margin-bottom:.14rem'>"+ createTime +"</p><div style='color:#666666;font-size:.11rem;display:flex;flex-wrap: wrap;height: .16rem;overflow: hidden;'>"+ label +"</div></div></li>")
        }
        Controller.iscrollContent.html(html);
        Controller.iscroll.refresh();//刷新高度
    }
    
    // 搜索字体高亮 
    function lightKeyword (text) {
        var searchText = $.trim(Controller.searchInput.find('input[type=search]').val());//获取你输入的关键字；
        var regExp = new RegExp(searchText, "g");//创建正则表达式
        return text.replace(regExp, "<span style='color:#C82128;' >"+searchText+"</span>");
    }

    //判读设备函数（主要解决点击事件失效问题）
    function iScrollClick(){
        if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
        if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
        if (/Silk/i.test(navigator.userAgent)) return false;
        if (/Android/i.test(navigator.userAgent)) {
        var s = navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
            return parseFloat(s[0]+s[3]) < 44 ? false : true
        }
    }


    //当用户点击返回按钮
    function goBackClick(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("closeWin");//关闭当前页面
            }catch(e){}
        }
    }


    //是否添加没有数据样式
    function noData(dataArray){
        if(dataArray.length == 0){
            Controller.iscrollContent.css({
                "background":"url(../djcommon/img/note/img_nodata_all.png)",
                "background-repeat":"no-repeat",
                "background-size":"2.54rem 1.21rem",
                "background-position":"50% 30%",
                "height": "100%"
            }); 
        }else{
            Controller.iscrollContent.css({
                "background":"",
                "background-repeat":"",
                "background-size":"",
                "background-position":""
            }); 
        }
    }
    return Controller;
});
