/*
*   2021年4月15日
*
*   选择页码
*
*   开发者：熊世华
*/
define(["jquery","Shell","Fastclick","CommonToast","CommonHead","CommonIscroll","FootBottom","YsnoteCell"],function($,Shell,Fastclick){
    var Controller = {
        dataList: [], // 返回数据
        selectData:[],//选中数据数组
        bookPageList:[], // 根据党建本ID查询党建本明细记录
        noteId: "", // 本子id
        isClick:true,//防止点击事件多次执行 
        currentPage:'1000',
        //页面加载成功执行的方法
        init:function(){
            $("body").css("opacity",0);
            global = JSON.parse(localStorage.getItem("configData")) || {};//获取配置信息
            global.skin = "redyingshuo"
            //设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            //禁止整个页面滚动
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});
            // 根据党建本ID查询党建本明细记录
            getBookPageList();
            Controller.create();//调用创建页面方法
            //调用监听原生抛出来的所有事件
			// monitorAllEvent();
        },
        //生成页面
        create:function(){
            //初始化飘窗组件
            this.toastContainer = $("<div></div>").CommonToast().appendTo($("body"));
            //初始化头部组件
            this.headContainer = $("<div></div>").appendTo($("body"));
            //判断是否需要云笔记选项
            this.headContainer.CommonHead({
                "isGoback":true,//是否显示返回按钮
                "title":"选择页码",  
            });
            //初始化滚动容器组件
            this.iscrollContainer = $("<div id='changeDowContainer' style='padding:0 0.15rem 0 0.15rem;box-sizing:border-box;overflow:hidden;'></div>").appendTo($("body"));
            //初始化底部foot组件
            this.footContainer = $("<div></div>").appendTo($("body"));
            this.footContainer.FootBottom();
            this.footContainer.find("p").hide();
            //初始化滚动组件
            this.iscrollContainer.css("height",$("body").height() - this.headContainer.outerHeight(true) - this.footContainer.outerHeight(true) + "px");//设置滚动组件的高度
            this.iscrollContainer.CommonIscroll({"isUploadBtn":false,"isRefresh":false,"isLoad":false,"isPaddingBottom":"0.15rem"});

            //监听返回按钮被点击
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                Shell.sendEvent("closeWin");//关闭当前页面
            });
            //监听cell组件勾选事件 
            this.iscrollContainer.bind("YSNETCELL_SELECT",function(event,obj){
                // alert(JSON.stringify(obj))
                //判断当前是取消还是选中
                if(obj.type == "yes"){
                    // alert(obj.type)
                    Controller.selectData.push(obj.data);
                }else{
                    //循环取消选中数据
                    for(var i = 0; i < Controller.selectData.length; i++){
                        if(Controller.selectData[i].pageNo == obj.data.pageNo){
                            Controller.selectData.splice(i,1);
                            break;
                        }
                    }
                } 
                listSelect();//调用cell操作方法
            });
            //监听底部foot点击全选和全不选按钮  
            this.footContainer.bind("ALL_SELECT",function(event,type){
                Controller.iscrollContainer.find("li").YsnoteCell("checkSelect",type);//选中或者不选中cell
                Controller.selectData = [];//清空选中数据
                //判断是全选还是反选
                if(type == "yes"){ 
                    Controller.iscrollContainer.find("li").each(function(){
                        Controller.selectData.push($(this).YsnoteCell("getData"));
                    });
                    Controller.footContainer.FootBottom("setSelectNumm",Controller.iscrollContainer.find("li").length);//设置选中cell数量
                    Controller.headContainer.CommonHead("showDetermine");//调用头部组件显示确定按钮
                }else{
                    Controller.footContainer.FootBottom("setSelectNumm",0);//设置选中cell数量
                    Controller.headContainer.CommonHead("hideDetermine");//调用头部组件隐藏确定按钮
                }
            });
            //监听cell组件被点击 
            this.iscrollContainer.bind("YSNET_CELL_CLICK",function(event,obj){
                var mask = $("<div style='z-index:1;position:absolute;top:0;left:0;width:100%;height:100%;background:rgba(0,0,0,0.5);opacity:0;display:flex;justify-content:center;align-items:center;'></div>").appendTo($("body"));
                var imgContainer = $("<div style='width:100%;display:flex;justify-content:center;align-items:center;'></div>").appendTo(mask);
                $("<img style='max-width:30%;' src='"+obj.recordUrl+"'/>").appendTo(imgContainer);
                //执行动画
                setTimeout(function(){
                    mask.stop().animate({"opacity":1},"fast");
                    imgContainer.find("img").stop().animate({"max-width":"100%"},"fast");
                    mask.bind("click",function(){
                        mask.stop().animate({"opacity":0},"fast");
                        imgContainer.find("img").stop().animate({"max-width":"30%"},"fast",function(){
                            mask.remove();
                        });
                    });
                },20);
            });
            //监听头部组件点击确定按钮
            this.headContainer.bind("DETERMINE_BTN_CLICK",function(){
                if(Controller.isClick) {
                    Controller.isClick = false;
                    setTimeout(function() { Controller.isClick = true }, 1500);
                    var noteId = Controller.noteId;
                    var pageList = Controller.selectData.map(function(e){
                        return e.pageNo;
                    }).join(",");
                    // 清除记录
                    localStorage.removeItem("archiveTitle");
                    localStorage.removeItem("selectLableList");
                    localStorage.removeItem("selectTypeList");
                    try{
                        Shell.sendEvent("openWin",{"url":"/pigeonholeclear/pigeonholeClear.html?noteId=" + noteId + "&pageList="+pageList,"open_type":true, "title": '归档整理'});
                    }catch(e){}
                }
            });
            //解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
            //给原生抛出加载完成事件
            setTimeout(function(){
                Shell.sendPageReady("pigeonholePage");
                $("body").css({"transition":"all 0.3s","opacity":"1"});
                setTimeout(function(){
                    $("body").css({"transition":"","opacity":""});
                },310);
            },100);
            //页面渲染完成开始监听原生抛出的事件
            try{
                //监听原生抛出来的数据H5AddArchiveSuccess
                api.addEventListener({"name":"sendPageSelectData"},function(e){
                    Controller.noteId = e.value.noteId;
                    Controller.dataList = Controller.bookPageList;
                    Controller.currentPage = e.value.currentPage;
                    // getListCell(Controller.bookPageList,Controller.currentPage);//调用生成cell卡片方法
				});
                // 监听归档成功
                api.addEventListener({"name":"H5AddArchiveSuccess"},function(){
                    Controller.selectData = [];//清空选中数据
                    getListCell(Controller.dataList);//调用生成cell卡片方法
                    listSelect();
                });
            }catch(e){
                // throw new Error(e);
                let arr = [
                    {
                        zoom: "https://commonstorge.ys100.com/oss/down/group1/M02/02/83/rBBjM2B-dyyANFdwAABqQlRDtUM032.png",
                        hash: "",
                        normal: "https://commonstorge.ys100.com/oss/down/group1/M02/02/83/rBBjM2B-dyyANFdwAABqQlRDtUM032.png",
                        name: "",
                        page: 46
                    },
                    {
                        zoom: "https://commonstorge.ys100.com/oss/down/group1/M00/02/91/rBBjM2CCJuaAUkakAAaviMKIrMg225.png",
                        hash: "",
                        normal: "https://commonstorge.ys100.com/oss/down/group1/M00/02/91/rBBjM2CCJuaAUkakAAaviMKIrMg225.png",
                        name: "",
                        page: 114
                    }
                ]
                getListCell(arr);//调用生成cell卡片方法
                listSelect();
            }

        }
    }

    //监听原生抛出来的所有事件
	function monitorAllEvent(){
        //监听原生点击退出登录按钮移除当前页面所有的事件监听
        api.addEventListener({"name":"noticeRemoveAllEvent"},function(){
            removeAllEvent();//调用移除当前页面所有的事件监听方法
        });
    }

    //移除当前页面所有的事件监听方法
	function removeAllEvent(){
		try{
            Shell.sendEvent("H5removeEvent");//给笔详情页面，连接管理页面，本子管理页面发送一个移除事件监听事件
			api.removeEventListener({"name":"H5AddArchiveSuccess"});
			api.removeEventListener({"name":"sendPageSelectData"});
            api.removeEventListener({"name":"noticeRemoveAllEvent"});//移除原生点击退出登录按钮移除当前页面所有的事件监听
			
			setTimeout(function(){
				Shell.sendEvent("eventRemoveComplete");//通知原生事件移除完成
			},100);
		}catch(e){}
	}

    //生成cell卡片方法
    // function getListCell(dataArray){
    //     Controller.iscrollContainer.find("ul").css({"min-height":"","display":"flex","flex-direction":"row","flex-wrap":"wrap","justify-content":"space-between"});
    //     var cellArray = [];
    //     for(var i = 0; i < dataArray.length; i++){
    //         var cell = $("<li class='ysnetCell"+i+"' style='width:30.6666667%;height:1.43rem;margin-top:0.15rem;border-radius:1px 0.08rem 0.08rem 0px;box-sizing:border-box;overflow:hidden;box-shadow:rgba(0, 37, 87, 0.2) 1px 0px 4px 0px;'></li>").YsnoteCell({"data":dataArray[i]});
    //         cellArray.push(cell);
    //     }
    //     Controller.iscrollContainer.CommonIscroll("initNode",cellArray);//调用滚动组件初始化数据
    //     Controller.footContainer.FootBottom("allowClick");//允许底部foot点击全选按钮
    //     $(".setDefault").YsnoteCell("defaultClick");//调用cell组件默认选中事件
    // }
    function getListCell(dataArray,page){
        if(page === undefined || page === ""){
            // alert("请原生人员传入currentPage参数（当前是在第几页点击的转换）");
            return;
        }
        Controller.iscrollContainer.find("ul").css({"min-height":"","display":"flex","flex-direction":"row","flex-wrap":"wrap","justify-content":"space-between"});
        var cellArray = [];
        for(var i = 0; i < dataArray.length; i++){
            var cell = $("<li class='ysnetCell"+i+"' style='width:30.6666667%;height:1.43rem;margin-top:0.15rem;border-radius:1px 0.08rem 0.08rem 0px;box-sizing:border-box;overflow:hidden;box-shadow:rgba(0, 37, 87, 0.2) 1px 0px 4px 0px;'></li>").YsnoteCell({"data":dataArray[i]});
            if(Controller.selectData != ''){
                Controller.selectData.forEach(element => {
                    if(parseInt(element.page) == parseInt(dataArray[i].pageNo)){
                        cell.addClass("setDefault");
                    }
                });
                
            }else if(parseInt(dataArray[i].pageNo) == parseInt(page)){
                cell.addClass("setDefault");
            }
            cellArray.push(cell);
        }
        Controller.iscrollContainer.CommonIscroll("initNode",cellArray);//调用滚动组件初始化数据
        Controller.footContainer.FootBottom("allowClick");//允许底部foot点击全选按钮
        $(".setDefault").YsnoteCell("defaultClick");//调用cell组件默认选中事件
    }
    //选中cell操作方法
    function listSelect(){
        if(Controller.selectData.length != 0){
            Controller.headContainer.CommonHead("showDetermine");//调用头部组件显示确定按钮
            if(Controller.selectData.length == Controller.iscrollContainer.find("li").length){
                Controller.footContainer.FootBottom("changeAllSelect","yes");
            }else{
                Controller.footContainer.FootBottom("changeAllSelect","no");
            }
        }else{
            Controller.headContainer.CommonHead("hideDetermine");//调用头部组件隐藏确定按钮
            Controller.footContainer.FootBottom("changeAllSelect","no");
        }
        Controller.footContainer.FootBottom("setSelectNumm",Controller.selectData.length);//设置选中cell数量
    }

    //根据党建本ID查询党建本明细记录
    function getBookPageList(){
        var smartPenData =  JSON.parse(localStorage.getItem("configData"))
        //请求参数
        var paramet = {
            "token":smartPenData.token,
            "accountCode":smartPenData.accountCode,
            "bookId":getUrl("bookId"),
            "noEmptyPageFlag":"1"   // 传给滕老师的参数，解决bug53382，归档时内页空白且有图片不显示
        };
        // 接口判断
        Controller.ajaxTimeoutTest = $.ajax({
            cache:false,
            type:"POST",
            url:ServerConfig.djDomain+"/ctl/cpcapi/book/get_book_page_list",
            timeout:3000,
            data:paramet,
            dataType:"json",
            success:function(arg){
                if(arg.retCode == "SUCCESS"){
                    try{
                        
                        setTimeout(function(){
                            // 插入数据
                        Controller.bookPageList = [...arg.data];
                        getListCell(Controller.bookPageList,Controller.currentPage);//调用生成cell卡片方法
                        },300);
                    }catch(e){}
                    
                   
                }else if(arg.retCode == "NO_AUTH"){
                    try{
                        Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                    }catch(e){}
                }else{

                    try{
                        api.toast({msg:arg.message,duration:1500,location:"middle"});
                    }catch(e){}
                }
            },
            error:function(res){
            },
        });
    }

    return Controller;
});