/*
*   2021年4月13日
*
*
*   开发者：熊世华
*/
define(["jquery","Shell","Fastclick","iscroll", "CommonHead", "CommonDeleteMask", "CommonToast"],function($,Shell,Fastclick,iscroll){
    var Controller = {
        iscroll:null,//滚动插件
        headContainer: null,//头部组件
        pageName:"bookmanage",//当前页面的名称主要用于监听原生事件在本页面执行 
        isClick: true,//防止点击事件多次执行 
        pageType: getUrl('pageType') || 0,
        selectImg: "../djcommon/img/common/pt_touxuan.png",
        activeSelectImg: "../djcommon/img/red/pt_touxuan.png",
        selectTypeList: [], // 已选分类
        selectLableList: [], // 已选标签
        nameList: [],
        init:function(){
            global.skin = "redyingshuo";
			//设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});//禁止整个页面滚动
            this.create(); // 生成页面
            this.bindEvent(); // 绑定事件
            this.getTypeList(); // 获取分类列表
            //解决移动端点击事件300ms延迟问题
			Fastclick.attach(document.body);
		},
        // 生成页面
        create() {
            var pageType = this.pageType;
            global = JSON.parse(localStorage.getItem("configData")) || {};//获取配置信息
            //创建飘窗提示元素
            this.toastContainer = $("<div></div>").CommonToast().appendTo($("body"));

            //初始化头部组件
            this.headContainer = $("<div style='border-bottom: 1px solid #EAEFF2;box-sizing:border-box;'></div>").appendTo($("body"));
            //判断是否需要云笔记选项
            this.headContainer.CommonHead({
                "isGoback": true,//是否显示返回按钮
                "title": pageType == 0 ? "选择分类" : "选择标签",  
            });

            // 添加右侧筛选
            $('.headRight').html("<div style='height:100%;display:flex;flex-direction:row;align-items:center;justify-content:center;'><img style='width:.18rem;height:.18rem;' src='../djcommon/img/common/btn-add.png'/></div>")


            // 创建滚动容器
            var bottom = phonexh("bottom") == 0 ? 0 : 20;
            var maxIscrollContainer = $("<div id='maxIscrollContainer' style='width:100%;height:"+($(window).height() - this.headContainer.outerHeight(true) - bottom)+"px;overflow:hidden;background:#F9FBFD;'></div>").appendTo($("body"));

            this.iscrollContent = $("<ul style='width:100%;box-sizing:border-box;padding-top:.06rem;padding-bottom: .9rem'></ul>").appendTo(maxIscrollContainer);
            
            // 初始化滚动插件
            this.iscroll = new iscroll("#maxIscrollContainer",{
                click:iScrollClick(),//调用判断函数
                tap:true,//开启自定义的点击事件
                bounceTime:300,//配置滑动回弹时间
                probeType:3//开启这个参数就可以每滑动1px获取一次值
            });

            this.confirmBtn = $("<div style='width:100%; padding:.1rem 0 .25rem 0; box-sizing:border-box;position:fixed;left:0;bottom: 0;background:#F9FBFD;display: flex;justify-content: center;'><p style='width:3.1rem;height:.44rem;display: flex;align-items: center;justify-content: center;border-radius: .22rem;background:linear-gradient(270deg, #CF000F 0%, #E30514 100%);font-size:0.16rem;color:#fff;font-weight:500;' class='addBtn'>确认</p></div>").appendTo('body');

        },
        // 初始化绑定事件
        bindEvent() {
            var pageType = this.pageType,
            that = this;

            // 监听返回按钮被点击
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                goBackClick(); // 关闭当前页面
            });
            // 点击显示添加弹窗
            $('.headRight').click(function() {
                showAddType(pageType)
            });

            // 点击确定
            this.confirmBtn.click(function() {
               if(that.selectTypeList.length || that.selectLableList.length) {
                    localStorage.setItem('selectTypeList', JSON.stringify(that.selectTypeList));
                    localStorage.setItem('selectLableList', JSON.stringify(that.selectLableList));
                    Shell.sendEvent("H5PigeonholeSelectSubmit"); // 发送选择事件
                    goBackClick(); // 关闭当前页面
               } else {
                   toast(pageType == 0 ?'请选择分类' : '请选择标签');
               }
            })

            // 点击选择
            this.iscrollContent.on('click', 'li', function() {
                var $img = $(this).find('img');
                var id =  $img.data("id");
                var name =  $img.data("name");
                if(pageType == 0) {
                    if(that.selectTypeList.find(function(e) { return e.id == id })) {
                        that.selectTypeList = that.selectTypeList.filter(function(e) { return e.id !== id });
                         $img.attr('src', that.selectImg);
                    } else {
                        that.selectTypeList.push({"id": id, "name": name});
                         $img.attr('src', that.activeSelectImg);
                    }
                } else {
                    if(that.selectLableList.find(function(e) { return e.id == id })) {
                        that.selectLableList = that.selectLableList.filter(function(e) { return e.id !== id });
                         $img.attr('src', that.selectImg);
                    } else {
                        that.selectLableList.push({"id": id, "name": name});
                         $img.attr('src', that.activeSelectImg);
                    }
                }
            })
        },
        // 获取分类列表
        getTypeList: function() {
            var paramet = {
                "accountCode": global.accountCode,
                "token": global.token
            };
            var URL = this.pageType == 0 ? '/ctl/cpcapi/category/list' : '/ctl/cpcapi/tag/list'; // 0 分类 1 标签
            http(ServerConfig.djDomain + URL, paramet,{
                success:function(arg){
                    if(arg.retCode == "SUCCESS"){
                        if(arg.data) {
                            noData(arg.data);
                            addTypeList(arg.data);
                            Controller.nameList = arg.data.map(function(e) {
                                return {name: e.tagName || e.categoryName, id: e.id}
                            });
                        } else {
                            noData([]);
                        }
                    }else if(arg.retCode == "NO_AUTH"){
                        try{
                            Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                        }catch(e){}
                    }else{
                        try{
                            api && api.toast({msg:arg.message,duration:1500,location:"middle"});
                        }catch(e){}
                    }
                    Shell.sendPageReady();
                }
            });
        },
        // 添加分类
        addType: function() {
            var paramet = {
                "accountCode": global.accountCode,
                "token": global.token,
                "id": "",
                "categoryName": $('.typeInput').val()
            }, pageType = this.pageType,
            URL = '';
            if(pageType == 0) {
                paramet.categoryName = $('.typeInput').val();
                URL = '/ctl/cpcapi/category/save';
            } else {
                paramet.tagName = $('.typeInput').val();
                URL = '/ctl/cpcapi/tag/save'
            }
            http(ServerConfig.djDomain + URL, paramet,{
                success: function(arg){
                    if(arg.retCode == "SUCCESS"){
                        var data = arg.data;
                        if(data) {
                            var useCount = pageType == 0 ? '0个内容' : '';
                            var name = data.categoryName || data.tagName;
                            Controller.iscrollContent.append("<li style='display:flex;align-items: center;justify-content: space-between;padding: .16rem .15rem;background: #FFF;border-bottom:.01rem solid #F9FBFD'><div><div style='color:#000000;font-weight: bold;font-size:.15rem'>"+ name +"</div><p style='margin-top:.04rem;color:#666666;font-size:.13rem'>"+ useCount +"</p></div><img data-name='"+ name +"' data-id='"+ data.id+"' style='width:.18rem;height:.18rem;padding:.1rem' src='../djcommon/img/common/pt_touxuan.png'/></li>");
                            noData([data])
                            Controller.iscroll.refresh();//刷新高度
                            toast("新增成功");
                            if(pageType == 0) {
                              Shell.sendEvent("H5AddModifyDelete"); // 刷新首页
                            }
                        }
                        // getTypeList();
                    }else if(arg.retCode == "NO_AUTH"){
                        try{
                            Shell.sendEvent("backLogin",{"reason":"您的账号在其他地方登录"});
                        }catch(e){}
                    }else{
                        try{
                            api.toast({msg:arg.message,duration:1500,location:"middle"});
                        }catch(e){}
                    }
                    Controller.isClick = true;
                }
            });
        },
        // 获取选择的数据
        getSelectData() {
            var selectTypeList = JSON.parse(localStorage.getItem('selectTypeList')),
            selectLableList = JSON.parse(localStorage.getItem('selectLableList')),
            imgs = this.iscrollContent.find('img'),
            that = this;
            if(selectTypeList && selectTypeList.length) {
                this.selectTypeList = selectTypeList;
                imgs.each(function() {
                    var id = $(this).data("id");
                    if(selectTypeList.find(function(e) { return e.id == id })) {
                        $(this).attr('src', that.activeSelectImg);
                    }
                })
            }
            
            if (selectLableList && selectLableList.length) {
                this.selectLableList = selectLableList;
                imgs.each(function() {
                    var id = $(this).data("id");
                    if(selectLableList.find(function(e) { return e.id == id })) {
                        $(this).attr('src', that.activeSelectImg);
                    }
                })
            }
        }
    }

    // 添加分类/标签数据pt_touxuan
    function addTypeList(typeList) {
        var html = [],
        pageType = Controller.pageType;
        for(var i=0; i< typeList.length; i++) {
            var useCount = pageType == 0 ? (typeList[i].useCount || 0) + '个内容' : '';
            var name = pageType == 0 ? typeList[i].categoryName : typeList[i].tagName;
            html.push("<li style='display:flex;align-items: center;justify-content: space-between;padding: .16rem .15rem;background: #FFF;border-bottom:.01rem solid #F9FBFD'><div><div style='color:#000000;font-weight: bold;font-size:.15rem'>"+ name +"</div><p style='margin-top:.04rem;color:#666666;font-size:.13rem'>"+ useCount +"</p></div><img data-name='"+ name +"' data-id='"+ typeList[i].id+"' style='width:.18rem;height:.18rem;padding:.1rem;' src='../djcommon/img/common/pt_touxuan.png'/></li>")
        }
        Controller.iscrollContent.html(html);
        Controller.getSelectData(); // 获取缓存数据
        Controller.iscroll.refresh();//刷新高度
    }

    // 显示弹窗
    function showAddType(type) {
        locking();
        var nameList = Controller.nameList;
        var name = type == 0 ? "新增笔记分类" : "新增笔记标签";
        var inquiryMaskContainer = $("<div style='z-index:1;'></div>").appendTo($("body"));
        inquiryMaskContainer.CommonDeleteMask({"title": name,"determineBtn": "确认", "text":""});
        // 添加input
        inquiryMaskContainer.children('div:nth-child(2)').html("<div class='inputBox' style='background: #F6F7F9;border-radius: .22rem;margin:0 .16rem;box-sizing: border-box;margin-top:.25rem;padding:.12rem .10rem'><input class='typeInput' type='text' maxlength='15' placeholder='请输入文本标题' style='font-size:.14rem; width:100%;line-height:.20rem;background: #F6F7F9;'></div>")

        inquiryMaskContainer.on('click', '.inputBox', function() {
            $(this).find('input').focus();
        })

        inquiryMaskContainer.on('input', 'input', function() {
            noEmoji($(this));
        })

        inquiryMaskContainer.css({
            marginTop: "-1.08rem"
        })

        inquiryMaskContainer.bind("DELETE_MASK_CANCEL",function(){
            lockout();//调用解锁页面方法
            // Controller.isClick = true;//允许点击了
        });
        //监听确定事件
        inquiryMaskContainer.bind("DELETE_MASK_DETERMINE",function(){
            var inputValue = $.trim($('.typeInput').val());
            if(!inputValue) {
                toast('请输入文本');
                return;
            }
            if(nameList.find(function(e) { return e.name == inputValue })) {
                return toast('名称不能重名');
            }
            inquiryMaskContainer.CommonDeleteMask("removeMask");//调用询问组件的隐藏组件方法
            Controller.addType();
            lockout();// 调用解锁页面方法
        });
    }

    // 锁定页面
    function locking() {
        Controller.headContainer.find(".operationBtnContainer, span").css({"pointer-events":"none","opacity":"0.5"});//锁定头部返回按钮
        $('#maxIscrollContainer, .addBtn').css({"pointer-events":"none","opacity":"0.5"})
        Controller.iscroll.enabled = false;//禁止滚动容器滚动
    }
    // 解锁
    function lockout() {
        Controller.headContainer.find(".operationBtnContainer, span").css({"pointer-events":"","opacity":"1"});
        $('#maxIscrollContainer, .addBtn').css({"pointer-events":"","opacity":"1"})
        Controller.iscroll.enabled = true;//禁止滚动容器滚动
    }
    //判读设备函数（主要解决点击事件失效问题）
    function iScrollClick(){
        if (/iPhone|iPad|iPod|Macintosh/i.test(navigator.userAgent)) return false;
        if (/Chrome/i.test(navigator.userAgent)) return (/Android/i.test(navigator.userAgent));
        if (/Silk/i.test(navigator.userAgent)) return false;
        if (/Android/i.test(navigator.userAgent)) {
        var s = navigator.userAgent.substr(navigator.userAgent.indexOf('Android')+8,3);
            return parseFloat(s[0]+s[3]) < 44 ? false : true
        }
    }


    //当用户点击返回按钮
    function goBackClick(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("closeWin");//关闭当前页面
            }catch(e){}
        }
    }
    //当用户点击帮助按钮
    function helpClick(){
        //判读防止多次执行
        if(Controller.isClick){
            Controller.isClick = false;
            try{
                Shell.sendEvent("openWin",{"url":"/notebookhelp/noteBookHelp.html","open_type":true,"title":"帮助"});
            }catch(e){}
            setTimeout(function(){
                Controller.isClick = true;
            },500);
        }
    }


    //是否添加没有数据样式
    function noData(dataArray){
        if(dataArray.length == 0){
            Controller.iscrollContent.css({
                "background":"url(../djcommon/img/note/img_nodata_all.png)",
                "background-repeat":"no-repeat",
                "background-size":"2.54rem 1.21rem",
                "background-position":"50% 30%",
                "height": "100%"
            }); 
        }else{
            Controller.iscrollContent.css({
                "background":"",
                "background-repeat":"",
                "background-size":"",
                "background-position":""
            }); 
        }
    }

    function toast(text, callBack, time = 1500) {
        Controller.toastContainer.CommonToast("showToast", text);//显示飘窗提示
        setTimeout(function(){
            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
            callBack && callBack();
        }, time);
    }

    // 过滤表情包
    function noEmoji(dom) {
        var html = $(dom).val(),
           oldHtml = "";
        oldHtml = html;
        var reg = /[\uD83C|\uD83D|\uD83E][\uDC00-\uDFFF][\u200D|\uFE0F]|[\uD83C|\uD83D|\uD83E][\uDC00-\uDFFF]|[0-9|*|#]\uFE0F\u20E3|[0-9|#]\u20E3|[\u203C-\u3299]\uFE0F\u200D|[\u203C-\u3299]\uFE0F|[\u2122-\u2B55]|\u303D|[\A9|\AE]\u3030|\uA9|\uAE|\u3030/ig;
        
        if(html.match(reg)) {
           html = html.replace(reg, '');
        }
 
        if(html != oldHtml) {
            $(dom).val(html);
        }
    };
    return Controller;
});
