/*
*   2020年12月5日
*
*   回收站js控制器
*
*   开发者：付长建
*/
define(["jquery","Shell","Fastclick","CommonToast","CommonDeleteMask","CommonHead","CommonIscroll","CommonBottonMenu","CommonCell"],function($,Shell,Fastclick){
    var Controller = {
        maxContainer:null,//页面最大容器
        toastContainer:null,//飘窗组件
        headContainer:null,//头部组件
        iscrollContainer:null,//滚动容器组件
        showLoadAndError:null,//数据请求超时定时器
        offset:0,//数据请求偏移量
        selectSize:2,//控制新生成的节点勾选图标大小参数2是小1是大
        selectData:[],//选中数据数组
        //页面加载成功执行的方法
        init:function(){
            $("body").css("opacity",0);
            //设置当前页面所有的高宽字体大小缩放比例的初始值（这里默认除100好算一些）
            $("html").css("font-size",$(window).width() / (375 / 100) + "px");
            //禁止整个页面滚动
            document.body.addEventListener("touchmove",bodyScroll,{passive:false});
            //获取配置信息
            // 替换云空间配置接口 0715
            http(ServerConfig.cloudDomain+"/Setting/getGlobal",{"token":getUrl("cloudToken")},{
                success:function(arg){
                    if(parseInt(arg.code) == 1){
                        global.userInfo = arg.data.userInfo;//得到用户信息
                        global.preview_config = arg.data.preview_config;//得到文件预览配置
                        global.is_thumb_model = arg.data.is_thumb_model;//得到是否显示搜索图
                        global.thumb_width_height_config = arg.data.thumb_width_height_config;//得到缩略图配置
                        global.skin = arg.data.skin_name;//得到皮肤配置
                        global.is_yingshuo = arg.data.is_yingshuo;//得到是否显示云笔记筛选选项
                        global.version = arg.data.version;//得到当前是哪个版本
                        Controller.create();//调用创建页面方法
                    }else{
                        //判断是否是退出登录了
                        if(arg.msg == "Please login first"){
                            Shell.sendEvent('backLogin');//通知原生退出登录
                        }else{
                            try{
                                api.toast({msg:arg.msg,duration:2000,location:"middle"});
                            }catch(e){}
                        }
                    }
                }
            });
            //监听ajax请求错误
            $(window).bind("HTTP_REQUEST_ERROR",function(event,msg){
                try{
                    api.toast({msg:msg,duration:2000,location:"middle"});
                }catch(e){}
            });
        },
        //生成页面
        create:function(){
            //初始化飘窗组件
            this.toastContainer =$("<div></div>").CommonToast().appendTo($("body"));
            //创建页面最大容器元素
            this.maxContainer = $("<div style='width:100%;height:100%;background:#fff;overflow:hidden;'></div>").appendTo($("body"));
            //创建页面头部
            this.headContainer = $("<div></div>").appendTo(this.maxContainer);
            this.headContainer.CommonHead({
                "title":"回收站",
                "isGoback":true
            });
            //创建提示
            var tipsContainer = $("<p style='width:100%;height:0.4rem;line-height:0.4rem;font-size:0.12rem;color:#999;padding-left:0.15rem;box-sizing:border-box;background:rgba(0,37,87,0.05);'>回收站文件保存15天，到期后自动清空</p>").appendTo(this.maxContainer);
            //创建滚动容器
            var safeHeight = phonexh("bottom") == 0 ? 0 : 0;
            this.iscrollContainer = $("<div id='recycle' style='width:100%;overflow:hidden;background:#fff;'></div>").appendTo(this.maxContainer);
            this.iscrollContainer.css("height",this.maxContainer.height() - this.headContainer.outerHeight(true) - tipsContainer.height() - safeHeight + "px");
            this.iscrollContainer.CommonIscroll({"isUploadBtn":false});
            //初始化底部操作菜单
            this.bottonMenuContainer = $("<div isShow='no' style='width:100%;'></div>").appendTo(this.maxContainer);
            this.bottonMenuContainer.CommonBottonMenu({
                "btnMenu":[
                    {"text":"彻底删除","type":"delete","icon":skinConfig(global.skin).commonIcon + "shanchu.png"},
                    {"text":"还原文件","type":"reduction","icon":skinConfig(global.skin).commonIcon + "huanyuan.png"},
                ]
            });
            this.bottonMenuContainer.CommonBottonMenu("gradually","no");
            //监听头部组件点击返回
            this.headContainer.bind("GOBACK_BTN_CLICK",function(){
                Shell.sendEvent("closeWin");//关闭当前页面
            });
            //监听头部组件全选事件
            this.headContainer.bind("ALL_SELECT_BTN_CLICK",function(){
                Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//允许菜单操作
                Controller.iscrollContainer.find("li").CommonCell("allSelect");//调用列表组件选中方法
                Controller.headContainer.CommonHead("showAllNoSelectBtn");//调用头部组件显示全不选按钮
                Controller.selectData = [];//清空选中数据
                //循环得到全选的所有数据
                Controller.iscrollContainer.find("li").each(function(){
                    Controller.selectData.push($(this).CommonCell("getData"));
                });
            });
            //监听头部组件全不选事件
            this.headContainer.bind("ALL_NO_SELECT_BTN_CLICK",function(){
                Controller.selectData = [];//清空选中数据
                Controller.headContainer.CommonHead("showAllSelectBtn");//调用头部组件显示全选按钮
                Controller.iscrollContainer.find("li").CommonCell("cancelSelect");//调用列表组件取消选中方法
                Controller.bottonMenuContainer.CommonBottonMenu("lock","yes");//禁止菜单操作
            });
            //监听头部组件取消事件
            this.headContainer.bind("CANCE_BTN_CLICK",function(){
                Controller.selectSize = 2;//列表勾选框默认设置为小的
                Controller.selectData = [];//清空选中数据
                Controller.iscrollContainer.find("li").CommonCell("changeSelectSize",2);//调用列表组件改变勾选图标大小方法
                Controller.iscrollContainer.find("li").CommonCell("cancelSelect");//调用列表组件取消选中方法
                Controller.headContainer.CommonHead("showGobackBtn");//调用头部组件显示返回按钮
                Controller.headContainer.CommonHead("hideCancelBtn");//调用头部组件隐藏取消按钮
                Controller.iscrollContainer.find("li").CommonCell("lock","no");//解锁列表图标和文件信息禁止点击
                Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//允许菜单操作
                showAndHideBottomMenu("hide");//隐藏列表选中底部操作菜单
            });
            //监听列表勾选按钮被点击
            this.iscrollContainer.bind("CELL_SELECT",function(event,obj){
                //判断当前是取消还是选中
                if(obj.type == "yes"){
                    Controller.selectData.push(obj.data);
                }else{
                    //循环取消选中数据
                    for(var i = 0; i < Controller.selectData.length; i++){
                        if(Controller.selectData[i].uuid == obj.data.uuid){
                            Controller.selectData.splice(i,1);
                            break;
                        }
                    }
                }
                listSelect();//调用列表选中操作方法
            });
            //监听列表点击事件
            this.iscrollContainer.bind("CELL_CLICK",function(event,arg){
                Controller.headContainer.CommonHead("lock","yes");//锁定头部组件
                Controller.iscrollContainer.CommonIscroll("isIscroll","yes");//锁定滚动容器
                Controller.iscrollContainer.find("li").CommonCell("lockList","yes");//锁定所有列表
                //初始化询问组件
                var deleteMaskContainer = $("<div style='z-index:1;'></div>").appendTo($("body"));
                deleteMaskContainer.CommonDeleteMask({
                    "title":"还原提示！",
                    "text":"回收站内无法打开文件（夹），是否还原文件",
                    "determineBtn":"还原"
                });
                //监听取消事件
                deleteMaskContainer.bind("DELETE_MASK_CANCEL",function(){
                    Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                    Controller.iscrollContainer.CommonIscroll("isIscroll","no");//解锁滚动容器
                    Controller.iscrollContainer.find("li").CommonCell("lockList","no");//解锁所有列表
                });
                //监听确定事件
                deleteMaskContainer.bind("DELETE_MASK_DETERMINE",function(){
                    deleteMaskContainer.CommonDeleteMask("removeMask");//调用询问组件删除方法
                    Controller.selectData = [];
                    Controller.selectData.push(arg);
                    reductionFile(0,2);//调用还原文件方法
                });
            });
            //监听滚动容器下拉刷新
            this.iscrollContainer.bind("ISCROLL_REFRESH",function(){
                Controller.iscrollContainer.find("li").CommonCell("lockList","yes");//锁定所有列表禁止点击
                Controller.bottonMenuContainer.CommonBottonMenu("lock","yes");//锁定底部操作菜单
                Controller.headContainer.CommonHead("lock","yes");//锁定头部组件
                Controller.offset = 0;//从第0条数据开始获取
                Controller.selectSize = 2;//重置列表勾选图标大小
                Controller.selectData = [];//清空选中数据
                getListData(2);//调用获取列表数据方法
            });
            //监听滚动容器上拉加载更多
            this.iscrollContainer.bind("ISCROLL_LOAD_MORE",function(){
                //判断当前列表选中底部菜单是否显示
                if(Controller.bottonMenuContainer.attr("isShow") == "yes"){
                    Controller.selectSize = 1;
                    Controller.bottonMenuContainer.CommonBottonMenu("lock","yes");//锁定底部操作菜单
                }
                Controller.iscrollContainer.find("li").CommonCell("lockList","yes");//锁定所有列表禁止点击
                Controller.headContainer.CommonHead("lock","yes");//锁定头部组件
                Controller.offset = Controller.offset + 100;//重置请求数据位置
                getListData(3);//调用获取列表数据方法
            });
            //监听底部操作菜单按钮被点击
            this.bottonMenuContainer.bind("OPERATION_BTN_CLICK",function(event,type){
                //判断当前点击的是那个按钮
                if(type == "delete"){
                    Controller.bottonMenuContainer.CommonBottonMenu("lock","yes");//锁定底部操作菜单
                    Controller.headContainer.CommonHead("lock","yes");//锁定头部组件
                    Controller.iscrollContainer.CommonIscroll("isIscroll","yes");//锁定滚动容器
                    Controller.iscrollContainer.find("li").CommonCell("lockList","yes");//锁定所有列表
                    deleteFile();//调用删除方法
                }else{
                    Controller.bottonMenuContainer.CommonBottonMenu("lock","yes");//锁定底部操作菜单
                    Controller.headContainer.CommonHead("lock","yes");//锁定头部组件
                    Controller.iscrollContainer.CommonIscroll("isIscroll","yes");//锁定滚动容器
                    Controller.iscrollContainer.find("li").CommonCell("lockList","yes");//锁定所有列表
                    reductionFile(0,1);//调用还原文件方法
                }
            });
            //解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
            //通知原生加载完毕
            Shell.sendPageReady();
            $("body").fadeTo("slow",1);
            //调用获取列表数据方法
            getListData(1);
        }
    }
    //显示隐藏底部操作菜单
    function showAndHideBottomMenu(type){
        var height = Controller.bottonMenuContainer.outerHeight(true);//得到需要减去的高度
        if(type == "show"){
            Controller.bottonMenuContainer.CommonBottonMenu("gradually","yes");
            Controller.bottonMenuContainer.attr("isShow","yes");//改变底部操作菜单属性表示菜单已经显示
            Controller.iscrollContainer.CommonIscroll("changeIscrollContainerMinHeight",Controller.iscrollContainer.height() - height);//调用改变滚动容器高度方法
        }else{
            Controller.bottonMenuContainer.CommonBottonMenu("gradually","no");
            Controller.bottonMenuContainer.attr("isShow","no");//改变底部操作菜单属性表示菜单已经隐藏
            Controller.iscrollContainer.CommonIscroll("changeIscrollContainerMinHeight",Controller.iscrollContainer.height() + height);//调用改变滚动容器高度方法
        }
    }
    //获取数据列表方法
    function getListData(type){
        //判断如果是初始化到2秒都还没有请求出数据就显示加载提示
        if(type == 1){
            Controller.showLoadAndError = setTimeout(function(){
                Controller.iscrollContainer.CommonIscroll("showLoadMask");//显示加载层
            },2000);
        }
        //请求参数
        // 替换云空间接口
        // var paramet = {"token":getUrl("token"),"pid":0,"offset":Controller.offset,"sort":"createtime","order":"desc"};
        var paramet = {"token":getUrl("cloudToken"),"pid":0,"offset":Controller.offset,"sort":"createtime","order":"desc"};
        http(ServerConfig.cloudDomain+"/recycle/getRecycleList",paramet,{
            success:function(arg){
                clearTimeout(Controller.showLoadAndError);//清除延时
                if(parseInt(arg.code) == 1){
                    generateList(type,arg.data.rows);//调用生成列表方法
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent('backLogin');//通知原生退出登录
                    }else{
                        //判断是初始化错误还是下拉刷新错误还是上拉加载更多错误
                        if(type == 1){//初始化错误
                            setTimeout(function(){
                                Controller.iscrollContainer.CommonIscroll("showErrorMask",arg.msg);//显示错误提示层
                            },500);
                        }else if(type == 2){//下拉刷新错误
                            setTimeout(function(){
                                Controller.iscrollContainer.CommonIscroll("refreshSuccessAndFail",arg.msg);//调用下拉刷新错误
                            },500);
                        }else if(type == 3){
                            setTimeout(function(){
                                Controller.iscrollContainer.CommonIscroll("loadMoreSuccessAndFail",arg.msg);//调用加载错误
                            },500);
                        }
                    }
                }
            }
        });
    }
    //生成列表方法
    function generateList(type,dataArray){
        var cellArray = [];
        for(var i = 0; i < dataArray.length; i++){
            var cell = $("<li text='"+dataArray[i].restore_day+"' style='width:100%;padding-left:0.15rem;box-sizing:border-box;'></li>").CommonCell({
                "commonIconUrl":skinConfig(global.skin).commonIcon,
                "shllIconUrl":skinConfig(global.skin).shllWebIon,
                "data":dataArray[i],
                "selectSize":Controller.selectSize,
            });
            cellArray.push(cell);
        }
        //判断当前是初始化列表，还是下拉刷新，还是上拉加载更多
        if(type == 1){
            //判断有无数据
            if(cellArray != 0){
                Controller.iscrollContainer.CommonIscroll("initNode",cellArray);//调用滚动组件初始化数据
            }else{
                Controller.iscrollContainer.CommonIscroll("showListNoDataMask");//显示没有数据提示层
            }
        }else if(type == 2){
            setTimeout(function(){
                Controller.iscrollContainer.CommonIscroll("refreshSuccessAndFail");//刷新成功方法
            },500);
            //监听下拉刷新完成事件
            Controller.iscrollContainer.unbind("REFRESH_COMPLETE").bind("REFRESH_COMPLETE",function(){
                //判断列表选中底部菜单是否显示
                if(Controller.bottonMenuContainer.attr("isShow") == "yes"){
                    showAndHideBottomMenu("hide");//隐藏列表选中底部操作菜单
                    Controller.headContainer.CommonHead("showGobackBtn");//调用头部组件显示返回按钮
                    Controller.headContainer.CommonHead("hideCancelBtn");//调用头部组件隐藏取消按钮
                }
                //判断有无数据
                if(cellArray.length != 0){
                    Controller.iscrollContainer.CommonIscroll("refreshNode",cellArray);//调用滚动组件添加下拉刷新数据
                }else{
                    Controller.iscrollContainer.CommonIscroll("emptyNode");//清空节点
                    Controller.iscrollContainer.CommonIscroll("showListNoDataMask");//显示没有数据提示层
                }
                Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单
                Controller.headContainer.CommonHead("lock","no");//解锁头部组件
            });
        }else if(type == 3){
            setTimeout(function(){
                Controller.iscrollContainer.CommonIscroll("loadMoreSuccessAndFail");//加载成功方法
            },500);
            //监听上拉加载更多完成事件
            Controller.iscrollContainer.unbind("LOAD_COMPLETE").bind("LOAD_COMPLETE",function(){
                Controller.iscrollContainer.CommonIscroll("addNode",cellArray);//调用滚动组件添加上拉的数据
                Controller.iscrollContainer.find("li").CommonCell("lockList","no");//解锁所有列表允许点击
                Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                //判断列表选中底部菜单是否显示
                if(Controller.bottonMenuContainer.attr("isShow") == "yes" && cellArray.length != 0){
                    Controller.headContainer.CommonHead("showAllSelectBtn");//调用头部组件显示全选按钮
                    Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单
                    Controller.iscrollContainer.find("li").CommonCell("lock","yes");//锁定所有列表的文件图标和文件信息禁止点击
                }
            });
        }
    }
    //列表选中操作方法
    function listSelect(){
        //判断选中的数据条数
        if(Controller.selectData.length != 0){
            //判断是否选中多条数据
            if(Controller.selectData.length == 1){
                Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单
                //判断是否显示了底部操作菜单
                if(Controller.bottonMenuContainer.attr("isShow") == "no"){
                    showAndHideBottomMenu("show");//显示底部操作菜单
                    Controller.headContainer.CommonHead("showCancelBtn");//调用头部组件显示取消按钮
                    Controller.iscrollContainer.find("li").CommonCell("changeSelectSize",1);//调用列表组件改变勾选图标大小方法
                    Controller.iscrollContainer.find("li").CommonCell("lock","yes");//锁定列表图标和文件信息禁止点击
                }
            }
            //判断当前列表是否全部被选中
            if(Controller.selectData.length == Controller.iscrollContainer.find("li").length){
                Controller.headContainer.CommonHead("showAllNoSelectBtn");//调用头部组件显示全不选按钮
            }else{
                Controller.headContainer.CommonHead("showAllSelectBtn");//调用头部组件显示全选按钮
            }
        }else{
            showAndHideBottomMenu("no");//隐藏底部操作菜单
            Controller.headContainer.CommonHead("showGobackBtn");//调用头部组件显示返回按钮
            Controller.headContainer.CommonHead("hideCancelBtn");//调用头部组件隐藏取消按钮
            Controller.iscrollContainer.find("li").CommonCell("changeSelectSize",2);//调用列表组件改变勾选图标大小方法
            Controller.iscrollContainer.find("li").CommonCell("lock","no");//解锁列表图标和文件信息禁止点击
        }
    }
    //彻底删除方法
    function deleteFile(){
        var ids = [];//要删除得文件id
        for(var i = 0; i < Controller.selectData.length; i++){
            ids.push( Controller.selectData[i].uuid);
        }
        //请求参数
        // 替换云空间接口
        // var paramet = {"token":getUrl("token"),"uuid":ids.join(",")};
        var paramet = {"token":getUrl("cloudToken"),"uuid":ids.join(",")};
        http(ServerConfig.cloudDomain+"/recycle/deleteFile",paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    Controller.toastContainer.CommonToast("showToast","删除成功");//改变提示文字
                    Controller.headContainer.trigger("CANCE_BTN_CLICK");//抛出取消事件
                    //飘窗提示后2s后删除飘窗
                    setTimeout(function(){
                        Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                        Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单
                        Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                        Controller.iscrollContainer.CommonIscroll("isIscroll","no");//解锁滚动容器
                        Controller.iscrollContainer.find("li").CommonCell("lockList","no");//解锁所有列表
                        Controller.offset = 0;//重置数据偏移量
                        getListData(1);
                    },1500);
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent("backLogin");//通知原生退出登录
                    }else{
                        Controller.toastContainer.CommonToast("showToast",arg.msg);//改变提示文字
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单
                            Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                            Controller.iscrollContainer.CommonIscroll("isIscroll","no");//解锁滚动容器
                            Controller.iscrollContainer.find("li").CommonCell("lockList","no");//解锁所有列表
                        },1500);
                    }
                }
            }
        });
    }
    //还原文件方法
    function reductionFile(conflictUuid,type){
        var ids = [];//要删除得文件id
        for(var i = 0; i < Controller.selectData.length; i++){
            ids.push(Controller.selectData[i].uuid);
        }
        //判断是点击列表触发的还原还是勾选列表点击的底部操作菜单触发的还原
        if(type == 2){
            Controller.selectData = [];//清空选中数据
        }
        //请求参数
        // 替换云空间接口
        // var paramet = {"token":getUrl("token"),"uuid":ids.join(","),"conflict_uuid":conflictUuid};
        var paramet = {"token":getUrl("cloudToken"),"uuid":ids.join(","),"conflict_uuid":conflictUuid};
        http(ServerConfig.cloudDomain+"/recycle/restore",paramet,{
            success:function(arg){
                if(parseInt(arg.code) == 1){
                    Controller.toastContainer.CommonToast("showToast","还原成功");//显示飘窗提示
                    Shell.sendEvent("commonChange",{"pageName":"djmyspace"});//通知原生我首页需要刷新
                    //判断是否显示了底部操作按钮
                    if(Controller.bottonMenuContainer.attr("isShow") == "yes"){
                        Controller.headContainer.trigger("CANCE_BTN_CLICK");//抛出取消事件
                    }
                    //飘窗提示后2s后删除飘窗
                    setTimeout(function(){
                        Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                        Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单
                        Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                        Controller.iscrollContainer.CommonIscroll("isIscroll","no");//解锁滚动容器
                        Controller.offset = 0;//重置数据偏移量
                        getListData(1);
                    },1500);
                }else{
                    //判断是否是退出登录了
                    if(arg.msg == "Please login first"){
                        Shell.sendEvent("backLogin");//通知原生退出登录
                    }else if(arg.msg == "文件冲突,请解决冲突文件" || arg.data.conflict_uuid != ""){
                        //初始化询问组件
                        var deleteMaskContainer = $("<div style='z-index:1;'></div>").appendTo($("body"));
                        deleteMaskContainer.CommonDeleteMask({
                            "title":"冲突提示！",
                            "text":"原路径已有相同文件（夹），是否还原文件，点击还原文件将被系统自动重命名",
                            "determineBtn":"还原"
                        });
                        //监听取消事件
                        deleteMaskContainer.bind("DELETE_MASK_CANCEL",function(){
                            Shell.sendEvent("commonChange",{"pageName":"djmyspace"});//通知原生我首页需要刷新
                            //判断是否显示了底部操作按钮
                            if(Controller.bottonMenuContainer.attr("isShow") == "yes"){
                                Controller.headContainer.trigger("CANCE_BTN_CLICK");//抛出取消事件
                            }
                            Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单
                            Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                            Controller.iscrollContainer.CommonIscroll("isIscroll","no");//解锁滚动容器
                            setTimeout(function(){
                                Controller.offset = 0;//重置数据偏移量
                                getListData(1);
                            },500);
                        });
                        //监听确定事件
                        deleteMaskContainer.bind("DELETE_MASK_DETERMINE",function(){
                            deleteMaskContainer.CommonDeleteMask("removeMask");//调用询问组件删除方法
                            reductionFile(arg.data.conflict_uuid,type);//调用自己本身
                        });
                    }else{
                        Controller.toastContainer.CommonToast("showToast",arg.msg);//改变提示文字
                        //飘窗提示后2s后删除飘窗
                        setTimeout(function(){
                            Controller.toastContainer.CommonToast("hideToast");//掉飘窗消失方法
                            Controller.bottonMenuContainer.CommonBottonMenu("lock","no");//解锁底部操作菜单
                            Controller.headContainer.CommonHead("lock","no");//解锁头部组件
                            Controller.iscrollContainer.CommonIscroll("isIscroll","no");//解锁滚动容器
                            Controller.iscrollContainer.find("li").CommonCell("lockList","no");//解锁所有列表
                        },1500);
                    }
                }
            }
        });
    }
    return Controller;
});
